// ------------------------------------------------------------------------- 
// High Level Design Compiler for Intel(R) FPGAs Version 20.3 (Release Build #121)
// 
// Legal Notice: Copyright 2020 Intel Corporation.  All rights reserved.
// Your use of  Intel Corporation's design tools,  logic functions and other
// software and  tools, and its AMPP partner logic functions, and any output
// files any  of the foregoing (including  device programming  or simulation
// files), and  any associated  documentation  or information  are expressly
// subject  to the terms and  conditions of the  Intel FPGA Software License
// Agreement, Intel MegaCore Function License Agreement, or other applicable
// license agreement,  including,  without limitation,  that your use is for
// the  sole  purpose of  programming  logic devices  manufactured by  Intel
// and  sold by Intel  or its authorized  distributors. Please refer  to the
// applicable agreement for further details.
// ---------------------------------------------------------------------------

// SystemVerilog created from k2_ZTS6c_calc_ZTS6c_calc_B1_merge
// SystemVerilog created on Thu Nov  5 06:32:57 2020


(* altera_attribute = "-name AUTO_SHIFT_REGISTER_RECOGNITION OFF; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 10037; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 15400; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 12020; -name MESSAGE_DISABLE 12030; -name MESSAGE_DISABLE 12010; -name MESSAGE_DISABLE 12110; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 13410; -name MESSAGE_DISABLE 113007; -name MESSAGE_DISABLE 10958" *)
module k2_ZTS6c_calc_ZTS6c_calc_B1_merge (
    input wire [63:0] in_acl_global_id_044_0,
    input wire [63:0] in_acl_global_id_150_0,
    input wire [31:0] in_acl_group_id_151_0,
    input wire [31:0] in_acl_hw_wg_id57_0,
    input wire [31:0] in_c0_exe17_0,
    input wire [31:0] in_c0_exe211_0,
    input wire [31:0] in_c0_exe415_0,
    input wire [63:0] in_c0_exe519_0,
    input wire [63:0] in_c0_exe623_0,
    input wire [63:0] in_c0_exe727_0,
    input wire [63:0] in_c0_exe831_0,
    input wire [31:0] in_l_grpid_06_0,
    input wire [0:0] in_stall_in,
    input wire [0:0] in_valid_in_0,
    output wire [63:0] out_acl_global_id_044,
    output wire [63:0] out_acl_global_id_150,
    output wire [31:0] out_acl_group_id_151,
    output wire [31:0] out_acl_hw_wg_id57,
    output wire [31:0] out_c0_exe17,
    output wire [31:0] out_c0_exe211,
    output wire [31:0] out_c0_exe415,
    output wire [63:0] out_c0_exe519,
    output wire [63:0] out_c0_exe623,
    output wire [63:0] out_c0_exe727,
    output wire [63:0] out_c0_exe831,
    output wire [31:0] out_l_grpid_06,
    output wire [0:0] out_stall_out_0,
    output wire [0:0] out_valid_out,
    input wire clock,
    input wire resetn
    );

    wire [0:0] stall_out_q;


    // out_acl_global_id_044(GPOUT,16)
    assign out_acl_global_id_044 = in_acl_global_id_044_0;

    // out_acl_global_id_150(GPOUT,17)
    assign out_acl_global_id_150 = in_acl_global_id_150_0;

    // out_acl_group_id_151(GPOUT,18)
    assign out_acl_group_id_151 = in_acl_group_id_151_0;

    // out_acl_hw_wg_id57(GPOUT,19)
    assign out_acl_hw_wg_id57 = in_acl_hw_wg_id57_0;

    // out_c0_exe17(GPOUT,20)
    assign out_c0_exe17 = in_c0_exe17_0;

    // out_c0_exe211(GPOUT,21)
    assign out_c0_exe211 = in_c0_exe211_0;

    // out_c0_exe415(GPOUT,22)
    assign out_c0_exe415 = in_c0_exe415_0;

    // out_c0_exe519(GPOUT,23)
    assign out_c0_exe519 = in_c0_exe519_0;

    // out_c0_exe623(GPOUT,24)
    assign out_c0_exe623 = in_c0_exe623_0;

    // out_c0_exe727(GPOUT,25)
    assign out_c0_exe727 = in_c0_exe727_0;

    // out_c0_exe831(GPOUT,26)
    assign out_c0_exe831 = in_c0_exe831_0;

    // out_l_grpid_06(GPOUT,27)
    assign out_l_grpid_06 = in_l_grpid_06_0;

    // stall_out(LOGICAL,30)
    assign stall_out_q = in_valid_in_0 & in_stall_in;

    // out_stall_out_0(GPOUT,28)
    assign out_stall_out_0 = stall_out_q;

    // out_valid_out(GPOUT,29)
    assign out_valid_out = in_valid_in_0;

endmodule
