// ------------------------------------------------------------------------- 
// High Level Design Compiler for Intel(R) FPGAs Version 20.3 (Release Build #121)
// 
// Legal Notice: Copyright 2020 Intel Corporation.  All rights reserved.
// Your use of  Intel Corporation's design tools,  logic functions and other
// software and  tools, and its AMPP partner logic functions, and any output
// files any  of the foregoing (including  device programming  or simulation
// files), and  any associated  documentation  or information  are expressly
// subject  to the terms and  conditions of the  Intel FPGA Software License
// Agreement, Intel MegaCore Function License Agreement, or other applicable
// license agreement,  including,  without limitation,  that your use is for
// the  sole  purpose of  programming  logic devices  manufactured by  Intel
// and  sold by Intel  or its authorized  distributors. Please refer  to the
// applicable agreement for further details.
// ---------------------------------------------------------------------------

// SystemVerilog created from k2_ZTS6c_calc_ZTS6c_calc_B3_merge
// SystemVerilog created on Thu Nov  5 06:32:57 2020


(* altera_attribute = "-name AUTO_SHIFT_REGISTER_RECOGNITION OFF; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 10037; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 15400; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 12020; -name MESSAGE_DISABLE 12030; -name MESSAGE_DISABLE 12010; -name MESSAGE_DISABLE 12110; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 13410; -name MESSAGE_DISABLE 113007; -name MESSAGE_DISABLE 10958" *)
module k2_ZTS6c_calc_ZTS6c_calc_B3_merge (
    input wire [63:0] in_acl_global_id_039_0,
    input wire [63:0] in_acl_global_id_039_1,
    input wire [63:0] in_acl_global_id_145_0,
    input wire [63:0] in_acl_global_id_145_1,
    input wire [31:0] in_acl_hw_wg_id52_0,
    input wire [31:0] in_acl_hw_wg_id52_1,
    input wire [0:0] in_do_directly_crit_edge_0,
    input wire [0:0] in_do_directly_crit_edge_1,
    input wire [0:0] in_do_directly_crit_edge_loopexit_0,
    input wire [0:0] in_do_directly_crit_edge_loopexit_1,
    input wire [31:0] in_l_grpid_01_0,
    input wire [31:0] in_l_grpid_01_1,
    input wire [31:0] in_lcssa_lcssa_0,
    input wire [31:0] in_lcssa_lcssa_1,
    input wire [0:0] in_stall_in,
    input wire [0:0] in_valid_in_0,
    input wire [0:0] in_valid_in_1,
    output wire [63:0] out_acl_global_id_039,
    output wire [63:0] out_acl_global_id_145,
    output wire [31:0] out_acl_hw_wg_id52,
    output wire [0:0] out_do_directly_crit_edge,
    output wire [0:0] out_do_directly_crit_edge_loopexit,
    output wire [31:0] out_l_grpid_01,
    output wire [31:0] out_lcssa_lcssa,
    output wire [0:0] out_stall_out_0,
    output wire [0:0] out_stall_out_1,
    output wire [0:0] out_valid_out,
    input wire clock,
    input wire resetn
    );

    wire [0:0] VCC_q;
    wire [0:0] acl_global_id_039_mux_s;
    reg [63:0] acl_global_id_039_mux_q;
    wire [0:0] acl_global_id_145_mux_s;
    reg [63:0] acl_global_id_145_mux_q;
    wire [0:0] acl_hw_wg_id52_mux_s;
    reg [31:0] acl_hw_wg_id52_mux_q;
    wire [0:0] do_directly_crit_edge_loopexit_mux_s;
    reg [0:0] do_directly_crit_edge_loopexit_mux_q;
    wire [0:0] do_directly_crit_edge_mux_s;
    reg [0:0] do_directly_crit_edge_mux_q;
    wire [0:0] l_grpid_01_mux_s;
    reg [31:0] l_grpid_01_mux_q;
    wire [0:0] lcssa_lcssa_mux_s;
    reg [31:0] lcssa_lcssa_mux_q;
    wire [0:0] stall_out_q;
    wire [0:0] stall_out_1_specific_q;
    wire [0:0] valid_or_q;


    // VCC(CONSTANT,1)
    assign VCC_q = $unsigned(1'b1);

    // acl_global_id_039_mux(MUX,2)
    assign acl_global_id_039_mux_s = in_valid_in_0;
    always @(acl_global_id_039_mux_s or in_acl_global_id_039_1 or in_acl_global_id_039_0)
    begin
        unique case (acl_global_id_039_mux_s)
            1'b0 : acl_global_id_039_mux_q = in_acl_global_id_039_1;
            1'b1 : acl_global_id_039_mux_q = in_acl_global_id_039_0;
            default : acl_global_id_039_mux_q = 64'b0;
        endcase
    end

    // out_acl_global_id_039(GPOUT,26)
    assign out_acl_global_id_039 = acl_global_id_039_mux_q;

    // acl_global_id_145_mux(MUX,3)
    assign acl_global_id_145_mux_s = in_valid_in_0;
    always @(acl_global_id_145_mux_s or in_acl_global_id_145_1 or in_acl_global_id_145_0)
    begin
        unique case (acl_global_id_145_mux_s)
            1'b0 : acl_global_id_145_mux_q = in_acl_global_id_145_1;
            1'b1 : acl_global_id_145_mux_q = in_acl_global_id_145_0;
            default : acl_global_id_145_mux_q = 64'b0;
        endcase
    end

    // out_acl_global_id_145(GPOUT,27)
    assign out_acl_global_id_145 = acl_global_id_145_mux_q;

    // acl_hw_wg_id52_mux(MUX,4)
    assign acl_hw_wg_id52_mux_s = in_valid_in_0;
    always @(acl_hw_wg_id52_mux_s or in_acl_hw_wg_id52_1 or in_acl_hw_wg_id52_0)
    begin
        unique case (acl_hw_wg_id52_mux_s)
            1'b0 : acl_hw_wg_id52_mux_q = in_acl_hw_wg_id52_1;
            1'b1 : acl_hw_wg_id52_mux_q = in_acl_hw_wg_id52_0;
            default : acl_hw_wg_id52_mux_q = 32'b0;
        endcase
    end

    // out_acl_hw_wg_id52(GPOUT,28)
    assign out_acl_hw_wg_id52 = acl_hw_wg_id52_mux_q;

    // do_directly_crit_edge_mux(MUX,6)
    assign do_directly_crit_edge_mux_s = in_valid_in_0;
    always @(do_directly_crit_edge_mux_s or in_do_directly_crit_edge_1 or in_do_directly_crit_edge_0)
    begin
        unique case (do_directly_crit_edge_mux_s)
            1'b0 : do_directly_crit_edge_mux_q = in_do_directly_crit_edge_1;
            1'b1 : do_directly_crit_edge_mux_q = in_do_directly_crit_edge_0;
            default : do_directly_crit_edge_mux_q = 1'b0;
        endcase
    end

    // out_do_directly_crit_edge(GPOUT,29)
    assign out_do_directly_crit_edge = do_directly_crit_edge_mux_q;

    // do_directly_crit_edge_loopexit_mux(MUX,5)
    assign do_directly_crit_edge_loopexit_mux_s = in_valid_in_0;
    always @(do_directly_crit_edge_loopexit_mux_s or in_do_directly_crit_edge_loopexit_1 or in_do_directly_crit_edge_loopexit_0)
    begin
        unique case (do_directly_crit_edge_loopexit_mux_s)
            1'b0 : do_directly_crit_edge_loopexit_mux_q = in_do_directly_crit_edge_loopexit_1;
            1'b1 : do_directly_crit_edge_loopexit_mux_q = in_do_directly_crit_edge_loopexit_0;
            default : do_directly_crit_edge_loopexit_mux_q = 1'b0;
        endcase
    end

    // out_do_directly_crit_edge_loopexit(GPOUT,30)
    assign out_do_directly_crit_edge_loopexit = do_directly_crit_edge_loopexit_mux_q;

    // l_grpid_01_mux(MUX,24)
    assign l_grpid_01_mux_s = in_valid_in_0;
    always @(l_grpid_01_mux_s or in_l_grpid_01_1 or in_l_grpid_01_0)
    begin
        unique case (l_grpid_01_mux_s)
            1'b0 : l_grpid_01_mux_q = in_l_grpid_01_1;
            1'b1 : l_grpid_01_mux_q = in_l_grpid_01_0;
            default : l_grpid_01_mux_q = 32'b0;
        endcase
    end

    // out_l_grpid_01(GPOUT,31)
    assign out_l_grpid_01 = l_grpid_01_mux_q;

    // lcssa_lcssa_mux(MUX,25)
    assign lcssa_lcssa_mux_s = in_valid_in_0;
    always @(lcssa_lcssa_mux_s or in_lcssa_lcssa_1 or in_lcssa_lcssa_0)
    begin
        unique case (lcssa_lcssa_mux_s)
            1'b0 : lcssa_lcssa_mux_q = in_lcssa_lcssa_1;
            1'b1 : lcssa_lcssa_mux_q = in_lcssa_lcssa_0;
            default : lcssa_lcssa_mux_q = 32'b0;
        endcase
    end

    // out_lcssa_lcssa(GPOUT,32)
    assign out_lcssa_lcssa = lcssa_lcssa_mux_q;

    // valid_or(LOGICAL,38)
    assign valid_or_q = in_valid_in_0 | in_valid_in_1;

    // stall_out(LOGICAL,36)
    assign stall_out_q = valid_or_q & in_stall_in;

    // out_stall_out_0(GPOUT,33)
    assign out_stall_out_0 = stall_out_q;

    // stall_out_1_specific(LOGICAL,37)
    assign stall_out_1_specific_q = in_valid_in_0 | stall_out_q;

    // out_stall_out_1(GPOUT,34)
    assign out_stall_out_1 = stall_out_1_specific_q;

    // out_valid_out(GPOUT,35)
    assign out_valid_out = valid_or_q;

endmodule
