// ------------------------------------------------------------------------- 
// High Level Design Compiler for Intel(R) FPGAs Version 20.3 (Release Build #121)
// 
// Legal Notice: Copyright 2020 Intel Corporation.  All rights reserved.
// Your use of  Intel Corporation's design tools,  logic functions and other
// software and  tools, and its AMPP partner logic functions, and any output
// files any  of the foregoing (including  device programming  or simulation
// files), and  any associated  documentation  or information  are expressly
// subject  to the terms and  conditions of the  Intel FPGA Software License
// Agreement, Intel MegaCore Function License Agreement, or other applicable
// license agreement,  including,  without limitation,  that your use is for
// the  sole  purpose of  programming  logic devices  manufactured by  Intel
// and  sold by Intel  or its authorized  distributors. Please refer  to the
// applicable agreement for further details.
// ---------------------------------------------------------------------------

// SystemVerilog created from k2_ZTS6c_calc_ZTS6c_calc_B4_branch
// SystemVerilog created on Thu Nov  5 06:32:57 2020


(* altera_attribute = "-name AUTO_SHIFT_REGISTER_RECOGNITION OFF; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 10037; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 15400; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 12020; -name MESSAGE_DISABLE 12030; -name MESSAGE_DISABLE 12010; -name MESSAGE_DISABLE 12110; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 13410; -name MESSAGE_DISABLE 113007; -name MESSAGE_DISABLE 10958" *)
module k2_ZTS6c_calc_ZTS6c_calc_B4_branch (
    input wire [31:0] in_acl_0141_i509,
    input wire [31:0] in_acl_0142_i508,
    input wire [31:0] in_acl_0143_i507,
    input wire [63:0] in_acl_global_id_043,
    input wire [63:0] in_acl_global_id_149,
    input wire [31:0] in_acl_hw_wg_id56,
    input wire [31:0] in_c0_exe210,
    input wire [31:0] in_c0_exe412,
    input wire [63:0] in_c0_exe517,
    input wire [63:0] in_c0_exe620,
    input wire [63:0] in_c0_exe725,
    input wire [63:0] in_c0_exe828,
    input wire [31:0] in_l_grpid_05,
    input wire [63:0] in_l_grpid_0_ext_offset,
    input wire [0:0] in_stall_in_0,
    input wire [0:0] in_valid_in,
    output wire [31:0] out_acl_0141_i509,
    output wire [31:0] out_acl_0142_i508,
    output wire [31:0] out_acl_0143_i507,
    output wire [63:0] out_acl_global_id_043,
    output wire [63:0] out_acl_global_id_149,
    output wire [31:0] out_acl_hw_wg_id56,
    output wire [31:0] out_c0_exe210,
    output wire [31:0] out_c0_exe412,
    output wire [63:0] out_c0_exe517,
    output wire [63:0] out_c0_exe620,
    output wire [63:0] out_c0_exe725,
    output wire [63:0] out_c0_exe828,
    output wire [31:0] out_l_grpid_05,
    output wire [63:0] out_l_grpid_0_ext_offset,
    output wire [0:0] out_stall_out,
    output wire [0:0] out_valid_out_0,
    input wire clock,
    input wire resetn
    );

    wire [0:0] stall_out_q;


    // out_acl_0141_i509(GPOUT,18)
    assign out_acl_0141_i509 = in_acl_0141_i509;

    // out_acl_0142_i508(GPOUT,19)
    assign out_acl_0142_i508 = in_acl_0142_i508;

    // out_acl_0143_i507(GPOUT,20)
    assign out_acl_0143_i507 = in_acl_0143_i507;

    // out_acl_global_id_043(GPOUT,21)
    assign out_acl_global_id_043 = in_acl_global_id_043;

    // out_acl_global_id_149(GPOUT,22)
    assign out_acl_global_id_149 = in_acl_global_id_149;

    // out_acl_hw_wg_id56(GPOUT,23)
    assign out_acl_hw_wg_id56 = in_acl_hw_wg_id56;

    // out_c0_exe210(GPOUT,24)
    assign out_c0_exe210 = in_c0_exe210;

    // out_c0_exe412(GPOUT,25)
    assign out_c0_exe412 = in_c0_exe412;

    // out_c0_exe517(GPOUT,26)
    assign out_c0_exe517 = in_c0_exe517;

    // out_c0_exe620(GPOUT,27)
    assign out_c0_exe620 = in_c0_exe620;

    // out_c0_exe725(GPOUT,28)
    assign out_c0_exe725 = in_c0_exe725;

    // out_c0_exe828(GPOUT,29)
    assign out_c0_exe828 = in_c0_exe828;

    // out_l_grpid_05(GPOUT,30)
    assign out_l_grpid_05 = in_l_grpid_05;

    // out_l_grpid_0_ext_offset(GPOUT,31)
    assign out_l_grpid_0_ext_offset = in_l_grpid_0_ext_offset;

    // stall_out(LOGICAL,34)
    assign stall_out_q = in_valid_in & in_stall_in_0;

    // out_stall_out(GPOUT,32)
    assign out_stall_out = stall_out_q;

    // out_valid_out_0(GPOUT,33)
    assign out_valid_out_0 = in_valid_in;

endmodule
