// ------------------------------------------------------------------------- 
// High Level Design Compiler for Intel(R) FPGAs Version 20.3 (Release Build #121)
// 
// Legal Notice: Copyright 2020 Intel Corporation.  All rights reserved.
// Your use of  Intel Corporation's design tools,  logic functions and other
// software and  tools, and its AMPP partner logic functions, and any output
// files any  of the foregoing (including  device programming  or simulation
// files), and  any associated  documentation  or information  are expressly
// subject  to the terms and  conditions of the  Intel FPGA Software License
// Agreement, Intel MegaCore Function License Agreement, or other applicable
// license agreement,  including,  without limitation,  that your use is for
// the  sole  purpose of  programming  logic devices  manufactured by  Intel
// and  sold by Intel  or its authorized  distributors. Please refer  to the
// applicable agreement for further details.
// ---------------------------------------------------------------------------

// SystemVerilog created from k2_ZTS6c_calc_ZTS6c_calc_B5_branch
// SystemVerilog created on Thu Nov  5 06:32:57 2020


(* altera_attribute = "-name AUTO_SHIFT_REGISTER_RECOGNITION OFF; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 10037; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 15400; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 12020; -name MESSAGE_DISABLE 12030; -name MESSAGE_DISABLE 12010; -name MESSAGE_DISABLE 12110; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 13410; -name MESSAGE_DISABLE 113007; -name MESSAGE_DISABLE 10958" *)
module k2_ZTS6c_calc_ZTS6c_calc_B5_branch (
    input wire [63:0] in_acl_global_id_041,
    input wire [63:0] in_acl_global_id_147,
    input wire [31:0] in_acl_hw_wg_id54,
    input wire [31:0] in_c0_exe15437,
    input wire [31:0] in_c0_exe28,
    input wire [31:0] in_c0_exe413,
    input wire [63:0] in_c0_exe518,
    input wire [63:0] in_c0_exe621,
    input wire [63:0] in_c0_exe726,
    input wire [63:0] in_c0_exe829,
    input wire [31:0] in_l_grpid_03,
    input wire [0:0] in_stall_in_0,
    input wire [0:0] in_stall_in_1,
    input wire [31:0] in_unnamed_k2_ZTS6c_calc19,
    input wire [31:0] in_unnamed_k2_ZTS6c_calc20,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc21,
    input wire [0:0] in_valid_in,
    output wire [63:0] out_acl_global_id_041,
    output wire [63:0] out_acl_global_id_147,
    output wire [31:0] out_acl_hw_wg_id54,
    output wire [31:0] out_c0_exe15437,
    output wire [31:0] out_c0_exe28,
    output wire [31:0] out_c0_exe413,
    output wire [63:0] out_c0_exe518,
    output wire [63:0] out_c0_exe621,
    output wire [63:0] out_c0_exe726,
    output wire [63:0] out_c0_exe829,
    output wire [31:0] out_l_grpid_03,
    output wire [0:0] out_stall_out,
    output wire [31:0] out_unnamed_k2_ZTS6c_calc19,
    output wire [31:0] out_unnamed_k2_ZTS6c_calc20,
    output wire [0:0] out_valid_out_0,
    output wire [0:0] out_valid_out_1,
    input wire clock,
    input wire resetn
    );

    wire [0:0] VCC_q;
    wire [0:0] ZTS6c_calc_B5_branch_enable_q;
    wire [0:0] ZTS6c_calc_B5_branch_enable_not_q;
    reg [63:0] acl_global_id_041_reg_q;
    reg [63:0] acl_global_id_147_reg_q;
    reg [31:0] acl_hw_wg_id54_reg_q;
    reg [31:0] c0_exe15437_reg_q;
    reg [31:0] c0_exe28_reg_q;
    reg [31:0] c0_exe413_reg_q;
    reg [63:0] c0_exe518_reg_q;
    reg [63:0] c0_exe621_reg_q;
    reg [63:0] c0_exe726_reg_q;
    reg [63:0] c0_exe829_reg_q;
    reg [31:0] l_grpid_03_reg_q;
    wire [0:0] not_stall_in_0_q;
    wire [0:0] not_stall_in_1_q;
    wire [0:0] not_valid_0_q;
    wire [0:0] not_valid_1_q;
    wire [0:0] not_valid_or_not_stall_0_q;
    wire [0:0] not_valid_or_not_stall_1_q;
    reg [31:0] unnamed_k2_ZTS6c_calc19_reg_q;
    reg [31:0] unnamed_k2_ZTS6c_calc20_reg_q;
    wire [0:0] unnamed_k2_ZTS6c_calc21_cmp_q;
    reg [0:0] valid_0_reg_q;
    reg [0:0] valid_1_reg_q;
    wire [0:0] valid_out_0_and_q;
    wire [0:0] valid_out_1_and_q;


    // VCC(CONSTANT,1)
    assign VCC_q = $unsigned(1'b1);

    // not_stall_in_1(LOGICAL,33)
    assign not_stall_in_1_q = ~ (in_stall_in_1);

    // unnamed_k2_ZTS6c_calc21_cmp(LOGICAL,56)
    assign unnamed_k2_ZTS6c_calc21_cmp_q = ~ (in_unnamed_k2_ZTS6c_calc21);

    // valid_out_1_and(LOGICAL,60)
    assign valid_out_1_and_q = in_valid_in & unnamed_k2_ZTS6c_calc21_cmp_q;

    // valid_1_reg(REG,58)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            valid_1_reg_q <= $unsigned(1'b0);
        end
        else if (ZTS6c_calc_B5_branch_enable_q == 1'b1)
        begin
            valid_1_reg_q <= valid_out_1_and_q;
        end
    end

    // not_valid_1(LOGICAL,35)
    assign not_valid_1_q = ~ (valid_1_reg_q);

    // not_valid_or_not_stall_1(LOGICAL,37)
    assign not_valid_or_not_stall_1_q = not_valid_1_q | not_stall_in_1_q;

    // not_stall_in_0(LOGICAL,32)
    assign not_stall_in_0_q = ~ (in_stall_in_0);

    // valid_out_0_and(LOGICAL,59)
    assign valid_out_0_and_q = in_valid_in & in_unnamed_k2_ZTS6c_calc21;

    // valid_0_reg(REG,57)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            valid_0_reg_q <= $unsigned(1'b0);
        end
        else if (ZTS6c_calc_B5_branch_enable_q == 1'b1)
        begin
            valid_0_reg_q <= valid_out_0_and_q;
        end
    end

    // not_valid_0(LOGICAL,34)
    assign not_valid_0_q = ~ (valid_0_reg_q);

    // not_valid_or_not_stall_0(LOGICAL,36)
    assign not_valid_or_not_stall_0_q = not_valid_0_q | not_stall_in_0_q;

    // ZTS6c_calc_B5_branch_enable(LOGICAL,2)
    assign ZTS6c_calc_B5_branch_enable_q = not_valid_or_not_stall_0_q & not_valid_or_not_stall_1_q;

    // acl_global_id_041_reg(REG,4)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            acl_global_id_041_reg_q <= $unsigned(64'b0000000000000000000000000000000000000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B5_branch_enable_q == 1'b1)
        begin
            acl_global_id_041_reg_q <= in_acl_global_id_041;
        end
    end

    // out_acl_global_id_041(GPOUT,38)
    assign out_acl_global_id_041 = acl_global_id_041_reg_q;

    // acl_global_id_147_reg(REG,5)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            acl_global_id_147_reg_q <= $unsigned(64'b0000000000000000000000000000000000000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B5_branch_enable_q == 1'b1)
        begin
            acl_global_id_147_reg_q <= in_acl_global_id_147;
        end
    end

    // out_acl_global_id_147(GPOUT,39)
    assign out_acl_global_id_147 = acl_global_id_147_reg_q;

    // acl_hw_wg_id54_reg(REG,6)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            acl_hw_wg_id54_reg_q <= $unsigned(32'b00000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B5_branch_enable_q == 1'b1)
        begin
            acl_hw_wg_id54_reg_q <= in_acl_hw_wg_id54;
        end
    end

    // out_acl_hw_wg_id54(GPOUT,40)
    assign out_acl_hw_wg_id54 = acl_hw_wg_id54_reg_q;

    // c0_exe15437_reg(REG,7)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            c0_exe15437_reg_q <= $unsigned(32'b00000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B5_branch_enable_q == 1'b1)
        begin
            c0_exe15437_reg_q <= $unsigned(in_c0_exe15437);
        end
    end

    // out_c0_exe15437(GPOUT,41)
    assign out_c0_exe15437 = c0_exe15437_reg_q;

    // c0_exe28_reg(REG,8)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            c0_exe28_reg_q <= $unsigned(32'b00000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B5_branch_enable_q == 1'b1)
        begin
            c0_exe28_reg_q <= in_c0_exe28;
        end
    end

    // out_c0_exe28(GPOUT,42)
    assign out_c0_exe28 = c0_exe28_reg_q;

    // c0_exe413_reg(REG,9)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            c0_exe413_reg_q <= $unsigned(32'b00000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B5_branch_enable_q == 1'b1)
        begin
            c0_exe413_reg_q <= in_c0_exe413;
        end
    end

    // out_c0_exe413(GPOUT,43)
    assign out_c0_exe413 = c0_exe413_reg_q;

    // c0_exe518_reg(REG,10)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            c0_exe518_reg_q <= $unsigned(64'b0000000000000000000000000000000000000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B5_branch_enable_q == 1'b1)
        begin
            c0_exe518_reg_q <= in_c0_exe518;
        end
    end

    // out_c0_exe518(GPOUT,44)
    assign out_c0_exe518 = c0_exe518_reg_q;

    // c0_exe621_reg(REG,11)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            c0_exe621_reg_q <= $unsigned(64'b0000000000000000000000000000000000000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B5_branch_enable_q == 1'b1)
        begin
            c0_exe621_reg_q <= in_c0_exe621;
        end
    end

    // out_c0_exe621(GPOUT,45)
    assign out_c0_exe621 = c0_exe621_reg_q;

    // c0_exe726_reg(REG,12)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            c0_exe726_reg_q <= $unsigned(64'b0000000000000000000000000000000000000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B5_branch_enable_q == 1'b1)
        begin
            c0_exe726_reg_q <= in_c0_exe726;
        end
    end

    // out_c0_exe726(GPOUT,46)
    assign out_c0_exe726 = c0_exe726_reg_q;

    // c0_exe829_reg(REG,13)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            c0_exe829_reg_q <= $unsigned(64'b0000000000000000000000000000000000000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B5_branch_enable_q == 1'b1)
        begin
            c0_exe829_reg_q <= in_c0_exe829;
        end
    end

    // out_c0_exe829(GPOUT,47)
    assign out_c0_exe829 = c0_exe829_reg_q;

    // l_grpid_03_reg(REG,31)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            l_grpid_03_reg_q <= $unsigned(32'b00000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B5_branch_enable_q == 1'b1)
        begin
            l_grpid_03_reg_q <= in_l_grpid_03;
        end
    end

    // out_l_grpid_03(GPOUT,48)
    assign out_l_grpid_03 = l_grpid_03_reg_q;

    // ZTS6c_calc_B5_branch_enable_not(LOGICAL,3)
    assign ZTS6c_calc_B5_branch_enable_not_q = ~ (ZTS6c_calc_B5_branch_enable_q);

    // out_stall_out(GPOUT,49)
    assign out_stall_out = ZTS6c_calc_B5_branch_enable_not_q;

    // unnamed_k2_ZTS6c_calc19_reg(REG,54)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            unnamed_k2_ZTS6c_calc19_reg_q <= $unsigned(32'b00000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B5_branch_enable_q == 1'b1)
        begin
            unnamed_k2_ZTS6c_calc19_reg_q <= in_unnamed_k2_ZTS6c_calc19;
        end
    end

    // out_unnamed_k2_ZTS6c_calc19(GPOUT,50)
    assign out_unnamed_k2_ZTS6c_calc19 = unnamed_k2_ZTS6c_calc19_reg_q;

    // unnamed_k2_ZTS6c_calc20_reg(REG,55)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            unnamed_k2_ZTS6c_calc20_reg_q <= $unsigned(32'b00000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B5_branch_enable_q == 1'b1)
        begin
            unnamed_k2_ZTS6c_calc20_reg_q <= in_unnamed_k2_ZTS6c_calc20;
        end
    end

    // out_unnamed_k2_ZTS6c_calc20(GPOUT,51)
    assign out_unnamed_k2_ZTS6c_calc20 = unnamed_k2_ZTS6c_calc20_reg_q;

    // out_valid_out_0(GPOUT,52)
    assign out_valid_out_0 = valid_0_reg_q;

    // out_valid_out_1(GPOUT,53)
    assign out_valid_out_1 = valid_1_reg_q;

endmodule
