// ------------------------------------------------------------------------- 
// High Level Design Compiler for Intel(R) FPGAs Version 20.3 (Release Build #121)
// 
// Legal Notice: Copyright 2020 Intel Corporation.  All rights reserved.
// Your use of  Intel Corporation's design tools,  logic functions and other
// software and  tools, and its AMPP partner logic functions, and any output
// files any  of the foregoing (including  device programming  or simulation
// files), and  any associated  documentation  or information  are expressly
// subject  to the terms and  conditions of the  Intel FPGA Software License
// Agreement, Intel MegaCore Function License Agreement, or other applicable
// license agreement,  including,  without limitation,  that your use is for
// the  sole  purpose of  programming  logic devices  manufactured by  Intel
// and  sold by Intel  or its authorized  distributors. Please refer  to the
// applicable agreement for further details.
// ---------------------------------------------------------------------------

// SystemVerilog created from k2_ZTS6c_calc_ZTS6c_calc_B5_merge
// SystemVerilog created on Thu Nov  5 06:32:57 2020


(* altera_attribute = "-name AUTO_SHIFT_REGISTER_RECOGNITION OFF; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 10037; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 15400; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 12020; -name MESSAGE_DISABLE 12030; -name MESSAGE_DISABLE 12010; -name MESSAGE_DISABLE 12110; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 13410; -name MESSAGE_DISABLE 113007; -name MESSAGE_DISABLE 10958" *)
module k2_ZTS6c_calc_ZTS6c_calc_B5_merge (
    input wire [31:0] in_acl_0141_i50932_0,
    input wire [31:0] in_acl_0142_i50834_0,
    input wire [63:0] in_acl_global_id_041_0,
    input wire [63:0] in_acl_global_id_147_0,
    input wire [31:0] in_acl_hw_wg_id54_0,
    input wire [31:0] in_c0_exe15437_0,
    input wire [31:0] in_c0_exe28_0,
    input wire [31:0] in_c0_exe413_0,
    input wire [63:0] in_c0_exe518_0,
    input wire [63:0] in_c0_exe621_0,
    input wire [63:0] in_c0_exe726_0,
    input wire [63:0] in_c0_exe829_0,
    input wire [31:0] in_l_grpid_03_0,
    input wire [0:0] in_stall_in,
    input wire [0:0] in_valid_in_0,
    output wire [31:0] out_acl_0141_i50932,
    output wire [31:0] out_acl_0142_i50834,
    output wire [63:0] out_acl_global_id_041,
    output wire [63:0] out_acl_global_id_147,
    output wire [31:0] out_acl_hw_wg_id54,
    output wire [31:0] out_c0_exe15437,
    output wire [31:0] out_c0_exe28,
    output wire [31:0] out_c0_exe413,
    output wire [63:0] out_c0_exe518,
    output wire [63:0] out_c0_exe621,
    output wire [63:0] out_c0_exe726,
    output wire [63:0] out_c0_exe829,
    output wire [31:0] out_l_grpid_03,
    output wire [0:0] out_stall_out_0,
    output wire [0:0] out_valid_out,
    input wire clock,
    input wire resetn
    );

    wire [0:0] stall_out_q;


    // out_acl_0141_i50932(GPOUT,17)
    assign out_acl_0141_i50932 = in_acl_0141_i50932_0;

    // out_acl_0142_i50834(GPOUT,18)
    assign out_acl_0142_i50834 = in_acl_0142_i50834_0;

    // out_acl_global_id_041(GPOUT,19)
    assign out_acl_global_id_041 = in_acl_global_id_041_0;

    // out_acl_global_id_147(GPOUT,20)
    assign out_acl_global_id_147 = in_acl_global_id_147_0;

    // out_acl_hw_wg_id54(GPOUT,21)
    assign out_acl_hw_wg_id54 = in_acl_hw_wg_id54_0;

    // out_c0_exe15437(GPOUT,22)
    assign out_c0_exe15437 = in_c0_exe15437_0;

    // out_c0_exe28(GPOUT,23)
    assign out_c0_exe28 = in_c0_exe28_0;

    // out_c0_exe413(GPOUT,24)
    assign out_c0_exe413 = in_c0_exe413_0;

    // out_c0_exe518(GPOUT,25)
    assign out_c0_exe518 = in_c0_exe518_0;

    // out_c0_exe621(GPOUT,26)
    assign out_c0_exe621 = in_c0_exe621_0;

    // out_c0_exe726(GPOUT,27)
    assign out_c0_exe726 = in_c0_exe726_0;

    // out_c0_exe829(GPOUT,28)
    assign out_c0_exe829 = in_c0_exe829_0;

    // out_l_grpid_03(GPOUT,29)
    assign out_l_grpid_03 = in_l_grpid_03_0;

    // stall_out(LOGICAL,32)
    assign stall_out_q = in_valid_in_0 & in_stall_in;

    // out_stall_out_0(GPOUT,30)
    assign out_stall_out_0 = stall_out_q;

    // out_valid_out(GPOUT,31)
    assign out_valid_out = in_valid_in_0;

endmodule
