// ------------------------------------------------------------------------- 
// High Level Design Compiler for Intel(R) FPGAs Version 20.3 (Release Build #121)
// 
// Legal Notice: Copyright 2020 Intel Corporation.  All rights reserved.
// Your use of  Intel Corporation's design tools,  logic functions and other
// software and  tools, and its AMPP partner logic functions, and any output
// files any  of the foregoing (including  device programming  or simulation
// files), and  any associated  documentation  or information  are expressly
// subject  to the terms and  conditions of the  Intel FPGA Software License
// Agreement, Intel MegaCore Function License Agreement, or other applicable
// license agreement,  including,  without limitation,  that your use is for
// the  sole  purpose of  programming  logic devices  manufactured by  Intel
// and  sold by Intel  or its authorized  distributors. Please refer  to the
// applicable agreement for further details.
// ---------------------------------------------------------------------------

// SystemVerilog created from k2_ZTS6c_calc_bb_ZTS6c_calc_B0
// SystemVerilog created on Thu Nov  5 06:32:57 2020


(* altera_attribute = "-name AUTO_SHIFT_REGISTER_RECOGNITION OFF; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 10037; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 15400; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 12020; -name MESSAGE_DISABLE 12030; -name MESSAGE_DISABLE 12010; -name MESSAGE_DISABLE 12110; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 13410; -name MESSAGE_DISABLE 113007; -name MESSAGE_DISABLE 10958" *)
module k2_ZTS6c_calc_bb_ZTS6c_calc_B0 (
    output wire [63:0] out_acl_global_id_0,
    output wire [63:0] out_acl_global_id_1,
    output wire [31:0] out_acl_group_id_1,
    output wire [31:0] out_acl_hw_wg_id,
    output wire [31:0] out_c0_exe1,
    output wire [31:0] out_c0_exe2,
    output wire [31:0] out_c0_exe4,
    output wire [63:0] out_c0_exe5,
    output wire [63:0] out_c0_exe6,
    output wire [63:0] out_c0_exe7,
    output wire [63:0] out_c0_exe8,
    output wire [31:0] out_l_grpid_0,
    output wire [0:0] out_stall_out_0,
    output wire [0:0] out_valid_out_0,
    output wire [0:0] out_valid_out_1,
    output wire [0:0] out_wgl_0_enter_exit_stall_out,
    output wire [0:0] out_wgl_0_enter_exit_valid_out,
    input wire [63:0] in_acl_global_id_0_0,
    input wire [63:0] in_acl_global_id_1_0,
    input wire [31:0] in_acl_group_id_0_0,
    input wire [31:0] in_acl_group_id_1_0,
    input wire [31:0] in_acl_hw_wg_id_0,
    input wire [31:0] in_acl_local_id_0_0,
    input wire [31:0] in_acl_local_id_1_0,
    input wire [63:0] in_arg12,
    input wire [63:0] in_arg16,
    input wire [63:0] in_arg4,
    input wire [0:0] in_stall_in_0,
    input wire [0:0] in_stall_in_1,
    input wire [0:0] in_valid_in_0,
    input wire [0:0] in_wgl_0_enter_exit_stall_in,
    input wire [0:0] in_wgl_0_enter_exit_valid_in,
    input wire [31:0] in_wgl_0_wgs_wg_size,
    input wire [63:0] in_arg1_0_tpl,
    input wire [63:0] in_arg1_1_tpl,
    input wire [63:0] in_arg15_0_tpl,
    input wire [63:0] in_arg18_0_tpl,
    input wire [63:0] in_arg18_1_tpl,
    input wire [63:0] in_arg19_0_tpl,
    input wire [63:0] in_arg19_1_tpl,
    input wire [63:0] in_arg7_0_tpl,
    input wire [63:0] in_arg9_0_tpl,
    input wire [63:0] in_arg9_1_tpl,
    input wire clock,
    input wire resetn
    );

    wire [63:0] ZTS6c_calc_B0_branch_out_acl_global_id_0;
    wire [63:0] ZTS6c_calc_B0_branch_out_acl_global_id_1;
    wire [31:0] ZTS6c_calc_B0_branch_out_acl_group_id_1;
    wire [31:0] ZTS6c_calc_B0_branch_out_acl_hw_wg_id;
    wire [31:0] ZTS6c_calc_B0_branch_out_c0_exe1;
    wire [31:0] ZTS6c_calc_B0_branch_out_c0_exe2;
    wire [31:0] ZTS6c_calc_B0_branch_out_c0_exe4;
    wire [63:0] ZTS6c_calc_B0_branch_out_c0_exe5;
    wire [63:0] ZTS6c_calc_B0_branch_out_c0_exe6;
    wire [63:0] ZTS6c_calc_B0_branch_out_c0_exe7;
    wire [63:0] ZTS6c_calc_B0_branch_out_c0_exe8;
    wire [31:0] ZTS6c_calc_B0_branch_out_l_grpid_0;
    wire [0:0] ZTS6c_calc_B0_branch_out_stall_out;
    wire [0:0] ZTS6c_calc_B0_branch_out_valid_out_0;
    wire [0:0] ZTS6c_calc_B0_branch_out_valid_out_1;
    wire [63:0] ZTS6c_calc_B0_merge_out_acl_global_id_0;
    wire [63:0] ZTS6c_calc_B0_merge_out_acl_global_id_1;
    wire [31:0] ZTS6c_calc_B0_merge_out_acl_group_id_0;
    wire [31:0] ZTS6c_calc_B0_merge_out_acl_group_id_1;
    wire [31:0] ZTS6c_calc_B0_merge_out_acl_hw_wg_id;
    wire [31:0] ZTS6c_calc_B0_merge_out_acl_local_id_0;
    wire [31:0] ZTS6c_calc_B0_merge_out_acl_local_id_1;
    wire [0:0] ZTS6c_calc_B0_merge_out_stall_out_0;
    wire [0:0] ZTS6c_calc_B0_merge_out_valid_out;
    wire [63:0] bb_ZTS6c_calc_B0_stall_region_out_acl_global_id_0;
    wire [63:0] bb_ZTS6c_calc_B0_stall_region_out_acl_global_id_1;
    wire [31:0] bb_ZTS6c_calc_B0_stall_region_out_acl_group_id_1;
    wire [31:0] bb_ZTS6c_calc_B0_stall_region_out_acl_hw_wg_id;
    wire [31:0] bb_ZTS6c_calc_B0_stall_region_out_c0_exe1;
    wire [31:0] bb_ZTS6c_calc_B0_stall_region_out_c0_exe2;
    wire [0:0] bb_ZTS6c_calc_B0_stall_region_out_c0_exe3;
    wire [31:0] bb_ZTS6c_calc_B0_stall_region_out_c0_exe4;
    wire [63:0] bb_ZTS6c_calc_B0_stall_region_out_c0_exe5;
    wire [63:0] bb_ZTS6c_calc_B0_stall_region_out_c0_exe6;
    wire [63:0] bb_ZTS6c_calc_B0_stall_region_out_c0_exe7;
    wire [63:0] bb_ZTS6c_calc_B0_stall_region_out_c0_exe8;
    wire [31:0] bb_ZTS6c_calc_B0_stall_region_out_l_grpid_0;
    wire [0:0] bb_ZTS6c_calc_B0_stall_region_out_stall_out;
    wire [0:0] bb_ZTS6c_calc_B0_stall_region_out_valid_out;
    wire [0:0] bb_ZTS6c_calc_B0_stall_region_out_wgl_0_enter_exit_stall_out;
    wire [0:0] bb_ZTS6c_calc_B0_stall_region_out_wgl_0_enter_exit_valid_out;


    // ZTS6c_calc_B0_merge(BLACKBOX,3)
    k2_ZTS6c_calc_ZTS6c_calc_B0_merge theZTS6c_calc_B0_merge (
        .in_acl_global_id_0_0(in_acl_global_id_0_0),
        .in_acl_global_id_1_0(in_acl_global_id_1_0),
        .in_acl_group_id_0_0(in_acl_group_id_0_0),
        .in_acl_group_id_1_0(in_acl_group_id_1_0),
        .in_acl_hw_wg_id_0(in_acl_hw_wg_id_0),
        .in_acl_local_id_0_0(in_acl_local_id_0_0),
        .in_acl_local_id_1_0(in_acl_local_id_1_0),
        .in_stall_in(bb_ZTS6c_calc_B0_stall_region_out_stall_out),
        .in_valid_in_0(in_valid_in_0),
        .out_acl_global_id_0(ZTS6c_calc_B0_merge_out_acl_global_id_0),
        .out_acl_global_id_1(ZTS6c_calc_B0_merge_out_acl_global_id_1),
        .out_acl_group_id_0(ZTS6c_calc_B0_merge_out_acl_group_id_0),
        .out_acl_group_id_1(ZTS6c_calc_B0_merge_out_acl_group_id_1),
        .out_acl_hw_wg_id(ZTS6c_calc_B0_merge_out_acl_hw_wg_id),
        .out_acl_local_id_0(ZTS6c_calc_B0_merge_out_acl_local_id_0),
        .out_acl_local_id_1(ZTS6c_calc_B0_merge_out_acl_local_id_1),
        .out_stall_out_0(ZTS6c_calc_B0_merge_out_stall_out_0),
        .out_valid_out(ZTS6c_calc_B0_merge_out_valid_out),
        .clock(clock),
        .resetn(resetn)
    );

    // bb_ZTS6c_calc_B0_stall_region(BLACKBOX,4)
    k2_ZTS6c_calc_bb_ZTS6c_calc_B0_stall_region thebb_ZTS6c_calc_B0_stall_region (
        .in_acl_global_id_0(ZTS6c_calc_B0_merge_out_acl_global_id_0),
        .in_acl_global_id_1(ZTS6c_calc_B0_merge_out_acl_global_id_1),
        .in_acl_group_id_0(ZTS6c_calc_B0_merge_out_acl_group_id_0),
        .in_acl_group_id_1(ZTS6c_calc_B0_merge_out_acl_group_id_1),
        .in_acl_hw_wg_id(ZTS6c_calc_B0_merge_out_acl_hw_wg_id),
        .in_acl_local_id_0(ZTS6c_calc_B0_merge_out_acl_local_id_0),
        .in_acl_local_id_1(ZTS6c_calc_B0_merge_out_acl_local_id_1),
        .in_stall_in(ZTS6c_calc_B0_branch_out_stall_out),
        .in_valid_in(ZTS6c_calc_B0_merge_out_valid_out),
        .in_wgl_0_enter_exit_stall_in(in_wgl_0_enter_exit_stall_in),
        .in_wgl_0_enter_exit_valid_in(in_wgl_0_enter_exit_valid_in),
        .in_wgl_0_wgs_wg_size(in_wgl_0_wgs_wg_size),
        .in_arg1_0_tpl(in_arg1_0_tpl),
        .in_arg1_1_tpl(in_arg1_1_tpl),
        .in_arg9_0_tpl(in_arg9_0_tpl),
        .in_arg9_1_tpl(in_arg9_1_tpl),
        .out_acl_global_id_0(bb_ZTS6c_calc_B0_stall_region_out_acl_global_id_0),
        .out_acl_global_id_1(bb_ZTS6c_calc_B0_stall_region_out_acl_global_id_1),
        .out_acl_group_id_1(bb_ZTS6c_calc_B0_stall_region_out_acl_group_id_1),
        .out_acl_hw_wg_id(bb_ZTS6c_calc_B0_stall_region_out_acl_hw_wg_id),
        .out_c0_exe1(bb_ZTS6c_calc_B0_stall_region_out_c0_exe1),
        .out_c0_exe2(bb_ZTS6c_calc_B0_stall_region_out_c0_exe2),
        .out_c0_exe3(bb_ZTS6c_calc_B0_stall_region_out_c0_exe3),
        .out_c0_exe4(bb_ZTS6c_calc_B0_stall_region_out_c0_exe4),
        .out_c0_exe5(bb_ZTS6c_calc_B0_stall_region_out_c0_exe5),
        .out_c0_exe6(bb_ZTS6c_calc_B0_stall_region_out_c0_exe6),
        .out_c0_exe7(bb_ZTS6c_calc_B0_stall_region_out_c0_exe7),
        .out_c0_exe8(bb_ZTS6c_calc_B0_stall_region_out_c0_exe8),
        .out_l_grpid_0(bb_ZTS6c_calc_B0_stall_region_out_l_grpid_0),
        .out_stall_out(bb_ZTS6c_calc_B0_stall_region_out_stall_out),
        .out_valid_out(bb_ZTS6c_calc_B0_stall_region_out_valid_out),
        .out_wgl_0_enter_exit_stall_out(bb_ZTS6c_calc_B0_stall_region_out_wgl_0_enter_exit_stall_out),
        .out_wgl_0_enter_exit_valid_out(bb_ZTS6c_calc_B0_stall_region_out_wgl_0_enter_exit_valid_out),
        .clock(clock),
        .resetn(resetn)
    );

    // ZTS6c_calc_B0_branch(BLACKBOX,2)
    k2_ZTS6c_calc_ZTS6c_calc_B0_branch theZTS6c_calc_B0_branch (
        .in_acl_global_id_0(bb_ZTS6c_calc_B0_stall_region_out_acl_global_id_0),
        .in_acl_global_id_1(bb_ZTS6c_calc_B0_stall_region_out_acl_global_id_1),
        .in_acl_group_id_1(bb_ZTS6c_calc_B0_stall_region_out_acl_group_id_1),
        .in_acl_hw_wg_id(bb_ZTS6c_calc_B0_stall_region_out_acl_hw_wg_id),
        .in_c0_exe1(bb_ZTS6c_calc_B0_stall_region_out_c0_exe1),
        .in_c0_exe2(bb_ZTS6c_calc_B0_stall_region_out_c0_exe2),
        .in_c0_exe3(bb_ZTS6c_calc_B0_stall_region_out_c0_exe3),
        .in_c0_exe4(bb_ZTS6c_calc_B0_stall_region_out_c0_exe4),
        .in_c0_exe5(bb_ZTS6c_calc_B0_stall_region_out_c0_exe5),
        .in_c0_exe6(bb_ZTS6c_calc_B0_stall_region_out_c0_exe6),
        .in_c0_exe7(bb_ZTS6c_calc_B0_stall_region_out_c0_exe7),
        .in_c0_exe8(bb_ZTS6c_calc_B0_stall_region_out_c0_exe8),
        .in_l_grpid_0(bb_ZTS6c_calc_B0_stall_region_out_l_grpid_0),
        .in_stall_in_0(in_stall_in_0),
        .in_stall_in_1(in_stall_in_1),
        .in_valid_in(bb_ZTS6c_calc_B0_stall_region_out_valid_out),
        .out_acl_global_id_0(ZTS6c_calc_B0_branch_out_acl_global_id_0),
        .out_acl_global_id_1(ZTS6c_calc_B0_branch_out_acl_global_id_1),
        .out_acl_group_id_1(ZTS6c_calc_B0_branch_out_acl_group_id_1),
        .out_acl_hw_wg_id(ZTS6c_calc_B0_branch_out_acl_hw_wg_id),
        .out_c0_exe1(ZTS6c_calc_B0_branch_out_c0_exe1),
        .out_c0_exe2(ZTS6c_calc_B0_branch_out_c0_exe2),
        .out_c0_exe4(ZTS6c_calc_B0_branch_out_c0_exe4),
        .out_c0_exe5(ZTS6c_calc_B0_branch_out_c0_exe5),
        .out_c0_exe6(ZTS6c_calc_B0_branch_out_c0_exe6),
        .out_c0_exe7(ZTS6c_calc_B0_branch_out_c0_exe7),
        .out_c0_exe8(ZTS6c_calc_B0_branch_out_c0_exe8),
        .out_l_grpid_0(ZTS6c_calc_B0_branch_out_l_grpid_0),
        .out_stall_out(ZTS6c_calc_B0_branch_out_stall_out),
        .out_valid_out_0(ZTS6c_calc_B0_branch_out_valid_out_0),
        .out_valid_out_1(ZTS6c_calc_B0_branch_out_valid_out_1),
        .clock(clock),
        .resetn(resetn)
    );

    // out_acl_global_id_0(GPOUT,5)
    assign out_acl_global_id_0 = ZTS6c_calc_B0_branch_out_acl_global_id_0;

    // out_acl_global_id_1(GPOUT,6)
    assign out_acl_global_id_1 = ZTS6c_calc_B0_branch_out_acl_global_id_1;

    // out_acl_group_id_1(GPOUT,7)
    assign out_acl_group_id_1 = ZTS6c_calc_B0_branch_out_acl_group_id_1;

    // out_acl_hw_wg_id(GPOUT,8)
    assign out_acl_hw_wg_id = ZTS6c_calc_B0_branch_out_acl_hw_wg_id;

    // out_c0_exe1(GPOUT,9)
    assign out_c0_exe1 = ZTS6c_calc_B0_branch_out_c0_exe1;

    // out_c0_exe2(GPOUT,10)
    assign out_c0_exe2 = ZTS6c_calc_B0_branch_out_c0_exe2;

    // out_c0_exe4(GPOUT,11)
    assign out_c0_exe4 = ZTS6c_calc_B0_branch_out_c0_exe4;

    // out_c0_exe5(GPOUT,12)
    assign out_c0_exe5 = ZTS6c_calc_B0_branch_out_c0_exe5;

    // out_c0_exe6(GPOUT,13)
    assign out_c0_exe6 = ZTS6c_calc_B0_branch_out_c0_exe6;

    // out_c0_exe7(GPOUT,14)
    assign out_c0_exe7 = ZTS6c_calc_B0_branch_out_c0_exe7;

    // out_c0_exe8(GPOUT,15)
    assign out_c0_exe8 = ZTS6c_calc_B0_branch_out_c0_exe8;

    // out_l_grpid_0(GPOUT,16)
    assign out_l_grpid_0 = ZTS6c_calc_B0_branch_out_l_grpid_0;

    // out_stall_out_0(GPOUT,17)
    assign out_stall_out_0 = ZTS6c_calc_B0_merge_out_stall_out_0;

    // out_valid_out_0(GPOUT,18)
    assign out_valid_out_0 = ZTS6c_calc_B0_branch_out_valid_out_0;

    // out_valid_out_1(GPOUT,19)
    assign out_valid_out_1 = ZTS6c_calc_B0_branch_out_valid_out_1;

    // out_wgl_0_enter_exit_stall_out(GPOUT,20)
    assign out_wgl_0_enter_exit_stall_out = bb_ZTS6c_calc_B0_stall_region_out_wgl_0_enter_exit_stall_out;

    // out_wgl_0_enter_exit_valid_out(GPOUT,21)
    assign out_wgl_0_enter_exit_valid_out = bb_ZTS6c_calc_B0_stall_region_out_wgl_0_enter_exit_valid_out;

endmodule
