// ------------------------------------------------------------------------- 
// High Level Design Compiler for Intel(R) FPGAs Version 20.3 (Release Build #121)
// 
// Legal Notice: Copyright 2020 Intel Corporation.  All rights reserved.
// Your use of  Intel Corporation's design tools,  logic functions and other
// software and  tools, and its AMPP partner logic functions, and any output
// files any  of the foregoing (including  device programming  or simulation
// files), and  any associated  documentation  or information  are expressly
// subject  to the terms and  conditions of the  Intel FPGA Software License
// Agreement, Intel MegaCore Function License Agreement, or other applicable
// license agreement,  including,  without limitation,  that your use is for
// the  sole  purpose of  programming  logic devices  manufactured by  Intel
// and  sold by Intel  or its authorized  distributors. Please refer  to the
// applicable agreement for further details.
// ---------------------------------------------------------------------------

// SystemVerilog created from k2_ZTS6c_calc_bb_ZTS6c_calc_B0_stall_region
// SystemVerilog created on Thu Nov  5 06:32:57 2020


(* altera_attribute = "-name AUTO_SHIFT_REGISTER_RECOGNITION OFF; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 10037; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 15400; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 12020; -name MESSAGE_DISABLE 12030; -name MESSAGE_DISABLE 12010; -name MESSAGE_DISABLE 12110; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 13410; -name MESSAGE_DISABLE 113007; -name MESSAGE_DISABLE 10958" *)
module k2_ZTS6c_calc_bb_ZTS6c_calc_B0_stall_region (
    input wire [0:0] in_wgl_0_enter_exit_valid_in,
    input wire [0:0] in_wgl_0_enter_exit_stall_in,
    output wire [0:0] out_wgl_0_enter_exit_valid_out,
    output wire [0:0] out_wgl_0_enter_exit_stall_out,
    input wire [0:0] in_stall_in,
    output wire [0:0] out_stall_out,
    input wire [63:0] in_acl_global_id_0,
    input wire [63:0] in_acl_global_id_1,
    input wire [31:0] in_acl_group_id_0,
    input wire [31:0] in_acl_group_id_1,
    input wire [31:0] in_acl_hw_wg_id,
    input wire [31:0] in_acl_local_id_0,
    input wire [31:0] in_acl_local_id_1,
    input wire [0:0] in_valid_in,
    input wire [31:0] in_wgl_0_wgs_wg_size,
    output wire [63:0] out_acl_global_id_0,
    output wire [63:0] out_acl_global_id_1,
    output wire [31:0] out_acl_group_id_1,
    output wire [31:0] out_acl_hw_wg_id,
    output wire [31:0] out_c0_exe1,
    output wire [31:0] out_c0_exe2,
    output wire [0:0] out_c0_exe3,
    output wire [31:0] out_c0_exe4,
    output wire [63:0] out_c0_exe5,
    output wire [63:0] out_c0_exe6,
    output wire [63:0] out_c0_exe7,
    output wire [63:0] out_c0_exe8,
    output wire [31:0] out_l_grpid_0,
    output wire [0:0] out_valid_out,
    input wire [63:0] in_arg1_0_tpl,
    input wire [63:0] in_arg1_1_tpl,
    input wire [63:0] in_arg9_0_tpl,
    input wire [63:0] in_arg9_1_tpl,
    input wire clock,
    input wire resetn
    );

    wire [0:0] GND_q;
    wire [31:0] i_llvm_fpga_wg_limiter_enter_l_grpid_0_k2_zts6c_calc0_out_o_data;
    wire [0:0] i_llvm_fpga_wg_limiter_enter_l_grpid_0_k2_zts6c_calc0_out_o_stall;
    wire [0:0] i_llvm_fpga_wg_limiter_enter_l_grpid_0_k2_zts6c_calc0_out_o_valid;
    wire [0:0] i_llvm_fpga_wg_limiter_enter_l_grpid_0_k2_zts6c_calc0_out_wgl_0_enter_exit_stall_out;
    wire [0:0] i_llvm_fpga_wg_limiter_enter_l_grpid_0_k2_zts6c_calc0_out_wgl_0_enter_exit_valid_out;
    wire [0:0] ZTS6c_calc_B0_merge_reg_aunroll_x_out_stall_out;
    wire [0:0] ZTS6c_calc_B0_merge_reg_aunroll_x_out_valid_out;
    wire [63:0] ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_0_tpl;
    wire [63:0] ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_1_tpl;
    wire [31:0] ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_2_tpl;
    wire [31:0] ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_3_tpl;
    wire [31:0] ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_4_tpl;
    wire [31:0] ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_5_tpl;
    wire [31:0] ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl;
    wire [0:0] i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_out_o_stall;
    wire [0:0] i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_out_o_valid;
    wire [31:0] i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_out_c0_exit_1_tpl;
    wire [31:0] i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_out_c0_exit_2_tpl;
    wire [0:0] i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_out_c0_exit_3_tpl;
    wire [31:0] i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_out_c0_exit_4_tpl;
    wire [63:0] i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_out_c0_exit_5_tpl;
    wire [63:0] i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_out_c0_exit_6_tpl;
    wire [63:0] i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_out_c0_exit_7_tpl;
    wire [63:0] i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_out_c0_exit_8_tpl;
    wire [159:0] join_for_coalesced_delay_0_q;
    wire [63:0] sel_for_coalesced_delay_0_b;
    wire [63:0] sel_for_coalesced_delay_0_c;
    wire [31:0] sel_for_coalesced_delay_0_d;
    wire [0:0] redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_valid_in;
    wire redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_valid_in_bitsignaltemp;
    wire [0:0] redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_stall_in;
    wire redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_stall_in_bitsignaltemp;
    wire [31:0] redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_data_in;
    wire [0:0] redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_valid_out;
    wire redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_valid_out_bitsignaltemp;
    wire [0:0] redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_stall_out;
    wire redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_stall_out_bitsignaltemp;
    wire [31:0] redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_data_out;
    reg [31:0] redist4_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_9_0_q;
    wire [0:0] coalesced_delay_0_fifo_valid_in;
    wire coalesced_delay_0_fifo_valid_in_bitsignaltemp;
    wire [0:0] coalesced_delay_0_fifo_stall_in;
    wire coalesced_delay_0_fifo_stall_in_bitsignaltemp;
    wire [159:0] coalesced_delay_0_fifo_data_in;
    wire [0:0] coalesced_delay_0_fifo_valid_out;
    wire coalesced_delay_0_fifo_valid_out_bitsignaltemp;
    wire [0:0] coalesced_delay_0_fifo_stall_out;
    wire coalesced_delay_0_fifo_stall_out_bitsignaltemp;
    wire [159:0] coalesced_delay_0_fifo_data_out;
    wire [31:0] bubble_join_i_llvm_fpga_wg_limiter_enter_l_grpid_0_k2_zts6c_calc0_q;
    wire [31:0] bubble_select_i_llvm_fpga_wg_limiter_enter_l_grpid_0_k2_zts6c_calc0_b;
    wire [287:0] bubble_join_stall_entry_q;
    wire [63:0] bubble_select_stall_entry_b;
    wire [63:0] bubble_select_stall_entry_c;
    wire [31:0] bubble_select_stall_entry_d;
    wire [31:0] bubble_select_stall_entry_e;
    wire [31:0] bubble_select_stall_entry_f;
    wire [31:0] bubble_select_stall_entry_g;
    wire [31:0] bubble_select_stall_entry_h;
    wire [287:0] bubble_join_ZTS6c_calc_B0_merge_reg_aunroll_x_q;
    wire [63:0] bubble_select_ZTS6c_calc_B0_merge_reg_aunroll_x_b;
    wire [63:0] bubble_select_ZTS6c_calc_B0_merge_reg_aunroll_x_c;
    wire [31:0] bubble_select_ZTS6c_calc_B0_merge_reg_aunroll_x_d;
    wire [31:0] bubble_select_ZTS6c_calc_B0_merge_reg_aunroll_x_e;
    wire [31:0] bubble_select_ZTS6c_calc_B0_merge_reg_aunroll_x_f;
    wire [31:0] bubble_select_ZTS6c_calc_B0_merge_reg_aunroll_x_g;
    wire [31:0] bubble_select_ZTS6c_calc_B0_merge_reg_aunroll_x_h;
    wire [352:0] bubble_join_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_q;
    wire [31:0] bubble_select_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_b;
    wire [31:0] bubble_select_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_c;
    wire [0:0] bubble_select_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_d;
    wire [31:0] bubble_select_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_e;
    wire [63:0] bubble_select_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_f;
    wire [63:0] bubble_select_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_g;
    wire [63:0] bubble_select_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_h;
    wire [63:0] bubble_select_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_i;
    wire [31:0] bubble_join_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_q;
    wire [31:0] bubble_select_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_b;
    wire [159:0] bubble_join_coalesced_delay_0_fifo_q;
    wire [159:0] bubble_select_coalesced_delay_0_fifo_b;
    wire [0:0] SE_stall_entry_wireValid;
    wire [0:0] SE_stall_entry_backStall;
    wire [0:0] SE_stall_entry_V0;
    wire [0:0] SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_wireValid;
    wire [0:0] SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_wireStall;
    wire [0:0] SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_StallValid;
    wire [0:0] SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_toReg0;
    reg [0:0] SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_fromReg0;
    wire [0:0] SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_consumed0;
    wire [0:0] SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_toReg1;
    reg [0:0] SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_fromReg1;
    wire [0:0] SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_consumed1;
    wire [0:0] SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_toReg2;
    reg [0:0] SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_fromReg2;
    wire [0:0] SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_consumed2;
    wire [0:0] SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_or0;
    wire [0:0] SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_or1;
    wire [0:0] SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_backStall;
    wire [0:0] SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_V0;
    wire [0:0] SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_V1;
    wire [0:0] SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_V2;
    wire [0:0] SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_wireValid;
    wire [0:0] SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_wireStall;
    wire [0:0] SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_StallValid;
    wire [0:0] SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_toReg0;
    reg [0:0] SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_fromReg0;
    wire [0:0] SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_consumed0;
    wire [0:0] SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_toReg1;
    reg [0:0] SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_fromReg1;
    wire [0:0] SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_consumed1;
    wire [0:0] SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_or0;
    wire [0:0] SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_backStall;
    wire [0:0] SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_V0;
    wire [0:0] SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_V1;
    reg [0:0] SE_redist4_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_9_0_R_v_0;
    wire [0:0] SE_redist4_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_9_0_v_s_0;
    wire [0:0] SE_redist4_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_9_0_s_tv_0;
    wire [0:0] SE_redist4_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_9_0_backEN;
    wire [0:0] SE_redist4_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_9_0_backStall;
    wire [0:0] SE_redist4_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_9_0_V0;
    wire [0:0] SE_out_coalesced_delay_0_fifo_wireValid;
    wire [0:0] SE_out_coalesced_delay_0_fifo_and0;
    wire [0:0] SE_out_coalesced_delay_0_fifo_and1;
    wire [0:0] SE_out_coalesced_delay_0_fifo_and2;
    wire [0:0] SE_out_coalesced_delay_0_fifo_backStall;
    wire [0:0] SE_out_coalesced_delay_0_fifo_V0;


    // SE_redist4_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_9_0(STALLENABLE,69)
    // Valid signal propagation
    assign SE_redist4_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_9_0_V0 = SE_redist4_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_9_0_R_v_0;
    // Stall signal propagation
    assign SE_redist4_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_9_0_s_tv_0 = SE_out_coalesced_delay_0_fifo_backStall & SE_redist4_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_9_0_R_v_0;
    // Backward Enable generation
    assign SE_redist4_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_9_0_backEN = ~ (SE_redist4_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_9_0_s_tv_0);
    // Determine whether to write valid data into the first register stage
    assign SE_redist4_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_9_0_v_s_0 = SE_redist4_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_9_0_backEN & SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_V0;
    // Backward Stall generation
    assign SE_redist4_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_9_0_backStall = ~ (SE_redist4_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_9_0_v_s_0);
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            SE_redist4_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_9_0_R_v_0 <= 1'b0;
        end
        else
        begin
            if (SE_redist4_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_9_0_backEN == 1'b0)
            begin
                SE_redist4_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_9_0_R_v_0 <= SE_redist4_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_9_0_R_v_0 & SE_redist4_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_9_0_s_tv_0;
            end
            else
            begin
                SE_redist4_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_9_0_R_v_0 <= SE_redist4_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_9_0_v_s_0;
            end

        end
    end

    // bubble_join_stall_entry(BITJOIN,41)
    assign bubble_join_stall_entry_q = {in_acl_local_id_1, in_acl_local_id_0, in_acl_hw_wg_id, in_acl_group_id_1, in_acl_group_id_0, in_acl_global_id_1, in_acl_global_id_0};

    // bubble_select_stall_entry(BITSELECT,42)
    assign bubble_select_stall_entry_b = $unsigned(bubble_join_stall_entry_q[63:0]);
    assign bubble_select_stall_entry_c = $unsigned(bubble_join_stall_entry_q[127:64]);
    assign bubble_select_stall_entry_d = $unsigned(bubble_join_stall_entry_q[159:128]);
    assign bubble_select_stall_entry_e = $unsigned(bubble_join_stall_entry_q[191:160]);
    assign bubble_select_stall_entry_f = $unsigned(bubble_join_stall_entry_q[223:192]);
    assign bubble_select_stall_entry_g = $unsigned(bubble_join_stall_entry_q[255:224]);
    assign bubble_select_stall_entry_h = $unsigned(bubble_join_stall_entry_q[287:256]);

    // SE_stall_entry(STALLENABLE,59)
    // Valid signal propagation
    assign SE_stall_entry_V0 = SE_stall_entry_wireValid;
    // Backward Stall generation
    assign SE_stall_entry_backStall = ZTS6c_calc_B0_merge_reg_aunroll_x_out_stall_out | ~ (SE_stall_entry_wireValid);
    // Computing multiple Valid(s)
    assign SE_stall_entry_wireValid = in_valid_in;

    // ZTS6c_calc_B0_merge_reg_aunroll_x(BLACKBOX,19)@0
    // in in_stall_in@20000000
    // out out_stall_out@20000000
    // out out_valid_out@1
    // out out_data_out_0_tpl@1
    // out out_data_out_1_tpl@1
    // out out_data_out_2_tpl@1
    // out out_data_out_3_tpl@1
    // out out_data_out_4_tpl@1
    // out out_data_out_5_tpl@1
    // out out_data_out_6_tpl@1
    k2_ZTS6c_calc_ZTS6c_calc_B0_merge_reg theZTS6c_calc_B0_merge_reg_aunroll_x (
        .in_stall_in(SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_backStall),
        .in_valid_in(SE_stall_entry_V0),
        .in_data_in_0_tpl(bubble_select_stall_entry_b),
        .in_data_in_1_tpl(bubble_select_stall_entry_c),
        .in_data_in_2_tpl(bubble_select_stall_entry_g),
        .in_data_in_3_tpl(bubble_select_stall_entry_h),
        .in_data_in_4_tpl(bubble_select_stall_entry_d),
        .in_data_in_5_tpl(bubble_select_stall_entry_e),
        .in_data_in_6_tpl(bubble_select_stall_entry_f),
        .out_stall_out(ZTS6c_calc_B0_merge_reg_aunroll_x_out_stall_out),
        .out_valid_out(ZTS6c_calc_B0_merge_reg_aunroll_x_out_valid_out),
        .out_data_out_0_tpl(ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_0_tpl),
        .out_data_out_1_tpl(ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_1_tpl),
        .out_data_out_2_tpl(ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_2_tpl),
        .out_data_out_3_tpl(ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_3_tpl),
        .out_data_out_4_tpl(ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_4_tpl),
        .out_data_out_5_tpl(ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_5_tpl),
        .out_data_out_6_tpl(ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl),
        .clock(clock),
        .resetn(resetn)
    );

    // bubble_join_ZTS6c_calc_B0_merge_reg_aunroll_x(BITJOIN,45)
    assign bubble_join_ZTS6c_calc_B0_merge_reg_aunroll_x_q = {ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl, ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_5_tpl, ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_4_tpl, ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_3_tpl, ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_2_tpl, ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_1_tpl, ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_0_tpl};

    // bubble_select_ZTS6c_calc_B0_merge_reg_aunroll_x(BITSELECT,46)
    assign bubble_select_ZTS6c_calc_B0_merge_reg_aunroll_x_b = $unsigned(bubble_join_ZTS6c_calc_B0_merge_reg_aunroll_x_q[63:0]);
    assign bubble_select_ZTS6c_calc_B0_merge_reg_aunroll_x_c = $unsigned(bubble_join_ZTS6c_calc_B0_merge_reg_aunroll_x_q[127:64]);
    assign bubble_select_ZTS6c_calc_B0_merge_reg_aunroll_x_d = $unsigned(bubble_join_ZTS6c_calc_B0_merge_reg_aunroll_x_q[159:128]);
    assign bubble_select_ZTS6c_calc_B0_merge_reg_aunroll_x_e = $unsigned(bubble_join_ZTS6c_calc_B0_merge_reg_aunroll_x_q[191:160]);
    assign bubble_select_ZTS6c_calc_B0_merge_reg_aunroll_x_f = $unsigned(bubble_join_ZTS6c_calc_B0_merge_reg_aunroll_x_q[223:192]);
    assign bubble_select_ZTS6c_calc_B0_merge_reg_aunroll_x_g = $unsigned(bubble_join_ZTS6c_calc_B0_merge_reg_aunroll_x_q[255:224]);
    assign bubble_select_ZTS6c_calc_B0_merge_reg_aunroll_x_h = $unsigned(bubble_join_ZTS6c_calc_B0_merge_reg_aunroll_x_q[287:256]);

    // join_for_coalesced_delay_0(BITJOIN,31)
    assign join_for_coalesced_delay_0_q = {bubble_select_ZTS6c_calc_B0_merge_reg_aunroll_x_g, bubble_select_ZTS6c_calc_B0_merge_reg_aunroll_x_c, bubble_select_ZTS6c_calc_B0_merge_reg_aunroll_x_b};

    // coalesced_delay_0_fifo(STALLFIFO,35)
    assign coalesced_delay_0_fifo_valid_in = SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_V2;
    assign coalesced_delay_0_fifo_stall_in = SE_out_coalesced_delay_0_fifo_backStall;
    assign coalesced_delay_0_fifo_data_in = join_for_coalesced_delay_0_q;
    assign coalesced_delay_0_fifo_valid_in_bitsignaltemp = coalesced_delay_0_fifo_valid_in[0];
    assign coalesced_delay_0_fifo_stall_in_bitsignaltemp = coalesced_delay_0_fifo_stall_in[0];
    assign coalesced_delay_0_fifo_valid_out[0] = coalesced_delay_0_fifo_valid_out_bitsignaltemp;
    assign coalesced_delay_0_fifo_stall_out[0] = coalesced_delay_0_fifo_stall_out_bitsignaltemp;
    acl_data_fifo #(
        .DEPTH(10),
        .STRICT_DEPTH(0),
        .ALLOW_FULL_WRITE(0),
        .DATA_WIDTH(160),
        .IMPL("ram")
    ) thecoalesced_delay_0_fifo (
        .valid_in(coalesced_delay_0_fifo_valid_in_bitsignaltemp),
        .stall_in(coalesced_delay_0_fifo_stall_in_bitsignaltemp),
        .data_in(join_for_coalesced_delay_0_q),
        .valid_out(coalesced_delay_0_fifo_valid_out_bitsignaltemp),
        .stall_out(coalesced_delay_0_fifo_stall_out_bitsignaltemp),
        .data_out(coalesced_delay_0_fifo_data_out),
        .clock(clock),
        .resetn(resetn)
    );

    // GND(CONSTANT,0)
    assign GND_q = $unsigned(1'b0);

    // i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x(BLACKBOX,22)@1
    // in in_i_stall@20000000
    // out out_o_stall@20000000
    // out out_o_valid@10
    // out out_c0_exit_0_tpl@10
    // out out_c0_exit_1_tpl@10
    // out out_c0_exit_2_tpl@10
    // out out_c0_exit_3_tpl@10
    // out out_c0_exit_4_tpl@10
    // out out_c0_exit_5_tpl@10
    // out out_c0_exit_6_tpl@10
    // out out_c0_exit_7_tpl@10
    // out out_c0_exit_8_tpl@10
    k2_ZTS6c_calc_i_sfc_s_c0_in_zn2cl4sycl8a0000enter_k2_zts6c_calc2 thei_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x (
        .in_i_stall(SE_out_coalesced_delay_0_fifo_backStall),
        .in_i_valid(SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_V0),
        .in_arg1_0_tpl(in_arg1_0_tpl),
        .in_arg1_1_tpl(in_arg1_1_tpl),
        .in_arg9_0_tpl(in_arg9_0_tpl),
        .in_arg9_1_tpl(in_arg9_1_tpl),
        .in_c0_eni3_0_tpl(GND_q),
        .in_c0_eni3_1_tpl(bubble_select_ZTS6c_calc_B0_merge_reg_aunroll_x_f),
        .in_c0_eni3_2_tpl(bubble_select_ZTS6c_calc_B0_merge_reg_aunroll_x_d),
        .in_c0_eni3_3_tpl(bubble_select_ZTS6c_calc_B0_merge_reg_aunroll_x_e),
        .out_o_stall(i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_out_o_stall),
        .out_o_valid(i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_out_o_valid),
        .out_c0_exit_0_tpl(),
        .out_c0_exit_1_tpl(i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_out_c0_exit_1_tpl),
        .out_c0_exit_2_tpl(i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_out_c0_exit_2_tpl),
        .out_c0_exit_3_tpl(i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_out_c0_exit_3_tpl),
        .out_c0_exit_4_tpl(i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_out_c0_exit_4_tpl),
        .out_c0_exit_5_tpl(i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_out_c0_exit_5_tpl),
        .out_c0_exit_6_tpl(i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_out_c0_exit_6_tpl),
        .out_c0_exit_7_tpl(i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_out_c0_exit_7_tpl),
        .out_c0_exit_8_tpl(i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_out_c0_exit_8_tpl),
        .clock(clock),
        .resetn(resetn)
    );

    // SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x(STALLENABLE,62)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_fromReg0 <= '0;
            SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_fromReg1 <= '0;
            SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_fromReg2 <= '0;
        end
        else
        begin
            // Successor 0
            SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_fromReg0 <= SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_toReg0;
            // Successor 1
            SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_fromReg1 <= SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_toReg1;
            // Successor 2
            SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_fromReg2 <= SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_toReg2;
        end
    end
    // Input Stall processing
    assign SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_consumed0 = (~ (i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_out_o_stall) & SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_wireValid) | SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_fromReg0;
    assign SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_consumed1 = (~ (redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_stall_out) & SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_wireValid) | SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_fromReg1;
    assign SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_consumed2 = (~ (coalesced_delay_0_fifo_stall_out) & SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_wireValid) | SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_fromReg2;
    // Consuming
    assign SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_StallValid = SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_backStall & SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_wireValid;
    assign SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_toReg0 = SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_StallValid & SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_consumed0;
    assign SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_toReg1 = SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_StallValid & SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_consumed1;
    assign SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_toReg2 = SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_StallValid & SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_consumed2;
    // Backward Stall generation
    assign SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_or0 = SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_consumed0;
    assign SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_or1 = SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_consumed1 & SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_or0;
    assign SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_wireStall = ~ (SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_consumed2 & SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_or1);
    assign SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_backStall = SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_wireStall;
    // Valid signal propagation
    assign SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_V0 = SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_wireValid & ~ (SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_fromReg0);
    assign SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_V1 = SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_wireValid & ~ (SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_fromReg1);
    assign SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_V2 = SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_wireValid & ~ (SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_fromReg2);
    // Computing multiple Valid(s)
    assign SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_wireValid = ZTS6c_calc_B0_merge_reg_aunroll_x_out_valid_out;

    // redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo(STALLFIFO,33)
    assign redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_valid_in = SE_out_ZTS6c_calc_B0_merge_reg_aunroll_x_V1;
    assign redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_stall_in = SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_backStall;
    assign redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_data_in = bubble_select_ZTS6c_calc_B0_merge_reg_aunroll_x_h;
    assign redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_valid_in_bitsignaltemp = redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_valid_in[0];
    assign redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_stall_in_bitsignaltemp = redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_stall_in[0];
    assign redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_valid_out[0] = redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_valid_out_bitsignaltemp;
    assign redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_stall_out[0] = redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_stall_out_bitsignaltemp;
    acl_data_fifo #(
        .DEPTH(9),
        .STRICT_DEPTH(0),
        .ALLOW_FULL_WRITE(0),
        .DATA_WIDTH(32),
        .IMPL("ram")
    ) theredist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo (
        .valid_in(redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_valid_in_bitsignaltemp),
        .stall_in(redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_stall_in_bitsignaltemp),
        .data_in(bubble_select_ZTS6c_calc_B0_merge_reg_aunroll_x_h),
        .valid_out(redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_valid_out_bitsignaltemp),
        .stall_out(redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_stall_out_bitsignaltemp),
        .data_out(redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_data_out),
        .clock(clock),
        .resetn(resetn)
    );

    // SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo(STALLENABLE,68)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_fromReg0 <= '0;
            SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_fromReg1 <= '0;
        end
        else
        begin
            // Successor 0
            SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_fromReg0 <= SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_toReg0;
            // Successor 1
            SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_fromReg1 <= SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_toReg1;
        end
    end
    // Input Stall processing
    assign SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_consumed0 = (~ (SE_redist4_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_9_0_backStall) & SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_wireValid) | SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_fromReg0;
    assign SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_consumed1 = (~ (i_llvm_fpga_wg_limiter_enter_l_grpid_0_k2_zts6c_calc0_out_o_stall) & SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_wireValid) | SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_fromReg1;
    // Consuming
    assign SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_StallValid = SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_backStall & SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_wireValid;
    assign SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_toReg0 = SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_StallValid & SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_consumed0;
    assign SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_toReg1 = SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_StallValid & SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_consumed1;
    // Backward Stall generation
    assign SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_or0 = SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_consumed0;
    assign SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_wireStall = ~ (SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_consumed1 & SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_or0);
    assign SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_backStall = SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_wireStall;
    // Valid signal propagation
    assign SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_V0 = SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_wireValid & ~ (SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_fromReg0);
    assign SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_V1 = SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_wireValid & ~ (SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_fromReg1);
    // Computing multiple Valid(s)
    assign SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_wireValid = redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_valid_out;

    // SE_out_coalesced_delay_0_fifo(STALLENABLE,71)
    // Valid signal propagation
    assign SE_out_coalesced_delay_0_fifo_V0 = SE_out_coalesced_delay_0_fifo_wireValid;
    // Backward Stall generation
    assign SE_out_coalesced_delay_0_fifo_backStall = in_stall_in | ~ (SE_out_coalesced_delay_0_fifo_wireValid);
    // Computing multiple Valid(s)
    assign SE_out_coalesced_delay_0_fifo_and0 = coalesced_delay_0_fifo_valid_out;
    assign SE_out_coalesced_delay_0_fifo_and1 = i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_out_o_valid & SE_out_coalesced_delay_0_fifo_and0;
    assign SE_out_coalesced_delay_0_fifo_and2 = i_llvm_fpga_wg_limiter_enter_l_grpid_0_k2_zts6c_calc0_out_o_valid & SE_out_coalesced_delay_0_fifo_and1;
    assign SE_out_coalesced_delay_0_fifo_wireValid = SE_redist4_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_9_0_V0 & SE_out_coalesced_delay_0_fifo_and2;

    // bubble_join_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo(BITJOIN,52)
    assign bubble_join_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_q = redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_data_out;

    // bubble_select_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo(BITSELECT,53)
    assign bubble_select_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_b = $unsigned(bubble_join_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_q[31:0]);

    // i_llvm_fpga_wg_limiter_enter_l_grpid_0_k2_zts6c_calc0(BLACKBOX,7)@9
    // in in_i_stall@20000000
    // out out_o_data@10
    // out out_o_stall@20000000
    // out out_o_valid@10
    // out out_wgl_0_enter_exit_stall_out@20000000
    // out out_wgl_0_enter_exit_valid_out@20000000
    k2_ZTS6c_calc_i_llvm_fpga_wg_limiter_ent0000pid_0_k2_zts6c_calc0 thei_llvm_fpga_wg_limiter_enter_l_grpid_0_k2_zts6c_calc0 (
        .in_i_data(bubble_select_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_b),
        .in_i_stall(SE_out_coalesced_delay_0_fifo_backStall),
        .in_i_valid(SE_out_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_V1),
        .in_wgl_0_enter_exit_stall_in(in_wgl_0_enter_exit_stall_in),
        .in_wgl_0_enter_exit_valid_in(in_wgl_0_enter_exit_valid_in),
        .in_wgl_0_wgs_wg_size(in_wgl_0_wgs_wg_size),
        .out_o_data(i_llvm_fpga_wg_limiter_enter_l_grpid_0_k2_zts6c_calc0_out_o_data),
        .out_o_stall(i_llvm_fpga_wg_limiter_enter_l_grpid_0_k2_zts6c_calc0_out_o_stall),
        .out_o_valid(i_llvm_fpga_wg_limiter_enter_l_grpid_0_k2_zts6c_calc0_out_o_valid),
        .out_wgl_0_enter_exit_stall_out(i_llvm_fpga_wg_limiter_enter_l_grpid_0_k2_zts6c_calc0_out_wgl_0_enter_exit_stall_out),
        .out_wgl_0_enter_exit_valid_out(i_llvm_fpga_wg_limiter_enter_l_grpid_0_k2_zts6c_calc0_out_wgl_0_enter_exit_valid_out),
        .clock(clock),
        .resetn(resetn)
    );

    // ext_sig_sync_out(GPOUT,6)
    assign out_wgl_0_enter_exit_valid_out = i_llvm_fpga_wg_limiter_enter_l_grpid_0_k2_zts6c_calc0_out_wgl_0_enter_exit_valid_out;
    assign out_wgl_0_enter_exit_stall_out = i_llvm_fpga_wg_limiter_enter_l_grpid_0_k2_zts6c_calc0_out_wgl_0_enter_exit_stall_out;

    // sync_out(GPOUT,17)@0
    assign out_stall_out = SE_stall_entry_backStall;

    // bubble_join_i_llvm_fpga_wg_limiter_enter_l_grpid_0_k2_zts6c_calc0(BITJOIN,37)
    assign bubble_join_i_llvm_fpga_wg_limiter_enter_l_grpid_0_k2_zts6c_calc0_q = i_llvm_fpga_wg_limiter_enter_l_grpid_0_k2_zts6c_calc0_out_o_data;

    // bubble_select_i_llvm_fpga_wg_limiter_enter_l_grpid_0_k2_zts6c_calc0(BITSELECT,38)
    assign bubble_select_i_llvm_fpga_wg_limiter_enter_l_grpid_0_k2_zts6c_calc0_b = $unsigned(bubble_join_i_llvm_fpga_wg_limiter_enter_l_grpid_0_k2_zts6c_calc0_q[31:0]);

    // bubble_join_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x(BITJOIN,48)
    assign bubble_join_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_q = {i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_out_c0_exit_8_tpl, i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_out_c0_exit_7_tpl, i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_out_c0_exit_6_tpl, i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_out_c0_exit_5_tpl, i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_out_c0_exit_4_tpl, i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_out_c0_exit_3_tpl, i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_out_c0_exit_2_tpl, i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_out_c0_exit_1_tpl};

    // bubble_select_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x(BITSELECT,49)
    assign bubble_select_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_b = $unsigned(bubble_join_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_q[31:0]);
    assign bubble_select_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_c = $unsigned(bubble_join_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_q[63:32]);
    assign bubble_select_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_d = $unsigned(bubble_join_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_q[64:64]);
    assign bubble_select_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_e = $unsigned(bubble_join_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_q[96:65]);
    assign bubble_select_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_f = $unsigned(bubble_join_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_q[160:97]);
    assign bubble_select_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_g = $unsigned(bubble_join_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_q[224:161]);
    assign bubble_select_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_h = $unsigned(bubble_join_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_q[288:225]);
    assign bubble_select_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_i = $unsigned(bubble_join_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_q[352:289]);

    // redist4_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_9_0(REG,34)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist4_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_9_0_q <= $unsigned(32'b00000000000000000000000000000000);
        end
        else if (SE_redist4_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_9_0_backEN == 1'b1)
        begin
            redist4_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_9_0_q <= $unsigned(bubble_select_redist3_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_8_fifo_b);
        end
    end

    // bubble_join_coalesced_delay_0_fifo(BITJOIN,55)
    assign bubble_join_coalesced_delay_0_fifo_q = coalesced_delay_0_fifo_data_out;

    // bubble_select_coalesced_delay_0_fifo(BITSELECT,56)
    assign bubble_select_coalesced_delay_0_fifo_b = $unsigned(bubble_join_coalesced_delay_0_fifo_q[159:0]);

    // sel_for_coalesced_delay_0(BITSELECT,32)
    assign sel_for_coalesced_delay_0_b = $unsigned(bubble_select_coalesced_delay_0_fifo_b[63:0]);
    assign sel_for_coalesced_delay_0_c = $unsigned(bubble_select_coalesced_delay_0_fifo_b[127:64]);
    assign sel_for_coalesced_delay_0_d = $unsigned(bubble_select_coalesced_delay_0_fifo_b[159:128]);

    // dupName_0_sync_out_x(GPOUT,21)@10
    assign out_acl_global_id_0 = sel_for_coalesced_delay_0_b;
    assign out_acl_global_id_1 = sel_for_coalesced_delay_0_c;
    assign out_acl_group_id_1 = sel_for_coalesced_delay_0_d;
    assign out_acl_hw_wg_id = redist4_ZTS6c_calc_B0_merge_reg_aunroll_x_out_data_out_6_tpl_9_0_q;
    assign out_c0_exe1 = bubble_select_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_b;
    assign out_c0_exe2 = bubble_select_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_c;
    assign out_c0_exe3 = bubble_select_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_d;
    assign out_c0_exe4 = bubble_select_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_e;
    assign out_c0_exe5 = bubble_select_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_f;
    assign out_c0_exe6 = bubble_select_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_g;
    assign out_c0_exe7 = bubble_select_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_h;
    assign out_c0_exe8 = bubble_select_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1026elns2_6targete2016elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as3fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6c_calcs_c0_enter_k2_zts6c_calc2_aunroll_x_i;
    assign out_l_grpid_0 = bubble_select_i_llvm_fpga_wg_limiter_enter_l_grpid_0_k2_zts6c_calc0_b;
    assign out_valid_out = SE_out_coalesced_delay_0_fifo_V0;

endmodule
