// ------------------------------------------------------------------------- 
// High Level Design Compiler for Intel(R) FPGAs Version 20.3 (Release Build #121)
// 
// Legal Notice: Copyright 2020 Intel Corporation.  All rights reserved.
// Your use of  Intel Corporation's design tools,  logic functions and other
// software and  tools, and its AMPP partner logic functions, and any output
// files any  of the foregoing (including  device programming  or simulation
// files), and  any associated  documentation  or information  are expressly
// subject  to the terms and  conditions of the  Intel FPGA Software License
// Agreement, Intel MegaCore Function License Agreement, or other applicable
// license agreement,  including,  without limitation,  that your use is for
// the  sole  purpose of  programming  logic devices  manufactured by  Intel
// and  sold by Intel  or its authorized  distributors. Please refer  to the
// applicable agreement for further details.
// ---------------------------------------------------------------------------

// SystemVerilog created from k2_ZTS6c_calc_bb_ZTS6c_calc_B1
// SystemVerilog created on Thu Nov  5 06:32:57 2020


(* altera_attribute = "-name AUTO_SHIFT_REGISTER_RECOGNITION OFF; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 10037; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 15400; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 12020; -name MESSAGE_DISABLE 12030; -name MESSAGE_DISABLE 12010; -name MESSAGE_DISABLE 12110; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 13410; -name MESSAGE_DISABLE 113007; -name MESSAGE_DISABLE 10958" *)
module k2_ZTS6c_calc_bb_ZTS6c_calc_B1 (
    output wire [63:0] out_acl_global_id_044,
    output wire [63:0] out_acl_global_id_150,
    output wire [31:0] out_acl_hw_wg_id57,
    output wire [31:0] out_c0_exe17,
    output wire [31:0] out_c0_exe211,
    output wire [31:0] out_c0_exe415,
    output wire [63:0] out_c0_exe519,
    output wire [63:0] out_c0_exe623,
    output wire [63:0] out_c0_exe727,
    output wire [63:0] out_c0_exe831,
    output wire [31:0] out_l_grpid_06,
    output wire [0:0] out_stall_out_0,
    output wire [31:0] out_unnamed_k2_ZTS6c_calc5,
    output wire [0:0] out_valid_out_0,
    input wire [63:0] in_acl_global_id_044_0,
    input wire [63:0] in_acl_global_id_150_0,
    input wire [31:0] in_acl_group_id_151_0,
    input wire [31:0] in_acl_hw_wg_id57_0,
    input wire [63:0] in_arg12,
    input wire [63:0] in_arg16,
    input wire [63:0] in_arg4,
    input wire [31:0] in_c0_exe17_0,
    input wire [31:0] in_c0_exe211_0,
    input wire [31:0] in_c0_exe415_0,
    input wire [63:0] in_c0_exe519_0,
    input wire [63:0] in_c0_exe623_0,
    input wire [63:0] in_c0_exe727_0,
    input wire [63:0] in_c0_exe831_0,
    input wire [31:0] in_l_grpid_06_0,
    input wire [0:0] in_stall_in_0,
    input wire [0:0] in_valid_in_0,
    input wire [63:0] in_arg15_0_tpl,
    input wire [63:0] in_arg18_0_tpl,
    input wire [63:0] in_arg18_1_tpl,
    input wire [63:0] in_arg19_0_tpl,
    input wire [63:0] in_arg19_1_tpl,
    input wire [63:0] in_arg7_0_tpl,
    input wire clock,
    input wire resetn
    );

    wire [63:0] ZTS6c_calc_B1_branch_out_acl_global_id_044;
    wire [63:0] ZTS6c_calc_B1_branch_out_acl_global_id_150;
    wire [31:0] ZTS6c_calc_B1_branch_out_acl_hw_wg_id57;
    wire [31:0] ZTS6c_calc_B1_branch_out_c0_exe17;
    wire [31:0] ZTS6c_calc_B1_branch_out_c0_exe211;
    wire [31:0] ZTS6c_calc_B1_branch_out_c0_exe415;
    wire [63:0] ZTS6c_calc_B1_branch_out_c0_exe519;
    wire [63:0] ZTS6c_calc_B1_branch_out_c0_exe623;
    wire [63:0] ZTS6c_calc_B1_branch_out_c0_exe727;
    wire [63:0] ZTS6c_calc_B1_branch_out_c0_exe831;
    wire [31:0] ZTS6c_calc_B1_branch_out_l_grpid_06;
    wire [0:0] ZTS6c_calc_B1_branch_out_stall_out;
    wire [31:0] ZTS6c_calc_B1_branch_out_unnamed_k2_ZTS6c_calc5;
    wire [0:0] ZTS6c_calc_B1_branch_out_valid_out_0;
    wire [63:0] ZTS6c_calc_B1_merge_out_acl_global_id_044;
    wire [63:0] ZTS6c_calc_B1_merge_out_acl_global_id_150;
    wire [31:0] ZTS6c_calc_B1_merge_out_acl_group_id_151;
    wire [31:0] ZTS6c_calc_B1_merge_out_acl_hw_wg_id57;
    wire [31:0] ZTS6c_calc_B1_merge_out_c0_exe17;
    wire [31:0] ZTS6c_calc_B1_merge_out_c0_exe211;
    wire [31:0] ZTS6c_calc_B1_merge_out_c0_exe415;
    wire [63:0] ZTS6c_calc_B1_merge_out_c0_exe519;
    wire [63:0] ZTS6c_calc_B1_merge_out_c0_exe623;
    wire [63:0] ZTS6c_calc_B1_merge_out_c0_exe727;
    wire [63:0] ZTS6c_calc_B1_merge_out_c0_exe831;
    wire [31:0] ZTS6c_calc_B1_merge_out_l_grpid_06;
    wire [0:0] ZTS6c_calc_B1_merge_out_stall_out_0;
    wire [0:0] ZTS6c_calc_B1_merge_out_valid_out;
    wire [63:0] bb_ZTS6c_calc_B1_stall_region_out_acl_global_id_044;
    wire [63:0] bb_ZTS6c_calc_B1_stall_region_out_acl_global_id_150;
    wire [31:0] bb_ZTS6c_calc_B1_stall_region_out_acl_hw_wg_id57;
    wire [31:0] bb_ZTS6c_calc_B1_stall_region_out_c0_exe17;
    wire [31:0] bb_ZTS6c_calc_B1_stall_region_out_c0_exe211;
    wire [31:0] bb_ZTS6c_calc_B1_stall_region_out_c0_exe415;
    wire [63:0] bb_ZTS6c_calc_B1_stall_region_out_c0_exe519;
    wire [63:0] bb_ZTS6c_calc_B1_stall_region_out_c0_exe623;
    wire [63:0] bb_ZTS6c_calc_B1_stall_region_out_c0_exe727;
    wire [63:0] bb_ZTS6c_calc_B1_stall_region_out_c0_exe831;
    wire [31:0] bb_ZTS6c_calc_B1_stall_region_out_l_grpid_06;
    wire [0:0] bb_ZTS6c_calc_B1_stall_region_out_stall_out;
    wire [31:0] bb_ZTS6c_calc_B1_stall_region_out_unnamed_k2_ZTS6c_calc5;
    wire [0:0] bb_ZTS6c_calc_B1_stall_region_out_valid_out;


    // ZTS6c_calc_B1_merge(BLACKBOX,3)
    k2_ZTS6c_calc_ZTS6c_calc_B1_merge theZTS6c_calc_B1_merge (
        .in_acl_global_id_044_0(in_acl_global_id_044_0),
        .in_acl_global_id_150_0(in_acl_global_id_150_0),
        .in_acl_group_id_151_0(in_acl_group_id_151_0),
        .in_acl_hw_wg_id57_0(in_acl_hw_wg_id57_0),
        .in_c0_exe17_0(in_c0_exe17_0),
        .in_c0_exe211_0(in_c0_exe211_0),
        .in_c0_exe415_0(in_c0_exe415_0),
        .in_c0_exe519_0(in_c0_exe519_0),
        .in_c0_exe623_0(in_c0_exe623_0),
        .in_c0_exe727_0(in_c0_exe727_0),
        .in_c0_exe831_0(in_c0_exe831_0),
        .in_l_grpid_06_0(in_l_grpid_06_0),
        .in_stall_in(bb_ZTS6c_calc_B1_stall_region_out_stall_out),
        .in_valid_in_0(in_valid_in_0),
        .out_acl_global_id_044(ZTS6c_calc_B1_merge_out_acl_global_id_044),
        .out_acl_global_id_150(ZTS6c_calc_B1_merge_out_acl_global_id_150),
        .out_acl_group_id_151(ZTS6c_calc_B1_merge_out_acl_group_id_151),
        .out_acl_hw_wg_id57(ZTS6c_calc_B1_merge_out_acl_hw_wg_id57),
        .out_c0_exe17(ZTS6c_calc_B1_merge_out_c0_exe17),
        .out_c0_exe211(ZTS6c_calc_B1_merge_out_c0_exe211),
        .out_c0_exe415(ZTS6c_calc_B1_merge_out_c0_exe415),
        .out_c0_exe519(ZTS6c_calc_B1_merge_out_c0_exe519),
        .out_c0_exe623(ZTS6c_calc_B1_merge_out_c0_exe623),
        .out_c0_exe727(ZTS6c_calc_B1_merge_out_c0_exe727),
        .out_c0_exe831(ZTS6c_calc_B1_merge_out_c0_exe831),
        .out_l_grpid_06(ZTS6c_calc_B1_merge_out_l_grpid_06),
        .out_stall_out_0(ZTS6c_calc_B1_merge_out_stall_out_0),
        .out_valid_out(ZTS6c_calc_B1_merge_out_valid_out),
        .clock(clock),
        .resetn(resetn)
    );

    // bb_ZTS6c_calc_B1_stall_region(BLACKBOX,4)
    k2_ZTS6c_calc_bb_ZTS6c_calc_B1_stall_region thebb_ZTS6c_calc_B1_stall_region (
        .in_acl_global_id_044(ZTS6c_calc_B1_merge_out_acl_global_id_044),
        .in_acl_global_id_150(ZTS6c_calc_B1_merge_out_acl_global_id_150),
        .in_acl_group_id_151(ZTS6c_calc_B1_merge_out_acl_group_id_151),
        .in_acl_hw_wg_id57(ZTS6c_calc_B1_merge_out_acl_hw_wg_id57),
        .in_c0_exe17(ZTS6c_calc_B1_merge_out_c0_exe17),
        .in_c0_exe211(ZTS6c_calc_B1_merge_out_c0_exe211),
        .in_c0_exe415(ZTS6c_calc_B1_merge_out_c0_exe415),
        .in_c0_exe519(ZTS6c_calc_B1_merge_out_c0_exe519),
        .in_c0_exe623(ZTS6c_calc_B1_merge_out_c0_exe623),
        .in_c0_exe727(ZTS6c_calc_B1_merge_out_c0_exe727),
        .in_c0_exe831(ZTS6c_calc_B1_merge_out_c0_exe831),
        .in_l_grpid_06(ZTS6c_calc_B1_merge_out_l_grpid_06),
        .in_stall_in(ZTS6c_calc_B1_branch_out_stall_out),
        .in_valid_in(ZTS6c_calc_B1_merge_out_valid_out),
        .out_acl_global_id_044(bb_ZTS6c_calc_B1_stall_region_out_acl_global_id_044),
        .out_acl_global_id_150(bb_ZTS6c_calc_B1_stall_region_out_acl_global_id_150),
        .out_acl_hw_wg_id57(bb_ZTS6c_calc_B1_stall_region_out_acl_hw_wg_id57),
        .out_c0_exe17(bb_ZTS6c_calc_B1_stall_region_out_c0_exe17),
        .out_c0_exe211(bb_ZTS6c_calc_B1_stall_region_out_c0_exe211),
        .out_c0_exe415(bb_ZTS6c_calc_B1_stall_region_out_c0_exe415),
        .out_c0_exe519(bb_ZTS6c_calc_B1_stall_region_out_c0_exe519),
        .out_c0_exe623(bb_ZTS6c_calc_B1_stall_region_out_c0_exe623),
        .out_c0_exe727(bb_ZTS6c_calc_B1_stall_region_out_c0_exe727),
        .out_c0_exe831(bb_ZTS6c_calc_B1_stall_region_out_c0_exe831),
        .out_l_grpid_06(bb_ZTS6c_calc_B1_stall_region_out_l_grpid_06),
        .out_stall_out(bb_ZTS6c_calc_B1_stall_region_out_stall_out),
        .out_unnamed_k2_ZTS6c_calc5(bb_ZTS6c_calc_B1_stall_region_out_unnamed_k2_ZTS6c_calc5),
        .out_valid_out(bb_ZTS6c_calc_B1_stall_region_out_valid_out),
        .clock(clock),
        .resetn(resetn)
    );

    // ZTS6c_calc_B1_branch(BLACKBOX,2)
    k2_ZTS6c_calc_ZTS6c_calc_B1_branch theZTS6c_calc_B1_branch (
        .in_acl_global_id_044(bb_ZTS6c_calc_B1_stall_region_out_acl_global_id_044),
        .in_acl_global_id_150(bb_ZTS6c_calc_B1_stall_region_out_acl_global_id_150),
        .in_acl_hw_wg_id57(bb_ZTS6c_calc_B1_stall_region_out_acl_hw_wg_id57),
        .in_c0_exe17(bb_ZTS6c_calc_B1_stall_region_out_c0_exe17),
        .in_c0_exe211(bb_ZTS6c_calc_B1_stall_region_out_c0_exe211),
        .in_c0_exe415(bb_ZTS6c_calc_B1_stall_region_out_c0_exe415),
        .in_c0_exe519(bb_ZTS6c_calc_B1_stall_region_out_c0_exe519),
        .in_c0_exe623(bb_ZTS6c_calc_B1_stall_region_out_c0_exe623),
        .in_c0_exe727(bb_ZTS6c_calc_B1_stall_region_out_c0_exe727),
        .in_c0_exe831(bb_ZTS6c_calc_B1_stall_region_out_c0_exe831),
        .in_l_grpid_06(bb_ZTS6c_calc_B1_stall_region_out_l_grpid_06),
        .in_stall_in_0(in_stall_in_0),
        .in_unnamed_k2_ZTS6c_calc5(bb_ZTS6c_calc_B1_stall_region_out_unnamed_k2_ZTS6c_calc5),
        .in_valid_in(bb_ZTS6c_calc_B1_stall_region_out_valid_out),
        .out_acl_global_id_044(ZTS6c_calc_B1_branch_out_acl_global_id_044),
        .out_acl_global_id_150(ZTS6c_calc_B1_branch_out_acl_global_id_150),
        .out_acl_hw_wg_id57(ZTS6c_calc_B1_branch_out_acl_hw_wg_id57),
        .out_c0_exe17(ZTS6c_calc_B1_branch_out_c0_exe17),
        .out_c0_exe211(ZTS6c_calc_B1_branch_out_c0_exe211),
        .out_c0_exe415(ZTS6c_calc_B1_branch_out_c0_exe415),
        .out_c0_exe519(ZTS6c_calc_B1_branch_out_c0_exe519),
        .out_c0_exe623(ZTS6c_calc_B1_branch_out_c0_exe623),
        .out_c0_exe727(ZTS6c_calc_B1_branch_out_c0_exe727),
        .out_c0_exe831(ZTS6c_calc_B1_branch_out_c0_exe831),
        .out_l_grpid_06(ZTS6c_calc_B1_branch_out_l_grpid_06),
        .out_stall_out(ZTS6c_calc_B1_branch_out_stall_out),
        .out_unnamed_k2_ZTS6c_calc5(ZTS6c_calc_B1_branch_out_unnamed_k2_ZTS6c_calc5),
        .out_valid_out_0(ZTS6c_calc_B1_branch_out_valid_out_0),
        .clock(clock),
        .resetn(resetn)
    );

    // out_acl_global_id_044(GPOUT,5)
    assign out_acl_global_id_044 = ZTS6c_calc_B1_branch_out_acl_global_id_044;

    // out_acl_global_id_150(GPOUT,6)
    assign out_acl_global_id_150 = ZTS6c_calc_B1_branch_out_acl_global_id_150;

    // out_acl_hw_wg_id57(GPOUT,7)
    assign out_acl_hw_wg_id57 = ZTS6c_calc_B1_branch_out_acl_hw_wg_id57;

    // out_c0_exe17(GPOUT,8)
    assign out_c0_exe17 = ZTS6c_calc_B1_branch_out_c0_exe17;

    // out_c0_exe211(GPOUT,9)
    assign out_c0_exe211 = ZTS6c_calc_B1_branch_out_c0_exe211;

    // out_c0_exe415(GPOUT,10)
    assign out_c0_exe415 = ZTS6c_calc_B1_branch_out_c0_exe415;

    // out_c0_exe519(GPOUT,11)
    assign out_c0_exe519 = ZTS6c_calc_B1_branch_out_c0_exe519;

    // out_c0_exe623(GPOUT,12)
    assign out_c0_exe623 = ZTS6c_calc_B1_branch_out_c0_exe623;

    // out_c0_exe727(GPOUT,13)
    assign out_c0_exe727 = ZTS6c_calc_B1_branch_out_c0_exe727;

    // out_c0_exe831(GPOUT,14)
    assign out_c0_exe831 = ZTS6c_calc_B1_branch_out_c0_exe831;

    // out_l_grpid_06(GPOUT,15)
    assign out_l_grpid_06 = ZTS6c_calc_B1_branch_out_l_grpid_06;

    // out_stall_out_0(GPOUT,16)
    assign out_stall_out_0 = ZTS6c_calc_B1_merge_out_stall_out_0;

    // out_unnamed_k2_ZTS6c_calc5(GPOUT,17)
    assign out_unnamed_k2_ZTS6c_calc5 = ZTS6c_calc_B1_branch_out_unnamed_k2_ZTS6c_calc5;

    // out_valid_out_0(GPOUT,18)
    assign out_valid_out_0 = ZTS6c_calc_B1_branch_out_valid_out_0;

endmodule
