// ------------------------------------------------------------------------- 
// High Level Design Compiler for Intel(R) FPGAs Version 20.3 (Release Build #121)
// 
// Legal Notice: Copyright 2020 Intel Corporation.  All rights reserved.
// Your use of  Intel Corporation's design tools,  logic functions and other
// software and  tools, and its AMPP partner logic functions, and any output
// files any  of the foregoing (including  device programming  or simulation
// files), and  any associated  documentation  or information  are expressly
// subject  to the terms and  conditions of the  Intel FPGA Software License
// Agreement, Intel MegaCore Function License Agreement, or other applicable
// license agreement,  including,  without limitation,  that your use is for
// the  sole  purpose of  programming  logic devices  manufactured by  Intel
// and  sold by Intel  or its authorized  distributors. Please refer  to the
// applicable agreement for further details.
// ---------------------------------------------------------------------------

// SystemVerilog created from k2_ZTS6c_calc_bb_ZTS6c_calc_B1_stall_region
// SystemVerilog created on Thu Nov  5 06:32:57 2020


(* altera_attribute = "-name AUTO_SHIFT_REGISTER_RECOGNITION OFF; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 10037; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 15400; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 12020; -name MESSAGE_DISABLE 12030; -name MESSAGE_DISABLE 12010; -name MESSAGE_DISABLE 12110; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 13410; -name MESSAGE_DISABLE 113007; -name MESSAGE_DISABLE 10958" *)
module k2_ZTS6c_calc_bb_ZTS6c_calc_B1_stall_region (
    input wire [0:0] in_stall_in,
    output wire [0:0] out_stall_out,
    input wire [63:0] in_acl_global_id_044,
    input wire [63:0] in_acl_global_id_150,
    input wire [31:0] in_acl_group_id_151,
    input wire [31:0] in_acl_hw_wg_id57,
    input wire [31:0] in_c0_exe17,
    input wire [31:0] in_c0_exe211,
    input wire [31:0] in_c0_exe415,
    input wire [63:0] in_c0_exe519,
    input wire [63:0] in_c0_exe623,
    input wire [63:0] in_c0_exe727,
    input wire [63:0] in_c0_exe831,
    input wire [31:0] in_l_grpid_06,
    input wire [0:0] in_valid_in,
    output wire [63:0] out_acl_global_id_044,
    output wire [63:0] out_acl_global_id_150,
    output wire [31:0] out_acl_hw_wg_id57,
    output wire [31:0] out_c0_exe17,
    output wire [31:0] out_c0_exe211,
    output wire [31:0] out_c0_exe415,
    output wire [63:0] out_c0_exe519,
    output wire [63:0] out_c0_exe623,
    output wire [63:0] out_c0_exe727,
    output wire [63:0] out_c0_exe831,
    output wire [31:0] out_l_grpid_06,
    output wire [31:0] out_unnamed_k2_ZTS6c_calc5,
    output wire [0:0] out_valid_out,
    input wire clock,
    input wire resetn
    );

    wire [0:0] VCC_q;
    wire [3:0] i_unnamed_k2_zts6c_calc0_vt_const_3_q;
    wire [31:0] i_unnamed_k2_zts6c_calc0_vt_join_q;
    wire [27:0] i_unnamed_k2_zts6c_calc0_vt_select_31_b;
    wire [27:0] leftShiftStage0Idx1Rng4_uid23_dupName_3_i_unnamed_k2_zts6c_calc0_shift_x_in;
    wire [27:0] leftShiftStage0Idx1Rng4_uid23_dupName_3_i_unnamed_k2_zts6c_calc0_shift_x_b;
    wire [31:0] leftShiftStage0Idx1_uid24_dupName_3_i_unnamed_k2_zts6c_calc0_shift_x_q;
    wire [0:0] leftShiftStage0_uid26_dupName_3_i_unnamed_k2_zts6c_calc0_shift_x_s;
    reg [31:0] leftShiftStage0_uid26_dupName_3_i_unnamed_k2_zts6c_calc0_shift_x_q;
    wire [575:0] bubble_join_stall_entry_q;
    wire [63:0] bubble_select_stall_entry_b;
    wire [63:0] bubble_select_stall_entry_c;
    wire [31:0] bubble_select_stall_entry_d;
    wire [31:0] bubble_select_stall_entry_e;
    wire [31:0] bubble_select_stall_entry_f;
    wire [31:0] bubble_select_stall_entry_g;
    wire [31:0] bubble_select_stall_entry_h;
    wire [63:0] bubble_select_stall_entry_i;
    wire [63:0] bubble_select_stall_entry_j;
    wire [63:0] bubble_select_stall_entry_k;
    wire [63:0] bubble_select_stall_entry_l;
    wire [31:0] bubble_select_stall_entry_m;
    wire [0:0] SE_stall_entry_wireValid;
    wire [0:0] SE_stall_entry_backStall;
    wire [0:0] SE_stall_entry_V0;


    // SE_stall_entry(STALLENABLE,32)
    // Valid signal propagation
    assign SE_stall_entry_V0 = SE_stall_entry_wireValid;
    // Backward Stall generation
    assign SE_stall_entry_backStall = in_stall_in | ~ (SE_stall_entry_wireValid);
    // Computing multiple Valid(s)
    assign SE_stall_entry_wireValid = in_valid_in;

    // sync_out(GPOUT,11)@0
    assign out_stall_out = SE_stall_entry_backStall;

    // leftShiftStage0Idx1Rng4_uid23_dupName_3_i_unnamed_k2_zts6c_calc0_shift_x(BITSELECT,22)@0
    assign leftShiftStage0Idx1Rng4_uid23_dupName_3_i_unnamed_k2_zts6c_calc0_shift_x_in = bubble_select_stall_entry_d[27:0];
    assign leftShiftStage0Idx1Rng4_uid23_dupName_3_i_unnamed_k2_zts6c_calc0_shift_x_b = leftShiftStage0Idx1Rng4_uid23_dupName_3_i_unnamed_k2_zts6c_calc0_shift_x_in[27:0];

    // leftShiftStage0Idx1_uid24_dupName_3_i_unnamed_k2_zts6c_calc0_shift_x(BITJOIN,23)@0
    assign leftShiftStage0Idx1_uid24_dupName_3_i_unnamed_k2_zts6c_calc0_shift_x_q = {leftShiftStage0Idx1Rng4_uid23_dupName_3_i_unnamed_k2_zts6c_calc0_shift_x_b, i_unnamed_k2_zts6c_calc0_vt_const_3_q};

    // VCC(CONSTANT,1)
    assign VCC_q = $unsigned(1'b1);

    // leftShiftStage0_uid26_dupName_3_i_unnamed_k2_zts6c_calc0_shift_x(MUX,25)@0
    assign leftShiftStage0_uid26_dupName_3_i_unnamed_k2_zts6c_calc0_shift_x_s = VCC_q;
    always @(leftShiftStage0_uid26_dupName_3_i_unnamed_k2_zts6c_calc0_shift_x_s or bubble_select_stall_entry_d or leftShiftStage0Idx1_uid24_dupName_3_i_unnamed_k2_zts6c_calc0_shift_x_q)
    begin
        unique case (leftShiftStage0_uid26_dupName_3_i_unnamed_k2_zts6c_calc0_shift_x_s)
            1'b0 : leftShiftStage0_uid26_dupName_3_i_unnamed_k2_zts6c_calc0_shift_x_q = bubble_select_stall_entry_d;
            1'b1 : leftShiftStage0_uid26_dupName_3_i_unnamed_k2_zts6c_calc0_shift_x_q = leftShiftStage0Idx1_uid24_dupName_3_i_unnamed_k2_zts6c_calc0_shift_x_q;
            default : leftShiftStage0_uid26_dupName_3_i_unnamed_k2_zts6c_calc0_shift_x_q = 32'b0;
        endcase
    end

    // i_unnamed_k2_zts6c_calc0_vt_select_31(BITSELECT,7)@0
    assign i_unnamed_k2_zts6c_calc0_vt_select_31_b = leftShiftStage0_uid26_dupName_3_i_unnamed_k2_zts6c_calc0_shift_x_q[31:4];

    // i_unnamed_k2_zts6c_calc0_vt_const_3(CONSTANT,5)
    assign i_unnamed_k2_zts6c_calc0_vt_const_3_q = $unsigned(4'b0000);

    // i_unnamed_k2_zts6c_calc0_vt_join(BITJOIN,6)@0
    assign i_unnamed_k2_zts6c_calc0_vt_join_q = {i_unnamed_k2_zts6c_calc0_vt_select_31_b, i_unnamed_k2_zts6c_calc0_vt_const_3_q};

    // bubble_join_stall_entry(BITJOIN,28)
    assign bubble_join_stall_entry_q = {in_l_grpid_06, in_c0_exe831, in_c0_exe727, in_c0_exe623, in_c0_exe519, in_c0_exe415, in_c0_exe211, in_c0_exe17, in_acl_hw_wg_id57, in_acl_group_id_151, in_acl_global_id_150, in_acl_global_id_044};

    // bubble_select_stall_entry(BITSELECT,29)
    assign bubble_select_stall_entry_b = $unsigned(bubble_join_stall_entry_q[63:0]);
    assign bubble_select_stall_entry_c = $unsigned(bubble_join_stall_entry_q[127:64]);
    assign bubble_select_stall_entry_d = $unsigned(bubble_join_stall_entry_q[159:128]);
    assign bubble_select_stall_entry_e = $unsigned(bubble_join_stall_entry_q[191:160]);
    assign bubble_select_stall_entry_f = $unsigned(bubble_join_stall_entry_q[223:192]);
    assign bubble_select_stall_entry_g = $unsigned(bubble_join_stall_entry_q[255:224]);
    assign bubble_select_stall_entry_h = $unsigned(bubble_join_stall_entry_q[287:256]);
    assign bubble_select_stall_entry_i = $unsigned(bubble_join_stall_entry_q[351:288]);
    assign bubble_select_stall_entry_j = $unsigned(bubble_join_stall_entry_q[415:352]);
    assign bubble_select_stall_entry_k = $unsigned(bubble_join_stall_entry_q[479:416]);
    assign bubble_select_stall_entry_l = $unsigned(bubble_join_stall_entry_q[543:480]);
    assign bubble_select_stall_entry_m = $unsigned(bubble_join_stall_entry_q[575:544]);

    // dupName_0_sync_out_x(GPOUT,13)@0
    assign out_acl_global_id_044 = bubble_select_stall_entry_b;
    assign out_acl_global_id_150 = bubble_select_stall_entry_c;
    assign out_acl_hw_wg_id57 = bubble_select_stall_entry_e;
    assign out_c0_exe17 = bubble_select_stall_entry_f;
    assign out_c0_exe211 = bubble_select_stall_entry_g;
    assign out_c0_exe415 = bubble_select_stall_entry_h;
    assign out_c0_exe519 = bubble_select_stall_entry_i;
    assign out_c0_exe623 = bubble_select_stall_entry_j;
    assign out_c0_exe727 = bubble_select_stall_entry_k;
    assign out_c0_exe831 = bubble_select_stall_entry_l;
    assign out_l_grpid_06 = bubble_select_stall_entry_m;
    assign out_unnamed_k2_ZTS6c_calc5 = i_unnamed_k2_zts6c_calc0_vt_join_q;
    assign out_valid_out = SE_stall_entry_V0;

endmodule
