// ------------------------------------------------------------------------- 
// High Level Design Compiler for Intel(R) FPGAs Version 20.3 (Release Build #121)
// 
// Legal Notice: Copyright 2020 Intel Corporation.  All rights reserved.
// Your use of  Intel Corporation's design tools,  logic functions and other
// software and  tools, and its AMPP partner logic functions, and any output
// files any  of the foregoing (including  device programming  or simulation
// files), and  any associated  documentation  or information  are expressly
// subject  to the terms and  conditions of the  Intel FPGA Software License
// Agreement, Intel MegaCore Function License Agreement, or other applicable
// license agreement,  including,  without limitation,  that your use is for
// the  sole  purpose of  programming  logic devices  manufactured by  Intel
// and  sold by Intel  or its authorized  distributors. Please refer  to the
// applicable agreement for further details.
// ---------------------------------------------------------------------------

// SystemVerilog created from k2_ZTS6c_calc_bb_ZTS6c_calc_B3_stall_region
// SystemVerilog created on Thu Nov  5 06:32:57 2020


(* altera_attribute = "-name AUTO_SHIFT_REGISTER_RECOGNITION OFF; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 10037; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 15400; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 12020; -name MESSAGE_DISABLE 12030; -name MESSAGE_DISABLE 12010; -name MESSAGE_DISABLE 12110; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 13410; -name MESSAGE_DISABLE 113007; -name MESSAGE_DISABLE 10958" *)
module k2_ZTS6c_calc_bb_ZTS6c_calc_B3_stall_region (
    input wire [0:0] in_wgl_0_exit_exit_valid_out,
    input wire [0:0] in_wgl_0_exit_exit_stall_out,
    output wire [0:0] out_wgl_0_exit_exit_valid_in,
    output wire [0:0] out_wgl_0_exit_exit_stall_in,
    input wire [63:0] in_arg16,
    input wire [0:0] in_flush,
    input wire [0:0] in_stall_in,
    output wire [0:0] out_stall_out,
    input wire [63:0] in_acl_global_id_039,
    input wire [63:0] in_acl_global_id_145,
    input wire [31:0] in_acl_hw_wg_id52,
    input wire [0:0] in_do_directly_crit_edge,
    input wire [0:0] in_do_directly_crit_edge_loopexit,
    input wire [31:0] in_l_grpid_01,
    input wire [31:0] in_lcssa_lcssa,
    input wire [0:0] in_valid_in,
    input wire [511:0] in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_readdata,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_writeack,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_waitrequest,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_readdatavalid,
    output wire [32:0] out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_address,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_enable,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_read,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_write,
    output wire [511:0] out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_writedata,
    output wire [63:0] out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_byteenable,
    output wire [4:0] out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_burstcount,
    output wire [31:0] out_acl_hw_wg_id52,
    output wire [0:0] out_valid_out,
    output wire [0:0] out_lsu_unnamed_k2_ZTS6c_calc9_o_active,
    input wire [63:0] in_arg18_0_tpl,
    input wire [63:0] in_arg18_1_tpl,
    input wire [63:0] in_arg19_0_tpl,
    input wire [63:0] in_arg19_1_tpl,
    input wire clock,
    input wire resetn
    );

    wire [0:0] GND_q;
    wire [0:0] VCC_q;
    wire [31:0] c_float_0_000000e_008_q;
    wire [0:0] i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_qi;
    reg [0:0] i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q;
    wire [0:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc9_k2_zts6c_calc7_out_lsu_unnamed_k2_ZTS6c_calc9_o_active;
    wire [0:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc9_k2_zts6c_calc7_out_o_stall;
    wire [0:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc9_k2_zts6c_calc7_out_o_valid;
    wire [32:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc9_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_address;
    wire [4:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc9_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_burstcount;
    wire [63:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc9_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_byteenable;
    wire [0:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc9_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_enable;
    wire [0:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc9_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_read;
    wire [0:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc9_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_write;
    wire [511:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc9_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_writedata;
    wire [0:0] i_llvm_fpga_wg_limiter_exit_unnamed_k2_zts6c_calc6_k2_zts6c_calc2_out_exit_stall_in;
    wire [0:0] i_llvm_fpga_wg_limiter_exit_unnamed_k2_zts6c_calc6_k2_zts6c_calc2_out_exit_valid_in;
    wire [0:0] i_llvm_fpga_wg_limiter_exit_unnamed_k2_zts6c_calc6_k2_zts6c_calc2_out_stall_out;
    wire [0:0] i_llvm_fpga_wg_limiter_exit_unnamed_k2_zts6c_calc6_k2_zts6c_calc2_out_valid_out;
    wire [0:0] i_select1_k2_zts6c_calc0_s;
    reg [31:0] i_select1_k2_zts6c_calc0_q;
    wire [0:0] i_unnamed_k2_zts6c_calc6_q;
    wire [0:0] ZTS6c_calc_B3_merge_reg_aunroll_x_out_stall_out;
    wire [0:0] ZTS6c_calc_B3_merge_reg_aunroll_x_out_valid_out;
    wire [31:0] ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_0_tpl;
    wire [0:0] ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_1_tpl;
    wire [0:0] ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_2_tpl;
    wire [31:0] ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_3_tpl;
    wire [63:0] ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_4_tpl;
    wire [63:0] ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_5_tpl;
    wire [31:0] ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl;
    wire [0:0] i_sfc_s_c0_in_crit_edge_loopexit_zts6c_calcs_c0_enter37_k2_zts6c_calc4_aunroll_x_out_o_stall;
    wire [0:0] i_sfc_s_c0_in_crit_edge_loopexit_zts6c_calcs_c0_enter37_k2_zts6c_calc4_aunroll_x_out_o_valid;
    wire [63:0] i_sfc_s_c0_in_crit_edge_loopexit_zts6c_calcs_c0_enter37_k2_zts6c_calc4_aunroll_x_out_c0_exit41_1_tpl;
    wire [0:0] redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_valid_in;
    wire redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_valid_in_bitsignaltemp;
    wire [0:0] redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_stall_in;
    wire redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_stall_in_bitsignaltemp;
    wire [31:0] redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_data_in;
    wire [0:0] redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_valid_out;
    wire redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_valid_out_bitsignaltemp;
    wire [0:0] redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_stall_out;
    wire redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_stall_out_bitsignaltemp;
    wire [31:0] redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_data_out;
    wire [0:0] redist1_i_select1_k2_zts6c_calc0_q_10_fifo_valid_in;
    wire redist1_i_select1_k2_zts6c_calc0_q_10_fifo_valid_in_bitsignaltemp;
    wire [0:0] redist1_i_select1_k2_zts6c_calc0_q_10_fifo_stall_in;
    wire redist1_i_select1_k2_zts6c_calc0_q_10_fifo_stall_in_bitsignaltemp;
    wire [31:0] redist1_i_select1_k2_zts6c_calc0_q_10_fifo_data_in;
    wire [0:0] redist1_i_select1_k2_zts6c_calc0_q_10_fifo_valid_out;
    wire redist1_i_select1_k2_zts6c_calc0_q_10_fifo_valid_out_bitsignaltemp;
    wire [0:0] redist1_i_select1_k2_zts6c_calc0_q_10_fifo_stall_out;
    wire redist1_i_select1_k2_zts6c_calc0_q_10_fifo_stall_out_bitsignaltemp;
    wire [31:0] redist1_i_select1_k2_zts6c_calc0_q_10_fifo_data_out;
    wire [0:0] redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_valid_in;
    wire redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_valid_in_bitsignaltemp;
    wire [0:0] redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_stall_in;
    wire redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_stall_in_bitsignaltemp;
    wire [0:0] redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_data_in;
    wire [0:0] redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_valid_out;
    wire redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_valid_out_bitsignaltemp;
    wire [0:0] redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_stall_out;
    wire redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_stall_out_bitsignaltemp;
    wire [0:0] redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_data_out;
    wire [225:0] bubble_join_stall_entry_q;
    wire [63:0] bubble_select_stall_entry_b;
    wire [63:0] bubble_select_stall_entry_c;
    wire [31:0] bubble_select_stall_entry_d;
    wire [0:0] bubble_select_stall_entry_e;
    wire [0:0] bubble_select_stall_entry_f;
    wire [31:0] bubble_select_stall_entry_g;
    wire [31:0] bubble_select_stall_entry_h;
    wire [225:0] bubble_join_ZTS6c_calc_B3_merge_reg_aunroll_x_q;
    wire [31:0] bubble_select_ZTS6c_calc_B3_merge_reg_aunroll_x_b;
    wire [0:0] bubble_select_ZTS6c_calc_B3_merge_reg_aunroll_x_c;
    wire [0:0] bubble_select_ZTS6c_calc_B3_merge_reg_aunroll_x_d;
    wire [31:0] bubble_select_ZTS6c_calc_B3_merge_reg_aunroll_x_e;
    wire [63:0] bubble_select_ZTS6c_calc_B3_merge_reg_aunroll_x_f;
    wire [63:0] bubble_select_ZTS6c_calc_B3_merge_reg_aunroll_x_g;
    wire [31:0] bubble_select_ZTS6c_calc_B3_merge_reg_aunroll_x_h;
    wire [63:0] bubble_join_i_sfc_s_c0_in_crit_edge_loopexit_zts6c_calcs_c0_enter37_k2_zts6c_calc4_aunroll_x_q;
    wire [63:0] bubble_select_i_sfc_s_c0_in_crit_edge_loopexit_zts6c_calcs_c0_enter37_k2_zts6c_calc4_aunroll_x_b;
    wire [31:0] bubble_join_redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_q;
    wire [31:0] bubble_select_redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_b;
    wire [31:0] bubble_join_redist1_i_select1_k2_zts6c_calc0_q_10_fifo_q;
    wire [31:0] bubble_select_redist1_i_select1_k2_zts6c_calc0_q_10_fifo_b;
    wire [0:0] bubble_join_redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_q;
    wire [0:0] bubble_select_redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_b;
    reg [0:0] SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_R_v_0;
    reg [0:0] SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_R_v_1;
    wire [0:0] SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_v_s_0;
    wire [0:0] SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_s_tv_0;
    wire [0:0] SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_s_tv_1;
    wire [0:0] SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_backEN;
    wire [0:0] SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_or0;
    wire [0:0] SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_backStall;
    wire [0:0] SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_V0;
    wire [0:0] SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_V1;
    wire [0:0] SE_out_i_llvm_fpga_wg_limiter_exit_unnamed_k2_zts6c_calc6_k2_zts6c_calc2_wireValid;
    wire [0:0] SE_out_i_llvm_fpga_wg_limiter_exit_unnamed_k2_zts6c_calc6_k2_zts6c_calc2_backStall;
    wire [0:0] SE_stall_entry_wireValid;
    wire [0:0] SE_stall_entry_backStall;
    wire [0:0] SE_stall_entry_V0;
    wire [0:0] SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_wireValid;
    wire [0:0] SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_wireStall;
    wire [0:0] SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_StallValid;
    wire [0:0] SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_toReg0;
    reg [0:0] SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_fromReg0;
    wire [0:0] SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_consumed0;
    wire [0:0] SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_toReg1;
    reg [0:0] SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_fromReg1;
    wire [0:0] SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_consumed1;
    wire [0:0] SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_toReg2;
    reg [0:0] SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_fromReg2;
    wire [0:0] SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_consumed2;
    wire [0:0] SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_toReg3;
    reg [0:0] SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_fromReg3;
    wire [0:0] SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_consumed3;
    wire [0:0] SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_or0;
    wire [0:0] SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_or1;
    wire [0:0] SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_or2;
    wire [0:0] SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_backStall;
    wire [0:0] SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_V0;
    wire [0:0] SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_V1;
    wire [0:0] SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_V2;
    wire [0:0] SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_V3;
    wire [0:0] SE_out_redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_wireValid;
    wire [0:0] SE_out_redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_and0;
    wire [0:0] SE_out_redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_backStall;
    wire [0:0] SE_out_redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_V0;
    wire [0:0] SE_out_redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_wireValid;
    wire [0:0] SE_out_redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_and0;
    wire [0:0] SE_out_redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_and1;
    wire [0:0] SE_out_redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_backStall;
    wire [0:0] SE_out_redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_V0;


    // c_float_0_000000e_008(FLOATCONSTANT,2)
    assign c_float_0_000000e_008_q = $unsigned(32'b00000000000000000000000000000000);

    // i_select1_k2_zts6c_calc0(MUX,12)@1 + 1
    assign i_select1_k2_zts6c_calc0_s = bubble_select_ZTS6c_calc_B3_merge_reg_aunroll_x_c;
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            i_select1_k2_zts6c_calc0_q <= 32'b0;
        end
        else if (SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_backEN == 1'b1)
        begin
            unique case (i_select1_k2_zts6c_calc0_s)
                1'b0 : i_select1_k2_zts6c_calc0_q <= c_float_0_000000e_008_q;
                1'b1 : i_select1_k2_zts6c_calc0_q <= bubble_select_ZTS6c_calc_B3_merge_reg_aunroll_x_b;
                default : i_select1_k2_zts6c_calc0_q <= 32'b0;
            endcase
        end
    end

    // redist1_i_select1_k2_zts6c_calc0_q_10_fifo(STALLFIFO,41)
    assign redist1_i_select1_k2_zts6c_calc0_q_10_fifo_valid_in = SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_V0;
    assign redist1_i_select1_k2_zts6c_calc0_q_10_fifo_stall_in = SE_out_redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_backStall;
    assign redist1_i_select1_k2_zts6c_calc0_q_10_fifo_data_in = i_select1_k2_zts6c_calc0_q;
    assign redist1_i_select1_k2_zts6c_calc0_q_10_fifo_valid_in_bitsignaltemp = redist1_i_select1_k2_zts6c_calc0_q_10_fifo_valid_in[0];
    assign redist1_i_select1_k2_zts6c_calc0_q_10_fifo_stall_in_bitsignaltemp = redist1_i_select1_k2_zts6c_calc0_q_10_fifo_stall_in[0];
    assign redist1_i_select1_k2_zts6c_calc0_q_10_fifo_valid_out[0] = redist1_i_select1_k2_zts6c_calc0_q_10_fifo_valid_out_bitsignaltemp;
    assign redist1_i_select1_k2_zts6c_calc0_q_10_fifo_stall_out[0] = redist1_i_select1_k2_zts6c_calc0_q_10_fifo_stall_out_bitsignaltemp;
    acl_data_fifo #(
        .DEPTH(10),
        .STRICT_DEPTH(0),
        .ALLOW_FULL_WRITE(0),
        .DATA_WIDTH(32),
        .IMPL("ram")
    ) theredist1_i_select1_k2_zts6c_calc0_q_10_fifo (
        .valid_in(redist1_i_select1_k2_zts6c_calc0_q_10_fifo_valid_in_bitsignaltemp),
        .stall_in(redist1_i_select1_k2_zts6c_calc0_q_10_fifo_stall_in_bitsignaltemp),
        .data_in(i_select1_k2_zts6c_calc0_q),
        .valid_out(redist1_i_select1_k2_zts6c_calc0_q_10_fifo_valid_out_bitsignaltemp),
        .stall_out(redist1_i_select1_k2_zts6c_calc0_q_10_fifo_stall_out_bitsignaltemp),
        .data_out(redist1_i_select1_k2_zts6c_calc0_q_10_fifo_data_out),
        .clock(clock),
        .resetn(resetn)
    );

    // bubble_join_redist1_i_select1_k2_zts6c_calc0_q_10_fifo(BITJOIN,58)
    assign bubble_join_redist1_i_select1_k2_zts6c_calc0_q_10_fifo_q = redist1_i_select1_k2_zts6c_calc0_q_10_fifo_data_out;

    // bubble_select_redist1_i_select1_k2_zts6c_calc0_q_10_fifo(BITSELECT,59)
    assign bubble_select_redist1_i_select1_k2_zts6c_calc0_q_10_fifo_b = $unsigned(bubble_join_redist1_i_select1_k2_zts6c_calc0_q_10_fifo_q[31:0]);

    // i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1(LOGICAL,9)@1 + 1
    assign i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_qi = bubble_select_ZTS6c_calc_B3_merge_reg_aunroll_x_d | bubble_select_ZTS6c_calc_B3_merge_reg_aunroll_x_c;
    dspba_delay_ver #( .width(1), .depth(1), .reset_kind("ASYNC"), .phase(0), .modulus(1), .reset_high(1'b0) )
    i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_delay ( .xin(i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_qi), .xout(i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q), .ena(SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_backEN[0]), .clk(clock), .aclr(resetn) );

    // redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo(STALLFIFO,42)
    assign redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_valid_in = SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_V1;
    assign redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_stall_in = SE_out_redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_backStall;
    assign redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_data_in = i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q;
    assign redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_valid_in_bitsignaltemp = redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_valid_in[0];
    assign redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_stall_in_bitsignaltemp = redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_stall_in[0];
    assign redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_valid_out[0] = redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_valid_out_bitsignaltemp;
    assign redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_stall_out[0] = redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_stall_out_bitsignaltemp;
    acl_data_fifo #(
        .DEPTH(10),
        .STRICT_DEPTH(0),
        .ALLOW_FULL_WRITE(0),
        .DATA_WIDTH(1),
        .IMPL("ram")
    ) theredist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo (
        .valid_in(redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_valid_in_bitsignaltemp),
        .stall_in(redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_stall_in_bitsignaltemp),
        .data_in(i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q),
        .valid_out(redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_valid_out_bitsignaltemp),
        .stall_out(redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_stall_out_bitsignaltemp),
        .data_out(redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_data_out),
        .clock(clock),
        .resetn(resetn)
    );

    // SE_out_redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo(STALLENABLE,81)
    // Valid signal propagation
    assign SE_out_redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_V0 = SE_out_redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_wireValid;
    // Backward Stall generation
    assign SE_out_redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_backStall = i_llvm_fpga_mem_unnamed_k2_zts6c_calc9_k2_zts6c_calc7_out_o_stall | ~ (SE_out_redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_wireValid);
    // Computing multiple Valid(s)
    assign SE_out_redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_and0 = redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_valid_out;
    assign SE_out_redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_and1 = redist1_i_select1_k2_zts6c_calc0_q_10_fifo_valid_out & SE_out_redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_and0;
    assign SE_out_redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_wireValid = i_sfc_s_c0_in_crit_edge_loopexit_zts6c_calcs_c0_enter37_k2_zts6c_calc4_aunroll_x_out_o_valid & SE_out_redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_and1;

    // VCC(CONSTANT,1)
    assign VCC_q = $unsigned(1'b1);

    // bubble_join_redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo(BITJOIN,61)
    assign bubble_join_redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_q = redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_data_out;

    // bubble_select_redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo(BITSELECT,62)
    assign bubble_select_redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_b = $unsigned(bubble_join_redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_q[0:0]);

    // i_unnamed_k2_zts6c_calc6(LOGICAL,13)@11
    assign i_unnamed_k2_zts6c_calc6_q = bubble_select_redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_b ^ VCC_q;

    // bubble_join_i_sfc_s_c0_in_crit_edge_loopexit_zts6c_calcs_c0_enter37_k2_zts6c_calc4_aunroll_x(BITJOIN,52)
    assign bubble_join_i_sfc_s_c0_in_crit_edge_loopexit_zts6c_calcs_c0_enter37_k2_zts6c_calc4_aunroll_x_q = i_sfc_s_c0_in_crit_edge_loopexit_zts6c_calcs_c0_enter37_k2_zts6c_calc4_aunroll_x_out_c0_exit41_1_tpl;

    // bubble_select_i_sfc_s_c0_in_crit_edge_loopexit_zts6c_calcs_c0_enter37_k2_zts6c_calc4_aunroll_x(BITSELECT,53)
    assign bubble_select_i_sfc_s_c0_in_crit_edge_loopexit_zts6c_calcs_c0_enter37_k2_zts6c_calc4_aunroll_x_b = $unsigned(bubble_join_i_sfc_s_c0_in_crit_edge_loopexit_zts6c_calcs_c0_enter37_k2_zts6c_calc4_aunroll_x_q[63:0]);

    // i_llvm_fpga_mem_unnamed_k2_zts6c_calc9_k2_zts6c_calc7(BLACKBOX,10)@11
    // in in_i_stall@20000000
    // out out_lsu_unnamed_k2_ZTS6c_calc9_o_active@20000000
    // out out_o_stall@20000000
    // out out_o_valid@13
    // out out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_address@20000000
    // out out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_burstcount@20000000
    // out out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_byteenable@20000000
    // out out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_enable@20000000
    // out out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_read@20000000
    // out out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_write@20000000
    // out out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_writedata@20000000
    k2_ZTS6c_calc_i_llvm_fpga_mem_unnamed_k20000calc9_k2_zts6c_calc0 thei_llvm_fpga_mem_unnamed_k2_zts6c_calc9_k2_zts6c_calc7 (
        .in_flush(in_flush),
        .in_i_address(bubble_select_i_sfc_s_c0_in_crit_edge_loopexit_zts6c_calcs_c0_enter37_k2_zts6c_calc4_aunroll_x_b),
        .in_i_predicate(i_unnamed_k2_zts6c_calc6_q),
        .in_i_stall(SE_out_redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_backStall),
        .in_i_valid(SE_out_redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_V0),
        .in_i_writedata(bubble_select_redist1_i_select1_k2_zts6c_calc0_q_10_fifo_b),
        .in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_readdata(in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_readdata),
        .in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_readdatavalid(in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_readdatavalid),
        .in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_waitrequest(in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_waitrequest),
        .in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_writeack(in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_writeack),
        .out_lsu_unnamed_k2_ZTS6c_calc9_o_active(i_llvm_fpga_mem_unnamed_k2_zts6c_calc9_k2_zts6c_calc7_out_lsu_unnamed_k2_ZTS6c_calc9_o_active),
        .out_o_stall(i_llvm_fpga_mem_unnamed_k2_zts6c_calc9_k2_zts6c_calc7_out_o_stall),
        .out_o_valid(i_llvm_fpga_mem_unnamed_k2_zts6c_calc9_k2_zts6c_calc7_out_o_valid),
        .out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_address(i_llvm_fpga_mem_unnamed_k2_zts6c_calc9_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_address),
        .out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_burstcount(i_llvm_fpga_mem_unnamed_k2_zts6c_calc9_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_burstcount),
        .out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_byteenable(i_llvm_fpga_mem_unnamed_k2_zts6c_calc9_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_byteenable),
        .out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_enable(i_llvm_fpga_mem_unnamed_k2_zts6c_calc9_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_enable),
        .out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_read(i_llvm_fpga_mem_unnamed_k2_zts6c_calc9_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_read),
        .out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_write(i_llvm_fpga_mem_unnamed_k2_zts6c_calc9_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_write),
        .out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_writedata(i_llvm_fpga_mem_unnamed_k2_zts6c_calc9_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_writedata),
        .clock(clock),
        .resetn(resetn)
    );

    // SE_out_redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo(STALLENABLE,77)
    // Valid signal propagation
    assign SE_out_redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_V0 = SE_out_redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_wireValid;
    // Backward Stall generation
    assign SE_out_redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_backStall = in_stall_in | ~ (SE_out_redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_wireValid);
    // Computing multiple Valid(s)
    assign SE_out_redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_and0 = redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_valid_out;
    assign SE_out_redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_wireValid = i_llvm_fpga_mem_unnamed_k2_zts6c_calc9_k2_zts6c_calc7_out_o_valid & SE_out_redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_and0;

    // redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo(STALLFIFO,40)
    assign redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_valid_in = SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_V3;
    assign redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_stall_in = SE_out_redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_backStall;
    assign redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_data_in = bubble_select_ZTS6c_calc_B3_merge_reg_aunroll_x_h;
    assign redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_valid_in_bitsignaltemp = redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_valid_in[0];
    assign redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_stall_in_bitsignaltemp = redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_stall_in[0];
    assign redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_valid_out[0] = redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_valid_out_bitsignaltemp;
    assign redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_stall_out[0] = redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_stall_out_bitsignaltemp;
    acl_data_fifo #(
        .DEPTH(13),
        .STRICT_DEPTH(0),
        .ALLOW_FULL_WRITE(0),
        .DATA_WIDTH(32),
        .IMPL("ram")
    ) theredist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo (
        .valid_in(redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_valid_in_bitsignaltemp),
        .stall_in(redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_stall_in_bitsignaltemp),
        .data_in(bubble_select_ZTS6c_calc_B3_merge_reg_aunroll_x_h),
        .valid_out(redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_valid_out_bitsignaltemp),
        .stall_out(redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_stall_out_bitsignaltemp),
        .data_out(redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_data_out),
        .clock(clock),
        .resetn(resetn)
    );

    // GND(CONSTANT,0)
    assign GND_q = $unsigned(1'b0);

    // i_sfc_s_c0_in_crit_edge_loopexit_zts6c_calcs_c0_enter37_k2_zts6c_calc4_aunroll_x(BLACKBOX,34)@1
    // in in_i_stall@20000000
    // out out_o_stall@20000000
    // out out_o_valid@11
    // out out_c0_exit41_0_tpl@11
    // out out_c0_exit41_1_tpl@11
    k2_ZTS6c_calc_i_sfc_s_c0_in_crit_edge_lo0000ter37_k2_zts6c_calc4 thei_sfc_s_c0_in_crit_edge_loopexit_zts6c_calcs_c0_enter37_k2_zts6c_calc4_aunroll_x (
        .in_arg16(in_arg16),
        .in_i_stall(SE_out_redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_backStall),
        .in_i_valid(SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_V2),
        .in_arg18_0_tpl(in_arg18_0_tpl),
        .in_arg18_1_tpl(in_arg18_1_tpl),
        .in_arg19_0_tpl(in_arg19_0_tpl),
        .in_arg19_1_tpl(in_arg19_1_tpl),
        .in_c0_eni236_0_tpl(GND_q),
        .in_c0_eni236_1_tpl(bubble_select_ZTS6c_calc_B3_merge_reg_aunroll_x_f),
        .in_c0_eni236_2_tpl(bubble_select_ZTS6c_calc_B3_merge_reg_aunroll_x_g),
        .out_o_stall(i_sfc_s_c0_in_crit_edge_loopexit_zts6c_calcs_c0_enter37_k2_zts6c_calc4_aunroll_x_out_o_stall),
        .out_o_valid(i_sfc_s_c0_in_crit_edge_loopexit_zts6c_calcs_c0_enter37_k2_zts6c_calc4_aunroll_x_out_o_valid),
        .out_c0_exit41_0_tpl(),
        .out_c0_exit41_1_tpl(i_sfc_s_c0_in_crit_edge_loopexit_zts6c_calcs_c0_enter37_k2_zts6c_calc4_aunroll_x_out_c0_exit41_1_tpl),
        .clock(clock),
        .resetn(resetn)
    );

    // SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1(STALLENABLE,63)
    // Valid signal propagation
    assign SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_V0 = SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_R_v_0;
    assign SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_V1 = SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_R_v_1;
    // Stall signal propagation
    assign SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_s_tv_0 = redist1_i_select1_k2_zts6c_calc0_q_10_fifo_stall_out & SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_R_v_0;
    assign SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_s_tv_1 = redist2_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_q_10_fifo_stall_out & SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_R_v_1;
    // Backward Enable generation
    assign SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_or0 = SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_s_tv_0;
    assign SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_backEN = ~ (SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_s_tv_1 | SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_or0);
    // Determine whether to write valid data into the first register stage
    assign SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_v_s_0 = SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_backEN & SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_V0;
    // Backward Stall generation
    assign SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_backStall = ~ (SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_v_s_0);
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_R_v_0 <= 1'b0;
            SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_R_v_1 <= 1'b0;
        end
        else
        begin
            if (SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_backEN == 1'b0)
            begin
                SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_R_v_0 <= SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_R_v_0 & SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_s_tv_0;
            end
            else
            begin
                SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_R_v_0 <= SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_v_s_0;
            end

            if (SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_backEN == 1'b0)
            begin
                SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_R_v_1 <= SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_R_v_1 & SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_s_tv_1;
            end
            else
            begin
                SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_R_v_1 <= SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_v_s_0;
            end

        end
    end

    // bubble_join_stall_entry(BITJOIN,45)
    assign bubble_join_stall_entry_q = {in_lcssa_lcssa, in_l_grpid_01, in_do_directly_crit_edge_loopexit, in_do_directly_crit_edge, in_acl_hw_wg_id52, in_acl_global_id_145, in_acl_global_id_039};

    // bubble_select_stall_entry(BITSELECT,46)
    assign bubble_select_stall_entry_b = $unsigned(bubble_join_stall_entry_q[63:0]);
    assign bubble_select_stall_entry_c = $unsigned(bubble_join_stall_entry_q[127:64]);
    assign bubble_select_stall_entry_d = $unsigned(bubble_join_stall_entry_q[159:128]);
    assign bubble_select_stall_entry_e = $unsigned(bubble_join_stall_entry_q[160:160]);
    assign bubble_select_stall_entry_f = $unsigned(bubble_join_stall_entry_q[161:161]);
    assign bubble_select_stall_entry_g = $unsigned(bubble_join_stall_entry_q[193:162]);
    assign bubble_select_stall_entry_h = $unsigned(bubble_join_stall_entry_q[225:194]);

    // SE_stall_entry(STALLENABLE,70)
    // Valid signal propagation
    assign SE_stall_entry_V0 = SE_stall_entry_wireValid;
    // Backward Stall generation
    assign SE_stall_entry_backStall = ZTS6c_calc_B3_merge_reg_aunroll_x_out_stall_out | ~ (SE_stall_entry_wireValid);
    // Computing multiple Valid(s)
    assign SE_stall_entry_wireValid = in_valid_in;

    // ZTS6c_calc_B3_merge_reg_aunroll_x(BLACKBOX,29)@0
    // in in_stall_in@20000000
    // out out_stall_out@20000000
    // out out_valid_out@1
    // out out_data_out_0_tpl@1
    // out out_data_out_1_tpl@1
    // out out_data_out_2_tpl@1
    // out out_data_out_3_tpl@1
    // out out_data_out_4_tpl@1
    // out out_data_out_5_tpl@1
    // out out_data_out_6_tpl@1
    k2_ZTS6c_calc_ZTS6c_calc_B3_merge_reg theZTS6c_calc_B3_merge_reg_aunroll_x (
        .in_stall_in(SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_backStall),
        .in_valid_in(SE_stall_entry_V0),
        .in_data_in_0_tpl(bubble_select_stall_entry_h),
        .in_data_in_1_tpl(bubble_select_stall_entry_f),
        .in_data_in_2_tpl(bubble_select_stall_entry_e),
        .in_data_in_3_tpl(bubble_select_stall_entry_g),
        .in_data_in_4_tpl(bubble_select_stall_entry_b),
        .in_data_in_5_tpl(bubble_select_stall_entry_c),
        .in_data_in_6_tpl(bubble_select_stall_entry_d),
        .out_stall_out(ZTS6c_calc_B3_merge_reg_aunroll_x_out_stall_out),
        .out_valid_out(ZTS6c_calc_B3_merge_reg_aunroll_x_out_valid_out),
        .out_data_out_0_tpl(ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_0_tpl),
        .out_data_out_1_tpl(ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_1_tpl),
        .out_data_out_2_tpl(ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_2_tpl),
        .out_data_out_3_tpl(ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_3_tpl),
        .out_data_out_4_tpl(ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_4_tpl),
        .out_data_out_5_tpl(ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_5_tpl),
        .out_data_out_6_tpl(ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl),
        .clock(clock),
        .resetn(resetn)
    );

    // SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x(STALLENABLE,73)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_fromReg0 <= '0;
            SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_fromReg1 <= '0;
            SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_fromReg2 <= '0;
            SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_fromReg3 <= '0;
        end
        else
        begin
            // Successor 0
            SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_fromReg0 <= SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_toReg0;
            // Successor 1
            SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_fromReg1 <= SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_toReg1;
            // Successor 2
            SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_fromReg2 <= SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_toReg2;
            // Successor 3
            SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_fromReg3 <= SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_toReg3;
        end
    end
    // Input Stall processing
    assign SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_consumed0 = (~ (SE_i_do_crit_edge_from_crit_edge_loopexit_k2_zts6c_calc1_backStall) & SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_wireValid) | SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_fromReg0;
    assign SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_consumed1 = (~ (i_llvm_fpga_wg_limiter_exit_unnamed_k2_zts6c_calc6_k2_zts6c_calc2_out_stall_out) & SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_wireValid) | SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_fromReg1;
    assign SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_consumed2 = (~ (i_sfc_s_c0_in_crit_edge_loopexit_zts6c_calcs_c0_enter37_k2_zts6c_calc4_aunroll_x_out_o_stall) & SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_wireValid) | SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_fromReg2;
    assign SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_consumed3 = (~ (redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_stall_out) & SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_wireValid) | SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_fromReg3;
    // Consuming
    assign SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_StallValid = SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_backStall & SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_wireValid;
    assign SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_toReg0 = SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_StallValid & SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_consumed0;
    assign SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_toReg1 = SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_StallValid & SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_consumed1;
    assign SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_toReg2 = SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_StallValid & SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_consumed2;
    assign SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_toReg3 = SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_StallValid & SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_consumed3;
    // Backward Stall generation
    assign SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_or0 = SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_consumed0;
    assign SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_or1 = SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_consumed1 & SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_or0;
    assign SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_or2 = SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_consumed2 & SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_or1;
    assign SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_wireStall = ~ (SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_consumed3 & SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_or2);
    assign SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_backStall = SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_wireStall;
    // Valid signal propagation
    assign SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_V0 = SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_wireValid & ~ (SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_fromReg0);
    assign SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_V1 = SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_wireValid & ~ (SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_fromReg1);
    assign SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_V2 = SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_wireValid & ~ (SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_fromReg2);
    assign SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_V3 = SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_wireValid & ~ (SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_fromReg3);
    // Computing multiple Valid(s)
    assign SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_wireValid = ZTS6c_calc_B3_merge_reg_aunroll_x_out_valid_out;

    // SE_out_i_llvm_fpga_wg_limiter_exit_unnamed_k2_zts6c_calc6_k2_zts6c_calc2(STALLENABLE,67)
    // Backward Stall generation
    assign SE_out_i_llvm_fpga_wg_limiter_exit_unnamed_k2_zts6c_calc6_k2_zts6c_calc2_backStall = $unsigned(1'b0);
    // Computing multiple Valid(s)
    assign SE_out_i_llvm_fpga_wg_limiter_exit_unnamed_k2_zts6c_calc6_k2_zts6c_calc2_wireValid = i_llvm_fpga_wg_limiter_exit_unnamed_k2_zts6c_calc6_k2_zts6c_calc2_out_valid_out;

    // bubble_join_ZTS6c_calc_B3_merge_reg_aunroll_x(BITJOIN,49)
    assign bubble_join_ZTS6c_calc_B3_merge_reg_aunroll_x_q = {ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl, ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_5_tpl, ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_4_tpl, ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_3_tpl, ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_2_tpl, ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_1_tpl, ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_0_tpl};

    // bubble_select_ZTS6c_calc_B3_merge_reg_aunroll_x(BITSELECT,50)
    assign bubble_select_ZTS6c_calc_B3_merge_reg_aunroll_x_b = $unsigned(bubble_join_ZTS6c_calc_B3_merge_reg_aunroll_x_q[31:0]);
    assign bubble_select_ZTS6c_calc_B3_merge_reg_aunroll_x_c = $unsigned(bubble_join_ZTS6c_calc_B3_merge_reg_aunroll_x_q[32:32]);
    assign bubble_select_ZTS6c_calc_B3_merge_reg_aunroll_x_d = $unsigned(bubble_join_ZTS6c_calc_B3_merge_reg_aunroll_x_q[33:33]);
    assign bubble_select_ZTS6c_calc_B3_merge_reg_aunroll_x_e = $unsigned(bubble_join_ZTS6c_calc_B3_merge_reg_aunroll_x_q[65:34]);
    assign bubble_select_ZTS6c_calc_B3_merge_reg_aunroll_x_f = $unsigned(bubble_join_ZTS6c_calc_B3_merge_reg_aunroll_x_q[129:66]);
    assign bubble_select_ZTS6c_calc_B3_merge_reg_aunroll_x_g = $unsigned(bubble_join_ZTS6c_calc_B3_merge_reg_aunroll_x_q[193:130]);
    assign bubble_select_ZTS6c_calc_B3_merge_reg_aunroll_x_h = $unsigned(bubble_join_ZTS6c_calc_B3_merge_reg_aunroll_x_q[225:194]);

    // i_llvm_fpga_wg_limiter_exit_unnamed_k2_zts6c_calc6_k2_zts6c_calc2(BLACKBOX,11)@1
    // in in_stall_in@20000000
    // out out_data_out@2
    // out out_exit_stall_in@2
    // out out_exit_valid_in@2
    // out out_stall_out@20000000
    // out out_valid_out@2
    k2_ZTS6c_calc_i_llvm_fpga_wg_limiter_exi0000calc6_k2_zts6c_calc0 thei_llvm_fpga_wg_limiter_exit_unnamed_k2_zts6c_calc6_k2_zts6c_calc2 (
        .in_data_in(bubble_select_ZTS6c_calc_B3_merge_reg_aunroll_x_e),
        .in_exit_stall_out(in_wgl_0_exit_exit_stall_out),
        .in_exit_valid_out(in_wgl_0_exit_exit_valid_out),
        .in_stall_in(SE_out_i_llvm_fpga_wg_limiter_exit_unnamed_k2_zts6c_calc6_k2_zts6c_calc2_backStall),
        .in_valid_in(SE_out_ZTS6c_calc_B3_merge_reg_aunroll_x_V1),
        .out_data_out(),
        .out_exit_stall_in(i_llvm_fpga_wg_limiter_exit_unnamed_k2_zts6c_calc6_k2_zts6c_calc2_out_exit_stall_in),
        .out_exit_valid_in(i_llvm_fpga_wg_limiter_exit_unnamed_k2_zts6c_calc6_k2_zts6c_calc2_out_exit_valid_in),
        .out_stall_out(i_llvm_fpga_wg_limiter_exit_unnamed_k2_zts6c_calc6_k2_zts6c_calc2_out_stall_out),
        .out_valid_out(i_llvm_fpga_wg_limiter_exit_unnamed_k2_zts6c_calc6_k2_zts6c_calc2_out_valid_out),
        .clock(clock),
        .resetn(resetn)
    );

    // ext_sig_sync_out(GPOUT,8)
    assign out_wgl_0_exit_exit_valid_in = i_llvm_fpga_wg_limiter_exit_unnamed_k2_zts6c_calc6_k2_zts6c_calc2_out_exit_valid_in;
    assign out_wgl_0_exit_exit_stall_in = i_llvm_fpga_wg_limiter_exit_unnamed_k2_zts6c_calc6_k2_zts6c_calc2_out_exit_stall_in;

    // sync_out(GPOUT,27)@0
    assign out_stall_out = SE_stall_entry_backStall;

    // dupName_0_ext_sig_sync_out_x(GPOUT,31)
    assign out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_address = i_llvm_fpga_mem_unnamed_k2_zts6c_calc9_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_address;
    assign out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_enable = i_llvm_fpga_mem_unnamed_k2_zts6c_calc9_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_enable;
    assign out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_read = i_llvm_fpga_mem_unnamed_k2_zts6c_calc9_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_read;
    assign out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_write = i_llvm_fpga_mem_unnamed_k2_zts6c_calc9_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_write;
    assign out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_writedata = i_llvm_fpga_mem_unnamed_k2_zts6c_calc9_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_writedata;
    assign out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_byteenable = i_llvm_fpga_mem_unnamed_k2_zts6c_calc9_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_byteenable;
    assign out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_burstcount = i_llvm_fpga_mem_unnamed_k2_zts6c_calc9_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_burstcount;

    // bubble_join_redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo(BITJOIN,55)
    assign bubble_join_redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_q = redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_data_out;

    // bubble_select_redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo(BITSELECT,56)
    assign bubble_select_redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_b = $unsigned(bubble_join_redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_q[31:0]);

    // dupName_0_sync_out_x(GPOUT,32)@13
    assign out_acl_hw_wg_id52 = bubble_select_redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_b;
    assign out_valid_out = SE_out_redist0_ZTS6c_calc_B3_merge_reg_aunroll_x_out_data_out_6_tpl_12_fifo_V0;

    // dupName_1_ext_sig_sync_out_x(GPOUT,33)
    assign out_lsu_unnamed_k2_ZTS6c_calc9_o_active = i_llvm_fpga_mem_unnamed_k2_zts6c_calc9_k2_zts6c_calc7_out_lsu_unnamed_k2_ZTS6c_calc9_o_active;

endmodule
