// ------------------------------------------------------------------------- 
// High Level Design Compiler for Intel(R) FPGAs Version 20.3 (Release Build #121)
// 
// Legal Notice: Copyright 2020 Intel Corporation.  All rights reserved.
// Your use of  Intel Corporation's design tools,  logic functions and other
// software and  tools, and its AMPP partner logic functions, and any output
// files any  of the foregoing (including  device programming  or simulation
// files), and  any associated  documentation  or information  are expressly
// subject  to the terms and  conditions of the  Intel FPGA Software License
// Agreement, Intel MegaCore Function License Agreement, or other applicable
// license agreement,  including,  without limitation,  that your use is for
// the  sole  purpose of  programming  logic devices  manufactured by  Intel
// and  sold by Intel  or its authorized  distributors. Please refer  to the
// applicable agreement for further details.
// ---------------------------------------------------------------------------

// SystemVerilog created from k2_ZTS6c_calc_bb_ZTS6c_calc_B4
// SystemVerilog created on Thu Nov  5 06:32:57 2020


(* altera_attribute = "-name AUTO_SHIFT_REGISTER_RECOGNITION OFF; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 10037; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 15400; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 12020; -name MESSAGE_DISABLE 12030; -name MESSAGE_DISABLE 12010; -name MESSAGE_DISABLE 12110; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 13410; -name MESSAGE_DISABLE 113007; -name MESSAGE_DISABLE 10958" *)
module k2_ZTS6c_calc_bb_ZTS6c_calc_B4 (
    output wire [31:0] out_acl_0141_i509,
    output wire [31:0] out_acl_0142_i508,
    output wire [31:0] out_acl_0143_i507,
    output wire [63:0] out_acl_global_id_043,
    output wire [63:0] out_acl_global_id_149,
    output wire [31:0] out_acl_hw_wg_id56,
    output wire [31:0] out_c0_exe210,
    output wire [31:0] out_c0_exe412,
    output wire [63:0] out_c0_exe517,
    output wire [63:0] out_c0_exe620,
    output wire [63:0] out_c0_exe725,
    output wire [63:0] out_c0_exe828,
    output wire [31:0] out_l_grpid_05,
    output wire [63:0] out_l_grpid_0_ext_offset,
    output wire [31:0] out_memdep_34_k2_ZTS6c_calc_avm_address,
    output wire [0:0] out_memdep_34_k2_ZTS6c_calc_avm_burstcount,
    output wire [3:0] out_memdep_34_k2_ZTS6c_calc_avm_byteenable,
    output wire [0:0] out_memdep_34_k2_ZTS6c_calc_avm_enable,
    output wire [0:0] out_memdep_34_k2_ZTS6c_calc_avm_read,
    output wire [0:0] out_memdep_34_k2_ZTS6c_calc_avm_write,
    output wire [31:0] out_memdep_34_k2_ZTS6c_calc_avm_writedata,
    output wire [31:0] out_memdep_k2_ZTS6c_calc_avm_address,
    output wire [0:0] out_memdep_k2_ZTS6c_calc_avm_burstcount,
    output wire [3:0] out_memdep_k2_ZTS6c_calc_avm_byteenable,
    output wire [0:0] out_memdep_k2_ZTS6c_calc_avm_enable,
    output wire [0:0] out_memdep_k2_ZTS6c_calc_avm_read,
    output wire [0:0] out_memdep_k2_ZTS6c_calc_avm_write,
    output wire [31:0] out_memdep_k2_ZTS6c_calc_avm_writedata,
    output wire [0:0] out_stall_out_0,
    output wire [0:0] out_stall_out_1,
    output wire [32:0] out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_address,
    output wire [4:0] out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_burstcount,
    output wire [63:0] out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_byteenable,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_enable,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_read,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_write,
    output wire [511:0] out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_writedata,
    output wire [32:0] out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_address,
    output wire [4:0] out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_burstcount,
    output wire [63:0] out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_byteenable,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_enable,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_read,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_write,
    output wire [511:0] out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_writedata,
    output wire [0:0] out_valid_in_0,
    output wire [0:0] out_valid_in_1,
    output wire [0:0] out_valid_out_0,
    input wire [31:0] in_acl_0141_i509_0,
    input wire [31:0] in_acl_0141_i509_1,
    input wire [31:0] in_acl_0142_i508_0,
    input wire [31:0] in_acl_0142_i508_1,
    input wire [31:0] in_acl_0143_i507_0,
    input wire [31:0] in_acl_0143_i507_1,
    input wire [63:0] in_acl_global_id_043_0,
    input wire [63:0] in_acl_global_id_043_1,
    input wire [63:0] in_acl_global_id_149_0,
    input wire [63:0] in_acl_global_id_149_1,
    input wire [31:0] in_acl_hw_wg_id56_0,
    input wire [31:0] in_acl_hw_wg_id56_1,
    input wire [63:0] in_arg12,
    input wire [63:0] in_arg16,
    input wire [63:0] in_arg4,
    input wire [31:0] in_barrier_unnamed_k2_ZTS6c_calc18_wgs_workgroup_size,
    input wire [31:0] in_c0_exe210_0,
    input wire [31:0] in_c0_exe210_1,
    input wire [31:0] in_c0_exe412_0,
    input wire [31:0] in_c0_exe412_1,
    input wire [63:0] in_c0_exe517_0,
    input wire [63:0] in_c0_exe517_1,
    input wire [63:0] in_c0_exe620_0,
    input wire [63:0] in_c0_exe620_1,
    input wire [63:0] in_c0_exe725_0,
    input wire [63:0] in_c0_exe725_1,
    input wire [63:0] in_c0_exe828_0,
    input wire [63:0] in_c0_exe828_1,
    input wire [31:0] in_encoder_ZTS6c_calc_B4_merge_priority_encoder_workgroup_size,
    input wire [0:0] in_flush,
    input wire [31:0] in_l_grpid_05_0,
    input wire [31:0] in_l_grpid_05_1,
    input wire [31:0] in_memdep_34_k2_ZTS6c_calc_avm_readdata,
    input wire [0:0] in_memdep_34_k2_ZTS6c_calc_avm_readdatavalid,
    input wire [0:0] in_memdep_34_k2_ZTS6c_calc_avm_waitrequest,
    input wire [0:0] in_memdep_34_k2_ZTS6c_calc_avm_writeack,
    input wire [31:0] in_memdep_k2_ZTS6c_calc_avm_readdata,
    input wire [0:0] in_memdep_k2_ZTS6c_calc_avm_readdatavalid,
    input wire [0:0] in_memdep_k2_ZTS6c_calc_avm_waitrequest,
    input wire [0:0] in_memdep_k2_ZTS6c_calc_avm_writeack,
    input wire [0:0] in_stall_in_0,
    input wire [511:0] in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_readdata,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_readdatavalid,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_waitrequest,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_writeack,
    input wire [511:0] in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_readdata,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_readdatavalid,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_waitrequest,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_writeack,
    input wire [0:0] in_valid_in_0,
    input wire [0:0] in_valid_in_1,
    input wire [63:0] in_arg15_0_tpl,
    input wire [63:0] in_arg18_0_tpl,
    input wire [63:0] in_arg18_1_tpl,
    input wire [63:0] in_arg19_0_tpl,
    input wire [63:0] in_arg19_1_tpl,
    input wire [63:0] in_arg7_0_tpl,
    input wire clock,
    input wire resetn
    );

    wire [31:0] ZTS6c_calc_B4_branch_out_acl_0141_i509;
    wire [31:0] ZTS6c_calc_B4_branch_out_acl_0142_i508;
    wire [31:0] ZTS6c_calc_B4_branch_out_acl_0143_i507;
    wire [63:0] ZTS6c_calc_B4_branch_out_acl_global_id_043;
    wire [63:0] ZTS6c_calc_B4_branch_out_acl_global_id_149;
    wire [31:0] ZTS6c_calc_B4_branch_out_acl_hw_wg_id56;
    wire [31:0] ZTS6c_calc_B4_branch_out_c0_exe210;
    wire [31:0] ZTS6c_calc_B4_branch_out_c0_exe412;
    wire [63:0] ZTS6c_calc_B4_branch_out_c0_exe517;
    wire [63:0] ZTS6c_calc_B4_branch_out_c0_exe620;
    wire [63:0] ZTS6c_calc_B4_branch_out_c0_exe725;
    wire [63:0] ZTS6c_calc_B4_branch_out_c0_exe828;
    wire [31:0] ZTS6c_calc_B4_branch_out_l_grpid_05;
    wire [63:0] ZTS6c_calc_B4_branch_out_l_grpid_0_ext_offset;
    wire [0:0] ZTS6c_calc_B4_branch_out_stall_out;
    wire [0:0] ZTS6c_calc_B4_branch_out_valid_out_0;
    wire [31:0] ZTS6c_calc_B4_merge_out_acl_0141_i509;
    wire [31:0] ZTS6c_calc_B4_merge_out_acl_0142_i508;
    wire [31:0] ZTS6c_calc_B4_merge_out_acl_0143_i507;
    wire [63:0] ZTS6c_calc_B4_merge_out_acl_global_id_043;
    wire [63:0] ZTS6c_calc_B4_merge_out_acl_global_id_149;
    wire [31:0] ZTS6c_calc_B4_merge_out_acl_hw_wg_id56;
    wire [31:0] ZTS6c_calc_B4_merge_out_c0_exe210;
    wire [31:0] ZTS6c_calc_B4_merge_out_c0_exe412;
    wire [63:0] ZTS6c_calc_B4_merge_out_c0_exe517;
    wire [63:0] ZTS6c_calc_B4_merge_out_c0_exe620;
    wire [63:0] ZTS6c_calc_B4_merge_out_c0_exe725;
    wire [63:0] ZTS6c_calc_B4_merge_out_c0_exe828;
    wire [31:0] ZTS6c_calc_B4_merge_out_l_grpid_05;
    wire [0:0] ZTS6c_calc_B4_merge_out_stall_out_0;
    wire [0:0] ZTS6c_calc_B4_merge_out_stall_out_1;
    wire [0:0] ZTS6c_calc_B4_merge_out_valid_out;
    wire [607:0] aggregateWireOut_join_q;
    wire [31:0] bb_ZTS6c_calc_B4_stall_region_out_acl_0141_i509;
    wire [31:0] bb_ZTS6c_calc_B4_stall_region_out_acl_0142_i508;
    wire [31:0] bb_ZTS6c_calc_B4_stall_region_out_acl_0143_i507;
    wire [63:0] bb_ZTS6c_calc_B4_stall_region_out_acl_global_id_043;
    wire [63:0] bb_ZTS6c_calc_B4_stall_region_out_acl_global_id_149;
    wire [31:0] bb_ZTS6c_calc_B4_stall_region_out_acl_hw_wg_id56;
    wire [31:0] bb_ZTS6c_calc_B4_stall_region_out_c0_exe210;
    wire [31:0] bb_ZTS6c_calc_B4_stall_region_out_c0_exe412;
    wire [63:0] bb_ZTS6c_calc_B4_stall_region_out_c0_exe517;
    wire [63:0] bb_ZTS6c_calc_B4_stall_region_out_c0_exe620;
    wire [63:0] bb_ZTS6c_calc_B4_stall_region_out_c0_exe725;
    wire [63:0] bb_ZTS6c_calc_B4_stall_region_out_c0_exe828;
    wire [31:0] bb_ZTS6c_calc_B4_stall_region_out_l_grpid_05;
    wire [63:0] bb_ZTS6c_calc_B4_stall_region_out_l_grpid_0_ext_offset;
    wire [31:0] bb_ZTS6c_calc_B4_stall_region_out_memdep_34_k2_ZTS6c_calc_avm_address;
    wire [0:0] bb_ZTS6c_calc_B4_stall_region_out_memdep_34_k2_ZTS6c_calc_avm_burstcount;
    wire [3:0] bb_ZTS6c_calc_B4_stall_region_out_memdep_34_k2_ZTS6c_calc_avm_byteenable;
    wire [0:0] bb_ZTS6c_calc_B4_stall_region_out_memdep_34_k2_ZTS6c_calc_avm_enable;
    wire [0:0] bb_ZTS6c_calc_B4_stall_region_out_memdep_34_k2_ZTS6c_calc_avm_read;
    wire [0:0] bb_ZTS6c_calc_B4_stall_region_out_memdep_34_k2_ZTS6c_calc_avm_write;
    wire [31:0] bb_ZTS6c_calc_B4_stall_region_out_memdep_34_k2_ZTS6c_calc_avm_writedata;
    wire [31:0] bb_ZTS6c_calc_B4_stall_region_out_memdep_k2_ZTS6c_calc_avm_address;
    wire [0:0] bb_ZTS6c_calc_B4_stall_region_out_memdep_k2_ZTS6c_calc_avm_burstcount;
    wire [3:0] bb_ZTS6c_calc_B4_stall_region_out_memdep_k2_ZTS6c_calc_avm_byteenable;
    wire [0:0] bb_ZTS6c_calc_B4_stall_region_out_memdep_k2_ZTS6c_calc_avm_enable;
    wire [0:0] bb_ZTS6c_calc_B4_stall_region_out_memdep_k2_ZTS6c_calc_avm_read;
    wire [0:0] bb_ZTS6c_calc_B4_stall_region_out_memdep_k2_ZTS6c_calc_avm_write;
    wire [31:0] bb_ZTS6c_calc_B4_stall_region_out_memdep_k2_ZTS6c_calc_avm_writedata;
    wire [0:0] bb_ZTS6c_calc_B4_stall_region_out_stall_out;
    wire [32:0] bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_address;
    wire [4:0] bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_burstcount;
    wire [63:0] bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_byteenable;
    wire [0:0] bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_enable;
    wire [0:0] bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_read;
    wire [0:0] bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_write;
    wire [511:0] bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_writedata;
    wire [32:0] bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_address;
    wire [4:0] bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_burstcount;
    wire [63:0] bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_byteenable;
    wire [0:0] bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_enable;
    wire [0:0] bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_read;
    wire [0:0] bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_write;
    wire [511:0] bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_writedata;
    wire [0:0] bb_ZTS6c_calc_B4_stall_region_out_valid_out;
    wire [31:0] data_out_select_b;
    wire [607:0] loop_capacity_FIFO_out_data_out;
    wire [0:0] loop_capacity_FIFO_out_stall_out;
    wire [0:0] loop_capacity_FIFO_out_valid_out;
    wire [31:0] dupName_0_data_out_select_x_b;
    wire [31:0] dupName_1_data_out_select_x_b;
    wire [63:0] dupName_2_data_out_select_x_b;
    wire [63:0] dupName_3_data_out_select_x_b;
    wire [31:0] dupName_4_data_out_select_x_b;
    wire [31:0] dupName_5_data_out_select_x_b;
    wire [31:0] dupName_6_data_out_select_x_b;
    wire [63:0] dupName_7_data_out_select_x_b;
    wire [63:0] dupName_8_data_out_select_x_b;
    wire [63:0] dupName_9_data_out_select_x_b;
    wire [63:0] dupName_10_data_out_select_x_b;
    wire [31:0] dupName_11_data_out_select_x_b;


    // ZTS6c_calc_B4_merge(BLACKBOX,16)
    k2_ZTS6c_calc_ZTS6c_calc_B4_merge theZTS6c_calc_B4_merge (
        .in_acl_0141_i509_0(in_acl_0141_i509_0),
        .in_acl_0141_i509_1(in_acl_0141_i509_1),
        .in_acl_0142_i508_0(in_acl_0142_i508_0),
        .in_acl_0142_i508_1(in_acl_0142_i508_1),
        .in_acl_0143_i507_0(in_acl_0143_i507_0),
        .in_acl_0143_i507_1(in_acl_0143_i507_1),
        .in_acl_global_id_043_0(in_acl_global_id_043_0),
        .in_acl_global_id_043_1(in_acl_global_id_043_1),
        .in_acl_global_id_149_0(in_acl_global_id_149_0),
        .in_acl_global_id_149_1(in_acl_global_id_149_1),
        .in_acl_hw_wg_id56_0(in_acl_hw_wg_id56_0),
        .in_acl_hw_wg_id56_1(in_acl_hw_wg_id56_1),
        .in_c0_exe210_0(in_c0_exe210_0),
        .in_c0_exe210_1(in_c0_exe210_1),
        .in_c0_exe412_0(in_c0_exe412_0),
        .in_c0_exe412_1(in_c0_exe412_1),
        .in_c0_exe517_0(in_c0_exe517_0),
        .in_c0_exe517_1(in_c0_exe517_1),
        .in_c0_exe620_0(in_c0_exe620_0),
        .in_c0_exe620_1(in_c0_exe620_1),
        .in_c0_exe725_0(in_c0_exe725_0),
        .in_c0_exe725_1(in_c0_exe725_1),
        .in_c0_exe828_0(in_c0_exe828_0),
        .in_c0_exe828_1(in_c0_exe828_1),
        .in_encoder_ZTS6c_calc_B4_merge_priority_encoder_workgroup_size(in_encoder_ZTS6c_calc_B4_merge_priority_encoder_workgroup_size),
        .in_l_grpid_05_0(in_l_grpid_05_0),
        .in_l_grpid_05_1(in_l_grpid_05_1),
        .in_stall_in(loop_capacity_FIFO_out_stall_out),
        .in_valid_in_0(in_valid_in_0),
        .in_valid_in_1(in_valid_in_1),
        .out_acl_0141_i509(ZTS6c_calc_B4_merge_out_acl_0141_i509),
        .out_acl_0142_i508(ZTS6c_calc_B4_merge_out_acl_0142_i508),
        .out_acl_0143_i507(ZTS6c_calc_B4_merge_out_acl_0143_i507),
        .out_acl_global_id_043(ZTS6c_calc_B4_merge_out_acl_global_id_043),
        .out_acl_global_id_149(ZTS6c_calc_B4_merge_out_acl_global_id_149),
        .out_acl_hw_wg_id56(ZTS6c_calc_B4_merge_out_acl_hw_wg_id56),
        .out_c0_exe210(ZTS6c_calc_B4_merge_out_c0_exe210),
        .out_c0_exe412(ZTS6c_calc_B4_merge_out_c0_exe412),
        .out_c0_exe517(ZTS6c_calc_B4_merge_out_c0_exe517),
        .out_c0_exe620(ZTS6c_calc_B4_merge_out_c0_exe620),
        .out_c0_exe725(ZTS6c_calc_B4_merge_out_c0_exe725),
        .out_c0_exe828(ZTS6c_calc_B4_merge_out_c0_exe828),
        .out_l_grpid_05(ZTS6c_calc_B4_merge_out_l_grpid_05),
        .out_stall_out_0(ZTS6c_calc_B4_merge_out_stall_out_0),
        .out_stall_out_1(ZTS6c_calc_B4_merge_out_stall_out_1),
        .out_valid_out(ZTS6c_calc_B4_merge_out_valid_out),
        .clock(clock),
        .resetn(resetn)
    );

    // aggregateWireOut_join(BITJOIN,17)
    assign aggregateWireOut_join_q = {ZTS6c_calc_B4_merge_out_l_grpid_05, ZTS6c_calc_B4_merge_out_c0_exe828, ZTS6c_calc_B4_merge_out_c0_exe725, ZTS6c_calc_B4_merge_out_c0_exe620, ZTS6c_calc_B4_merge_out_c0_exe517, ZTS6c_calc_B4_merge_out_c0_exe412, ZTS6c_calc_B4_merge_out_c0_exe210, ZTS6c_calc_B4_merge_out_acl_hw_wg_id56, ZTS6c_calc_B4_merge_out_acl_global_id_149, ZTS6c_calc_B4_merge_out_acl_global_id_043, ZTS6c_calc_B4_merge_out_acl_0143_i507, ZTS6c_calc_B4_merge_out_acl_0142_i508, ZTS6c_calc_B4_merge_out_acl_0141_i509};

    // loop_capacity_FIFO(BLACKBOX,20)
    k2_ZTS6c_calc_dupName_0_loop_capacity_FI00006j6e6x6s6u0qc0xgbuoz theloop_capacity_FIFO (
        .in_data_in(aggregateWireOut_join_q),
        .in_stall_in(bb_ZTS6c_calc_B4_stall_region_out_stall_out),
        .in_valid_in(ZTS6c_calc_B4_merge_out_valid_out),
        .out_almost_full(),
        .out_data_out(loop_capacity_FIFO_out_data_out),
        .out_stall_out(loop_capacity_FIFO_out_stall_out),
        .out_valid_out(loop_capacity_FIFO_out_valid_out),
        .clock(clock),
        .resetn(resetn)
    );

    // dupName_11_data_out_select_x(BITSELECT,80)
    assign dupName_11_data_out_select_x_b = loop_capacity_FIFO_out_data_out[607:576];

    // dupName_10_data_out_select_x(BITSELECT,79)
    assign dupName_10_data_out_select_x_b = loop_capacity_FIFO_out_data_out[575:512];

    // dupName_9_data_out_select_x(BITSELECT,78)
    assign dupName_9_data_out_select_x_b = loop_capacity_FIFO_out_data_out[511:448];

    // dupName_8_data_out_select_x(BITSELECT,77)
    assign dupName_8_data_out_select_x_b = loop_capacity_FIFO_out_data_out[447:384];

    // dupName_7_data_out_select_x(BITSELECT,76)
    assign dupName_7_data_out_select_x_b = loop_capacity_FIFO_out_data_out[383:320];

    // dupName_6_data_out_select_x(BITSELECT,75)
    assign dupName_6_data_out_select_x_b = loop_capacity_FIFO_out_data_out[319:288];

    // dupName_5_data_out_select_x(BITSELECT,74)
    assign dupName_5_data_out_select_x_b = loop_capacity_FIFO_out_data_out[287:256];

    // dupName_4_data_out_select_x(BITSELECT,73)
    assign dupName_4_data_out_select_x_b = loop_capacity_FIFO_out_data_out[255:224];

    // dupName_3_data_out_select_x(BITSELECT,72)
    assign dupName_3_data_out_select_x_b = loop_capacity_FIFO_out_data_out[223:160];

    // dupName_2_data_out_select_x(BITSELECT,71)
    assign dupName_2_data_out_select_x_b = loop_capacity_FIFO_out_data_out[159:96];

    // dupName_1_data_out_select_x(BITSELECT,70)
    assign dupName_1_data_out_select_x_b = loop_capacity_FIFO_out_data_out[95:64];

    // dupName_0_data_out_select_x(BITSELECT,69)
    assign dupName_0_data_out_select_x_b = loop_capacity_FIFO_out_data_out[63:32];

    // data_out_select(BITSELECT,19)
    assign data_out_select_b = loop_capacity_FIFO_out_data_out[31:0];

    // bb_ZTS6c_calc_B4_stall_region(BLACKBOX,18)
    k2_ZTS6c_calc_bb_ZTS6c_calc_B4_stall_region thebb_ZTS6c_calc_B4_stall_region (
        .in_acl_0141_i509(data_out_select_b),
        .in_acl_0142_i508(dupName_0_data_out_select_x_b),
        .in_acl_0143_i507(dupName_1_data_out_select_x_b),
        .in_acl_global_id_043(dupName_2_data_out_select_x_b),
        .in_acl_global_id_149(dupName_3_data_out_select_x_b),
        .in_acl_hw_wg_id56(dupName_4_data_out_select_x_b),
        .in_arg12(in_arg12),
        .in_arg4(in_arg4),
        .in_barrier_unnamed_k2_ZTS6c_calc18_wgs_workgroup_size(in_barrier_unnamed_k2_ZTS6c_calc18_wgs_workgroup_size),
        .in_c0_exe210(dupName_5_data_out_select_x_b),
        .in_c0_exe412(dupName_6_data_out_select_x_b),
        .in_c0_exe517(dupName_7_data_out_select_x_b),
        .in_c0_exe620(dupName_8_data_out_select_x_b),
        .in_c0_exe725(dupName_9_data_out_select_x_b),
        .in_c0_exe828(dupName_10_data_out_select_x_b),
        .in_flush(in_flush),
        .in_l_grpid_05(dupName_11_data_out_select_x_b),
        .in_memdep_34_k2_ZTS6c_calc_avm_readdata(in_memdep_34_k2_ZTS6c_calc_avm_readdata),
        .in_memdep_34_k2_ZTS6c_calc_avm_readdatavalid(in_memdep_34_k2_ZTS6c_calc_avm_readdatavalid),
        .in_memdep_34_k2_ZTS6c_calc_avm_waitrequest(in_memdep_34_k2_ZTS6c_calc_avm_waitrequest),
        .in_memdep_34_k2_ZTS6c_calc_avm_writeack(in_memdep_34_k2_ZTS6c_calc_avm_writeack),
        .in_memdep_k2_ZTS6c_calc_avm_readdata(in_memdep_k2_ZTS6c_calc_avm_readdata),
        .in_memdep_k2_ZTS6c_calc_avm_readdatavalid(in_memdep_k2_ZTS6c_calc_avm_readdatavalid),
        .in_memdep_k2_ZTS6c_calc_avm_waitrequest(in_memdep_k2_ZTS6c_calc_avm_waitrequest),
        .in_memdep_k2_ZTS6c_calc_avm_writeack(in_memdep_k2_ZTS6c_calc_avm_writeack),
        .in_stall_in(ZTS6c_calc_B4_branch_out_stall_out),
        .in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_readdata(in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_readdata),
        .in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_readdatavalid(in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_readdatavalid),
        .in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_waitrequest(in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_waitrequest),
        .in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_writeack(in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_writeack),
        .in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_readdata(in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_readdata),
        .in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_readdatavalid(in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_readdatavalid),
        .in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_waitrequest(in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_waitrequest),
        .in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_writeack(in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_writeack),
        .in_valid_in(loop_capacity_FIFO_out_valid_out),
        .in_arg15_0_tpl(in_arg15_0_tpl),
        .in_arg7_0_tpl(in_arg7_0_tpl),
        .out_acl_0141_i509(bb_ZTS6c_calc_B4_stall_region_out_acl_0141_i509),
        .out_acl_0142_i508(bb_ZTS6c_calc_B4_stall_region_out_acl_0142_i508),
        .out_acl_0143_i507(bb_ZTS6c_calc_B4_stall_region_out_acl_0143_i507),
        .out_acl_global_id_043(bb_ZTS6c_calc_B4_stall_region_out_acl_global_id_043),
        .out_acl_global_id_149(bb_ZTS6c_calc_B4_stall_region_out_acl_global_id_149),
        .out_acl_hw_wg_id56(bb_ZTS6c_calc_B4_stall_region_out_acl_hw_wg_id56),
        .out_c0_exe210(bb_ZTS6c_calc_B4_stall_region_out_c0_exe210),
        .out_c0_exe412(bb_ZTS6c_calc_B4_stall_region_out_c0_exe412),
        .out_c0_exe517(bb_ZTS6c_calc_B4_stall_region_out_c0_exe517),
        .out_c0_exe620(bb_ZTS6c_calc_B4_stall_region_out_c0_exe620),
        .out_c0_exe725(bb_ZTS6c_calc_B4_stall_region_out_c0_exe725),
        .out_c0_exe828(bb_ZTS6c_calc_B4_stall_region_out_c0_exe828),
        .out_l_grpid_05(bb_ZTS6c_calc_B4_stall_region_out_l_grpid_05),
        .out_l_grpid_0_ext_offset(bb_ZTS6c_calc_B4_stall_region_out_l_grpid_0_ext_offset),
        .out_memdep_34_k2_ZTS6c_calc_avm_address(bb_ZTS6c_calc_B4_stall_region_out_memdep_34_k2_ZTS6c_calc_avm_address),
        .out_memdep_34_k2_ZTS6c_calc_avm_burstcount(bb_ZTS6c_calc_B4_stall_region_out_memdep_34_k2_ZTS6c_calc_avm_burstcount),
        .out_memdep_34_k2_ZTS6c_calc_avm_byteenable(bb_ZTS6c_calc_B4_stall_region_out_memdep_34_k2_ZTS6c_calc_avm_byteenable),
        .out_memdep_34_k2_ZTS6c_calc_avm_enable(bb_ZTS6c_calc_B4_stall_region_out_memdep_34_k2_ZTS6c_calc_avm_enable),
        .out_memdep_34_k2_ZTS6c_calc_avm_read(bb_ZTS6c_calc_B4_stall_region_out_memdep_34_k2_ZTS6c_calc_avm_read),
        .out_memdep_34_k2_ZTS6c_calc_avm_write(bb_ZTS6c_calc_B4_stall_region_out_memdep_34_k2_ZTS6c_calc_avm_write),
        .out_memdep_34_k2_ZTS6c_calc_avm_writedata(bb_ZTS6c_calc_B4_stall_region_out_memdep_34_k2_ZTS6c_calc_avm_writedata),
        .out_memdep_k2_ZTS6c_calc_avm_address(bb_ZTS6c_calc_B4_stall_region_out_memdep_k2_ZTS6c_calc_avm_address),
        .out_memdep_k2_ZTS6c_calc_avm_burstcount(bb_ZTS6c_calc_B4_stall_region_out_memdep_k2_ZTS6c_calc_avm_burstcount),
        .out_memdep_k2_ZTS6c_calc_avm_byteenable(bb_ZTS6c_calc_B4_stall_region_out_memdep_k2_ZTS6c_calc_avm_byteenable),
        .out_memdep_k2_ZTS6c_calc_avm_enable(bb_ZTS6c_calc_B4_stall_region_out_memdep_k2_ZTS6c_calc_avm_enable),
        .out_memdep_k2_ZTS6c_calc_avm_read(bb_ZTS6c_calc_B4_stall_region_out_memdep_k2_ZTS6c_calc_avm_read),
        .out_memdep_k2_ZTS6c_calc_avm_write(bb_ZTS6c_calc_B4_stall_region_out_memdep_k2_ZTS6c_calc_avm_write),
        .out_memdep_k2_ZTS6c_calc_avm_writedata(bb_ZTS6c_calc_B4_stall_region_out_memdep_k2_ZTS6c_calc_avm_writedata),
        .out_stall_out(bb_ZTS6c_calc_B4_stall_region_out_stall_out),
        .out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_address(bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_address),
        .out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_burstcount(bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_burstcount),
        .out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_byteenable(bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_byteenable),
        .out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_enable(bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_enable),
        .out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_read(bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_read),
        .out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_write(bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_write),
        .out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_writedata(bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_writedata),
        .out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_address(bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_address),
        .out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_burstcount(bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_burstcount),
        .out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_byteenable(bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_byteenable),
        .out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_enable(bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_enable),
        .out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_read(bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_read),
        .out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_write(bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_write),
        .out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_writedata(bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_writedata),
        .out_valid_out(bb_ZTS6c_calc_B4_stall_region_out_valid_out),
        .clock(clock),
        .resetn(resetn)
    );

    // ZTS6c_calc_B4_branch(BLACKBOX,15)
    k2_ZTS6c_calc_ZTS6c_calc_B4_branch theZTS6c_calc_B4_branch (
        .in_acl_0141_i509(bb_ZTS6c_calc_B4_stall_region_out_acl_0141_i509),
        .in_acl_0142_i508(bb_ZTS6c_calc_B4_stall_region_out_acl_0142_i508),
        .in_acl_0143_i507(bb_ZTS6c_calc_B4_stall_region_out_acl_0143_i507),
        .in_acl_global_id_043(bb_ZTS6c_calc_B4_stall_region_out_acl_global_id_043),
        .in_acl_global_id_149(bb_ZTS6c_calc_B4_stall_region_out_acl_global_id_149),
        .in_acl_hw_wg_id56(bb_ZTS6c_calc_B4_stall_region_out_acl_hw_wg_id56),
        .in_c0_exe210(bb_ZTS6c_calc_B4_stall_region_out_c0_exe210),
        .in_c0_exe412(bb_ZTS6c_calc_B4_stall_region_out_c0_exe412),
        .in_c0_exe517(bb_ZTS6c_calc_B4_stall_region_out_c0_exe517),
        .in_c0_exe620(bb_ZTS6c_calc_B4_stall_region_out_c0_exe620),
        .in_c0_exe725(bb_ZTS6c_calc_B4_stall_region_out_c0_exe725),
        .in_c0_exe828(bb_ZTS6c_calc_B4_stall_region_out_c0_exe828),
        .in_l_grpid_05(bb_ZTS6c_calc_B4_stall_region_out_l_grpid_05),
        .in_l_grpid_0_ext_offset(bb_ZTS6c_calc_B4_stall_region_out_l_grpid_0_ext_offset),
        .in_stall_in_0(in_stall_in_0),
        .in_valid_in(bb_ZTS6c_calc_B4_stall_region_out_valid_out),
        .out_acl_0141_i509(ZTS6c_calc_B4_branch_out_acl_0141_i509),
        .out_acl_0142_i508(ZTS6c_calc_B4_branch_out_acl_0142_i508),
        .out_acl_0143_i507(ZTS6c_calc_B4_branch_out_acl_0143_i507),
        .out_acl_global_id_043(ZTS6c_calc_B4_branch_out_acl_global_id_043),
        .out_acl_global_id_149(ZTS6c_calc_B4_branch_out_acl_global_id_149),
        .out_acl_hw_wg_id56(ZTS6c_calc_B4_branch_out_acl_hw_wg_id56),
        .out_c0_exe210(ZTS6c_calc_B4_branch_out_c0_exe210),
        .out_c0_exe412(ZTS6c_calc_B4_branch_out_c0_exe412),
        .out_c0_exe517(ZTS6c_calc_B4_branch_out_c0_exe517),
        .out_c0_exe620(ZTS6c_calc_B4_branch_out_c0_exe620),
        .out_c0_exe725(ZTS6c_calc_B4_branch_out_c0_exe725),
        .out_c0_exe828(ZTS6c_calc_B4_branch_out_c0_exe828),
        .out_l_grpid_05(ZTS6c_calc_B4_branch_out_l_grpid_05),
        .out_l_grpid_0_ext_offset(ZTS6c_calc_B4_branch_out_l_grpid_0_ext_offset),
        .out_stall_out(ZTS6c_calc_B4_branch_out_stall_out),
        .out_valid_out_0(ZTS6c_calc_B4_branch_out_valid_out_0),
        .clock(clock),
        .resetn(resetn)
    );

    // out_acl_0141_i509(GPOUT,21)
    assign out_acl_0141_i509 = ZTS6c_calc_B4_branch_out_acl_0141_i509;

    // out_acl_0142_i508(GPOUT,22)
    assign out_acl_0142_i508 = ZTS6c_calc_B4_branch_out_acl_0142_i508;

    // out_acl_0143_i507(GPOUT,23)
    assign out_acl_0143_i507 = ZTS6c_calc_B4_branch_out_acl_0143_i507;

    // out_acl_global_id_043(GPOUT,24)
    assign out_acl_global_id_043 = ZTS6c_calc_B4_branch_out_acl_global_id_043;

    // out_acl_global_id_149(GPOUT,25)
    assign out_acl_global_id_149 = ZTS6c_calc_B4_branch_out_acl_global_id_149;

    // out_acl_hw_wg_id56(GPOUT,26)
    assign out_acl_hw_wg_id56 = ZTS6c_calc_B4_branch_out_acl_hw_wg_id56;

    // out_c0_exe210(GPOUT,27)
    assign out_c0_exe210 = ZTS6c_calc_B4_branch_out_c0_exe210;

    // out_c0_exe412(GPOUT,28)
    assign out_c0_exe412 = ZTS6c_calc_B4_branch_out_c0_exe412;

    // out_c0_exe517(GPOUT,29)
    assign out_c0_exe517 = ZTS6c_calc_B4_branch_out_c0_exe517;

    // out_c0_exe620(GPOUT,30)
    assign out_c0_exe620 = ZTS6c_calc_B4_branch_out_c0_exe620;

    // out_c0_exe725(GPOUT,31)
    assign out_c0_exe725 = ZTS6c_calc_B4_branch_out_c0_exe725;

    // out_c0_exe828(GPOUT,32)
    assign out_c0_exe828 = ZTS6c_calc_B4_branch_out_c0_exe828;

    // out_l_grpid_05(GPOUT,33)
    assign out_l_grpid_05 = ZTS6c_calc_B4_branch_out_l_grpid_05;

    // out_l_grpid_0_ext_offset(GPOUT,34)
    assign out_l_grpid_0_ext_offset = ZTS6c_calc_B4_branch_out_l_grpid_0_ext_offset;

    // out_memdep_34_k2_ZTS6c_calc_avm_address(GPOUT,35)
    assign out_memdep_34_k2_ZTS6c_calc_avm_address = bb_ZTS6c_calc_B4_stall_region_out_memdep_34_k2_ZTS6c_calc_avm_address;

    // out_memdep_34_k2_ZTS6c_calc_avm_burstcount(GPOUT,36)
    assign out_memdep_34_k2_ZTS6c_calc_avm_burstcount = bb_ZTS6c_calc_B4_stall_region_out_memdep_34_k2_ZTS6c_calc_avm_burstcount;

    // out_memdep_34_k2_ZTS6c_calc_avm_byteenable(GPOUT,37)
    assign out_memdep_34_k2_ZTS6c_calc_avm_byteenable = bb_ZTS6c_calc_B4_stall_region_out_memdep_34_k2_ZTS6c_calc_avm_byteenable;

    // out_memdep_34_k2_ZTS6c_calc_avm_enable(GPOUT,38)
    assign out_memdep_34_k2_ZTS6c_calc_avm_enable = bb_ZTS6c_calc_B4_stall_region_out_memdep_34_k2_ZTS6c_calc_avm_enable;

    // out_memdep_34_k2_ZTS6c_calc_avm_read(GPOUT,39)
    assign out_memdep_34_k2_ZTS6c_calc_avm_read = bb_ZTS6c_calc_B4_stall_region_out_memdep_34_k2_ZTS6c_calc_avm_read;

    // out_memdep_34_k2_ZTS6c_calc_avm_write(GPOUT,40)
    assign out_memdep_34_k2_ZTS6c_calc_avm_write = bb_ZTS6c_calc_B4_stall_region_out_memdep_34_k2_ZTS6c_calc_avm_write;

    // out_memdep_34_k2_ZTS6c_calc_avm_writedata(GPOUT,41)
    assign out_memdep_34_k2_ZTS6c_calc_avm_writedata = bb_ZTS6c_calc_B4_stall_region_out_memdep_34_k2_ZTS6c_calc_avm_writedata;

    // out_memdep_k2_ZTS6c_calc_avm_address(GPOUT,42)
    assign out_memdep_k2_ZTS6c_calc_avm_address = bb_ZTS6c_calc_B4_stall_region_out_memdep_k2_ZTS6c_calc_avm_address;

    // out_memdep_k2_ZTS6c_calc_avm_burstcount(GPOUT,43)
    assign out_memdep_k2_ZTS6c_calc_avm_burstcount = bb_ZTS6c_calc_B4_stall_region_out_memdep_k2_ZTS6c_calc_avm_burstcount;

    // out_memdep_k2_ZTS6c_calc_avm_byteenable(GPOUT,44)
    assign out_memdep_k2_ZTS6c_calc_avm_byteenable = bb_ZTS6c_calc_B4_stall_region_out_memdep_k2_ZTS6c_calc_avm_byteenable;

    // out_memdep_k2_ZTS6c_calc_avm_enable(GPOUT,45)
    assign out_memdep_k2_ZTS6c_calc_avm_enable = bb_ZTS6c_calc_B4_stall_region_out_memdep_k2_ZTS6c_calc_avm_enable;

    // out_memdep_k2_ZTS6c_calc_avm_read(GPOUT,46)
    assign out_memdep_k2_ZTS6c_calc_avm_read = bb_ZTS6c_calc_B4_stall_region_out_memdep_k2_ZTS6c_calc_avm_read;

    // out_memdep_k2_ZTS6c_calc_avm_write(GPOUT,47)
    assign out_memdep_k2_ZTS6c_calc_avm_write = bb_ZTS6c_calc_B4_stall_region_out_memdep_k2_ZTS6c_calc_avm_write;

    // out_memdep_k2_ZTS6c_calc_avm_writedata(GPOUT,48)
    assign out_memdep_k2_ZTS6c_calc_avm_writedata = bb_ZTS6c_calc_B4_stall_region_out_memdep_k2_ZTS6c_calc_avm_writedata;

    // out_stall_out_0(GPOUT,49)
    assign out_stall_out_0 = ZTS6c_calc_B4_merge_out_stall_out_0;

    // out_stall_out_1(GPOUT,50)
    assign out_stall_out_1 = ZTS6c_calc_B4_merge_out_stall_out_1;

    // out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_address(GPOUT,51)
    assign out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_address = bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_address;

    // out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_burstcount(GPOUT,52)
    assign out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_burstcount = bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_burstcount;

    // out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_byteenable(GPOUT,53)
    assign out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_byteenable = bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_byteenable;

    // out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_enable(GPOUT,54)
    assign out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_enable = bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_enable;

    // out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_read(GPOUT,55)
    assign out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_read = bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_read;

    // out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_write(GPOUT,56)
    assign out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_write = bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_write;

    // out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_writedata(GPOUT,57)
    assign out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_writedata = bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_writedata;

    // out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_address(GPOUT,58)
    assign out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_address = bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_address;

    // out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_burstcount(GPOUT,59)
    assign out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_burstcount = bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_burstcount;

    // out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_byteenable(GPOUT,60)
    assign out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_byteenable = bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_byteenable;

    // out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_enable(GPOUT,61)
    assign out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_enable = bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_enable;

    // out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_read(GPOUT,62)
    assign out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_read = bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_read;

    // out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_write(GPOUT,63)
    assign out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_write = bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_write;

    // out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_writedata(GPOUT,64)
    assign out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_writedata = bb_ZTS6c_calc_B4_stall_region_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_writedata;

    // out_valid_in_0(GPOUT,65)
    assign out_valid_in_0 = in_valid_in_0;

    // out_valid_in_1(GPOUT,66)
    assign out_valid_in_1 = in_valid_in_1;

    // out_valid_out_0(GPOUT,67)
    assign out_valid_out_0 = ZTS6c_calc_B4_branch_out_valid_out_0;

endmodule
