// ------------------------------------------------------------------------- 
// High Level Design Compiler for Intel(R) FPGAs Version 20.3 (Release Build #121)
// 
// Legal Notice: Copyright 2020 Intel Corporation.  All rights reserved.
// Your use of  Intel Corporation's design tools,  logic functions and other
// software and  tools, and its AMPP partner logic functions, and any output
// files any  of the foregoing (including  device programming  or simulation
// files), and  any associated  documentation  or information  are expressly
// subject  to the terms and  conditions of the  Intel FPGA Software License
// Agreement, Intel MegaCore Function License Agreement, or other applicable
// license agreement,  including,  without limitation,  that your use is for
// the  sole  purpose of  programming  logic devices  manufactured by  Intel
// and  sold by Intel  or its authorized  distributors. Please refer  to the
// applicable agreement for further details.
// ---------------------------------------------------------------------------

// SystemVerilog created from k2_ZTS6c_calc_bb_ZTS6c_calc_B4_stall_region
// SystemVerilog created on Thu Nov  5 06:32:57 2020


(* altera_attribute = "-name AUTO_SHIFT_REGISTER_RECOGNITION OFF; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 10037; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 15400; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 12020; -name MESSAGE_DISABLE 12030; -name MESSAGE_DISABLE 12010; -name MESSAGE_DISABLE 12110; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 13410; -name MESSAGE_DISABLE 113007; -name MESSAGE_DISABLE 10958" *)
module k2_ZTS6c_calc_bb_ZTS6c_calc_B4_stall_region (
    input wire [511:0] in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_readdata,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_writeack,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_waitrequest,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_readdatavalid,
    output wire [32:0] out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_address,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_enable,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_read,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_write,
    output wire [511:0] out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_writedata,
    output wire [63:0] out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_byteenable,
    output wire [4:0] out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_burstcount,
    input wire [63:0] in_arg12,
    input wire [63:0] in_arg4,
    input wire [0:0] in_flush,
    input wire [0:0] in_stall_in,
    output wire [0:0] out_stall_out,
    input wire [31:0] in_acl_0141_i509,
    input wire [31:0] in_acl_0142_i508,
    input wire [31:0] in_acl_0143_i507,
    input wire [63:0] in_acl_global_id_043,
    input wire [63:0] in_acl_global_id_149,
    input wire [31:0] in_acl_hw_wg_id56,
    input wire [31:0] in_c0_exe210,
    input wire [31:0] in_c0_exe412,
    input wire [63:0] in_c0_exe517,
    input wire [63:0] in_c0_exe620,
    input wire [63:0] in_c0_exe725,
    input wire [63:0] in_c0_exe828,
    input wire [31:0] in_l_grpid_05,
    input wire [0:0] in_valid_in,
    input wire [31:0] in_memdep_34_k2_ZTS6c_calc_avm_readdata,
    input wire [0:0] in_memdep_34_k2_ZTS6c_calc_avm_writeack,
    input wire [0:0] in_memdep_34_k2_ZTS6c_calc_avm_waitrequest,
    input wire [0:0] in_memdep_34_k2_ZTS6c_calc_avm_readdatavalid,
    output wire [31:0] out_memdep_34_k2_ZTS6c_calc_avm_address,
    output wire [0:0] out_memdep_34_k2_ZTS6c_calc_avm_enable,
    output wire [0:0] out_memdep_34_k2_ZTS6c_calc_avm_read,
    output wire [0:0] out_memdep_34_k2_ZTS6c_calc_avm_write,
    output wire [31:0] out_memdep_34_k2_ZTS6c_calc_avm_writedata,
    output wire [3:0] out_memdep_34_k2_ZTS6c_calc_avm_byteenable,
    output wire [0:0] out_memdep_34_k2_ZTS6c_calc_avm_burstcount,
    output wire [31:0] out_acl_0141_i509,
    output wire [31:0] out_acl_0142_i508,
    output wire [31:0] out_acl_0143_i507,
    output wire [63:0] out_acl_global_id_043,
    output wire [63:0] out_acl_global_id_149,
    output wire [31:0] out_acl_hw_wg_id56,
    output wire [31:0] out_c0_exe210,
    output wire [31:0] out_c0_exe412,
    output wire [63:0] out_c0_exe517,
    output wire [63:0] out_c0_exe620,
    output wire [63:0] out_c0_exe725,
    output wire [63:0] out_c0_exe828,
    output wire [31:0] out_l_grpid_05,
    output wire [63:0] out_l_grpid_0_ext_offset,
    output wire [0:0] out_valid_out,
    input wire [511:0] in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_readdata,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_writeack,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_waitrequest,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_readdatavalid,
    output wire [32:0] out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_address,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_enable,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_read,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_write,
    output wire [511:0] out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_writedata,
    output wire [63:0] out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_byteenable,
    output wire [4:0] out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_burstcount,
    input wire [31:0] in_memdep_k2_ZTS6c_calc_avm_readdata,
    input wire [0:0] in_memdep_k2_ZTS6c_calc_avm_writeack,
    input wire [0:0] in_memdep_k2_ZTS6c_calc_avm_waitrequest,
    input wire [0:0] in_memdep_k2_ZTS6c_calc_avm_readdatavalid,
    output wire [31:0] out_memdep_k2_ZTS6c_calc_avm_address,
    output wire [0:0] out_memdep_k2_ZTS6c_calc_avm_enable,
    output wire [0:0] out_memdep_k2_ZTS6c_calc_avm_read,
    output wire [0:0] out_memdep_k2_ZTS6c_calc_avm_write,
    output wire [31:0] out_memdep_k2_ZTS6c_calc_avm_writedata,
    output wire [3:0] out_memdep_k2_ZTS6c_calc_avm_byteenable,
    output wire [0:0] out_memdep_k2_ZTS6c_calc_avm_burstcount,
    input wire [31:0] in_barrier_unnamed_k2_ZTS6c_calc18_wgs_workgroup_size,
    input wire [63:0] in_arg15_0_tpl,
    input wire [63:0] in_arg7_0_tpl,
    input wire clock,
    input wire resetn
    );

    wire [0:0] GND_q;
    wire [0:0] VCC_q;
    wire [0:0] i_barrier_dep_k2_zts6c_calc20_q;
    wire [31:0] i_l_grpid_0_ext_k2_zts6c_calc8_vt_const_63_q;
    wire [63:0] i_l_grpid_0_ext_k2_zts6c_calc8_vt_join_q;
    wire [31:0] i_l_grpid_0_ext_k2_zts6c_calc8_vt_select_31_b;
    wire [11:0] i_l_grpid_0_ext_offset_k2_zts6c_calc9_vt_const_11_q;
    wire [19:0] i_l_grpid_0_ext_offset_k2_zts6c_calc9_vt_const_63_q;
    wire [63:0] i_l_grpid_0_ext_offset_k2_zts6c_calc9_vt_join_q;
    wire [31:0] i_l_grpid_0_ext_offset_k2_zts6c_calc9_vt_select_43_b;
    wire [31:0] i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10_out_memdep_34_k2_ZTS6c_calc_avm_address;
    wire [0:0] i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10_out_memdep_34_k2_ZTS6c_calc_avm_burstcount;
    wire [3:0] i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10_out_memdep_34_k2_ZTS6c_calc_avm_byteenable;
    wire [0:0] i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10_out_memdep_34_k2_ZTS6c_calc_avm_enable;
    wire [0:0] i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10_out_memdep_34_k2_ZTS6c_calc_avm_read;
    wire [0:0] i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10_out_memdep_34_k2_ZTS6c_calc_avm_write;
    wire [31:0] i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10_out_memdep_34_k2_ZTS6c_calc_avm_writedata;
    wire [0:0] i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10_out_o_stall;
    wire [0:0] i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10_out_o_valid;
    wire [0:0] i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10_out_o_writeack;
    wire [31:0] i_llvm_fpga_mem_memdep_k2_zts6c_calc19_out_memdep_k2_ZTS6c_calc_avm_address;
    wire [0:0] i_llvm_fpga_mem_memdep_k2_zts6c_calc19_out_memdep_k2_ZTS6c_calc_avm_burstcount;
    wire [3:0] i_llvm_fpga_mem_memdep_k2_zts6c_calc19_out_memdep_k2_ZTS6c_calc_avm_byteenable;
    wire [0:0] i_llvm_fpga_mem_memdep_k2_zts6c_calc19_out_memdep_k2_ZTS6c_calc_avm_enable;
    wire [0:0] i_llvm_fpga_mem_memdep_k2_zts6c_calc19_out_memdep_k2_ZTS6c_calc_avm_read;
    wire [0:0] i_llvm_fpga_mem_memdep_k2_zts6c_calc19_out_memdep_k2_ZTS6c_calc_avm_write;
    wire [31:0] i_llvm_fpga_mem_memdep_k2_zts6c_calc19_out_memdep_k2_ZTS6c_calc_avm_writedata;
    wire [0:0] i_llvm_fpga_mem_memdep_k2_zts6c_calc19_out_o_stall;
    wire [0:0] i_llvm_fpga_mem_memdep_k2_zts6c_calc19_out_o_valid;
    wire [0:0] i_llvm_fpga_mem_memdep_k2_zts6c_calc19_out_o_writeack;
    wire [31:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_out_o_readdata;
    wire [0:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_out_o_stall;
    wire [0:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_out_o_valid;
    wire [32:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_address;
    wire [4:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_burstcount;
    wire [63:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_byteenable;
    wire [0:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_enable;
    wire [0:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_read;
    wire [0:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_write;
    wire [511:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_writedata;
    wire [31:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_out_o_readdata;
    wire [0:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_out_o_stall;
    wire [0:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_out_o_valid;
    wire [32:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_address;
    wire [4:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_burstcount;
    wire [63:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_byteenable;
    wire [0:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_enable;
    wire [0:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_read;
    wire [0:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_write;
    wire [511:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_writedata;
    wire [0:0] i_llvm_fpga_simple_barrier_unnamed_k2_zts6c_calc18_k2_zts6c_calc21_out_stall_entry;
    wire [0:0] i_llvm_fpga_simple_barrier_unnamed_k2_zts6c_calc18_k2_zts6c_calc21_out_valid_exit;
    wire [63:0] i_llvm_fpga_sync_buffer_p1024f32_arg12_sync_buffer_k2_zts6c_calc15_out_buffer_out;
    wire [0:0] i_llvm_fpga_sync_buffer_p1024f32_arg12_sync_buffer_k2_zts6c_calc15_out_stall_out;
    wire [0:0] i_llvm_fpga_sync_buffer_p1024f32_arg12_sync_buffer_k2_zts6c_calc15_out_valid_out;
    wire [9:0] i_llvm_fpga_sync_buffer_p1024f32_arg12_sync_buffer_k2_zts6c_calc15_vt_const_9_q;
    wire [63:0] i_llvm_fpga_sync_buffer_p1024f32_arg12_sync_buffer_k2_zts6c_calc15_vt_join_q;
    wire [53:0] i_llvm_fpga_sync_buffer_p1024f32_arg12_sync_buffer_k2_zts6c_calc15_vt_select_63_b;
    wire [63:0] i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k2_zts6c_calc4_out_buffer_out;
    wire [0:0] i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k2_zts6c_calc4_out_stall_out;
    wire [0:0] i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k2_zts6c_calc4_out_valid_out;
    wire [63:0] i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k2_zts6c_calc4_vt_join_q;
    wire [53:0] i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k2_zts6c_calc4_vt_select_63_b;
    wire [32:0] i_unnamed_k2_zts6c_calc0_a;
    wire [32:0] i_unnamed_k2_zts6c_calc0_b;
    logic [32:0] i_unnamed_k2_zts6c_calc0_o;
    wire [32:0] i_unnamed_k2_zts6c_calc0_q;
    wire [32:0] i_unnamed_k2_zts6c_calc11_a;
    wire [32:0] i_unnamed_k2_zts6c_calc11_b;
    logic [32:0] i_unnamed_k2_zts6c_calc11_o;
    wire [32:0] i_unnamed_k2_zts6c_calc11_q;
    wire [1:0] i_unnamed_k2_zts6c_calc16_vt_const_1_q;
    wire [63:0] i_unnamed_k2_zts6c_calc16_vt_join_q;
    wire [61:0] i_unnamed_k2_zts6c_calc16_vt_select_63_b;
    wire [63:0] i_unnamed_k2_zts6c_calc17_vt_join_q;
    wire [61:0] i_unnamed_k2_zts6c_calc17_vt_select_63_b;
    wire [63:0] i_unnamed_k2_zts6c_calc5_vt_join_q;
    wire [61:0] i_unnamed_k2_zts6c_calc5_vt_select_63_b;
    wire [63:0] i_unnamed_k2_zts6c_calc6_vt_join_q;
    wire [61:0] i_unnamed_k2_zts6c_calc6_vt_select_63_b;
    wire [0:0] ZTS6c_calc_B4_merge_reg_aunroll_x_out_stall_out;
    wire [0:0] ZTS6c_calc_B4_merge_reg_aunroll_x_out_valid_out;
    wire [31:0] ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_0_tpl;
    wire [31:0] ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_1_tpl;
    wire [31:0] ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_2_tpl;
    wire [31:0] ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_3_tpl;
    wire [31:0] ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_4_tpl;
    wire [31:0] ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_5_tpl;
    wire [63:0] ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_6_tpl;
    wire [63:0] ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_7_tpl;
    wire [63:0] ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_8_tpl;
    wire [63:0] ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_9_tpl;
    wire [63:0] ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_10_tpl;
    wire [63:0] ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_11_tpl;
    wire [31:0] ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_12_tpl;
    wire [31:0] bgTrunc_i_unnamed_k2_zts6c_calc0_sel_x_b;
    wire [31:0] bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b;
    wire [63:0] i_l_grpid_0_ext_k2_zts6c_calc8_sel_x_b;
    wire [0:0] i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x_out_stall_out;
    wire [0:0] i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x_out_valid_out;
    wire [63:0] i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x_out_buffer_out_0_tpl;
    wire [0:0] i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x_out_stall_out;
    wire [0:0] i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x_out_valid_out;
    wire [63:0] i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x_out_buffer_out_0_tpl;
    wire [63:0] i_unnamed_k2_zts6c_calc1_sel_x_b;
    wire [63:0] i_unnamed_k2_zts6c_calc12_sel_x_b;
    wire [64:0] dupName_5_i_unnamed_k2_zts6c_calc0_add_x_a;
    wire [64:0] dupName_5_i_unnamed_k2_zts6c_calc0_add_x_b;
    logic [64:0] dupName_5_i_unnamed_k2_zts6c_calc0_add_x_o;
    wire [64:0] dupName_5_i_unnamed_k2_zts6c_calc0_add_x_q;
    wire [61:0] dupName_5_i_unnamed_k2_zts6c_calc0_narrow_x_b;
    wire [63:0] dupName_5_i_unnamed_k2_zts6c_calc0_shift_join_x_q;
    wire [63:0] dupName_5_i_unnamed_k2_zts6c_calc0_dupName_0_trunc_sel_x_b;
    wire [64:0] dupName_6_i_unnamed_k2_zts6c_calc0_add_x_a;
    wire [64:0] dupName_6_i_unnamed_k2_zts6c_calc0_add_x_b;
    logic [64:0] dupName_6_i_unnamed_k2_zts6c_calc0_add_x_o;
    wire [64:0] dupName_6_i_unnamed_k2_zts6c_calc0_add_x_q;
    wire [61:0] dupName_6_i_unnamed_k2_zts6c_calc0_narrow_x_b;
    wire [63:0] dupName_6_i_unnamed_k2_zts6c_calc0_shift_join_x_q;
    wire [63:0] dupName_6_i_unnamed_k2_zts6c_calc0_dupName_0_trunc_sel_x_b;
    wire [64:0] dupName_7_i_unnamed_k2_zts6c_calc0_add_x_a;
    wire [64:0] dupName_7_i_unnamed_k2_zts6c_calc0_add_x_b;
    logic [64:0] dupName_7_i_unnamed_k2_zts6c_calc0_add_x_o;
    wire [64:0] dupName_7_i_unnamed_k2_zts6c_calc0_add_x_q;
    wire [61:0] dupName_7_i_unnamed_k2_zts6c_calc0_narrow_x_b;
    wire [63:0] dupName_7_i_unnamed_k2_zts6c_calc0_shift_join_x_q;
    wire [63:0] dupName_7_i_unnamed_k2_zts6c_calc0_dupName_0_trunc_sel_x_b;
    wire [64:0] dupName_8_i_unnamed_k2_zts6c_calc0_add_x_a;
    wire [64:0] dupName_8_i_unnamed_k2_zts6c_calc0_add_x_b;
    logic [64:0] dupName_8_i_unnamed_k2_zts6c_calc0_add_x_o;
    wire [64:0] dupName_8_i_unnamed_k2_zts6c_calc0_add_x_q;
    wire [61:0] dupName_8_i_unnamed_k2_zts6c_calc0_narrow_x_b;
    wire [63:0] dupName_8_i_unnamed_k2_zts6c_calc0_shift_join_x_q;
    wire [63:0] dupName_8_i_unnamed_k2_zts6c_calc0_dupName_0_trunc_sel_x_b;
    wire [3:0] leftShiftStage0Idx1Pad4_uid135_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_q;
    wire [59:0] leftShiftStage0Idx1Rng4_uid136_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_in;
    wire [59:0] leftShiftStage0Idx1Rng4_uid136_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_b;
    wire [63:0] leftShiftStage0Idx1_uid137_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_q;
    wire [0:0] leftShiftStage0_uid139_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_s;
    reg [63:0] leftShiftStage0_uid139_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_q;
    wire [7:0] leftShiftStage1Idx1Pad8_uid140_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_q;
    wire [55:0] leftShiftStage1Idx1Rng8_uid141_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_in;
    wire [55:0] leftShiftStage1Idx1Rng8_uid141_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_b;
    wire [63:0] leftShiftStage1Idx1_uid142_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_q;
    wire [0:0] leftShiftStage1_uid144_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_s;
    reg [63:0] leftShiftStage1_uid144_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_q;
    wire [159:0] join_for_coalesced_delay_0_q;
    wire [63:0] sel_for_coalesced_delay_0_b;
    wire [63:0] sel_for_coalesced_delay_0_c;
    wire [31:0] sel_for_coalesced_delay_0_d;
    wire [447:0] join_for_coalesced_delay_1_q;
    wire [63:0] sel_for_coalesced_delay_1_b;
    wire [63:0] sel_for_coalesced_delay_1_c;
    wire [63:0] sel_for_coalesced_delay_1_d;
    wire [63:0] sel_for_coalesced_delay_1_e;
    wire [31:0] sel_for_coalesced_delay_1_f;
    wire [31:0] sel_for_coalesced_delay_1_g;
    wire [31:0] sel_for_coalesced_delay_1_h;
    wire [31:0] sel_for_coalesced_delay_1_i;
    wire [31:0] sel_for_coalesced_delay_1_j;
    wire [31:0] sel_for_coalesced_delay_1_k;
    wire [223:0] join_for_coalesced_delay_2_q;
    wire [63:0] sel_for_coalesced_delay_2_b;
    wire [63:0] sel_for_coalesced_delay_2_c;
    wire [63:0] sel_for_coalesced_delay_2_d;
    wire [31:0] sel_for_coalesced_delay_2_e;
    wire [0:0] coalesced_delay_0_fifo_valid_in;
    wire coalesced_delay_0_fifo_valid_in_bitsignaltemp;
    wire [0:0] coalesced_delay_0_fifo_stall_in;
    wire coalesced_delay_0_fifo_stall_in_bitsignaltemp;
    wire [159:0] coalesced_delay_0_fifo_data_in;
    wire [0:0] coalesced_delay_0_fifo_valid_out;
    wire coalesced_delay_0_fifo_valid_out_bitsignaltemp;
    wire [0:0] coalesced_delay_0_fifo_stall_out;
    wire coalesced_delay_0_fifo_stall_out_bitsignaltemp;
    wire [159:0] coalesced_delay_0_fifo_data_out;
    wire [0:0] coalesced_delay_1_fifo_valid_in;
    wire coalesced_delay_1_fifo_valid_in_bitsignaltemp;
    wire [0:0] coalesced_delay_1_fifo_stall_in;
    wire coalesced_delay_1_fifo_stall_in_bitsignaltemp;
    wire [447:0] coalesced_delay_1_fifo_data_in;
    wire [0:0] coalesced_delay_1_fifo_valid_out;
    wire coalesced_delay_1_fifo_valid_out_bitsignaltemp;
    wire [0:0] coalesced_delay_1_fifo_stall_out;
    wire coalesced_delay_1_fifo_stall_out_bitsignaltemp;
    wire [447:0] coalesced_delay_1_fifo_data_out;
    wire [0:0] coalesced_delay_2_fifo_valid_in;
    wire coalesced_delay_2_fifo_valid_in_bitsignaltemp;
    wire [0:0] coalesced_delay_2_fifo_stall_in;
    wire coalesced_delay_2_fifo_stall_in_bitsignaltemp;
    wire [223:0] coalesced_delay_2_fifo_data_in;
    wire [0:0] coalesced_delay_2_fifo_valid_out;
    wire coalesced_delay_2_fifo_valid_out_bitsignaltemp;
    wire [0:0] coalesced_delay_2_fifo_stall_out;
    wire coalesced_delay_2_fifo_stall_out_bitsignaltemp;
    wire [223:0] coalesced_delay_2_fifo_data_out;
    wire [0:0] bubble_join_i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10_q;
    wire [0:0] bubble_select_i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10_b;
    wire [0:0] bubble_join_i_llvm_fpga_mem_memdep_k2_zts6c_calc19_q;
    wire [0:0] bubble_select_i_llvm_fpga_mem_memdep_k2_zts6c_calc19_b;
    wire [31:0] bubble_join_i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_q;
    wire [31:0] bubble_select_i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_b;
    wire [31:0] bubble_join_i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_q;
    wire [31:0] bubble_select_i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_b;
    wire [63:0] bubble_join_i_llvm_fpga_sync_buffer_p1024f32_arg12_sync_buffer_k2_zts6c_calc15_q;
    wire [63:0] bubble_select_i_llvm_fpga_sync_buffer_p1024f32_arg12_sync_buffer_k2_zts6c_calc15_b;
    wire [63:0] bubble_join_i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k2_zts6c_calc4_q;
    wire [63:0] bubble_select_i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k2_zts6c_calc4_b;
    wire [607:0] bubble_join_stall_entry_q;
    wire [31:0] bubble_select_stall_entry_b;
    wire [31:0] bubble_select_stall_entry_c;
    wire [31:0] bubble_select_stall_entry_d;
    wire [63:0] bubble_select_stall_entry_e;
    wire [63:0] bubble_select_stall_entry_f;
    wire [31:0] bubble_select_stall_entry_g;
    wire [31:0] bubble_select_stall_entry_h;
    wire [31:0] bubble_select_stall_entry_i;
    wire [63:0] bubble_select_stall_entry_j;
    wire [63:0] bubble_select_stall_entry_k;
    wire [63:0] bubble_select_stall_entry_l;
    wire [63:0] bubble_select_stall_entry_m;
    wire [31:0] bubble_select_stall_entry_n;
    wire [607:0] bubble_join_ZTS6c_calc_B4_merge_reg_aunroll_x_q;
    wire [31:0] bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_b;
    wire [31:0] bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_c;
    wire [31:0] bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_d;
    wire [31:0] bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_e;
    wire [31:0] bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_f;
    wire [31:0] bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_g;
    wire [63:0] bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_h;
    wire [63:0] bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_i;
    wire [63:0] bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_j;
    wire [63:0] bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_k;
    wire [63:0] bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_l;
    wire [63:0] bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_m;
    wire [31:0] bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_n;
    wire [63:0] bubble_join_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x_q;
    wire [63:0] bubble_select_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x_b;
    wire [63:0] bubble_join_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x_q;
    wire [63:0] bubble_select_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x_b;
    wire [159:0] bubble_join_coalesced_delay_0_fifo_q;
    wire [159:0] bubble_select_coalesced_delay_0_fifo_b;
    wire [447:0] bubble_join_coalesced_delay_1_fifo_q;
    wire [447:0] bubble_select_coalesced_delay_1_fifo_b;
    wire [223:0] bubble_join_coalesced_delay_2_fifo_q;
    wire [223:0] bubble_select_coalesced_delay_2_fifo_b;
    wire [0:0] SE_out_i_llvm_fpga_mem_memdep_k2_zts6c_calc19_wireValid;
    wire [0:0] SE_out_i_llvm_fpga_mem_memdep_k2_zts6c_calc19_and0;
    wire [0:0] SE_out_i_llvm_fpga_mem_memdep_k2_zts6c_calc19_backStall;
    wire [0:0] SE_out_i_llvm_fpga_mem_memdep_k2_zts6c_calc19_V0;
    wire [0:0] SE_out_i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_wireValid;
    wire [0:0] SE_out_i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_and0;
    wire [0:0] SE_out_i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_backStall;
    wire [0:0] SE_out_i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_V0;
    wire [0:0] SE_out_i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_wireValid;
    wire [0:0] SE_out_i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_and0;
    wire [0:0] SE_out_i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_backStall;
    wire [0:0] SE_out_i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_V0;
    wire [0:0] SE_stall_entry_wireValid;
    wire [0:0] SE_stall_entry_backStall;
    wire [0:0] SE_stall_entry_V0;
    wire [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_wireValid;
    wire [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_wireStall;
    wire [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_StallValid;
    wire [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_toReg0;
    reg [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg0;
    wire [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_consumed0;
    wire [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_toReg1;
    reg [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg1;
    wire [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_consumed1;
    wire [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_toReg2;
    reg [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg2;
    wire [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_consumed2;
    wire [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_toReg3;
    reg [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg3;
    wire [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_consumed3;
    wire [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_toReg4;
    reg [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg4;
    wire [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_consumed4;
    wire [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_toReg5;
    reg [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg5;
    wire [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_consumed5;
    wire [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_toReg6;
    reg [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg6;
    wire [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_consumed6;
    wire [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_toReg7;
    reg [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg7;
    wire [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_consumed7;
    wire [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_or0;
    wire [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_or1;
    wire [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_or2;
    wire [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_or3;
    wire [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_or4;
    wire [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_or5;
    wire [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_or6;
    wire [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_backStall;
    wire [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_V0;
    wire [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_V1;
    wire [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_V2;
    wire [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_V3;
    wire [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_V4;
    wire [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_V5;
    wire [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_V6;
    wire [0:0] SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_V7;
    wire [0:0] SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x_wireValid;
    wire [0:0] SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x_and0;
    wire [0:0] SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x_and1;
    wire [0:0] SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x_backStall;
    wire [0:0] SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x_V0;
    wire [0:0] SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x_wireValid;
    wire [0:0] SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x_and0;
    wire [0:0] SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x_and1;
    wire [0:0] SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x_backStall;
    wire [0:0] SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x_V0;
    wire [0:0] SE_out_coalesced_delay_0_fifo_wireValid;
    wire [0:0] SE_out_coalesced_delay_0_fifo_wireStall;
    wire [0:0] SE_out_coalesced_delay_0_fifo_StallValid;
    wire [0:0] SE_out_coalesced_delay_0_fifo_toReg0;
    reg [0:0] SE_out_coalesced_delay_0_fifo_fromReg0;
    wire [0:0] SE_out_coalesced_delay_0_fifo_consumed0;
    wire [0:0] SE_out_coalesced_delay_0_fifo_toReg1;
    reg [0:0] SE_out_coalesced_delay_0_fifo_fromReg1;
    wire [0:0] SE_out_coalesced_delay_0_fifo_consumed1;
    wire [0:0] SE_out_coalesced_delay_0_fifo_toReg2;
    reg [0:0] SE_out_coalesced_delay_0_fifo_fromReg2;
    wire [0:0] SE_out_coalesced_delay_0_fifo_consumed2;
    wire [0:0] SE_out_coalesced_delay_0_fifo_or0;
    wire [0:0] SE_out_coalesced_delay_0_fifo_or1;
    wire [0:0] SE_out_coalesced_delay_0_fifo_backStall;
    wire [0:0] SE_out_coalesced_delay_0_fifo_V0;
    wire [0:0] SE_out_coalesced_delay_0_fifo_V1;
    wire [0:0] SE_out_coalesced_delay_0_fifo_V2;
    wire [0:0] SE_out_coalesced_delay_2_fifo_wireValid;
    wire [0:0] SE_out_coalesced_delay_2_fifo_and0;
    wire [0:0] SE_out_coalesced_delay_2_fifo_and1;
    wire [0:0] SE_out_coalesced_delay_2_fifo_backStall;
    wire [0:0] SE_out_coalesced_delay_2_fifo_V0;


    // bubble_join_i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18(BITJOIN,184)
    assign bubble_join_i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_q = i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_out_o_readdata;

    // bubble_select_i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18(BITSELECT,185)
    assign bubble_select_i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_b = $unsigned(bubble_join_i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_q[31:0]);

    // join_for_coalesced_delay_2(BITJOIN,169)
    assign join_for_coalesced_delay_2_q = {sel_for_coalesced_delay_0_d, i_l_grpid_0_ext_offset_k2_zts6c_calc9_vt_join_q, sel_for_coalesced_delay_0_c, sel_for_coalesced_delay_0_b};

    // coalesced_delay_2_fifo(STALLFIFO,173)
    assign coalesced_delay_2_fifo_valid_in = SE_out_coalesced_delay_0_fifo_V2;
    assign coalesced_delay_2_fifo_stall_in = SE_out_coalesced_delay_2_fifo_backStall;
    assign coalesced_delay_2_fifo_data_in = join_for_coalesced_delay_2_q;
    assign coalesced_delay_2_fifo_valid_in_bitsignaltemp = coalesced_delay_2_fifo_valid_in[0];
    assign coalesced_delay_2_fifo_stall_in_bitsignaltemp = coalesced_delay_2_fifo_stall_in[0];
    assign coalesced_delay_2_fifo_valid_out[0] = coalesced_delay_2_fifo_valid_out_bitsignaltemp;
    assign coalesced_delay_2_fifo_stall_out[0] = coalesced_delay_2_fifo_stall_out_bitsignaltemp;
    acl_data_fifo #(
        .DEPTH(132),
        .STRICT_DEPTH(0),
        .ALLOW_FULL_WRITE(0),
        .DATA_WIDTH(224),
        .IMPL("ram")
    ) thecoalesced_delay_2_fifo (
        .valid_in(coalesced_delay_2_fifo_valid_in_bitsignaltemp),
        .stall_in(coalesced_delay_2_fifo_stall_in_bitsignaltemp),
        .data_in(join_for_coalesced_delay_2_q),
        .valid_out(coalesced_delay_2_fifo_valid_out_bitsignaltemp),
        .stall_out(coalesced_delay_2_fifo_stall_out_bitsignaltemp),
        .data_out(coalesced_delay_2_fifo_data_out),
        .clock(clock),
        .resetn(resetn)
    );

    // SE_out_coalesced_delay_2_fifo(STALLENABLE,298)
    // Valid signal propagation
    assign SE_out_coalesced_delay_2_fifo_V0 = SE_out_coalesced_delay_2_fifo_wireValid;
    // Backward Stall generation
    assign SE_out_coalesced_delay_2_fifo_backStall = in_stall_in | ~ (SE_out_coalesced_delay_2_fifo_wireValid);
    // Computing multiple Valid(s)
    assign SE_out_coalesced_delay_2_fifo_and0 = coalesced_delay_2_fifo_valid_out;
    assign SE_out_coalesced_delay_2_fifo_and1 = coalesced_delay_1_fifo_valid_out & SE_out_coalesced_delay_2_fifo_and0;
    assign SE_out_coalesced_delay_2_fifo_wireValid = i_llvm_fpga_simple_barrier_unnamed_k2_zts6c_calc18_k2_zts6c_calc21_out_valid_exit & SE_out_coalesced_delay_2_fifo_and1;

    // bubble_join_i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10(BITJOIN,175)
    assign bubble_join_i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10_q = i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10_out_o_writeack;

    // bubble_select_i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10(BITSELECT,176)
    assign bubble_select_i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10_b = $unsigned(bubble_join_i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10_q[0:0]);

    // bubble_join_i_llvm_fpga_mem_memdep_k2_zts6c_calc19(BITJOIN,178)
    assign bubble_join_i_llvm_fpga_mem_memdep_k2_zts6c_calc19_q = i_llvm_fpga_mem_memdep_k2_zts6c_calc19_out_o_writeack;

    // bubble_select_i_llvm_fpga_mem_memdep_k2_zts6c_calc19(BITSELECT,179)
    assign bubble_select_i_llvm_fpga_mem_memdep_k2_zts6c_calc19_b = $unsigned(bubble_join_i_llvm_fpga_mem_memdep_k2_zts6c_calc19_q[0:0]);

    // i_barrier_dep_k2_zts6c_calc20(LOGICAL,10)@226
    assign i_barrier_dep_k2_zts6c_calc20_q = bubble_select_i_llvm_fpga_mem_memdep_k2_zts6c_calc19_b | bubble_select_i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10_b;

    // i_llvm_fpga_simple_barrier_unnamed_k2_zts6c_calc18_k2_zts6c_calc21(BLACKBOX,23)@226
    // in in_stall_exit@20000000
    // out out_data_exit@356
    // out out_stall_entry@20000000
    // out out_valid_exit@356
    k2_ZTS6c_calc_i_llvm_fpga_simple_barrier0000alc18_k2_zts6c_calc0 thei_llvm_fpga_simple_barrier_unnamed_k2_zts6c_calc18_k2_zts6c_calc21 (
        .in_data_entry(i_barrier_dep_k2_zts6c_calc20_q),
        .in_stall_exit(SE_out_coalesced_delay_2_fifo_backStall),
        .in_valid_entry(SE_out_i_llvm_fpga_mem_memdep_k2_zts6c_calc19_V0),
        .in_workgroup_size(in_barrier_unnamed_k2_ZTS6c_calc18_wgs_workgroup_size),
        .out_data_exit(),
        .out_stall_entry(i_llvm_fpga_simple_barrier_unnamed_k2_zts6c_calc18_k2_zts6c_calc21_out_stall_entry),
        .out_valid_exit(i_llvm_fpga_simple_barrier_unnamed_k2_zts6c_calc18_k2_zts6c_calc21_out_valid_exit),
        .clock(clock),
        .resetn(resetn)
    );

    // bubble_join_i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7(BITJOIN,181)
    assign bubble_join_i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_q = i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_out_o_readdata;

    // bubble_select_i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7(BITSELECT,182)
    assign bubble_select_i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_b = $unsigned(bubble_join_i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_q[31:0]);

    // i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10(BLACKBOX,19)@225
    // in in_i_stall@20000000
    // out out_memdep_34_k2_ZTS6c_calc_avm_address@20000000
    // out out_memdep_34_k2_ZTS6c_calc_avm_burstcount@20000000
    // out out_memdep_34_k2_ZTS6c_calc_avm_byteenable@20000000
    // out out_memdep_34_k2_ZTS6c_calc_avm_enable@20000000
    // out out_memdep_34_k2_ZTS6c_calc_avm_read@20000000
    // out out_memdep_34_k2_ZTS6c_calc_avm_write@20000000
    // out out_memdep_34_k2_ZTS6c_calc_avm_writedata@20000000
    // out out_o_stall@20000000
    // out out_o_valid@226
    // out out_o_writeack@226
    k2_ZTS6c_calc_i_llvm_fpga_mem_memdep_34_k2_zts6c_calc0 thei_llvm_fpga_mem_memdep_34_k2_zts6c_calc10 (
        .in_AddrOffset(i_l_grpid_0_ext_offset_k2_zts6c_calc9_vt_join_q),
        .in_flush(in_flush),
        .in_i_address(sel_for_coalesced_delay_0_b),
        .in_i_predicate(GND_q),
        .in_i_stall(SE_out_i_llvm_fpga_mem_memdep_k2_zts6c_calc19_backStall),
        .in_i_valid(SE_out_i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_V0),
        .in_i_writedata(bubble_select_i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_b),
        .in_memdep_34_k2_ZTS6c_calc_avm_readdata(in_memdep_34_k2_ZTS6c_calc_avm_readdata),
        .in_memdep_34_k2_ZTS6c_calc_avm_readdatavalid(in_memdep_34_k2_ZTS6c_calc_avm_readdatavalid),
        .in_memdep_34_k2_ZTS6c_calc_avm_waitrequest(in_memdep_34_k2_ZTS6c_calc_avm_waitrequest),
        .in_memdep_34_k2_ZTS6c_calc_avm_writeack(in_memdep_34_k2_ZTS6c_calc_avm_writeack),
        .out_memdep_34_k2_ZTS6c_calc_avm_address(i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10_out_memdep_34_k2_ZTS6c_calc_avm_address),
        .out_memdep_34_k2_ZTS6c_calc_avm_burstcount(i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10_out_memdep_34_k2_ZTS6c_calc_avm_burstcount),
        .out_memdep_34_k2_ZTS6c_calc_avm_byteenable(i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10_out_memdep_34_k2_ZTS6c_calc_avm_byteenable),
        .out_memdep_34_k2_ZTS6c_calc_avm_enable(i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10_out_memdep_34_k2_ZTS6c_calc_avm_enable),
        .out_memdep_34_k2_ZTS6c_calc_avm_read(i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10_out_memdep_34_k2_ZTS6c_calc_avm_read),
        .out_memdep_34_k2_ZTS6c_calc_avm_write(i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10_out_memdep_34_k2_ZTS6c_calc_avm_write),
        .out_memdep_34_k2_ZTS6c_calc_avm_writedata(i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10_out_memdep_34_k2_ZTS6c_calc_avm_writedata),
        .out_o_stall(i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10_out_o_stall),
        .out_o_valid(i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10_out_o_valid),
        .out_o_writeack(i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10_out_o_writeack),
        .clock(clock),
        .resetn(resetn)
    );

    // SE_out_i_llvm_fpga_mem_memdep_k2_zts6c_calc19(STALLENABLE,227)
    // Valid signal propagation
    assign SE_out_i_llvm_fpga_mem_memdep_k2_zts6c_calc19_V0 = SE_out_i_llvm_fpga_mem_memdep_k2_zts6c_calc19_wireValid;
    // Backward Stall generation
    assign SE_out_i_llvm_fpga_mem_memdep_k2_zts6c_calc19_backStall = i_llvm_fpga_simple_barrier_unnamed_k2_zts6c_calc18_k2_zts6c_calc21_out_stall_entry | ~ (SE_out_i_llvm_fpga_mem_memdep_k2_zts6c_calc19_wireValid);
    // Computing multiple Valid(s)
    assign SE_out_i_llvm_fpga_mem_memdep_k2_zts6c_calc19_and0 = i_llvm_fpga_mem_memdep_k2_zts6c_calc19_out_o_valid;
    assign SE_out_i_llvm_fpga_mem_memdep_k2_zts6c_calc19_wireValid = i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10_out_o_valid & SE_out_i_llvm_fpga_mem_memdep_k2_zts6c_calc19_and0;

    // bubble_join_coalesced_delay_0_fifo(BITJOIN,211)
    assign bubble_join_coalesced_delay_0_fifo_q = coalesced_delay_0_fifo_data_out;

    // bubble_select_coalesced_delay_0_fifo(BITSELECT,212)
    assign bubble_select_coalesced_delay_0_fifo_b = $unsigned(bubble_join_coalesced_delay_0_fifo_q[159:0]);

    // sel_for_coalesced_delay_0(BITSELECT,164)
    assign sel_for_coalesced_delay_0_b = $unsigned(bubble_select_coalesced_delay_0_fifo_b[63:0]);
    assign sel_for_coalesced_delay_0_c = $unsigned(bubble_select_coalesced_delay_0_fifo_b[127:64]);
    assign sel_for_coalesced_delay_0_d = $unsigned(bubble_select_coalesced_delay_0_fifo_b[159:128]);

    // i_l_grpid_0_ext_offset_k2_zts6c_calc9_vt_const_63(CONSTANT,16)
    assign i_l_grpid_0_ext_offset_k2_zts6c_calc9_vt_const_63_q = $unsigned(20'b00000000000000000000);

    // leftShiftStage1Idx1Rng8_uid141_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x(BITSELECT,140)@225
    assign leftShiftStage1Idx1Rng8_uid141_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_in = leftShiftStage0_uid139_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_q[55:0];
    assign leftShiftStage1Idx1Rng8_uid141_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_b = leftShiftStage1Idx1Rng8_uid141_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_in[55:0];

    // leftShiftStage1Idx1Pad8_uid140_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x(CONSTANT,139)
    assign leftShiftStage1Idx1Pad8_uid140_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_q = $unsigned(8'b00000000);

    // leftShiftStage1Idx1_uid142_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x(BITJOIN,141)@225
    assign leftShiftStage1Idx1_uid142_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_q = {leftShiftStage1Idx1Rng8_uid141_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_b, leftShiftStage1Idx1Pad8_uid140_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_q};

    // leftShiftStage0Idx1Rng4_uid136_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x(BITSELECT,135)@225
    assign leftShiftStage0Idx1Rng4_uid136_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_in = i_l_grpid_0_ext_k2_zts6c_calc8_vt_join_q[59:0];
    assign leftShiftStage0Idx1Rng4_uid136_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_b = leftShiftStage0Idx1Rng4_uid136_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_in[59:0];

    // leftShiftStage0Idx1Pad4_uid135_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x(CONSTANT,134)
    assign leftShiftStage0Idx1Pad4_uid135_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_q = $unsigned(4'b0000);

    // leftShiftStage0Idx1_uid137_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x(BITJOIN,136)@225
    assign leftShiftStage0Idx1_uid137_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_q = {leftShiftStage0Idx1Rng4_uid136_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_b, leftShiftStage0Idx1Pad4_uid135_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_q};

    // i_l_grpid_0_ext_k2_zts6c_calc8_vt_const_63(CONSTANT,12)
    assign i_l_grpid_0_ext_k2_zts6c_calc8_vt_const_63_q = $unsigned(32'b00000000000000000000000000000000);

    // i_l_grpid_0_ext_k2_zts6c_calc8_sel_x(BITSELECT,91)@225
    assign i_l_grpid_0_ext_k2_zts6c_calc8_sel_x_b = {32'b00000000000000000000000000000000, sel_for_coalesced_delay_0_d[31:0]};

    // i_l_grpid_0_ext_k2_zts6c_calc8_vt_select_31(BITSELECT,14)@225
    assign i_l_grpid_0_ext_k2_zts6c_calc8_vt_select_31_b = i_l_grpid_0_ext_k2_zts6c_calc8_sel_x_b[31:0];

    // i_l_grpid_0_ext_k2_zts6c_calc8_vt_join(BITJOIN,13)@225
    assign i_l_grpid_0_ext_k2_zts6c_calc8_vt_join_q = {i_l_grpid_0_ext_k2_zts6c_calc8_vt_const_63_q, i_l_grpid_0_ext_k2_zts6c_calc8_vt_select_31_b};

    // leftShiftStage0_uid139_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x(MUX,138)@225
    assign leftShiftStage0_uid139_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_s = VCC_q;
    always @(leftShiftStage0_uid139_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_s or i_l_grpid_0_ext_k2_zts6c_calc8_vt_join_q or leftShiftStage0Idx1_uid137_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_q)
    begin
        unique case (leftShiftStage0_uid139_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_s)
            1'b0 : leftShiftStage0_uid139_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_q = i_l_grpid_0_ext_k2_zts6c_calc8_vt_join_q;
            1'b1 : leftShiftStage0_uid139_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_q = leftShiftStage0Idx1_uid137_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_q;
            default : leftShiftStage0_uid139_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_q = 64'b0;
        endcase
    end

    // VCC(CONSTANT,1)
    assign VCC_q = $unsigned(1'b1);

    // leftShiftStage1_uid144_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x(MUX,143)@225
    assign leftShiftStage1_uid144_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_s = VCC_q;
    always @(leftShiftStage1_uid144_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_s or leftShiftStage0_uid139_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_q or leftShiftStage1Idx1_uid142_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_q)
    begin
        unique case (leftShiftStage1_uid144_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_s)
            1'b0 : leftShiftStage1_uid144_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_q = leftShiftStage0_uid139_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_q;
            1'b1 : leftShiftStage1_uid144_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_q = leftShiftStage1Idx1_uid142_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_q;
            default : leftShiftStage1_uid144_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_q = 64'b0;
        endcase
    end

    // i_l_grpid_0_ext_offset_k2_zts6c_calc9_vt_select_43(BITSELECT,18)@225
    assign i_l_grpid_0_ext_offset_k2_zts6c_calc9_vt_select_43_b = leftShiftStage1_uid144_i_l_grpid_0_ext_offset_k2_zts6c_calc0_shift_x_q[43:12];

    // i_l_grpid_0_ext_offset_k2_zts6c_calc9_vt_const_11(CONSTANT,15)
    assign i_l_grpid_0_ext_offset_k2_zts6c_calc9_vt_const_11_q = $unsigned(12'b000000000000);

    // i_l_grpid_0_ext_offset_k2_zts6c_calc9_vt_join(BITJOIN,17)@225
    assign i_l_grpid_0_ext_offset_k2_zts6c_calc9_vt_join_q = {i_l_grpid_0_ext_offset_k2_zts6c_calc9_vt_const_63_q, i_l_grpid_0_ext_offset_k2_zts6c_calc9_vt_select_43_b, i_l_grpid_0_ext_offset_k2_zts6c_calc9_vt_const_11_q};

    // i_llvm_fpga_mem_memdep_k2_zts6c_calc19(BLACKBOX,20)@225
    // in in_i_stall@20000000
    // out out_memdep_k2_ZTS6c_calc_avm_address@20000000
    // out out_memdep_k2_ZTS6c_calc_avm_burstcount@20000000
    // out out_memdep_k2_ZTS6c_calc_avm_byteenable@20000000
    // out out_memdep_k2_ZTS6c_calc_avm_enable@20000000
    // out out_memdep_k2_ZTS6c_calc_avm_read@20000000
    // out out_memdep_k2_ZTS6c_calc_avm_write@20000000
    // out out_memdep_k2_ZTS6c_calc_avm_writedata@20000000
    // out out_o_stall@20000000
    // out out_o_valid@226
    // out out_o_writeack@226
    k2_ZTS6c_calc_i_llvm_fpga_mem_memdep_k2_zts6c_calc0 thei_llvm_fpga_mem_memdep_k2_zts6c_calc19 (
        .in_AddrOffset(i_l_grpid_0_ext_offset_k2_zts6c_calc9_vt_join_q),
        .in_flush(in_flush),
        .in_i_address(sel_for_coalesced_delay_0_c),
        .in_i_predicate(GND_q),
        .in_i_stall(SE_out_i_llvm_fpga_mem_memdep_k2_zts6c_calc19_backStall),
        .in_i_valid(SE_out_i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_V0),
        .in_i_writedata(bubble_select_i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_b),
        .in_memdep_k2_ZTS6c_calc_avm_readdata(in_memdep_k2_ZTS6c_calc_avm_readdata),
        .in_memdep_k2_ZTS6c_calc_avm_readdatavalid(in_memdep_k2_ZTS6c_calc_avm_readdatavalid),
        .in_memdep_k2_ZTS6c_calc_avm_waitrequest(in_memdep_k2_ZTS6c_calc_avm_waitrequest),
        .in_memdep_k2_ZTS6c_calc_avm_writeack(in_memdep_k2_ZTS6c_calc_avm_writeack),
        .out_memdep_k2_ZTS6c_calc_avm_address(i_llvm_fpga_mem_memdep_k2_zts6c_calc19_out_memdep_k2_ZTS6c_calc_avm_address),
        .out_memdep_k2_ZTS6c_calc_avm_burstcount(i_llvm_fpga_mem_memdep_k2_zts6c_calc19_out_memdep_k2_ZTS6c_calc_avm_burstcount),
        .out_memdep_k2_ZTS6c_calc_avm_byteenable(i_llvm_fpga_mem_memdep_k2_zts6c_calc19_out_memdep_k2_ZTS6c_calc_avm_byteenable),
        .out_memdep_k2_ZTS6c_calc_avm_enable(i_llvm_fpga_mem_memdep_k2_zts6c_calc19_out_memdep_k2_ZTS6c_calc_avm_enable),
        .out_memdep_k2_ZTS6c_calc_avm_read(i_llvm_fpga_mem_memdep_k2_zts6c_calc19_out_memdep_k2_ZTS6c_calc_avm_read),
        .out_memdep_k2_ZTS6c_calc_avm_write(i_llvm_fpga_mem_memdep_k2_zts6c_calc19_out_memdep_k2_ZTS6c_calc_avm_write),
        .out_memdep_k2_ZTS6c_calc_avm_writedata(i_llvm_fpga_mem_memdep_k2_zts6c_calc19_out_memdep_k2_ZTS6c_calc_avm_writedata),
        .out_o_stall(i_llvm_fpga_mem_memdep_k2_zts6c_calc19_out_o_stall),
        .out_o_valid(i_llvm_fpga_mem_memdep_k2_zts6c_calc19_out_o_valid),
        .out_o_writeack(i_llvm_fpga_mem_memdep_k2_zts6c_calc19_out_o_writeack),
        .clock(clock),
        .resetn(resetn)
    );

    // SE_out_coalesced_delay_0_fifo(STALLENABLE,294)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            SE_out_coalesced_delay_0_fifo_fromReg0 <= '0;
            SE_out_coalesced_delay_0_fifo_fromReg1 <= '0;
            SE_out_coalesced_delay_0_fifo_fromReg2 <= '0;
        end
        else
        begin
            // Successor 0
            SE_out_coalesced_delay_0_fifo_fromReg0 <= SE_out_coalesced_delay_0_fifo_toReg0;
            // Successor 1
            SE_out_coalesced_delay_0_fifo_fromReg1 <= SE_out_coalesced_delay_0_fifo_toReg1;
            // Successor 2
            SE_out_coalesced_delay_0_fifo_fromReg2 <= SE_out_coalesced_delay_0_fifo_toReg2;
        end
    end
    // Input Stall processing
    assign SE_out_coalesced_delay_0_fifo_consumed0 = (~ (SE_out_i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_backStall) & SE_out_coalesced_delay_0_fifo_wireValid) | SE_out_coalesced_delay_0_fifo_fromReg0;
    assign SE_out_coalesced_delay_0_fifo_consumed1 = (~ (SE_out_i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_backStall) & SE_out_coalesced_delay_0_fifo_wireValid) | SE_out_coalesced_delay_0_fifo_fromReg1;
    assign SE_out_coalesced_delay_0_fifo_consumed2 = (~ (coalesced_delay_2_fifo_stall_out) & SE_out_coalesced_delay_0_fifo_wireValid) | SE_out_coalesced_delay_0_fifo_fromReg2;
    // Consuming
    assign SE_out_coalesced_delay_0_fifo_StallValid = SE_out_coalesced_delay_0_fifo_backStall & SE_out_coalesced_delay_0_fifo_wireValid;
    assign SE_out_coalesced_delay_0_fifo_toReg0 = SE_out_coalesced_delay_0_fifo_StallValid & SE_out_coalesced_delay_0_fifo_consumed0;
    assign SE_out_coalesced_delay_0_fifo_toReg1 = SE_out_coalesced_delay_0_fifo_StallValid & SE_out_coalesced_delay_0_fifo_consumed1;
    assign SE_out_coalesced_delay_0_fifo_toReg2 = SE_out_coalesced_delay_0_fifo_StallValid & SE_out_coalesced_delay_0_fifo_consumed2;
    // Backward Stall generation
    assign SE_out_coalesced_delay_0_fifo_or0 = SE_out_coalesced_delay_0_fifo_consumed0;
    assign SE_out_coalesced_delay_0_fifo_or1 = SE_out_coalesced_delay_0_fifo_consumed1 & SE_out_coalesced_delay_0_fifo_or0;
    assign SE_out_coalesced_delay_0_fifo_wireStall = ~ (SE_out_coalesced_delay_0_fifo_consumed2 & SE_out_coalesced_delay_0_fifo_or1);
    assign SE_out_coalesced_delay_0_fifo_backStall = SE_out_coalesced_delay_0_fifo_wireStall;
    // Valid signal propagation
    assign SE_out_coalesced_delay_0_fifo_V0 = SE_out_coalesced_delay_0_fifo_wireValid & ~ (SE_out_coalesced_delay_0_fifo_fromReg0);
    assign SE_out_coalesced_delay_0_fifo_V1 = SE_out_coalesced_delay_0_fifo_wireValid & ~ (SE_out_coalesced_delay_0_fifo_fromReg1);
    assign SE_out_coalesced_delay_0_fifo_V2 = SE_out_coalesced_delay_0_fifo_wireValid & ~ (SE_out_coalesced_delay_0_fifo_fromReg2);
    // Computing multiple Valid(s)
    assign SE_out_coalesced_delay_0_fifo_wireValid = coalesced_delay_0_fifo_valid_out;

    // SE_out_i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18(STALLENABLE,231)
    // Valid signal propagation
    assign SE_out_i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_V0 = SE_out_i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_wireValid;
    // Backward Stall generation
    assign SE_out_i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_backStall = i_llvm_fpga_mem_memdep_k2_zts6c_calc19_out_o_stall | ~ (SE_out_i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_wireValid);
    // Computing multiple Valid(s)
    assign SE_out_i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_and0 = i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_out_o_valid;
    assign SE_out_i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_wireValid = SE_out_coalesced_delay_0_fifo_V1 & SE_out_i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_and0;

    // bubble_join_ZTS6c_calc_B4_merge_reg_aunroll_x(BITJOIN,198)
    assign bubble_join_ZTS6c_calc_B4_merge_reg_aunroll_x_q = {ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_12_tpl, ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_11_tpl, ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_10_tpl, ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_9_tpl, ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_8_tpl, ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_7_tpl, ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_6_tpl, ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_5_tpl, ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_4_tpl, ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_3_tpl, ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_2_tpl, ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_1_tpl, ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_0_tpl};

    // bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x(BITSELECT,199)
    assign bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_b = $unsigned(bubble_join_ZTS6c_calc_B4_merge_reg_aunroll_x_q[31:0]);
    assign bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_c = $unsigned(bubble_join_ZTS6c_calc_B4_merge_reg_aunroll_x_q[63:32]);
    assign bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_d = $unsigned(bubble_join_ZTS6c_calc_B4_merge_reg_aunroll_x_q[95:64]);
    assign bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_e = $unsigned(bubble_join_ZTS6c_calc_B4_merge_reg_aunroll_x_q[127:96]);
    assign bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_f = $unsigned(bubble_join_ZTS6c_calc_B4_merge_reg_aunroll_x_q[159:128]);
    assign bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_g = $unsigned(bubble_join_ZTS6c_calc_B4_merge_reg_aunroll_x_q[191:160]);
    assign bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_h = $unsigned(bubble_join_ZTS6c_calc_B4_merge_reg_aunroll_x_q[255:192]);
    assign bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_i = $unsigned(bubble_join_ZTS6c_calc_B4_merge_reg_aunroll_x_q[319:256]);
    assign bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_j = $unsigned(bubble_join_ZTS6c_calc_B4_merge_reg_aunroll_x_q[383:320]);
    assign bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_k = $unsigned(bubble_join_ZTS6c_calc_B4_merge_reg_aunroll_x_q[447:384]);
    assign bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_l = $unsigned(bubble_join_ZTS6c_calc_B4_merge_reg_aunroll_x_q[511:448]);
    assign bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_m = $unsigned(bubble_join_ZTS6c_calc_B4_merge_reg_aunroll_x_q[575:512]);
    assign bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_n = $unsigned(bubble_join_ZTS6c_calc_B4_merge_reg_aunroll_x_q[607:576]);

    // i_unnamed_k2_zts6c_calc11(ADD,33)@1
    assign i_unnamed_k2_zts6c_calc11_a = {1'b0, bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_g};
    assign i_unnamed_k2_zts6c_calc11_b = {1'b0, bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_b};
    assign i_unnamed_k2_zts6c_calc11_o = $unsigned(i_unnamed_k2_zts6c_calc11_a) + $unsigned(i_unnamed_k2_zts6c_calc11_b);
    assign i_unnamed_k2_zts6c_calc11_q = i_unnamed_k2_zts6c_calc11_o[32:0];

    // bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x(BITSELECT,81)@1
    assign bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b = i_unnamed_k2_zts6c_calc11_q[31:0];

    // i_unnamed_k2_zts6c_calc12_sel_x(BITSELECT,99)@1
    assign i_unnamed_k2_zts6c_calc12_sel_x_b = $unsigned({{32{bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b[31]}}, bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b[31:0]});

    // dupName_8_i_unnamed_k2_zts6c_calc0_narrow_x(BITSELECT,122)@1
    assign dupName_8_i_unnamed_k2_zts6c_calc0_narrow_x_b = i_unnamed_k2_zts6c_calc12_sel_x_b[61:0];

    // dupName_8_i_unnamed_k2_zts6c_calc0_shift_join_x(BITJOIN,123)@1
    assign dupName_8_i_unnamed_k2_zts6c_calc0_shift_join_x_q = {dupName_8_i_unnamed_k2_zts6c_calc0_narrow_x_b, i_unnamed_k2_zts6c_calc16_vt_const_1_q};

    // bubble_join_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x(BITJOIN,205)
    assign bubble_join_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x_q = i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x_out_buffer_out_0_tpl;

    // bubble_select_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x(BITSELECT,206)
    assign bubble_select_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x_b = $unsigned(bubble_join_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x_q[63:0]);

    // dupName_7_i_unnamed_k2_zts6c_calc0_narrow_x(BITSELECT,116)@1
    assign dupName_7_i_unnamed_k2_zts6c_calc0_narrow_x_b = bubble_select_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x_b[61:0];

    // dupName_7_i_unnamed_k2_zts6c_calc0_shift_join_x(BITJOIN,117)@1
    assign dupName_7_i_unnamed_k2_zts6c_calc0_shift_join_x_q = {dupName_7_i_unnamed_k2_zts6c_calc0_narrow_x_b, i_unnamed_k2_zts6c_calc16_vt_const_1_q};

    // bubble_join_i_llvm_fpga_sync_buffer_p1024f32_arg12_sync_buffer_k2_zts6c_calc15(BITJOIN,188)
    assign bubble_join_i_llvm_fpga_sync_buffer_p1024f32_arg12_sync_buffer_k2_zts6c_calc15_q = i_llvm_fpga_sync_buffer_p1024f32_arg12_sync_buffer_k2_zts6c_calc15_out_buffer_out;

    // bubble_select_i_llvm_fpga_sync_buffer_p1024f32_arg12_sync_buffer_k2_zts6c_calc15(BITSELECT,189)
    assign bubble_select_i_llvm_fpga_sync_buffer_p1024f32_arg12_sync_buffer_k2_zts6c_calc15_b = $unsigned(bubble_join_i_llvm_fpga_sync_buffer_p1024f32_arg12_sync_buffer_k2_zts6c_calc15_q[63:0]);

    // i_llvm_fpga_sync_buffer_p1024f32_arg12_sync_buffer_k2_zts6c_calc15_vt_select_63(BITSELECT,27)@1
    assign i_llvm_fpga_sync_buffer_p1024f32_arg12_sync_buffer_k2_zts6c_calc15_vt_select_63_b = bubble_select_i_llvm_fpga_sync_buffer_p1024f32_arg12_sync_buffer_k2_zts6c_calc15_b[63:10];

    // i_llvm_fpga_sync_buffer_p1024f32_arg12_sync_buffer_k2_zts6c_calc15_vt_const_9(CONSTANT,25)
    assign i_llvm_fpga_sync_buffer_p1024f32_arg12_sync_buffer_k2_zts6c_calc15_vt_const_9_q = $unsigned(10'b0000000000);

    // i_llvm_fpga_sync_buffer_p1024f32_arg12_sync_buffer_k2_zts6c_calc15_vt_join(BITJOIN,26)@1
    assign i_llvm_fpga_sync_buffer_p1024f32_arg12_sync_buffer_k2_zts6c_calc15_vt_join_q = {i_llvm_fpga_sync_buffer_p1024f32_arg12_sync_buffer_k2_zts6c_calc15_vt_select_63_b, i_llvm_fpga_sync_buffer_p1024f32_arg12_sync_buffer_k2_zts6c_calc15_vt_const_9_q};

    // dupName_7_i_unnamed_k2_zts6c_calc0_add_x(ADD,114)@1
    assign dupName_7_i_unnamed_k2_zts6c_calc0_add_x_a = {1'b0, i_llvm_fpga_sync_buffer_p1024f32_arg12_sync_buffer_k2_zts6c_calc15_vt_join_q};
    assign dupName_7_i_unnamed_k2_zts6c_calc0_add_x_b = {1'b0, dupName_7_i_unnamed_k2_zts6c_calc0_shift_join_x_q};
    assign dupName_7_i_unnamed_k2_zts6c_calc0_add_x_o = $unsigned(dupName_7_i_unnamed_k2_zts6c_calc0_add_x_a) + $unsigned(dupName_7_i_unnamed_k2_zts6c_calc0_add_x_b);
    assign dupName_7_i_unnamed_k2_zts6c_calc0_add_x_q = dupName_7_i_unnamed_k2_zts6c_calc0_add_x_o[64:0];

    // dupName_7_i_unnamed_k2_zts6c_calc0_dupName_0_trunc_sel_x(BITSELECT,119)@1
    assign dupName_7_i_unnamed_k2_zts6c_calc0_dupName_0_trunc_sel_x_b = dupName_7_i_unnamed_k2_zts6c_calc0_add_x_q[63:0];

    // i_unnamed_k2_zts6c_calc16_vt_select_63(BITSELECT,38)@1
    assign i_unnamed_k2_zts6c_calc16_vt_select_63_b = dupName_7_i_unnamed_k2_zts6c_calc0_dupName_0_trunc_sel_x_b[63:2];

    // i_unnamed_k2_zts6c_calc16_vt_join(BITJOIN,37)@1
    assign i_unnamed_k2_zts6c_calc16_vt_join_q = {i_unnamed_k2_zts6c_calc16_vt_select_63_b, i_unnamed_k2_zts6c_calc16_vt_const_1_q};

    // dupName_8_i_unnamed_k2_zts6c_calc0_add_x(ADD,120)@1
    assign dupName_8_i_unnamed_k2_zts6c_calc0_add_x_a = {1'b0, i_unnamed_k2_zts6c_calc16_vt_join_q};
    assign dupName_8_i_unnamed_k2_zts6c_calc0_add_x_b = {1'b0, dupName_8_i_unnamed_k2_zts6c_calc0_shift_join_x_q};
    assign dupName_8_i_unnamed_k2_zts6c_calc0_add_x_o = $unsigned(dupName_8_i_unnamed_k2_zts6c_calc0_add_x_a) + $unsigned(dupName_8_i_unnamed_k2_zts6c_calc0_add_x_b);
    assign dupName_8_i_unnamed_k2_zts6c_calc0_add_x_q = dupName_8_i_unnamed_k2_zts6c_calc0_add_x_o[64:0];

    // dupName_8_i_unnamed_k2_zts6c_calc0_dupName_0_trunc_sel_x(BITSELECT,125)@1
    assign dupName_8_i_unnamed_k2_zts6c_calc0_dupName_0_trunc_sel_x_b = dupName_8_i_unnamed_k2_zts6c_calc0_add_x_q[63:0];

    // i_unnamed_k2_zts6c_calc17_vt_select_63(BITSELECT,41)@1
    assign i_unnamed_k2_zts6c_calc17_vt_select_63_b = dupName_8_i_unnamed_k2_zts6c_calc0_dupName_0_trunc_sel_x_b[63:2];

    // i_unnamed_k2_zts6c_calc16_vt_const_1(CONSTANT,36)
    assign i_unnamed_k2_zts6c_calc16_vt_const_1_q = $unsigned(2'b00);

    // i_unnamed_k2_zts6c_calc17_vt_join(BITJOIN,40)@1
    assign i_unnamed_k2_zts6c_calc17_vt_join_q = {i_unnamed_k2_zts6c_calc17_vt_select_63_b, i_unnamed_k2_zts6c_calc16_vt_const_1_q};

    // i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18(BLACKBOX,22)@1
    // in in_i_stall@20000000
    // out out_o_readdata@225
    // out out_o_stall@20000000
    // out out_o_valid@225
    // out out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_address@20000000
    // out out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_burstcount@20000000
    // out out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_byteenable@20000000
    // out out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_enable@20000000
    // out out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_read@20000000
    // out out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_write@20000000
    // out out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_writedata@20000000
    k2_ZTS6c_calc_i_llvm_fpga_mem_unnamed_k20000alc17_k2_zts6c_calc0 thei_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18 (
        .in_flush(in_flush),
        .in_i_address(i_unnamed_k2_zts6c_calc17_vt_join_q),
        .in_i_predicate(GND_q),
        .in_i_stall(SE_out_i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_backStall),
        .in_i_valid(SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x_V0),
        .in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_readdata(in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_readdata),
        .in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_readdatavalid(in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_readdatavalid),
        .in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_waitrequest(in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_waitrequest),
        .in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_writeack(in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_writeack),
        .out_o_readdata(i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_out_o_readdata),
        .out_o_stall(i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_out_o_stall),
        .out_o_valid(i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_out_o_valid),
        .out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_address(i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_address),
        .out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_burstcount(i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_burstcount),
        .out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_byteenable(i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_byteenable),
        .out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_enable(i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_enable),
        .out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_read(i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_read),
        .out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_write(i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_write),
        .out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_writedata(i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_writedata),
        .clock(clock),
        .resetn(resetn)
    );

    // SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x(STALLENABLE,260)
    // Valid signal propagation
    assign SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x_V0 = SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x_wireValid;
    // Backward Stall generation
    assign SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x_backStall = i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_out_o_stall | ~ (SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x_wireValid);
    // Computing multiple Valid(s)
    assign SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x_and0 = i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x_out_valid_out;
    assign SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x_and1 = i_llvm_fpga_sync_buffer_p1024f32_arg12_sync_buffer_k2_zts6c_calc15_out_valid_out & SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x_and0;
    assign SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x_wireValid = SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_V7 & SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x_and1;

    // join_for_coalesced_delay_1(BITJOIN,166)
    assign join_for_coalesced_delay_1_q = {bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_n, bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_g, bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_f, bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_d, bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_c, bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_b, bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_m, bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_l, bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_j, bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_h};

    // coalesced_delay_1_fifo(STALLFIFO,172)
    assign coalesced_delay_1_fifo_valid_in = SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_V5;
    assign coalesced_delay_1_fifo_stall_in = SE_out_coalesced_delay_2_fifo_backStall;
    assign coalesced_delay_1_fifo_data_in = join_for_coalesced_delay_1_q;
    assign coalesced_delay_1_fifo_valid_in_bitsignaltemp = coalesced_delay_1_fifo_valid_in[0];
    assign coalesced_delay_1_fifo_stall_in_bitsignaltemp = coalesced_delay_1_fifo_stall_in[0];
    assign coalesced_delay_1_fifo_valid_out[0] = coalesced_delay_1_fifo_valid_out_bitsignaltemp;
    assign coalesced_delay_1_fifo_stall_out[0] = coalesced_delay_1_fifo_stall_out_bitsignaltemp;
    acl_data_fifo #(
        .DEPTH(356),
        .STRICT_DEPTH(0),
        .ALLOW_FULL_WRITE(0),
        .DATA_WIDTH(448),
        .IMPL("ram")
    ) thecoalesced_delay_1_fifo (
        .valid_in(coalesced_delay_1_fifo_valid_in_bitsignaltemp),
        .stall_in(coalesced_delay_1_fifo_stall_in_bitsignaltemp),
        .data_in(join_for_coalesced_delay_1_q),
        .valid_out(coalesced_delay_1_fifo_valid_out_bitsignaltemp),
        .stall_out(coalesced_delay_1_fifo_stall_out_bitsignaltemp),
        .data_out(coalesced_delay_1_fifo_data_out),
        .clock(clock),
        .resetn(resetn)
    );

    // join_for_coalesced_delay_0(BITJOIN,163)
    assign join_for_coalesced_delay_0_q = {bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_e, bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_k, bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_i};

    // coalesced_delay_0_fifo(STALLFIFO,171)
    assign coalesced_delay_0_fifo_valid_in = SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_V4;
    assign coalesced_delay_0_fifo_stall_in = SE_out_coalesced_delay_0_fifo_backStall;
    assign coalesced_delay_0_fifo_data_in = join_for_coalesced_delay_0_q;
    assign coalesced_delay_0_fifo_valid_in_bitsignaltemp = coalesced_delay_0_fifo_valid_in[0];
    assign coalesced_delay_0_fifo_stall_in_bitsignaltemp = coalesced_delay_0_fifo_stall_in[0];
    assign coalesced_delay_0_fifo_valid_out[0] = coalesced_delay_0_fifo_valid_out_bitsignaltemp;
    assign coalesced_delay_0_fifo_stall_out[0] = coalesced_delay_0_fifo_stall_out_bitsignaltemp;
    acl_data_fifo #(
        .DEPTH(225),
        .STRICT_DEPTH(0),
        .ALLOW_FULL_WRITE(0),
        .DATA_WIDTH(160),
        .IMPL("ram")
    ) thecoalesced_delay_0_fifo (
        .valid_in(coalesced_delay_0_fifo_valid_in_bitsignaltemp),
        .stall_in(coalesced_delay_0_fifo_stall_in_bitsignaltemp),
        .data_in(join_for_coalesced_delay_0_q),
        .valid_out(coalesced_delay_0_fifo_valid_out_bitsignaltemp),
        .stall_out(coalesced_delay_0_fifo_stall_out_bitsignaltemp),
        .data_out(coalesced_delay_0_fifo_data_out),
        .clock(clock),
        .resetn(resetn)
    );

    // i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x(BLACKBOX,96)@1
    // in in_stall_in@20000000
    // out out_stall_out@20000000
    k2_ZTS6c_calc_i_llvm_fpga_sync_buffer_s_0004uffer_k2_zts6c_calc0 thei_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x (
        .in_i_dependence(GND_q),
        .in_stall_in(SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x_backStall),
        .in_valid_in(SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_V2),
        .in_buffer_in_0_tpl(in_arg15_0_tpl),
        .out_stall_out(i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x_out_stall_out),
        .out_valid_out(i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x_out_valid_out),
        .out_buffer_out_0_tpl(i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x_out_buffer_out_0_tpl),
        .clock(clock),
        .resetn(resetn)
    );

    // i_llvm_fpga_sync_buffer_p1024f32_arg12_sync_buffer_k2_zts6c_calc15(BLACKBOX,24)@1
    // in in_stall_in@20000000
    // out out_stall_out@20000000
    k2_ZTS6c_calc_i_llvm_fpga_sync_buffer_p10001uffer_k2_zts6c_calc0 thei_llvm_fpga_sync_buffer_p1024f32_arg12_sync_buffer_k2_zts6c_calc15 (
        .in_buffer_in(in_arg12),
        .in_i_dependence(GND_q),
        .in_stall_in(SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x_backStall),
        .in_valid_in(SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_V0),
        .out_buffer_out(i_llvm_fpga_sync_buffer_p1024f32_arg12_sync_buffer_k2_zts6c_calc15_out_buffer_out),
        .out_stall_out(i_llvm_fpga_sync_buffer_p1024f32_arg12_sync_buffer_k2_zts6c_calc15_out_stall_out),
        .out_valid_out(i_llvm_fpga_sync_buffer_p1024f32_arg12_sync_buffer_k2_zts6c_calc15_out_valid_out),
        .clock(clock),
        .resetn(resetn)
    );

    // bubble_join_stall_entry(BITJOIN,194)
    assign bubble_join_stall_entry_q = {in_l_grpid_05, in_c0_exe828, in_c0_exe725, in_c0_exe620, in_c0_exe517, in_c0_exe412, in_c0_exe210, in_acl_hw_wg_id56, in_acl_global_id_149, in_acl_global_id_043, in_acl_0143_i507, in_acl_0142_i508, in_acl_0141_i509};

    // bubble_select_stall_entry(BITSELECT,195)
    assign bubble_select_stall_entry_b = $unsigned(bubble_join_stall_entry_q[31:0]);
    assign bubble_select_stall_entry_c = $unsigned(bubble_join_stall_entry_q[63:32]);
    assign bubble_select_stall_entry_d = $unsigned(bubble_join_stall_entry_q[95:64]);
    assign bubble_select_stall_entry_e = $unsigned(bubble_join_stall_entry_q[159:96]);
    assign bubble_select_stall_entry_f = $unsigned(bubble_join_stall_entry_q[223:160]);
    assign bubble_select_stall_entry_g = $unsigned(bubble_join_stall_entry_q[255:224]);
    assign bubble_select_stall_entry_h = $unsigned(bubble_join_stall_entry_q[287:256]);
    assign bubble_select_stall_entry_i = $unsigned(bubble_join_stall_entry_q[319:288]);
    assign bubble_select_stall_entry_j = $unsigned(bubble_join_stall_entry_q[383:320]);
    assign bubble_select_stall_entry_k = $unsigned(bubble_join_stall_entry_q[447:384]);
    assign bubble_select_stall_entry_l = $unsigned(bubble_join_stall_entry_q[511:448]);
    assign bubble_select_stall_entry_m = $unsigned(bubble_join_stall_entry_q[575:512]);
    assign bubble_select_stall_entry_n = $unsigned(bubble_join_stall_entry_q[607:576]);

    // SE_stall_entry(STALLENABLE,252)
    // Valid signal propagation
    assign SE_stall_entry_V0 = SE_stall_entry_wireValid;
    // Backward Stall generation
    assign SE_stall_entry_backStall = ZTS6c_calc_B4_merge_reg_aunroll_x_out_stall_out | ~ (SE_stall_entry_wireValid);
    // Computing multiple Valid(s)
    assign SE_stall_entry_wireValid = in_valid_in;

    // ZTS6c_calc_B4_merge_reg_aunroll_x(BLACKBOX,79)@0
    // in in_stall_in@20000000
    // out out_stall_out@20000000
    // out out_valid_out@1
    // out out_data_out_0_tpl@1
    // out out_data_out_1_tpl@1
    // out out_data_out_2_tpl@1
    // out out_data_out_3_tpl@1
    // out out_data_out_4_tpl@1
    // out out_data_out_5_tpl@1
    // out out_data_out_6_tpl@1
    // out out_data_out_7_tpl@1
    // out out_data_out_8_tpl@1
    // out out_data_out_9_tpl@1
    // out out_data_out_10_tpl@1
    // out out_data_out_11_tpl@1
    // out out_data_out_12_tpl@1
    k2_ZTS6c_calc_ZTS6c_calc_B4_merge_reg theZTS6c_calc_B4_merge_reg_aunroll_x (
        .in_stall_in(SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_backStall),
        .in_valid_in(SE_stall_entry_V0),
        .in_data_in_0_tpl(bubble_select_stall_entry_b),
        .in_data_in_1_tpl(bubble_select_stall_entry_c),
        .in_data_in_2_tpl(bubble_select_stall_entry_d),
        .in_data_in_3_tpl(bubble_select_stall_entry_n),
        .in_data_in_4_tpl(bubble_select_stall_entry_h),
        .in_data_in_5_tpl(bubble_select_stall_entry_i),
        .in_data_in_6_tpl(bubble_select_stall_entry_j),
        .in_data_in_7_tpl(bubble_select_stall_entry_k),
        .in_data_in_8_tpl(bubble_select_stall_entry_l),
        .in_data_in_9_tpl(bubble_select_stall_entry_m),
        .in_data_in_10_tpl(bubble_select_stall_entry_e),
        .in_data_in_11_tpl(bubble_select_stall_entry_f),
        .in_data_in_12_tpl(bubble_select_stall_entry_g),
        .out_stall_out(ZTS6c_calc_B4_merge_reg_aunroll_x_out_stall_out),
        .out_valid_out(ZTS6c_calc_B4_merge_reg_aunroll_x_out_valid_out),
        .out_data_out_0_tpl(ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_0_tpl),
        .out_data_out_1_tpl(ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_1_tpl),
        .out_data_out_2_tpl(ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_2_tpl),
        .out_data_out_3_tpl(ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_3_tpl),
        .out_data_out_4_tpl(ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_4_tpl),
        .out_data_out_5_tpl(ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_5_tpl),
        .out_data_out_6_tpl(ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_6_tpl),
        .out_data_out_7_tpl(ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_7_tpl),
        .out_data_out_8_tpl(ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_8_tpl),
        .out_data_out_9_tpl(ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_9_tpl),
        .out_data_out_10_tpl(ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_10_tpl),
        .out_data_out_11_tpl(ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_11_tpl),
        .out_data_out_12_tpl(ZTS6c_calc_B4_merge_reg_aunroll_x_out_data_out_12_tpl),
        .clock(clock),
        .resetn(resetn)
    );

    // SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x(STALLENABLE,255)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg0 <= '0;
            SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg1 <= '0;
            SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg2 <= '0;
            SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg3 <= '0;
            SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg4 <= '0;
            SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg5 <= '0;
            SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg6 <= '0;
            SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg7 <= '0;
        end
        else
        begin
            // Successor 0
            SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg0 <= SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_toReg0;
            // Successor 1
            SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg1 <= SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_toReg1;
            // Successor 2
            SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg2 <= SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_toReg2;
            // Successor 3
            SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg3 <= SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_toReg3;
            // Successor 4
            SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg4 <= SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_toReg4;
            // Successor 5
            SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg5 <= SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_toReg5;
            // Successor 6
            SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg6 <= SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_toReg6;
            // Successor 7
            SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg7 <= SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_toReg7;
        end
    end
    // Input Stall processing
    assign SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_consumed0 = (~ (i_llvm_fpga_sync_buffer_p1024f32_arg12_sync_buffer_k2_zts6c_calc15_out_stall_out) & SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_wireValid) | SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg0;
    assign SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_consumed1 = (~ (i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k2_zts6c_calc4_out_stall_out) & SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_wireValid) | SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg1;
    assign SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_consumed2 = (~ (i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x_out_stall_out) & SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_wireValid) | SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg2;
    assign SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_consumed3 = (~ (i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x_out_stall_out) & SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_wireValid) | SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg3;
    assign SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_consumed4 = (~ (coalesced_delay_0_fifo_stall_out) & SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_wireValid) | SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg4;
    assign SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_consumed5 = (~ (coalesced_delay_1_fifo_stall_out) & SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_wireValid) | SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg5;
    assign SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_consumed6 = (~ (SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x_backStall) & SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_wireValid) | SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg6;
    assign SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_consumed7 = (~ (SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg15_sync_buffer_k2_zts6c_calc13_aunroll_x_backStall) & SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_wireValid) | SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg7;
    // Consuming
    assign SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_StallValid = SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_backStall & SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_wireValid;
    assign SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_toReg0 = SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_StallValid & SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_consumed0;
    assign SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_toReg1 = SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_StallValid & SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_consumed1;
    assign SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_toReg2 = SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_StallValid & SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_consumed2;
    assign SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_toReg3 = SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_StallValid & SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_consumed3;
    assign SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_toReg4 = SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_StallValid & SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_consumed4;
    assign SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_toReg5 = SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_StallValid & SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_consumed5;
    assign SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_toReg6 = SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_StallValid & SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_consumed6;
    assign SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_toReg7 = SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_StallValid & SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_consumed7;
    // Backward Stall generation
    assign SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_or0 = SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_consumed0;
    assign SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_or1 = SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_consumed1 & SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_or0;
    assign SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_or2 = SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_consumed2 & SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_or1;
    assign SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_or3 = SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_consumed3 & SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_or2;
    assign SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_or4 = SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_consumed4 & SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_or3;
    assign SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_or5 = SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_consumed5 & SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_or4;
    assign SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_or6 = SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_consumed6 & SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_or5;
    assign SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_wireStall = ~ (SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_consumed7 & SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_or6);
    assign SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_backStall = SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_wireStall;
    // Valid signal propagation
    assign SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_V0 = SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_wireValid & ~ (SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg0);
    assign SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_V1 = SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_wireValid & ~ (SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg1);
    assign SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_V2 = SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_wireValid & ~ (SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg2);
    assign SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_V3 = SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_wireValid & ~ (SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg3);
    assign SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_V4 = SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_wireValid & ~ (SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg4);
    assign SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_V5 = SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_wireValid & ~ (SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg5);
    assign SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_V6 = SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_wireValid & ~ (SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg6);
    assign SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_V7 = SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_wireValid & ~ (SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_fromReg7);
    // Computing multiple Valid(s)
    assign SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_wireValid = ZTS6c_calc_B4_merge_reg_aunroll_x_out_valid_out;

    // i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k2_zts6c_calc4(BLACKBOX,28)@1
    // in in_stall_in@20000000
    // out out_stall_out@20000000
    k2_ZTS6c_calc_i_llvm_fpga_sync_buffer_p10002uffer_k2_zts6c_calc0 thei_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k2_zts6c_calc4 (
        .in_buffer_in(in_arg4),
        .in_i_dependence(GND_q),
        .in_stall_in(SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x_backStall),
        .in_valid_in(SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_V1),
        .out_buffer_out(i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k2_zts6c_calc4_out_buffer_out),
        .out_stall_out(i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k2_zts6c_calc4_out_stall_out),
        .out_valid_out(i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k2_zts6c_calc4_out_valid_out),
        .clock(clock),
        .resetn(resetn)
    );

    // i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x(BLACKBOX,97)@1
    // in in_stall_in@20000000
    // out out_stall_out@20000000
    k2_ZTS6c_calc_i_llvm_fpga_sync_buffer_s_0005uffer_k2_zts6c_calc0 thei_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x (
        .in_i_dependence(GND_q),
        .in_stall_in(SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x_backStall),
        .in_valid_in(SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_V3),
        .in_buffer_in_0_tpl(in_arg7_0_tpl),
        .out_stall_out(i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x_out_stall_out),
        .out_valid_out(i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x_out_valid_out),
        .out_buffer_out_0_tpl(i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x_out_buffer_out_0_tpl),
        .clock(clock),
        .resetn(resetn)
    );

    // SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x(STALLENABLE,262)
    // Valid signal propagation
    assign SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x_V0 = SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x_wireValid;
    // Backward Stall generation
    assign SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x_backStall = i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_out_o_stall | ~ (SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x_wireValid);
    // Computing multiple Valid(s)
    assign SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x_and0 = i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x_out_valid_out;
    assign SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x_and1 = i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k2_zts6c_calc4_out_valid_out & SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x_and0;
    assign SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x_wireValid = SE_out_ZTS6c_calc_B4_merge_reg_aunroll_x_V6 & SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x_and1;

    // SE_out_i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7(STALLENABLE,229)
    // Valid signal propagation
    assign SE_out_i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_V0 = SE_out_i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_wireValid;
    // Backward Stall generation
    assign SE_out_i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_backStall = i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10_out_o_stall | ~ (SE_out_i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_wireValid);
    // Computing multiple Valid(s)
    assign SE_out_i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_and0 = i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_out_o_valid;
    assign SE_out_i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_wireValid = SE_out_coalesced_delay_0_fifo_V0 & SE_out_i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_and0;

    // GND(CONSTANT,0)
    assign GND_q = $unsigned(1'b0);

    // i_unnamed_k2_zts6c_calc0(ADD,32)@1
    assign i_unnamed_k2_zts6c_calc0_a = {1'b0, bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_g};
    assign i_unnamed_k2_zts6c_calc0_b = {1'b0, bubble_select_ZTS6c_calc_B4_merge_reg_aunroll_x_c};
    assign i_unnamed_k2_zts6c_calc0_o = $unsigned(i_unnamed_k2_zts6c_calc0_a) + $unsigned(i_unnamed_k2_zts6c_calc0_b);
    assign i_unnamed_k2_zts6c_calc0_q = i_unnamed_k2_zts6c_calc0_o[32:0];

    // bgTrunc_i_unnamed_k2_zts6c_calc0_sel_x(BITSELECT,80)@1
    assign bgTrunc_i_unnamed_k2_zts6c_calc0_sel_x_b = i_unnamed_k2_zts6c_calc0_q[31:0];

    // i_unnamed_k2_zts6c_calc1_sel_x(BITSELECT,98)@1
    assign i_unnamed_k2_zts6c_calc1_sel_x_b = $unsigned({{32{bgTrunc_i_unnamed_k2_zts6c_calc0_sel_x_b[31]}}, bgTrunc_i_unnamed_k2_zts6c_calc0_sel_x_b[31:0]});

    // dupName_6_i_unnamed_k2_zts6c_calc0_narrow_x(BITSELECT,110)@1
    assign dupName_6_i_unnamed_k2_zts6c_calc0_narrow_x_b = i_unnamed_k2_zts6c_calc1_sel_x_b[61:0];

    // dupName_6_i_unnamed_k2_zts6c_calc0_shift_join_x(BITJOIN,111)@1
    assign dupName_6_i_unnamed_k2_zts6c_calc0_shift_join_x_q = {dupName_6_i_unnamed_k2_zts6c_calc0_narrow_x_b, i_unnamed_k2_zts6c_calc16_vt_const_1_q};

    // bubble_join_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x(BITJOIN,208)
    assign bubble_join_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x_q = i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x_out_buffer_out_0_tpl;

    // bubble_select_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x(BITSELECT,209)
    assign bubble_select_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x_b = $unsigned(bubble_join_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x_q[63:0]);

    // dupName_5_i_unnamed_k2_zts6c_calc0_narrow_x(BITSELECT,104)@1
    assign dupName_5_i_unnamed_k2_zts6c_calc0_narrow_x_b = bubble_select_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x_b[61:0];

    // dupName_5_i_unnamed_k2_zts6c_calc0_shift_join_x(BITJOIN,105)@1
    assign dupName_5_i_unnamed_k2_zts6c_calc0_shift_join_x_q = {dupName_5_i_unnamed_k2_zts6c_calc0_narrow_x_b, i_unnamed_k2_zts6c_calc16_vt_const_1_q};

    // bubble_join_i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k2_zts6c_calc4(BITJOIN,191)
    assign bubble_join_i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k2_zts6c_calc4_q = i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k2_zts6c_calc4_out_buffer_out;

    // bubble_select_i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k2_zts6c_calc4(BITSELECT,192)
    assign bubble_select_i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k2_zts6c_calc4_b = $unsigned(bubble_join_i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k2_zts6c_calc4_q[63:0]);

    // i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k2_zts6c_calc4_vt_select_63(BITSELECT,31)@1
    assign i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k2_zts6c_calc4_vt_select_63_b = bubble_select_i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k2_zts6c_calc4_b[63:10];

    // i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k2_zts6c_calc4_vt_join(BITJOIN,30)@1
    assign i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k2_zts6c_calc4_vt_join_q = {i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k2_zts6c_calc4_vt_select_63_b, i_llvm_fpga_sync_buffer_p1024f32_arg12_sync_buffer_k2_zts6c_calc15_vt_const_9_q};

    // dupName_5_i_unnamed_k2_zts6c_calc0_add_x(ADD,102)@1
    assign dupName_5_i_unnamed_k2_zts6c_calc0_add_x_a = {1'b0, i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k2_zts6c_calc4_vt_join_q};
    assign dupName_5_i_unnamed_k2_zts6c_calc0_add_x_b = {1'b0, dupName_5_i_unnamed_k2_zts6c_calc0_shift_join_x_q};
    assign dupName_5_i_unnamed_k2_zts6c_calc0_add_x_o = $unsigned(dupName_5_i_unnamed_k2_zts6c_calc0_add_x_a) + $unsigned(dupName_5_i_unnamed_k2_zts6c_calc0_add_x_b);
    assign dupName_5_i_unnamed_k2_zts6c_calc0_add_x_q = dupName_5_i_unnamed_k2_zts6c_calc0_add_x_o[64:0];

    // dupName_5_i_unnamed_k2_zts6c_calc0_dupName_0_trunc_sel_x(BITSELECT,107)@1
    assign dupName_5_i_unnamed_k2_zts6c_calc0_dupName_0_trunc_sel_x_b = dupName_5_i_unnamed_k2_zts6c_calc0_add_x_q[63:0];

    // i_unnamed_k2_zts6c_calc5_vt_select_63(BITSELECT,46)@1
    assign i_unnamed_k2_zts6c_calc5_vt_select_63_b = dupName_5_i_unnamed_k2_zts6c_calc0_dupName_0_trunc_sel_x_b[63:2];

    // i_unnamed_k2_zts6c_calc5_vt_join(BITJOIN,45)@1
    assign i_unnamed_k2_zts6c_calc5_vt_join_q = {i_unnamed_k2_zts6c_calc5_vt_select_63_b, i_unnamed_k2_zts6c_calc16_vt_const_1_q};

    // dupName_6_i_unnamed_k2_zts6c_calc0_add_x(ADD,108)@1
    assign dupName_6_i_unnamed_k2_zts6c_calc0_add_x_a = {1'b0, i_unnamed_k2_zts6c_calc5_vt_join_q};
    assign dupName_6_i_unnamed_k2_zts6c_calc0_add_x_b = {1'b0, dupName_6_i_unnamed_k2_zts6c_calc0_shift_join_x_q};
    assign dupName_6_i_unnamed_k2_zts6c_calc0_add_x_o = $unsigned(dupName_6_i_unnamed_k2_zts6c_calc0_add_x_a) + $unsigned(dupName_6_i_unnamed_k2_zts6c_calc0_add_x_b);
    assign dupName_6_i_unnamed_k2_zts6c_calc0_add_x_q = dupName_6_i_unnamed_k2_zts6c_calc0_add_x_o[64:0];

    // dupName_6_i_unnamed_k2_zts6c_calc0_dupName_0_trunc_sel_x(BITSELECT,113)@1
    assign dupName_6_i_unnamed_k2_zts6c_calc0_dupName_0_trunc_sel_x_b = dupName_6_i_unnamed_k2_zts6c_calc0_add_x_q[63:0];

    // i_unnamed_k2_zts6c_calc6_vt_select_63(BITSELECT,49)@1
    assign i_unnamed_k2_zts6c_calc6_vt_select_63_b = dupName_6_i_unnamed_k2_zts6c_calc0_dupName_0_trunc_sel_x_b[63:2];

    // i_unnamed_k2_zts6c_calc6_vt_join(BITJOIN,48)@1
    assign i_unnamed_k2_zts6c_calc6_vt_join_q = {i_unnamed_k2_zts6c_calc6_vt_select_63_b, i_unnamed_k2_zts6c_calc16_vt_const_1_q};

    // i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7(BLACKBOX,21)@1
    // in in_i_stall@20000000
    // out out_o_readdata@225
    // out out_o_stall@20000000
    // out out_o_valid@225
    // out out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_address@20000000
    // out out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_burstcount@20000000
    // out out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_byteenable@20000000
    // out out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_enable@20000000
    // out out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_read@20000000
    // out out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_write@20000000
    // out out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_writedata@20000000
    k2_ZTS6c_calc_i_llvm_fpga_mem_unnamed_k20000alc13_k2_zts6c_calc0 thei_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7 (
        .in_flush(in_flush),
        .in_i_address(i_unnamed_k2_zts6c_calc6_vt_join_q),
        .in_i_predicate(GND_q),
        .in_i_stall(SE_out_i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_backStall),
        .in_i_valid(SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k2_zts6c_calc2_aunroll_x_V0),
        .in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_readdata(in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_readdata),
        .in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_readdatavalid(in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_readdatavalid),
        .in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_waitrequest(in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_waitrequest),
        .in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_writeack(in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_writeack),
        .out_o_readdata(i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_out_o_readdata),
        .out_o_stall(i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_out_o_stall),
        .out_o_valid(i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_out_o_valid),
        .out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_address(i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_address),
        .out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_burstcount(i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_burstcount),
        .out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_byteenable(i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_byteenable),
        .out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_enable(i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_enable),
        .out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_read(i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_read),
        .out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_write(i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_write),
        .out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_writedata(i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_writedata),
        .clock(clock),
        .resetn(resetn)
    );

    // ext_sig_sync_out(GPOUT,9)
    assign out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_address = i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_address;
    assign out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_enable = i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_enable;
    assign out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_read = i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_read;
    assign out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_write = i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_write;
    assign out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_writedata = i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_writedata;
    assign out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_byteenable = i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_byteenable;
    assign out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_burstcount = i_llvm_fpga_mem_unnamed_k2_zts6c_calc13_k2_zts6c_calc7_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_burstcount;

    // sync_out(GPOUT,77)@0
    assign out_stall_out = SE_stall_entry_backStall;

    // dupName_0_ext_sig_sync_out_x(GPOUT,83)
    assign out_memdep_34_k2_ZTS6c_calc_avm_address = i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10_out_memdep_34_k2_ZTS6c_calc_avm_address;
    assign out_memdep_34_k2_ZTS6c_calc_avm_enable = i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10_out_memdep_34_k2_ZTS6c_calc_avm_enable;
    assign out_memdep_34_k2_ZTS6c_calc_avm_read = i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10_out_memdep_34_k2_ZTS6c_calc_avm_read;
    assign out_memdep_34_k2_ZTS6c_calc_avm_write = i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10_out_memdep_34_k2_ZTS6c_calc_avm_write;
    assign out_memdep_34_k2_ZTS6c_calc_avm_writedata = i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10_out_memdep_34_k2_ZTS6c_calc_avm_writedata;
    assign out_memdep_34_k2_ZTS6c_calc_avm_byteenable = i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10_out_memdep_34_k2_ZTS6c_calc_avm_byteenable;
    assign out_memdep_34_k2_ZTS6c_calc_avm_burstcount = i_llvm_fpga_mem_memdep_34_k2_zts6c_calc10_out_memdep_34_k2_ZTS6c_calc_avm_burstcount;

    // bubble_join_coalesced_delay_2_fifo(BITJOIN,217)
    assign bubble_join_coalesced_delay_2_fifo_q = coalesced_delay_2_fifo_data_out;

    // bubble_select_coalesced_delay_2_fifo(BITSELECT,218)
    assign bubble_select_coalesced_delay_2_fifo_b = $unsigned(bubble_join_coalesced_delay_2_fifo_q[223:0]);

    // sel_for_coalesced_delay_2(BITSELECT,170)
    assign sel_for_coalesced_delay_2_b = $unsigned(bubble_select_coalesced_delay_2_fifo_b[63:0]);
    assign sel_for_coalesced_delay_2_c = $unsigned(bubble_select_coalesced_delay_2_fifo_b[127:64]);
    assign sel_for_coalesced_delay_2_d = $unsigned(bubble_select_coalesced_delay_2_fifo_b[191:128]);
    assign sel_for_coalesced_delay_2_e = $unsigned(bubble_select_coalesced_delay_2_fifo_b[223:192]);

    // bubble_join_coalesced_delay_1_fifo(BITJOIN,214)
    assign bubble_join_coalesced_delay_1_fifo_q = coalesced_delay_1_fifo_data_out;

    // bubble_select_coalesced_delay_1_fifo(BITSELECT,215)
    assign bubble_select_coalesced_delay_1_fifo_b = $unsigned(bubble_join_coalesced_delay_1_fifo_q[447:0]);

    // sel_for_coalesced_delay_1(BITSELECT,167)
    assign sel_for_coalesced_delay_1_b = $unsigned(bubble_select_coalesced_delay_1_fifo_b[63:0]);
    assign sel_for_coalesced_delay_1_c = $unsigned(bubble_select_coalesced_delay_1_fifo_b[127:64]);
    assign sel_for_coalesced_delay_1_d = $unsigned(bubble_select_coalesced_delay_1_fifo_b[191:128]);
    assign sel_for_coalesced_delay_1_e = $unsigned(bubble_select_coalesced_delay_1_fifo_b[255:192]);
    assign sel_for_coalesced_delay_1_f = $unsigned(bubble_select_coalesced_delay_1_fifo_b[287:256]);
    assign sel_for_coalesced_delay_1_g = $unsigned(bubble_select_coalesced_delay_1_fifo_b[319:288]);
    assign sel_for_coalesced_delay_1_h = $unsigned(bubble_select_coalesced_delay_1_fifo_b[351:320]);
    assign sel_for_coalesced_delay_1_i = $unsigned(bubble_select_coalesced_delay_1_fifo_b[383:352]);
    assign sel_for_coalesced_delay_1_j = $unsigned(bubble_select_coalesced_delay_1_fifo_b[415:384]);
    assign sel_for_coalesced_delay_1_k = $unsigned(bubble_select_coalesced_delay_1_fifo_b[447:416]);

    // dupName_0_sync_out_x(GPOUT,85)@356
    assign out_acl_0141_i509 = sel_for_coalesced_delay_1_f;
    assign out_acl_0142_i508 = sel_for_coalesced_delay_1_g;
    assign out_acl_0143_i507 = sel_for_coalesced_delay_1_h;
    assign out_acl_global_id_043 = sel_for_coalesced_delay_1_d;
    assign out_acl_global_id_149 = sel_for_coalesced_delay_1_e;
    assign out_acl_hw_wg_id56 = sel_for_coalesced_delay_1_k;
    assign out_c0_exe210 = sel_for_coalesced_delay_1_i;
    assign out_c0_exe412 = sel_for_coalesced_delay_1_j;
    assign out_c0_exe517 = sel_for_coalesced_delay_1_b;
    assign out_c0_exe620 = sel_for_coalesced_delay_2_b;
    assign out_c0_exe725 = sel_for_coalesced_delay_1_c;
    assign out_c0_exe828 = sel_for_coalesced_delay_2_c;
    assign out_l_grpid_05 = sel_for_coalesced_delay_2_e;
    assign out_l_grpid_0_ext_offset = sel_for_coalesced_delay_2_d;
    assign out_valid_out = SE_out_coalesced_delay_2_fifo_V0;

    // dupName_1_ext_sig_sync_out_x(GPOUT,87)
    assign out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_address = i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_address;
    assign out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_enable = i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_enable;
    assign out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_read = i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_read;
    assign out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_write = i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_write;
    assign out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_writedata = i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_writedata;
    assign out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_byteenable = i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_byteenable;
    assign out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_burstcount = i_llvm_fpga_mem_unnamed_k2_zts6c_calc17_k2_zts6c_calc18_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_burstcount;

    // dupName_2_ext_sig_sync_out_x(GPOUT,89)
    assign out_memdep_k2_ZTS6c_calc_avm_address = i_llvm_fpga_mem_memdep_k2_zts6c_calc19_out_memdep_k2_ZTS6c_calc_avm_address;
    assign out_memdep_k2_ZTS6c_calc_avm_enable = i_llvm_fpga_mem_memdep_k2_zts6c_calc19_out_memdep_k2_ZTS6c_calc_avm_enable;
    assign out_memdep_k2_ZTS6c_calc_avm_read = i_llvm_fpga_mem_memdep_k2_zts6c_calc19_out_memdep_k2_ZTS6c_calc_avm_read;
    assign out_memdep_k2_ZTS6c_calc_avm_write = i_llvm_fpga_mem_memdep_k2_zts6c_calc19_out_memdep_k2_ZTS6c_calc_avm_write;
    assign out_memdep_k2_ZTS6c_calc_avm_writedata = i_llvm_fpga_mem_memdep_k2_zts6c_calc19_out_memdep_k2_ZTS6c_calc_avm_writedata;
    assign out_memdep_k2_ZTS6c_calc_avm_byteenable = i_llvm_fpga_mem_memdep_k2_zts6c_calc19_out_memdep_k2_ZTS6c_calc_avm_byteenable;
    assign out_memdep_k2_ZTS6c_calc_avm_burstcount = i_llvm_fpga_mem_memdep_k2_zts6c_calc19_out_memdep_k2_ZTS6c_calc_avm_burstcount;

endmodule
