// ------------------------------------------------------------------------- 
// High Level Design Compiler for Intel(R) FPGAs Version 20.3 (Release Build #121)
// 
// Legal Notice: Copyright 2020 Intel Corporation.  All rights reserved.
// Your use of  Intel Corporation's design tools,  logic functions and other
// software and  tools, and its AMPP partner logic functions, and any output
// files any  of the foregoing (including  device programming  or simulation
// files), and  any associated  documentation  or information  are expressly
// subject  to the terms and  conditions of the  Intel FPGA Software License
// Agreement, Intel MegaCore Function License Agreement, or other applicable
// license agreement,  including,  without limitation,  that your use is for
// the  sole  purpose of  programming  logic devices  manufactured by  Intel
// and  sold by Intel  or its authorized  distributors. Please refer  to the
// applicable agreement for further details.
// ---------------------------------------------------------------------------

// SystemVerilog created from k2_ZTS6c_calc_bb_ZTS6c_calc_B5_stall_region
// SystemVerilog created on Thu Nov  5 06:32:57 2020


(* altera_attribute = "-name AUTO_SHIFT_REGISTER_RECOGNITION OFF; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 10037; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 15400; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 12020; -name MESSAGE_DISABLE 12030; -name MESSAGE_DISABLE 12010; -name MESSAGE_DISABLE 12110; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 13410; -name MESSAGE_DISABLE 113007; -name MESSAGE_DISABLE 10958" *)
module k2_ZTS6c_calc_bb_ZTS6c_calc_B5_stall_region (
    input wire [31:0] in_barrier_unnamed_k2_ZTS6c_calc22_wgs_workgroup_size,
    input wire [0:0] in_stall_in,
    output wire [0:0] out_stall_out,
    input wire [31:0] in_acl_0141_i50932,
    input wire [31:0] in_acl_0142_i50834,
    input wire [63:0] in_acl_global_id_041,
    input wire [63:0] in_acl_global_id_147,
    input wire [31:0] in_acl_hw_wg_id54,
    input wire [31:0] in_c0_exe15437,
    input wire [31:0] in_c0_exe28,
    input wire [31:0] in_c0_exe413,
    input wire [63:0] in_c0_exe518,
    input wire [63:0] in_c0_exe621,
    input wire [63:0] in_c0_exe726,
    input wire [63:0] in_c0_exe829,
    input wire [31:0] in_l_grpid_03,
    input wire [0:0] in_valid_in,
    output wire [63:0] out_acl_global_id_041,
    output wire [63:0] out_acl_global_id_147,
    output wire [31:0] out_acl_hw_wg_id54,
    output wire [31:0] out_c0_exe15437,
    output wire [31:0] out_c0_exe28,
    output wire [31:0] out_c0_exe413,
    output wire [63:0] out_c0_exe518,
    output wire [63:0] out_c0_exe621,
    output wire [63:0] out_c0_exe726,
    output wire [63:0] out_c0_exe829,
    output wire [31:0] out_l_grpid_03,
    output wire [31:0] out_unnamed_k2_ZTS6c_calc19,
    output wire [31:0] out_unnamed_k2_ZTS6c_calc20,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc21,
    output wire [0:0] out_valid_out,
    input wire clock,
    input wire resetn
    );

    wire [0:0] GND_q;
    wire [31:0] c_i32_166_q;
    wire [31:0] c_i32_20487_q;
    wire [0:0] i_llvm_fpga_simple_barrier_unnamed_k2_zts6c_calc22_k2_zts6c_calc0_out_stall_entry;
    wire [0:0] i_llvm_fpga_simple_barrier_unnamed_k2_zts6c_calc22_k2_zts6c_calc0_out_valid_exit;
    wire [32:0] i_unnamed_k2_zts6c_calc1_a;
    wire [32:0] i_unnamed_k2_zts6c_calc1_b;
    logic [32:0] i_unnamed_k2_zts6c_calc1_o;
    wire [32:0] i_unnamed_k2_zts6c_calc1_q;
    wire [32:0] i_unnamed_k2_zts6c_calc2_a;
    wire [32:0] i_unnamed_k2_zts6c_calc2_b;
    logic [32:0] i_unnamed_k2_zts6c_calc2_o;
    wire [32:0] i_unnamed_k2_zts6c_calc2_q;
    wire [33:0] i_unnamed_k2_zts6c_calc3_a;
    wire [33:0] i_unnamed_k2_zts6c_calc3_b;
    logic [33:0] i_unnamed_k2_zts6c_calc3_o;
    wire [0:0] i_unnamed_k2_zts6c_calc3_c;
    wire [31:0] bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b;
    wire [31:0] bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b;
    wire [543:0] join_for_coalesced_delay_0_q;
    wire [63:0] sel_for_coalesced_delay_0_b;
    wire [63:0] sel_for_coalesced_delay_0_c;
    wire [63:0] sel_for_coalesced_delay_0_d;
    wire [63:0] sel_for_coalesced_delay_0_e;
    wire [63:0] sel_for_coalesced_delay_0_f;
    wire [63:0] sel_for_coalesced_delay_0_g;
    wire [31:0] sel_for_coalesced_delay_0_h;
    wire [31:0] sel_for_coalesced_delay_0_i;
    wire [31:0] sel_for_coalesced_delay_0_j;
    wire [31:0] sel_for_coalesced_delay_0_k;
    wire [31:0] sel_for_coalesced_delay_0_l;
    wire [0:0] redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo_valid_in;
    wire redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo_valid_in_bitsignaltemp;
    wire [0:0] redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo_stall_in;
    wire redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo_stall_in_bitsignaltemp;
    wire [31:0] redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo_data_in;
    wire [0:0] redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo_valid_out;
    wire redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo_valid_out_bitsignaltemp;
    wire [0:0] redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo_stall_out;
    wire redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo_stall_out_bitsignaltemp;
    wire [31:0] redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo_data_out;
    wire [0:0] redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_valid_in;
    wire redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_valid_in_bitsignaltemp;
    wire [0:0] redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_stall_in;
    wire redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_stall_in_bitsignaltemp;
    wire [31:0] redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_data_in;
    wire [0:0] redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_valid_out;
    wire redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_valid_out_bitsignaltemp;
    wire [0:0] redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_stall_out;
    wire redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_stall_out_bitsignaltemp;
    wire [31:0] redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_data_out;
    wire [0:0] coalesced_delay_0_fifo_valid_in;
    wire coalesced_delay_0_fifo_valid_in_bitsignaltemp;
    wire [0:0] coalesced_delay_0_fifo_stall_in;
    wire coalesced_delay_0_fifo_stall_in_bitsignaltemp;
    wire [543:0] coalesced_delay_0_fifo_data_in;
    wire [0:0] coalesced_delay_0_fifo_valid_out;
    wire coalesced_delay_0_fifo_valid_out_bitsignaltemp;
    wire [0:0] coalesced_delay_0_fifo_stall_out;
    wire coalesced_delay_0_fifo_stall_out_bitsignaltemp;
    wire [543:0] coalesced_delay_0_fifo_data_out;
    wire [607:0] bubble_join_stall_entry_q;
    wire [31:0] bubble_select_stall_entry_b;
    wire [31:0] bubble_select_stall_entry_c;
    wire [63:0] bubble_select_stall_entry_d;
    wire [63:0] bubble_select_stall_entry_e;
    wire [31:0] bubble_select_stall_entry_f;
    wire [31:0] bubble_select_stall_entry_g;
    wire [31:0] bubble_select_stall_entry_h;
    wire [31:0] bubble_select_stall_entry_i;
    wire [63:0] bubble_select_stall_entry_j;
    wire [63:0] bubble_select_stall_entry_k;
    wire [63:0] bubble_select_stall_entry_l;
    wire [63:0] bubble_select_stall_entry_m;
    wire [31:0] bubble_select_stall_entry_n;
    wire [31:0] bubble_join_redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo_q;
    wire [31:0] bubble_select_redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo_b;
    wire [31:0] bubble_join_redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_q;
    wire [31:0] bubble_select_redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_b;
    wire [543:0] bubble_join_coalesced_delay_0_fifo_q;
    wire [543:0] bubble_select_coalesced_delay_0_fifo_b;
    wire [0:0] SE_stall_entry_wireValid;
    wire [0:0] SE_stall_entry_wireStall;
    wire [0:0] SE_stall_entry_StallValid;
    wire [0:0] SE_stall_entry_toReg0;
    reg [0:0] SE_stall_entry_fromReg0;
    wire [0:0] SE_stall_entry_consumed0;
    wire [0:0] SE_stall_entry_toReg1;
    reg [0:0] SE_stall_entry_fromReg1;
    wire [0:0] SE_stall_entry_consumed1;
    wire [0:0] SE_stall_entry_toReg2;
    reg [0:0] SE_stall_entry_fromReg2;
    wire [0:0] SE_stall_entry_consumed2;
    wire [0:0] SE_stall_entry_toReg3;
    reg [0:0] SE_stall_entry_fromReg3;
    wire [0:0] SE_stall_entry_consumed3;
    wire [0:0] SE_stall_entry_or0;
    wire [0:0] SE_stall_entry_or1;
    wire [0:0] SE_stall_entry_or2;
    wire [0:0] SE_stall_entry_backStall;
    wire [0:0] SE_stall_entry_V0;
    wire [0:0] SE_stall_entry_V1;
    wire [0:0] SE_stall_entry_V2;
    wire [0:0] SE_stall_entry_V3;
    wire [0:0] SE_out_coalesced_delay_0_fifo_wireValid;
    wire [0:0] SE_out_coalesced_delay_0_fifo_and0;
    wire [0:0] SE_out_coalesced_delay_0_fifo_and1;
    wire [0:0] SE_out_coalesced_delay_0_fifo_and2;
    wire [0:0] SE_out_coalesced_delay_0_fifo_backStall;
    wire [0:0] SE_out_coalesced_delay_0_fifo_V0;


    // c_i32_166(CONSTANT,5)
    assign c_i32_166_q = $unsigned(32'b00000000000000000000000000010000);

    // bubble_join_stall_entry(BITJOIN,49)
    assign bubble_join_stall_entry_q = {in_l_grpid_03, in_c0_exe829, in_c0_exe726, in_c0_exe621, in_c0_exe518, in_c0_exe413, in_c0_exe28, in_c0_exe15437, in_acl_hw_wg_id54, in_acl_global_id_147, in_acl_global_id_041, in_acl_0142_i50834, in_acl_0141_i50932};

    // bubble_select_stall_entry(BITSELECT,50)
    assign bubble_select_stall_entry_b = $unsigned(bubble_join_stall_entry_q[31:0]);
    assign bubble_select_stall_entry_c = $unsigned(bubble_join_stall_entry_q[63:32]);
    assign bubble_select_stall_entry_d = $unsigned(bubble_join_stall_entry_q[127:64]);
    assign bubble_select_stall_entry_e = $unsigned(bubble_join_stall_entry_q[191:128]);
    assign bubble_select_stall_entry_f = $unsigned(bubble_join_stall_entry_q[223:192]);
    assign bubble_select_stall_entry_g = $unsigned(bubble_join_stall_entry_q[255:224]);
    assign bubble_select_stall_entry_h = $unsigned(bubble_join_stall_entry_q[287:256]);
    assign bubble_select_stall_entry_i = $unsigned(bubble_join_stall_entry_q[319:288]);
    assign bubble_select_stall_entry_j = $unsigned(bubble_join_stall_entry_q[383:320]);
    assign bubble_select_stall_entry_k = $unsigned(bubble_join_stall_entry_q[447:384]);
    assign bubble_select_stall_entry_l = $unsigned(bubble_join_stall_entry_q[511:448]);
    assign bubble_select_stall_entry_m = $unsigned(bubble_join_stall_entry_q[575:512]);
    assign bubble_select_stall_entry_n = $unsigned(bubble_join_stall_entry_q[607:576]);

    // i_unnamed_k2_zts6c_calc1(ADD,11)@0
    assign i_unnamed_k2_zts6c_calc1_a = {1'b0, bubble_select_stall_entry_c};
    assign i_unnamed_k2_zts6c_calc1_b = {1'b0, c_i32_166_q};
    assign i_unnamed_k2_zts6c_calc1_o = $unsigned(i_unnamed_k2_zts6c_calc1_a) + $unsigned(i_unnamed_k2_zts6c_calc1_b);
    assign i_unnamed_k2_zts6c_calc1_q = i_unnamed_k2_zts6c_calc1_o[32:0];

    // bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x(BITSELECT,23)@0
    assign bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b = i_unnamed_k2_zts6c_calc1_q[31:0];

    // SE_out_coalesced_delay_0_fifo(STALLENABLE,77)
    // Valid signal propagation
    assign SE_out_coalesced_delay_0_fifo_V0 = SE_out_coalesced_delay_0_fifo_wireValid;
    // Backward Stall generation
    assign SE_out_coalesced_delay_0_fifo_backStall = in_stall_in | ~ (SE_out_coalesced_delay_0_fifo_wireValid);
    // Computing multiple Valid(s)
    assign SE_out_coalesced_delay_0_fifo_and0 = coalesced_delay_0_fifo_valid_out;
    assign SE_out_coalesced_delay_0_fifo_and1 = redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_valid_out & SE_out_coalesced_delay_0_fifo_and0;
    assign SE_out_coalesced_delay_0_fifo_and2 = redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo_valid_out & SE_out_coalesced_delay_0_fifo_and1;
    assign SE_out_coalesced_delay_0_fifo_wireValid = i_llvm_fpga_simple_barrier_unnamed_k2_zts6c_calc22_k2_zts6c_calc0_out_valid_exit & SE_out_coalesced_delay_0_fifo_and2;

    // redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo(STALLFIFO,45)
    assign redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_valid_in = SE_stall_entry_V3;
    assign redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_stall_in = SE_out_coalesced_delay_0_fifo_backStall;
    assign redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_data_in = bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b;
    assign redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_valid_in_bitsignaltemp = redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_valid_in[0];
    assign redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_stall_in_bitsignaltemp = redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_stall_in[0];
    assign redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_valid_out[0] = redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_valid_out_bitsignaltemp;
    assign redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_stall_out[0] = redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_stall_out_bitsignaltemp;
    acl_data_fifo #(
        .DEPTH(131),
        .STRICT_DEPTH(0),
        .ALLOW_FULL_WRITE(0),
        .DATA_WIDTH(32),
        .IMPL("ram")
    ) theredist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo (
        .valid_in(redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_valid_in_bitsignaltemp),
        .stall_in(redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_stall_in_bitsignaltemp),
        .data_in(bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b),
        .valid_out(redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_valid_out_bitsignaltemp),
        .stall_out(redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_stall_out_bitsignaltemp),
        .data_out(redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_data_out),
        .clock(clock),
        .resetn(resetn)
    );

    // c_i32_20487(CONSTANT,6)
    assign c_i32_20487_q = $unsigned(32'b00000000000000000000100000000000);

    // i_unnamed_k2_zts6c_calc2(ADD,12)@0
    assign i_unnamed_k2_zts6c_calc2_a = {1'b0, bubble_select_stall_entry_b};
    assign i_unnamed_k2_zts6c_calc2_b = {1'b0, c_i32_20487_q};
    assign i_unnamed_k2_zts6c_calc2_o = $unsigned(i_unnamed_k2_zts6c_calc2_a) + $unsigned(i_unnamed_k2_zts6c_calc2_b);
    assign i_unnamed_k2_zts6c_calc2_q = i_unnamed_k2_zts6c_calc2_o[32:0];

    // bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x(BITSELECT,24)@0
    assign bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b = i_unnamed_k2_zts6c_calc2_q[31:0];

    // redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo(STALLFIFO,44)
    assign redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo_valid_in = SE_stall_entry_V2;
    assign redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo_stall_in = SE_out_coalesced_delay_0_fifo_backStall;
    assign redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo_data_in = bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b;
    assign redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo_valid_in_bitsignaltemp = redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo_valid_in[0];
    assign redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo_stall_in_bitsignaltemp = redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo_stall_in[0];
    assign redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo_valid_out[0] = redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo_valid_out_bitsignaltemp;
    assign redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo_stall_out[0] = redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo_stall_out_bitsignaltemp;
    acl_data_fifo #(
        .DEPTH(131),
        .STRICT_DEPTH(0),
        .ALLOW_FULL_WRITE(0),
        .DATA_WIDTH(32),
        .IMPL("ram")
    ) theredist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo (
        .valid_in(redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo_valid_in_bitsignaltemp),
        .stall_in(redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo_stall_in_bitsignaltemp),
        .data_in(bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b),
        .valid_out(redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo_valid_out_bitsignaltemp),
        .stall_out(redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo_stall_out_bitsignaltemp),
        .data_out(redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo_data_out),
        .clock(clock),
        .resetn(resetn)
    );

    // join_for_coalesced_delay_0(BITJOIN,42)
    assign join_for_coalesced_delay_0_q = {bubble_select_stall_entry_n, bubble_select_stall_entry_i, bubble_select_stall_entry_h, bubble_select_stall_entry_g, bubble_select_stall_entry_f, bubble_select_stall_entry_m, bubble_select_stall_entry_l, bubble_select_stall_entry_k, bubble_select_stall_entry_j, bubble_select_stall_entry_e, bubble_select_stall_entry_d};

    // coalesced_delay_0_fifo(STALLFIFO,46)
    assign coalesced_delay_0_fifo_valid_in = SE_stall_entry_V1;
    assign coalesced_delay_0_fifo_stall_in = SE_out_coalesced_delay_0_fifo_backStall;
    assign coalesced_delay_0_fifo_data_in = join_for_coalesced_delay_0_q;
    assign coalesced_delay_0_fifo_valid_in_bitsignaltemp = coalesced_delay_0_fifo_valid_in[0];
    assign coalesced_delay_0_fifo_stall_in_bitsignaltemp = coalesced_delay_0_fifo_stall_in[0];
    assign coalesced_delay_0_fifo_valid_out[0] = coalesced_delay_0_fifo_valid_out_bitsignaltemp;
    assign coalesced_delay_0_fifo_stall_out[0] = coalesced_delay_0_fifo_stall_out_bitsignaltemp;
    acl_data_fifo #(
        .DEPTH(131),
        .STRICT_DEPTH(0),
        .ALLOW_FULL_WRITE(0),
        .DATA_WIDTH(544),
        .IMPL("ram")
    ) thecoalesced_delay_0_fifo (
        .valid_in(coalesced_delay_0_fifo_valid_in_bitsignaltemp),
        .stall_in(coalesced_delay_0_fifo_stall_in_bitsignaltemp),
        .data_in(join_for_coalesced_delay_0_q),
        .valid_out(coalesced_delay_0_fifo_valid_out_bitsignaltemp),
        .stall_out(coalesced_delay_0_fifo_stall_out_bitsignaltemp),
        .data_out(coalesced_delay_0_fifo_data_out),
        .clock(clock),
        .resetn(resetn)
    );

    // GND(CONSTANT,0)
    assign GND_q = $unsigned(1'b0);

    // i_llvm_fpga_simple_barrier_unnamed_k2_zts6c_calc22_k2_zts6c_calc0(BLACKBOX,10)@0
    // in in_stall_exit@20000000
    // out out_data_exit@130
    // out out_stall_entry@20000000
    // out out_valid_exit@130
    k2_ZTS6c_calc_i_llvm_fpga_simple_barrier0000alc22_k2_zts6c_calc0 thei_llvm_fpga_simple_barrier_unnamed_k2_zts6c_calc22_k2_zts6c_calc0 (
        .in_data_entry(GND_q),
        .in_stall_exit(SE_out_coalesced_delay_0_fifo_backStall),
        .in_valid_entry(SE_stall_entry_V0),
        .in_workgroup_size(in_barrier_unnamed_k2_ZTS6c_calc22_wgs_workgroup_size),
        .out_data_exit(),
        .out_stall_entry(i_llvm_fpga_simple_barrier_unnamed_k2_zts6c_calc22_k2_zts6c_calc0_out_stall_entry),
        .out_valid_exit(i_llvm_fpga_simple_barrier_unnamed_k2_zts6c_calc22_k2_zts6c_calc0_out_valid_exit),
        .clock(clock),
        .resetn(resetn)
    );

    // SE_stall_entry(STALLENABLE,66)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            SE_stall_entry_fromReg0 <= '0;
            SE_stall_entry_fromReg1 <= '0;
            SE_stall_entry_fromReg2 <= '0;
            SE_stall_entry_fromReg3 <= '0;
        end
        else
        begin
            // Successor 0
            SE_stall_entry_fromReg0 <= SE_stall_entry_toReg0;
            // Successor 1
            SE_stall_entry_fromReg1 <= SE_stall_entry_toReg1;
            // Successor 2
            SE_stall_entry_fromReg2 <= SE_stall_entry_toReg2;
            // Successor 3
            SE_stall_entry_fromReg3 <= SE_stall_entry_toReg3;
        end
    end
    // Input Stall processing
    assign SE_stall_entry_consumed0 = (~ (i_llvm_fpga_simple_barrier_unnamed_k2_zts6c_calc22_k2_zts6c_calc0_out_stall_entry) & SE_stall_entry_wireValid) | SE_stall_entry_fromReg0;
    assign SE_stall_entry_consumed1 = (~ (coalesced_delay_0_fifo_stall_out) & SE_stall_entry_wireValid) | SE_stall_entry_fromReg1;
    assign SE_stall_entry_consumed2 = (~ (redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo_stall_out) & SE_stall_entry_wireValid) | SE_stall_entry_fromReg2;
    assign SE_stall_entry_consumed3 = (~ (redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_stall_out) & SE_stall_entry_wireValid) | SE_stall_entry_fromReg3;
    // Consuming
    assign SE_stall_entry_StallValid = SE_stall_entry_backStall & SE_stall_entry_wireValid;
    assign SE_stall_entry_toReg0 = SE_stall_entry_StallValid & SE_stall_entry_consumed0;
    assign SE_stall_entry_toReg1 = SE_stall_entry_StallValid & SE_stall_entry_consumed1;
    assign SE_stall_entry_toReg2 = SE_stall_entry_StallValid & SE_stall_entry_consumed2;
    assign SE_stall_entry_toReg3 = SE_stall_entry_StallValid & SE_stall_entry_consumed3;
    // Backward Stall generation
    assign SE_stall_entry_or0 = SE_stall_entry_consumed0;
    assign SE_stall_entry_or1 = SE_stall_entry_consumed1 & SE_stall_entry_or0;
    assign SE_stall_entry_or2 = SE_stall_entry_consumed2 & SE_stall_entry_or1;
    assign SE_stall_entry_wireStall = ~ (SE_stall_entry_consumed3 & SE_stall_entry_or2);
    assign SE_stall_entry_backStall = SE_stall_entry_wireStall;
    // Valid signal propagation
    assign SE_stall_entry_V0 = SE_stall_entry_wireValid & ~ (SE_stall_entry_fromReg0);
    assign SE_stall_entry_V1 = SE_stall_entry_wireValid & ~ (SE_stall_entry_fromReg1);
    assign SE_stall_entry_V2 = SE_stall_entry_wireValid & ~ (SE_stall_entry_fromReg2);
    assign SE_stall_entry_V3 = SE_stall_entry_wireValid & ~ (SE_stall_entry_fromReg3);
    // Computing multiple Valid(s)
    assign SE_stall_entry_wireValid = in_valid_in;

    // sync_out(GPOUT,21)@0
    assign out_stall_out = SE_stall_entry_backStall;

    // i_unnamed_k2_zts6c_calc3(COMPARE,13)@130
    assign i_unnamed_k2_zts6c_calc3_a = $unsigned({{2{bubble_select_redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_b[31]}}, bubble_select_redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_b});
    assign i_unnamed_k2_zts6c_calc3_b = $unsigned({{2{sel_for_coalesced_delay_0_j[31]}}, sel_for_coalesced_delay_0_j});
    assign i_unnamed_k2_zts6c_calc3_o = $unsigned($signed(i_unnamed_k2_zts6c_calc3_a) - $signed(i_unnamed_k2_zts6c_calc3_b));
    assign i_unnamed_k2_zts6c_calc3_c[0] = i_unnamed_k2_zts6c_calc3_o[33];

    // bubble_join_redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo(BITJOIN,53)
    assign bubble_join_redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo_q = redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo_data_out;

    // bubble_select_redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo(BITSELECT,54)
    assign bubble_select_redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo_b = $unsigned(bubble_join_redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo_q[31:0]);

    // bubble_join_redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo(BITJOIN,56)
    assign bubble_join_redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_q = redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_data_out;

    // bubble_select_redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo(BITSELECT,57)
    assign bubble_select_redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_b = $unsigned(bubble_join_redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_q[31:0]);

    // bubble_join_coalesced_delay_0_fifo(BITJOIN,59)
    assign bubble_join_coalesced_delay_0_fifo_q = coalesced_delay_0_fifo_data_out;

    // bubble_select_coalesced_delay_0_fifo(BITSELECT,60)
    assign bubble_select_coalesced_delay_0_fifo_b = $unsigned(bubble_join_coalesced_delay_0_fifo_q[543:0]);

    // sel_for_coalesced_delay_0(BITSELECT,43)
    assign sel_for_coalesced_delay_0_b = $unsigned(bubble_select_coalesced_delay_0_fifo_b[63:0]);
    assign sel_for_coalesced_delay_0_c = $unsigned(bubble_select_coalesced_delay_0_fifo_b[127:64]);
    assign sel_for_coalesced_delay_0_d = $unsigned(bubble_select_coalesced_delay_0_fifo_b[191:128]);
    assign sel_for_coalesced_delay_0_e = $unsigned(bubble_select_coalesced_delay_0_fifo_b[255:192]);
    assign sel_for_coalesced_delay_0_f = $unsigned(bubble_select_coalesced_delay_0_fifo_b[319:256]);
    assign sel_for_coalesced_delay_0_g = $unsigned(bubble_select_coalesced_delay_0_fifo_b[383:320]);
    assign sel_for_coalesced_delay_0_h = $unsigned(bubble_select_coalesced_delay_0_fifo_b[415:384]);
    assign sel_for_coalesced_delay_0_i = $unsigned(bubble_select_coalesced_delay_0_fifo_b[447:416]);
    assign sel_for_coalesced_delay_0_j = $unsigned(bubble_select_coalesced_delay_0_fifo_b[479:448]);
    assign sel_for_coalesced_delay_0_k = $unsigned(bubble_select_coalesced_delay_0_fifo_b[511:480]);
    assign sel_for_coalesced_delay_0_l = $unsigned(bubble_select_coalesced_delay_0_fifo_b[543:512]);

    // dupName_0_sync_out_x(GPOUT,25)@130
    assign out_acl_global_id_041 = sel_for_coalesced_delay_0_b;
    assign out_acl_global_id_147 = sel_for_coalesced_delay_0_c;
    assign out_acl_hw_wg_id54 = sel_for_coalesced_delay_0_h;
    assign out_c0_exe15437 = sel_for_coalesced_delay_0_i;
    assign out_c0_exe28 = sel_for_coalesced_delay_0_j;
    assign out_c0_exe413 = sel_for_coalesced_delay_0_k;
    assign out_c0_exe518 = sel_for_coalesced_delay_0_d;
    assign out_c0_exe621 = sel_for_coalesced_delay_0_e;
    assign out_c0_exe726 = sel_for_coalesced_delay_0_f;
    assign out_c0_exe829 = sel_for_coalesced_delay_0_g;
    assign out_l_grpid_03 = sel_for_coalesced_delay_0_l;
    assign out_unnamed_k2_ZTS6c_calc19 = bubble_select_redist1_bgTrunc_i_unnamed_k2_zts6c_calc1_sel_x_b_130_fifo_b;
    assign out_unnamed_k2_ZTS6c_calc20 = bubble_select_redist0_bgTrunc_i_unnamed_k2_zts6c_calc2_sel_x_b_130_fifo_b;
    assign out_unnamed_k2_ZTS6c_calc21 = i_unnamed_k2_zts6c_calc3_c;
    assign out_valid_out = SE_out_coalesced_delay_0_fifo_V0;

endmodule
