// ------------------------------------------------------------------------- 
// High Level Design Compiler for Intel(R) FPGAs Version 20.3 (Release Build #121)
// 
// Legal Notice: Copyright 2020 Intel Corporation.  All rights reserved.
// Your use of  Intel Corporation's design tools,  logic functions and other
// software and  tools, and its AMPP partner logic functions, and any output
// files any  of the foregoing (including  device programming  or simulation
// files), and  any associated  documentation  or information  are expressly
// subject  to the terms and  conditions of the  Intel FPGA Software License
// Agreement, Intel MegaCore Function License Agreement, or other applicable
// license agreement,  including,  without limitation,  that your use is for
// the  sole  purpose of  programming  logic devices  manufactured by  Intel
// and  sold by Intel  or its authorized  distributors. Please refer  to the
// applicable agreement for further details.
// ---------------------------------------------------------------------------

// SystemVerilog created from k2_ZTS6c_calc_function_wrapper
// SystemVerilog created on Thu Nov  5 06:32:57 2020


(* altera_attribute = "-name AUTO_SHIFT_REGISTER_RECOGNITION OFF; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 10037; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 15400; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 12020; -name MESSAGE_DISABLE 12030; -name MESSAGE_DISABLE 12010; -name MESSAGE_DISABLE 12110; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 13410; -name MESSAGE_DISABLE 113007; -name MESSAGE_DISABLE 10958" *)
module k2_ZTS6c_calc_function_wrapper (
    input wire [31:0] avm_memdep_34_k2_ZTS6c_calc_readdata,
    input wire [0:0] avm_memdep_34_k2_ZTS6c_calc_readdatavalid,
    input wire [0:0] avm_memdep_34_k2_ZTS6c_calc_waitrequest,
    input wire [0:0] avm_memdep_34_k2_ZTS6c_calc_writeack,
    input wire [31:0] avm_memdep_k2_ZTS6c_calc_readdata,
    input wire [0:0] avm_memdep_k2_ZTS6c_calc_readdatavalid,
    input wire [0:0] avm_memdep_k2_ZTS6c_calc_waitrequest,
    input wire [0:0] avm_memdep_k2_ZTS6c_calc_writeack,
    input wire [511:0] avm_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_readdata,
    input wire [0:0] avm_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_readdatavalid,
    input wire [0:0] avm_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_waitrequest,
    input wire [0:0] avm_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_writeack,
    input wire [511:0] avm_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_readdata,
    input wire [0:0] avm_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_readdatavalid,
    input wire [0:0] avm_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_waitrequest,
    input wire [0:0] avm_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_writeack,
    input wire [31:0] avm_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_readdata,
    input wire [0:0] avm_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_readdatavalid,
    input wire [0:0] avm_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_waitrequest,
    input wire [0:0] avm_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_writeack,
    input wire [31:0] avm_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_readdata,
    input wire [0:0] avm_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_readdatavalid,
    input wire [0:0] avm_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_waitrequest,
    input wire [0:0] avm_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_writeack,
    input wire [511:0] avm_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_readdata,
    input wire [0:0] avm_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_readdatavalid,
    input wire [0:0] avm_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_waitrequest,
    input wire [0:0] avm_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_writeack,
    input wire [0:0] clock2x,
    input wire [63:0] global_id_0,
    input wire [63:0] global_id_1,
    input wire [63:0] global_id_2,
    input wire [63:0] global_offset_0,
    input wire [63:0] global_offset_1,
    input wire [63:0] global_offset_2,
    input wire [63:0] global_size_0,
    input wire [63:0] global_size_1,
    input wire [63:0] global_size_2,
    input wire [31:0] group_id_0,
    input wire [31:0] group_id_1,
    input wire [31:0] group_id_2,
    input wire [1791:0] kernel_arguments,
    input wire [0:0] kernel_stall_in,
    input wire [0:0] kernel_valid_in,
    input wire [31:0] local_id_0,
    input wire [31:0] local_id_1,
    input wire [31:0] local_id_2,
    input wire [0:0] local_router_hang,
    input wire [31:0] local_size_0,
    input wire [31:0] local_size_1,
    input wire [31:0] local_size_2,
    input wire [31:0] num_groups_0,
    input wire [31:0] num_groups_1,
    input wire [31:0] num_groups_2,
    input wire [0:0] stall_in,
    input wire [0:0] start,
    input wire [0:0] valid_in,
    input wire [31:0] work_dim,
    input wire [31:0] workgroup_size,
    output wire [31:0] avm_memdep_34_k2_ZTS6c_calc_address,
    output wire [0:0] avm_memdep_34_k2_ZTS6c_calc_burstcount,
    output wire [3:0] avm_memdep_34_k2_ZTS6c_calc_byteenable,
    output wire [0:0] avm_memdep_34_k2_ZTS6c_calc_enable,
    output wire [0:0] avm_memdep_34_k2_ZTS6c_calc_read,
    output wire [0:0] avm_memdep_34_k2_ZTS6c_calc_write,
    output wire [31:0] avm_memdep_34_k2_ZTS6c_calc_writedata,
    output wire [31:0] avm_memdep_k2_ZTS6c_calc_address,
    output wire [0:0] avm_memdep_k2_ZTS6c_calc_burstcount,
    output wire [3:0] avm_memdep_k2_ZTS6c_calc_byteenable,
    output wire [0:0] avm_memdep_k2_ZTS6c_calc_enable,
    output wire [0:0] avm_memdep_k2_ZTS6c_calc_read,
    output wire [0:0] avm_memdep_k2_ZTS6c_calc_write,
    output wire [31:0] avm_memdep_k2_ZTS6c_calc_writedata,
    output wire [32:0] avm_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_address,
    output wire [4:0] avm_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_burstcount,
    output wire [63:0] avm_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_byteenable,
    output wire [0:0] avm_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_enable,
    output wire [0:0] avm_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_read,
    output wire [0:0] avm_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_write,
    output wire [511:0] avm_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_writedata,
    output wire [32:0] avm_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_address,
    output wire [4:0] avm_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_burstcount,
    output wire [63:0] avm_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_byteenable,
    output wire [0:0] avm_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_enable,
    output wire [0:0] avm_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_read,
    output wire [0:0] avm_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_write,
    output wire [511:0] avm_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_writedata,
    output wire [31:0] avm_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_address,
    output wire [0:0] avm_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_burstcount,
    output wire [3:0] avm_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_byteenable,
    output wire [0:0] avm_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_enable,
    output wire [0:0] avm_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_read,
    output wire [0:0] avm_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_write,
    output wire [31:0] avm_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_writedata,
    output wire [31:0] avm_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_address,
    output wire [0:0] avm_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_burstcount,
    output wire [3:0] avm_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_byteenable,
    output wire [0:0] avm_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_enable,
    output wire [0:0] avm_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_read,
    output wire [0:0] avm_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_write,
    output wire [31:0] avm_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_writedata,
    output wire [32:0] avm_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_address,
    output wire [4:0] avm_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_burstcount,
    output wire [63:0] avm_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_byteenable,
    output wire [0:0] avm_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_enable,
    output wire [0:0] avm_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_read,
    output wire [0:0] avm_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_write,
    output wire [511:0] avm_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_writedata,
    output wire [0:0] clock2x_output,
    output wire [0:0] has_a_lsu_active,
    output wire [0:0] has_a_write_pending,
    output wire [0:0] kernel_stall_out,
    output wire [0:0] kernel_valid_out,
    input wire clock,
    input wire resetn
    );

    wire [0:0] GND_q;
    wire [0:0] acl_clock2x_dummy_consumer_clock2x;
    wire acl_clock2x_dummy_consumer_clock2x_bitsignaltemp;
    wire [0:0] acl_clock2x_dummy_consumer_myout;
    wire acl_clock2x_dummy_consumer_myout_bitsignaltemp;
    wire [31:0] arg_arg0_select_b;
    wire [127:0] arg_arg10_select_b;
    wire [127:0] arg_arg11_select_b;
    wire [63:0] arg_arg12_select_b;
    wire [63:0] arg_arg13_select_b;
    wire [63:0] arg_arg14_select_b;
    wire [63:0] arg_arg15_select_b;
    wire [63:0] arg_arg16_select_b;
    wire [127:0] arg_arg17_select_b;
    wire [127:0] arg_arg18_select_b;
    wire [127:0] arg_arg19_select_b;
    wire [127:0] arg_arg1_select_b;
    wire [127:0] arg_arg2_select_b;
    wire [127:0] arg_arg3_select_b;
    wire [63:0] arg_arg4_select_b;
    wire [63:0] arg_arg5_select_b;
    wire [63:0] arg_arg6_select_b;
    wire [63:0] arg_arg7_select_b;
    wire [31:0] arg_arg8_select_b;
    wire [127:0] arg_arg9_select_b;
    wire [31:0] embedded_issuer_done_hw_wg_id_in;
    wire [63:0] embedded_issuer_global_id_in_0;
    wire [63:0] embedded_issuer_global_id_in_1;
    wire [63:0] embedded_issuer_global_id_in_2;
    wire [31:0] embedded_issuer_group_id_in_0;
    wire [31:0] embedded_issuer_group_id_in_1;
    wire [31:0] embedded_issuer_group_id_in_2;
    wire [31:0] embedded_issuer_local_id_in_0;
    wire [31:0] embedded_issuer_local_id_in_1;
    wire [31:0] embedded_issuer_local_id_in_2;
    wire [0:0] embedded_issuer_stall_entry;
    wire embedded_issuer_stall_entry_bitsignaltemp;
    wire [0:0] embedded_issuer_stall_exit;
    wire embedded_issuer_stall_exit_bitsignaltemp;
    wire [0:0] embedded_issuer_valid_exit;
    wire embedded_issuer_valid_exit_bitsignaltemp;
    wire [0:0] embedded_issuer_valid_in;
    wire embedded_issuer_valid_in_bitsignaltemp;
    wire [31:0] embedded_issuer_workgroup_size;
    wire [63:0] embedded_issuer_global_id_out_0;
    wire [63:0] embedded_issuer_global_id_out_1;
    wire [31:0] embedded_issuer_group_id_out_0;
    wire [31:0] embedded_issuer_group_id_out_1;
    wire [31:0] embedded_issuer_hw_wg_id_out;
    wire [31:0] embedded_issuer_local_id_out_0;
    wire [31:0] embedded_issuer_local_id_out_1;
    wire [0:0] embedded_issuer_stall_out;
    wire embedded_issuer_stall_out_bitsignaltemp;
    wire [0:0] embedded_issuer_valid_entry;
    wire embedded_issuer_valid_entry_bitsignaltemp;
    wire [63:0] ip_dsdk_adapt_bitselect115_b;
    wire [63:0] ip_dsdk_adapt_bitselect117_b;
    wire [63:0] ip_dsdk_adapt_bitselect124_b;
    wire [63:0] ip_dsdk_adapt_bitselect126_b;
    wire [63:0] ip_dsdk_adapt_bitselect133_b;
    wire [63:0] ip_dsdk_adapt_bitselect135_b;
    wire [63:0] ip_dsdk_adapt_bitselect165_b;
    wire [63:0] ip_dsdk_adapt_bitselect167_b;
    wire [63:0] ip_dsdk_adapt_bitselect174_b;
    wire [63:0] ip_dsdk_adapt_bitselect176_b;
    wire [63:0] ip_dsdk_adapt_bitselect183_b;
    wire [63:0] ip_dsdk_adapt_bitselect185_b;
    wire [63:0] ip_dsdk_adapt_bitselect65_b;
    wire [63:0] ip_dsdk_adapt_bitselect67_b;
    wire [63:0] ip_dsdk_adapt_bitselect74_b;
    wire [63:0] ip_dsdk_adapt_bitselect76_b;
    wire [63:0] ip_dsdk_adapt_bitselect83_b;
    wire [63:0] ip_dsdk_adapt_bitselect85_b;
    wire [63:0] ip_dsdk_adapt_cast109_b;
    wire [63:0] ip_dsdk_adapt_cast59_b;
    wire [31:0] k2_ZTS6c_calc_function_aunroll_x_out_acl_hw_wg_id52;
    wire [31:0] k2_ZTS6c_calc_function_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_address;
    wire [0:0] k2_ZTS6c_calc_function_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_burstcount;
    wire [3:0] k2_ZTS6c_calc_function_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_byteenable;
    wire [0:0] k2_ZTS6c_calc_function_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_enable;
    wire [0:0] k2_ZTS6c_calc_function_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_read;
    wire [0:0] k2_ZTS6c_calc_function_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_write;
    wire [31:0] k2_ZTS6c_calc_function_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_writedata;
    wire [31:0] k2_ZTS6c_calc_function_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_address;
    wire [0:0] k2_ZTS6c_calc_function_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_burstcount;
    wire [3:0] k2_ZTS6c_calc_function_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_byteenable;
    wire [0:0] k2_ZTS6c_calc_function_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_enable;
    wire [0:0] k2_ZTS6c_calc_function_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_read;
    wire [0:0] k2_ZTS6c_calc_function_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_write;
    wire [31:0] k2_ZTS6c_calc_function_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_writedata;
    wire [0:0] k2_ZTS6c_calc_function_aunroll_x_out_o_active_unnamed_k2_ZTS6c_calc9;
    wire [63:0] k2_ZTS6c_calc_function_aunroll_x_out_primWireOut;
    wire [0:0] k2_ZTS6c_calc_function_aunroll_x_out_stall_out;
    wire [32:0] k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_address;
    wire [4:0] k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_burstcount;
    wire [63:0] k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_byteenable;
    wire [0:0] k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_enable;
    wire [0:0] k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_read;
    wire [0:0] k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_write;
    wire [511:0] k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_writedata;
    wire [32:0] k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_address;
    wire [4:0] k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_burstcount;
    wire [63:0] k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_byteenable;
    wire [0:0] k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_enable;
    wire [0:0] k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_read;
    wire [0:0] k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_write;
    wire [511:0] k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_writedata;
    wire [31:0] k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_address;
    wire [0:0] k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_burstcount;
    wire [3:0] k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_byteenable;
    wire [0:0] k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_enable;
    wire [0:0] k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_read;
    wire [0:0] k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_write;
    wire [31:0] k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writedata;
    wire [31:0] k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_address;
    wire [0:0] k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_burstcount;
    wire [3:0] k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_byteenable;
    wire [0:0] k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_enable;
    wire [0:0] k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_read;
    wire [0:0] k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_write;
    wire [31:0] k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writedata;
    wire [32:0] k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_address;
    wire [4:0] k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_burstcount;
    wire [63:0] k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_byteenable;
    wire [0:0] k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_enable;
    wire [0:0] k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_read;
    wire [0:0] k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_write;
    wire [511:0] k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_writedata;
    wire [0:0] k2_ZTS6c_calc_function_aunroll_x_out_valid_out;


    // arg_arg9_select(BITSELECT,22)
    assign arg_arg9_select_b = kernel_arguments[831:704];

    // ip_dsdk_adapt_bitselect117(BITSELECT,91)
    assign ip_dsdk_adapt_bitselect117_b = arg_arg9_select_b[127:64];

    // ip_dsdk_adapt_bitselect115(BITSELECT,90)
    assign ip_dsdk_adapt_bitselect115_b = arg_arg9_select_b[63:0];

    // arg_arg7_select(BITSELECT,20)
    assign arg_arg7_select_b = kernel_arguments[671:608];

    // arg_arg6_select(BITSELECT,19)
    assign arg_arg6_select_b = kernel_arguments[607:544];

    // arg_arg5_select(BITSELECT,18)
    assign arg_arg5_select_b = kernel_arguments[543:480];

    // arg_arg3_select(BITSELECT,16)
    assign arg_arg3_select_b = kernel_arguments[415:288];

    // ip_dsdk_adapt_bitselect85(BITSELECT,132)
    assign ip_dsdk_adapt_bitselect85_b = arg_arg3_select_b[127:64];

    // ip_dsdk_adapt_bitselect83(BITSELECT,131)
    assign ip_dsdk_adapt_bitselect83_b = arg_arg3_select_b[63:0];

    // arg_arg2_select(BITSELECT,15)
    assign arg_arg2_select_b = kernel_arguments[287:160];

    // ip_dsdk_adapt_bitselect76(BITSELECT,128)
    assign ip_dsdk_adapt_bitselect76_b = arg_arg2_select_b[127:64];

    // ip_dsdk_adapt_bitselect74(BITSELECT,127)
    assign ip_dsdk_adapt_bitselect74_b = arg_arg2_select_b[63:0];

    // arg_arg19_select(BITSELECT,13)
    assign arg_arg19_select_b = kernel_arguments[1791:1664];

    // ip_dsdk_adapt_bitselect185(BITSELECT,120)
    assign ip_dsdk_adapt_bitselect185_b = arg_arg19_select_b[127:64];

    // ip_dsdk_adapt_bitselect183(BITSELECT,119)
    assign ip_dsdk_adapt_bitselect183_b = arg_arg19_select_b[63:0];

    // arg_arg18_select(BITSELECT,12)
    assign arg_arg18_select_b = kernel_arguments[1663:1536];

    // ip_dsdk_adapt_bitselect176(BITSELECT,116)
    assign ip_dsdk_adapt_bitselect176_b = arg_arg18_select_b[127:64];

    // ip_dsdk_adapt_bitselect174(BITSELECT,115)
    assign ip_dsdk_adapt_bitselect174_b = arg_arg18_select_b[63:0];

    // arg_arg17_select(BITSELECT,11)
    assign arg_arg17_select_b = kernel_arguments[1535:1408];

    // ip_dsdk_adapt_bitselect167(BITSELECT,112)
    assign ip_dsdk_adapt_bitselect167_b = arg_arg17_select_b[127:64];

    // ip_dsdk_adapt_bitselect165(BITSELECT,111)
    assign ip_dsdk_adapt_bitselect165_b = arg_arg17_select_b[63:0];

    // arg_arg15_select(BITSELECT,9)
    assign arg_arg15_select_b = kernel_arguments[1343:1280];

    // arg_arg14_select(BITSELECT,8)
    assign arg_arg14_select_b = kernel_arguments[1279:1216];

    // arg_arg13_select(BITSELECT,7)
    assign arg_arg13_select_b = kernel_arguments[1215:1152];

    // arg_arg11_select(BITSELECT,5)
    assign arg_arg11_select_b = kernel_arguments[1087:960];

    // ip_dsdk_adapt_bitselect135(BITSELECT,99)
    assign ip_dsdk_adapt_bitselect135_b = arg_arg11_select_b[127:64];

    // ip_dsdk_adapt_bitselect133(BITSELECT,98)
    assign ip_dsdk_adapt_bitselect133_b = arg_arg11_select_b[63:0];

    // arg_arg10_select(BITSELECT,4)
    assign arg_arg10_select_b = kernel_arguments[959:832];

    // ip_dsdk_adapt_bitselect126(BITSELECT,95)
    assign ip_dsdk_adapt_bitselect126_b = arg_arg10_select_b[127:64];

    // ip_dsdk_adapt_bitselect124(BITSELECT,94)
    assign ip_dsdk_adapt_bitselect124_b = arg_arg10_select_b[63:0];

    // arg_arg1_select(BITSELECT,14)
    assign arg_arg1_select_b = kernel_arguments[159:32];

    // ip_dsdk_adapt_bitselect67(BITSELECT,124)
    assign ip_dsdk_adapt_bitselect67_b = arg_arg1_select_b[127:64];

    // ip_dsdk_adapt_bitselect65(BITSELECT,123)
    assign ip_dsdk_adapt_bitselect65_b = arg_arg1_select_b[63:0];

    // GND(CONSTANT,0)
    assign GND_q = $unsigned(1'b0);

    // arg_arg8_select(BITSELECT,21)
    assign arg_arg8_select_b = kernel_arguments[703:672];

    // ip_dsdk_adapt_cast109(BITSELECT,140)
    assign ip_dsdk_adapt_cast109_b = {32'b00000000000000000000000000000000, arg_arg8_select_b[31:0]};

    // arg_arg4_select(BITSELECT,17)
    assign arg_arg4_select_b = kernel_arguments[479:416];

    // arg_arg16_select(BITSELECT,10)
    assign arg_arg16_select_b = kernel_arguments[1407:1344];

    // arg_arg12_select(BITSELECT,6)
    assign arg_arg12_select_b = kernel_arguments[1151:1088];

    // arg_arg0_select(BITSELECT,3)
    assign arg_arg0_select_b = kernel_arguments[31:0];

    // ip_dsdk_adapt_cast59(BITSELECT,158)
    assign ip_dsdk_adapt_cast59_b = {32'b00000000000000000000000000000000, arg_arg0_select_b[31:0]};

    // embedded_issuer(EXTIFACE,24)
    assign embedded_issuer_done_hw_wg_id_in = k2_ZTS6c_calc_function_aunroll_x_out_acl_hw_wg_id52;
    assign embedded_issuer_global_id_in_0 = global_id_0;
    assign embedded_issuer_global_id_in_1 = global_id_1;
    assign embedded_issuer_global_id_in_2 = k2_ZTS6c_calc_function_aunroll_x_out_primWireOut;
    assign embedded_issuer_group_id_in_0 = group_id_0;
    assign embedded_issuer_group_id_in_1 = group_id_1;
    assign embedded_issuer_group_id_in_2 = k2_ZTS6c_calc_function_aunroll_x_out_primWireOut[31:0];
    assign embedded_issuer_local_id_in_0 = local_id_0;
    assign embedded_issuer_local_id_in_1 = local_id_1;
    assign embedded_issuer_local_id_in_2 = k2_ZTS6c_calc_function_aunroll_x_out_primWireOut[31:0];
    assign embedded_issuer_stall_entry = k2_ZTS6c_calc_function_aunroll_x_out_stall_out;
    assign embedded_issuer_stall_exit = GND_q;
    assign embedded_issuer_valid_exit = k2_ZTS6c_calc_function_aunroll_x_out_valid_out;
    assign embedded_issuer_valid_in = kernel_valid_in;
    assign embedded_issuer_workgroup_size = workgroup_size;
    assign embedded_issuer_stall_entry_bitsignaltemp = embedded_issuer_stall_entry[0];
    assign embedded_issuer_stall_exit_bitsignaltemp = embedded_issuer_stall_exit[0];
    assign embedded_issuer_valid_exit_bitsignaltemp = embedded_issuer_valid_exit[0];
    assign embedded_issuer_valid_in_bitsignaltemp = embedded_issuer_valid_in[0];
    assign embedded_issuer_stall_out[0] = embedded_issuer_stall_out_bitsignaltemp;
    assign embedded_issuer_valid_entry[0] = embedded_issuer_valid_entry_bitsignaltemp;
    acl_embedded_workgroup_issuer_dspba #(
        .ASYNC_RESET(1),
        .GLOBAL_ID_WIDTH(64),
        .MAX_SIMULTANEOUS_WORKGROUPS(1),
        .MAX_WORKGROUP_SIZE(128),
        .SYNCHRONIZE_RESET(0),
        .WORKGROUP_EXIT_ORDER("noninterleaved")
    ) theembedded_issuer (
        .done_hw_wg_id_in(k2_ZTS6c_calc_function_aunroll_x_out_acl_hw_wg_id52),
        .global_id_in_0(global_id_0),
        .global_id_in_1(global_id_1),
        .global_id_in_2(k2_ZTS6c_calc_function_aunroll_x_out_primWireOut),
        .group_id_in_0(group_id_0),
        .group_id_in_1(group_id_1),
        .group_id_in_2(k2_ZTS6c_calc_function_aunroll_x_out_primWireOut[31:0]),
        .local_id_in_0(local_id_0),
        .local_id_in_1(local_id_1),
        .local_id_in_2(k2_ZTS6c_calc_function_aunroll_x_out_primWireOut[31:0]),
        .stall_entry(embedded_issuer_stall_entry_bitsignaltemp),
        .stall_exit(embedded_issuer_stall_exit_bitsignaltemp),
        .valid_exit(embedded_issuer_valid_exit_bitsignaltemp),
        .valid_in(embedded_issuer_valid_in_bitsignaltemp),
        .workgroup_size(workgroup_size),
        .global_id_out_0(embedded_issuer_global_id_out_0),
        .global_id_out_1(embedded_issuer_global_id_out_1),
        .group_id_out_0(embedded_issuer_group_id_out_0),
        .group_id_out_1(embedded_issuer_group_id_out_1),
        .hw_wg_id_out(embedded_issuer_hw_wg_id_out),
        .local_id_out_0(embedded_issuer_local_id_out_0),
        .local_id_out_1(embedded_issuer_local_id_out_1),
        .stall_out(embedded_issuer_stall_out_bitsignaltemp),
        .valid_entry(embedded_issuer_valid_entry_bitsignaltemp),
        .clock(clock),
        .resetn(resetn)
    );

    // k2_ZTS6c_calc_function_aunroll_x(BLACKBOX,221)
    k2_ZTS6c_calc_function thek2_ZTS6c_calc_function_aunroll_x (
        .in_arg_acl_global_id_0(embedded_issuer_global_id_out_0),
        .in_arg_acl_global_id_1(embedded_issuer_global_id_out_1),
        .in_arg_acl_global_size_0(global_size_0),
        .in_arg_acl_global_size_1(global_size_1),
        .in_arg_acl_global_size_2(global_size_2),
        .in_arg_acl_group_id_0(embedded_issuer_group_id_out_0),
        .in_arg_acl_group_id_1(embedded_issuer_group_id_out_1),
        .in_arg_acl_hw_wg_id(embedded_issuer_hw_wg_id_out),
        .in_arg_acl_local_id_0(embedded_issuer_local_id_out_0),
        .in_arg_acl_local_id_1(embedded_issuer_local_id_out_1),
        .in_arg_acl_local_size_0(local_size_0),
        .in_arg_acl_local_size_1(local_size_1),
        .in_arg_acl_local_size_2(local_size_2),
        .in_arg_arg0(ip_dsdk_adapt_cast59_b),
        .in_arg_arg12(arg_arg12_select_b),
        .in_arg_arg16(arg_arg16_select_b),
        .in_arg_arg4(arg_arg4_select_b),
        .in_arg_arg8(ip_dsdk_adapt_cast109_b),
        .in_memdep_34_k2_ZTS6c_calc_avm_readdata(avm_memdep_34_k2_ZTS6c_calc_readdata),
        .in_memdep_34_k2_ZTS6c_calc_avm_readdatavalid(avm_memdep_34_k2_ZTS6c_calc_readdatavalid),
        .in_memdep_34_k2_ZTS6c_calc_avm_waitrequest(avm_memdep_34_k2_ZTS6c_calc_waitrequest),
        .in_memdep_34_k2_ZTS6c_calc_avm_writeack(avm_memdep_34_k2_ZTS6c_calc_writeack),
        .in_memdep_k2_ZTS6c_calc_avm_readdata(avm_memdep_k2_ZTS6c_calc_readdata),
        .in_memdep_k2_ZTS6c_calc_avm_readdatavalid(avm_memdep_k2_ZTS6c_calc_readdatavalid),
        .in_memdep_k2_ZTS6c_calc_avm_waitrequest(avm_memdep_k2_ZTS6c_calc_waitrequest),
        .in_memdep_k2_ZTS6c_calc_avm_writeack(avm_memdep_k2_ZTS6c_calc_writeack),
        .in_stall_in(GND_q),
        .in_start(start),
        .in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_readdata(avm_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_readdata),
        .in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_readdatavalid(avm_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_readdatavalid),
        .in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_waitrequest(avm_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_waitrequest),
        .in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_writeack(avm_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_writeack),
        .in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_readdata(avm_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_readdata),
        .in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_readdatavalid(avm_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_readdatavalid),
        .in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_waitrequest(avm_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_waitrequest),
        .in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_writeack(avm_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_writeack),
        .in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_readdata(avm_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_readdata),
        .in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_readdatavalid(avm_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_readdatavalid),
        .in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_waitrequest(avm_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_waitrequest),
        .in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writeack(avm_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_writeack),
        .in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_readdata(avm_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_readdata),
        .in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_readdatavalid(avm_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_readdatavalid),
        .in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_waitrequest(avm_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_waitrequest),
        .in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writeack(avm_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_writeack),
        .in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_readdata(avm_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_readdata),
        .in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_readdatavalid(avm_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_readdatavalid),
        .in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_waitrequest(avm_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_waitrequest),
        .in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_writeack(avm_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_writeack),
        .in_valid_in(embedded_issuer_valid_entry),
        .in_workgroup_size(workgroup_size),
        .in_arg_arg1_0_tpl(ip_dsdk_adapt_bitselect65_b),
        .in_arg_arg1_1_tpl(ip_dsdk_adapt_bitselect67_b),
        .in_arg_arg10_0_tpl(ip_dsdk_adapt_bitselect124_b),
        .in_arg_arg10_1_tpl(ip_dsdk_adapt_bitselect126_b),
        .in_arg_arg11_0_tpl(ip_dsdk_adapt_bitselect133_b),
        .in_arg_arg11_1_tpl(ip_dsdk_adapt_bitselect135_b),
        .in_arg_arg13_0_tpl(arg_arg13_select_b),
        .in_arg_arg14_0_tpl(arg_arg14_select_b),
        .in_arg_arg15_0_tpl(arg_arg15_select_b),
        .in_arg_arg17_0_tpl(ip_dsdk_adapt_bitselect165_b),
        .in_arg_arg17_1_tpl(ip_dsdk_adapt_bitselect167_b),
        .in_arg_arg18_0_tpl(ip_dsdk_adapt_bitselect174_b),
        .in_arg_arg18_1_tpl(ip_dsdk_adapt_bitselect176_b),
        .in_arg_arg19_0_tpl(ip_dsdk_adapt_bitselect183_b),
        .in_arg_arg19_1_tpl(ip_dsdk_adapt_bitselect185_b),
        .in_arg_arg2_0_tpl(ip_dsdk_adapt_bitselect74_b),
        .in_arg_arg2_1_tpl(ip_dsdk_adapt_bitselect76_b),
        .in_arg_arg3_0_tpl(ip_dsdk_adapt_bitselect83_b),
        .in_arg_arg3_1_tpl(ip_dsdk_adapt_bitselect85_b),
        .in_arg_arg5_0_tpl(arg_arg5_select_b),
        .in_arg_arg6_0_tpl(arg_arg6_select_b),
        .in_arg_arg7_0_tpl(arg_arg7_select_b),
        .in_arg_arg9_0_tpl(ip_dsdk_adapt_bitselect115_b),
        .in_arg_arg9_1_tpl(ip_dsdk_adapt_bitselect117_b),
        .out_acl_hw_wg_id52(k2_ZTS6c_calc_function_aunroll_x_out_acl_hw_wg_id52),
        .out_memdep_34_k2_ZTS6c_calc_avm_address(k2_ZTS6c_calc_function_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_address),
        .out_memdep_34_k2_ZTS6c_calc_avm_burstcount(k2_ZTS6c_calc_function_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_burstcount),
        .out_memdep_34_k2_ZTS6c_calc_avm_byteenable(k2_ZTS6c_calc_function_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_byteenable),
        .out_memdep_34_k2_ZTS6c_calc_avm_enable(k2_ZTS6c_calc_function_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_enable),
        .out_memdep_34_k2_ZTS6c_calc_avm_read(k2_ZTS6c_calc_function_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_read),
        .out_memdep_34_k2_ZTS6c_calc_avm_write(k2_ZTS6c_calc_function_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_write),
        .out_memdep_34_k2_ZTS6c_calc_avm_writedata(k2_ZTS6c_calc_function_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_writedata),
        .out_memdep_k2_ZTS6c_calc_avm_address(k2_ZTS6c_calc_function_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_address),
        .out_memdep_k2_ZTS6c_calc_avm_burstcount(k2_ZTS6c_calc_function_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_burstcount),
        .out_memdep_k2_ZTS6c_calc_avm_byteenable(k2_ZTS6c_calc_function_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_byteenable),
        .out_memdep_k2_ZTS6c_calc_avm_enable(k2_ZTS6c_calc_function_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_enable),
        .out_memdep_k2_ZTS6c_calc_avm_read(k2_ZTS6c_calc_function_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_read),
        .out_memdep_k2_ZTS6c_calc_avm_write(k2_ZTS6c_calc_function_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_write),
        .out_memdep_k2_ZTS6c_calc_avm_writedata(k2_ZTS6c_calc_function_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_writedata),
        .out_o_active_unnamed_k2_ZTS6c_calc9(k2_ZTS6c_calc_function_aunroll_x_out_o_active_unnamed_k2_ZTS6c_calc9),
        .out_primWireOut(k2_ZTS6c_calc_function_aunroll_x_out_primWireOut),
        .out_stall_out(k2_ZTS6c_calc_function_aunroll_x_out_stall_out),
        .out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_address(k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_address),
        .out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_burstcount(k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_burstcount),
        .out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_byteenable(k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_byteenable),
        .out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_enable(k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_enable),
        .out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_read(k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_read),
        .out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_write(k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_write),
        .out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_writedata(k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_writedata),
        .out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_address(k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_address),
        .out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_burstcount(k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_burstcount),
        .out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_byteenable(k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_byteenable),
        .out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_enable(k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_enable),
        .out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_read(k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_read),
        .out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_write(k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_write),
        .out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_writedata(k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_writedata),
        .out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_address(k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_address),
        .out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_burstcount(k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_burstcount),
        .out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_byteenable(k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_byteenable),
        .out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_enable(k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_enable),
        .out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_read(k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_read),
        .out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_write(k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_write),
        .out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writedata(k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writedata),
        .out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_address(k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_address),
        .out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_burstcount(k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_burstcount),
        .out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_byteenable(k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_byteenable),
        .out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_enable(k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_enable),
        .out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_read(k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_read),
        .out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_write(k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_write),
        .out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writedata(k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writedata),
        .out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_address(k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_address),
        .out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_burstcount(k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_burstcount),
        .out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_byteenable(k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_byteenable),
        .out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_enable(k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_enable),
        .out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_read(k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_read),
        .out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_write(k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_write),
        .out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_writedata(k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_writedata),
        .out_valid_out(k2_ZTS6c_calc_function_aunroll_x_out_valid_out),
        .clock(clock),
        .resetn(resetn)
    );

    // avm_memdep_34_k2_ZTS6c_calc_address(GPOUT,167)
    assign avm_memdep_34_k2_ZTS6c_calc_address = k2_ZTS6c_calc_function_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_address;

    // avm_memdep_34_k2_ZTS6c_calc_burstcount(GPOUT,168)
    assign avm_memdep_34_k2_ZTS6c_calc_burstcount = k2_ZTS6c_calc_function_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_burstcount;

    // avm_memdep_34_k2_ZTS6c_calc_byteenable(GPOUT,169)
    assign avm_memdep_34_k2_ZTS6c_calc_byteenable = k2_ZTS6c_calc_function_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_byteenable;

    // avm_memdep_34_k2_ZTS6c_calc_enable(GPOUT,170)
    assign avm_memdep_34_k2_ZTS6c_calc_enable = k2_ZTS6c_calc_function_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_enable;

    // avm_memdep_34_k2_ZTS6c_calc_read(GPOUT,171)
    assign avm_memdep_34_k2_ZTS6c_calc_read = k2_ZTS6c_calc_function_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_read;

    // avm_memdep_34_k2_ZTS6c_calc_write(GPOUT,172)
    assign avm_memdep_34_k2_ZTS6c_calc_write = k2_ZTS6c_calc_function_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_write;

    // avm_memdep_34_k2_ZTS6c_calc_writedata(GPOUT,173)
    assign avm_memdep_34_k2_ZTS6c_calc_writedata = k2_ZTS6c_calc_function_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_writedata;

    // avm_memdep_k2_ZTS6c_calc_address(GPOUT,174)
    assign avm_memdep_k2_ZTS6c_calc_address = k2_ZTS6c_calc_function_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_address;

    // avm_memdep_k2_ZTS6c_calc_burstcount(GPOUT,175)
    assign avm_memdep_k2_ZTS6c_calc_burstcount = k2_ZTS6c_calc_function_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_burstcount;

    // avm_memdep_k2_ZTS6c_calc_byteenable(GPOUT,176)
    assign avm_memdep_k2_ZTS6c_calc_byteenable = k2_ZTS6c_calc_function_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_byteenable;

    // avm_memdep_k2_ZTS6c_calc_enable(GPOUT,177)
    assign avm_memdep_k2_ZTS6c_calc_enable = k2_ZTS6c_calc_function_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_enable;

    // avm_memdep_k2_ZTS6c_calc_read(GPOUT,178)
    assign avm_memdep_k2_ZTS6c_calc_read = k2_ZTS6c_calc_function_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_read;

    // avm_memdep_k2_ZTS6c_calc_write(GPOUT,179)
    assign avm_memdep_k2_ZTS6c_calc_write = k2_ZTS6c_calc_function_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_write;

    // avm_memdep_k2_ZTS6c_calc_writedata(GPOUT,180)
    assign avm_memdep_k2_ZTS6c_calc_writedata = k2_ZTS6c_calc_function_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_writedata;

    // avm_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_address(GPOUT,181)
    assign avm_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_address = k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_address;

    // avm_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_burstcount(GPOUT,182)
    assign avm_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_burstcount = k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_burstcount;

    // avm_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_byteenable(GPOUT,183)
    assign avm_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_byteenable = k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_byteenable;

    // avm_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_enable(GPOUT,184)
    assign avm_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_enable = k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_enable;

    // avm_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_read(GPOUT,185)
    assign avm_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_read = k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_read;

    // avm_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_write(GPOUT,186)
    assign avm_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_write = k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_write;

    // avm_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_writedata(GPOUT,187)
    assign avm_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_writedata = k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_writedata;

    // avm_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_address(GPOUT,188)
    assign avm_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_address = k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_address;

    // avm_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_burstcount(GPOUT,189)
    assign avm_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_burstcount = k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_burstcount;

    // avm_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_byteenable(GPOUT,190)
    assign avm_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_byteenable = k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_byteenable;

    // avm_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_enable(GPOUT,191)
    assign avm_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_enable = k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_enable;

    // avm_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_read(GPOUT,192)
    assign avm_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_read = k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_read;

    // avm_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_write(GPOUT,193)
    assign avm_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_write = k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_write;

    // avm_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_writedata(GPOUT,194)
    assign avm_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_writedata = k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_writedata;

    // avm_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_address(GPOUT,195)
    assign avm_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_address = k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_address;

    // avm_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_burstcount(GPOUT,196)
    assign avm_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_burstcount = k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_burstcount;

    // avm_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_byteenable(GPOUT,197)
    assign avm_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_byteenable = k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_byteenable;

    // avm_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_enable(GPOUT,198)
    assign avm_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_enable = k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_enable;

    // avm_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_read(GPOUT,199)
    assign avm_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_read = k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_read;

    // avm_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_write(GPOUT,200)
    assign avm_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_write = k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_write;

    // avm_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_writedata(GPOUT,201)
    assign avm_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_writedata = k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writedata;

    // avm_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_address(GPOUT,202)
    assign avm_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_address = k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_address;

    // avm_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_burstcount(GPOUT,203)
    assign avm_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_burstcount = k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_burstcount;

    // avm_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_byteenable(GPOUT,204)
    assign avm_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_byteenable = k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_byteenable;

    // avm_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_enable(GPOUT,205)
    assign avm_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_enable = k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_enable;

    // avm_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_read(GPOUT,206)
    assign avm_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_read = k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_read;

    // avm_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_write(GPOUT,207)
    assign avm_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_write = k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_write;

    // avm_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_writedata(GPOUT,208)
    assign avm_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_writedata = k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writedata;

    // avm_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_address(GPOUT,209)
    assign avm_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_address = k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_address;

    // avm_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_burstcount(GPOUT,210)
    assign avm_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_burstcount = k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_burstcount;

    // avm_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_byteenable(GPOUT,211)
    assign avm_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_byteenable = k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_byteenable;

    // avm_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_enable(GPOUT,212)
    assign avm_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_enable = k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_enable;

    // avm_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_read(GPOUT,213)
    assign avm_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_read = k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_read;

    // avm_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_write(GPOUT,214)
    assign avm_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_write = k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_write;

    // avm_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_writedata(GPOUT,215)
    assign avm_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_writedata = k2_ZTS6c_calc_function_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_writedata;

    // acl_clock2x_dummy_consumer(EXTIFACE,2)
    assign acl_clock2x_dummy_consumer_clock2x = clock2x;
    assign acl_clock2x_dummy_consumer_clock2x_bitsignaltemp = acl_clock2x_dummy_consumer_clock2x[0];
    assign acl_clock2x_dummy_consumer_myout[0] = acl_clock2x_dummy_consumer_myout_bitsignaltemp;
    acl_clock2x_holder theacl_clock2x_dummy_consumer (
        .clock2x(acl_clock2x_dummy_consumer_clock2x_bitsignaltemp),
        .myout(acl_clock2x_dummy_consumer_myout_bitsignaltemp),
        .clock(clock),
        .resetn(resetn)
    );

    // clock2x_output(GPOUT,216)
    assign clock2x_output = acl_clock2x_dummy_consumer_myout;

    // has_a_lsu_active(GPOUT,217)
    assign has_a_lsu_active = k2_ZTS6c_calc_function_aunroll_x_out_o_active_unnamed_k2_ZTS6c_calc9;

    // has_a_write_pending(GPOUT,218)
    assign has_a_write_pending = k2_ZTS6c_calc_function_aunroll_x_out_o_active_unnamed_k2_ZTS6c_calc9;

    // kernel_stall_out(GPOUT,219)
    assign kernel_stall_out = embedded_issuer_stall_out;

    // kernel_valid_out(GPOUT,220)
    assign kernel_valid_out = k2_ZTS6c_calc_function_aunroll_x_out_valid_out;

endmodule
