// ------------------------------------------------------------------------- 
// High Level Design Compiler for Intel(R) FPGAs Version 20.3 (Release Build #121)
// 
// Legal Notice: Copyright 2020 Intel Corporation.  All rights reserved.
// Your use of  Intel Corporation's design tools,  logic functions and other
// software and  tools, and its AMPP partner logic functions, and any output
// files any  of the foregoing (including  device programming  or simulation
// files), and  any associated  documentation  or information  are expressly
// subject  to the terms and  conditions of the  Intel FPGA Software License
// Agreement, Intel MegaCore Function License Agreement, or other applicable
// license agreement,  including,  without limitation,  that your use is for
// the  sole  purpose of  programming  logic devices  manufactured by  Intel
// and  sold by Intel  or its authorized  distributors. Please refer  to the
// applicable agreement for further details.
// ---------------------------------------------------------------------------

// SystemVerilog created from k0_ZTS6a_init_bb_ZTS6a_init_B0_stall_region
// SystemVerilog created on Thu Nov  5 06:32:56 2020


(* altera_attribute = "-name AUTO_SHIFT_REGISTER_RECOGNITION OFF; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 10037; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 15400; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 12020; -name MESSAGE_DISABLE 12030; -name MESSAGE_DISABLE 12010; -name MESSAGE_DISABLE 12110; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 13410; -name MESSAGE_DISABLE 113007; -name MESSAGE_DISABLE 10958" *)
module k0_ZTS6a_init_bb_ZTS6a_init_B0_stall_region (
    input wire [511:0] in_memdep_k0_ZTS6a_init_avm_readdata,
    input wire [0:0] in_memdep_k0_ZTS6a_init_avm_writeack,
    input wire [0:0] in_memdep_k0_ZTS6a_init_avm_waitrequest,
    input wire [0:0] in_memdep_k0_ZTS6a_init_avm_readdatavalid,
    output wire [32:0] out_memdep_k0_ZTS6a_init_avm_address,
    output wire [0:0] out_memdep_k0_ZTS6a_init_avm_enable,
    output wire [0:0] out_memdep_k0_ZTS6a_init_avm_read,
    output wire [0:0] out_memdep_k0_ZTS6a_init_avm_write,
    output wire [511:0] out_memdep_k0_ZTS6a_init_avm_writedata,
    output wire [63:0] out_memdep_k0_ZTS6a_init_avm_byteenable,
    output wire [4:0] out_memdep_k0_ZTS6a_init_avm_burstcount,
    input wire [63:0] in_arg0,
    input wire [63:0] in_arg4,
    input wire [0:0] in_flush,
    input wire [0:0] in_stall_in,
    output wire [0:0] out_stall_out,
    input wire [63:0] in_acl_global_id_0,
    input wire [63:0] in_acl_global_id_1,
    input wire [0:0] in_valid_in,
    input wire [511:0] in_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_readdata,
    input wire [0:0] in_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_writeack,
    input wire [0:0] in_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_waitrequest,
    input wire [0:0] in_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_readdatavalid,
    output wire [0:0] out_lsu_memdep_o_active,
    output wire [0:0] out_valid_out,
    output wire [32:0] out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_address,
    output wire [0:0] out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_enable,
    output wire [0:0] out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_read,
    output wire [0:0] out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_write,
    output wire [511:0] out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_writedata,
    output wire [63:0] out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_byteenable,
    output wire [4:0] out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_burstcount,
    output wire [0:0] out_lsu_unnamed_k0_ZTS6a_init6_o_active,
    input wire [63:0] in_arg2_0_tpl,
    input wire [63:0] in_arg2_1_tpl,
    input wire [63:0] in_arg3_0_tpl,
    input wire [63:0] in_arg3_1_tpl,
    input wire [63:0] in_arg7_0_tpl,
    input wire clock,
    input wire resetn
    );

    wire [0:0] GND_q;
    wire [0:0] VCC_q;
    wire [31:0] c_float_1_000000e_0016_q;
    wire [0:0] i_llvm_fpga_mem_memdep_k0_zts6a_init7_out_lsu_memdep_o_active;
    wire [32:0] i_llvm_fpga_mem_memdep_k0_zts6a_init7_out_memdep_k0_ZTS6a_init_avm_address;
    wire [4:0] i_llvm_fpga_mem_memdep_k0_zts6a_init7_out_memdep_k0_ZTS6a_init_avm_burstcount;
    wire [63:0] i_llvm_fpga_mem_memdep_k0_zts6a_init7_out_memdep_k0_ZTS6a_init_avm_byteenable;
    wire [0:0] i_llvm_fpga_mem_memdep_k0_zts6a_init7_out_memdep_k0_ZTS6a_init_avm_enable;
    wire [0:0] i_llvm_fpga_mem_memdep_k0_zts6a_init7_out_memdep_k0_ZTS6a_init_avm_read;
    wire [0:0] i_llvm_fpga_mem_memdep_k0_zts6a_init7_out_memdep_k0_ZTS6a_init_avm_write;
    wire [511:0] i_llvm_fpga_mem_memdep_k0_zts6a_init7_out_memdep_k0_ZTS6a_init_avm_writedata;
    wire [0:0] i_llvm_fpga_mem_memdep_k0_zts6a_init7_out_o_stall;
    wire [0:0] i_llvm_fpga_mem_memdep_k0_zts6a_init7_out_o_valid;
    wire [0:0] i_llvm_fpga_mem_memdep_k0_zts6a_init7_out_o_writeack;
    wire [0:0] i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_out_lsu_unnamed_k0_ZTS6a_init6_o_active;
    wire [0:0] i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_out_o_stall;
    wire [0:0] i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_out_o_valid;
    wire [32:0] i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_address;
    wire [4:0] i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_burstcount;
    wire [63:0] i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_byteenable;
    wire [0:0] i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_enable;
    wire [0:0] i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_read;
    wire [0:0] i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_write;
    wire [511:0] i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_writedata;
    wire [63:0] i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k0_zts6a_init1_out_buffer_out;
    wire [0:0] i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k0_zts6a_init1_out_stall_out;
    wire [0:0] i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k0_zts6a_init1_out_valid_out;
    wire [9:0] i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k0_zts6a_init1_vt_const_9_q;
    wire [63:0] i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k0_zts6a_init1_vt_join_q;
    wire [53:0] i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k0_zts6a_init1_vt_select_63_b;
    wire [1:0] i_unnamed_k0_zts6a_init10_vt_const_1_q;
    wire [63:0] i_unnamed_k0_zts6a_init10_vt_join_q;
    wire [61:0] i_unnamed_k0_zts6a_init10_vt_select_63_b;
    wire [6:0] i_unnamed_k0_zts6a_init5_vt_const_6_q;
    wire [63:0] i_unnamed_k0_zts6a_init5_vt_join_q;
    wire [56:0] i_unnamed_k0_zts6a_init5_vt_select_63_b;
    wire [64:0] i_unnamed_k0_zts6a_init8_a;
    wire [64:0] i_unnamed_k0_zts6a_init8_b;
    logic [64:0] i_unnamed_k0_zts6a_init8_o;
    wire [64:0] i_unnamed_k0_zts6a_init8_q;
    wire [63:0] i_unnamed_k0_zts6a_init9_vt_join_q;
    wire [61:0] i_unnamed_k0_zts6a_init9_vt_select_63_b;
    wire [0:0] ZTS6a_init_B0_merge_reg_aunroll_x_out_stall_out;
    wire [0:0] ZTS6a_init_B0_merge_reg_aunroll_x_out_valid_out;
    wire [63:0] ZTS6a_init_B0_merge_reg_aunroll_x_out_data_out_0_tpl;
    wire [63:0] ZTS6a_init_B0_merge_reg_aunroll_x_out_data_out_1_tpl;
    wire [63:0] bgTrunc_i_unnamed_k0_zts6a_init8_sel_x_b;
    wire [0:0] i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x_out_stall_out;
    wire [0:0] i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x_out_valid_out;
    wire [63:0] i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x_out_buffer_out_0_tpl;
    wire [0:0] i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1025elns2_6targete2014elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as5fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6a_inits_c0_enter_k0_zts6a_init3_aunroll_x_out_o_stall;
    wire [0:0] i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1025elns2_6targete2014elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as5fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6a_inits_c0_enter_k0_zts6a_init3_aunroll_x_out_o_valid;
    wire [63:0] i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1025elns2_6targete2014elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as5fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6a_inits_c0_enter_k0_zts6a_init3_aunroll_x_out_c0_exit_1_tpl;
    wire [64:0] dupName_1_i_unnamed_k0_zts6a_init0_add_x_a;
    wire [64:0] dupName_1_i_unnamed_k0_zts6a_init0_add_x_b;
    logic [64:0] dupName_1_i_unnamed_k0_zts6a_init0_add_x_o;
    wire [64:0] dupName_1_i_unnamed_k0_zts6a_init0_add_x_q;
    wire [61:0] dupName_1_i_unnamed_k0_zts6a_init0_narrow_x_b;
    wire [63:0] dupName_1_i_unnamed_k0_zts6a_init0_shift_join_x_q;
    wire [63:0] dupName_1_i_unnamed_k0_zts6a_init0_dupName_0_trunc_sel_x_b;
    wire [64:0] dupName_2_i_unnamed_k0_zts6a_init0_add_x_a;
    wire [64:0] dupName_2_i_unnamed_k0_zts6a_init0_add_x_b;
    logic [64:0] dupName_2_i_unnamed_k0_zts6a_init0_add_x_o;
    wire [64:0] dupName_2_i_unnamed_k0_zts6a_init0_add_x_q;
    wire [61:0] dupName_2_i_unnamed_k0_zts6a_init0_narrow_x_b;
    wire [63:0] dupName_2_i_unnamed_k0_zts6a_init0_shift_join_x_q;
    wire [63:0] dupName_2_i_unnamed_k0_zts6a_init0_dupName_0_trunc_sel_x_b;
    wire [62:0] leftShiftStage0Idx1Rng1_uid80_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_in;
    wire [62:0] leftShiftStage0Idx1Rng1_uid80_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_b;
    wire [63:0] leftShiftStage0Idx1_uid81_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_q;
    wire [0:0] leftShiftStage0_uid83_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_s;
    reg [63:0] leftShiftStage0_uid83_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_q;
    wire [61:0] leftShiftStage1Idx1Rng2_uid85_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_in;
    wire [61:0] leftShiftStage1Idx1Rng2_uid85_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_b;
    wire [63:0] leftShiftStage1Idx1_uid86_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_q;
    wire [0:0] leftShiftStage1_uid88_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_s;
    reg [63:0] leftShiftStage1_uid88_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_q;
    wire [3:0] leftShiftStage2Idx1Pad4_uid89_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_q;
    wire [59:0] leftShiftStage2Idx1Rng4_uid90_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_in;
    wire [59:0] leftShiftStage2Idx1Rng4_uid90_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_b;
    wire [63:0] leftShiftStage2Idx1_uid91_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_q;
    wire [0:0] leftShiftStage2_uid93_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_s;
    reg [63:0] leftShiftStage2_uid93_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_q;
    wire [0:0] redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_valid_in;
    wire redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_valid_in_bitsignaltemp;
    wire [0:0] redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_stall_in;
    wire redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_stall_in_bitsignaltemp;
    wire [61:0] redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_data_in;
    wire [0:0] redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_valid_out;
    wire redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_valid_out_bitsignaltemp;
    wire [0:0] redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_stall_out;
    wire redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_stall_out_bitsignaltemp;
    wire [61:0] redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_data_out;
    wire [0:0] bubble_join_i_llvm_fpga_mem_memdep_k0_zts6a_init7_q;
    wire [0:0] bubble_select_i_llvm_fpga_mem_memdep_k0_zts6a_init7_b;
    wire [63:0] bubble_join_i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k0_zts6a_init1_q;
    wire [63:0] bubble_select_i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k0_zts6a_init1_b;
    wire [127:0] bubble_join_stall_entry_q;
    wire [63:0] bubble_select_stall_entry_b;
    wire [63:0] bubble_select_stall_entry_c;
    wire [127:0] bubble_join_ZTS6a_init_B0_merge_reg_aunroll_x_q;
    wire [63:0] bubble_select_ZTS6a_init_B0_merge_reg_aunroll_x_b;
    wire [63:0] bubble_select_ZTS6a_init_B0_merge_reg_aunroll_x_c;
    wire [63:0] bubble_join_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x_q;
    wire [63:0] bubble_select_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x_b;
    wire [63:0] bubble_join_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1025elns2_6targete2014elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as5fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6a_inits_c0_enter_k0_zts6a_init3_aunroll_x_q;
    wire [63:0] bubble_select_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1025elns2_6targete2014elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as5fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6a_inits_c0_enter_k0_zts6a_init3_aunroll_x_b;
    wire [61:0] bubble_join_redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_q;
    wire [61:0] bubble_select_redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_b;
    wire [0:0] SE_out_i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_wireValid;
    wire [0:0] SE_out_i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_backStall;
    wire [0:0] SE_out_i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_V0;
    wire [0:0] SE_stall_entry_wireValid;
    wire [0:0] SE_stall_entry_backStall;
    wire [0:0] SE_stall_entry_V0;
    wire [0:0] SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_wireValid;
    wire [0:0] SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_wireStall;
    wire [0:0] SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_StallValid;
    wire [0:0] SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_toReg0;
    reg [0:0] SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_fromReg0;
    wire [0:0] SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_consumed0;
    wire [0:0] SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_toReg1;
    reg [0:0] SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_fromReg1;
    wire [0:0] SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_consumed1;
    wire [0:0] SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_toReg2;
    reg [0:0] SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_fromReg2;
    wire [0:0] SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_consumed2;
    wire [0:0] SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_toReg3;
    reg [0:0] SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_fromReg3;
    wire [0:0] SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_consumed3;
    wire [0:0] SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_or0;
    wire [0:0] SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_or1;
    wire [0:0] SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_or2;
    wire [0:0] SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_backStall;
    wire [0:0] SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_V0;
    wire [0:0] SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_V1;
    wire [0:0] SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_V2;
    wire [0:0] SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_V3;
    wire [0:0] SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x_wireValid;
    wire [0:0] SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x_and0;
    wire [0:0] SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x_and1;
    wire [0:0] SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x_backStall;
    wire [0:0] SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x_V0;
    wire [0:0] SE_out_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1025elns2_6targete2014elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as5fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6a_inits_c0_enter_k0_zts6a_init3_aunroll_x_wireValid;
    wire [0:0] SE_out_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1025elns2_6targete2014elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as5fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6a_inits_c0_enter_k0_zts6a_init3_aunroll_x_backStall;
    wire [0:0] SE_out_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1025elns2_6targete2014elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as5fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6a_inits_c0_enter_k0_zts6a_init3_aunroll_x_V0;
    wire [0:0] SE_out_redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_wireValid;
    wire [0:0] SE_out_redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_and0;
    wire [0:0] SE_out_redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_backStall;
    wire [0:0] SE_out_redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_V0;


    // c_float_1_000000e_0016(FLOATCONSTANT,3)
    assign c_float_1_000000e_0016_q = $unsigned(32'b00111111100000000000000000000000);

    // bubble_join_stall_entry(BITJOIN,104)
    assign bubble_join_stall_entry_q = {in_acl_global_id_1, in_acl_global_id_0};

    // bubble_select_stall_entry(BITSELECT,105)
    assign bubble_select_stall_entry_b = $unsigned(bubble_join_stall_entry_q[63:0]);
    assign bubble_select_stall_entry_c = $unsigned(bubble_join_stall_entry_q[127:64]);

    // SE_stall_entry(STALLENABLE,136)
    // Valid signal propagation
    assign SE_stall_entry_V0 = SE_stall_entry_wireValid;
    // Backward Stall generation
    assign SE_stall_entry_backStall = ZTS6a_init_B0_merge_reg_aunroll_x_out_stall_out | ~ (SE_stall_entry_wireValid);
    // Computing multiple Valid(s)
    assign SE_stall_entry_wireValid = in_valid_in;

    // ZTS6a_init_B0_merge_reg_aunroll_x(BLACKBOX,46)@0
    // in in_stall_in@20000000
    // out out_stall_out@20000000
    // out out_valid_out@1
    // out out_data_out_0_tpl@1
    // out out_data_out_1_tpl@1
    k0_ZTS6a_init_ZTS6a_init_B0_merge_reg theZTS6a_init_B0_merge_reg_aunroll_x (
        .in_stall_in(SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_backStall),
        .in_valid_in(SE_stall_entry_V0),
        .in_data_in_0_tpl(bubble_select_stall_entry_b),
        .in_data_in_1_tpl(bubble_select_stall_entry_c),
        .out_stall_out(ZTS6a_init_B0_merge_reg_aunroll_x_out_stall_out),
        .out_valid_out(ZTS6a_init_B0_merge_reg_aunroll_x_out_valid_out),
        .out_data_out_0_tpl(ZTS6a_init_B0_merge_reg_aunroll_x_out_data_out_0_tpl),
        .out_data_out_1_tpl(ZTS6a_init_B0_merge_reg_aunroll_x_out_data_out_1_tpl),
        .clock(clock),
        .resetn(resetn)
    );

    // bubble_join_ZTS6a_init_B0_merge_reg_aunroll_x(BITJOIN,108)
    assign bubble_join_ZTS6a_init_B0_merge_reg_aunroll_x_q = {ZTS6a_init_B0_merge_reg_aunroll_x_out_data_out_1_tpl, ZTS6a_init_B0_merge_reg_aunroll_x_out_data_out_0_tpl};

    // bubble_select_ZTS6a_init_B0_merge_reg_aunroll_x(BITSELECT,109)
    assign bubble_select_ZTS6a_init_B0_merge_reg_aunroll_x_b = $unsigned(bubble_join_ZTS6a_init_B0_merge_reg_aunroll_x_q[63:0]);
    assign bubble_select_ZTS6a_init_B0_merge_reg_aunroll_x_c = $unsigned(bubble_join_ZTS6a_init_B0_merge_reg_aunroll_x_q[127:64]);

    // leftShiftStage2Idx1Rng4_uid90_dupName_0_i_unnamed_k0_zts6a_init0_shift_x(BITSELECT,89)@1
    assign leftShiftStage2Idx1Rng4_uid90_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_in = leftShiftStage1_uid88_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_q[59:0];
    assign leftShiftStage2Idx1Rng4_uid90_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_b = leftShiftStage2Idx1Rng4_uid90_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_in[59:0];

    // leftShiftStage2Idx1Pad4_uid89_dupName_0_i_unnamed_k0_zts6a_init0_shift_x(CONSTANT,88)
    assign leftShiftStage2Idx1Pad4_uid89_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_q = $unsigned(4'b0000);

    // leftShiftStage2Idx1_uid91_dupName_0_i_unnamed_k0_zts6a_init0_shift_x(BITJOIN,90)@1
    assign leftShiftStage2Idx1_uid91_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_q = {leftShiftStage2Idx1Rng4_uid90_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_b, leftShiftStage2Idx1Pad4_uid89_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_q};

    // leftShiftStage1Idx1Rng2_uid85_dupName_0_i_unnamed_k0_zts6a_init0_shift_x(BITSELECT,84)@1
    assign leftShiftStage1Idx1Rng2_uid85_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_in = leftShiftStage0_uid83_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_q[61:0];
    assign leftShiftStage1Idx1Rng2_uid85_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_b = leftShiftStage1Idx1Rng2_uid85_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_in[61:0];

    // leftShiftStage1Idx1_uid86_dupName_0_i_unnamed_k0_zts6a_init0_shift_x(BITJOIN,85)@1
    assign leftShiftStage1Idx1_uid86_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_q = {leftShiftStage1Idx1Rng2_uid85_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_b, i_unnamed_k0_zts6a_init10_vt_const_1_q};

    // leftShiftStage0Idx1Rng1_uid80_dupName_0_i_unnamed_k0_zts6a_init0_shift_x(BITSELECT,79)@1
    assign leftShiftStage0Idx1Rng1_uid80_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_in = bubble_select_ZTS6a_init_B0_merge_reg_aunroll_x_c[62:0];
    assign leftShiftStage0Idx1Rng1_uid80_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_b = leftShiftStage0Idx1Rng1_uid80_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_in[62:0];

    // leftShiftStage0Idx1_uid81_dupName_0_i_unnamed_k0_zts6a_init0_shift_x(BITJOIN,80)@1
    assign leftShiftStage0Idx1_uid81_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_q = {leftShiftStage0Idx1Rng1_uid80_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_b, GND_q};

    // leftShiftStage0_uid83_dupName_0_i_unnamed_k0_zts6a_init0_shift_x(MUX,82)@1
    assign leftShiftStage0_uid83_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_s = VCC_q;
    always @(leftShiftStage0_uid83_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_s or bubble_select_ZTS6a_init_B0_merge_reg_aunroll_x_c or leftShiftStage0Idx1_uid81_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_q)
    begin
        unique case (leftShiftStage0_uid83_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_s)
            1'b0 : leftShiftStage0_uid83_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_q = bubble_select_ZTS6a_init_B0_merge_reg_aunroll_x_c;
            1'b1 : leftShiftStage0_uid83_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_q = leftShiftStage0Idx1_uid81_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_q;
            default : leftShiftStage0_uid83_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_q = 64'b0;
        endcase
    end

    // leftShiftStage1_uid88_dupName_0_i_unnamed_k0_zts6a_init0_shift_x(MUX,87)@1
    assign leftShiftStage1_uid88_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_s = VCC_q;
    always @(leftShiftStage1_uid88_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_s or leftShiftStage0_uid83_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_q or leftShiftStage1Idx1_uid86_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_q)
    begin
        unique case (leftShiftStage1_uid88_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_s)
            1'b0 : leftShiftStage1_uid88_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_q = leftShiftStage0_uid83_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_q;
            1'b1 : leftShiftStage1_uid88_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_q = leftShiftStage1Idx1_uid86_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_q;
            default : leftShiftStage1_uid88_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_q = 64'b0;
        endcase
    end

    // VCC(CONSTANT,1)
    assign VCC_q = $unsigned(1'b1);

    // leftShiftStage2_uid93_dupName_0_i_unnamed_k0_zts6a_init0_shift_x(MUX,92)@1
    assign leftShiftStage2_uid93_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_s = VCC_q;
    always @(leftShiftStage2_uid93_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_s or leftShiftStage1_uid88_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_q or leftShiftStage2Idx1_uid91_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_q)
    begin
        unique case (leftShiftStage2_uid93_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_s)
            1'b0 : leftShiftStage2_uid93_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_q = leftShiftStage1_uid88_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_q;
            1'b1 : leftShiftStage2_uid93_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_q = leftShiftStage2Idx1_uid91_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_q;
            default : leftShiftStage2_uid93_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_q = 64'b0;
        endcase
    end

    // i_unnamed_k0_zts6a_init5_vt_select_63(BITSELECT,21)@1
    assign i_unnamed_k0_zts6a_init5_vt_select_63_b = leftShiftStage2_uid93_dupName_0_i_unnamed_k0_zts6a_init0_shift_x_q[63:7];

    // i_unnamed_k0_zts6a_init5_vt_const_6(CONSTANT,19)
    assign i_unnamed_k0_zts6a_init5_vt_const_6_q = $unsigned(7'b0000000);

    // i_unnamed_k0_zts6a_init5_vt_join(BITJOIN,20)@1
    assign i_unnamed_k0_zts6a_init5_vt_join_q = {i_unnamed_k0_zts6a_init5_vt_select_63_b, i_unnamed_k0_zts6a_init5_vt_const_6_q};

    // i_unnamed_k0_zts6a_init8(ADD,22)@1
    assign i_unnamed_k0_zts6a_init8_a = {1'b0, i_unnamed_k0_zts6a_init5_vt_join_q};
    assign i_unnamed_k0_zts6a_init8_b = {1'b0, bubble_select_ZTS6a_init_B0_merge_reg_aunroll_x_b};
    assign i_unnamed_k0_zts6a_init8_o = $unsigned(i_unnamed_k0_zts6a_init8_a) + $unsigned(i_unnamed_k0_zts6a_init8_b);
    assign i_unnamed_k0_zts6a_init8_q = i_unnamed_k0_zts6a_init8_o[64:0];

    // bgTrunc_i_unnamed_k0_zts6a_init8_sel_x(BITSELECT,47)@1
    assign bgTrunc_i_unnamed_k0_zts6a_init8_sel_x_b = i_unnamed_k0_zts6a_init8_q[63:0];

    // dupName_2_i_unnamed_k0_zts6a_init0_narrow_x(BITSELECT,70)@1
    assign dupName_2_i_unnamed_k0_zts6a_init0_narrow_x_b = bgTrunc_i_unnamed_k0_zts6a_init8_sel_x_b[61:0];

    // i_unnamed_k0_zts6a_init10_vt_const_1(CONSTANT,16)
    assign i_unnamed_k0_zts6a_init10_vt_const_1_q = $unsigned(2'b00);

    // dupName_2_i_unnamed_k0_zts6a_init0_shift_join_x(BITJOIN,71)@1
    assign dupName_2_i_unnamed_k0_zts6a_init0_shift_join_x_q = {dupName_2_i_unnamed_k0_zts6a_init0_narrow_x_b, i_unnamed_k0_zts6a_init10_vt_const_1_q};

    // bubble_join_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x(BITJOIN,113)
    assign bubble_join_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x_q = i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x_out_buffer_out_0_tpl;

    // bubble_select_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x(BITSELECT,114)
    assign bubble_select_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x_b = $unsigned(bubble_join_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x_q[63:0]);

    // dupName_1_i_unnamed_k0_zts6a_init0_narrow_x(BITSELECT,64)@1
    assign dupName_1_i_unnamed_k0_zts6a_init0_narrow_x_b = bubble_select_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x_b[61:0];

    // dupName_1_i_unnamed_k0_zts6a_init0_shift_join_x(BITJOIN,65)@1
    assign dupName_1_i_unnamed_k0_zts6a_init0_shift_join_x_q = {dupName_1_i_unnamed_k0_zts6a_init0_narrow_x_b, i_unnamed_k0_zts6a_init10_vt_const_1_q};

    // bubble_join_i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k0_zts6a_init1(BITJOIN,101)
    assign bubble_join_i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k0_zts6a_init1_q = i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k0_zts6a_init1_out_buffer_out;

    // bubble_select_i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k0_zts6a_init1(BITSELECT,102)
    assign bubble_select_i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k0_zts6a_init1_b = $unsigned(bubble_join_i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k0_zts6a_init1_q[63:0]);

    // i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k0_zts6a_init1_vt_select_63(BITSELECT,15)@1
    assign i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k0_zts6a_init1_vt_select_63_b = bubble_select_i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k0_zts6a_init1_b[63:10];

    // i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k0_zts6a_init1_vt_const_9(CONSTANT,13)
    assign i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k0_zts6a_init1_vt_const_9_q = $unsigned(10'b0000000000);

    // i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k0_zts6a_init1_vt_join(BITJOIN,14)@1
    assign i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k0_zts6a_init1_vt_join_q = {i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k0_zts6a_init1_vt_select_63_b, i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k0_zts6a_init1_vt_const_9_q};

    // dupName_1_i_unnamed_k0_zts6a_init0_add_x(ADD,62)@1
    assign dupName_1_i_unnamed_k0_zts6a_init0_add_x_a = {1'b0, i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k0_zts6a_init1_vt_join_q};
    assign dupName_1_i_unnamed_k0_zts6a_init0_add_x_b = {1'b0, dupName_1_i_unnamed_k0_zts6a_init0_shift_join_x_q};
    assign dupName_1_i_unnamed_k0_zts6a_init0_add_x_o = $unsigned(dupName_1_i_unnamed_k0_zts6a_init0_add_x_a) + $unsigned(dupName_1_i_unnamed_k0_zts6a_init0_add_x_b);
    assign dupName_1_i_unnamed_k0_zts6a_init0_add_x_q = dupName_1_i_unnamed_k0_zts6a_init0_add_x_o[64:0];

    // dupName_1_i_unnamed_k0_zts6a_init0_dupName_0_trunc_sel_x(BITSELECT,67)@1
    assign dupName_1_i_unnamed_k0_zts6a_init0_dupName_0_trunc_sel_x_b = dupName_1_i_unnamed_k0_zts6a_init0_add_x_q[63:0];

    // i_unnamed_k0_zts6a_init9_vt_select_63(BITSELECT,25)@1
    assign i_unnamed_k0_zts6a_init9_vt_select_63_b = dupName_1_i_unnamed_k0_zts6a_init0_dupName_0_trunc_sel_x_b[63:2];

    // i_unnamed_k0_zts6a_init9_vt_join(BITJOIN,24)@1
    assign i_unnamed_k0_zts6a_init9_vt_join_q = {i_unnamed_k0_zts6a_init9_vt_select_63_b, i_unnamed_k0_zts6a_init10_vt_const_1_q};

    // dupName_2_i_unnamed_k0_zts6a_init0_add_x(ADD,68)@1
    assign dupName_2_i_unnamed_k0_zts6a_init0_add_x_a = {1'b0, i_unnamed_k0_zts6a_init9_vt_join_q};
    assign dupName_2_i_unnamed_k0_zts6a_init0_add_x_b = {1'b0, dupName_2_i_unnamed_k0_zts6a_init0_shift_join_x_q};
    assign dupName_2_i_unnamed_k0_zts6a_init0_add_x_o = $unsigned(dupName_2_i_unnamed_k0_zts6a_init0_add_x_a) + $unsigned(dupName_2_i_unnamed_k0_zts6a_init0_add_x_b);
    assign dupName_2_i_unnamed_k0_zts6a_init0_add_x_q = dupName_2_i_unnamed_k0_zts6a_init0_add_x_o[64:0];

    // dupName_2_i_unnamed_k0_zts6a_init0_dupName_0_trunc_sel_x(BITSELECT,73)@1
    assign dupName_2_i_unnamed_k0_zts6a_init0_dupName_0_trunc_sel_x_b = dupName_2_i_unnamed_k0_zts6a_init0_add_x_q[63:0];

    // i_unnamed_k0_zts6a_init10_vt_select_63(BITSELECT,18)@1
    assign i_unnamed_k0_zts6a_init10_vt_select_63_b = dupName_2_i_unnamed_k0_zts6a_init0_dupName_0_trunc_sel_x_b[63:2];

    // redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo(STALLFIFO,95)
    assign redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_valid_in = SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x_V0;
    assign redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_stall_in = SE_out_redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_backStall;
    assign redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_data_in = i_unnamed_k0_zts6a_init10_vt_select_63_b;
    assign redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_valid_in_bitsignaltemp = redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_valid_in[0];
    assign redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_stall_in_bitsignaltemp = redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_stall_in[0];
    assign redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_valid_out[0] = redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_valid_out_bitsignaltemp;
    assign redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_stall_out[0] = redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_stall_out_bitsignaltemp;
    acl_data_fifo #(
        .DEPTH(59),
        .STRICT_DEPTH(0),
        .ALLOW_FULL_WRITE(0),
        .DATA_WIDTH(62),
        .IMPL("ram")
    ) theredist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo (
        .valid_in(redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_valid_in_bitsignaltemp),
        .stall_in(redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_stall_in_bitsignaltemp),
        .data_in(i_unnamed_k0_zts6a_init10_vt_select_63_b),
        .valid_out(redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_valid_out_bitsignaltemp),
        .stall_out(redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_stall_out_bitsignaltemp),
        .data_out(redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_data_out),
        .clock(clock),
        .resetn(resetn)
    );

    // SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x(STALLENABLE,142)
    // Valid signal propagation
    assign SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x_V0 = SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x_wireValid;
    // Backward Stall generation
    assign SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x_backStall = redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_stall_out | ~ (SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x_wireValid);
    // Computing multiple Valid(s)
    assign SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x_and0 = i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x_out_valid_out;
    assign SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x_and1 = i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k0_zts6a_init1_out_valid_out & SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x_and0;
    assign SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x_wireValid = SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_V3 & SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x_and1;

    // i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x(BLACKBOX,53)@1
    // in in_stall_in@20000000
    // out out_stall_out@20000000
    k0_ZTS6a_init_i_llvm_fpga_sync_buffer_s_0000uffer_k0_zts6a_init0 thei_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x (
        .in_i_dependence(GND_q),
        .in_stall_in(SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x_backStall),
        .in_valid_in(SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_V1),
        .in_buffer_in_0_tpl(in_arg7_0_tpl),
        .out_stall_out(i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x_out_stall_out),
        .out_valid_out(i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x_out_valid_out),
        .out_buffer_out_0_tpl(i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x_out_buffer_out_0_tpl),
        .clock(clock),
        .resetn(resetn)
    );

    // i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k0_zts6a_init1(BLACKBOX,12)@1
    // in in_stall_in@20000000
    // out out_stall_out@20000000
    k0_ZTS6a_init_i_llvm_fpga_sync_buffer_p10000uffer_k0_zts6a_init0 thei_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k0_zts6a_init1 (
        .in_buffer_in(in_arg4),
        .in_i_dependence(GND_q),
        .in_stall_in(SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x_backStall),
        .in_valid_in(SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_V0),
        .out_buffer_out(i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k0_zts6a_init1_out_buffer_out),
        .out_stall_out(i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k0_zts6a_init1_out_stall_out),
        .out_valid_out(i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k0_zts6a_init1_out_valid_out),
        .clock(clock),
        .resetn(resetn)
    );

    // SE_out_ZTS6a_init_B0_merge_reg_aunroll_x(STALLENABLE,139)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_fromReg0 <= '0;
            SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_fromReg1 <= '0;
            SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_fromReg2 <= '0;
            SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_fromReg3 <= '0;
        end
        else
        begin
            // Successor 0
            SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_fromReg0 <= SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_toReg0;
            // Successor 1
            SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_fromReg1 <= SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_toReg1;
            // Successor 2
            SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_fromReg2 <= SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_toReg2;
            // Successor 3
            SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_fromReg3 <= SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_toReg3;
        end
    end
    // Input Stall processing
    assign SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_consumed0 = (~ (i_llvm_fpga_sync_buffer_p1024f32_arg4_sync_buffer_k0_zts6a_init1_out_stall_out) & SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_wireValid) | SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_fromReg0;
    assign SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_consumed1 = (~ (i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x_out_stall_out) & SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_wireValid) | SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_fromReg1;
    assign SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_consumed2 = (~ (i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1025elns2_6targete2014elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as5fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6a_inits_c0_enter_k0_zts6a_init3_aunroll_x_out_o_stall) & SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_wireValid) | SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_fromReg2;
    assign SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_consumed3 = (~ (SE_out_i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili1eee_cl_sycl_ranges_arg7_sync_buffer_k0_zts6a_init0_aunroll_x_backStall) & SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_wireValid) | SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_fromReg3;
    // Consuming
    assign SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_StallValid = SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_backStall & SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_wireValid;
    assign SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_toReg0 = SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_StallValid & SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_consumed0;
    assign SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_toReg1 = SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_StallValid & SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_consumed1;
    assign SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_toReg2 = SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_StallValid & SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_consumed2;
    assign SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_toReg3 = SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_StallValid & SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_consumed3;
    // Backward Stall generation
    assign SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_or0 = SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_consumed0;
    assign SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_or1 = SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_consumed1 & SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_or0;
    assign SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_or2 = SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_consumed2 & SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_or1;
    assign SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_wireStall = ~ (SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_consumed3 & SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_or2);
    assign SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_backStall = SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_wireStall;
    // Valid signal propagation
    assign SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_V0 = SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_wireValid & ~ (SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_fromReg0);
    assign SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_V1 = SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_wireValid & ~ (SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_fromReg1);
    assign SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_V2 = SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_wireValid & ~ (SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_fromReg2);
    assign SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_V3 = SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_wireValid & ~ (SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_fromReg3);
    // Computing multiple Valid(s)
    assign SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_wireValid = ZTS6a_init_B0_merge_reg_aunroll_x_out_valid_out;

    // i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1025elns2_6targete2014elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as5fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6a_inits_c0_enter_k0_zts6a_init3_aunroll_x(BLACKBOX,54)@1
    // in in_i_stall@20000000
    // out out_o_stall@20000000
    // out out_o_valid@11
    // out out_c0_exit_0_tpl@11
    // out out_c0_exit_1_tpl@11
    k0_ZTS6a_init_i_sfc_s_c0_in_zn2cl4sycl8a0000enter_k0_zts6a_init3 thei_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1025elns2_6targete2014elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as5fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6a_inits_c0_enter_k0_zts6a_init3_aunroll_x (
        .in_arg0(in_arg0),
        .in_i_stall(SE_out_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1025elns2_6targete2014elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as5fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6a_inits_c0_enter_k0_zts6a_init3_aunroll_x_backStall),
        .in_i_valid(SE_out_ZTS6a_init_B0_merge_reg_aunroll_x_V2),
        .in_arg2_0_tpl(in_arg2_0_tpl),
        .in_arg2_1_tpl(in_arg2_1_tpl),
        .in_arg3_0_tpl(in_arg3_0_tpl),
        .in_arg3_1_tpl(in_arg3_1_tpl),
        .in_c0_eni2_0_tpl(GND_q),
        .in_c0_eni2_1_tpl(bubble_select_ZTS6a_init_B0_merge_reg_aunroll_x_c),
        .in_c0_eni2_2_tpl(bubble_select_ZTS6a_init_B0_merge_reg_aunroll_x_b),
        .out_o_stall(i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1025elns2_6targete2014elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as5fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6a_inits_c0_enter_k0_zts6a_init3_aunroll_x_out_o_stall),
        .out_o_valid(i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1025elns2_6targete2014elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as5fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6a_inits_c0_enter_k0_zts6a_init3_aunroll_x_out_o_valid),
        .out_c0_exit_0_tpl(),
        .out_c0_exit_1_tpl(i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1025elns2_6targete2014elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as5fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6a_inits_c0_enter_k0_zts6a_init3_aunroll_x_out_c0_exit_1_tpl),
        .clock(clock),
        .resetn(resetn)
    );

    // SE_out_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1025elns2_6targete2014elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as5fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6a_inits_c0_enter_k0_zts6a_init3_aunroll_x(STALLENABLE,144)
    // Valid signal propagation
    assign SE_out_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1025elns2_6targete2014elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as5fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6a_inits_c0_enter_k0_zts6a_init3_aunroll_x_V0 = SE_out_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1025elns2_6targete2014elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as5fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6a_inits_c0_enter_k0_zts6a_init3_aunroll_x_wireValid;
    // Backward Stall generation
    assign SE_out_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1025elns2_6targete2014elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as5fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6a_inits_c0_enter_k0_zts6a_init3_aunroll_x_backStall = i_llvm_fpga_mem_memdep_k0_zts6a_init7_out_o_stall | ~ (SE_out_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1025elns2_6targete2014elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as5fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6a_inits_c0_enter_k0_zts6a_init3_aunroll_x_wireValid);
    // Computing multiple Valid(s)
    assign SE_out_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1025elns2_6targete2014elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as5fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6a_inits_c0_enter_k0_zts6a_init3_aunroll_x_wireValid = i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1025elns2_6targete2014elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as5fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6a_inits_c0_enter_k0_zts6a_init3_aunroll_x_out_o_valid;

    // SE_out_i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11(STALLENABLE,124)
    // Valid signal propagation
    assign SE_out_i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_V0 = SE_out_i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_wireValid;
    // Backward Stall generation
    assign SE_out_i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_backStall = in_stall_in | ~ (SE_out_i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_wireValid);
    // Computing multiple Valid(s)
    assign SE_out_i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_wireValid = i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_out_o_valid;

    // bubble_join_i_llvm_fpga_mem_memdep_k0_zts6a_init7(BITJOIN,97)
    assign bubble_join_i_llvm_fpga_mem_memdep_k0_zts6a_init7_q = i_llvm_fpga_mem_memdep_k0_zts6a_init7_out_o_writeack;

    // bubble_select_i_llvm_fpga_mem_memdep_k0_zts6a_init7(BITSELECT,98)
    assign bubble_select_i_llvm_fpga_mem_memdep_k0_zts6a_init7_b = $unsigned(bubble_join_i_llvm_fpga_mem_memdep_k0_zts6a_init7_q[0:0]);

    // bubble_join_redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo(BITJOIN,119)
    assign bubble_join_redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_q = redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_data_out;

    // bubble_select_redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo(BITSELECT,120)
    assign bubble_select_redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_b = $unsigned(bubble_join_redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_q[61:0]);

    // i_unnamed_k0_zts6a_init10_vt_join(BITJOIN,17)@59
    assign i_unnamed_k0_zts6a_init10_vt_join_q = {bubble_select_redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_b, i_unnamed_k0_zts6a_init10_vt_const_1_q};

    // i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11(BLACKBOX,11)@59
    // in in_i_stall@20000000
    // out out_lsu_unnamed_k0_ZTS6a_init6_o_active@20000000
    // out out_o_stall@20000000
    // out out_o_valid@61
    // out out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_address@20000000
    // out out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_burstcount@20000000
    // out out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_byteenable@20000000
    // out out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_enable@20000000
    // out out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_read@20000000
    // out out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_write@20000000
    // out out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_writedata@20000000
    k0_ZTS6a_init_i_llvm_fpga_mem_unnamed_k00000init6_k0_zts6a_init0 thei_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11 (
        .in_flush(in_flush),
        .in_i_address(i_unnamed_k0_zts6a_init10_vt_join_q),
        .in_i_dependence(bubble_select_i_llvm_fpga_mem_memdep_k0_zts6a_init7_b),
        .in_i_predicate(GND_q),
        .in_i_stall(SE_out_i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_backStall),
        .in_i_valid(SE_out_redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_V0),
        .in_i_writedata(c_float_1_000000e_0016_q),
        .in_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_readdata(in_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_readdata),
        .in_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_readdatavalid(in_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_readdatavalid),
        .in_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_waitrequest(in_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_waitrequest),
        .in_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_writeack(in_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_writeack),
        .out_lsu_unnamed_k0_ZTS6a_init6_o_active(i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_out_lsu_unnamed_k0_ZTS6a_init6_o_active),
        .out_o_stall(i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_out_o_stall),
        .out_o_valid(i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_out_o_valid),
        .out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_address(i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_address),
        .out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_burstcount(i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_burstcount),
        .out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_byteenable(i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_byteenable),
        .out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_enable(i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_enable),
        .out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_read(i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_read),
        .out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_write(i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_write),
        .out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_writedata(i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_writedata),
        .clock(clock),
        .resetn(resetn)
    );

    // SE_out_redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo(STALLENABLE,163)
    // Valid signal propagation
    assign SE_out_redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_V0 = SE_out_redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_wireValid;
    // Backward Stall generation
    assign SE_out_redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_backStall = i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_out_o_stall | ~ (SE_out_redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_wireValid);
    // Computing multiple Valid(s)
    assign SE_out_redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_and0 = redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_valid_out;
    assign SE_out_redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_wireValid = i_llvm_fpga_mem_memdep_k0_zts6a_init7_out_o_valid & SE_out_redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_and0;

    // GND(CONSTANT,0)
    assign GND_q = $unsigned(1'b0);

    // bubble_join_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1025elns2_6targete2014elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as5fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6a_inits_c0_enter_k0_zts6a_init3_aunroll_x(BITJOIN,116)
    assign bubble_join_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1025elns2_6targete2014elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as5fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6a_inits_c0_enter_k0_zts6a_init3_aunroll_x_q = i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1025elns2_6targete2014elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as5fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6a_inits_c0_enter_k0_zts6a_init3_aunroll_x_out_c0_exit_1_tpl;

    // bubble_select_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1025elns2_6targete2014elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as5fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6a_inits_c0_enter_k0_zts6a_init3_aunroll_x(BITSELECT,117)
    assign bubble_select_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1025elns2_6targete2014elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as5fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6a_inits_c0_enter_k0_zts6a_init3_aunroll_x_b = $unsigned(bubble_join_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1025elns2_6targete2014elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as5fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6a_inits_c0_enter_k0_zts6a_init3_aunroll_x_q[63:0]);

    // i_llvm_fpga_mem_memdep_k0_zts6a_init7(BLACKBOX,10)@11
    // in in_i_stall@20000000
    // out out_lsu_memdep_o_active@20000000
    // out out_memdep_k0_ZTS6a_init_avm_address@20000000
    // out out_memdep_k0_ZTS6a_init_avm_burstcount@20000000
    // out out_memdep_k0_ZTS6a_init_avm_byteenable@20000000
    // out out_memdep_k0_ZTS6a_init_avm_enable@20000000
    // out out_memdep_k0_ZTS6a_init_avm_read@20000000
    // out out_memdep_k0_ZTS6a_init_avm_write@20000000
    // out out_memdep_k0_ZTS6a_init_avm_writedata@20000000
    // out out_o_stall@20000000
    // out out_o_valid@59
    // out out_o_writeack@59
    k0_ZTS6a_init_i_llvm_fpga_mem_memdep_k0_zts6a_init0 thei_llvm_fpga_mem_memdep_k0_zts6a_init7 (
        .in_flush(in_flush),
        .in_i_address(bubble_select_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1025elns2_6targete2014elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as5fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6a_inits_c0_enter_k0_zts6a_init3_aunroll_x_b),
        .in_i_predicate(GND_q),
        .in_i_stall(SE_out_redist0_i_unnamed_k0_zts6a_init10_vt_select_63_b_58_fifo_backStall),
        .in_i_valid(SE_out_i_sfc_s_c0_in_zn2cl4sycl8accessorifli2elns0_6access4modee1025elns2_6targete2014elns2_11placeholdere0ens0_6oneapi22accessor_property_listijeeee6_initepu3as5fns0_5rangeili2eeesd_ns0_2idili2eee_exit_zts6a_inits_c0_enter_k0_zts6a_init3_aunroll_x_V0),
        .in_i_writedata(c_float_1_000000e_0016_q),
        .in_memdep_k0_ZTS6a_init_avm_readdata(in_memdep_k0_ZTS6a_init_avm_readdata),
        .in_memdep_k0_ZTS6a_init_avm_readdatavalid(in_memdep_k0_ZTS6a_init_avm_readdatavalid),
        .in_memdep_k0_ZTS6a_init_avm_waitrequest(in_memdep_k0_ZTS6a_init_avm_waitrequest),
        .in_memdep_k0_ZTS6a_init_avm_writeack(in_memdep_k0_ZTS6a_init_avm_writeack),
        .out_lsu_memdep_o_active(i_llvm_fpga_mem_memdep_k0_zts6a_init7_out_lsu_memdep_o_active),
        .out_memdep_k0_ZTS6a_init_avm_address(i_llvm_fpga_mem_memdep_k0_zts6a_init7_out_memdep_k0_ZTS6a_init_avm_address),
        .out_memdep_k0_ZTS6a_init_avm_burstcount(i_llvm_fpga_mem_memdep_k0_zts6a_init7_out_memdep_k0_ZTS6a_init_avm_burstcount),
        .out_memdep_k0_ZTS6a_init_avm_byteenable(i_llvm_fpga_mem_memdep_k0_zts6a_init7_out_memdep_k0_ZTS6a_init_avm_byteenable),
        .out_memdep_k0_ZTS6a_init_avm_enable(i_llvm_fpga_mem_memdep_k0_zts6a_init7_out_memdep_k0_ZTS6a_init_avm_enable),
        .out_memdep_k0_ZTS6a_init_avm_read(i_llvm_fpga_mem_memdep_k0_zts6a_init7_out_memdep_k0_ZTS6a_init_avm_read),
        .out_memdep_k0_ZTS6a_init_avm_write(i_llvm_fpga_mem_memdep_k0_zts6a_init7_out_memdep_k0_ZTS6a_init_avm_write),
        .out_memdep_k0_ZTS6a_init_avm_writedata(i_llvm_fpga_mem_memdep_k0_zts6a_init7_out_memdep_k0_ZTS6a_init_avm_writedata),
        .out_o_stall(i_llvm_fpga_mem_memdep_k0_zts6a_init7_out_o_stall),
        .out_o_valid(i_llvm_fpga_mem_memdep_k0_zts6a_init7_out_o_valid),
        .out_o_writeack(i_llvm_fpga_mem_memdep_k0_zts6a_init7_out_o_writeack),
        .clock(clock),
        .resetn(resetn)
    );

    // ext_sig_sync_out(GPOUT,9)
    assign out_memdep_k0_ZTS6a_init_avm_address = i_llvm_fpga_mem_memdep_k0_zts6a_init7_out_memdep_k0_ZTS6a_init_avm_address;
    assign out_memdep_k0_ZTS6a_init_avm_enable = i_llvm_fpga_mem_memdep_k0_zts6a_init7_out_memdep_k0_ZTS6a_init_avm_enable;
    assign out_memdep_k0_ZTS6a_init_avm_read = i_llvm_fpga_mem_memdep_k0_zts6a_init7_out_memdep_k0_ZTS6a_init_avm_read;
    assign out_memdep_k0_ZTS6a_init_avm_write = i_llvm_fpga_mem_memdep_k0_zts6a_init7_out_memdep_k0_ZTS6a_init_avm_write;
    assign out_memdep_k0_ZTS6a_init_avm_writedata = i_llvm_fpga_mem_memdep_k0_zts6a_init7_out_memdep_k0_ZTS6a_init_avm_writedata;
    assign out_memdep_k0_ZTS6a_init_avm_byteenable = i_llvm_fpga_mem_memdep_k0_zts6a_init7_out_memdep_k0_ZTS6a_init_avm_byteenable;
    assign out_memdep_k0_ZTS6a_init_avm_burstcount = i_llvm_fpga_mem_memdep_k0_zts6a_init7_out_memdep_k0_ZTS6a_init_avm_burstcount;

    // sync_out(GPOUT,44)@0
    assign out_stall_out = SE_stall_entry_backStall;

    // dupName_0_ext_sig_sync_out_x(GPOUT,49)
    assign out_lsu_memdep_o_active = i_llvm_fpga_mem_memdep_k0_zts6a_init7_out_lsu_memdep_o_active;

    // dupName_0_sync_out_x(GPOUT,50)@61
    assign out_valid_out = SE_out_i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_V0;

    // dupName_1_ext_sig_sync_out_x(GPOUT,51)
    assign out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_address = i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_address;
    assign out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_enable = i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_enable;
    assign out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_read = i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_read;
    assign out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_write = i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_write;
    assign out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_writedata = i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_writedata;
    assign out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_byteenable = i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_byteenable;
    assign out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_burstcount = i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_out_unnamed_k0_ZTS6a_init6_k0_ZTS6a_init_avm_burstcount;

    // dupName_2_ext_sig_sync_out_x(GPOUT,52)
    assign out_lsu_unnamed_k0_ZTS6a_init6_o_active = i_llvm_fpga_mem_unnamed_k0_zts6a_init6_k0_zts6a_init11_out_lsu_unnamed_k0_ZTS6a_init6_o_active;

endmodule
