// ------------------------------------------------------------------------- 
// High Level Design Compiler for Intel(R) FPGAs Version 20.3 (Release Build #121)
// 
// Legal Notice: Copyright 2020 Intel Corporation.  All rights reserved.
// Your use of  Intel Corporation's design tools,  logic functions and other
// software and  tools, and its AMPP partner logic functions, and any output
// files any  of the foregoing (including  device programming  or simulation
// files), and  any associated  documentation  or information  are expressly
// subject  to the terms and  conditions of the  Intel FPGA Software License
// Agreement, Intel MegaCore Function License Agreement, or other applicable
// license agreement,  including,  without limitation,  that your use is for
// the  sole  purpose of  programming  logic devices  manufactured by  Intel
// and  sold by Intel  or its authorized  distributors. Please refer  to the
// applicable agreement for further details.
// ---------------------------------------------------------------------------

// SystemVerilog created from k2_ZTS6c_calc_ZTS6c_calc_B4_merge
// SystemVerilog created on Thu Nov  5 06:32:57 2020


(* altera_attribute = "-name AUTO_SHIFT_REGISTER_RECOGNITION OFF; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 10037; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 15400; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 12020; -name MESSAGE_DISABLE 12030; -name MESSAGE_DISABLE 12010; -name MESSAGE_DISABLE 12110; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 13410; -name MESSAGE_DISABLE 113007; -name MESSAGE_DISABLE 10958" *)
module k2_ZTS6c_calc_ZTS6c_calc_B4_merge (
    input wire [31:0] in_acl_0141_i509_0,
    input wire [31:0] in_acl_0141_i509_1,
    input wire [31:0] in_acl_0142_i508_0,
    input wire [31:0] in_acl_0142_i508_1,
    input wire [31:0] in_acl_0143_i507_0,
    input wire [31:0] in_acl_0143_i507_1,
    input wire [63:0] in_acl_global_id_043_0,
    input wire [63:0] in_acl_global_id_043_1,
    input wire [63:0] in_acl_global_id_149_0,
    input wire [63:0] in_acl_global_id_149_1,
    input wire [31:0] in_acl_hw_wg_id56_0,
    input wire [31:0] in_acl_hw_wg_id56_1,
    input wire [31:0] in_c0_exe210_0,
    input wire [31:0] in_c0_exe210_1,
    input wire [31:0] in_c0_exe412_0,
    input wire [31:0] in_c0_exe412_1,
    input wire [63:0] in_c0_exe517_0,
    input wire [63:0] in_c0_exe517_1,
    input wire [63:0] in_c0_exe620_0,
    input wire [63:0] in_c0_exe620_1,
    input wire [63:0] in_c0_exe725_0,
    input wire [63:0] in_c0_exe725_1,
    input wire [63:0] in_c0_exe828_0,
    input wire [63:0] in_c0_exe828_1,
    input wire [31:0] in_encoder_ZTS6c_calc_B4_merge_priority_encoder_workgroup_size,
    input wire [31:0] in_l_grpid_05_0,
    input wire [31:0] in_l_grpid_05_1,
    input wire [0:0] in_stall_in,
    input wire [0:0] in_valid_in_0,
    input wire [0:0] in_valid_in_1,
    output wire [31:0] out_acl_0141_i509,
    output wire [31:0] out_acl_0142_i508,
    output wire [31:0] out_acl_0143_i507,
    output wire [63:0] out_acl_global_id_043,
    output wire [63:0] out_acl_global_id_149,
    output wire [31:0] out_acl_hw_wg_id56,
    output wire [31:0] out_c0_exe210,
    output wire [31:0] out_c0_exe412,
    output wire [63:0] out_c0_exe517,
    output wire [63:0] out_c0_exe620,
    output wire [63:0] out_c0_exe725,
    output wire [63:0] out_c0_exe828,
    output wire [31:0] out_l_grpid_05,
    output wire [0:0] out_stall_out_0,
    output wire [0:0] out_stall_out_1,
    output wire [0:0] out_valid_out,
    input wire clock,
    input wire resetn
    );

    wire [0:0] VCC_q;
    wire [0:0] acl_0141_i509_mux_s;
    reg [31:0] acl_0141_i509_mux_q;
    wire [0:0] acl_0142_i508_mux_s;
    reg [31:0] acl_0142_i508_mux_q;
    wire [0:0] acl_0143_i507_mux_s;
    reg [31:0] acl_0143_i507_mux_q;
    wire [0:0] acl_global_id_043_mux_s;
    reg [63:0] acl_global_id_043_mux_q;
    wire [0:0] acl_global_id_149_mux_s;
    reg [63:0] acl_global_id_149_mux_q;
    wire [0:0] acl_hw_wg_id56_mux_s;
    reg [31:0] acl_hw_wg_id56_mux_q;
    wire [0:0] c0_exe210_mux_s;
    reg [31:0] c0_exe210_mux_q;
    wire [0:0] c0_exe412_mux_s;
    reg [31:0] c0_exe412_mux_q;
    wire [0:0] c0_exe517_mux_s;
    reg [63:0] c0_exe517_mux_q;
    wire [0:0] c0_exe620_mux_s;
    reg [63:0] c0_exe620_mux_q;
    wire [0:0] c0_exe725_mux_s;
    reg [63:0] c0_exe725_mux_q;
    wire [0:0] c0_exe828_mux_s;
    reg [63:0] c0_exe828_mux_q;
    wire [0:0] l_grpid_05_mux_s;
    reg [31:0] l_grpid_05_mux_q;
    wire [0:0] not_select_q;
    wire [0:0] priority_encoder_out_o_select;
    wire [0:0] priority_encoder_out_o_valid;
    wire [0:0] stall_out_0_specific_q;
    wire [0:0] stall_out_1_specific_q;


    // priority_encoder(BLACKBOX,62)
    k2_ZTS6c_calc_priority_encoder thepriority_encoder (
        .in_i_stall(in_stall_in),
        .in_valid_in_0(in_valid_in_0),
        .in_valid_in_1(in_valid_in_1),
        .in_workgroup_size(in_encoder_ZTS6c_calc_B4_merge_priority_encoder_workgroup_size),
        .out_o_select(priority_encoder_out_o_select),
        .out_o_valid(priority_encoder_out_o_valid),
        .clock(clock),
        .resetn(resetn)
    );

    // VCC(CONSTANT,1)
    assign VCC_q = $unsigned(1'b1);

    // acl_0141_i509_mux(MUX,2)
    assign acl_0141_i509_mux_s = priority_encoder_out_o_select;
    always @(acl_0141_i509_mux_s or in_acl_0141_i509_0 or in_acl_0141_i509_1)
    begin
        unique case (acl_0141_i509_mux_s)
            1'b0 : acl_0141_i509_mux_q = in_acl_0141_i509_0;
            1'b1 : acl_0141_i509_mux_q = in_acl_0141_i509_1;
            default : acl_0141_i509_mux_q = 32'b0;
        endcase
    end

    // out_acl_0141_i509(GPOUT,46)
    assign out_acl_0141_i509 = acl_0141_i509_mux_q;

    // acl_0142_i508_mux(MUX,3)
    assign acl_0142_i508_mux_s = priority_encoder_out_o_select;
    always @(acl_0142_i508_mux_s or in_acl_0142_i508_0 or in_acl_0142_i508_1)
    begin
        unique case (acl_0142_i508_mux_s)
            1'b0 : acl_0142_i508_mux_q = in_acl_0142_i508_0;
            1'b1 : acl_0142_i508_mux_q = in_acl_0142_i508_1;
            default : acl_0142_i508_mux_q = 32'b0;
        endcase
    end

    // out_acl_0142_i508(GPOUT,47)
    assign out_acl_0142_i508 = acl_0142_i508_mux_q;

    // acl_0143_i507_mux(MUX,4)
    assign acl_0143_i507_mux_s = priority_encoder_out_o_select;
    always @(acl_0143_i507_mux_s or in_acl_0143_i507_0 or in_acl_0143_i507_1)
    begin
        unique case (acl_0143_i507_mux_s)
            1'b0 : acl_0143_i507_mux_q = in_acl_0143_i507_0;
            1'b1 : acl_0143_i507_mux_q = in_acl_0143_i507_1;
            default : acl_0143_i507_mux_q = 32'b0;
        endcase
    end

    // out_acl_0143_i507(GPOUT,48)
    assign out_acl_0143_i507 = acl_0143_i507_mux_q;

    // acl_global_id_043_mux(MUX,5)
    assign acl_global_id_043_mux_s = priority_encoder_out_o_select;
    always @(acl_global_id_043_mux_s or in_acl_global_id_043_0 or in_acl_global_id_043_1)
    begin
        unique case (acl_global_id_043_mux_s)
            1'b0 : acl_global_id_043_mux_q = in_acl_global_id_043_0;
            1'b1 : acl_global_id_043_mux_q = in_acl_global_id_043_1;
            default : acl_global_id_043_mux_q = 64'b0;
        endcase
    end

    // out_acl_global_id_043(GPOUT,49)
    assign out_acl_global_id_043 = acl_global_id_043_mux_q;

    // acl_global_id_149_mux(MUX,6)
    assign acl_global_id_149_mux_s = priority_encoder_out_o_select;
    always @(acl_global_id_149_mux_s or in_acl_global_id_149_0 or in_acl_global_id_149_1)
    begin
        unique case (acl_global_id_149_mux_s)
            1'b0 : acl_global_id_149_mux_q = in_acl_global_id_149_0;
            1'b1 : acl_global_id_149_mux_q = in_acl_global_id_149_1;
            default : acl_global_id_149_mux_q = 64'b0;
        endcase
    end

    // out_acl_global_id_149(GPOUT,50)
    assign out_acl_global_id_149 = acl_global_id_149_mux_q;

    // acl_hw_wg_id56_mux(MUX,7)
    assign acl_hw_wg_id56_mux_s = priority_encoder_out_o_select;
    always @(acl_hw_wg_id56_mux_s or in_acl_hw_wg_id56_0 or in_acl_hw_wg_id56_1)
    begin
        unique case (acl_hw_wg_id56_mux_s)
            1'b0 : acl_hw_wg_id56_mux_q = in_acl_hw_wg_id56_0;
            1'b1 : acl_hw_wg_id56_mux_q = in_acl_hw_wg_id56_1;
            default : acl_hw_wg_id56_mux_q = 32'b0;
        endcase
    end

    // out_acl_hw_wg_id56(GPOUT,51)
    assign out_acl_hw_wg_id56 = acl_hw_wg_id56_mux_q;

    // c0_exe210_mux(MUX,8)
    assign c0_exe210_mux_s = priority_encoder_out_o_select;
    always @(c0_exe210_mux_s or in_c0_exe210_0 or in_c0_exe210_1)
    begin
        unique case (c0_exe210_mux_s)
            1'b0 : c0_exe210_mux_q = in_c0_exe210_0;
            1'b1 : c0_exe210_mux_q = in_c0_exe210_1;
            default : c0_exe210_mux_q = 32'b0;
        endcase
    end

    // out_c0_exe210(GPOUT,52)
    assign out_c0_exe210 = c0_exe210_mux_q;

    // c0_exe412_mux(MUX,9)
    assign c0_exe412_mux_s = priority_encoder_out_o_select;
    always @(c0_exe412_mux_s or in_c0_exe412_0 or in_c0_exe412_1)
    begin
        unique case (c0_exe412_mux_s)
            1'b0 : c0_exe412_mux_q = in_c0_exe412_0;
            1'b1 : c0_exe412_mux_q = in_c0_exe412_1;
            default : c0_exe412_mux_q = 32'b0;
        endcase
    end

    // out_c0_exe412(GPOUT,53)
    assign out_c0_exe412 = c0_exe412_mux_q;

    // c0_exe517_mux(MUX,10)
    assign c0_exe517_mux_s = priority_encoder_out_o_select;
    always @(c0_exe517_mux_s or in_c0_exe517_0 or in_c0_exe517_1)
    begin
        unique case (c0_exe517_mux_s)
            1'b0 : c0_exe517_mux_q = in_c0_exe517_0;
            1'b1 : c0_exe517_mux_q = in_c0_exe517_1;
            default : c0_exe517_mux_q = 64'b0;
        endcase
    end

    // out_c0_exe517(GPOUT,54)
    assign out_c0_exe517 = c0_exe517_mux_q;

    // c0_exe620_mux(MUX,11)
    assign c0_exe620_mux_s = priority_encoder_out_o_select;
    always @(c0_exe620_mux_s or in_c0_exe620_0 or in_c0_exe620_1)
    begin
        unique case (c0_exe620_mux_s)
            1'b0 : c0_exe620_mux_q = in_c0_exe620_0;
            1'b1 : c0_exe620_mux_q = in_c0_exe620_1;
            default : c0_exe620_mux_q = 64'b0;
        endcase
    end

    // out_c0_exe620(GPOUT,55)
    assign out_c0_exe620 = c0_exe620_mux_q;

    // c0_exe725_mux(MUX,12)
    assign c0_exe725_mux_s = priority_encoder_out_o_select;
    always @(c0_exe725_mux_s or in_c0_exe725_0 or in_c0_exe725_1)
    begin
        unique case (c0_exe725_mux_s)
            1'b0 : c0_exe725_mux_q = in_c0_exe725_0;
            1'b1 : c0_exe725_mux_q = in_c0_exe725_1;
            default : c0_exe725_mux_q = 64'b0;
        endcase
    end

    // out_c0_exe725(GPOUT,56)
    assign out_c0_exe725 = c0_exe725_mux_q;

    // c0_exe828_mux(MUX,13)
    assign c0_exe828_mux_s = priority_encoder_out_o_select;
    always @(c0_exe828_mux_s or in_c0_exe828_0 or in_c0_exe828_1)
    begin
        unique case (c0_exe828_mux_s)
            1'b0 : c0_exe828_mux_q = in_c0_exe828_0;
            1'b1 : c0_exe828_mux_q = in_c0_exe828_1;
            default : c0_exe828_mux_q = 64'b0;
        endcase
    end

    // out_c0_exe828(GPOUT,57)
    assign out_c0_exe828 = c0_exe828_mux_q;

    // l_grpid_05_mux(MUX,44)
    assign l_grpid_05_mux_s = priority_encoder_out_o_select;
    always @(l_grpid_05_mux_s or in_l_grpid_05_0 or in_l_grpid_05_1)
    begin
        unique case (l_grpid_05_mux_s)
            1'b0 : l_grpid_05_mux_q = in_l_grpid_05_0;
            1'b1 : l_grpid_05_mux_q = in_l_grpid_05_1;
            default : l_grpid_05_mux_q = 32'b0;
        endcase
    end

    // out_l_grpid_05(GPOUT,58)
    assign out_l_grpid_05 = l_grpid_05_mux_q;

    // stall_out_0_specific(LOGICAL,63)
    assign stall_out_0_specific_q = in_stall_in | priority_encoder_out_o_select;

    // out_stall_out_0(GPOUT,59)
    assign out_stall_out_0 = stall_out_0_specific_q;

    // not_select(LOGICAL,45)
    assign not_select_q = ~ (priority_encoder_out_o_select);

    // stall_out_1_specific(LOGICAL,64)
    assign stall_out_1_specific_q = in_stall_in | not_select_q;

    // out_stall_out_1(GPOUT,60)
    assign out_stall_out_1 = stall_out_1_specific_q;

    // out_valid_out(GPOUT,61)
    assign out_valid_out = priority_encoder_out_o_valid;

endmodule
