// ------------------------------------------------------------------------- 
// High Level Design Compiler for Intel(R) FPGAs Version 20.3 (Release Build #121)
// 
// Legal Notice: Copyright 2020 Intel Corporation.  All rights reserved.
// Your use of  Intel Corporation's design tools,  logic functions and other
// software and  tools, and its AMPP partner logic functions, and any output
// files any  of the foregoing (including  device programming  or simulation
// files), and  any associated  documentation  or information  are expressly
// subject  to the terms and  conditions of the  Intel FPGA Software License
// Agreement, Intel MegaCore Function License Agreement, or other applicable
// license agreement,  including,  without limitation,  that your use is for
// the  sole  purpose of  programming  logic devices  manufactured by  Intel
// and  sold by Intel  or its authorized  distributors. Please refer  to the
// applicable agreement for further details.
// ---------------------------------------------------------------------------

// SystemVerilog created from k2_ZTS6c_calc_ZTS6c_calc_B6_merge
// SystemVerilog created on Thu Nov  5 06:32:57 2020


(* altera_attribute = "-name AUTO_SHIFT_REGISTER_RECOGNITION OFF; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 10037; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 15400; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 12020; -name MESSAGE_DISABLE 12030; -name MESSAGE_DISABLE 12010; -name MESSAGE_DISABLE 12110; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 13410; -name MESSAGE_DISABLE 113007; -name MESSAGE_DISABLE 10958" *)
module k2_ZTS6c_calc_ZTS6c_calc_B6_merge (
    input wire [31:0] in_acl_0141_i50933_0,
    input wire [31:0] in_acl_0141_i50933_1,
    input wire [31:0] in_acl_0142_i50835_0,
    input wire [31:0] in_acl_0142_i50835_1,
    input wire [31:0] in_acl_0_i506_0,
    input wire [31:0] in_acl_0_i506_1,
    input wire [31:0] in_acl_1_i505_0,
    input wire [31:0] in_acl_1_i505_1,
    input wire [63:0] in_acl_global_id_042_0,
    input wire [63:0] in_acl_global_id_042_1,
    input wire [63:0] in_acl_global_id_148_0,
    input wire [63:0] in_acl_global_id_148_1,
    input wire [31:0] in_acl_hw_wg_id55_0,
    input wire [31:0] in_acl_hw_wg_id55_1,
    input wire [31:0] in_c0_exe29_0,
    input wire [31:0] in_c0_exe29_1,
    input wire [31:0] in_c0_exe414_0,
    input wire [31:0] in_c0_exe414_1,
    input wire [63:0] in_c0_exe516_0,
    input wire [63:0] in_c0_exe516_1,
    input wire [63:0] in_c0_exe622_0,
    input wire [63:0] in_c0_exe622_1,
    input wire [63:0] in_c0_exe724_0,
    input wire [63:0] in_c0_exe724_1,
    input wire [63:0] in_c0_exe830_0,
    input wire [63:0] in_c0_exe830_1,
    input wire [31:0] in_encoder_ZTS6c_calc_B6_merge_priority_encoder_workgroup_size,
    input wire [31:0] in_l_grpid_04_0,
    input wire [31:0] in_l_grpid_04_1,
    input wire [63:0] in_l_grpid_0_ext_offset36_0,
    input wire [63:0] in_l_grpid_0_ext_offset36_1,
    input wire [0:0] in_stall_in,
    input wire [0:0] in_valid_in_0,
    input wire [0:0] in_valid_in_1,
    output wire [31:0] out_acl_0141_i50933,
    output wire [31:0] out_acl_0142_i50835,
    output wire [31:0] out_acl_0_i506,
    output wire [31:0] out_acl_1_i505,
    output wire [63:0] out_acl_global_id_042,
    output wire [63:0] out_acl_global_id_148,
    output wire [31:0] out_acl_hw_wg_id55,
    output wire [31:0] out_c0_exe29,
    output wire [31:0] out_c0_exe414,
    output wire [63:0] out_c0_exe516,
    output wire [63:0] out_c0_exe622,
    output wire [63:0] out_c0_exe724,
    output wire [63:0] out_c0_exe830,
    output wire [31:0] out_l_grpid_04,
    output wire [63:0] out_l_grpid_0_ext_offset36,
    output wire [0:0] out_stall_out_0,
    output wire [0:0] out_stall_out_1,
    output wire [0:0] out_valid_out,
    input wire clock,
    input wire resetn
    );

    wire [0:0] VCC_q;
    wire [0:0] acl_0141_i50933_mux_s;
    reg [31:0] acl_0141_i50933_mux_q;
    wire [0:0] acl_0142_i50835_mux_s;
    reg [31:0] acl_0142_i50835_mux_q;
    wire [0:0] acl_0_i506_mux_s;
    reg [31:0] acl_0_i506_mux_q;
    wire [0:0] acl_1_i505_mux_s;
    reg [31:0] acl_1_i505_mux_q;
    wire [0:0] acl_global_id_042_mux_s;
    reg [63:0] acl_global_id_042_mux_q;
    wire [0:0] acl_global_id_148_mux_s;
    reg [63:0] acl_global_id_148_mux_q;
    wire [0:0] acl_hw_wg_id55_mux_s;
    reg [31:0] acl_hw_wg_id55_mux_q;
    wire [0:0] c0_exe29_mux_s;
    reg [31:0] c0_exe29_mux_q;
    wire [0:0] c0_exe414_mux_s;
    reg [31:0] c0_exe414_mux_q;
    wire [0:0] c0_exe516_mux_s;
    reg [63:0] c0_exe516_mux_q;
    wire [0:0] c0_exe622_mux_s;
    reg [63:0] c0_exe622_mux_q;
    wire [0:0] c0_exe724_mux_s;
    reg [63:0] c0_exe724_mux_q;
    wire [0:0] c0_exe830_mux_s;
    reg [63:0] c0_exe830_mux_q;
    wire [0:0] l_grpid_04_mux_s;
    reg [31:0] l_grpid_04_mux_q;
    wire [0:0] l_grpid_0_ext_offset36_mux_s;
    reg [63:0] l_grpid_0_ext_offset36_mux_q;
    wire [0:0] not_select_q;
    wire [0:0] priority_encoder_out_o_select;
    wire [0:0] priority_encoder_out_o_valid;
    wire [0:0] stall_out_0_specific_q;
    wire [0:0] stall_out_1_specific_q;


    // priority_encoder(BLACKBOX,70)
    k2_ZTS6c_calc_dupName_0_priority_encoder_26ui0676j636g6u0qc0xajz thepriority_encoder (
        .in_i_stall(in_stall_in),
        .in_valid_in_0(in_valid_in_0),
        .in_valid_in_1(in_valid_in_1),
        .in_workgroup_size(in_encoder_ZTS6c_calc_B6_merge_priority_encoder_workgroup_size),
        .out_o_select(priority_encoder_out_o_select),
        .out_o_valid(priority_encoder_out_o_valid),
        .clock(clock),
        .resetn(resetn)
    );

    // VCC(CONSTANT,1)
    assign VCC_q = $unsigned(1'b1);

    // acl_0141_i50933_mux(MUX,2)
    assign acl_0141_i50933_mux_s = priority_encoder_out_o_select;
    always @(acl_0141_i50933_mux_s or in_acl_0141_i50933_0 or in_acl_0141_i50933_1)
    begin
        unique case (acl_0141_i50933_mux_s)
            1'b0 : acl_0141_i50933_mux_q = in_acl_0141_i50933_0;
            1'b1 : acl_0141_i50933_mux_q = in_acl_0141_i50933_1;
            default : acl_0141_i50933_mux_q = 32'b0;
        endcase
    end

    // out_acl_0141_i50933(GPOUT,52)
    assign out_acl_0141_i50933 = acl_0141_i50933_mux_q;

    // acl_0142_i50835_mux(MUX,3)
    assign acl_0142_i50835_mux_s = priority_encoder_out_o_select;
    always @(acl_0142_i50835_mux_s or in_acl_0142_i50835_0 or in_acl_0142_i50835_1)
    begin
        unique case (acl_0142_i50835_mux_s)
            1'b0 : acl_0142_i50835_mux_q = in_acl_0142_i50835_0;
            1'b1 : acl_0142_i50835_mux_q = in_acl_0142_i50835_1;
            default : acl_0142_i50835_mux_q = 32'b0;
        endcase
    end

    // out_acl_0142_i50835(GPOUT,53)
    assign out_acl_0142_i50835 = acl_0142_i50835_mux_q;

    // acl_0_i506_mux(MUX,4)
    assign acl_0_i506_mux_s = priority_encoder_out_o_select;
    always @(acl_0_i506_mux_s or in_acl_0_i506_0 or in_acl_0_i506_1)
    begin
        unique case (acl_0_i506_mux_s)
            1'b0 : acl_0_i506_mux_q = in_acl_0_i506_0;
            1'b1 : acl_0_i506_mux_q = in_acl_0_i506_1;
            default : acl_0_i506_mux_q = 32'b0;
        endcase
    end

    // out_acl_0_i506(GPOUT,54)
    assign out_acl_0_i506 = acl_0_i506_mux_q;

    // acl_1_i505_mux(MUX,5)
    assign acl_1_i505_mux_s = priority_encoder_out_o_select;
    always @(acl_1_i505_mux_s or in_acl_1_i505_0 or in_acl_1_i505_1)
    begin
        unique case (acl_1_i505_mux_s)
            1'b0 : acl_1_i505_mux_q = in_acl_1_i505_0;
            1'b1 : acl_1_i505_mux_q = in_acl_1_i505_1;
            default : acl_1_i505_mux_q = 32'b0;
        endcase
    end

    // out_acl_1_i505(GPOUT,55)
    assign out_acl_1_i505 = acl_1_i505_mux_q;

    // acl_global_id_042_mux(MUX,6)
    assign acl_global_id_042_mux_s = priority_encoder_out_o_select;
    always @(acl_global_id_042_mux_s or in_acl_global_id_042_0 or in_acl_global_id_042_1)
    begin
        unique case (acl_global_id_042_mux_s)
            1'b0 : acl_global_id_042_mux_q = in_acl_global_id_042_0;
            1'b1 : acl_global_id_042_mux_q = in_acl_global_id_042_1;
            default : acl_global_id_042_mux_q = 64'b0;
        endcase
    end

    // out_acl_global_id_042(GPOUT,56)
    assign out_acl_global_id_042 = acl_global_id_042_mux_q;

    // acl_global_id_148_mux(MUX,7)
    assign acl_global_id_148_mux_s = priority_encoder_out_o_select;
    always @(acl_global_id_148_mux_s or in_acl_global_id_148_0 or in_acl_global_id_148_1)
    begin
        unique case (acl_global_id_148_mux_s)
            1'b0 : acl_global_id_148_mux_q = in_acl_global_id_148_0;
            1'b1 : acl_global_id_148_mux_q = in_acl_global_id_148_1;
            default : acl_global_id_148_mux_q = 64'b0;
        endcase
    end

    // out_acl_global_id_148(GPOUT,57)
    assign out_acl_global_id_148 = acl_global_id_148_mux_q;

    // acl_hw_wg_id55_mux(MUX,8)
    assign acl_hw_wg_id55_mux_s = priority_encoder_out_o_select;
    always @(acl_hw_wg_id55_mux_s or in_acl_hw_wg_id55_0 or in_acl_hw_wg_id55_1)
    begin
        unique case (acl_hw_wg_id55_mux_s)
            1'b0 : acl_hw_wg_id55_mux_q = in_acl_hw_wg_id55_0;
            1'b1 : acl_hw_wg_id55_mux_q = in_acl_hw_wg_id55_1;
            default : acl_hw_wg_id55_mux_q = 32'b0;
        endcase
    end

    // out_acl_hw_wg_id55(GPOUT,58)
    assign out_acl_hw_wg_id55 = acl_hw_wg_id55_mux_q;

    // c0_exe29_mux(MUX,9)
    assign c0_exe29_mux_s = priority_encoder_out_o_select;
    always @(c0_exe29_mux_s or in_c0_exe29_0 or in_c0_exe29_1)
    begin
        unique case (c0_exe29_mux_s)
            1'b0 : c0_exe29_mux_q = in_c0_exe29_0;
            1'b1 : c0_exe29_mux_q = in_c0_exe29_1;
            default : c0_exe29_mux_q = 32'b0;
        endcase
    end

    // out_c0_exe29(GPOUT,59)
    assign out_c0_exe29 = c0_exe29_mux_q;

    // c0_exe414_mux(MUX,10)
    assign c0_exe414_mux_s = priority_encoder_out_o_select;
    always @(c0_exe414_mux_s or in_c0_exe414_0 or in_c0_exe414_1)
    begin
        unique case (c0_exe414_mux_s)
            1'b0 : c0_exe414_mux_q = in_c0_exe414_0;
            1'b1 : c0_exe414_mux_q = in_c0_exe414_1;
            default : c0_exe414_mux_q = 32'b0;
        endcase
    end

    // out_c0_exe414(GPOUT,60)
    assign out_c0_exe414 = c0_exe414_mux_q;

    // c0_exe516_mux(MUX,11)
    assign c0_exe516_mux_s = priority_encoder_out_o_select;
    always @(c0_exe516_mux_s or in_c0_exe516_0 or in_c0_exe516_1)
    begin
        unique case (c0_exe516_mux_s)
            1'b0 : c0_exe516_mux_q = in_c0_exe516_0;
            1'b1 : c0_exe516_mux_q = in_c0_exe516_1;
            default : c0_exe516_mux_q = 64'b0;
        endcase
    end

    // out_c0_exe516(GPOUT,61)
    assign out_c0_exe516 = c0_exe516_mux_q;

    // c0_exe622_mux(MUX,12)
    assign c0_exe622_mux_s = priority_encoder_out_o_select;
    always @(c0_exe622_mux_s or in_c0_exe622_0 or in_c0_exe622_1)
    begin
        unique case (c0_exe622_mux_s)
            1'b0 : c0_exe622_mux_q = in_c0_exe622_0;
            1'b1 : c0_exe622_mux_q = in_c0_exe622_1;
            default : c0_exe622_mux_q = 64'b0;
        endcase
    end

    // out_c0_exe622(GPOUT,62)
    assign out_c0_exe622 = c0_exe622_mux_q;

    // c0_exe724_mux(MUX,13)
    assign c0_exe724_mux_s = priority_encoder_out_o_select;
    always @(c0_exe724_mux_s or in_c0_exe724_0 or in_c0_exe724_1)
    begin
        unique case (c0_exe724_mux_s)
            1'b0 : c0_exe724_mux_q = in_c0_exe724_0;
            1'b1 : c0_exe724_mux_q = in_c0_exe724_1;
            default : c0_exe724_mux_q = 64'b0;
        endcase
    end

    // out_c0_exe724(GPOUT,63)
    assign out_c0_exe724 = c0_exe724_mux_q;

    // c0_exe830_mux(MUX,14)
    assign c0_exe830_mux_s = priority_encoder_out_o_select;
    always @(c0_exe830_mux_s or in_c0_exe830_0 or in_c0_exe830_1)
    begin
        unique case (c0_exe830_mux_s)
            1'b0 : c0_exe830_mux_q = in_c0_exe830_0;
            1'b1 : c0_exe830_mux_q = in_c0_exe830_1;
            default : c0_exe830_mux_q = 64'b0;
        endcase
    end

    // out_c0_exe830(GPOUT,64)
    assign out_c0_exe830 = c0_exe830_mux_q;

    // l_grpid_04_mux(MUX,49)
    assign l_grpid_04_mux_s = priority_encoder_out_o_select;
    always @(l_grpid_04_mux_s or in_l_grpid_04_0 or in_l_grpid_04_1)
    begin
        unique case (l_grpid_04_mux_s)
            1'b0 : l_grpid_04_mux_q = in_l_grpid_04_0;
            1'b1 : l_grpid_04_mux_q = in_l_grpid_04_1;
            default : l_grpid_04_mux_q = 32'b0;
        endcase
    end

    // out_l_grpid_04(GPOUT,65)
    assign out_l_grpid_04 = l_grpid_04_mux_q;

    // l_grpid_0_ext_offset36_mux(MUX,50)
    assign l_grpid_0_ext_offset36_mux_s = priority_encoder_out_o_select;
    always @(l_grpid_0_ext_offset36_mux_s or in_l_grpid_0_ext_offset36_0 or in_l_grpid_0_ext_offset36_1)
    begin
        unique case (l_grpid_0_ext_offset36_mux_s)
            1'b0 : l_grpid_0_ext_offset36_mux_q = in_l_grpid_0_ext_offset36_0;
            1'b1 : l_grpid_0_ext_offset36_mux_q = in_l_grpid_0_ext_offset36_1;
            default : l_grpid_0_ext_offset36_mux_q = 64'b0;
        endcase
    end

    // out_l_grpid_0_ext_offset36(GPOUT,66)
    assign out_l_grpid_0_ext_offset36 = l_grpid_0_ext_offset36_mux_q;

    // stall_out_0_specific(LOGICAL,71)
    assign stall_out_0_specific_q = in_stall_in | priority_encoder_out_o_select;

    // out_stall_out_0(GPOUT,67)
    assign out_stall_out_0 = stall_out_0_specific_q;

    // not_select(LOGICAL,51)
    assign not_select_q = ~ (priority_encoder_out_o_select);

    // stall_out_1_specific(LOGICAL,72)
    assign stall_out_1_specific_q = in_stall_in | not_select_q;

    // out_stall_out_1(GPOUT,68)
    assign out_stall_out_1 = stall_out_1_specific_q;

    // out_valid_out(GPOUT,69)
    assign out_valid_out = priority_encoder_out_o_valid;

endmodule
