// ------------------------------------------------------------------------- 
// High Level Design Compiler for Intel(R) FPGAs Version 20.3 (Release Build #121)
// 
// Legal Notice: Copyright 2020 Intel Corporation.  All rights reserved.
// Your use of  Intel Corporation's design tools,  logic functions and other
// software and  tools, and its AMPP partner logic functions, and any output
// files any  of the foregoing (including  device programming  or simulation
// files), and  any associated  documentation  or information  are expressly
// subject  to the terms and  conditions of the  Intel FPGA Software License
// Agreement, Intel MegaCore Function License Agreement, or other applicable
// license agreement,  including,  without limitation,  that your use is for
// the  sole  purpose of  programming  logic devices  manufactured by  Intel
// and  sold by Intel  or its authorized  distributors. Please refer  to the
// applicable agreement for further details.
// ---------------------------------------------------------------------------

// SystemVerilog created from k2_ZTS6c_calc_bb_ZTS6c_calc_B2
// SystemVerilog created on Thu Nov  5 06:32:57 2020


(* altera_attribute = "-name AUTO_SHIFT_REGISTER_RECOGNITION OFF; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 10037; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 15400; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 12020; -name MESSAGE_DISABLE 12030; -name MESSAGE_DISABLE 12010; -name MESSAGE_DISABLE 12110; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 13410; -name MESSAGE_DISABLE 113007; -name MESSAGE_DISABLE 10958" *)
module k2_ZTS6c_calc_bb_ZTS6c_calc_B2 (
    output wire [63:0] out_acl_global_id_040,
    output wire [63:0] out_acl_global_id_146,
    output wire [31:0] out_acl_hw_wg_id53,
    output wire [31:0] out_c0_exe15438,
    output wire [31:0] out_l_grpid_02,
    output wire [0:0] out_stall_out_0,
    output wire [0:0] out_valid_out_0,
    input wire [63:0] in_acl_global_id_040_0,
    input wire [63:0] in_acl_global_id_146_0,
    input wire [31:0] in_acl_hw_wg_id53_0,
    input wire [63:0] in_arg16,
    input wire [31:0] in_c0_exe15438_0,
    input wire [31:0] in_l_grpid_02_0,
    input wire [0:0] in_stall_in_0,
    input wire [0:0] in_valid_in_0,
    input wire [63:0] in_arg18_0_tpl,
    input wire [63:0] in_arg18_1_tpl,
    input wire [63:0] in_arg19_0_tpl,
    input wire [63:0] in_arg19_1_tpl,
    input wire clock,
    input wire resetn
    );

    wire [63:0] ZTS6c_calc_B2_branch_out_acl_global_id_040;
    wire [63:0] ZTS6c_calc_B2_branch_out_acl_global_id_146;
    wire [31:0] ZTS6c_calc_B2_branch_out_acl_hw_wg_id53;
    wire [31:0] ZTS6c_calc_B2_branch_out_c0_exe15438;
    wire [31:0] ZTS6c_calc_B2_branch_out_l_grpid_02;
    wire [0:0] ZTS6c_calc_B2_branch_out_stall_out;
    wire [0:0] ZTS6c_calc_B2_branch_out_valid_out_0;
    wire [63:0] ZTS6c_calc_B2_merge_out_acl_global_id_040;
    wire [63:0] ZTS6c_calc_B2_merge_out_acl_global_id_146;
    wire [31:0] ZTS6c_calc_B2_merge_out_acl_hw_wg_id53;
    wire [31:0] ZTS6c_calc_B2_merge_out_c0_exe15438;
    wire [31:0] ZTS6c_calc_B2_merge_out_l_grpid_02;
    wire [0:0] ZTS6c_calc_B2_merge_out_stall_out_0;
    wire [0:0] ZTS6c_calc_B2_merge_out_valid_out;
    wire [63:0] bb_ZTS6c_calc_B2_stall_region_out_acl_global_id_040;
    wire [63:0] bb_ZTS6c_calc_B2_stall_region_out_acl_global_id_146;
    wire [31:0] bb_ZTS6c_calc_B2_stall_region_out_acl_hw_wg_id53;
    wire [31:0] bb_ZTS6c_calc_B2_stall_region_out_c0_exe15438;
    wire [31:0] bb_ZTS6c_calc_B2_stall_region_out_l_grpid_02;
    wire [0:0] bb_ZTS6c_calc_B2_stall_region_out_stall_out;
    wire [0:0] bb_ZTS6c_calc_B2_stall_region_out_valid_out;


    // ZTS6c_calc_B2_merge(BLACKBOX,3)
    k2_ZTS6c_calc_ZTS6c_calc_B2_merge theZTS6c_calc_B2_merge (
        .in_acl_global_id_040_0(in_acl_global_id_040_0),
        .in_acl_global_id_146_0(in_acl_global_id_146_0),
        .in_acl_hw_wg_id53_0(in_acl_hw_wg_id53_0),
        .in_c0_exe15438_0(in_c0_exe15438_0),
        .in_l_grpid_02_0(in_l_grpid_02_0),
        .in_stall_in(bb_ZTS6c_calc_B2_stall_region_out_stall_out),
        .in_valid_in_0(in_valid_in_0),
        .out_acl_global_id_040(ZTS6c_calc_B2_merge_out_acl_global_id_040),
        .out_acl_global_id_146(ZTS6c_calc_B2_merge_out_acl_global_id_146),
        .out_acl_hw_wg_id53(ZTS6c_calc_B2_merge_out_acl_hw_wg_id53),
        .out_c0_exe15438(ZTS6c_calc_B2_merge_out_c0_exe15438),
        .out_l_grpid_02(ZTS6c_calc_B2_merge_out_l_grpid_02),
        .out_stall_out_0(ZTS6c_calc_B2_merge_out_stall_out_0),
        .out_valid_out(ZTS6c_calc_B2_merge_out_valid_out),
        .clock(clock),
        .resetn(resetn)
    );

    // bb_ZTS6c_calc_B2_stall_region(BLACKBOX,4)
    k2_ZTS6c_calc_bb_ZTS6c_calc_B2_stall_region thebb_ZTS6c_calc_B2_stall_region (
        .in_acl_global_id_040(ZTS6c_calc_B2_merge_out_acl_global_id_040),
        .in_acl_global_id_146(ZTS6c_calc_B2_merge_out_acl_global_id_146),
        .in_acl_hw_wg_id53(ZTS6c_calc_B2_merge_out_acl_hw_wg_id53),
        .in_c0_exe15438(ZTS6c_calc_B2_merge_out_c0_exe15438),
        .in_l_grpid_02(ZTS6c_calc_B2_merge_out_l_grpid_02),
        .in_stall_in(ZTS6c_calc_B2_branch_out_stall_out),
        .in_valid_in(ZTS6c_calc_B2_merge_out_valid_out),
        .out_acl_global_id_040(bb_ZTS6c_calc_B2_stall_region_out_acl_global_id_040),
        .out_acl_global_id_146(bb_ZTS6c_calc_B2_stall_region_out_acl_global_id_146),
        .out_acl_hw_wg_id53(bb_ZTS6c_calc_B2_stall_region_out_acl_hw_wg_id53),
        .out_c0_exe15438(bb_ZTS6c_calc_B2_stall_region_out_c0_exe15438),
        .out_l_grpid_02(bb_ZTS6c_calc_B2_stall_region_out_l_grpid_02),
        .out_stall_out(bb_ZTS6c_calc_B2_stall_region_out_stall_out),
        .out_valid_out(bb_ZTS6c_calc_B2_stall_region_out_valid_out),
        .clock(clock),
        .resetn(resetn)
    );

    // ZTS6c_calc_B2_branch(BLACKBOX,2)
    k2_ZTS6c_calc_ZTS6c_calc_B2_branch theZTS6c_calc_B2_branch (
        .in_acl_global_id_040(bb_ZTS6c_calc_B2_stall_region_out_acl_global_id_040),
        .in_acl_global_id_146(bb_ZTS6c_calc_B2_stall_region_out_acl_global_id_146),
        .in_acl_hw_wg_id53(bb_ZTS6c_calc_B2_stall_region_out_acl_hw_wg_id53),
        .in_c0_exe15438(bb_ZTS6c_calc_B2_stall_region_out_c0_exe15438),
        .in_l_grpid_02(bb_ZTS6c_calc_B2_stall_region_out_l_grpid_02),
        .in_stall_in_0(in_stall_in_0),
        .in_valid_in(bb_ZTS6c_calc_B2_stall_region_out_valid_out),
        .out_acl_global_id_040(ZTS6c_calc_B2_branch_out_acl_global_id_040),
        .out_acl_global_id_146(ZTS6c_calc_B2_branch_out_acl_global_id_146),
        .out_acl_hw_wg_id53(ZTS6c_calc_B2_branch_out_acl_hw_wg_id53),
        .out_c0_exe15438(ZTS6c_calc_B2_branch_out_c0_exe15438),
        .out_l_grpid_02(ZTS6c_calc_B2_branch_out_l_grpid_02),
        .out_stall_out(ZTS6c_calc_B2_branch_out_stall_out),
        .out_valid_out_0(ZTS6c_calc_B2_branch_out_valid_out_0),
        .clock(clock),
        .resetn(resetn)
    );

    // out_acl_global_id_040(GPOUT,5)
    assign out_acl_global_id_040 = ZTS6c_calc_B2_branch_out_acl_global_id_040;

    // out_acl_global_id_146(GPOUT,6)
    assign out_acl_global_id_146 = ZTS6c_calc_B2_branch_out_acl_global_id_146;

    // out_acl_hw_wg_id53(GPOUT,7)
    assign out_acl_hw_wg_id53 = ZTS6c_calc_B2_branch_out_acl_hw_wg_id53;

    // out_c0_exe15438(GPOUT,8)
    assign out_c0_exe15438 = ZTS6c_calc_B2_branch_out_c0_exe15438;

    // out_l_grpid_02(GPOUT,9)
    assign out_l_grpid_02 = ZTS6c_calc_B2_branch_out_l_grpid_02;

    // out_stall_out_0(GPOUT,10)
    assign out_stall_out_0 = ZTS6c_calc_B2_merge_out_stall_out_0;

    // out_valid_out_0(GPOUT,11)
    assign out_valid_out_0 = ZTS6c_calc_B2_branch_out_valid_out_0;

endmodule
