// ------------------------------------------------------------------------- 
// High Level Design Compiler for Intel(R) FPGAs Version 20.3 (Release Build #121)
// 
// Legal Notice: Copyright 2020 Intel Corporation.  All rights reserved.
// Your use of  Intel Corporation's design tools,  logic functions and other
// software and  tools, and its AMPP partner logic functions, and any output
// files any  of the foregoing (including  device programming  or simulation
// files), and  any associated  documentation  or information  are expressly
// subject  to the terms and  conditions of the  Intel FPGA Software License
// Agreement, Intel MegaCore Function License Agreement, or other applicable
// license agreement,  including,  without limitation,  that your use is for
// the  sole  purpose of  programming  logic devices  manufactured by  Intel
// and  sold by Intel  or its authorized  distributors. Please refer  to the
// applicable agreement for further details.
// ---------------------------------------------------------------------------

// SystemVerilog created from k2_ZTS6c_calc_bb_ZTS6c_calc_B3
// SystemVerilog created on Thu Nov  5 06:32:57 2020


(* altera_attribute = "-name AUTO_SHIFT_REGISTER_RECOGNITION OFF; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 10037; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 15400; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 12020; -name MESSAGE_DISABLE 12030; -name MESSAGE_DISABLE 12010; -name MESSAGE_DISABLE 12110; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 13410; -name MESSAGE_DISABLE 113007; -name MESSAGE_DISABLE 10958" *)
module k2_ZTS6c_calc_bb_ZTS6c_calc_B3 (
    output wire [31:0] out_acl_hw_wg_id52,
    output wire [0:0] out_lsu_unnamed_k2_ZTS6c_calc9_o_active,
    output wire [0:0] out_stall_out_0,
    output wire [0:0] out_stall_out_1,
    output wire [32:0] out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_address,
    output wire [4:0] out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_burstcount,
    output wire [63:0] out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_byteenable,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_enable,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_read,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_write,
    output wire [511:0] out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_writedata,
    output wire [0:0] out_valid_out_0,
    output wire [0:0] out_wgl_0_exit_exit_stall_in,
    output wire [0:0] out_wgl_0_exit_exit_valid_in,
    input wire [63:0] in_acl_global_id_039_0,
    input wire [63:0] in_acl_global_id_039_1,
    input wire [63:0] in_acl_global_id_145_0,
    input wire [63:0] in_acl_global_id_145_1,
    input wire [31:0] in_acl_hw_wg_id52_0,
    input wire [31:0] in_acl_hw_wg_id52_1,
    input wire [63:0] in_arg16,
    input wire [0:0] in_do_directly_crit_edge_0,
    input wire [0:0] in_do_directly_crit_edge_1,
    input wire [0:0] in_do_directly_crit_edge_loopexit_0,
    input wire [0:0] in_do_directly_crit_edge_loopexit_1,
    input wire [0:0] in_flush,
    input wire [31:0] in_l_grpid_01_0,
    input wire [31:0] in_l_grpid_01_1,
    input wire [31:0] in_lcssa_lcssa_0,
    input wire [31:0] in_lcssa_lcssa_1,
    input wire [0:0] in_stall_in_0,
    input wire [511:0] in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_readdata,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_readdatavalid,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_waitrequest,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_writeack,
    input wire [0:0] in_valid_in_0,
    input wire [0:0] in_valid_in_1,
    input wire [0:0] in_wgl_0_exit_exit_stall_out,
    input wire [0:0] in_wgl_0_exit_exit_valid_out,
    input wire [63:0] in_arg18_0_tpl,
    input wire [63:0] in_arg18_1_tpl,
    input wire [63:0] in_arg19_0_tpl,
    input wire [63:0] in_arg19_1_tpl,
    input wire clock,
    input wire resetn
    );

    wire [31:0] ZTS6c_calc_B3_branch_out_acl_hw_wg_id52;
    wire [0:0] ZTS6c_calc_B3_branch_out_stall_out;
    wire [0:0] ZTS6c_calc_B3_branch_out_valid_out_0;
    wire [63:0] ZTS6c_calc_B3_merge_out_acl_global_id_039;
    wire [63:0] ZTS6c_calc_B3_merge_out_acl_global_id_145;
    wire [31:0] ZTS6c_calc_B3_merge_out_acl_hw_wg_id52;
    wire [0:0] ZTS6c_calc_B3_merge_out_do_directly_crit_edge;
    wire [0:0] ZTS6c_calc_B3_merge_out_do_directly_crit_edge_loopexit;
    wire [31:0] ZTS6c_calc_B3_merge_out_l_grpid_01;
    wire [31:0] ZTS6c_calc_B3_merge_out_lcssa_lcssa;
    wire [0:0] ZTS6c_calc_B3_merge_out_stall_out_0;
    wire [0:0] ZTS6c_calc_B3_merge_out_stall_out_1;
    wire [0:0] ZTS6c_calc_B3_merge_out_valid_out;
    wire [31:0] bb_ZTS6c_calc_B3_stall_region_out_acl_hw_wg_id52;
    wire [0:0] bb_ZTS6c_calc_B3_stall_region_out_lsu_unnamed_k2_ZTS6c_calc9_o_active;
    wire [0:0] bb_ZTS6c_calc_B3_stall_region_out_stall_out;
    wire [32:0] bb_ZTS6c_calc_B3_stall_region_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_address;
    wire [4:0] bb_ZTS6c_calc_B3_stall_region_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_burstcount;
    wire [63:0] bb_ZTS6c_calc_B3_stall_region_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_byteenable;
    wire [0:0] bb_ZTS6c_calc_B3_stall_region_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_enable;
    wire [0:0] bb_ZTS6c_calc_B3_stall_region_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_read;
    wire [0:0] bb_ZTS6c_calc_B3_stall_region_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_write;
    wire [511:0] bb_ZTS6c_calc_B3_stall_region_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_writedata;
    wire [0:0] bb_ZTS6c_calc_B3_stall_region_out_valid_out;
    wire [0:0] bb_ZTS6c_calc_B3_stall_region_out_wgl_0_exit_exit_stall_in;
    wire [0:0] bb_ZTS6c_calc_B3_stall_region_out_wgl_0_exit_exit_valid_in;


    // ZTS6c_calc_B3_merge(BLACKBOX,3)
    k2_ZTS6c_calc_ZTS6c_calc_B3_merge theZTS6c_calc_B3_merge (
        .in_acl_global_id_039_0(in_acl_global_id_039_0),
        .in_acl_global_id_039_1(in_acl_global_id_039_1),
        .in_acl_global_id_145_0(in_acl_global_id_145_0),
        .in_acl_global_id_145_1(in_acl_global_id_145_1),
        .in_acl_hw_wg_id52_0(in_acl_hw_wg_id52_0),
        .in_acl_hw_wg_id52_1(in_acl_hw_wg_id52_1),
        .in_do_directly_crit_edge_0(in_do_directly_crit_edge_0),
        .in_do_directly_crit_edge_1(in_do_directly_crit_edge_1),
        .in_do_directly_crit_edge_loopexit_0(in_do_directly_crit_edge_loopexit_0),
        .in_do_directly_crit_edge_loopexit_1(in_do_directly_crit_edge_loopexit_1),
        .in_l_grpid_01_0(in_l_grpid_01_0),
        .in_l_grpid_01_1(in_l_grpid_01_1),
        .in_lcssa_lcssa_0(in_lcssa_lcssa_0),
        .in_lcssa_lcssa_1(in_lcssa_lcssa_1),
        .in_stall_in(bb_ZTS6c_calc_B3_stall_region_out_stall_out),
        .in_valid_in_0(in_valid_in_0),
        .in_valid_in_1(in_valid_in_1),
        .out_acl_global_id_039(ZTS6c_calc_B3_merge_out_acl_global_id_039),
        .out_acl_global_id_145(ZTS6c_calc_B3_merge_out_acl_global_id_145),
        .out_acl_hw_wg_id52(ZTS6c_calc_B3_merge_out_acl_hw_wg_id52),
        .out_do_directly_crit_edge(ZTS6c_calc_B3_merge_out_do_directly_crit_edge),
        .out_do_directly_crit_edge_loopexit(ZTS6c_calc_B3_merge_out_do_directly_crit_edge_loopexit),
        .out_l_grpid_01(ZTS6c_calc_B3_merge_out_l_grpid_01),
        .out_lcssa_lcssa(ZTS6c_calc_B3_merge_out_lcssa_lcssa),
        .out_stall_out_0(ZTS6c_calc_B3_merge_out_stall_out_0),
        .out_stall_out_1(ZTS6c_calc_B3_merge_out_stall_out_1),
        .out_valid_out(ZTS6c_calc_B3_merge_out_valid_out),
        .clock(clock),
        .resetn(resetn)
    );

    // bb_ZTS6c_calc_B3_stall_region(BLACKBOX,4)
    k2_ZTS6c_calc_bb_ZTS6c_calc_B3_stall_region thebb_ZTS6c_calc_B3_stall_region (
        .in_acl_global_id_039(ZTS6c_calc_B3_merge_out_acl_global_id_039),
        .in_acl_global_id_145(ZTS6c_calc_B3_merge_out_acl_global_id_145),
        .in_acl_hw_wg_id52(ZTS6c_calc_B3_merge_out_acl_hw_wg_id52),
        .in_arg16(in_arg16),
        .in_do_directly_crit_edge(ZTS6c_calc_B3_merge_out_do_directly_crit_edge),
        .in_do_directly_crit_edge_loopexit(ZTS6c_calc_B3_merge_out_do_directly_crit_edge_loopexit),
        .in_flush(in_flush),
        .in_l_grpid_01(ZTS6c_calc_B3_merge_out_l_grpid_01),
        .in_lcssa_lcssa(ZTS6c_calc_B3_merge_out_lcssa_lcssa),
        .in_stall_in(ZTS6c_calc_B3_branch_out_stall_out),
        .in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_readdata(in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_readdata),
        .in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_readdatavalid(in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_readdatavalid),
        .in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_waitrequest(in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_waitrequest),
        .in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_writeack(in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_writeack),
        .in_valid_in(ZTS6c_calc_B3_merge_out_valid_out),
        .in_wgl_0_exit_exit_stall_out(in_wgl_0_exit_exit_stall_out),
        .in_wgl_0_exit_exit_valid_out(in_wgl_0_exit_exit_valid_out),
        .in_arg18_0_tpl(in_arg18_0_tpl),
        .in_arg18_1_tpl(in_arg18_1_tpl),
        .in_arg19_0_tpl(in_arg19_0_tpl),
        .in_arg19_1_tpl(in_arg19_1_tpl),
        .out_acl_hw_wg_id52(bb_ZTS6c_calc_B3_stall_region_out_acl_hw_wg_id52),
        .out_lsu_unnamed_k2_ZTS6c_calc9_o_active(bb_ZTS6c_calc_B3_stall_region_out_lsu_unnamed_k2_ZTS6c_calc9_o_active),
        .out_stall_out(bb_ZTS6c_calc_B3_stall_region_out_stall_out),
        .out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_address(bb_ZTS6c_calc_B3_stall_region_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_address),
        .out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_burstcount(bb_ZTS6c_calc_B3_stall_region_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_burstcount),
        .out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_byteenable(bb_ZTS6c_calc_B3_stall_region_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_byteenable),
        .out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_enable(bb_ZTS6c_calc_B3_stall_region_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_enable),
        .out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_read(bb_ZTS6c_calc_B3_stall_region_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_read),
        .out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_write(bb_ZTS6c_calc_B3_stall_region_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_write),
        .out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_writedata(bb_ZTS6c_calc_B3_stall_region_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_writedata),
        .out_valid_out(bb_ZTS6c_calc_B3_stall_region_out_valid_out),
        .out_wgl_0_exit_exit_stall_in(bb_ZTS6c_calc_B3_stall_region_out_wgl_0_exit_exit_stall_in),
        .out_wgl_0_exit_exit_valid_in(bb_ZTS6c_calc_B3_stall_region_out_wgl_0_exit_exit_valid_in),
        .clock(clock),
        .resetn(resetn)
    );

    // ZTS6c_calc_B3_branch(BLACKBOX,2)
    k2_ZTS6c_calc_ZTS6c_calc_B3_branch theZTS6c_calc_B3_branch (
        .in_acl_hw_wg_id52(bb_ZTS6c_calc_B3_stall_region_out_acl_hw_wg_id52),
        .in_stall_in_0(in_stall_in_0),
        .in_valid_in(bb_ZTS6c_calc_B3_stall_region_out_valid_out),
        .out_acl_hw_wg_id52(ZTS6c_calc_B3_branch_out_acl_hw_wg_id52),
        .out_stall_out(ZTS6c_calc_B3_branch_out_stall_out),
        .out_valid_out_0(ZTS6c_calc_B3_branch_out_valid_out_0),
        .clock(clock),
        .resetn(resetn)
    );

    // out_acl_hw_wg_id52(GPOUT,5)
    assign out_acl_hw_wg_id52 = ZTS6c_calc_B3_branch_out_acl_hw_wg_id52;

    // out_lsu_unnamed_k2_ZTS6c_calc9_o_active(GPOUT,6)
    assign out_lsu_unnamed_k2_ZTS6c_calc9_o_active = bb_ZTS6c_calc_B3_stall_region_out_lsu_unnamed_k2_ZTS6c_calc9_o_active;

    // out_stall_out_0(GPOUT,7)
    assign out_stall_out_0 = ZTS6c_calc_B3_merge_out_stall_out_0;

    // out_stall_out_1(GPOUT,8)
    assign out_stall_out_1 = ZTS6c_calc_B3_merge_out_stall_out_1;

    // out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_address(GPOUT,9)
    assign out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_address = bb_ZTS6c_calc_B3_stall_region_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_address;

    // out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_burstcount(GPOUT,10)
    assign out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_burstcount = bb_ZTS6c_calc_B3_stall_region_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_burstcount;

    // out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_byteenable(GPOUT,11)
    assign out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_byteenable = bb_ZTS6c_calc_B3_stall_region_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_byteenable;

    // out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_enable(GPOUT,12)
    assign out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_enable = bb_ZTS6c_calc_B3_stall_region_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_enable;

    // out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_read(GPOUT,13)
    assign out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_read = bb_ZTS6c_calc_B3_stall_region_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_read;

    // out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_write(GPOUT,14)
    assign out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_write = bb_ZTS6c_calc_B3_stall_region_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_write;

    // out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_writedata(GPOUT,15)
    assign out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_writedata = bb_ZTS6c_calc_B3_stall_region_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_writedata;

    // out_valid_out_0(GPOUT,16)
    assign out_valid_out_0 = ZTS6c_calc_B3_branch_out_valid_out_0;

    // out_wgl_0_exit_exit_stall_in(GPOUT,17)
    assign out_wgl_0_exit_exit_stall_in = bb_ZTS6c_calc_B3_stall_region_out_wgl_0_exit_exit_stall_in;

    // out_wgl_0_exit_exit_valid_in(GPOUT,18)
    assign out_wgl_0_exit_exit_valid_in = bb_ZTS6c_calc_B3_stall_region_out_wgl_0_exit_exit_valid_in;

endmodule
