// ------------------------------------------------------------------------- 
// High Level Design Compiler for Intel(R) FPGAs Version 20.3 (Release Build #121)
// 
// Legal Notice: Copyright 2020 Intel Corporation.  All rights reserved.
// Your use of  Intel Corporation's design tools,  logic functions and other
// software and  tools, and its AMPP partner logic functions, and any output
// files any  of the foregoing (including  device programming  or simulation
// files), and  any associated  documentation  or information  are expressly
// subject  to the terms and  conditions of the  Intel FPGA Software License
// Agreement, Intel MegaCore Function License Agreement, or other applicable
// license agreement,  including,  without limitation,  that your use is for
// the  sole  purpose of  programming  logic devices  manufactured by  Intel
// and  sold by Intel  or its authorized  distributors. Please refer  to the
// applicable agreement for further details.
// ---------------------------------------------------------------------------

// SystemVerilog created from k2_ZTS6c_calc_bb_ZTS6c_calc_B5
// SystemVerilog created on Thu Nov  5 06:32:57 2020


(* altera_attribute = "-name AUTO_SHIFT_REGISTER_RECOGNITION OFF; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 10037; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 15400; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 12020; -name MESSAGE_DISABLE 12030; -name MESSAGE_DISABLE 12010; -name MESSAGE_DISABLE 12110; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 13410; -name MESSAGE_DISABLE 113007; -name MESSAGE_DISABLE 10958" *)
module k2_ZTS6c_calc_bb_ZTS6c_calc_B5 (
    output wire [63:0] out_acl_global_id_041,
    output wire [63:0] out_acl_global_id_147,
    output wire [31:0] out_acl_hw_wg_id54,
    output wire [31:0] out_c0_exe15437,
    output wire [31:0] out_c0_exe28,
    output wire [31:0] out_c0_exe413,
    output wire [63:0] out_c0_exe518,
    output wire [63:0] out_c0_exe621,
    output wire [63:0] out_c0_exe726,
    output wire [63:0] out_c0_exe829,
    output wire [31:0] out_l_grpid_03,
    output wire [0:0] out_stall_in_0,
    output wire [0:0] out_stall_out_0,
    output wire [31:0] out_unnamed_k2_ZTS6c_calc19,
    output wire [31:0] out_unnamed_k2_ZTS6c_calc20,
    output wire [0:0] out_valid_out_0,
    output wire [0:0] out_valid_out_1,
    input wire [31:0] in_acl_0141_i50932_0,
    input wire [31:0] in_acl_0142_i50834_0,
    input wire [63:0] in_acl_global_id_041_0,
    input wire [63:0] in_acl_global_id_147_0,
    input wire [31:0] in_acl_hw_wg_id54_0,
    input wire [63:0] in_arg12,
    input wire [63:0] in_arg16,
    input wire [63:0] in_arg4,
    input wire [31:0] in_barrier_unnamed_k2_ZTS6c_calc22_wgs_workgroup_size,
    input wire [31:0] in_c0_exe15437_0,
    input wire [31:0] in_c0_exe28_0,
    input wire [31:0] in_c0_exe413_0,
    input wire [63:0] in_c0_exe518_0,
    input wire [63:0] in_c0_exe621_0,
    input wire [63:0] in_c0_exe726_0,
    input wire [63:0] in_c0_exe829_0,
    input wire [31:0] in_l_grpid_03_0,
    input wire [0:0] in_stall_in_0,
    input wire [0:0] in_stall_in_1,
    input wire [0:0] in_valid_in_0,
    input wire [63:0] in_arg15_0_tpl,
    input wire [63:0] in_arg18_0_tpl,
    input wire [63:0] in_arg18_1_tpl,
    input wire [63:0] in_arg19_0_tpl,
    input wire [63:0] in_arg19_1_tpl,
    input wire [63:0] in_arg7_0_tpl,
    input wire clock,
    input wire resetn
    );

    wire [63:0] ZTS6c_calc_B5_branch_out_acl_global_id_041;
    wire [63:0] ZTS6c_calc_B5_branch_out_acl_global_id_147;
    wire [31:0] ZTS6c_calc_B5_branch_out_acl_hw_wg_id54;
    wire [31:0] ZTS6c_calc_B5_branch_out_c0_exe15437;
    wire [31:0] ZTS6c_calc_B5_branch_out_c0_exe28;
    wire [31:0] ZTS6c_calc_B5_branch_out_c0_exe413;
    wire [63:0] ZTS6c_calc_B5_branch_out_c0_exe518;
    wire [63:0] ZTS6c_calc_B5_branch_out_c0_exe621;
    wire [63:0] ZTS6c_calc_B5_branch_out_c0_exe726;
    wire [63:0] ZTS6c_calc_B5_branch_out_c0_exe829;
    wire [31:0] ZTS6c_calc_B5_branch_out_l_grpid_03;
    wire [0:0] ZTS6c_calc_B5_branch_out_stall_out;
    wire [31:0] ZTS6c_calc_B5_branch_out_unnamed_k2_ZTS6c_calc19;
    wire [31:0] ZTS6c_calc_B5_branch_out_unnamed_k2_ZTS6c_calc20;
    wire [0:0] ZTS6c_calc_B5_branch_out_valid_out_0;
    wire [0:0] ZTS6c_calc_B5_branch_out_valid_out_1;
    wire [31:0] ZTS6c_calc_B5_merge_out_acl_0141_i50932;
    wire [31:0] ZTS6c_calc_B5_merge_out_acl_0142_i50834;
    wire [63:0] ZTS6c_calc_B5_merge_out_acl_global_id_041;
    wire [63:0] ZTS6c_calc_B5_merge_out_acl_global_id_147;
    wire [31:0] ZTS6c_calc_B5_merge_out_acl_hw_wg_id54;
    wire [31:0] ZTS6c_calc_B5_merge_out_c0_exe15437;
    wire [31:0] ZTS6c_calc_B5_merge_out_c0_exe28;
    wire [31:0] ZTS6c_calc_B5_merge_out_c0_exe413;
    wire [63:0] ZTS6c_calc_B5_merge_out_c0_exe518;
    wire [63:0] ZTS6c_calc_B5_merge_out_c0_exe621;
    wire [63:0] ZTS6c_calc_B5_merge_out_c0_exe726;
    wire [63:0] ZTS6c_calc_B5_merge_out_c0_exe829;
    wire [31:0] ZTS6c_calc_B5_merge_out_l_grpid_03;
    wire [0:0] ZTS6c_calc_B5_merge_out_stall_out_0;
    wire [0:0] ZTS6c_calc_B5_merge_out_valid_out;
    wire [63:0] bb_ZTS6c_calc_B5_stall_region_out_acl_global_id_041;
    wire [63:0] bb_ZTS6c_calc_B5_stall_region_out_acl_global_id_147;
    wire [31:0] bb_ZTS6c_calc_B5_stall_region_out_acl_hw_wg_id54;
    wire [31:0] bb_ZTS6c_calc_B5_stall_region_out_c0_exe15437;
    wire [31:0] bb_ZTS6c_calc_B5_stall_region_out_c0_exe28;
    wire [31:0] bb_ZTS6c_calc_B5_stall_region_out_c0_exe413;
    wire [63:0] bb_ZTS6c_calc_B5_stall_region_out_c0_exe518;
    wire [63:0] bb_ZTS6c_calc_B5_stall_region_out_c0_exe621;
    wire [63:0] bb_ZTS6c_calc_B5_stall_region_out_c0_exe726;
    wire [63:0] bb_ZTS6c_calc_B5_stall_region_out_c0_exe829;
    wire [31:0] bb_ZTS6c_calc_B5_stall_region_out_l_grpid_03;
    wire [0:0] bb_ZTS6c_calc_B5_stall_region_out_stall_out;
    wire [31:0] bb_ZTS6c_calc_B5_stall_region_out_unnamed_k2_ZTS6c_calc19;
    wire [31:0] bb_ZTS6c_calc_B5_stall_region_out_unnamed_k2_ZTS6c_calc20;
    wire [0:0] bb_ZTS6c_calc_B5_stall_region_out_unnamed_k2_ZTS6c_calc21;
    wire [0:0] bb_ZTS6c_calc_B5_stall_region_out_valid_out;


    // ZTS6c_calc_B5_merge(BLACKBOX,3)
    k2_ZTS6c_calc_ZTS6c_calc_B5_merge theZTS6c_calc_B5_merge (
        .in_acl_0141_i50932_0(in_acl_0141_i50932_0),
        .in_acl_0142_i50834_0(in_acl_0142_i50834_0),
        .in_acl_global_id_041_0(in_acl_global_id_041_0),
        .in_acl_global_id_147_0(in_acl_global_id_147_0),
        .in_acl_hw_wg_id54_0(in_acl_hw_wg_id54_0),
        .in_c0_exe15437_0(in_c0_exe15437_0),
        .in_c0_exe28_0(in_c0_exe28_0),
        .in_c0_exe413_0(in_c0_exe413_0),
        .in_c0_exe518_0(in_c0_exe518_0),
        .in_c0_exe621_0(in_c0_exe621_0),
        .in_c0_exe726_0(in_c0_exe726_0),
        .in_c0_exe829_0(in_c0_exe829_0),
        .in_l_grpid_03_0(in_l_grpid_03_0),
        .in_stall_in(bb_ZTS6c_calc_B5_stall_region_out_stall_out),
        .in_valid_in_0(in_valid_in_0),
        .out_acl_0141_i50932(ZTS6c_calc_B5_merge_out_acl_0141_i50932),
        .out_acl_0142_i50834(ZTS6c_calc_B5_merge_out_acl_0142_i50834),
        .out_acl_global_id_041(ZTS6c_calc_B5_merge_out_acl_global_id_041),
        .out_acl_global_id_147(ZTS6c_calc_B5_merge_out_acl_global_id_147),
        .out_acl_hw_wg_id54(ZTS6c_calc_B5_merge_out_acl_hw_wg_id54),
        .out_c0_exe15437(ZTS6c_calc_B5_merge_out_c0_exe15437),
        .out_c0_exe28(ZTS6c_calc_B5_merge_out_c0_exe28),
        .out_c0_exe413(ZTS6c_calc_B5_merge_out_c0_exe413),
        .out_c0_exe518(ZTS6c_calc_B5_merge_out_c0_exe518),
        .out_c0_exe621(ZTS6c_calc_B5_merge_out_c0_exe621),
        .out_c0_exe726(ZTS6c_calc_B5_merge_out_c0_exe726),
        .out_c0_exe829(ZTS6c_calc_B5_merge_out_c0_exe829),
        .out_l_grpid_03(ZTS6c_calc_B5_merge_out_l_grpid_03),
        .out_stall_out_0(ZTS6c_calc_B5_merge_out_stall_out_0),
        .out_valid_out(ZTS6c_calc_B5_merge_out_valid_out),
        .clock(clock),
        .resetn(resetn)
    );

    // bb_ZTS6c_calc_B5_stall_region(BLACKBOX,4)
    k2_ZTS6c_calc_bb_ZTS6c_calc_B5_stall_region thebb_ZTS6c_calc_B5_stall_region (
        .in_acl_0141_i50932(ZTS6c_calc_B5_merge_out_acl_0141_i50932),
        .in_acl_0142_i50834(ZTS6c_calc_B5_merge_out_acl_0142_i50834),
        .in_acl_global_id_041(ZTS6c_calc_B5_merge_out_acl_global_id_041),
        .in_acl_global_id_147(ZTS6c_calc_B5_merge_out_acl_global_id_147),
        .in_acl_hw_wg_id54(ZTS6c_calc_B5_merge_out_acl_hw_wg_id54),
        .in_barrier_unnamed_k2_ZTS6c_calc22_wgs_workgroup_size(in_barrier_unnamed_k2_ZTS6c_calc22_wgs_workgroup_size),
        .in_c0_exe15437(ZTS6c_calc_B5_merge_out_c0_exe15437),
        .in_c0_exe28(ZTS6c_calc_B5_merge_out_c0_exe28),
        .in_c0_exe413(ZTS6c_calc_B5_merge_out_c0_exe413),
        .in_c0_exe518(ZTS6c_calc_B5_merge_out_c0_exe518),
        .in_c0_exe621(ZTS6c_calc_B5_merge_out_c0_exe621),
        .in_c0_exe726(ZTS6c_calc_B5_merge_out_c0_exe726),
        .in_c0_exe829(ZTS6c_calc_B5_merge_out_c0_exe829),
        .in_l_grpid_03(ZTS6c_calc_B5_merge_out_l_grpid_03),
        .in_stall_in(ZTS6c_calc_B5_branch_out_stall_out),
        .in_valid_in(ZTS6c_calc_B5_merge_out_valid_out),
        .out_acl_global_id_041(bb_ZTS6c_calc_B5_stall_region_out_acl_global_id_041),
        .out_acl_global_id_147(bb_ZTS6c_calc_B5_stall_region_out_acl_global_id_147),
        .out_acl_hw_wg_id54(bb_ZTS6c_calc_B5_stall_region_out_acl_hw_wg_id54),
        .out_c0_exe15437(bb_ZTS6c_calc_B5_stall_region_out_c0_exe15437),
        .out_c0_exe28(bb_ZTS6c_calc_B5_stall_region_out_c0_exe28),
        .out_c0_exe413(bb_ZTS6c_calc_B5_stall_region_out_c0_exe413),
        .out_c0_exe518(bb_ZTS6c_calc_B5_stall_region_out_c0_exe518),
        .out_c0_exe621(bb_ZTS6c_calc_B5_stall_region_out_c0_exe621),
        .out_c0_exe726(bb_ZTS6c_calc_B5_stall_region_out_c0_exe726),
        .out_c0_exe829(bb_ZTS6c_calc_B5_stall_region_out_c0_exe829),
        .out_l_grpid_03(bb_ZTS6c_calc_B5_stall_region_out_l_grpid_03),
        .out_stall_out(bb_ZTS6c_calc_B5_stall_region_out_stall_out),
        .out_unnamed_k2_ZTS6c_calc19(bb_ZTS6c_calc_B5_stall_region_out_unnamed_k2_ZTS6c_calc19),
        .out_unnamed_k2_ZTS6c_calc20(bb_ZTS6c_calc_B5_stall_region_out_unnamed_k2_ZTS6c_calc20),
        .out_unnamed_k2_ZTS6c_calc21(bb_ZTS6c_calc_B5_stall_region_out_unnamed_k2_ZTS6c_calc21),
        .out_valid_out(bb_ZTS6c_calc_B5_stall_region_out_valid_out),
        .clock(clock),
        .resetn(resetn)
    );

    // ZTS6c_calc_B5_branch(BLACKBOX,2)
    k2_ZTS6c_calc_ZTS6c_calc_B5_branch theZTS6c_calc_B5_branch (
        .in_acl_global_id_041(bb_ZTS6c_calc_B5_stall_region_out_acl_global_id_041),
        .in_acl_global_id_147(bb_ZTS6c_calc_B5_stall_region_out_acl_global_id_147),
        .in_acl_hw_wg_id54(bb_ZTS6c_calc_B5_stall_region_out_acl_hw_wg_id54),
        .in_c0_exe15437(bb_ZTS6c_calc_B5_stall_region_out_c0_exe15437),
        .in_c0_exe28(bb_ZTS6c_calc_B5_stall_region_out_c0_exe28),
        .in_c0_exe413(bb_ZTS6c_calc_B5_stall_region_out_c0_exe413),
        .in_c0_exe518(bb_ZTS6c_calc_B5_stall_region_out_c0_exe518),
        .in_c0_exe621(bb_ZTS6c_calc_B5_stall_region_out_c0_exe621),
        .in_c0_exe726(bb_ZTS6c_calc_B5_stall_region_out_c0_exe726),
        .in_c0_exe829(bb_ZTS6c_calc_B5_stall_region_out_c0_exe829),
        .in_l_grpid_03(bb_ZTS6c_calc_B5_stall_region_out_l_grpid_03),
        .in_stall_in_0(in_stall_in_0),
        .in_stall_in_1(in_stall_in_1),
        .in_unnamed_k2_ZTS6c_calc19(bb_ZTS6c_calc_B5_stall_region_out_unnamed_k2_ZTS6c_calc19),
        .in_unnamed_k2_ZTS6c_calc20(bb_ZTS6c_calc_B5_stall_region_out_unnamed_k2_ZTS6c_calc20),
        .in_unnamed_k2_ZTS6c_calc21(bb_ZTS6c_calc_B5_stall_region_out_unnamed_k2_ZTS6c_calc21),
        .in_valid_in(bb_ZTS6c_calc_B5_stall_region_out_valid_out),
        .out_acl_global_id_041(ZTS6c_calc_B5_branch_out_acl_global_id_041),
        .out_acl_global_id_147(ZTS6c_calc_B5_branch_out_acl_global_id_147),
        .out_acl_hw_wg_id54(ZTS6c_calc_B5_branch_out_acl_hw_wg_id54),
        .out_c0_exe15437(ZTS6c_calc_B5_branch_out_c0_exe15437),
        .out_c0_exe28(ZTS6c_calc_B5_branch_out_c0_exe28),
        .out_c0_exe413(ZTS6c_calc_B5_branch_out_c0_exe413),
        .out_c0_exe518(ZTS6c_calc_B5_branch_out_c0_exe518),
        .out_c0_exe621(ZTS6c_calc_B5_branch_out_c0_exe621),
        .out_c0_exe726(ZTS6c_calc_B5_branch_out_c0_exe726),
        .out_c0_exe829(ZTS6c_calc_B5_branch_out_c0_exe829),
        .out_l_grpid_03(ZTS6c_calc_B5_branch_out_l_grpid_03),
        .out_stall_out(ZTS6c_calc_B5_branch_out_stall_out),
        .out_unnamed_k2_ZTS6c_calc19(ZTS6c_calc_B5_branch_out_unnamed_k2_ZTS6c_calc19),
        .out_unnamed_k2_ZTS6c_calc20(ZTS6c_calc_B5_branch_out_unnamed_k2_ZTS6c_calc20),
        .out_valid_out_0(ZTS6c_calc_B5_branch_out_valid_out_0),
        .out_valid_out_1(ZTS6c_calc_B5_branch_out_valid_out_1),
        .clock(clock),
        .resetn(resetn)
    );

    // out_acl_global_id_041(GPOUT,5)
    assign out_acl_global_id_041 = ZTS6c_calc_B5_branch_out_acl_global_id_041;

    // out_acl_global_id_147(GPOUT,6)
    assign out_acl_global_id_147 = ZTS6c_calc_B5_branch_out_acl_global_id_147;

    // out_acl_hw_wg_id54(GPOUT,7)
    assign out_acl_hw_wg_id54 = ZTS6c_calc_B5_branch_out_acl_hw_wg_id54;

    // out_c0_exe15437(GPOUT,8)
    assign out_c0_exe15437 = ZTS6c_calc_B5_branch_out_c0_exe15437;

    // out_c0_exe28(GPOUT,9)
    assign out_c0_exe28 = ZTS6c_calc_B5_branch_out_c0_exe28;

    // out_c0_exe413(GPOUT,10)
    assign out_c0_exe413 = ZTS6c_calc_B5_branch_out_c0_exe413;

    // out_c0_exe518(GPOUT,11)
    assign out_c0_exe518 = ZTS6c_calc_B5_branch_out_c0_exe518;

    // out_c0_exe621(GPOUT,12)
    assign out_c0_exe621 = ZTS6c_calc_B5_branch_out_c0_exe621;

    // out_c0_exe726(GPOUT,13)
    assign out_c0_exe726 = ZTS6c_calc_B5_branch_out_c0_exe726;

    // out_c0_exe829(GPOUT,14)
    assign out_c0_exe829 = ZTS6c_calc_B5_branch_out_c0_exe829;

    // out_l_grpid_03(GPOUT,15)
    assign out_l_grpid_03 = ZTS6c_calc_B5_branch_out_l_grpid_03;

    // out_stall_in_0(GPOUT,16)
    assign out_stall_in_0 = in_stall_in_0;

    // out_stall_out_0(GPOUT,17)
    assign out_stall_out_0 = ZTS6c_calc_B5_merge_out_stall_out_0;

    // out_unnamed_k2_ZTS6c_calc19(GPOUT,18)
    assign out_unnamed_k2_ZTS6c_calc19 = ZTS6c_calc_B5_branch_out_unnamed_k2_ZTS6c_calc19;

    // out_unnamed_k2_ZTS6c_calc20(GPOUT,19)
    assign out_unnamed_k2_ZTS6c_calc20 = ZTS6c_calc_B5_branch_out_unnamed_k2_ZTS6c_calc20;

    // out_valid_out_0(GPOUT,20)
    assign out_valid_out_0 = ZTS6c_calc_B5_branch_out_valid_out_0;

    // out_valid_out_1(GPOUT,21)
    assign out_valid_out_1 = ZTS6c_calc_B5_branch_out_valid_out_1;

endmodule
