// ------------------------------------------------------------------------- 
// High Level Design Compiler for Intel(R) FPGAs Version 20.3 (Release Build #121)
// 
// Legal Notice: Copyright 2020 Intel Corporation.  All rights reserved.
// Your use of  Intel Corporation's design tools,  logic functions and other
// software and  tools, and its AMPP partner logic functions, and any output
// files any  of the foregoing (including  device programming  or simulation
// files), and  any associated  documentation  or information  are expressly
// subject  to the terms and  conditions of the  Intel FPGA Software License
// Agreement, Intel MegaCore Function License Agreement, or other applicable
// license agreement,  including,  without limitation,  that your use is for
// the  sole  purpose of  programming  logic devices  manufactured by  Intel
// and  sold by Intel  or its authorized  distributors. Please refer  to the
// applicable agreement for further details.
// ---------------------------------------------------------------------------

// SystemVerilog created from k2_ZTS6c_calc_bb_ZTS6c_calc_B6
// SystemVerilog created on Thu Nov  5 06:32:57 2020


(* altera_attribute = "-name AUTO_SHIFT_REGISTER_RECOGNITION OFF; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 10037; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 15400; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 12020; -name MESSAGE_DISABLE 12030; -name MESSAGE_DISABLE 12010; -name MESSAGE_DISABLE 12110; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 13410; -name MESSAGE_DISABLE 113007; -name MESSAGE_DISABLE 10958" *)
module k2_ZTS6c_calc_bb_ZTS6c_calc_B6 (
    output wire [31:0] out_acl_0141_i50933,
    output wire [31:0] out_acl_0142_i50835,
    output wire [63:0] out_acl_global_id_042,
    output wire [63:0] out_acl_global_id_148,
    output wire [31:0] out_acl_hw_wg_id55,
    output wire [31:0] out_c0_exe154,
    output wire [31:0] out_c0_exe255,
    output wire [31:0] out_c0_exe29,
    output wire [31:0] out_c0_exe414,
    output wire [63:0] out_c0_exe516,
    output wire [63:0] out_c0_exe622,
    output wire [63:0] out_c0_exe724,
    output wire [63:0] out_c0_exe830,
    output wire [31:0] out_l_grpid_04,
    output wire [63:0] out_l_grpid_0_ext_offset36,
    output wire [0:0] out_stall_in_0,
    output wire [0:0] out_stall_out_0,
    output wire [0:0] out_stall_out_1,
    output wire [31:0] out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_address,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_burstcount,
    output wire [3:0] out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_byteenable,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_enable,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_read,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_write,
    output wire [31:0] out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writedata,
    output wire [31:0] out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_address,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_burstcount,
    output wire [3:0] out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_byteenable,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_enable,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_read,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_write,
    output wire [31:0] out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writedata,
    output wire [0:0] out_valid_in_0,
    output wire [0:0] out_valid_in_1,
    output wire [0:0] out_valid_out_0,
    output wire [0:0] out_valid_out_1,
    input wire [31:0] in_acl_0141_i50933_0,
    input wire [31:0] in_acl_0141_i50933_1,
    input wire [31:0] in_acl_0142_i50835_0,
    input wire [31:0] in_acl_0142_i50835_1,
    input wire [31:0] in_acl_0_i506_0,
    input wire [31:0] in_acl_0_i506_1,
    input wire [31:0] in_acl_1_i505_0,
    input wire [31:0] in_acl_1_i505_1,
    input wire [63:0] in_acl_global_id_042_0,
    input wire [63:0] in_acl_global_id_042_1,
    input wire [63:0] in_acl_global_id_148_0,
    input wire [63:0] in_acl_global_id_148_1,
    input wire [31:0] in_acl_hw_wg_id55_0,
    input wire [31:0] in_acl_hw_wg_id55_1,
    input wire [63:0] in_arg12,
    input wire [63:0] in_arg16,
    input wire [63:0] in_arg4,
    input wire [31:0] in_c0_exe29_0,
    input wire [31:0] in_c0_exe29_1,
    input wire [31:0] in_c0_exe414_0,
    input wire [31:0] in_c0_exe414_1,
    input wire [63:0] in_c0_exe516_0,
    input wire [63:0] in_c0_exe516_1,
    input wire [63:0] in_c0_exe622_0,
    input wire [63:0] in_c0_exe622_1,
    input wire [63:0] in_c0_exe724_0,
    input wire [63:0] in_c0_exe724_1,
    input wire [63:0] in_c0_exe830_0,
    input wire [63:0] in_c0_exe830_1,
    input wire [31:0] in_encoder_ZTS6c_calc_B6_merge_priority_encoder_workgroup_size,
    input wire [0:0] in_flush,
    input wire [31:0] in_l_grpid_04_0,
    input wire [31:0] in_l_grpid_04_1,
    input wire [63:0] in_l_grpid_0_ext_offset36_0,
    input wire [63:0] in_l_grpid_0_ext_offset36_1,
    input wire [0:0] in_stall_in_0,
    input wire [0:0] in_stall_in_1,
    input wire [31:0] in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_readdata,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_readdatavalid,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_waitrequest,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writeack,
    input wire [31:0] in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_readdata,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_readdatavalid,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_waitrequest,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writeack,
    input wire [0:0] in_valid_in_0,
    input wire [0:0] in_valid_in_1,
    input wire [63:0] in_arg15_0_tpl,
    input wire [63:0] in_arg18_0_tpl,
    input wire [63:0] in_arg18_1_tpl,
    input wire [63:0] in_arg19_0_tpl,
    input wire [63:0] in_arg19_1_tpl,
    input wire [63:0] in_arg7_0_tpl,
    input wire clock,
    input wire resetn
    );

    wire [31:0] ZTS6c_calc_B6_branch_out_acl_0141_i50933;
    wire [31:0] ZTS6c_calc_B6_branch_out_acl_0142_i50835;
    wire [63:0] ZTS6c_calc_B6_branch_out_acl_global_id_042;
    wire [63:0] ZTS6c_calc_B6_branch_out_acl_global_id_148;
    wire [31:0] ZTS6c_calc_B6_branch_out_acl_hw_wg_id55;
    wire [31:0] ZTS6c_calc_B6_branch_out_c0_exe154;
    wire [31:0] ZTS6c_calc_B6_branch_out_c0_exe255;
    wire [31:0] ZTS6c_calc_B6_branch_out_c0_exe29;
    wire [31:0] ZTS6c_calc_B6_branch_out_c0_exe414;
    wire [63:0] ZTS6c_calc_B6_branch_out_c0_exe516;
    wire [63:0] ZTS6c_calc_B6_branch_out_c0_exe622;
    wire [63:0] ZTS6c_calc_B6_branch_out_c0_exe724;
    wire [63:0] ZTS6c_calc_B6_branch_out_c0_exe830;
    wire [31:0] ZTS6c_calc_B6_branch_out_l_grpid_04;
    wire [63:0] ZTS6c_calc_B6_branch_out_l_grpid_0_ext_offset36;
    wire [0:0] ZTS6c_calc_B6_branch_out_stall_out;
    wire [0:0] ZTS6c_calc_B6_branch_out_valid_out_0;
    wire [0:0] ZTS6c_calc_B6_branch_out_valid_out_1;
    wire [31:0] ZTS6c_calc_B6_merge_out_acl_0141_i50933;
    wire [31:0] ZTS6c_calc_B6_merge_out_acl_0142_i50835;
    wire [31:0] ZTS6c_calc_B6_merge_out_acl_0_i506;
    wire [31:0] ZTS6c_calc_B6_merge_out_acl_1_i505;
    wire [63:0] ZTS6c_calc_B6_merge_out_acl_global_id_042;
    wire [63:0] ZTS6c_calc_B6_merge_out_acl_global_id_148;
    wire [31:0] ZTS6c_calc_B6_merge_out_acl_hw_wg_id55;
    wire [31:0] ZTS6c_calc_B6_merge_out_c0_exe29;
    wire [31:0] ZTS6c_calc_B6_merge_out_c0_exe414;
    wire [63:0] ZTS6c_calc_B6_merge_out_c0_exe516;
    wire [63:0] ZTS6c_calc_B6_merge_out_c0_exe622;
    wire [63:0] ZTS6c_calc_B6_merge_out_c0_exe724;
    wire [63:0] ZTS6c_calc_B6_merge_out_c0_exe830;
    wire [31:0] ZTS6c_calc_B6_merge_out_l_grpid_04;
    wire [63:0] ZTS6c_calc_B6_merge_out_l_grpid_0_ext_offset36;
    wire [0:0] ZTS6c_calc_B6_merge_out_stall_out_0;
    wire [0:0] ZTS6c_calc_B6_merge_out_stall_out_1;
    wire [0:0] ZTS6c_calc_B6_merge_out_valid_out;
    wire [703:0] aggregateWireOut_join_q;
    wire [31:0] bb_ZTS6c_calc_B6_stall_region_out_acl_0141_i50933;
    wire [31:0] bb_ZTS6c_calc_B6_stall_region_out_acl_0142_i50835;
    wire [63:0] bb_ZTS6c_calc_B6_stall_region_out_acl_global_id_042;
    wire [63:0] bb_ZTS6c_calc_B6_stall_region_out_acl_global_id_148;
    wire [31:0] bb_ZTS6c_calc_B6_stall_region_out_acl_hw_wg_id55;
    wire [31:0] bb_ZTS6c_calc_B6_stall_region_out_c0_exe154;
    wire [31:0] bb_ZTS6c_calc_B6_stall_region_out_c0_exe255;
    wire [31:0] bb_ZTS6c_calc_B6_stall_region_out_c0_exe29;
    wire [0:0] bb_ZTS6c_calc_B6_stall_region_out_c0_exe356;
    wire [31:0] bb_ZTS6c_calc_B6_stall_region_out_c0_exe414;
    wire [63:0] bb_ZTS6c_calc_B6_stall_region_out_c0_exe516;
    wire [63:0] bb_ZTS6c_calc_B6_stall_region_out_c0_exe622;
    wire [63:0] bb_ZTS6c_calc_B6_stall_region_out_c0_exe724;
    wire [63:0] bb_ZTS6c_calc_B6_stall_region_out_c0_exe830;
    wire [31:0] bb_ZTS6c_calc_B6_stall_region_out_l_grpid_04;
    wire [63:0] bb_ZTS6c_calc_B6_stall_region_out_l_grpid_0_ext_offset36;
    wire [0:0] bb_ZTS6c_calc_B6_stall_region_out_stall_out;
    wire [31:0] bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_address;
    wire [0:0] bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_burstcount;
    wire [3:0] bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_byteenable;
    wire [0:0] bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_enable;
    wire [0:0] bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_read;
    wire [0:0] bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_write;
    wire [31:0] bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writedata;
    wire [31:0] bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_address;
    wire [0:0] bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_burstcount;
    wire [3:0] bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_byteenable;
    wire [0:0] bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_enable;
    wire [0:0] bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_read;
    wire [0:0] bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_write;
    wire [31:0] bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writedata;
    wire [0:0] bb_ZTS6c_calc_B6_stall_region_out_valid_out;
    wire [31:0] data_out_select_b;
    wire [703:0] loop_capacity_FIFO_out_data_out;
    wire [0:0] loop_capacity_FIFO_out_stall_out;
    wire [0:0] loop_capacity_FIFO_out_valid_out;
    wire [31:0] dupName_0_data_out_select_x_b;
    wire [31:0] dupName_1_data_out_select_x_b;
    wire [31:0] dupName_2_data_out_select_x_b;
    wire [63:0] dupName_3_data_out_select_x_b;
    wire [63:0] dupName_4_data_out_select_x_b;
    wire [31:0] dupName_5_data_out_select_x_b;
    wire [31:0] dupName_6_data_out_select_x_b;
    wire [31:0] dupName_7_data_out_select_x_b;
    wire [63:0] dupName_8_data_out_select_x_b;
    wire [63:0] dupName_9_data_out_select_x_b;
    wire [63:0] dupName_10_data_out_select_x_b;
    wire [63:0] dupName_11_data_out_select_x_b;
    wire [31:0] dupName_12_data_out_select_x_b;
    wire [63:0] dupName_13_data_out_select_x_b;


    // ZTS6c_calc_B6_merge(BLACKBOX,18)
    k2_ZTS6c_calc_ZTS6c_calc_B6_merge theZTS6c_calc_B6_merge (
        .in_acl_0141_i50933_0(in_acl_0141_i50933_0),
        .in_acl_0141_i50933_1(in_acl_0141_i50933_1),
        .in_acl_0142_i50835_0(in_acl_0142_i50835_0),
        .in_acl_0142_i50835_1(in_acl_0142_i50835_1),
        .in_acl_0_i506_0(in_acl_0_i506_0),
        .in_acl_0_i506_1(in_acl_0_i506_1),
        .in_acl_1_i505_0(in_acl_1_i505_0),
        .in_acl_1_i505_1(in_acl_1_i505_1),
        .in_acl_global_id_042_0(in_acl_global_id_042_0),
        .in_acl_global_id_042_1(in_acl_global_id_042_1),
        .in_acl_global_id_148_0(in_acl_global_id_148_0),
        .in_acl_global_id_148_1(in_acl_global_id_148_1),
        .in_acl_hw_wg_id55_0(in_acl_hw_wg_id55_0),
        .in_acl_hw_wg_id55_1(in_acl_hw_wg_id55_1),
        .in_c0_exe29_0(in_c0_exe29_0),
        .in_c0_exe29_1(in_c0_exe29_1),
        .in_c0_exe414_0(in_c0_exe414_0),
        .in_c0_exe414_1(in_c0_exe414_1),
        .in_c0_exe516_0(in_c0_exe516_0),
        .in_c0_exe516_1(in_c0_exe516_1),
        .in_c0_exe622_0(in_c0_exe622_0),
        .in_c0_exe622_1(in_c0_exe622_1),
        .in_c0_exe724_0(in_c0_exe724_0),
        .in_c0_exe724_1(in_c0_exe724_1),
        .in_c0_exe830_0(in_c0_exe830_0),
        .in_c0_exe830_1(in_c0_exe830_1),
        .in_encoder_ZTS6c_calc_B6_merge_priority_encoder_workgroup_size(in_encoder_ZTS6c_calc_B6_merge_priority_encoder_workgroup_size),
        .in_l_grpid_04_0(in_l_grpid_04_0),
        .in_l_grpid_04_1(in_l_grpid_04_1),
        .in_l_grpid_0_ext_offset36_0(in_l_grpid_0_ext_offset36_0),
        .in_l_grpid_0_ext_offset36_1(in_l_grpid_0_ext_offset36_1),
        .in_stall_in(loop_capacity_FIFO_out_stall_out),
        .in_valid_in_0(in_valid_in_0),
        .in_valid_in_1(in_valid_in_1),
        .out_acl_0141_i50933(ZTS6c_calc_B6_merge_out_acl_0141_i50933),
        .out_acl_0142_i50835(ZTS6c_calc_B6_merge_out_acl_0142_i50835),
        .out_acl_0_i506(ZTS6c_calc_B6_merge_out_acl_0_i506),
        .out_acl_1_i505(ZTS6c_calc_B6_merge_out_acl_1_i505),
        .out_acl_global_id_042(ZTS6c_calc_B6_merge_out_acl_global_id_042),
        .out_acl_global_id_148(ZTS6c_calc_B6_merge_out_acl_global_id_148),
        .out_acl_hw_wg_id55(ZTS6c_calc_B6_merge_out_acl_hw_wg_id55),
        .out_c0_exe29(ZTS6c_calc_B6_merge_out_c0_exe29),
        .out_c0_exe414(ZTS6c_calc_B6_merge_out_c0_exe414),
        .out_c0_exe516(ZTS6c_calc_B6_merge_out_c0_exe516),
        .out_c0_exe622(ZTS6c_calc_B6_merge_out_c0_exe622),
        .out_c0_exe724(ZTS6c_calc_B6_merge_out_c0_exe724),
        .out_c0_exe830(ZTS6c_calc_B6_merge_out_c0_exe830),
        .out_l_grpid_04(ZTS6c_calc_B6_merge_out_l_grpid_04),
        .out_l_grpid_0_ext_offset36(ZTS6c_calc_B6_merge_out_l_grpid_0_ext_offset36),
        .out_stall_out_0(ZTS6c_calc_B6_merge_out_stall_out_0),
        .out_stall_out_1(ZTS6c_calc_B6_merge_out_stall_out_1),
        .out_valid_out(ZTS6c_calc_B6_merge_out_valid_out),
        .clock(clock),
        .resetn(resetn)
    );

    // aggregateWireOut_join(BITJOIN,19)
    assign aggregateWireOut_join_q = {ZTS6c_calc_B6_merge_out_l_grpid_0_ext_offset36, ZTS6c_calc_B6_merge_out_l_grpid_04, ZTS6c_calc_B6_merge_out_c0_exe830, ZTS6c_calc_B6_merge_out_c0_exe724, ZTS6c_calc_B6_merge_out_c0_exe622, ZTS6c_calc_B6_merge_out_c0_exe516, ZTS6c_calc_B6_merge_out_c0_exe414, ZTS6c_calc_B6_merge_out_c0_exe29, ZTS6c_calc_B6_merge_out_acl_hw_wg_id55, ZTS6c_calc_B6_merge_out_acl_global_id_148, ZTS6c_calc_B6_merge_out_acl_global_id_042, ZTS6c_calc_B6_merge_out_acl_1_i505, ZTS6c_calc_B6_merge_out_acl_0_i506, ZTS6c_calc_B6_merge_out_acl_0142_i50835, ZTS6c_calc_B6_merge_out_acl_0141_i50933};

    // loop_capacity_FIFO(BLACKBOX,22)
    k2_ZTS6c_calc_loop_capacity_FIFO theloop_capacity_FIFO (
        .in_data_in(aggregateWireOut_join_q),
        .in_stall_in(bb_ZTS6c_calc_B6_stall_region_out_stall_out),
        .in_valid_in(ZTS6c_calc_B6_merge_out_valid_out),
        .out_almost_full(),
        .out_data_out(loop_capacity_FIFO_out_data_out),
        .out_stall_out(loop_capacity_FIFO_out_stall_out),
        .out_valid_out(loop_capacity_FIFO_out_valid_out),
        .clock(clock),
        .resetn(resetn)
    );

    // dupName_13_data_out_select_x(BITSELECT,73)
    assign dupName_13_data_out_select_x_b = loop_capacity_FIFO_out_data_out[703:640];

    // dupName_12_data_out_select_x(BITSELECT,72)
    assign dupName_12_data_out_select_x_b = loop_capacity_FIFO_out_data_out[639:608];

    // dupName_11_data_out_select_x(BITSELECT,71)
    assign dupName_11_data_out_select_x_b = loop_capacity_FIFO_out_data_out[607:544];

    // dupName_10_data_out_select_x(BITSELECT,70)
    assign dupName_10_data_out_select_x_b = loop_capacity_FIFO_out_data_out[543:480];

    // dupName_9_data_out_select_x(BITSELECT,69)
    assign dupName_9_data_out_select_x_b = loop_capacity_FIFO_out_data_out[479:416];

    // dupName_8_data_out_select_x(BITSELECT,68)
    assign dupName_8_data_out_select_x_b = loop_capacity_FIFO_out_data_out[415:352];

    // dupName_7_data_out_select_x(BITSELECT,67)
    assign dupName_7_data_out_select_x_b = loop_capacity_FIFO_out_data_out[351:320];

    // dupName_6_data_out_select_x(BITSELECT,66)
    assign dupName_6_data_out_select_x_b = loop_capacity_FIFO_out_data_out[319:288];

    // dupName_5_data_out_select_x(BITSELECT,65)
    assign dupName_5_data_out_select_x_b = loop_capacity_FIFO_out_data_out[287:256];

    // dupName_4_data_out_select_x(BITSELECT,64)
    assign dupName_4_data_out_select_x_b = loop_capacity_FIFO_out_data_out[255:192];

    // dupName_3_data_out_select_x(BITSELECT,63)
    assign dupName_3_data_out_select_x_b = loop_capacity_FIFO_out_data_out[191:128];

    // dupName_2_data_out_select_x(BITSELECT,62)
    assign dupName_2_data_out_select_x_b = loop_capacity_FIFO_out_data_out[127:96];

    // dupName_1_data_out_select_x(BITSELECT,61)
    assign dupName_1_data_out_select_x_b = loop_capacity_FIFO_out_data_out[95:64];

    // dupName_0_data_out_select_x(BITSELECT,60)
    assign dupName_0_data_out_select_x_b = loop_capacity_FIFO_out_data_out[63:32];

    // data_out_select(BITSELECT,21)
    assign data_out_select_b = loop_capacity_FIFO_out_data_out[31:0];

    // bb_ZTS6c_calc_B6_stall_region(BLACKBOX,20)
    k2_ZTS6c_calc_bb_ZTS6c_calc_B6_stall_region thebb_ZTS6c_calc_B6_stall_region (
        .in_acl_0141_i50933(data_out_select_b),
        .in_acl_0142_i50835(dupName_0_data_out_select_x_b),
        .in_acl_0_i506(dupName_1_data_out_select_x_b),
        .in_acl_1_i505(dupName_2_data_out_select_x_b),
        .in_acl_global_id_042(dupName_3_data_out_select_x_b),
        .in_acl_global_id_148(dupName_4_data_out_select_x_b),
        .in_acl_hw_wg_id55(dupName_5_data_out_select_x_b),
        .in_c0_exe29(dupName_6_data_out_select_x_b),
        .in_c0_exe414(dupName_7_data_out_select_x_b),
        .in_c0_exe516(dupName_8_data_out_select_x_b),
        .in_c0_exe622(dupName_9_data_out_select_x_b),
        .in_c0_exe724(dupName_10_data_out_select_x_b),
        .in_c0_exe830(dupName_11_data_out_select_x_b),
        .in_flush(in_flush),
        .in_l_grpid_04(dupName_12_data_out_select_x_b),
        .in_l_grpid_0_ext_offset36(dupName_13_data_out_select_x_b),
        .in_stall_in(ZTS6c_calc_B6_branch_out_stall_out),
        .in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_readdata(in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_readdata),
        .in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_readdatavalid(in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_readdatavalid),
        .in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_waitrequest(in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_waitrequest),
        .in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writeack(in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writeack),
        .in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_readdata(in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_readdata),
        .in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_readdatavalid(in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_readdatavalid),
        .in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_waitrequest(in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_waitrequest),
        .in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writeack(in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writeack),
        .in_valid_in(loop_capacity_FIFO_out_valid_out),
        .out_acl_0141_i50933(bb_ZTS6c_calc_B6_stall_region_out_acl_0141_i50933),
        .out_acl_0142_i50835(bb_ZTS6c_calc_B6_stall_region_out_acl_0142_i50835),
        .out_acl_global_id_042(bb_ZTS6c_calc_B6_stall_region_out_acl_global_id_042),
        .out_acl_global_id_148(bb_ZTS6c_calc_B6_stall_region_out_acl_global_id_148),
        .out_acl_hw_wg_id55(bb_ZTS6c_calc_B6_stall_region_out_acl_hw_wg_id55),
        .out_c0_exe154(bb_ZTS6c_calc_B6_stall_region_out_c0_exe154),
        .out_c0_exe255(bb_ZTS6c_calc_B6_stall_region_out_c0_exe255),
        .out_c0_exe29(bb_ZTS6c_calc_B6_stall_region_out_c0_exe29),
        .out_c0_exe356(bb_ZTS6c_calc_B6_stall_region_out_c0_exe356),
        .out_c0_exe414(bb_ZTS6c_calc_B6_stall_region_out_c0_exe414),
        .out_c0_exe516(bb_ZTS6c_calc_B6_stall_region_out_c0_exe516),
        .out_c0_exe622(bb_ZTS6c_calc_B6_stall_region_out_c0_exe622),
        .out_c0_exe724(bb_ZTS6c_calc_B6_stall_region_out_c0_exe724),
        .out_c0_exe830(bb_ZTS6c_calc_B6_stall_region_out_c0_exe830),
        .out_l_grpid_04(bb_ZTS6c_calc_B6_stall_region_out_l_grpid_04),
        .out_l_grpid_0_ext_offset36(bb_ZTS6c_calc_B6_stall_region_out_l_grpid_0_ext_offset36),
        .out_stall_out(bb_ZTS6c_calc_B6_stall_region_out_stall_out),
        .out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_address(bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_address),
        .out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_burstcount(bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_burstcount),
        .out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_byteenable(bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_byteenable),
        .out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_enable(bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_enable),
        .out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_read(bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_read),
        .out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_write(bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_write),
        .out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writedata(bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writedata),
        .out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_address(bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_address),
        .out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_burstcount(bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_burstcount),
        .out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_byteenable(bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_byteenable),
        .out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_enable(bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_enable),
        .out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_read(bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_read),
        .out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_write(bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_write),
        .out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writedata(bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writedata),
        .out_valid_out(bb_ZTS6c_calc_B6_stall_region_out_valid_out),
        .clock(clock),
        .resetn(resetn)
    );

    // ZTS6c_calc_B6_branch(BLACKBOX,17)
    k2_ZTS6c_calc_ZTS6c_calc_B6_branch theZTS6c_calc_B6_branch (
        .in_acl_0141_i50933(bb_ZTS6c_calc_B6_stall_region_out_acl_0141_i50933),
        .in_acl_0142_i50835(bb_ZTS6c_calc_B6_stall_region_out_acl_0142_i50835),
        .in_acl_global_id_042(bb_ZTS6c_calc_B6_stall_region_out_acl_global_id_042),
        .in_acl_global_id_148(bb_ZTS6c_calc_B6_stall_region_out_acl_global_id_148),
        .in_acl_hw_wg_id55(bb_ZTS6c_calc_B6_stall_region_out_acl_hw_wg_id55),
        .in_c0_exe154(bb_ZTS6c_calc_B6_stall_region_out_c0_exe154),
        .in_c0_exe255(bb_ZTS6c_calc_B6_stall_region_out_c0_exe255),
        .in_c0_exe29(bb_ZTS6c_calc_B6_stall_region_out_c0_exe29),
        .in_c0_exe356(bb_ZTS6c_calc_B6_stall_region_out_c0_exe356),
        .in_c0_exe414(bb_ZTS6c_calc_B6_stall_region_out_c0_exe414),
        .in_c0_exe516(bb_ZTS6c_calc_B6_stall_region_out_c0_exe516),
        .in_c0_exe622(bb_ZTS6c_calc_B6_stall_region_out_c0_exe622),
        .in_c0_exe724(bb_ZTS6c_calc_B6_stall_region_out_c0_exe724),
        .in_c0_exe830(bb_ZTS6c_calc_B6_stall_region_out_c0_exe830),
        .in_l_grpid_04(bb_ZTS6c_calc_B6_stall_region_out_l_grpid_04),
        .in_l_grpid_0_ext_offset36(bb_ZTS6c_calc_B6_stall_region_out_l_grpid_0_ext_offset36),
        .in_stall_in_0(in_stall_in_0),
        .in_stall_in_1(in_stall_in_1),
        .in_valid_in(bb_ZTS6c_calc_B6_stall_region_out_valid_out),
        .out_acl_0141_i50933(ZTS6c_calc_B6_branch_out_acl_0141_i50933),
        .out_acl_0142_i50835(ZTS6c_calc_B6_branch_out_acl_0142_i50835),
        .out_acl_global_id_042(ZTS6c_calc_B6_branch_out_acl_global_id_042),
        .out_acl_global_id_148(ZTS6c_calc_B6_branch_out_acl_global_id_148),
        .out_acl_hw_wg_id55(ZTS6c_calc_B6_branch_out_acl_hw_wg_id55),
        .out_c0_exe154(ZTS6c_calc_B6_branch_out_c0_exe154),
        .out_c0_exe255(ZTS6c_calc_B6_branch_out_c0_exe255),
        .out_c0_exe29(ZTS6c_calc_B6_branch_out_c0_exe29),
        .out_c0_exe414(ZTS6c_calc_B6_branch_out_c0_exe414),
        .out_c0_exe516(ZTS6c_calc_B6_branch_out_c0_exe516),
        .out_c0_exe622(ZTS6c_calc_B6_branch_out_c0_exe622),
        .out_c0_exe724(ZTS6c_calc_B6_branch_out_c0_exe724),
        .out_c0_exe830(ZTS6c_calc_B6_branch_out_c0_exe830),
        .out_l_grpid_04(ZTS6c_calc_B6_branch_out_l_grpid_04),
        .out_l_grpid_0_ext_offset36(ZTS6c_calc_B6_branch_out_l_grpid_0_ext_offset36),
        .out_stall_out(ZTS6c_calc_B6_branch_out_stall_out),
        .out_valid_out_0(ZTS6c_calc_B6_branch_out_valid_out_0),
        .out_valid_out_1(ZTS6c_calc_B6_branch_out_valid_out_1),
        .clock(clock),
        .resetn(resetn)
    );

    // out_acl_0141_i50933(GPOUT,23)
    assign out_acl_0141_i50933 = ZTS6c_calc_B6_branch_out_acl_0141_i50933;

    // out_acl_0142_i50835(GPOUT,24)
    assign out_acl_0142_i50835 = ZTS6c_calc_B6_branch_out_acl_0142_i50835;

    // out_acl_global_id_042(GPOUT,25)
    assign out_acl_global_id_042 = ZTS6c_calc_B6_branch_out_acl_global_id_042;

    // out_acl_global_id_148(GPOUT,26)
    assign out_acl_global_id_148 = ZTS6c_calc_B6_branch_out_acl_global_id_148;

    // out_acl_hw_wg_id55(GPOUT,27)
    assign out_acl_hw_wg_id55 = ZTS6c_calc_B6_branch_out_acl_hw_wg_id55;

    // out_c0_exe154(GPOUT,28)
    assign out_c0_exe154 = ZTS6c_calc_B6_branch_out_c0_exe154;

    // out_c0_exe255(GPOUT,29)
    assign out_c0_exe255 = ZTS6c_calc_B6_branch_out_c0_exe255;

    // out_c0_exe29(GPOUT,30)
    assign out_c0_exe29 = ZTS6c_calc_B6_branch_out_c0_exe29;

    // out_c0_exe414(GPOUT,31)
    assign out_c0_exe414 = ZTS6c_calc_B6_branch_out_c0_exe414;

    // out_c0_exe516(GPOUT,32)
    assign out_c0_exe516 = ZTS6c_calc_B6_branch_out_c0_exe516;

    // out_c0_exe622(GPOUT,33)
    assign out_c0_exe622 = ZTS6c_calc_B6_branch_out_c0_exe622;

    // out_c0_exe724(GPOUT,34)
    assign out_c0_exe724 = ZTS6c_calc_B6_branch_out_c0_exe724;

    // out_c0_exe830(GPOUT,35)
    assign out_c0_exe830 = ZTS6c_calc_B6_branch_out_c0_exe830;

    // out_l_grpid_04(GPOUT,36)
    assign out_l_grpid_04 = ZTS6c_calc_B6_branch_out_l_grpid_04;

    // out_l_grpid_0_ext_offset36(GPOUT,37)
    assign out_l_grpid_0_ext_offset36 = ZTS6c_calc_B6_branch_out_l_grpid_0_ext_offset36;

    // out_stall_in_0(GPOUT,38)
    assign out_stall_in_0 = in_stall_in_0;

    // out_stall_out_0(GPOUT,39)
    assign out_stall_out_0 = ZTS6c_calc_B6_merge_out_stall_out_0;

    // out_stall_out_1(GPOUT,40)
    assign out_stall_out_1 = ZTS6c_calc_B6_merge_out_stall_out_1;

    // out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_address(GPOUT,41)
    assign out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_address = bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_address;

    // out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_burstcount(GPOUT,42)
    assign out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_burstcount = bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_burstcount;

    // out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_byteenable(GPOUT,43)
    assign out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_byteenable = bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_byteenable;

    // out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_enable(GPOUT,44)
    assign out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_enable = bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_enable;

    // out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_read(GPOUT,45)
    assign out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_read = bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_read;

    // out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_write(GPOUT,46)
    assign out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_write = bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_write;

    // out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writedata(GPOUT,47)
    assign out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writedata = bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writedata;

    // out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_address(GPOUT,48)
    assign out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_address = bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_address;

    // out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_burstcount(GPOUT,49)
    assign out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_burstcount = bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_burstcount;

    // out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_byteenable(GPOUT,50)
    assign out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_byteenable = bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_byteenable;

    // out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_enable(GPOUT,51)
    assign out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_enable = bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_enable;

    // out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_read(GPOUT,52)
    assign out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_read = bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_read;

    // out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_write(GPOUT,53)
    assign out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_write = bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_write;

    // out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writedata(GPOUT,54)
    assign out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writedata = bb_ZTS6c_calc_B6_stall_region_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writedata;

    // out_valid_in_0(GPOUT,55)
    assign out_valid_in_0 = in_valid_in_0;

    // out_valid_in_1(GPOUT,56)
    assign out_valid_in_1 = in_valid_in_1;

    // out_valid_out_0(GPOUT,57)
    assign out_valid_out_0 = ZTS6c_calc_B6_branch_out_valid_out_0;

    // out_valid_out_1(GPOUT,58)
    assign out_valid_out_1 = ZTS6c_calc_B6_branch_out_valid_out_1;

endmodule
