// ------------------------------------------------------------------------- 
// High Level Design Compiler for Intel(R) FPGAs Version 20.3 (Release Build #121)
// 
// Legal Notice: Copyright 2020 Intel Corporation.  All rights reserved.
// Your use of  Intel Corporation's design tools,  logic functions and other
// software and  tools, and its AMPP partner logic functions, and any output
// files any  of the foregoing (including  device programming  or simulation
// files), and  any associated  documentation  or information  are expressly
// subject  to the terms and  conditions of the  Intel FPGA Software License
// Agreement, Intel MegaCore Function License Agreement, or other applicable
// license agreement,  including,  without limitation,  that your use is for
// the  sole  purpose of  programming  logic devices  manufactured by  Intel
// and  sold by Intel  or its authorized  distributors. Please refer  to the
// applicable agreement for further details.
// ---------------------------------------------------------------------------

// SystemVerilog created from k2_ZTS6c_calc_bb_ZTS6c_calc_B6_stall_region
// SystemVerilog created on Thu Nov  5 06:32:57 2020


(* altera_attribute = "-name AUTO_SHIFT_REGISTER_RECOGNITION OFF; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 10037; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 15400; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 12020; -name MESSAGE_DISABLE 12030; -name MESSAGE_DISABLE 12010; -name MESSAGE_DISABLE 12110; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 13410; -name MESSAGE_DISABLE 113007; -name MESSAGE_DISABLE 10958" *)
module k2_ZTS6c_calc_bb_ZTS6c_calc_B6_stall_region (
    input wire [31:0] in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_readdata,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writeack,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_waitrequest,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_readdatavalid,
    output wire [31:0] out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_address,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_enable,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_read,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_write,
    output wire [31:0] out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writedata,
    output wire [3:0] out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_byteenable,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_burstcount,
    input wire [0:0] in_flush,
    input wire [0:0] in_stall_in,
    output wire [0:0] out_stall_out,
    input wire [31:0] in_acl_0141_i50933,
    input wire [31:0] in_acl_0142_i50835,
    input wire [31:0] in_acl_0_i506,
    input wire [31:0] in_acl_1_i505,
    input wire [63:0] in_acl_global_id_042,
    input wire [63:0] in_acl_global_id_148,
    input wire [31:0] in_acl_hw_wg_id55,
    input wire [31:0] in_c0_exe29,
    input wire [31:0] in_c0_exe414,
    input wire [63:0] in_c0_exe516,
    input wire [63:0] in_c0_exe622,
    input wire [63:0] in_c0_exe724,
    input wire [63:0] in_c0_exe830,
    input wire [31:0] in_l_grpid_04,
    input wire [63:0] in_l_grpid_0_ext_offset36,
    input wire [0:0] in_valid_in,
    input wire [31:0] in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_readdata,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writeack,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_waitrequest,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_readdatavalid,
    output wire [31:0] out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_address,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_enable,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_read,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_write,
    output wire [31:0] out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writedata,
    output wire [3:0] out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_byteenable,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_burstcount,
    output wire [31:0] out_acl_0141_i50933,
    output wire [31:0] out_acl_0142_i50835,
    output wire [63:0] out_acl_global_id_042,
    output wire [63:0] out_acl_global_id_148,
    output wire [31:0] out_acl_hw_wg_id55,
    output wire [31:0] out_c0_exe154,
    output wire [31:0] out_c0_exe255,
    output wire [31:0] out_c0_exe29,
    output wire [0:0] out_c0_exe356,
    output wire [31:0] out_c0_exe414,
    output wire [63:0] out_c0_exe516,
    output wire [63:0] out_c0_exe622,
    output wire [63:0] out_c0_exe724,
    output wire [63:0] out_c0_exe830,
    output wire [31:0] out_l_grpid_04,
    output wire [63:0] out_l_grpid_0_ext_offset36,
    output wire [0:0] out_valid_out,
    input wire clock,
    input wire resetn
    );

    wire [0:0] GND_q;
    wire [0:0] ZTS6c_calc_B6_merge_reg_aunroll_x_out_stall_out;
    wire [0:0] ZTS6c_calc_B6_merge_reg_aunroll_x_out_valid_out;
    wire [31:0] ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_0_tpl;
    wire [31:0] ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_1_tpl;
    wire [31:0] ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_2_tpl;
    wire [31:0] ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_3_tpl;
    wire [31:0] ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_4_tpl;
    wire [63:0] ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_5_tpl;
    wire [63:0] ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_6_tpl;
    wire [63:0] ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_7_tpl;
    wire [63:0] ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_8_tpl;
    wire [31:0] ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_9_tpl;
    wire [31:0] ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_10_tpl;
    wire [63:0] ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_11_tpl;
    wire [63:0] ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_12_tpl;
    wire [63:0] ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_13_tpl;
    wire [31:0] ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_14_tpl;
    wire [0:0] i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_o_stall;
    wire [0:0] i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_o_valid;
    wire [31:0] i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_address;
    wire [0:0] i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_burstcount;
    wire [3:0] i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_byteenable;
    wire [0:0] i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_enable;
    wire [0:0] i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_read;
    wire [0:0] i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_write;
    wire [31:0] i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writedata;
    wire [31:0] i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_address;
    wire [0:0] i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_burstcount;
    wire [3:0] i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_byteenable;
    wire [0:0] i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_enable;
    wire [0:0] i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_read;
    wire [0:0] i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_write;
    wire [31:0] i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writedata;
    wire [31:0] i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_c0_exit53_1_tpl;
    wire [31:0] i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_c0_exit53_2_tpl;
    wire [0:0] i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_c0_exit53_3_tpl;
    wire [639:0] join_for_coalesced_delay_0_q;
    wire [63:0] sel_for_coalesced_delay_0_b;
    wire [63:0] sel_for_coalesced_delay_0_c;
    wire [63:0] sel_for_coalesced_delay_0_d;
    wire [63:0] sel_for_coalesced_delay_0_e;
    wire [63:0] sel_for_coalesced_delay_0_f;
    wire [63:0] sel_for_coalesced_delay_0_g;
    wire [63:0] sel_for_coalesced_delay_0_h;
    wire [31:0] sel_for_coalesced_delay_0_i;
    wire [31:0] sel_for_coalesced_delay_0_j;
    wire [31:0] sel_for_coalesced_delay_0_k;
    wire [31:0] sel_for_coalesced_delay_0_l;
    wire [31:0] sel_for_coalesced_delay_0_m;
    wire [31:0] sel_for_coalesced_delay_0_n;
    wire [0:0] coalesced_delay_0_fifo_valid_in;
    wire coalesced_delay_0_fifo_valid_in_bitsignaltemp;
    wire [0:0] coalesced_delay_0_fifo_stall_in;
    wire coalesced_delay_0_fifo_stall_in_bitsignaltemp;
    wire [639:0] coalesced_delay_0_fifo_data_in;
    wire [0:0] coalesced_delay_0_fifo_valid_out;
    wire coalesced_delay_0_fifo_valid_out_bitsignaltemp;
    wire [0:0] coalesced_delay_0_fifo_stall_out;
    wire coalesced_delay_0_fifo_stall_out_bitsignaltemp;
    wire [639:0] coalesced_delay_0_fifo_data_out;
    wire [703:0] bubble_join_stall_entry_q;
    wire [31:0] bubble_select_stall_entry_b;
    wire [31:0] bubble_select_stall_entry_c;
    wire [31:0] bubble_select_stall_entry_d;
    wire [31:0] bubble_select_stall_entry_e;
    wire [63:0] bubble_select_stall_entry_f;
    wire [63:0] bubble_select_stall_entry_g;
    wire [31:0] bubble_select_stall_entry_h;
    wire [31:0] bubble_select_stall_entry_i;
    wire [31:0] bubble_select_stall_entry_j;
    wire [63:0] bubble_select_stall_entry_k;
    wire [63:0] bubble_select_stall_entry_l;
    wire [63:0] bubble_select_stall_entry_m;
    wire [63:0] bubble_select_stall_entry_n;
    wire [31:0] bubble_select_stall_entry_o;
    wire [63:0] bubble_select_stall_entry_p;
    wire [703:0] bubble_join_ZTS6c_calc_B6_merge_reg_aunroll_x_q;
    wire [31:0] bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_b;
    wire [31:0] bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_c;
    wire [31:0] bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_d;
    wire [31:0] bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_e;
    wire [31:0] bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_f;
    wire [63:0] bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_g;
    wire [63:0] bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_h;
    wire [63:0] bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_i;
    wire [63:0] bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_j;
    wire [31:0] bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_k;
    wire [31:0] bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_l;
    wire [63:0] bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_m;
    wire [63:0] bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_n;
    wire [63:0] bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_o;
    wire [31:0] bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_p;
    wire [64:0] bubble_join_i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_q;
    wire [31:0] bubble_select_i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_b;
    wire [31:0] bubble_select_i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_c;
    wire [0:0] bubble_select_i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_d;
    wire [639:0] bubble_join_coalesced_delay_0_fifo_q;
    wire [639:0] bubble_select_coalesced_delay_0_fifo_b;
    wire [0:0] SE_stall_entry_wireValid;
    wire [0:0] SE_stall_entry_backStall;
    wire [0:0] SE_stall_entry_V0;
    wire [0:0] SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_wireValid;
    wire [0:0] SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_wireStall;
    wire [0:0] SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_StallValid;
    wire [0:0] SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_toReg0;
    reg [0:0] SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_fromReg0;
    wire [0:0] SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_consumed0;
    wire [0:0] SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_toReg1;
    reg [0:0] SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_fromReg1;
    wire [0:0] SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_consumed1;
    wire [0:0] SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_or0;
    wire [0:0] SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_backStall;
    wire [0:0] SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_V0;
    wire [0:0] SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_V1;
    wire [0:0] SE_out_coalesced_delay_0_fifo_wireValid;
    wire [0:0] SE_out_coalesced_delay_0_fifo_and0;
    wire [0:0] SE_out_coalesced_delay_0_fifo_backStall;
    wire [0:0] SE_out_coalesced_delay_0_fifo_V0;


    // bubble_join_stall_entry(BITJOIN,40)
    assign bubble_join_stall_entry_q = {in_l_grpid_0_ext_offset36, in_l_grpid_04, in_c0_exe830, in_c0_exe724, in_c0_exe622, in_c0_exe516, in_c0_exe414, in_c0_exe29, in_acl_hw_wg_id55, in_acl_global_id_148, in_acl_global_id_042, in_acl_1_i505, in_acl_0_i506, in_acl_0142_i50835, in_acl_0141_i50933};

    // bubble_select_stall_entry(BITSELECT,41)
    assign bubble_select_stall_entry_b = $unsigned(bubble_join_stall_entry_q[31:0]);
    assign bubble_select_stall_entry_c = $unsigned(bubble_join_stall_entry_q[63:32]);
    assign bubble_select_stall_entry_d = $unsigned(bubble_join_stall_entry_q[95:64]);
    assign bubble_select_stall_entry_e = $unsigned(bubble_join_stall_entry_q[127:96]);
    assign bubble_select_stall_entry_f = $unsigned(bubble_join_stall_entry_q[191:128]);
    assign bubble_select_stall_entry_g = $unsigned(bubble_join_stall_entry_q[255:192]);
    assign bubble_select_stall_entry_h = $unsigned(bubble_join_stall_entry_q[287:256]);
    assign bubble_select_stall_entry_i = $unsigned(bubble_join_stall_entry_q[319:288]);
    assign bubble_select_stall_entry_j = $unsigned(bubble_join_stall_entry_q[351:320]);
    assign bubble_select_stall_entry_k = $unsigned(bubble_join_stall_entry_q[415:352]);
    assign bubble_select_stall_entry_l = $unsigned(bubble_join_stall_entry_q[479:416]);
    assign bubble_select_stall_entry_m = $unsigned(bubble_join_stall_entry_q[543:480]);
    assign bubble_select_stall_entry_n = $unsigned(bubble_join_stall_entry_q[607:544]);
    assign bubble_select_stall_entry_o = $unsigned(bubble_join_stall_entry_q[639:608]);
    assign bubble_select_stall_entry_p = $unsigned(bubble_join_stall_entry_q[703:640]);

    // SE_stall_entry(STALLENABLE,53)
    // Valid signal propagation
    assign SE_stall_entry_V0 = SE_stall_entry_wireValid;
    // Backward Stall generation
    assign SE_stall_entry_backStall = ZTS6c_calc_B6_merge_reg_aunroll_x_out_stall_out | ~ (SE_stall_entry_wireValid);
    // Computing multiple Valid(s)
    assign SE_stall_entry_wireValid = in_valid_in;

    // ZTS6c_calc_B6_merge_reg_aunroll_x(BLACKBOX,17)@0
    // in in_stall_in@20000000
    // out out_stall_out@20000000
    // out out_valid_out@1
    // out out_data_out_0_tpl@1
    // out out_data_out_1_tpl@1
    // out out_data_out_2_tpl@1
    // out out_data_out_3_tpl@1
    // out out_data_out_4_tpl@1
    // out out_data_out_5_tpl@1
    // out out_data_out_6_tpl@1
    // out out_data_out_7_tpl@1
    // out out_data_out_8_tpl@1
    // out out_data_out_9_tpl@1
    // out out_data_out_10_tpl@1
    // out out_data_out_11_tpl@1
    // out out_data_out_12_tpl@1
    // out out_data_out_13_tpl@1
    // out out_data_out_14_tpl@1
    k2_ZTS6c_calc_ZTS6c_calc_B6_merge_reg theZTS6c_calc_B6_merge_reg_aunroll_x (
        .in_stall_in(SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_backStall),
        .in_valid_in(SE_stall_entry_V0),
        .in_data_in_0_tpl(bubble_select_stall_entry_d),
        .in_data_in_1_tpl(bubble_select_stall_entry_e),
        .in_data_in_2_tpl(bubble_select_stall_entry_o),
        .in_data_in_3_tpl(bubble_select_stall_entry_i),
        .in_data_in_4_tpl(bubble_select_stall_entry_j),
        .in_data_in_5_tpl(bubble_select_stall_entry_k),
        .in_data_in_6_tpl(bubble_select_stall_entry_l),
        .in_data_in_7_tpl(bubble_select_stall_entry_m),
        .in_data_in_8_tpl(bubble_select_stall_entry_n),
        .in_data_in_9_tpl(bubble_select_stall_entry_b),
        .in_data_in_10_tpl(bubble_select_stall_entry_c),
        .in_data_in_11_tpl(bubble_select_stall_entry_p),
        .in_data_in_12_tpl(bubble_select_stall_entry_f),
        .in_data_in_13_tpl(bubble_select_stall_entry_g),
        .in_data_in_14_tpl(bubble_select_stall_entry_h),
        .out_stall_out(ZTS6c_calc_B6_merge_reg_aunroll_x_out_stall_out),
        .out_valid_out(ZTS6c_calc_B6_merge_reg_aunroll_x_out_valid_out),
        .out_data_out_0_tpl(ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_0_tpl),
        .out_data_out_1_tpl(ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_1_tpl),
        .out_data_out_2_tpl(ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_2_tpl),
        .out_data_out_3_tpl(ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_3_tpl),
        .out_data_out_4_tpl(ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_4_tpl),
        .out_data_out_5_tpl(ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_5_tpl),
        .out_data_out_6_tpl(ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_6_tpl),
        .out_data_out_7_tpl(ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_7_tpl),
        .out_data_out_8_tpl(ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_8_tpl),
        .out_data_out_9_tpl(ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_9_tpl),
        .out_data_out_10_tpl(ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_10_tpl),
        .out_data_out_11_tpl(ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_11_tpl),
        .out_data_out_12_tpl(ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_12_tpl),
        .out_data_out_13_tpl(ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_13_tpl),
        .out_data_out_14_tpl(ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_14_tpl),
        .clock(clock),
        .resetn(resetn)
    );

    // bubble_join_ZTS6c_calc_B6_merge_reg_aunroll_x(BITJOIN,44)
    assign bubble_join_ZTS6c_calc_B6_merge_reg_aunroll_x_q = {ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_14_tpl, ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_13_tpl, ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_12_tpl, ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_11_tpl, ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_10_tpl, ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_9_tpl, ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_8_tpl, ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_7_tpl, ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_6_tpl, ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_5_tpl, ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_4_tpl, ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_3_tpl, ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_2_tpl, ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_1_tpl, ZTS6c_calc_B6_merge_reg_aunroll_x_out_data_out_0_tpl};

    // bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x(BITSELECT,45)
    assign bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_b = $unsigned(bubble_join_ZTS6c_calc_B6_merge_reg_aunroll_x_q[31:0]);
    assign bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_c = $unsigned(bubble_join_ZTS6c_calc_B6_merge_reg_aunroll_x_q[63:32]);
    assign bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_d = $unsigned(bubble_join_ZTS6c_calc_B6_merge_reg_aunroll_x_q[95:64]);
    assign bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_e = $unsigned(bubble_join_ZTS6c_calc_B6_merge_reg_aunroll_x_q[127:96]);
    assign bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_f = $unsigned(bubble_join_ZTS6c_calc_B6_merge_reg_aunroll_x_q[159:128]);
    assign bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_g = $unsigned(bubble_join_ZTS6c_calc_B6_merge_reg_aunroll_x_q[223:160]);
    assign bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_h = $unsigned(bubble_join_ZTS6c_calc_B6_merge_reg_aunroll_x_q[287:224]);
    assign bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_i = $unsigned(bubble_join_ZTS6c_calc_B6_merge_reg_aunroll_x_q[351:288]);
    assign bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_j = $unsigned(bubble_join_ZTS6c_calc_B6_merge_reg_aunroll_x_q[415:352]);
    assign bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_k = $unsigned(bubble_join_ZTS6c_calc_B6_merge_reg_aunroll_x_q[447:416]);
    assign bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_l = $unsigned(bubble_join_ZTS6c_calc_B6_merge_reg_aunroll_x_q[479:448]);
    assign bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_m = $unsigned(bubble_join_ZTS6c_calc_B6_merge_reg_aunroll_x_q[543:480]);
    assign bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_n = $unsigned(bubble_join_ZTS6c_calc_B6_merge_reg_aunroll_x_q[607:544]);
    assign bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_o = $unsigned(bubble_join_ZTS6c_calc_B6_merge_reg_aunroll_x_q[671:608]);
    assign bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_p = $unsigned(bubble_join_ZTS6c_calc_B6_merge_reg_aunroll_x_q[703:672]);

    // GND(CONSTANT,0)
    assign GND_q = $unsigned(1'b0);

    // join_for_coalesced_delay_0(BITJOIN,36)
    assign join_for_coalesced_delay_0_q = {bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_p, bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_l, bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_k, bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_f, bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_e, bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_d, bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_o, bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_n, bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_m, bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_j, bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_i, bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_h, bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_g};

    // coalesced_delay_0_fifo(STALLFIFO,38)
    assign coalesced_delay_0_fifo_valid_in = SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_V1;
    assign coalesced_delay_0_fifo_stall_in = SE_out_coalesced_delay_0_fifo_backStall;
    assign coalesced_delay_0_fifo_data_in = join_for_coalesced_delay_0_q;
    assign coalesced_delay_0_fifo_valid_in_bitsignaltemp = coalesced_delay_0_fifo_valid_in[0];
    assign coalesced_delay_0_fifo_stall_in_bitsignaltemp = coalesced_delay_0_fifo_stall_in[0];
    assign coalesced_delay_0_fifo_valid_out[0] = coalesced_delay_0_fifo_valid_out_bitsignaltemp;
    assign coalesced_delay_0_fifo_stall_out[0] = coalesced_delay_0_fifo_stall_out_bitsignaltemp;
    acl_data_fifo #(
        .DEPTH(13),
        .STRICT_DEPTH(0),
        .ALLOW_FULL_WRITE(0),
        .DATA_WIDTH(640),
        .IMPL("ram")
    ) thecoalesced_delay_0_fifo (
        .valid_in(coalesced_delay_0_fifo_valid_in_bitsignaltemp),
        .stall_in(coalesced_delay_0_fifo_stall_in_bitsignaltemp),
        .data_in(join_for_coalesced_delay_0_q),
        .valid_out(coalesced_delay_0_fifo_valid_out_bitsignaltemp),
        .stall_out(coalesced_delay_0_fifo_stall_out_bitsignaltemp),
        .data_out(coalesced_delay_0_fifo_data_out),
        .clock(clock),
        .resetn(resetn)
    );

    // SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x(STALLENABLE,56)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_fromReg0 <= '0;
            SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_fromReg1 <= '0;
        end
        else
        begin
            // Successor 0
            SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_fromReg0 <= SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_toReg0;
            // Successor 1
            SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_fromReg1 <= SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_toReg1;
        end
    end
    // Input Stall processing
    assign SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_consumed0 = (~ (i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_o_stall) & SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_wireValid) | SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_fromReg0;
    assign SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_consumed1 = (~ (coalesced_delay_0_fifo_stall_out) & SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_wireValid) | SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_fromReg1;
    // Consuming
    assign SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_StallValid = SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_backStall & SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_wireValid;
    assign SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_toReg0 = SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_StallValid & SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_consumed0;
    assign SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_toReg1 = SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_StallValid & SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_consumed1;
    // Backward Stall generation
    assign SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_or0 = SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_consumed0;
    assign SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_wireStall = ~ (SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_consumed1 & SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_or0);
    assign SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_backStall = SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_wireStall;
    // Valid signal propagation
    assign SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_V0 = SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_wireValid & ~ (SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_fromReg0);
    assign SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_V1 = SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_wireValid & ~ (SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_fromReg1);
    // Computing multiple Valid(s)
    assign SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_wireValid = ZTS6c_calc_B6_merge_reg_aunroll_x_out_valid_out;

    // SE_out_coalesced_delay_0_fifo(STALLENABLE,62)
    // Valid signal propagation
    assign SE_out_coalesced_delay_0_fifo_V0 = SE_out_coalesced_delay_0_fifo_wireValid;
    // Backward Stall generation
    assign SE_out_coalesced_delay_0_fifo_backStall = in_stall_in | ~ (SE_out_coalesced_delay_0_fifo_wireValid);
    // Computing multiple Valid(s)
    assign SE_out_coalesced_delay_0_fifo_and0 = coalesced_delay_0_fifo_valid_out;
    assign SE_out_coalesced_delay_0_fifo_wireValid = i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_o_valid & SE_out_coalesced_delay_0_fifo_and0;

    // i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x(BLACKBOX,21)@1
    // in in_i_stall@20000000
    // out out_o_stall@20000000
    // out out_o_valid@13
    // out out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_address@20000000
    // out out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_burstcount@20000000
    // out out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_byteenable@20000000
    // out out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_enable@20000000
    // out out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_read@20000000
    // out out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_write@20000000
    // out out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writedata@20000000
    // out out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_address@20000000
    // out out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_burstcount@20000000
    // out out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_byteenable@20000000
    // out out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_enable@20000000
    // out out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_read@20000000
    // out out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_write@20000000
    // out out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writedata@20000000
    // out out_c0_exit53_0_tpl@13
    // out out_c0_exit53_1_tpl@13
    // out out_c0_exit53_2_tpl@13
    // out out_c0_exit53_3_tpl@13
    k2_ZTS6c_calc_i_sfc_s_c0_in_crit_edge5300000r4658_k2_zts6c_calc1 thei_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x (
        .in_flush(in_flush),
        .in_i_stall(SE_out_coalesced_delay_0_fifo_backStall),
        .in_i_valid(SE_out_ZTS6c_calc_B6_merge_reg_aunroll_x_V0),
        .in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_readdata(in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_readdata),
        .in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_readdatavalid(in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_readdatavalid),
        .in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_waitrequest(in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_waitrequest),
        .in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writeack(in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writeack),
        .in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_readdata(in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_readdata),
        .in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_readdatavalid(in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_readdatavalid),
        .in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_waitrequest(in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_waitrequest),
        .in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writeack(in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writeack),
        .in_c0_eni5_0_tpl(GND_q),
        .in_c0_eni5_1_tpl(bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_b),
        .in_c0_eni5_2_tpl(bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_g),
        .in_c0_eni5_3_tpl(bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_m),
        .in_c0_eni5_4_tpl(bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_i),
        .in_c0_eni5_5_tpl(bubble_select_ZTS6c_calc_B6_merge_reg_aunroll_x_c),
        .out_o_stall(i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_o_stall),
        .out_o_valid(i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_o_valid),
        .out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_address(i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_address),
        .out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_burstcount(i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_burstcount),
        .out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_byteenable(i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_byteenable),
        .out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_enable(i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_enable),
        .out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_read(i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_read),
        .out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_write(i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_write),
        .out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writedata(i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writedata),
        .out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_address(i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_address),
        .out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_burstcount(i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_burstcount),
        .out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_byteenable(i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_byteenable),
        .out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_enable(i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_enable),
        .out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_read(i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_read),
        .out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_write(i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_write),
        .out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writedata(i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writedata),
        .out_c0_exit53_0_tpl(),
        .out_c0_exit53_1_tpl(i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_c0_exit53_1_tpl),
        .out_c0_exit53_2_tpl(i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_c0_exit53_2_tpl),
        .out_c0_exit53_3_tpl(i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_c0_exit53_3_tpl),
        .clock(clock),
        .resetn(resetn)
    );

    // ext_sig_sync_out(GPOUT,6)
    assign out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_address = i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_address;
    assign out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_enable = i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_enable;
    assign out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_read = i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_read;
    assign out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_write = i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_write;
    assign out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writedata = i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writedata;
    assign out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_byteenable = i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_byteenable;
    assign out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_burstcount = i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_burstcount;

    // sync_out(GPOUT,15)@0
    assign out_stall_out = SE_stall_entry_backStall;

    // dupName_0_ext_sig_sync_out_x(GPOUT,19)
    assign out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_address = i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_address;
    assign out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_enable = i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_enable;
    assign out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_read = i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_read;
    assign out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_write = i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_write;
    assign out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writedata = i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writedata;
    assign out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_byteenable = i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_byteenable;
    assign out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_burstcount = i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_burstcount;

    // bubble_join_i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x(BITJOIN,47)
    assign bubble_join_i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_q = {i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_c0_exit53_3_tpl, i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_c0_exit53_2_tpl, i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_out_c0_exit53_1_tpl};

    // bubble_select_i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x(BITSELECT,48)
    assign bubble_select_i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_b = $unsigned(bubble_join_i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_q[31:0]);
    assign bubble_select_i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_c = $unsigned(bubble_join_i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_q[63:32]);
    assign bubble_select_i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_d = $unsigned(bubble_join_i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_q[64:64]);

    // bubble_join_coalesced_delay_0_fifo(BITJOIN,51)
    assign bubble_join_coalesced_delay_0_fifo_q = coalesced_delay_0_fifo_data_out;

    // bubble_select_coalesced_delay_0_fifo(BITSELECT,52)
    assign bubble_select_coalesced_delay_0_fifo_b = $unsigned(bubble_join_coalesced_delay_0_fifo_q[639:0]);

    // sel_for_coalesced_delay_0(BITSELECT,37)
    assign sel_for_coalesced_delay_0_b = $unsigned(bubble_select_coalesced_delay_0_fifo_b[63:0]);
    assign sel_for_coalesced_delay_0_c = $unsigned(bubble_select_coalesced_delay_0_fifo_b[127:64]);
    assign sel_for_coalesced_delay_0_d = $unsigned(bubble_select_coalesced_delay_0_fifo_b[191:128]);
    assign sel_for_coalesced_delay_0_e = $unsigned(bubble_select_coalesced_delay_0_fifo_b[255:192]);
    assign sel_for_coalesced_delay_0_f = $unsigned(bubble_select_coalesced_delay_0_fifo_b[319:256]);
    assign sel_for_coalesced_delay_0_g = $unsigned(bubble_select_coalesced_delay_0_fifo_b[383:320]);
    assign sel_for_coalesced_delay_0_h = $unsigned(bubble_select_coalesced_delay_0_fifo_b[447:384]);
    assign sel_for_coalesced_delay_0_i = $unsigned(bubble_select_coalesced_delay_0_fifo_b[479:448]);
    assign sel_for_coalesced_delay_0_j = $unsigned(bubble_select_coalesced_delay_0_fifo_b[511:480]);
    assign sel_for_coalesced_delay_0_k = $unsigned(bubble_select_coalesced_delay_0_fifo_b[543:512]);
    assign sel_for_coalesced_delay_0_l = $unsigned(bubble_select_coalesced_delay_0_fifo_b[575:544]);
    assign sel_for_coalesced_delay_0_m = $unsigned(bubble_select_coalesced_delay_0_fifo_b[607:576]);
    assign sel_for_coalesced_delay_0_n = $unsigned(bubble_select_coalesced_delay_0_fifo_b[639:608]);

    // dupName_0_sync_out_x(GPOUT,20)@13
    assign out_acl_0141_i50933 = sel_for_coalesced_delay_0_l;
    assign out_acl_0142_i50835 = sel_for_coalesced_delay_0_m;
    assign out_acl_global_id_042 = sel_for_coalesced_delay_0_g;
    assign out_acl_global_id_148 = sel_for_coalesced_delay_0_h;
    assign out_acl_hw_wg_id55 = sel_for_coalesced_delay_0_n;
    assign out_c0_exe154 = bubble_select_i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_b;
    assign out_c0_exe255 = bubble_select_i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_c;
    assign out_c0_exe29 = sel_for_coalesced_delay_0_j;
    assign out_c0_exe356 = bubble_select_i_sfc_s_c0_in_crit_edge530_zts6c_calcs_c0_enter4658_k2_zts6c_calc1_aunroll_x_d;
    assign out_c0_exe414 = sel_for_coalesced_delay_0_k;
    assign out_c0_exe516 = sel_for_coalesced_delay_0_b;
    assign out_c0_exe622 = sel_for_coalesced_delay_0_c;
    assign out_c0_exe724 = sel_for_coalesced_delay_0_d;
    assign out_c0_exe830 = sel_for_coalesced_delay_0_e;
    assign out_l_grpid_04 = sel_for_coalesced_delay_0_i;
    assign out_l_grpid_0_ext_offset36 = sel_for_coalesced_delay_0_f;
    assign out_valid_out = SE_out_coalesced_delay_0_fifo_V0;

endmodule
