// ------------------------------------------------------------------------- 
// High Level Design Compiler for Intel(R) FPGAs Version 20.3 (Release Build #121)
// 
// Legal Notice: Copyright 2020 Intel Corporation.  All rights reserved.
// Your use of  Intel Corporation's design tools,  logic functions and other
// software and  tools, and its AMPP partner logic functions, and any output
// files any  of the foregoing (including  device programming  or simulation
// files), and  any associated  documentation  or information  are expressly
// subject  to the terms and  conditions of the  Intel FPGA Software License
// Agreement, Intel MegaCore Function License Agreement, or other applicable
// license agreement,  including,  without limitation,  that your use is for
// the  sole  purpose of  programming  logic devices  manufactured by  Intel
// and  sold by Intel  or its authorized  distributors. Please refer  to the
// applicable agreement for further details.
// ---------------------------------------------------------------------------

// SystemVerilog created from k2_ZTS6c_calc_function
// SystemVerilog created on Thu Nov  5 06:32:57 2020


(* altera_attribute = "-name AUTO_SHIFT_REGISTER_RECOGNITION OFF; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 10037; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 15400; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 12020; -name MESSAGE_DISABLE 12030; -name MESSAGE_DISABLE 12010; -name MESSAGE_DISABLE 12110; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 13410; -name MESSAGE_DISABLE 113007; -name MESSAGE_DISABLE 10958" *)
module k2_ZTS6c_calc_function (
    output wire [31:0] out_acl_hw_wg_id52,
    output wire [31:0] out_memdep_34_k2_ZTS6c_calc_avm_address,
    output wire [0:0] out_memdep_34_k2_ZTS6c_calc_avm_burstcount,
    output wire [3:0] out_memdep_34_k2_ZTS6c_calc_avm_byteenable,
    output wire [0:0] out_memdep_34_k2_ZTS6c_calc_avm_enable,
    output wire [0:0] out_memdep_34_k2_ZTS6c_calc_avm_read,
    output wire [0:0] out_memdep_34_k2_ZTS6c_calc_avm_write,
    output wire [31:0] out_memdep_34_k2_ZTS6c_calc_avm_writedata,
    output wire [31:0] out_memdep_k2_ZTS6c_calc_avm_address,
    output wire [0:0] out_memdep_k2_ZTS6c_calc_avm_burstcount,
    output wire [3:0] out_memdep_k2_ZTS6c_calc_avm_byteenable,
    output wire [0:0] out_memdep_k2_ZTS6c_calc_avm_enable,
    output wire [0:0] out_memdep_k2_ZTS6c_calc_avm_read,
    output wire [0:0] out_memdep_k2_ZTS6c_calc_avm_write,
    output wire [31:0] out_memdep_k2_ZTS6c_calc_avm_writedata,
    output wire [0:0] out_o_active_unnamed_k2_ZTS6c_calc9,
    output wire [63:0] out_primWireOut,
    output wire [0:0] out_stall_out,
    output wire [32:0] out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_address,
    output wire [4:0] out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_burstcount,
    output wire [63:0] out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_byteenable,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_enable,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_read,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_write,
    output wire [511:0] out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_writedata,
    output wire [32:0] out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_address,
    output wire [4:0] out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_burstcount,
    output wire [63:0] out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_byteenable,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_enable,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_read,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_write,
    output wire [511:0] out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_writedata,
    output wire [31:0] out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_address,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_burstcount,
    output wire [3:0] out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_byteenable,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_enable,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_read,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_write,
    output wire [31:0] out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writedata,
    output wire [31:0] out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_address,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_burstcount,
    output wire [3:0] out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_byteenable,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_enable,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_read,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_write,
    output wire [31:0] out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writedata,
    output wire [32:0] out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_address,
    output wire [4:0] out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_burstcount,
    output wire [63:0] out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_byteenable,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_enable,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_read,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_write,
    output wire [511:0] out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_writedata,
    output wire [0:0] out_valid_out,
    input wire [63:0] in_arg_acl_global_id_0,
    input wire [63:0] in_arg_acl_global_id_1,
    input wire [63:0] in_arg_acl_global_size_0,
    input wire [63:0] in_arg_acl_global_size_1,
    input wire [63:0] in_arg_acl_global_size_2,
    input wire [31:0] in_arg_acl_group_id_0,
    input wire [31:0] in_arg_acl_group_id_1,
    input wire [31:0] in_arg_acl_hw_wg_id,
    input wire [31:0] in_arg_acl_local_id_0,
    input wire [31:0] in_arg_acl_local_id_1,
    input wire [31:0] in_arg_acl_local_size_0,
    input wire [31:0] in_arg_acl_local_size_1,
    input wire [31:0] in_arg_acl_local_size_2,
    input wire [63:0] in_arg_arg0,
    input wire [63:0] in_arg_arg12,
    input wire [63:0] in_arg_arg16,
    input wire [63:0] in_arg_arg4,
    input wire [63:0] in_arg_arg8,
    input wire [31:0] in_memdep_34_k2_ZTS6c_calc_avm_readdata,
    input wire [0:0] in_memdep_34_k2_ZTS6c_calc_avm_readdatavalid,
    input wire [0:0] in_memdep_34_k2_ZTS6c_calc_avm_waitrequest,
    input wire [0:0] in_memdep_34_k2_ZTS6c_calc_avm_writeack,
    input wire [31:0] in_memdep_k2_ZTS6c_calc_avm_readdata,
    input wire [0:0] in_memdep_k2_ZTS6c_calc_avm_readdatavalid,
    input wire [0:0] in_memdep_k2_ZTS6c_calc_avm_waitrequest,
    input wire [0:0] in_memdep_k2_ZTS6c_calc_avm_writeack,
    input wire [0:0] in_stall_in,
    input wire [0:0] in_start,
    input wire [511:0] in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_readdata,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_readdatavalid,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_waitrequest,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_writeack,
    input wire [511:0] in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_readdata,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_readdatavalid,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_waitrequest,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_writeack,
    input wire [31:0] in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_readdata,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_readdatavalid,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_waitrequest,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writeack,
    input wire [31:0] in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_readdata,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_readdatavalid,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_waitrequest,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writeack,
    input wire [511:0] in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_readdata,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_readdatavalid,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_waitrequest,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_writeack,
    input wire [0:0] in_valid_in,
    input wire [31:0] in_workgroup_size,
    input wire [63:0] in_arg_arg1_0_tpl,
    input wire [63:0] in_arg_arg1_1_tpl,
    input wire [63:0] in_arg_arg10_0_tpl,
    input wire [63:0] in_arg_arg10_1_tpl,
    input wire [63:0] in_arg_arg11_0_tpl,
    input wire [63:0] in_arg_arg11_1_tpl,
    input wire [63:0] in_arg_arg13_0_tpl,
    input wire [63:0] in_arg_arg14_0_tpl,
    input wire [63:0] in_arg_arg15_0_tpl,
    input wire [63:0] in_arg_arg17_0_tpl,
    input wire [63:0] in_arg_arg17_1_tpl,
    input wire [63:0] in_arg_arg18_0_tpl,
    input wire [63:0] in_arg_arg18_1_tpl,
    input wire [63:0] in_arg_arg19_0_tpl,
    input wire [63:0] in_arg_arg19_1_tpl,
    input wire [63:0] in_arg_arg2_0_tpl,
    input wire [63:0] in_arg_arg2_1_tpl,
    input wire [63:0] in_arg_arg3_0_tpl,
    input wire [63:0] in_arg_arg3_1_tpl,
    input wire [63:0] in_arg_arg5_0_tpl,
    input wire [63:0] in_arg_arg6_0_tpl,
    input wire [63:0] in_arg_arg7_0_tpl,
    input wire [63:0] in_arg_arg9_0_tpl,
    input wire [63:0] in_arg_arg9_1_tpl,
    input wire clock,
    input wire resetn
    );

    wire [0:0] GND_q;
    wire [0:0] VCC_q;
    wire [0:0] c_calc_B4_x_i_capture;
    wire c_calc_B4_x_i_capture_bitsignaltemp;
    wire [0:0] c_calc_B4_x_i_clear;
    wire c_calc_B4_x_i_clear_bitsignaltemp;
    wire [0:0] c_calc_B4_x_i_enable;
    wire c_calc_B4_x_i_enable_bitsignaltemp;
    wire [0:0] c_calc_B4_x_i_shift;
    wire c_calc_B4_x_i_shift_bitsignaltemp;
    wire [0:0] c_calc_B4_x_i_stall_pred;
    wire c_calc_B4_x_i_stall_pred_bitsignaltemp;
    wire [0:0] c_calc_B4_x_i_stall_succ;
    wire c_calc_B4_x_i_stall_succ_bitsignaltemp;
    wire [0:0] c_calc_B4_x_i_valid_loop;
    wire c_calc_B4_x_i_valid_loop_bitsignaltemp;
    wire [0:0] c_calc_B4_x_i_valid_pred;
    wire c_calc_B4_x_i_valid_pred_bitsignaltemp;
    wire [0:0] c_calc_B4_x_i_valid_succ;
    wire c_calc_B4_x_i_valid_succ_bitsignaltemp;
    wire [0:0] c_calc_B6_x_i_capture;
    wire c_calc_B6_x_i_capture_bitsignaltemp;
    wire [0:0] c_calc_B6_x_i_clear;
    wire c_calc_B6_x_i_clear_bitsignaltemp;
    wire [0:0] c_calc_B6_x_i_enable;
    wire c_calc_B6_x_i_enable_bitsignaltemp;
    wire [0:0] c_calc_B6_x_i_shift;
    wire c_calc_B6_x_i_shift_bitsignaltemp;
    wire [0:0] c_calc_B6_x_i_stall_pred;
    wire c_calc_B6_x_i_stall_pred_bitsignaltemp;
    wire [0:0] c_calc_B6_x_i_stall_succ;
    wire c_calc_B6_x_i_stall_succ_bitsignaltemp;
    wire [0:0] c_calc_B6_x_i_valid_loop;
    wire c_calc_B6_x_i_valid_loop_bitsignaltemp;
    wire [0:0] c_calc_B6_x_i_valid_pred;
    wire c_calc_B6_x_i_valid_pred_bitsignaltemp;
    wire [0:0] c_calc_B6_x_i_valid_succ;
    wire c_calc_B6_x_i_valid_succ_bitsignaltemp;
    wire [31:0] c_float_0_000000e_0069_q;
    wire [31:0] c_i32_0101_q;
    wire [0:0] loop_limiter_k2_ZTS6c_calc0_out_o_stall;
    wire [0:0] loop_limiter_k2_ZTS6c_calc0_out_o_valid;
    wire [0:0] loop_limiter_k2_ZTS6c_calc1_out_o_stall;
    wire [0:0] loop_limiter_k2_ZTS6c_calc1_out_o_valid;
    wire [63:0] bb_ZTS6c_calc_B0_aunroll_x_out_acl_global_id_0;
    wire [63:0] bb_ZTS6c_calc_B0_aunroll_x_out_acl_global_id_1;
    wire [31:0] bb_ZTS6c_calc_B0_aunroll_x_out_acl_group_id_1;
    wire [31:0] bb_ZTS6c_calc_B0_aunroll_x_out_acl_hw_wg_id;
    wire [31:0] bb_ZTS6c_calc_B0_aunroll_x_out_c0_exe1;
    wire [31:0] bb_ZTS6c_calc_B0_aunroll_x_out_c0_exe2;
    wire [31:0] bb_ZTS6c_calc_B0_aunroll_x_out_c0_exe4;
    wire [63:0] bb_ZTS6c_calc_B0_aunroll_x_out_c0_exe5;
    wire [63:0] bb_ZTS6c_calc_B0_aunroll_x_out_c0_exe6;
    wire [63:0] bb_ZTS6c_calc_B0_aunroll_x_out_c0_exe7;
    wire [63:0] bb_ZTS6c_calc_B0_aunroll_x_out_c0_exe8;
    wire [31:0] bb_ZTS6c_calc_B0_aunroll_x_out_l_grpid_0;
    wire [0:0] bb_ZTS6c_calc_B0_aunroll_x_out_stall_out_0;
    wire [0:0] bb_ZTS6c_calc_B0_aunroll_x_out_valid_out_0;
    wire [0:0] bb_ZTS6c_calc_B0_aunroll_x_out_valid_out_1;
    wire [0:0] bb_ZTS6c_calc_B0_aunroll_x_out_wgl_0_enter_exit_stall_out;
    wire [0:0] bb_ZTS6c_calc_B0_aunroll_x_out_wgl_0_enter_exit_valid_out;
    wire [63:0] bb_ZTS6c_calc_B1_aunroll_x_out_acl_global_id_044;
    wire [63:0] bb_ZTS6c_calc_B1_aunroll_x_out_acl_global_id_150;
    wire [31:0] bb_ZTS6c_calc_B1_aunroll_x_out_acl_hw_wg_id57;
    wire [31:0] bb_ZTS6c_calc_B1_aunroll_x_out_c0_exe17;
    wire [31:0] bb_ZTS6c_calc_B1_aunroll_x_out_c0_exe211;
    wire [31:0] bb_ZTS6c_calc_B1_aunroll_x_out_c0_exe415;
    wire [63:0] bb_ZTS6c_calc_B1_aunroll_x_out_c0_exe519;
    wire [63:0] bb_ZTS6c_calc_B1_aunroll_x_out_c0_exe623;
    wire [63:0] bb_ZTS6c_calc_B1_aunroll_x_out_c0_exe727;
    wire [63:0] bb_ZTS6c_calc_B1_aunroll_x_out_c0_exe831;
    wire [31:0] bb_ZTS6c_calc_B1_aunroll_x_out_l_grpid_06;
    wire [0:0] bb_ZTS6c_calc_B1_aunroll_x_out_stall_out_0;
    wire [31:0] bb_ZTS6c_calc_B1_aunroll_x_out_unnamed_k2_ZTS6c_calc5;
    wire [0:0] bb_ZTS6c_calc_B1_aunroll_x_out_valid_out_0;
    wire [0:0] bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_stall;
    wire [0:0] bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_valid;
    wire [31:0] bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_data_0_tpl;
    wire [31:0] bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_data_1_tpl;
    wire [31:0] bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_data_2_tpl;
    wire [31:0] bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_data_3_tpl;
    wire [63:0] bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_data_4_tpl;
    wire [63:0] bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_data_5_tpl;
    wire [63:0] bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_data_6_tpl;
    wire [63:0] bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_data_7_tpl;
    wire [63:0] bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_data_8_tpl;
    wire [63:0] bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_data_9_tpl;
    wire [31:0] bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_data_10_tpl;
    wire [31:0] bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_data_11_tpl;
    wire [63:0] bb_ZTS6c_calc_B2_aunroll_x_out_acl_global_id_040;
    wire [63:0] bb_ZTS6c_calc_B2_aunroll_x_out_acl_global_id_146;
    wire [31:0] bb_ZTS6c_calc_B2_aunroll_x_out_acl_hw_wg_id53;
    wire [31:0] bb_ZTS6c_calc_B2_aunroll_x_out_c0_exe15438;
    wire [31:0] bb_ZTS6c_calc_B2_aunroll_x_out_l_grpid_02;
    wire [0:0] bb_ZTS6c_calc_B2_aunroll_x_out_stall_out_0;
    wire [0:0] bb_ZTS6c_calc_B2_aunroll_x_out_valid_out_0;
    wire [0:0] bb_ZTS6c_calc_B2_sr_0_aunroll_x_out_o_stall;
    wire [0:0] bb_ZTS6c_calc_B2_sr_0_aunroll_x_out_o_valid;
    wire [31:0] bb_ZTS6c_calc_B2_sr_0_aunroll_x_out_o_data_0_tpl;
    wire [31:0] bb_ZTS6c_calc_B2_sr_0_aunroll_x_out_o_data_1_tpl;
    wire [63:0] bb_ZTS6c_calc_B2_sr_0_aunroll_x_out_o_data_2_tpl;
    wire [63:0] bb_ZTS6c_calc_B2_sr_0_aunroll_x_out_o_data_3_tpl;
    wire [31:0] bb_ZTS6c_calc_B2_sr_0_aunroll_x_out_o_data_4_tpl;
    wire [31:0] bb_ZTS6c_calc_B3_aunroll_x_out_acl_hw_wg_id52;
    wire [0:0] bb_ZTS6c_calc_B3_aunroll_x_out_lsu_unnamed_k2_ZTS6c_calc9_o_active;
    wire [0:0] bb_ZTS6c_calc_B3_aunroll_x_out_stall_out_0;
    wire [0:0] bb_ZTS6c_calc_B3_aunroll_x_out_stall_out_1;
    wire [32:0] bb_ZTS6c_calc_B3_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_address;
    wire [4:0] bb_ZTS6c_calc_B3_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_burstcount;
    wire [63:0] bb_ZTS6c_calc_B3_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_byteenable;
    wire [0:0] bb_ZTS6c_calc_B3_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_enable;
    wire [0:0] bb_ZTS6c_calc_B3_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_read;
    wire [0:0] bb_ZTS6c_calc_B3_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_write;
    wire [511:0] bb_ZTS6c_calc_B3_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_writedata;
    wire [0:0] bb_ZTS6c_calc_B3_aunroll_x_out_valid_out_0;
    wire [0:0] bb_ZTS6c_calc_B3_aunroll_x_out_wgl_0_exit_exit_stall_in;
    wire [0:0] bb_ZTS6c_calc_B3_aunroll_x_out_wgl_0_exit_exit_valid_in;
    wire [0:0] bb_ZTS6c_calc_B3_sr_0_aunroll_x_out_o_stall;
    wire [0:0] bb_ZTS6c_calc_B3_sr_0_aunroll_x_out_o_valid;
    wire [31:0] bb_ZTS6c_calc_B3_sr_0_aunroll_x_out_o_data_0_tpl;
    wire [0:0] bb_ZTS6c_calc_B3_sr_0_aunroll_x_out_o_data_1_tpl;
    wire [0:0] bb_ZTS6c_calc_B3_sr_0_aunroll_x_out_o_data_2_tpl;
    wire [31:0] bb_ZTS6c_calc_B3_sr_0_aunroll_x_out_o_data_3_tpl;
    wire [63:0] bb_ZTS6c_calc_B3_sr_0_aunroll_x_out_o_data_4_tpl;
    wire [63:0] bb_ZTS6c_calc_B3_sr_0_aunroll_x_out_o_data_5_tpl;
    wire [31:0] bb_ZTS6c_calc_B3_sr_0_aunroll_x_out_o_data_6_tpl;
    wire [0:0] bb_ZTS6c_calc_B3_sr_1_aunroll_x_out_o_stall;
    wire [0:0] bb_ZTS6c_calc_B3_sr_1_aunroll_x_out_o_valid;
    wire [31:0] bb_ZTS6c_calc_B3_sr_1_aunroll_x_out_o_data_0_tpl;
    wire [0:0] bb_ZTS6c_calc_B3_sr_1_aunroll_x_out_o_data_1_tpl;
    wire [0:0] bb_ZTS6c_calc_B3_sr_1_aunroll_x_out_o_data_2_tpl;
    wire [31:0] bb_ZTS6c_calc_B3_sr_1_aunroll_x_out_o_data_3_tpl;
    wire [63:0] bb_ZTS6c_calc_B3_sr_1_aunroll_x_out_o_data_4_tpl;
    wire [63:0] bb_ZTS6c_calc_B3_sr_1_aunroll_x_out_o_data_5_tpl;
    wire [31:0] bb_ZTS6c_calc_B3_sr_1_aunroll_x_out_o_data_6_tpl;
    wire [31:0] bb_ZTS6c_calc_B4_aunroll_x_out_acl_0141_i509;
    wire [31:0] bb_ZTS6c_calc_B4_aunroll_x_out_acl_0142_i508;
    wire [31:0] bb_ZTS6c_calc_B4_aunroll_x_out_acl_0143_i507;
    wire [63:0] bb_ZTS6c_calc_B4_aunroll_x_out_acl_global_id_043;
    wire [63:0] bb_ZTS6c_calc_B4_aunroll_x_out_acl_global_id_149;
    wire [31:0] bb_ZTS6c_calc_B4_aunroll_x_out_acl_hw_wg_id56;
    wire [31:0] bb_ZTS6c_calc_B4_aunroll_x_out_c0_exe210;
    wire [31:0] bb_ZTS6c_calc_B4_aunroll_x_out_c0_exe412;
    wire [63:0] bb_ZTS6c_calc_B4_aunroll_x_out_c0_exe517;
    wire [63:0] bb_ZTS6c_calc_B4_aunroll_x_out_c0_exe620;
    wire [63:0] bb_ZTS6c_calc_B4_aunroll_x_out_c0_exe725;
    wire [63:0] bb_ZTS6c_calc_B4_aunroll_x_out_c0_exe828;
    wire [31:0] bb_ZTS6c_calc_B4_aunroll_x_out_l_grpid_05;
    wire [63:0] bb_ZTS6c_calc_B4_aunroll_x_out_l_grpid_0_ext_offset;
    wire [31:0] bb_ZTS6c_calc_B4_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_address;
    wire [0:0] bb_ZTS6c_calc_B4_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_burstcount;
    wire [3:0] bb_ZTS6c_calc_B4_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_byteenable;
    wire [0:0] bb_ZTS6c_calc_B4_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_enable;
    wire [0:0] bb_ZTS6c_calc_B4_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_read;
    wire [0:0] bb_ZTS6c_calc_B4_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_write;
    wire [31:0] bb_ZTS6c_calc_B4_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_writedata;
    wire [31:0] bb_ZTS6c_calc_B4_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_address;
    wire [0:0] bb_ZTS6c_calc_B4_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_burstcount;
    wire [3:0] bb_ZTS6c_calc_B4_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_byteenable;
    wire [0:0] bb_ZTS6c_calc_B4_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_enable;
    wire [0:0] bb_ZTS6c_calc_B4_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_read;
    wire [0:0] bb_ZTS6c_calc_B4_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_write;
    wire [31:0] bb_ZTS6c_calc_B4_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_writedata;
    wire [0:0] bb_ZTS6c_calc_B4_aunroll_x_out_stall_out_0;
    wire [0:0] bb_ZTS6c_calc_B4_aunroll_x_out_stall_out_1;
    wire [32:0] bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_address;
    wire [4:0] bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_burstcount;
    wire [63:0] bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_byteenable;
    wire [0:0] bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_enable;
    wire [0:0] bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_read;
    wire [0:0] bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_write;
    wire [511:0] bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_writedata;
    wire [32:0] bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_address;
    wire [4:0] bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_burstcount;
    wire [63:0] bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_byteenable;
    wire [0:0] bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_enable;
    wire [0:0] bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_read;
    wire [0:0] bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_write;
    wire [511:0] bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_writedata;
    wire [0:0] bb_ZTS6c_calc_B4_aunroll_x_out_valid_in_0;
    wire [0:0] bb_ZTS6c_calc_B4_aunroll_x_out_valid_in_1;
    wire [0:0] bb_ZTS6c_calc_B4_aunroll_x_out_valid_out_0;
    wire [0:0] bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_stall;
    wire [0:0] bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_valid;
    wire [31:0] bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_0_tpl;
    wire [31:0] bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_1_tpl;
    wire [31:0] bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_2_tpl;
    wire [31:0] bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_3_tpl;
    wire [31:0] bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_4_tpl;
    wire [31:0] bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_5_tpl;
    wire [63:0] bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_6_tpl;
    wire [63:0] bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_7_tpl;
    wire [63:0] bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_8_tpl;
    wire [63:0] bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_9_tpl;
    wire [63:0] bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_10_tpl;
    wire [63:0] bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_11_tpl;
    wire [31:0] bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_12_tpl;
    wire [0:0] bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_stall;
    wire [0:0] bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_valid;
    wire [31:0] bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_0_tpl;
    wire [31:0] bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_1_tpl;
    wire [31:0] bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_2_tpl;
    wire [31:0] bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_3_tpl;
    wire [31:0] bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_4_tpl;
    wire [31:0] bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_5_tpl;
    wire [63:0] bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_6_tpl;
    wire [63:0] bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_7_tpl;
    wire [63:0] bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_8_tpl;
    wire [63:0] bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_9_tpl;
    wire [63:0] bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_10_tpl;
    wire [63:0] bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_11_tpl;
    wire [31:0] bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_12_tpl;
    wire [63:0] bb_ZTS6c_calc_B5_aunroll_x_out_acl_global_id_041;
    wire [63:0] bb_ZTS6c_calc_B5_aunroll_x_out_acl_global_id_147;
    wire [31:0] bb_ZTS6c_calc_B5_aunroll_x_out_acl_hw_wg_id54;
    wire [31:0] bb_ZTS6c_calc_B5_aunroll_x_out_c0_exe15437;
    wire [31:0] bb_ZTS6c_calc_B5_aunroll_x_out_c0_exe28;
    wire [31:0] bb_ZTS6c_calc_B5_aunroll_x_out_c0_exe413;
    wire [63:0] bb_ZTS6c_calc_B5_aunroll_x_out_c0_exe518;
    wire [63:0] bb_ZTS6c_calc_B5_aunroll_x_out_c0_exe621;
    wire [63:0] bb_ZTS6c_calc_B5_aunroll_x_out_c0_exe726;
    wire [63:0] bb_ZTS6c_calc_B5_aunroll_x_out_c0_exe829;
    wire [31:0] bb_ZTS6c_calc_B5_aunroll_x_out_l_grpid_03;
    wire [0:0] bb_ZTS6c_calc_B5_aunroll_x_out_stall_in_0;
    wire [0:0] bb_ZTS6c_calc_B5_aunroll_x_out_stall_out_0;
    wire [31:0] bb_ZTS6c_calc_B5_aunroll_x_out_unnamed_k2_ZTS6c_calc19;
    wire [31:0] bb_ZTS6c_calc_B5_aunroll_x_out_unnamed_k2_ZTS6c_calc20;
    wire [0:0] bb_ZTS6c_calc_B5_aunroll_x_out_valid_out_0;
    wire [0:0] bb_ZTS6c_calc_B5_aunroll_x_out_valid_out_1;
    wire [0:0] bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_stall;
    wire [0:0] bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_valid;
    wire [31:0] bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_0_tpl;
    wire [31:0] bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_1_tpl;
    wire [31:0] bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_2_tpl;
    wire [63:0] bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_3_tpl;
    wire [63:0] bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_4_tpl;
    wire [63:0] bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_5_tpl;
    wire [63:0] bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_6_tpl;
    wire [31:0] bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_7_tpl;
    wire [31:0] bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_8_tpl;
    wire [31:0] bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_9_tpl;
    wire [63:0] bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_10_tpl;
    wire [63:0] bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_11_tpl;
    wire [31:0] bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_12_tpl;
    wire [31:0] bb_ZTS6c_calc_B6_aunroll_x_out_acl_0141_i50933;
    wire [31:0] bb_ZTS6c_calc_B6_aunroll_x_out_acl_0142_i50835;
    wire [63:0] bb_ZTS6c_calc_B6_aunroll_x_out_acl_global_id_042;
    wire [63:0] bb_ZTS6c_calc_B6_aunroll_x_out_acl_global_id_148;
    wire [31:0] bb_ZTS6c_calc_B6_aunroll_x_out_acl_hw_wg_id55;
    wire [31:0] bb_ZTS6c_calc_B6_aunroll_x_out_c0_exe154;
    wire [31:0] bb_ZTS6c_calc_B6_aunroll_x_out_c0_exe255;
    wire [31:0] bb_ZTS6c_calc_B6_aunroll_x_out_c0_exe29;
    wire [31:0] bb_ZTS6c_calc_B6_aunroll_x_out_c0_exe414;
    wire [63:0] bb_ZTS6c_calc_B6_aunroll_x_out_c0_exe516;
    wire [63:0] bb_ZTS6c_calc_B6_aunroll_x_out_c0_exe622;
    wire [63:0] bb_ZTS6c_calc_B6_aunroll_x_out_c0_exe724;
    wire [63:0] bb_ZTS6c_calc_B6_aunroll_x_out_c0_exe830;
    wire [31:0] bb_ZTS6c_calc_B6_aunroll_x_out_l_grpid_04;
    wire [63:0] bb_ZTS6c_calc_B6_aunroll_x_out_l_grpid_0_ext_offset36;
    wire [0:0] bb_ZTS6c_calc_B6_aunroll_x_out_stall_in_0;
    wire [0:0] bb_ZTS6c_calc_B6_aunroll_x_out_stall_out_0;
    wire [0:0] bb_ZTS6c_calc_B6_aunroll_x_out_stall_out_1;
    wire [31:0] bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_address;
    wire [0:0] bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_burstcount;
    wire [3:0] bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_byteenable;
    wire [0:0] bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_enable;
    wire [0:0] bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_read;
    wire [0:0] bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_write;
    wire [31:0] bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writedata;
    wire [31:0] bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_address;
    wire [0:0] bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_burstcount;
    wire [3:0] bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_byteenable;
    wire [0:0] bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_enable;
    wire [0:0] bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_read;
    wire [0:0] bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_write;
    wire [31:0] bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writedata;
    wire [0:0] bb_ZTS6c_calc_B6_aunroll_x_out_valid_in_0;
    wire [0:0] bb_ZTS6c_calc_B6_aunroll_x_out_valid_in_1;
    wire [0:0] bb_ZTS6c_calc_B6_aunroll_x_out_valid_out_0;
    wire [0:0] bb_ZTS6c_calc_B6_aunroll_x_out_valid_out_1;
    wire [0:0] bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_stall;
    wire [0:0] bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_valid;
    wire [31:0] bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_0_tpl;
    wire [31:0] bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_1_tpl;
    wire [31:0] bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_2_tpl;
    wire [31:0] bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_3_tpl;
    wire [31:0] bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_4_tpl;
    wire [63:0] bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_5_tpl;
    wire [63:0] bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_6_tpl;
    wire [63:0] bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_7_tpl;
    wire [63:0] bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_8_tpl;
    wire [31:0] bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_9_tpl;
    wire [31:0] bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_10_tpl;
    wire [63:0] bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_11_tpl;
    wire [63:0] bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_12_tpl;
    wire [63:0] bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_13_tpl;
    wire [31:0] bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_14_tpl;
    wire [0:0] bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_stall;
    wire [0:0] bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_valid;
    wire [31:0] bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_0_tpl;
    wire [31:0] bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_1_tpl;
    wire [31:0] bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_2_tpl;
    wire [31:0] bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_3_tpl;
    wire [31:0] bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_4_tpl;
    wire [63:0] bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_5_tpl;
    wire [63:0] bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_6_tpl;
    wire [63:0] bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_7_tpl;
    wire [63:0] bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_8_tpl;
    wire [31:0] bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_9_tpl;
    wire [31:0] bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_10_tpl;
    wire [63:0] bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_11_tpl;
    wire [63:0] bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_12_tpl;
    wire [63:0] bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_13_tpl;
    wire [31:0] bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_14_tpl;


    // bb_ZTS6c_calc_B6_sr_0_aunroll_x(BLACKBOX,86)
    k2_ZTS6c_calc_bb_ZTS6c_calc_B6_sr_0 thebb_ZTS6c_calc_B6_sr_0_aunroll_x (
        .in_i_stall(bb_ZTS6c_calc_B6_aunroll_x_out_stall_out_0),
        .in_i_valid(bb_ZTS6c_calc_B6_aunroll_x_out_valid_out_0),
        .in_i_data_0_tpl(bb_ZTS6c_calc_B6_aunroll_x_out_c0_exe255),
        .in_i_data_1_tpl(bb_ZTS6c_calc_B6_aunroll_x_out_c0_exe154),
        .in_i_data_2_tpl(bb_ZTS6c_calc_B6_aunroll_x_out_l_grpid_04),
        .in_i_data_3_tpl(bb_ZTS6c_calc_B6_aunroll_x_out_c0_exe29),
        .in_i_data_4_tpl(bb_ZTS6c_calc_B6_aunroll_x_out_c0_exe414),
        .in_i_data_5_tpl(bb_ZTS6c_calc_B6_aunroll_x_out_c0_exe516),
        .in_i_data_6_tpl(bb_ZTS6c_calc_B6_aunroll_x_out_c0_exe622),
        .in_i_data_7_tpl(bb_ZTS6c_calc_B6_aunroll_x_out_c0_exe724),
        .in_i_data_8_tpl(bb_ZTS6c_calc_B6_aunroll_x_out_c0_exe830),
        .in_i_data_9_tpl(bb_ZTS6c_calc_B6_aunroll_x_out_acl_0141_i50933),
        .in_i_data_10_tpl(bb_ZTS6c_calc_B6_aunroll_x_out_acl_0142_i50835),
        .in_i_data_11_tpl(bb_ZTS6c_calc_B6_aunroll_x_out_l_grpid_0_ext_offset36),
        .in_i_data_12_tpl(bb_ZTS6c_calc_B6_aunroll_x_out_acl_global_id_042),
        .in_i_data_13_tpl(bb_ZTS6c_calc_B6_aunroll_x_out_acl_global_id_148),
        .in_i_data_14_tpl(bb_ZTS6c_calc_B6_aunroll_x_out_acl_hw_wg_id55),
        .out_o_stall(bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_stall),
        .out_o_valid(bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_valid),
        .out_o_data_0_tpl(bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_0_tpl),
        .out_o_data_1_tpl(bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_1_tpl),
        .out_o_data_2_tpl(bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_2_tpl),
        .out_o_data_3_tpl(bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_3_tpl),
        .out_o_data_4_tpl(bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_4_tpl),
        .out_o_data_5_tpl(bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_5_tpl),
        .out_o_data_6_tpl(bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_6_tpl),
        .out_o_data_7_tpl(bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_7_tpl),
        .out_o_data_8_tpl(bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_8_tpl),
        .out_o_data_9_tpl(bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_9_tpl),
        .out_o_data_10_tpl(bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_10_tpl),
        .out_o_data_11_tpl(bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_11_tpl),
        .out_o_data_12_tpl(bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_12_tpl),
        .out_o_data_13_tpl(bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_13_tpl),
        .out_o_data_14_tpl(bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_14_tpl),
        .clock(clock),
        .resetn(resetn)
    );

    // bb_ZTS6c_calc_B6_aunroll_x(BLACKBOX,85)
    k2_ZTS6c_calc_bb_ZTS6c_calc_B6 thebb_ZTS6c_calc_B6_aunroll_x (
        .in_acl_0141_i50933_0(bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_9_tpl),
        .in_acl_0141_i50933_1(bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_9_tpl),
        .in_acl_0142_i50835_0(bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_10_tpl),
        .in_acl_0142_i50835_1(bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_10_tpl),
        .in_acl_0_i506_0(bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_0_tpl),
        .in_acl_0_i506_1(bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_0_tpl),
        .in_acl_1_i505_0(bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_1_tpl),
        .in_acl_1_i505_1(bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_1_tpl),
        .in_acl_global_id_042_0(bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_12_tpl),
        .in_acl_global_id_042_1(bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_12_tpl),
        .in_acl_global_id_148_0(bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_13_tpl),
        .in_acl_global_id_148_1(bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_13_tpl),
        .in_acl_hw_wg_id55_0(bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_14_tpl),
        .in_acl_hw_wg_id55_1(bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_14_tpl),
        .in_arg12(in_arg_arg12),
        .in_arg16(in_arg_arg16),
        .in_arg4(in_arg_arg4),
        .in_c0_exe29_0(bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_3_tpl),
        .in_c0_exe29_1(bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_3_tpl),
        .in_c0_exe414_0(bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_4_tpl),
        .in_c0_exe414_1(bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_4_tpl),
        .in_c0_exe516_0(bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_5_tpl),
        .in_c0_exe516_1(bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_5_tpl),
        .in_c0_exe622_0(bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_6_tpl),
        .in_c0_exe622_1(bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_6_tpl),
        .in_c0_exe724_0(bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_7_tpl),
        .in_c0_exe724_1(bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_7_tpl),
        .in_c0_exe830_0(bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_8_tpl),
        .in_c0_exe830_1(bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_8_tpl),
        .in_encoder_ZTS6c_calc_B6_merge_priority_encoder_workgroup_size(in_workgroup_size),
        .in_flush(in_start),
        .in_l_grpid_04_0(bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_2_tpl),
        .in_l_grpid_04_1(bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_2_tpl),
        .in_l_grpid_0_ext_offset36_0(bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_data_11_tpl),
        .in_l_grpid_0_ext_offset36_1(bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_11_tpl),
        .in_stall_in_0(bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_stall),
        .in_stall_in_1(bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_stall),
        .in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_readdata(in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_readdata),
        .in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_readdatavalid(in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_readdatavalid),
        .in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_waitrequest(in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_waitrequest),
        .in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writeack(in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writeack),
        .in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_readdata(in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_readdata),
        .in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_readdatavalid(in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_readdatavalid),
        .in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_waitrequest(in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_waitrequest),
        .in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writeack(in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writeack),
        .in_valid_in_0(bb_ZTS6c_calc_B6_sr_0_aunroll_x_out_o_valid),
        .in_valid_in_1(bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_valid),
        .in_arg15_0_tpl(in_arg_arg15_0_tpl),
        .in_arg18_0_tpl(in_arg_arg18_0_tpl),
        .in_arg18_1_tpl(in_arg_arg18_1_tpl),
        .in_arg19_0_tpl(in_arg_arg19_0_tpl),
        .in_arg19_1_tpl(in_arg_arg19_1_tpl),
        .in_arg7_0_tpl(in_arg_arg7_0_tpl),
        .out_acl_0141_i50933(bb_ZTS6c_calc_B6_aunroll_x_out_acl_0141_i50933),
        .out_acl_0142_i50835(bb_ZTS6c_calc_B6_aunroll_x_out_acl_0142_i50835),
        .out_acl_global_id_042(bb_ZTS6c_calc_B6_aunroll_x_out_acl_global_id_042),
        .out_acl_global_id_148(bb_ZTS6c_calc_B6_aunroll_x_out_acl_global_id_148),
        .out_acl_hw_wg_id55(bb_ZTS6c_calc_B6_aunroll_x_out_acl_hw_wg_id55),
        .out_c0_exe154(bb_ZTS6c_calc_B6_aunroll_x_out_c0_exe154),
        .out_c0_exe255(bb_ZTS6c_calc_B6_aunroll_x_out_c0_exe255),
        .out_c0_exe29(bb_ZTS6c_calc_B6_aunroll_x_out_c0_exe29),
        .out_c0_exe414(bb_ZTS6c_calc_B6_aunroll_x_out_c0_exe414),
        .out_c0_exe516(bb_ZTS6c_calc_B6_aunroll_x_out_c0_exe516),
        .out_c0_exe622(bb_ZTS6c_calc_B6_aunroll_x_out_c0_exe622),
        .out_c0_exe724(bb_ZTS6c_calc_B6_aunroll_x_out_c0_exe724),
        .out_c0_exe830(bb_ZTS6c_calc_B6_aunroll_x_out_c0_exe830),
        .out_l_grpid_04(bb_ZTS6c_calc_B6_aunroll_x_out_l_grpid_04),
        .out_l_grpid_0_ext_offset36(bb_ZTS6c_calc_B6_aunroll_x_out_l_grpid_0_ext_offset36),
        .out_stall_in_0(bb_ZTS6c_calc_B6_aunroll_x_out_stall_in_0),
        .out_stall_out_0(bb_ZTS6c_calc_B6_aunroll_x_out_stall_out_0),
        .out_stall_out_1(bb_ZTS6c_calc_B6_aunroll_x_out_stall_out_1),
        .out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_address(bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_address),
        .out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_burstcount(bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_burstcount),
        .out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_byteenable(bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_byteenable),
        .out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_enable(bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_enable),
        .out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_read(bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_read),
        .out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_write(bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_write),
        .out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writedata(bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writedata),
        .out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_address(bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_address),
        .out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_burstcount(bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_burstcount),
        .out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_byteenable(bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_byteenable),
        .out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_enable(bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_enable),
        .out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_read(bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_read),
        .out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_write(bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_write),
        .out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writedata(bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writedata),
        .out_valid_in_0(bb_ZTS6c_calc_B6_aunroll_x_out_valid_in_0),
        .out_valid_in_1(bb_ZTS6c_calc_B6_aunroll_x_out_valid_in_1),
        .out_valid_out_0(bb_ZTS6c_calc_B6_aunroll_x_out_valid_out_0),
        .out_valid_out_1(bb_ZTS6c_calc_B6_aunroll_x_out_valid_out_1),
        .clock(clock),
        .resetn(resetn)
    );

    // bb_ZTS6c_calc_B5_sr_0_aunroll_x(BLACKBOX,84)
    k2_ZTS6c_calc_bb_ZTS6c_calc_B5_sr_0 thebb_ZTS6c_calc_B5_sr_0_aunroll_x (
        .in_i_stall(bb_ZTS6c_calc_B5_aunroll_x_out_stall_out_0),
        .in_i_valid(bb_ZTS6c_calc_B6_aunroll_x_out_valid_out_1),
        .in_i_data_0_tpl(bb_ZTS6c_calc_B6_aunroll_x_out_l_grpid_04),
        .in_i_data_1_tpl(bb_ZTS6c_calc_B6_aunroll_x_out_c0_exe29),
        .in_i_data_2_tpl(bb_ZTS6c_calc_B6_aunroll_x_out_c0_exe414),
        .in_i_data_3_tpl(bb_ZTS6c_calc_B6_aunroll_x_out_c0_exe516),
        .in_i_data_4_tpl(bb_ZTS6c_calc_B6_aunroll_x_out_c0_exe622),
        .in_i_data_5_tpl(bb_ZTS6c_calc_B6_aunroll_x_out_c0_exe724),
        .in_i_data_6_tpl(bb_ZTS6c_calc_B6_aunroll_x_out_c0_exe830),
        .in_i_data_7_tpl(bb_ZTS6c_calc_B6_aunroll_x_out_acl_0141_i50933),
        .in_i_data_8_tpl(bb_ZTS6c_calc_B6_aunroll_x_out_acl_0142_i50835),
        .in_i_data_9_tpl(bb_ZTS6c_calc_B6_aunroll_x_out_c0_exe154),
        .in_i_data_10_tpl(bb_ZTS6c_calc_B6_aunroll_x_out_acl_global_id_042),
        .in_i_data_11_tpl(bb_ZTS6c_calc_B6_aunroll_x_out_acl_global_id_148),
        .in_i_data_12_tpl(bb_ZTS6c_calc_B6_aunroll_x_out_acl_hw_wg_id55),
        .out_o_stall(bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_stall),
        .out_o_valid(bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_valid),
        .out_o_data_0_tpl(bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_0_tpl),
        .out_o_data_1_tpl(bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_1_tpl),
        .out_o_data_2_tpl(bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_2_tpl),
        .out_o_data_3_tpl(bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_3_tpl),
        .out_o_data_4_tpl(bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_4_tpl),
        .out_o_data_5_tpl(bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_5_tpl),
        .out_o_data_6_tpl(bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_6_tpl),
        .out_o_data_7_tpl(bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_7_tpl),
        .out_o_data_8_tpl(bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_8_tpl),
        .out_o_data_9_tpl(bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_9_tpl),
        .out_o_data_10_tpl(bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_10_tpl),
        .out_o_data_11_tpl(bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_11_tpl),
        .out_o_data_12_tpl(bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_12_tpl),
        .clock(clock),
        .resetn(resetn)
    );

    // c_i32_0101(CONSTANT,14)
    assign c_i32_0101_q = $unsigned(32'b00000000000000000000000000000000);

    // bb_ZTS6c_calc_B6_sr_1_aunroll_x(BLACKBOX,87)
    k2_ZTS6c_calc_bb_ZTS6c_calc_B6_sr_1 thebb_ZTS6c_calc_B6_sr_1_aunroll_x (
        .in_i_stall(bb_ZTS6c_calc_B6_aunroll_x_out_stall_out_1),
        .in_i_valid(loop_limiter_k2_ZTS6c_calc1_out_o_valid),
        .in_i_data_0_tpl(c_i32_0101_q),
        .in_i_data_1_tpl(bb_ZTS6c_calc_B4_aunroll_x_out_acl_0143_i507),
        .in_i_data_2_tpl(bb_ZTS6c_calc_B4_aunroll_x_out_l_grpid_05),
        .in_i_data_3_tpl(bb_ZTS6c_calc_B4_aunroll_x_out_c0_exe210),
        .in_i_data_4_tpl(bb_ZTS6c_calc_B4_aunroll_x_out_c0_exe412),
        .in_i_data_5_tpl(bb_ZTS6c_calc_B4_aunroll_x_out_c0_exe517),
        .in_i_data_6_tpl(bb_ZTS6c_calc_B4_aunroll_x_out_c0_exe620),
        .in_i_data_7_tpl(bb_ZTS6c_calc_B4_aunroll_x_out_c0_exe725),
        .in_i_data_8_tpl(bb_ZTS6c_calc_B4_aunroll_x_out_c0_exe828),
        .in_i_data_9_tpl(bb_ZTS6c_calc_B4_aunroll_x_out_acl_0141_i509),
        .in_i_data_10_tpl(bb_ZTS6c_calc_B4_aunroll_x_out_acl_0142_i508),
        .in_i_data_11_tpl(bb_ZTS6c_calc_B4_aunroll_x_out_l_grpid_0_ext_offset),
        .in_i_data_12_tpl(bb_ZTS6c_calc_B4_aunroll_x_out_acl_global_id_043),
        .in_i_data_13_tpl(bb_ZTS6c_calc_B4_aunroll_x_out_acl_global_id_149),
        .in_i_data_14_tpl(bb_ZTS6c_calc_B4_aunroll_x_out_acl_hw_wg_id56),
        .out_o_stall(bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_stall),
        .out_o_valid(bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_valid),
        .out_o_data_0_tpl(bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_0_tpl),
        .out_o_data_1_tpl(bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_1_tpl),
        .out_o_data_2_tpl(bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_2_tpl),
        .out_o_data_3_tpl(bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_3_tpl),
        .out_o_data_4_tpl(bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_4_tpl),
        .out_o_data_5_tpl(bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_5_tpl),
        .out_o_data_6_tpl(bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_6_tpl),
        .out_o_data_7_tpl(bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_7_tpl),
        .out_o_data_8_tpl(bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_8_tpl),
        .out_o_data_9_tpl(bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_9_tpl),
        .out_o_data_10_tpl(bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_10_tpl),
        .out_o_data_11_tpl(bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_11_tpl),
        .out_o_data_12_tpl(bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_12_tpl),
        .out_o_data_13_tpl(bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_13_tpl),
        .out_o_data_14_tpl(bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_data_14_tpl),
        .clock(clock),
        .resetn(resetn)
    );

    // loop_limiter_k2_ZTS6c_calc1(BLACKBOX,17)
    k2_ZTS6c_calc_loop_limiter_1 theloop_limiter_k2_ZTS6c_calc1 (
        .in_i_stall(bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_stall),
        .in_i_stall_exit(bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_stall),
        .in_i_valid(bb_ZTS6c_calc_B4_aunroll_x_out_valid_out_0),
        .in_i_valid_exit(bb_ZTS6c_calc_B6_aunroll_x_out_valid_out_1),
        .out_o_stall(loop_limiter_k2_ZTS6c_calc1_out_o_stall),
        .out_o_valid(loop_limiter_k2_ZTS6c_calc1_out_o_valid),
        .clock(clock),
        .resetn(resetn)
    );

    // bb_ZTS6c_calc_B4_sr_0_aunroll_x(BLACKBOX,81)
    k2_ZTS6c_calc_bb_ZTS6c_calc_B4_sr_0 thebb_ZTS6c_calc_B4_sr_0_aunroll_x (
        .in_i_stall(bb_ZTS6c_calc_B4_aunroll_x_out_stall_out_0),
        .in_i_valid(bb_ZTS6c_calc_B5_aunroll_x_out_valid_out_0),
        .in_i_data_0_tpl(bb_ZTS6c_calc_B5_aunroll_x_out_unnamed_k2_ZTS6c_calc20),
        .in_i_data_1_tpl(bb_ZTS6c_calc_B5_aunroll_x_out_unnamed_k2_ZTS6c_calc19),
        .in_i_data_2_tpl(bb_ZTS6c_calc_B5_aunroll_x_out_c0_exe15437),
        .in_i_data_3_tpl(bb_ZTS6c_calc_B5_aunroll_x_out_l_grpid_03),
        .in_i_data_4_tpl(bb_ZTS6c_calc_B5_aunroll_x_out_c0_exe28),
        .in_i_data_5_tpl(bb_ZTS6c_calc_B5_aunroll_x_out_c0_exe413),
        .in_i_data_6_tpl(bb_ZTS6c_calc_B5_aunroll_x_out_c0_exe518),
        .in_i_data_7_tpl(bb_ZTS6c_calc_B5_aunroll_x_out_c0_exe621),
        .in_i_data_8_tpl(bb_ZTS6c_calc_B5_aunroll_x_out_c0_exe726),
        .in_i_data_9_tpl(bb_ZTS6c_calc_B5_aunroll_x_out_c0_exe829),
        .in_i_data_10_tpl(bb_ZTS6c_calc_B5_aunroll_x_out_acl_global_id_041),
        .in_i_data_11_tpl(bb_ZTS6c_calc_B5_aunroll_x_out_acl_global_id_147),
        .in_i_data_12_tpl(bb_ZTS6c_calc_B5_aunroll_x_out_acl_hw_wg_id54),
        .out_o_stall(bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_stall),
        .out_o_valid(bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_valid),
        .out_o_data_0_tpl(bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_0_tpl),
        .out_o_data_1_tpl(bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_1_tpl),
        .out_o_data_2_tpl(bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_2_tpl),
        .out_o_data_3_tpl(bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_3_tpl),
        .out_o_data_4_tpl(bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_4_tpl),
        .out_o_data_5_tpl(bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_5_tpl),
        .out_o_data_6_tpl(bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_6_tpl),
        .out_o_data_7_tpl(bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_7_tpl),
        .out_o_data_8_tpl(bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_8_tpl),
        .out_o_data_9_tpl(bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_9_tpl),
        .out_o_data_10_tpl(bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_10_tpl),
        .out_o_data_11_tpl(bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_11_tpl),
        .out_o_data_12_tpl(bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_12_tpl),
        .clock(clock),
        .resetn(resetn)
    );

    // bb_ZTS6c_calc_B4_aunroll_x(BLACKBOX,80)
    k2_ZTS6c_calc_bb_ZTS6c_calc_B4 thebb_ZTS6c_calc_B4_aunroll_x (
        .in_acl_0141_i509_0(bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_0_tpl),
        .in_acl_0141_i509_1(bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_0_tpl),
        .in_acl_0142_i508_0(bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_1_tpl),
        .in_acl_0142_i508_1(bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_1_tpl),
        .in_acl_0143_i507_0(bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_2_tpl),
        .in_acl_0143_i507_1(bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_2_tpl),
        .in_acl_global_id_043_0(bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_10_tpl),
        .in_acl_global_id_043_1(bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_10_tpl),
        .in_acl_global_id_149_0(bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_11_tpl),
        .in_acl_global_id_149_1(bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_11_tpl),
        .in_acl_hw_wg_id56_0(bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_12_tpl),
        .in_acl_hw_wg_id56_1(bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_12_tpl),
        .in_arg12(in_arg_arg12),
        .in_arg16(in_arg_arg16),
        .in_arg4(in_arg_arg4),
        .in_barrier_unnamed_k2_ZTS6c_calc18_wgs_workgroup_size(in_workgroup_size),
        .in_c0_exe210_0(bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_4_tpl),
        .in_c0_exe210_1(bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_4_tpl),
        .in_c0_exe412_0(bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_5_tpl),
        .in_c0_exe412_1(bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_5_tpl),
        .in_c0_exe517_0(bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_6_tpl),
        .in_c0_exe517_1(bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_6_tpl),
        .in_c0_exe620_0(bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_7_tpl),
        .in_c0_exe620_1(bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_7_tpl),
        .in_c0_exe725_0(bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_8_tpl),
        .in_c0_exe725_1(bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_8_tpl),
        .in_c0_exe828_0(bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_9_tpl),
        .in_c0_exe828_1(bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_9_tpl),
        .in_encoder_ZTS6c_calc_B4_merge_priority_encoder_workgroup_size(in_workgroup_size),
        .in_flush(in_start),
        .in_l_grpid_05_0(bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_data_3_tpl),
        .in_l_grpid_05_1(bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_3_tpl),
        .in_memdep_34_k2_ZTS6c_calc_avm_readdata(in_memdep_34_k2_ZTS6c_calc_avm_readdata),
        .in_memdep_34_k2_ZTS6c_calc_avm_readdatavalid(in_memdep_34_k2_ZTS6c_calc_avm_readdatavalid),
        .in_memdep_34_k2_ZTS6c_calc_avm_waitrequest(in_memdep_34_k2_ZTS6c_calc_avm_waitrequest),
        .in_memdep_34_k2_ZTS6c_calc_avm_writeack(in_memdep_34_k2_ZTS6c_calc_avm_writeack),
        .in_memdep_k2_ZTS6c_calc_avm_readdata(in_memdep_k2_ZTS6c_calc_avm_readdata),
        .in_memdep_k2_ZTS6c_calc_avm_readdatavalid(in_memdep_k2_ZTS6c_calc_avm_readdatavalid),
        .in_memdep_k2_ZTS6c_calc_avm_waitrequest(in_memdep_k2_ZTS6c_calc_avm_waitrequest),
        .in_memdep_k2_ZTS6c_calc_avm_writeack(in_memdep_k2_ZTS6c_calc_avm_writeack),
        .in_stall_in_0(loop_limiter_k2_ZTS6c_calc1_out_o_stall),
        .in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_readdata(in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_readdata),
        .in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_readdatavalid(in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_readdatavalid),
        .in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_waitrequest(in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_waitrequest),
        .in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_writeack(in_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_writeack),
        .in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_readdata(in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_readdata),
        .in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_readdatavalid(in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_readdatavalid),
        .in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_waitrequest(in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_waitrequest),
        .in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_writeack(in_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_writeack),
        .in_valid_in_0(bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_valid),
        .in_valid_in_1(bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_valid),
        .in_arg15_0_tpl(in_arg_arg15_0_tpl),
        .in_arg18_0_tpl(in_arg_arg18_0_tpl),
        .in_arg18_1_tpl(in_arg_arg18_1_tpl),
        .in_arg19_0_tpl(in_arg_arg19_0_tpl),
        .in_arg19_1_tpl(in_arg_arg19_1_tpl),
        .in_arg7_0_tpl(in_arg_arg7_0_tpl),
        .out_acl_0141_i509(bb_ZTS6c_calc_B4_aunroll_x_out_acl_0141_i509),
        .out_acl_0142_i508(bb_ZTS6c_calc_B4_aunroll_x_out_acl_0142_i508),
        .out_acl_0143_i507(bb_ZTS6c_calc_B4_aunroll_x_out_acl_0143_i507),
        .out_acl_global_id_043(bb_ZTS6c_calc_B4_aunroll_x_out_acl_global_id_043),
        .out_acl_global_id_149(bb_ZTS6c_calc_B4_aunroll_x_out_acl_global_id_149),
        .out_acl_hw_wg_id56(bb_ZTS6c_calc_B4_aunroll_x_out_acl_hw_wg_id56),
        .out_c0_exe210(bb_ZTS6c_calc_B4_aunroll_x_out_c0_exe210),
        .out_c0_exe412(bb_ZTS6c_calc_B4_aunroll_x_out_c0_exe412),
        .out_c0_exe517(bb_ZTS6c_calc_B4_aunroll_x_out_c0_exe517),
        .out_c0_exe620(bb_ZTS6c_calc_B4_aunroll_x_out_c0_exe620),
        .out_c0_exe725(bb_ZTS6c_calc_B4_aunroll_x_out_c0_exe725),
        .out_c0_exe828(bb_ZTS6c_calc_B4_aunroll_x_out_c0_exe828),
        .out_l_grpid_05(bb_ZTS6c_calc_B4_aunroll_x_out_l_grpid_05),
        .out_l_grpid_0_ext_offset(bb_ZTS6c_calc_B4_aunroll_x_out_l_grpid_0_ext_offset),
        .out_memdep_34_k2_ZTS6c_calc_avm_address(bb_ZTS6c_calc_B4_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_address),
        .out_memdep_34_k2_ZTS6c_calc_avm_burstcount(bb_ZTS6c_calc_B4_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_burstcount),
        .out_memdep_34_k2_ZTS6c_calc_avm_byteenable(bb_ZTS6c_calc_B4_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_byteenable),
        .out_memdep_34_k2_ZTS6c_calc_avm_enable(bb_ZTS6c_calc_B4_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_enable),
        .out_memdep_34_k2_ZTS6c_calc_avm_read(bb_ZTS6c_calc_B4_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_read),
        .out_memdep_34_k2_ZTS6c_calc_avm_write(bb_ZTS6c_calc_B4_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_write),
        .out_memdep_34_k2_ZTS6c_calc_avm_writedata(bb_ZTS6c_calc_B4_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_writedata),
        .out_memdep_k2_ZTS6c_calc_avm_address(bb_ZTS6c_calc_B4_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_address),
        .out_memdep_k2_ZTS6c_calc_avm_burstcount(bb_ZTS6c_calc_B4_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_burstcount),
        .out_memdep_k2_ZTS6c_calc_avm_byteenable(bb_ZTS6c_calc_B4_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_byteenable),
        .out_memdep_k2_ZTS6c_calc_avm_enable(bb_ZTS6c_calc_B4_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_enable),
        .out_memdep_k2_ZTS6c_calc_avm_read(bb_ZTS6c_calc_B4_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_read),
        .out_memdep_k2_ZTS6c_calc_avm_write(bb_ZTS6c_calc_B4_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_write),
        .out_memdep_k2_ZTS6c_calc_avm_writedata(bb_ZTS6c_calc_B4_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_writedata),
        .out_stall_out_0(bb_ZTS6c_calc_B4_aunroll_x_out_stall_out_0),
        .out_stall_out_1(bb_ZTS6c_calc_B4_aunroll_x_out_stall_out_1),
        .out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_address(bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_address),
        .out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_burstcount(bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_burstcount),
        .out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_byteenable(bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_byteenable),
        .out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_enable(bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_enable),
        .out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_read(bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_read),
        .out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_write(bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_write),
        .out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_writedata(bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_writedata),
        .out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_address(bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_address),
        .out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_burstcount(bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_burstcount),
        .out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_byteenable(bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_byteenable),
        .out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_enable(bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_enable),
        .out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_read(bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_read),
        .out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_write(bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_write),
        .out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_writedata(bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_writedata),
        .out_valid_in_0(bb_ZTS6c_calc_B4_aunroll_x_out_valid_in_0),
        .out_valid_in_1(bb_ZTS6c_calc_B4_aunroll_x_out_valid_in_1),
        .out_valid_out_0(bb_ZTS6c_calc_B4_aunroll_x_out_valid_out_0),
        .clock(clock),
        .resetn(resetn)
    );

    // loop_limiter_k2_ZTS6c_calc0(BLACKBOX,16)
    k2_ZTS6c_calc_loop_limiter_0 theloop_limiter_k2_ZTS6c_calc0 (
        .in_i_stall(bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_stall),
        .in_i_stall_exit(bb_ZTS6c_calc_B2_sr_0_aunroll_x_out_o_stall),
        .in_i_valid(bb_ZTS6c_calc_B1_aunroll_x_out_valid_out_0),
        .in_i_valid_exit(bb_ZTS6c_calc_B5_aunroll_x_out_valid_out_1),
        .out_o_stall(loop_limiter_k2_ZTS6c_calc0_out_o_stall),
        .out_o_valid(loop_limiter_k2_ZTS6c_calc0_out_o_valid),
        .clock(clock),
        .resetn(resetn)
    );

    // bb_ZTS6c_calc_B1_aunroll_x(BLACKBOX,73)
    k2_ZTS6c_calc_bb_ZTS6c_calc_B1 thebb_ZTS6c_calc_B1_aunroll_x (
        .in_acl_global_id_044_0(bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_data_8_tpl),
        .in_acl_global_id_150_0(bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_data_9_tpl),
        .in_acl_group_id_151_0(bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_data_10_tpl),
        .in_acl_hw_wg_id57_0(bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_data_11_tpl),
        .in_arg12(in_arg_arg12),
        .in_arg16(in_arg_arg16),
        .in_arg4(in_arg_arg4),
        .in_c0_exe17_0(bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_data_1_tpl),
        .in_c0_exe211_0(bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_data_2_tpl),
        .in_c0_exe415_0(bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_data_3_tpl),
        .in_c0_exe519_0(bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_data_4_tpl),
        .in_c0_exe623_0(bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_data_5_tpl),
        .in_c0_exe727_0(bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_data_6_tpl),
        .in_c0_exe831_0(bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_data_7_tpl),
        .in_l_grpid_06_0(bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_data_0_tpl),
        .in_stall_in_0(loop_limiter_k2_ZTS6c_calc0_out_o_stall),
        .in_valid_in_0(bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_valid),
        .in_arg15_0_tpl(in_arg_arg15_0_tpl),
        .in_arg18_0_tpl(in_arg_arg18_0_tpl),
        .in_arg18_1_tpl(in_arg_arg18_1_tpl),
        .in_arg19_0_tpl(in_arg_arg19_0_tpl),
        .in_arg19_1_tpl(in_arg_arg19_1_tpl),
        .in_arg7_0_tpl(in_arg_arg7_0_tpl),
        .out_acl_global_id_044(bb_ZTS6c_calc_B1_aunroll_x_out_acl_global_id_044),
        .out_acl_global_id_150(bb_ZTS6c_calc_B1_aunroll_x_out_acl_global_id_150),
        .out_acl_hw_wg_id57(bb_ZTS6c_calc_B1_aunroll_x_out_acl_hw_wg_id57),
        .out_c0_exe17(bb_ZTS6c_calc_B1_aunroll_x_out_c0_exe17),
        .out_c0_exe211(bb_ZTS6c_calc_B1_aunroll_x_out_c0_exe211),
        .out_c0_exe415(bb_ZTS6c_calc_B1_aunroll_x_out_c0_exe415),
        .out_c0_exe519(bb_ZTS6c_calc_B1_aunroll_x_out_c0_exe519),
        .out_c0_exe623(bb_ZTS6c_calc_B1_aunroll_x_out_c0_exe623),
        .out_c0_exe727(bb_ZTS6c_calc_B1_aunroll_x_out_c0_exe727),
        .out_c0_exe831(bb_ZTS6c_calc_B1_aunroll_x_out_c0_exe831),
        .out_l_grpid_06(bb_ZTS6c_calc_B1_aunroll_x_out_l_grpid_06),
        .out_stall_out_0(bb_ZTS6c_calc_B1_aunroll_x_out_stall_out_0),
        .out_unnamed_k2_ZTS6c_calc5(bb_ZTS6c_calc_B1_aunroll_x_out_unnamed_k2_ZTS6c_calc5),
        .out_valid_out_0(bb_ZTS6c_calc_B1_aunroll_x_out_valid_out_0),
        .clock(clock),
        .resetn(resetn)
    );

    // bb_ZTS6c_calc_B1_sr_0_aunroll_x(BLACKBOX,74)
    k2_ZTS6c_calc_bb_ZTS6c_calc_B1_sr_0 thebb_ZTS6c_calc_B1_sr_0_aunroll_x (
        .in_i_stall(bb_ZTS6c_calc_B1_aunroll_x_out_stall_out_0),
        .in_i_valid(bb_ZTS6c_calc_B0_aunroll_x_out_valid_out_0),
        .in_i_data_0_tpl(bb_ZTS6c_calc_B0_aunroll_x_out_l_grpid_0),
        .in_i_data_1_tpl(bb_ZTS6c_calc_B0_aunroll_x_out_c0_exe1),
        .in_i_data_2_tpl(bb_ZTS6c_calc_B0_aunroll_x_out_c0_exe2),
        .in_i_data_3_tpl(bb_ZTS6c_calc_B0_aunroll_x_out_c0_exe4),
        .in_i_data_4_tpl(bb_ZTS6c_calc_B0_aunroll_x_out_c0_exe5),
        .in_i_data_5_tpl(bb_ZTS6c_calc_B0_aunroll_x_out_c0_exe6),
        .in_i_data_6_tpl(bb_ZTS6c_calc_B0_aunroll_x_out_c0_exe7),
        .in_i_data_7_tpl(bb_ZTS6c_calc_B0_aunroll_x_out_c0_exe8),
        .in_i_data_8_tpl(bb_ZTS6c_calc_B0_aunroll_x_out_acl_global_id_0),
        .in_i_data_9_tpl(bb_ZTS6c_calc_B0_aunroll_x_out_acl_global_id_1),
        .in_i_data_10_tpl(bb_ZTS6c_calc_B0_aunroll_x_out_acl_group_id_1),
        .in_i_data_11_tpl(bb_ZTS6c_calc_B0_aunroll_x_out_acl_hw_wg_id),
        .out_o_stall(bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_stall),
        .out_o_valid(bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_valid),
        .out_o_data_0_tpl(bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_data_0_tpl),
        .out_o_data_1_tpl(bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_data_1_tpl),
        .out_o_data_2_tpl(bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_data_2_tpl),
        .out_o_data_3_tpl(bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_data_3_tpl),
        .out_o_data_4_tpl(bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_data_4_tpl),
        .out_o_data_5_tpl(bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_data_5_tpl),
        .out_o_data_6_tpl(bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_data_6_tpl),
        .out_o_data_7_tpl(bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_data_7_tpl),
        .out_o_data_8_tpl(bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_data_8_tpl),
        .out_o_data_9_tpl(bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_data_9_tpl),
        .out_o_data_10_tpl(bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_data_10_tpl),
        .out_o_data_11_tpl(bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_data_11_tpl),
        .clock(clock),
        .resetn(resetn)
    );

    // bb_ZTS6c_calc_B0_aunroll_x(BLACKBOX,72)
    k2_ZTS6c_calc_bb_ZTS6c_calc_B0 thebb_ZTS6c_calc_B0_aunroll_x (
        .in_acl_global_id_0_0(in_arg_acl_global_id_0),
        .in_acl_global_id_1_0(in_arg_acl_global_id_1),
        .in_acl_group_id_0_0(in_arg_acl_group_id_0),
        .in_acl_group_id_1_0(in_arg_acl_group_id_1),
        .in_acl_hw_wg_id_0(in_arg_acl_hw_wg_id),
        .in_acl_local_id_0_0(in_arg_acl_local_id_0),
        .in_acl_local_id_1_0(in_arg_acl_local_id_1),
        .in_arg12(in_arg_arg12),
        .in_arg16(in_arg_arg16),
        .in_arg4(in_arg_arg4),
        .in_stall_in_0(bb_ZTS6c_calc_B1_sr_0_aunroll_x_out_o_stall),
        .in_stall_in_1(bb_ZTS6c_calc_B3_sr_1_aunroll_x_out_o_stall),
        .in_valid_in_0(in_valid_in),
        .in_wgl_0_enter_exit_stall_in(bb_ZTS6c_calc_B3_aunroll_x_out_wgl_0_exit_exit_stall_in),
        .in_wgl_0_enter_exit_valid_in(bb_ZTS6c_calc_B3_aunroll_x_out_wgl_0_exit_exit_valid_in),
        .in_wgl_0_wgs_wg_size(in_workgroup_size),
        .in_arg1_0_tpl(in_arg_arg1_0_tpl),
        .in_arg1_1_tpl(in_arg_arg1_1_tpl),
        .in_arg15_0_tpl(in_arg_arg15_0_tpl),
        .in_arg18_0_tpl(in_arg_arg18_0_tpl),
        .in_arg18_1_tpl(in_arg_arg18_1_tpl),
        .in_arg19_0_tpl(in_arg_arg19_0_tpl),
        .in_arg19_1_tpl(in_arg_arg19_1_tpl),
        .in_arg7_0_tpl(in_arg_arg7_0_tpl),
        .in_arg9_0_tpl(in_arg_arg9_0_tpl),
        .in_arg9_1_tpl(in_arg_arg9_1_tpl),
        .out_acl_global_id_0(bb_ZTS6c_calc_B0_aunroll_x_out_acl_global_id_0),
        .out_acl_global_id_1(bb_ZTS6c_calc_B0_aunroll_x_out_acl_global_id_1),
        .out_acl_group_id_1(bb_ZTS6c_calc_B0_aunroll_x_out_acl_group_id_1),
        .out_acl_hw_wg_id(bb_ZTS6c_calc_B0_aunroll_x_out_acl_hw_wg_id),
        .out_c0_exe1(bb_ZTS6c_calc_B0_aunroll_x_out_c0_exe1),
        .out_c0_exe2(bb_ZTS6c_calc_B0_aunroll_x_out_c0_exe2),
        .out_c0_exe4(bb_ZTS6c_calc_B0_aunroll_x_out_c0_exe4),
        .out_c0_exe5(bb_ZTS6c_calc_B0_aunroll_x_out_c0_exe5),
        .out_c0_exe6(bb_ZTS6c_calc_B0_aunroll_x_out_c0_exe6),
        .out_c0_exe7(bb_ZTS6c_calc_B0_aunroll_x_out_c0_exe7),
        .out_c0_exe8(bb_ZTS6c_calc_B0_aunroll_x_out_c0_exe8),
        .out_l_grpid_0(bb_ZTS6c_calc_B0_aunroll_x_out_l_grpid_0),
        .out_stall_out_0(bb_ZTS6c_calc_B0_aunroll_x_out_stall_out_0),
        .out_valid_out_0(bb_ZTS6c_calc_B0_aunroll_x_out_valid_out_0),
        .out_valid_out_1(bb_ZTS6c_calc_B0_aunroll_x_out_valid_out_1),
        .out_wgl_0_enter_exit_stall_out(bb_ZTS6c_calc_B0_aunroll_x_out_wgl_0_enter_exit_stall_out),
        .out_wgl_0_enter_exit_valid_out(bb_ZTS6c_calc_B0_aunroll_x_out_wgl_0_enter_exit_valid_out),
        .clock(clock),
        .resetn(resetn)
    );

    // c_float_0_000000e_0069(FLOATCONSTANT,4)
    assign c_float_0_000000e_0069_q = $unsigned(32'b00000000000000000000000000000000);

    // bb_ZTS6c_calc_B3_sr_1_aunroll_x(BLACKBOX,79)
    k2_ZTS6c_calc_bb_ZTS6c_calc_B3_sr_1 thebb_ZTS6c_calc_B3_sr_1_aunroll_x (
        .in_i_stall(bb_ZTS6c_calc_B3_aunroll_x_out_stall_out_1),
        .in_i_valid(bb_ZTS6c_calc_B0_aunroll_x_out_valid_out_1),
        .in_i_data_0_tpl(c_float_0_000000e_0069_q),
        .in_i_data_1_tpl(GND_q),
        .in_i_data_2_tpl(VCC_q),
        .in_i_data_3_tpl(bb_ZTS6c_calc_B0_aunroll_x_out_l_grpid_0),
        .in_i_data_4_tpl(bb_ZTS6c_calc_B0_aunroll_x_out_acl_global_id_0),
        .in_i_data_5_tpl(bb_ZTS6c_calc_B0_aunroll_x_out_acl_global_id_1),
        .in_i_data_6_tpl(bb_ZTS6c_calc_B0_aunroll_x_out_acl_hw_wg_id),
        .out_o_stall(bb_ZTS6c_calc_B3_sr_1_aunroll_x_out_o_stall),
        .out_o_valid(bb_ZTS6c_calc_B3_sr_1_aunroll_x_out_o_valid),
        .out_o_data_0_tpl(bb_ZTS6c_calc_B3_sr_1_aunroll_x_out_o_data_0_tpl),
        .out_o_data_1_tpl(bb_ZTS6c_calc_B3_sr_1_aunroll_x_out_o_data_1_tpl),
        .out_o_data_2_tpl(bb_ZTS6c_calc_B3_sr_1_aunroll_x_out_o_data_2_tpl),
        .out_o_data_3_tpl(bb_ZTS6c_calc_B3_sr_1_aunroll_x_out_o_data_3_tpl),
        .out_o_data_4_tpl(bb_ZTS6c_calc_B3_sr_1_aunroll_x_out_o_data_4_tpl),
        .out_o_data_5_tpl(bb_ZTS6c_calc_B3_sr_1_aunroll_x_out_o_data_5_tpl),
        .out_o_data_6_tpl(bb_ZTS6c_calc_B3_sr_1_aunroll_x_out_o_data_6_tpl),
        .clock(clock),
        .resetn(resetn)
    );

    // bb_ZTS6c_calc_B3_aunroll_x(BLACKBOX,77)
    k2_ZTS6c_calc_bb_ZTS6c_calc_B3 thebb_ZTS6c_calc_B3_aunroll_x (
        .in_acl_global_id_039_0(bb_ZTS6c_calc_B3_sr_0_aunroll_x_out_o_data_4_tpl),
        .in_acl_global_id_039_1(bb_ZTS6c_calc_B3_sr_1_aunroll_x_out_o_data_4_tpl),
        .in_acl_global_id_145_0(bb_ZTS6c_calc_B3_sr_0_aunroll_x_out_o_data_5_tpl),
        .in_acl_global_id_145_1(bb_ZTS6c_calc_B3_sr_1_aunroll_x_out_o_data_5_tpl),
        .in_acl_hw_wg_id52_0(bb_ZTS6c_calc_B3_sr_0_aunroll_x_out_o_data_6_tpl),
        .in_acl_hw_wg_id52_1(bb_ZTS6c_calc_B3_sr_1_aunroll_x_out_o_data_6_tpl),
        .in_arg16(in_arg_arg16),
        .in_do_directly_crit_edge_0(bb_ZTS6c_calc_B3_sr_0_aunroll_x_out_o_data_2_tpl),
        .in_do_directly_crit_edge_1(bb_ZTS6c_calc_B3_sr_1_aunroll_x_out_o_data_2_tpl),
        .in_do_directly_crit_edge_loopexit_0(bb_ZTS6c_calc_B3_sr_0_aunroll_x_out_o_data_1_tpl),
        .in_do_directly_crit_edge_loopexit_1(bb_ZTS6c_calc_B3_sr_1_aunroll_x_out_o_data_1_tpl),
        .in_flush(in_start),
        .in_l_grpid_01_0(bb_ZTS6c_calc_B3_sr_0_aunroll_x_out_o_data_3_tpl),
        .in_l_grpid_01_1(bb_ZTS6c_calc_B3_sr_1_aunroll_x_out_o_data_3_tpl),
        .in_lcssa_lcssa_0(bb_ZTS6c_calc_B3_sr_0_aunroll_x_out_o_data_0_tpl),
        .in_lcssa_lcssa_1(bb_ZTS6c_calc_B3_sr_1_aunroll_x_out_o_data_0_tpl),
        .in_stall_in_0(in_stall_in),
        .in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_readdata(in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_readdata),
        .in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_readdatavalid(in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_readdatavalid),
        .in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_waitrequest(in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_waitrequest),
        .in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_writeack(in_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_writeack),
        .in_valid_in_0(bb_ZTS6c_calc_B3_sr_0_aunroll_x_out_o_valid),
        .in_valid_in_1(bb_ZTS6c_calc_B3_sr_1_aunroll_x_out_o_valid),
        .in_wgl_0_exit_exit_stall_out(bb_ZTS6c_calc_B0_aunroll_x_out_wgl_0_enter_exit_stall_out),
        .in_wgl_0_exit_exit_valid_out(bb_ZTS6c_calc_B0_aunroll_x_out_wgl_0_enter_exit_valid_out),
        .in_arg18_0_tpl(in_arg_arg18_0_tpl),
        .in_arg18_1_tpl(in_arg_arg18_1_tpl),
        .in_arg19_0_tpl(in_arg_arg19_0_tpl),
        .in_arg19_1_tpl(in_arg_arg19_1_tpl),
        .out_acl_hw_wg_id52(bb_ZTS6c_calc_B3_aunroll_x_out_acl_hw_wg_id52),
        .out_lsu_unnamed_k2_ZTS6c_calc9_o_active(bb_ZTS6c_calc_B3_aunroll_x_out_lsu_unnamed_k2_ZTS6c_calc9_o_active),
        .out_stall_out_0(bb_ZTS6c_calc_B3_aunroll_x_out_stall_out_0),
        .out_stall_out_1(bb_ZTS6c_calc_B3_aunroll_x_out_stall_out_1),
        .out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_address(bb_ZTS6c_calc_B3_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_address),
        .out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_burstcount(bb_ZTS6c_calc_B3_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_burstcount),
        .out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_byteenable(bb_ZTS6c_calc_B3_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_byteenable),
        .out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_enable(bb_ZTS6c_calc_B3_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_enable),
        .out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_read(bb_ZTS6c_calc_B3_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_read),
        .out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_write(bb_ZTS6c_calc_B3_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_write),
        .out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_writedata(bb_ZTS6c_calc_B3_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_writedata),
        .out_valid_out_0(bb_ZTS6c_calc_B3_aunroll_x_out_valid_out_0),
        .out_wgl_0_exit_exit_stall_in(bb_ZTS6c_calc_B3_aunroll_x_out_wgl_0_exit_exit_stall_in),
        .out_wgl_0_exit_exit_valid_in(bb_ZTS6c_calc_B3_aunroll_x_out_wgl_0_exit_exit_valid_in),
        .clock(clock),
        .resetn(resetn)
    );

    // bb_ZTS6c_calc_B3_sr_0_aunroll_x(BLACKBOX,78)
    k2_ZTS6c_calc_bb_ZTS6c_calc_B3_sr_0 thebb_ZTS6c_calc_B3_sr_0_aunroll_x (
        .in_i_stall(bb_ZTS6c_calc_B3_aunroll_x_out_stall_out_0),
        .in_i_valid(bb_ZTS6c_calc_B2_aunroll_x_out_valid_out_0),
        .in_i_data_0_tpl(bb_ZTS6c_calc_B2_aunroll_x_out_c0_exe15438),
        .in_i_data_1_tpl(VCC_q),
        .in_i_data_2_tpl(GND_q),
        .in_i_data_3_tpl(bb_ZTS6c_calc_B2_aunroll_x_out_l_grpid_02),
        .in_i_data_4_tpl(bb_ZTS6c_calc_B2_aunroll_x_out_acl_global_id_040),
        .in_i_data_5_tpl(bb_ZTS6c_calc_B2_aunroll_x_out_acl_global_id_146),
        .in_i_data_6_tpl(bb_ZTS6c_calc_B2_aunroll_x_out_acl_hw_wg_id53),
        .out_o_stall(bb_ZTS6c_calc_B3_sr_0_aunroll_x_out_o_stall),
        .out_o_valid(bb_ZTS6c_calc_B3_sr_0_aunroll_x_out_o_valid),
        .out_o_data_0_tpl(bb_ZTS6c_calc_B3_sr_0_aunroll_x_out_o_data_0_tpl),
        .out_o_data_1_tpl(bb_ZTS6c_calc_B3_sr_0_aunroll_x_out_o_data_1_tpl),
        .out_o_data_2_tpl(bb_ZTS6c_calc_B3_sr_0_aunroll_x_out_o_data_2_tpl),
        .out_o_data_3_tpl(bb_ZTS6c_calc_B3_sr_0_aunroll_x_out_o_data_3_tpl),
        .out_o_data_4_tpl(bb_ZTS6c_calc_B3_sr_0_aunroll_x_out_o_data_4_tpl),
        .out_o_data_5_tpl(bb_ZTS6c_calc_B3_sr_0_aunroll_x_out_o_data_5_tpl),
        .out_o_data_6_tpl(bb_ZTS6c_calc_B3_sr_0_aunroll_x_out_o_data_6_tpl),
        .clock(clock),
        .resetn(resetn)
    );

    // bb_ZTS6c_calc_B2_aunroll_x(BLACKBOX,75)
    k2_ZTS6c_calc_bb_ZTS6c_calc_B2 thebb_ZTS6c_calc_B2_aunroll_x (
        .in_acl_global_id_040_0(bb_ZTS6c_calc_B2_sr_0_aunroll_x_out_o_data_2_tpl),
        .in_acl_global_id_146_0(bb_ZTS6c_calc_B2_sr_0_aunroll_x_out_o_data_3_tpl),
        .in_acl_hw_wg_id53_0(bb_ZTS6c_calc_B2_sr_0_aunroll_x_out_o_data_4_tpl),
        .in_arg16(in_arg_arg16),
        .in_c0_exe15438_0(bb_ZTS6c_calc_B2_sr_0_aunroll_x_out_o_data_1_tpl),
        .in_l_grpid_02_0(bb_ZTS6c_calc_B2_sr_0_aunroll_x_out_o_data_0_tpl),
        .in_stall_in_0(bb_ZTS6c_calc_B3_sr_0_aunroll_x_out_o_stall),
        .in_valid_in_0(bb_ZTS6c_calc_B2_sr_0_aunroll_x_out_o_valid),
        .in_arg18_0_tpl(in_arg_arg18_0_tpl),
        .in_arg18_1_tpl(in_arg_arg18_1_tpl),
        .in_arg19_0_tpl(in_arg_arg19_0_tpl),
        .in_arg19_1_tpl(in_arg_arg19_1_tpl),
        .out_acl_global_id_040(bb_ZTS6c_calc_B2_aunroll_x_out_acl_global_id_040),
        .out_acl_global_id_146(bb_ZTS6c_calc_B2_aunroll_x_out_acl_global_id_146),
        .out_acl_hw_wg_id53(bb_ZTS6c_calc_B2_aunroll_x_out_acl_hw_wg_id53),
        .out_c0_exe15438(bb_ZTS6c_calc_B2_aunroll_x_out_c0_exe15438),
        .out_l_grpid_02(bb_ZTS6c_calc_B2_aunroll_x_out_l_grpid_02),
        .out_stall_out_0(bb_ZTS6c_calc_B2_aunroll_x_out_stall_out_0),
        .out_valid_out_0(bb_ZTS6c_calc_B2_aunroll_x_out_valid_out_0),
        .clock(clock),
        .resetn(resetn)
    );

    // bb_ZTS6c_calc_B2_sr_0_aunroll_x(BLACKBOX,76)
    k2_ZTS6c_calc_bb_ZTS6c_calc_B2_sr_0 thebb_ZTS6c_calc_B2_sr_0_aunroll_x (
        .in_i_stall(bb_ZTS6c_calc_B2_aunroll_x_out_stall_out_0),
        .in_i_valid(bb_ZTS6c_calc_B5_aunroll_x_out_valid_out_1),
        .in_i_data_0_tpl(bb_ZTS6c_calc_B5_aunroll_x_out_l_grpid_03),
        .in_i_data_1_tpl(bb_ZTS6c_calc_B5_aunroll_x_out_c0_exe15437),
        .in_i_data_2_tpl(bb_ZTS6c_calc_B5_aunroll_x_out_acl_global_id_041),
        .in_i_data_3_tpl(bb_ZTS6c_calc_B5_aunroll_x_out_acl_global_id_147),
        .in_i_data_4_tpl(bb_ZTS6c_calc_B5_aunroll_x_out_acl_hw_wg_id54),
        .out_o_stall(bb_ZTS6c_calc_B2_sr_0_aunroll_x_out_o_stall),
        .out_o_valid(bb_ZTS6c_calc_B2_sr_0_aunroll_x_out_o_valid),
        .out_o_data_0_tpl(bb_ZTS6c_calc_B2_sr_0_aunroll_x_out_o_data_0_tpl),
        .out_o_data_1_tpl(bb_ZTS6c_calc_B2_sr_0_aunroll_x_out_o_data_1_tpl),
        .out_o_data_2_tpl(bb_ZTS6c_calc_B2_sr_0_aunroll_x_out_o_data_2_tpl),
        .out_o_data_3_tpl(bb_ZTS6c_calc_B2_sr_0_aunroll_x_out_o_data_3_tpl),
        .out_o_data_4_tpl(bb_ZTS6c_calc_B2_sr_0_aunroll_x_out_o_data_4_tpl),
        .clock(clock),
        .resetn(resetn)
    );

    // bb_ZTS6c_calc_B5_aunroll_x(BLACKBOX,83)
    k2_ZTS6c_calc_bb_ZTS6c_calc_B5 thebb_ZTS6c_calc_B5_aunroll_x (
        .in_acl_0141_i50932_0(bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_7_tpl),
        .in_acl_0142_i50834_0(bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_8_tpl),
        .in_acl_global_id_041_0(bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_10_tpl),
        .in_acl_global_id_147_0(bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_11_tpl),
        .in_acl_hw_wg_id54_0(bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_12_tpl),
        .in_arg12(in_arg_arg12),
        .in_arg16(in_arg_arg16),
        .in_arg4(in_arg_arg4),
        .in_barrier_unnamed_k2_ZTS6c_calc22_wgs_workgroup_size(in_workgroup_size),
        .in_c0_exe15437_0(bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_9_tpl),
        .in_c0_exe28_0(bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_1_tpl),
        .in_c0_exe413_0(bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_2_tpl),
        .in_c0_exe518_0(bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_3_tpl),
        .in_c0_exe621_0(bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_4_tpl),
        .in_c0_exe726_0(bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_5_tpl),
        .in_c0_exe829_0(bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_6_tpl),
        .in_l_grpid_03_0(bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_data_0_tpl),
        .in_stall_in_0(bb_ZTS6c_calc_B4_sr_0_aunroll_x_out_o_stall),
        .in_stall_in_1(bb_ZTS6c_calc_B2_sr_0_aunroll_x_out_o_stall),
        .in_valid_in_0(bb_ZTS6c_calc_B5_sr_0_aunroll_x_out_o_valid),
        .in_arg15_0_tpl(in_arg_arg15_0_tpl),
        .in_arg18_0_tpl(in_arg_arg18_0_tpl),
        .in_arg18_1_tpl(in_arg_arg18_1_tpl),
        .in_arg19_0_tpl(in_arg_arg19_0_tpl),
        .in_arg19_1_tpl(in_arg_arg19_1_tpl),
        .in_arg7_0_tpl(in_arg_arg7_0_tpl),
        .out_acl_global_id_041(bb_ZTS6c_calc_B5_aunroll_x_out_acl_global_id_041),
        .out_acl_global_id_147(bb_ZTS6c_calc_B5_aunroll_x_out_acl_global_id_147),
        .out_acl_hw_wg_id54(bb_ZTS6c_calc_B5_aunroll_x_out_acl_hw_wg_id54),
        .out_c0_exe15437(bb_ZTS6c_calc_B5_aunroll_x_out_c0_exe15437),
        .out_c0_exe28(bb_ZTS6c_calc_B5_aunroll_x_out_c0_exe28),
        .out_c0_exe413(bb_ZTS6c_calc_B5_aunroll_x_out_c0_exe413),
        .out_c0_exe518(bb_ZTS6c_calc_B5_aunroll_x_out_c0_exe518),
        .out_c0_exe621(bb_ZTS6c_calc_B5_aunroll_x_out_c0_exe621),
        .out_c0_exe726(bb_ZTS6c_calc_B5_aunroll_x_out_c0_exe726),
        .out_c0_exe829(bb_ZTS6c_calc_B5_aunroll_x_out_c0_exe829),
        .out_l_grpid_03(bb_ZTS6c_calc_B5_aunroll_x_out_l_grpid_03),
        .out_stall_in_0(bb_ZTS6c_calc_B5_aunroll_x_out_stall_in_0),
        .out_stall_out_0(bb_ZTS6c_calc_B5_aunroll_x_out_stall_out_0),
        .out_unnamed_k2_ZTS6c_calc19(bb_ZTS6c_calc_B5_aunroll_x_out_unnamed_k2_ZTS6c_calc19),
        .out_unnamed_k2_ZTS6c_calc20(bb_ZTS6c_calc_B5_aunroll_x_out_unnamed_k2_ZTS6c_calc20),
        .out_valid_out_0(bb_ZTS6c_calc_B5_aunroll_x_out_valid_out_0),
        .out_valid_out_1(bb_ZTS6c_calc_B5_aunroll_x_out_valid_out_1),
        .clock(clock),
        .resetn(resetn)
    );

    // bb_ZTS6c_calc_B4_sr_1_aunroll_x(BLACKBOX,82)
    k2_ZTS6c_calc_bb_ZTS6c_calc_B4_sr_1 thebb_ZTS6c_calc_B4_sr_1_aunroll_x (
        .in_i_stall(bb_ZTS6c_calc_B4_aunroll_x_out_stall_out_1),
        .in_i_valid(loop_limiter_k2_ZTS6c_calc0_out_o_valid),
        .in_i_data_0_tpl(bb_ZTS6c_calc_B1_aunroll_x_out_unnamed_k2_ZTS6c_calc5),
        .in_i_data_1_tpl(bb_ZTS6c_calc_B1_aunroll_x_out_c0_exe17),
        .in_i_data_2_tpl(c_float_0_000000e_0069_q),
        .in_i_data_3_tpl(bb_ZTS6c_calc_B1_aunroll_x_out_l_grpid_06),
        .in_i_data_4_tpl(bb_ZTS6c_calc_B1_aunroll_x_out_c0_exe211),
        .in_i_data_5_tpl(bb_ZTS6c_calc_B1_aunroll_x_out_c0_exe415),
        .in_i_data_6_tpl(bb_ZTS6c_calc_B1_aunroll_x_out_c0_exe519),
        .in_i_data_7_tpl(bb_ZTS6c_calc_B1_aunroll_x_out_c0_exe623),
        .in_i_data_8_tpl(bb_ZTS6c_calc_B1_aunroll_x_out_c0_exe727),
        .in_i_data_9_tpl(bb_ZTS6c_calc_B1_aunroll_x_out_c0_exe831),
        .in_i_data_10_tpl(bb_ZTS6c_calc_B1_aunroll_x_out_acl_global_id_044),
        .in_i_data_11_tpl(bb_ZTS6c_calc_B1_aunroll_x_out_acl_global_id_150),
        .in_i_data_12_tpl(bb_ZTS6c_calc_B1_aunroll_x_out_acl_hw_wg_id57),
        .out_o_stall(bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_stall),
        .out_o_valid(bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_valid),
        .out_o_data_0_tpl(bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_0_tpl),
        .out_o_data_1_tpl(bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_1_tpl),
        .out_o_data_2_tpl(bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_2_tpl),
        .out_o_data_3_tpl(bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_3_tpl),
        .out_o_data_4_tpl(bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_4_tpl),
        .out_o_data_5_tpl(bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_5_tpl),
        .out_o_data_6_tpl(bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_6_tpl),
        .out_o_data_7_tpl(bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_7_tpl),
        .out_o_data_8_tpl(bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_8_tpl),
        .out_o_data_9_tpl(bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_9_tpl),
        .out_o_data_10_tpl(bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_10_tpl),
        .out_o_data_11_tpl(bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_11_tpl),
        .out_o_data_12_tpl(bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_data_12_tpl),
        .clock(clock),
        .resetn(resetn)
    );

    // VCC(CONSTANT,1)
    assign VCC_q = $unsigned(1'b1);

    // GND(CONSTANT,0)
    assign GND_q = $unsigned(1'b0);

    // c_calc_B4_x(EXTIFACE,2)
    assign c_calc_B4_x_i_capture = GND_q;
    assign c_calc_B4_x_i_clear = GND_q;
    assign c_calc_B4_x_i_enable = VCC_q;
    assign c_calc_B4_x_i_shift = GND_q;
    assign c_calc_B4_x_i_stall_pred = bb_ZTS6c_calc_B4_sr_1_aunroll_x_out_o_stall;
    assign c_calc_B4_x_i_stall_succ = bb_ZTS6c_calc_B5_aunroll_x_out_stall_in_0;
    assign c_calc_B4_x_i_valid_loop = bb_ZTS6c_calc_B4_aunroll_x_out_valid_in_0;
    assign c_calc_B4_x_i_valid_pred = bb_ZTS6c_calc_B4_aunroll_x_out_valid_in_1;
    assign c_calc_B4_x_i_valid_succ = bb_ZTS6c_calc_B5_aunroll_x_out_valid_out_0;
    assign c_calc_B4_x_i_capture_bitsignaltemp = c_calc_B4_x_i_capture[0];
    assign c_calc_B4_x_i_clear_bitsignaltemp = c_calc_B4_x_i_clear[0];
    assign c_calc_B4_x_i_enable_bitsignaltemp = c_calc_B4_x_i_enable[0];
    assign c_calc_B4_x_i_shift_bitsignaltemp = c_calc_B4_x_i_shift[0];
    assign c_calc_B4_x_i_stall_pred_bitsignaltemp = c_calc_B4_x_i_stall_pred[0];
    assign c_calc_B4_x_i_stall_succ_bitsignaltemp = c_calc_B4_x_i_stall_succ[0];
    assign c_calc_B4_x_i_valid_loop_bitsignaltemp = c_calc_B4_x_i_valid_loop[0];
    assign c_calc_B4_x_i_valid_pred_bitsignaltemp = c_calc_B4_x_i_valid_pred[0];
    assign c_calc_B4_x_i_valid_succ_bitsignaltemp = c_calc_B4_x_i_valid_succ[0];
    hld_loop_profiler #(
        .LOOP_NAME("c_calc.B4")
    ) thec_calc_B4_x (
        .i_capture(c_calc_B4_x_i_capture_bitsignaltemp),
        .i_clear(c_calc_B4_x_i_clear_bitsignaltemp),
        .i_enable(c_calc_B4_x_i_enable_bitsignaltemp),
        .i_shift(c_calc_B4_x_i_shift_bitsignaltemp),
        .i_stall_pred(c_calc_B4_x_i_stall_pred_bitsignaltemp),
        .i_stall_succ(c_calc_B4_x_i_stall_succ_bitsignaltemp),
        .i_valid_loop(c_calc_B4_x_i_valid_loop_bitsignaltemp),
        .i_valid_pred(c_calc_B4_x_i_valid_pred_bitsignaltemp),
        .i_valid_succ(c_calc_B4_x_i_valid_succ_bitsignaltemp),
        .clock(clock),
        .resetn(resetn)
    );

    // c_calc_B6_x(EXTIFACE,3)
    assign c_calc_B6_x_i_capture = GND_q;
    assign c_calc_B6_x_i_clear = GND_q;
    assign c_calc_B6_x_i_enable = VCC_q;
    assign c_calc_B6_x_i_shift = GND_q;
    assign c_calc_B6_x_i_stall_pred = bb_ZTS6c_calc_B6_sr_1_aunroll_x_out_o_stall;
    assign c_calc_B6_x_i_stall_succ = bb_ZTS6c_calc_B6_aunroll_x_out_stall_in_0;
    assign c_calc_B6_x_i_valid_loop = bb_ZTS6c_calc_B6_aunroll_x_out_valid_in_0;
    assign c_calc_B6_x_i_valid_pred = bb_ZTS6c_calc_B6_aunroll_x_out_valid_in_1;
    assign c_calc_B6_x_i_valid_succ = bb_ZTS6c_calc_B6_aunroll_x_out_valid_out_0;
    assign c_calc_B6_x_i_capture_bitsignaltemp = c_calc_B6_x_i_capture[0];
    assign c_calc_B6_x_i_clear_bitsignaltemp = c_calc_B6_x_i_clear[0];
    assign c_calc_B6_x_i_enable_bitsignaltemp = c_calc_B6_x_i_enable[0];
    assign c_calc_B6_x_i_shift_bitsignaltemp = c_calc_B6_x_i_shift[0];
    assign c_calc_B6_x_i_stall_pred_bitsignaltemp = c_calc_B6_x_i_stall_pred[0];
    assign c_calc_B6_x_i_stall_succ_bitsignaltemp = c_calc_B6_x_i_stall_succ[0];
    assign c_calc_B6_x_i_valid_loop_bitsignaltemp = c_calc_B6_x_i_valid_loop[0];
    assign c_calc_B6_x_i_valid_pred_bitsignaltemp = c_calc_B6_x_i_valid_pred[0];
    assign c_calc_B6_x_i_valid_succ_bitsignaltemp = c_calc_B6_x_i_valid_succ[0];
    hld_loop_profiler #(
        .LOOP_NAME("c_calc.B6")
    ) thec_calc_B6_x (
        .i_capture(c_calc_B6_x_i_capture_bitsignaltemp),
        .i_clear(c_calc_B6_x_i_clear_bitsignaltemp),
        .i_enable(c_calc_B6_x_i_enable_bitsignaltemp),
        .i_shift(c_calc_B6_x_i_shift_bitsignaltemp),
        .i_stall_pred(c_calc_B6_x_i_stall_pred_bitsignaltemp),
        .i_stall_succ(c_calc_B6_x_i_stall_succ_bitsignaltemp),
        .i_valid_loop(c_calc_B6_x_i_valid_loop_bitsignaltemp),
        .i_valid_pred(c_calc_B6_x_i_valid_pred_bitsignaltemp),
        .i_valid_succ(c_calc_B6_x_i_valid_succ_bitsignaltemp),
        .clock(clock),
        .resetn(resetn)
    );

    // out_acl_hw_wg_id52(GPOUT,18)
    assign out_acl_hw_wg_id52 = bb_ZTS6c_calc_B3_aunroll_x_out_acl_hw_wg_id52;

    // out_memdep_34_k2_ZTS6c_calc_avm_address(GPOUT,19)
    assign out_memdep_34_k2_ZTS6c_calc_avm_address = bb_ZTS6c_calc_B4_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_address;

    // out_memdep_34_k2_ZTS6c_calc_avm_burstcount(GPOUT,20)
    assign out_memdep_34_k2_ZTS6c_calc_avm_burstcount = bb_ZTS6c_calc_B4_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_burstcount;

    // out_memdep_34_k2_ZTS6c_calc_avm_byteenable(GPOUT,21)
    assign out_memdep_34_k2_ZTS6c_calc_avm_byteenable = bb_ZTS6c_calc_B4_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_byteenable;

    // out_memdep_34_k2_ZTS6c_calc_avm_enable(GPOUT,22)
    assign out_memdep_34_k2_ZTS6c_calc_avm_enable = bb_ZTS6c_calc_B4_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_enable;

    // out_memdep_34_k2_ZTS6c_calc_avm_read(GPOUT,23)
    assign out_memdep_34_k2_ZTS6c_calc_avm_read = bb_ZTS6c_calc_B4_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_read;

    // out_memdep_34_k2_ZTS6c_calc_avm_write(GPOUT,24)
    assign out_memdep_34_k2_ZTS6c_calc_avm_write = bb_ZTS6c_calc_B4_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_write;

    // out_memdep_34_k2_ZTS6c_calc_avm_writedata(GPOUT,25)
    assign out_memdep_34_k2_ZTS6c_calc_avm_writedata = bb_ZTS6c_calc_B4_aunroll_x_out_memdep_34_k2_ZTS6c_calc_avm_writedata;

    // out_memdep_k2_ZTS6c_calc_avm_address(GPOUT,26)
    assign out_memdep_k2_ZTS6c_calc_avm_address = bb_ZTS6c_calc_B4_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_address;

    // out_memdep_k2_ZTS6c_calc_avm_burstcount(GPOUT,27)
    assign out_memdep_k2_ZTS6c_calc_avm_burstcount = bb_ZTS6c_calc_B4_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_burstcount;

    // out_memdep_k2_ZTS6c_calc_avm_byteenable(GPOUT,28)
    assign out_memdep_k2_ZTS6c_calc_avm_byteenable = bb_ZTS6c_calc_B4_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_byteenable;

    // out_memdep_k2_ZTS6c_calc_avm_enable(GPOUT,29)
    assign out_memdep_k2_ZTS6c_calc_avm_enable = bb_ZTS6c_calc_B4_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_enable;

    // out_memdep_k2_ZTS6c_calc_avm_read(GPOUT,30)
    assign out_memdep_k2_ZTS6c_calc_avm_read = bb_ZTS6c_calc_B4_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_read;

    // out_memdep_k2_ZTS6c_calc_avm_write(GPOUT,31)
    assign out_memdep_k2_ZTS6c_calc_avm_write = bb_ZTS6c_calc_B4_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_write;

    // out_memdep_k2_ZTS6c_calc_avm_writedata(GPOUT,32)
    assign out_memdep_k2_ZTS6c_calc_avm_writedata = bb_ZTS6c_calc_B4_aunroll_x_out_memdep_k2_ZTS6c_calc_avm_writedata;

    // out_o_active_unnamed_k2_ZTS6c_calc9(GPOUT,33)
    assign out_o_active_unnamed_k2_ZTS6c_calc9 = bb_ZTS6c_calc_B3_aunroll_x_out_lsu_unnamed_k2_ZTS6c_calc9_o_active;

    // out_primWireOut(GPOUT,34)
    assign out_primWireOut = {32'b00000000000000000000000000000000, c_i32_0101_q};

    // out_stall_out(GPOUT,35)
    assign out_stall_out = bb_ZTS6c_calc_B0_aunroll_x_out_stall_out_0;

    // out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_address(GPOUT,36)
    assign out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_address = bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_address;

    // out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_burstcount(GPOUT,37)
    assign out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_burstcount = bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_burstcount;

    // out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_byteenable(GPOUT,38)
    assign out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_byteenable = bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_byteenable;

    // out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_enable(GPOUT,39)
    assign out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_enable = bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_enable;

    // out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_read(GPOUT,40)
    assign out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_read = bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_read;

    // out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_write(GPOUT,41)
    assign out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_write = bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_write;

    // out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_writedata(GPOUT,42)
    assign out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_writedata = bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc13_k2_ZTS6c_calc_avm_writedata;

    // out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_address(GPOUT,43)
    assign out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_address = bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_address;

    // out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_burstcount(GPOUT,44)
    assign out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_burstcount = bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_burstcount;

    // out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_byteenable(GPOUT,45)
    assign out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_byteenable = bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_byteenable;

    // out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_enable(GPOUT,46)
    assign out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_enable = bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_enable;

    // out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_read(GPOUT,47)
    assign out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_read = bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_read;

    // out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_write(GPOUT,48)
    assign out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_write = bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_write;

    // out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_writedata(GPOUT,49)
    assign out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_writedata = bb_ZTS6c_calc_B4_aunroll_x_out_unnamed_k2_ZTS6c_calc17_k2_ZTS6c_calc_avm_writedata;

    // out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_address(GPOUT,50)
    assign out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_address = bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_address;

    // out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_burstcount(GPOUT,51)
    assign out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_burstcount = bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_burstcount;

    // out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_byteenable(GPOUT,52)
    assign out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_byteenable = bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_byteenable;

    // out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_enable(GPOUT,53)
    assign out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_enable = bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_enable;

    // out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_read(GPOUT,54)
    assign out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_read = bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_read;

    // out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_write(GPOUT,55)
    assign out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_write = bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_write;

    // out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writedata(GPOUT,56)
    assign out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writedata = bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writedata;

    // out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_address(GPOUT,57)
    assign out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_address = bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_address;

    // out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_burstcount(GPOUT,58)
    assign out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_burstcount = bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_burstcount;

    // out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_byteenable(GPOUT,59)
    assign out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_byteenable = bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_byteenable;

    // out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_enable(GPOUT,60)
    assign out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_enable = bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_enable;

    // out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_read(GPOUT,61)
    assign out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_read = bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_read;

    // out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_write(GPOUT,62)
    assign out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_write = bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_write;

    // out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writedata(GPOUT,63)
    assign out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writedata = bb_ZTS6c_calc_B6_aunroll_x_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writedata;

    // out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_address(GPOUT,64)
    assign out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_address = bb_ZTS6c_calc_B3_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_address;

    // out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_burstcount(GPOUT,65)
    assign out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_burstcount = bb_ZTS6c_calc_B3_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_burstcount;

    // out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_byteenable(GPOUT,66)
    assign out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_byteenable = bb_ZTS6c_calc_B3_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_byteenable;

    // out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_enable(GPOUT,67)
    assign out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_enable = bb_ZTS6c_calc_B3_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_enable;

    // out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_read(GPOUT,68)
    assign out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_read = bb_ZTS6c_calc_B3_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_read;

    // out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_write(GPOUT,69)
    assign out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_write = bb_ZTS6c_calc_B3_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_write;

    // out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_writedata(GPOUT,70)
    assign out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_writedata = bb_ZTS6c_calc_B3_aunroll_x_out_unnamed_k2_ZTS6c_calc9_k2_ZTS6c_calc_avm_writedata;

    // out_valid_out(GPOUT,71)
    assign out_valid_out = bb_ZTS6c_calc_B3_aunroll_x_out_valid_out_0;

endmodule
