// ------------------------------------------------------------------------- 
// High Level Design Compiler for Intel(R) FPGAs Version 20.3 (Release Build #121)
// 
// Legal Notice: Copyright 2020 Intel Corporation.  All rights reserved.
// Your use of  Intel Corporation's design tools,  logic functions and other
// software and  tools, and its AMPP partner logic functions, and any output
// files any  of the foregoing (including  device programming  or simulation
// files), and  any associated  documentation  or information  are expressly
// subject  to the terms and  conditions of the  Intel FPGA Software License
// Agreement, Intel MegaCore Function License Agreement, or other applicable
// license agreement,  including,  without limitation,  that your use is for
// the  sole  purpose of  programming  logic devices  manufactured by  Intel
// and  sold by Intel  or its authorized  distributors. Please refer  to the
// applicable agreement for further details.
// ---------------------------------------------------------------------------

// SystemVerilog created from k2_ZTS6c_calc_i_sfc_logic_s_c0_in_crit_e0000r4658_k2_zts6c_calc0
// SystemVerilog created on Thu Nov  5 06:32:57 2020


(* altera_attribute = "-name AUTO_SHIFT_REGISTER_RECOGNITION OFF; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 10037; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 15400; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 12020; -name MESSAGE_DISABLE 12030; -name MESSAGE_DISABLE 12010; -name MESSAGE_DISABLE 12110; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 13410; -name MESSAGE_DISABLE 113007; -name MESSAGE_DISABLE 10958" *)
module k2_ZTS6c_calc_i_sfc_logic_s_c0_in_crit_e0000r4658_k2_zts6c_calc0 (
    input wire [31:0] in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_readdata,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writeack,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_waitrequest,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_readdatavalid,
    output wire [31:0] out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_address,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_enable,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_read,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_write,
    output wire [31:0] out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writedata,
    output wire [3:0] out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_byteenable,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_burstcount,
    input wire [0:0] in_flush,
    input wire [31:0] in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_readdata,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writeack,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_waitrequest,
    input wire [0:0] in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_readdatavalid,
    output wire [31:0] out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_address,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_enable,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_read,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_write,
    output wire [31:0] out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writedata,
    output wire [3:0] out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_byteenable,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_burstcount,
    output wire [0:0] out_c0_exi352_0_tpl,
    output wire [31:0] out_c0_exi352_1_tpl,
    output wire [31:0] out_c0_exi352_2_tpl,
    output wire [0:0] out_c0_exi352_3_tpl,
    output wire [0:0] out_o_valid,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc4,
    input wire [0:0] in_c0_eni5_0_tpl,
    input wire [31:0] in_c0_eni5_1_tpl,
    input wire [63:0] in_c0_eni5_2_tpl,
    input wire [63:0] in_c0_eni5_3_tpl,
    input wire [63:0] in_c0_eni5_4_tpl,
    input wire [31:0] in_c0_eni5_5_tpl,
    input wire [0:0] in_i_valid,
    input wire clock,
    input wire resetn
    );

    wire [0:0] GND_q;
    wire [0:0] VCC_q;
    wire [63:0] c_arg0_q;
    wire [63:0] c_arg8_q;
    wire [31:0] c_i32_115_q;
    wire [31:0] c_i32_1616_q;
    wire [31:0] i_llvm_fpga_fp_multadd_mult_add_k2_zts6c_calc9_out_primWireOut;
    wire [31:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc25_k2_zts6c_calc5_out_o_readdata;
    wire [31:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc25_k2_zts6c_calc5_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_address;
    wire [0:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc25_k2_zts6c_calc5_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_burstcount;
    wire [3:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc25_k2_zts6c_calc5_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_byteenable;
    wire [0:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc25_k2_zts6c_calc5_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_enable;
    wire [0:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc25_k2_zts6c_calc5_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_read;
    wire [0:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc25_k2_zts6c_calc5_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_write;
    wire [31:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc25_k2_zts6c_calc5_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writedata;
    wire [31:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc28_k2_zts6c_calc8_out_o_readdata;
    wire [31:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc28_k2_zts6c_calc8_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_address;
    wire [0:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc28_k2_zts6c_calc8_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_burstcount;
    wire [3:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc28_k2_zts6c_calc8_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_byteenable;
    wire [0:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc28_k2_zts6c_calc8_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_enable;
    wire [0:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc28_k2_zts6c_calc8_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_read;
    wire [0:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc28_k2_zts6c_calc8_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_write;
    wire [31:0] i_llvm_fpga_mem_unnamed_k2_zts6c_calc28_k2_zts6c_calc8_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writedata;
    wire [32:0] i_unnamed_k2_zts6c_calc10_a;
    wire [32:0] i_unnamed_k2_zts6c_calc10_b;
    logic [32:0] i_unnamed_k2_zts6c_calc10_o;
    wire [32:0] i_unnamed_k2_zts6c_calc10_q;
    wire [33:0] i_unnamed_k2_zts6c_calc11_a;
    wire [33:0] i_unnamed_k2_zts6c_calc11_b;
    logic [33:0] i_unnamed_k2_zts6c_calc11_o;
    wire [0:0] i_unnamed_k2_zts6c_calc11_c;
    wire [31:0] i_unnamed_k2_zts6c_calc2_vt_const_63_q;
    wire [63:0] i_unnamed_k2_zts6c_calc2_vt_join_q;
    wire [31:0] i_unnamed_k2_zts6c_calc2_vt_select_31_b;
    wire [64:0] i_unnamed_k2_zts6c_calc3_a;
    wire [64:0] i_unnamed_k2_zts6c_calc3_b;
    logic [64:0] i_unnamed_k2_zts6c_calc3_o;
    wire [64:0] i_unnamed_k2_zts6c_calc3_q;
    wire [1:0] i_unnamed_k2_zts6c_calc4_vt_const_1_q;
    wire [63:0] i_unnamed_k2_zts6c_calc4_vt_join_q;
    wire [61:0] i_unnamed_k2_zts6c_calc4_vt_select_63_b;
    wire [64:0] i_unnamed_k2_zts6c_calc6_a;
    wire [64:0] i_unnamed_k2_zts6c_calc6_b;
    logic [64:0] i_unnamed_k2_zts6c_calc6_o;
    wire [64:0] i_unnamed_k2_zts6c_calc6_q;
    wire [63:0] i_unnamed_k2_zts6c_calc7_vt_join_q;
    wire [61:0] i_unnamed_k2_zts6c_calc7_vt_select_63_b;
    wire [31:0] bgTrunc_i_unnamed_k2_zts6c_calc10_sel_x_b;
    wire [63:0] bgTrunc_i_unnamed_k2_zts6c_calc3_sel_x_b;
    wire [63:0] bgTrunc_i_unnamed_k2_zts6c_calc6_sel_x_b;
    wire [63:0] i_unnamed_k2_zts6c_calc2_sel_x_b;
    wire [14:0] dupName_9_i_unnamed_k2_zts6c_calc0_add_x_a;
    wire [14:0] dupName_9_i_unnamed_k2_zts6c_calc0_add_x_b;
    logic [14:0] dupName_9_i_unnamed_k2_zts6c_calc0_add_x_o;
    wire [14:0] dupName_9_i_unnamed_k2_zts6c_calc0_add_x_q;
    wire [63:0] dupName_9_i_unnamed_k2_zts6c_calc0_append_upper_bits_x_q;
    wire [11:0] dupName_9_i_unnamed_k2_zts6c_calc0_narrow_x_b;
    wire [13:0] dupName_9_i_unnamed_k2_zts6c_calc0_shift_join_x_q;
    wire [13:0] dupName_9_i_unnamed_k2_zts6c_calc0_dupName_0_trunc_sel_x_b;
    wire [13:0] dupName_9_i_unnamed_k2_zts6c_calc0_dupName_2_trunc_sel_x_b;
    wire [14:0] dupName_10_i_unnamed_k2_zts6c_calc0_add_x_a;
    wire [14:0] dupName_10_i_unnamed_k2_zts6c_calc0_add_x_b;
    logic [14:0] dupName_10_i_unnamed_k2_zts6c_calc0_add_x_o;
    wire [14:0] dupName_10_i_unnamed_k2_zts6c_calc0_add_x_q;
    wire [63:0] dupName_10_i_unnamed_k2_zts6c_calc0_append_upper_bits_x_q;
    wire [11:0] dupName_10_i_unnamed_k2_zts6c_calc0_narrow_x_b;
    wire [13:0] dupName_10_i_unnamed_k2_zts6c_calc0_shift_join_x_q;
    wire [13:0] dupName_10_i_unnamed_k2_zts6c_calc0_dupName_0_trunc_sel_x_b;
    wire [13:0] dupName_10_i_unnamed_k2_zts6c_calc0_dupName_2_trunc_sel_x_b;
    (* dont_merge *) reg [0:0] valid_fanout_reg0_q;
    (* dont_merge *) reg [0:0] valid_fanout_reg1_q;
    (* dont_merge *) reg [0:0] valid_fanout_reg2_q;
    wire [49:0] dupName_9_i_unnamed_k2_zts6c_calc0_upper_bits_x_merged_bit_select_b;
    wire [13:0] dupName_9_i_unnamed_k2_zts6c_calc0_upper_bits_x_merged_bit_select_c;
    wire [49:0] dupName_10_i_unnamed_k2_zts6c_calc0_upper_bits_x_merged_bit_select_b;
    wire [13:0] dupName_10_i_unnamed_k2_zts6c_calc0_upper_bits_x_merged_bit_select_c;
    reg [11:0] redist0_dupName_10_i_unnamed_k2_zts6c_calc0_narrow_x_b_1_q;
    reg [11:0] redist1_dupName_9_i_unnamed_k2_zts6c_calc0_narrow_x_b_1_q;
    reg [63:0] redist3_sync_together21_aunroll_x_in_c0_eni5_3_tpl_1_q;
    reg [0:0] redist5_sync_together21_aunroll_x_in_i_valid_8_q;
    reg [31:0] redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_outputreg0_q;
    wire redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_mem_reset0;
    wire [31:0] redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_mem_ia;
    wire [2:0] redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_mem_aa;
    wire [2:0] redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_mem_ab;
    wire [31:0] redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_mem_iq;
    wire [31:0] redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_mem_q;
    wire [2:0] redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_rdcnt_q;
    (* preserve *) reg [2:0] redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_rdcnt_i;
    (* preserve *) reg redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_rdcnt_eq;
    reg [2:0] redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_wraddr_q;
    wire [3:0] redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_mem_last_q;
    wire [3:0] redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_cmp_b;
    wire [0:0] redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_cmp_q;
    (* dont_merge *) reg [0:0] redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_cmpReg_q;
    wire [0:0] redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_notEnable_q;
    wire [0:0] redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_nor_q;
    (* dont_merge *) reg [0:0] redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_sticky_ena_q;
    wire [0:0] redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_enaAnd_q;
    reg [31:0] redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_outputreg0_q;
    wire redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_mem_reset0;
    wire [31:0] redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_mem_ia;
    wire [1:0] redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_mem_aa;
    wire [1:0] redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_mem_ab;
    wire [31:0] redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_mem_iq;
    wire [31:0] redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_mem_q;
    wire [1:0] redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_rdcnt_q;
    (* preserve *) reg [1:0] redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_rdcnt_i;
    (* preserve *) reg redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_rdcnt_eq;
    reg [1:0] redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_wraddr_q;
    wire [1:0] redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_mem_last_q;
    wire [0:0] redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_cmp_q;
    (* dont_merge *) reg [0:0] redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_cmpReg_q;
    wire [0:0] redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_notEnable_q;
    wire [0:0] redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_nor_q;
    (* dont_merge *) reg [0:0] redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_sticky_ena_q;
    wire [0:0] redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_enaAnd_q;


    // VCC(CONSTANT,1)
    assign VCC_q = $unsigned(1'b1);

    // valid_fanout_reg1(REG,65)@1 + 1
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            valid_fanout_reg1_q <= $unsigned(1'b0);
        end
        else
        begin
            valid_fanout_reg1_q <= $unsigned(in_i_valid);
        end
    end

    // GND(CONSTANT,0)
    assign GND_q = $unsigned(1'b0);

    // c_arg0(CONSTANT,5)
    assign c_arg0_q = $unsigned(64'b0100000001000000000000000000000000000000000000000000000000000000);

    // dupName_9_i_unnamed_k2_zts6c_calc0_upper_bits_x_merged_bit_select(BITSELECT,71)@2
    assign dupName_9_i_unnamed_k2_zts6c_calc0_upper_bits_x_merged_bit_select_b = c_arg0_q[63:14];
    assign dupName_9_i_unnamed_k2_zts6c_calc0_upper_bits_x_merged_bit_select_c = c_arg0_q[13:0];

    // i_unnamed_k2_zts6c_calc2_vt_const_63(CONSTANT,19)
    assign i_unnamed_k2_zts6c_calc2_vt_const_63_q = $unsigned(32'b00000000000000000000000000000000);

    // i_unnamed_k2_zts6c_calc2_sel_x(BITSELECT,37)@1
    assign i_unnamed_k2_zts6c_calc2_sel_x_b = {32'b00000000000000000000000000000000, in_c0_eni5_1_tpl[31:0]};

    // i_unnamed_k2_zts6c_calc2_vt_select_31(BITSELECT,21)@1
    assign i_unnamed_k2_zts6c_calc2_vt_select_31_b = i_unnamed_k2_zts6c_calc2_sel_x_b[31:0];

    // i_unnamed_k2_zts6c_calc2_vt_join(BITJOIN,20)@1
    assign i_unnamed_k2_zts6c_calc2_vt_join_q = {i_unnamed_k2_zts6c_calc2_vt_const_63_q, i_unnamed_k2_zts6c_calc2_vt_select_31_b};

    // i_unnamed_k2_zts6c_calc3(ADD,22)@1
    assign i_unnamed_k2_zts6c_calc3_a = {1'b0, in_c0_eni5_2_tpl};
    assign i_unnamed_k2_zts6c_calc3_b = {1'b0, i_unnamed_k2_zts6c_calc2_vt_join_q};
    assign i_unnamed_k2_zts6c_calc3_o = $unsigned(i_unnamed_k2_zts6c_calc3_a) + $unsigned(i_unnamed_k2_zts6c_calc3_b);
    assign i_unnamed_k2_zts6c_calc3_q = i_unnamed_k2_zts6c_calc3_o[64:0];

    // bgTrunc_i_unnamed_k2_zts6c_calc3_sel_x(BITSELECT,33)@1
    assign bgTrunc_i_unnamed_k2_zts6c_calc3_sel_x_b = i_unnamed_k2_zts6c_calc3_q[63:0];

    // dupName_9_i_unnamed_k2_zts6c_calc0_dupName_0_trunc_sel_x(BITSELECT,50)@1
    assign dupName_9_i_unnamed_k2_zts6c_calc0_dupName_0_trunc_sel_x_b = bgTrunc_i_unnamed_k2_zts6c_calc3_sel_x_b[13:0];

    // dupName_9_i_unnamed_k2_zts6c_calc0_narrow_x(BITSELECT,43)@1
    assign dupName_9_i_unnamed_k2_zts6c_calc0_narrow_x_b = dupName_9_i_unnamed_k2_zts6c_calc0_dupName_0_trunc_sel_x_b[11:0];

    // redist1_dupName_9_i_unnamed_k2_zts6c_calc0_narrow_x_b_1(DELAY,74)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist1_dupName_9_i_unnamed_k2_zts6c_calc0_narrow_x_b_1_q <= '0;
        end
        else
        begin
            redist1_dupName_9_i_unnamed_k2_zts6c_calc0_narrow_x_b_1_q <= $unsigned(dupName_9_i_unnamed_k2_zts6c_calc0_narrow_x_b);
        end
    end

    // dupName_9_i_unnamed_k2_zts6c_calc0_shift_join_x(BITJOIN,44)@2
    assign dupName_9_i_unnamed_k2_zts6c_calc0_shift_join_x_q = {redist1_dupName_9_i_unnamed_k2_zts6c_calc0_narrow_x_b_1_q, i_unnamed_k2_zts6c_calc4_vt_const_1_q};

    // dupName_9_i_unnamed_k2_zts6c_calc0_add_x(ADD,40)@2
    assign dupName_9_i_unnamed_k2_zts6c_calc0_add_x_a = {1'b0, dupName_9_i_unnamed_k2_zts6c_calc0_upper_bits_x_merged_bit_select_c};
    assign dupName_9_i_unnamed_k2_zts6c_calc0_add_x_b = {1'b0, dupName_9_i_unnamed_k2_zts6c_calc0_shift_join_x_q};
    assign dupName_9_i_unnamed_k2_zts6c_calc0_add_x_o = $unsigned(dupName_9_i_unnamed_k2_zts6c_calc0_add_x_a) + $unsigned(dupName_9_i_unnamed_k2_zts6c_calc0_add_x_b);
    assign dupName_9_i_unnamed_k2_zts6c_calc0_add_x_q = dupName_9_i_unnamed_k2_zts6c_calc0_add_x_o[14:0];

    // dupName_9_i_unnamed_k2_zts6c_calc0_dupName_2_trunc_sel_x(BITSELECT,51)@2
    assign dupName_9_i_unnamed_k2_zts6c_calc0_dupName_2_trunc_sel_x_b = dupName_9_i_unnamed_k2_zts6c_calc0_add_x_q[13:0];

    // dupName_9_i_unnamed_k2_zts6c_calc0_append_upper_bits_x(BITJOIN,41)@2
    assign dupName_9_i_unnamed_k2_zts6c_calc0_append_upper_bits_x_q = {dupName_9_i_unnamed_k2_zts6c_calc0_upper_bits_x_merged_bit_select_b, dupName_9_i_unnamed_k2_zts6c_calc0_dupName_2_trunc_sel_x_b};

    // i_unnamed_k2_zts6c_calc4_vt_select_63(BITSELECT,25)@2
    assign i_unnamed_k2_zts6c_calc4_vt_select_63_b = dupName_9_i_unnamed_k2_zts6c_calc0_append_upper_bits_x_q[63:2];

    // i_unnamed_k2_zts6c_calc4_vt_const_1(CONSTANT,23)
    assign i_unnamed_k2_zts6c_calc4_vt_const_1_q = $unsigned(2'b00);

    // i_unnamed_k2_zts6c_calc4_vt_join(BITJOIN,24)@2
    assign i_unnamed_k2_zts6c_calc4_vt_join_q = {i_unnamed_k2_zts6c_calc4_vt_select_63_b, i_unnamed_k2_zts6c_calc4_vt_const_1_q};

    // redist3_sync_together21_aunroll_x_in_c0_eni5_3_tpl_1(DELAY,76)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist3_sync_together21_aunroll_x_in_c0_eni5_3_tpl_1_q <= '0;
        end
        else
        begin
            redist3_sync_together21_aunroll_x_in_c0_eni5_3_tpl_1_q <= $unsigned(in_c0_eni5_3_tpl);
        end
    end

    // i_llvm_fpga_mem_unnamed_k2_zts6c_calc25_k2_zts6c_calc5(BLACKBOX,14)@2
    // in in_i_stall@20000000
    // out out_o_readdata@6
    // out out_o_stall@5
    // out out_o_valid@6
    // out out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_address@20000000
    // out out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_burstcount@20000000
    // out out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_byteenable@20000000
    // out out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_enable@20000000
    // out out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_read@20000000
    // out out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_write@20000000
    // out out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writedata@20000000
    k2_ZTS6c_calc_i_llvm_fpga_mem_unnamed_k20000alc25_k2_zts6c_calc0 thei_llvm_fpga_mem_unnamed_k2_zts6c_calc25_k2_zts6c_calc5 (
        .in_AddrOffset(redist3_sync_together21_aunroll_x_in_c0_eni5_3_tpl_1_q),
        .in_flush(in_flush),
        .in_i_address(i_unnamed_k2_zts6c_calc4_vt_join_q),
        .in_i_predicate(GND_q),
        .in_i_stall(GND_q),
        .in_i_valid(valid_fanout_reg1_q),
        .in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_readdata(in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_readdata),
        .in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_readdatavalid(in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_readdatavalid),
        .in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_waitrequest(in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_waitrequest),
        .in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writeack(in_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writeack),
        .out_o_readdata(i_llvm_fpga_mem_unnamed_k2_zts6c_calc25_k2_zts6c_calc5_out_o_readdata),
        .out_o_stall(),
        .out_o_valid(),
        .out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_address(i_llvm_fpga_mem_unnamed_k2_zts6c_calc25_k2_zts6c_calc5_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_address),
        .out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_burstcount(i_llvm_fpga_mem_unnamed_k2_zts6c_calc25_k2_zts6c_calc5_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_burstcount),
        .out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_byteenable(i_llvm_fpga_mem_unnamed_k2_zts6c_calc25_k2_zts6c_calc5_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_byteenable),
        .out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_enable(i_llvm_fpga_mem_unnamed_k2_zts6c_calc25_k2_zts6c_calc5_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_enable),
        .out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_read(i_llvm_fpga_mem_unnamed_k2_zts6c_calc25_k2_zts6c_calc5_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_read),
        .out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_write(i_llvm_fpga_mem_unnamed_k2_zts6c_calc25_k2_zts6c_calc5_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_write),
        .out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writedata(i_llvm_fpga_mem_unnamed_k2_zts6c_calc25_k2_zts6c_calc5_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writedata),
        .clock(clock),
        .resetn(resetn)
    );

    // ext_sig_sync_out(GPOUT,12)
    assign out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_address = i_llvm_fpga_mem_unnamed_k2_zts6c_calc25_k2_zts6c_calc5_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_address;
    assign out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_enable = i_llvm_fpga_mem_unnamed_k2_zts6c_calc25_k2_zts6c_calc5_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_enable;
    assign out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_read = i_llvm_fpga_mem_unnamed_k2_zts6c_calc25_k2_zts6c_calc5_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_read;
    assign out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_write = i_llvm_fpga_mem_unnamed_k2_zts6c_calc25_k2_zts6c_calc5_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_write;
    assign out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writedata = i_llvm_fpga_mem_unnamed_k2_zts6c_calc25_k2_zts6c_calc5_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_writedata;
    assign out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_byteenable = i_llvm_fpga_mem_unnamed_k2_zts6c_calc25_k2_zts6c_calc5_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_byteenable;
    assign out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_burstcount = i_llvm_fpga_mem_unnamed_k2_zts6c_calc25_k2_zts6c_calc5_out_unnamed_k2_ZTS6c_calc25_k2_ZTS6c_calc_avm_burstcount;

    // valid_fanout_reg2(REG,66)@1 + 1
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            valid_fanout_reg2_q <= $unsigned(1'b0);
        end
        else
        begin
            valid_fanout_reg2_q <= $unsigned(in_i_valid);
        end
    end

    // c_arg8(CONSTANT,6)
    assign c_arg8_q = $unsigned(64'b0100000001000001000000000000000000000000000000000000000000000000);

    // dupName_10_i_unnamed_k2_zts6c_calc0_upper_bits_x_merged_bit_select(BITSELECT,72)@2
    assign dupName_10_i_unnamed_k2_zts6c_calc0_upper_bits_x_merged_bit_select_b = c_arg8_q[63:14];
    assign dupName_10_i_unnamed_k2_zts6c_calc0_upper_bits_x_merged_bit_select_c = c_arg8_q[13:0];

    // i_unnamed_k2_zts6c_calc6(ADD,26)@1
    assign i_unnamed_k2_zts6c_calc6_a = {1'b0, in_c0_eni5_4_tpl};
    assign i_unnamed_k2_zts6c_calc6_b = {1'b0, i_unnamed_k2_zts6c_calc2_vt_join_q};
    assign i_unnamed_k2_zts6c_calc6_o = $unsigned(i_unnamed_k2_zts6c_calc6_a) + $unsigned(i_unnamed_k2_zts6c_calc6_b);
    assign i_unnamed_k2_zts6c_calc6_q = i_unnamed_k2_zts6c_calc6_o[64:0];

    // bgTrunc_i_unnamed_k2_zts6c_calc6_sel_x(BITSELECT,34)@1
    assign bgTrunc_i_unnamed_k2_zts6c_calc6_sel_x_b = i_unnamed_k2_zts6c_calc6_q[63:0];

    // dupName_10_i_unnamed_k2_zts6c_calc0_dupName_0_trunc_sel_x(BITSELECT,62)@1
    assign dupName_10_i_unnamed_k2_zts6c_calc0_dupName_0_trunc_sel_x_b = bgTrunc_i_unnamed_k2_zts6c_calc6_sel_x_b[13:0];

    // dupName_10_i_unnamed_k2_zts6c_calc0_narrow_x(BITSELECT,55)@1
    assign dupName_10_i_unnamed_k2_zts6c_calc0_narrow_x_b = dupName_10_i_unnamed_k2_zts6c_calc0_dupName_0_trunc_sel_x_b[11:0];

    // redist0_dupName_10_i_unnamed_k2_zts6c_calc0_narrow_x_b_1(DELAY,73)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist0_dupName_10_i_unnamed_k2_zts6c_calc0_narrow_x_b_1_q <= '0;
        end
        else
        begin
            redist0_dupName_10_i_unnamed_k2_zts6c_calc0_narrow_x_b_1_q <= $unsigned(dupName_10_i_unnamed_k2_zts6c_calc0_narrow_x_b);
        end
    end

    // dupName_10_i_unnamed_k2_zts6c_calc0_shift_join_x(BITJOIN,56)@2
    assign dupName_10_i_unnamed_k2_zts6c_calc0_shift_join_x_q = {redist0_dupName_10_i_unnamed_k2_zts6c_calc0_narrow_x_b_1_q, i_unnamed_k2_zts6c_calc4_vt_const_1_q};

    // dupName_10_i_unnamed_k2_zts6c_calc0_add_x(ADD,52)@2
    assign dupName_10_i_unnamed_k2_zts6c_calc0_add_x_a = {1'b0, dupName_10_i_unnamed_k2_zts6c_calc0_upper_bits_x_merged_bit_select_c};
    assign dupName_10_i_unnamed_k2_zts6c_calc0_add_x_b = {1'b0, dupName_10_i_unnamed_k2_zts6c_calc0_shift_join_x_q};
    assign dupName_10_i_unnamed_k2_zts6c_calc0_add_x_o = $unsigned(dupName_10_i_unnamed_k2_zts6c_calc0_add_x_a) + $unsigned(dupName_10_i_unnamed_k2_zts6c_calc0_add_x_b);
    assign dupName_10_i_unnamed_k2_zts6c_calc0_add_x_q = dupName_10_i_unnamed_k2_zts6c_calc0_add_x_o[14:0];

    // dupName_10_i_unnamed_k2_zts6c_calc0_dupName_2_trunc_sel_x(BITSELECT,63)@2
    assign dupName_10_i_unnamed_k2_zts6c_calc0_dupName_2_trunc_sel_x_b = dupName_10_i_unnamed_k2_zts6c_calc0_add_x_q[13:0];

    // dupName_10_i_unnamed_k2_zts6c_calc0_append_upper_bits_x(BITJOIN,53)@2
    assign dupName_10_i_unnamed_k2_zts6c_calc0_append_upper_bits_x_q = {dupName_10_i_unnamed_k2_zts6c_calc0_upper_bits_x_merged_bit_select_b, dupName_10_i_unnamed_k2_zts6c_calc0_dupName_2_trunc_sel_x_b};

    // i_unnamed_k2_zts6c_calc7_vt_select_63(BITSELECT,29)@2
    assign i_unnamed_k2_zts6c_calc7_vt_select_63_b = dupName_10_i_unnamed_k2_zts6c_calc0_append_upper_bits_x_q[63:2];

    // i_unnamed_k2_zts6c_calc7_vt_join(BITJOIN,28)@2
    assign i_unnamed_k2_zts6c_calc7_vt_join_q = {i_unnamed_k2_zts6c_calc7_vt_select_63_b, i_unnamed_k2_zts6c_calc4_vt_const_1_q};

    // i_llvm_fpga_mem_unnamed_k2_zts6c_calc28_k2_zts6c_calc8(BLACKBOX,15)@2
    // in in_i_stall@20000000
    // out out_o_readdata@6
    // out out_o_stall@5
    // out out_o_valid@6
    // out out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_address@20000000
    // out out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_burstcount@20000000
    // out out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_byteenable@20000000
    // out out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_enable@20000000
    // out out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_read@20000000
    // out out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_write@20000000
    // out out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writedata@20000000
    k2_ZTS6c_calc_i_llvm_fpga_mem_unnamed_k20000alc28_k2_zts6c_calc0 thei_llvm_fpga_mem_unnamed_k2_zts6c_calc28_k2_zts6c_calc8 (
        .in_AddrOffset(redist3_sync_together21_aunroll_x_in_c0_eni5_3_tpl_1_q),
        .in_flush(in_flush),
        .in_i_address(i_unnamed_k2_zts6c_calc7_vt_join_q),
        .in_i_predicate(GND_q),
        .in_i_stall(GND_q),
        .in_i_valid(valid_fanout_reg2_q),
        .in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_readdata(in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_readdata),
        .in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_readdatavalid(in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_readdatavalid),
        .in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_waitrequest(in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_waitrequest),
        .in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writeack(in_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writeack),
        .out_o_readdata(i_llvm_fpga_mem_unnamed_k2_zts6c_calc28_k2_zts6c_calc8_out_o_readdata),
        .out_o_stall(),
        .out_o_valid(),
        .out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_address(i_llvm_fpga_mem_unnamed_k2_zts6c_calc28_k2_zts6c_calc8_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_address),
        .out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_burstcount(i_llvm_fpga_mem_unnamed_k2_zts6c_calc28_k2_zts6c_calc8_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_burstcount),
        .out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_byteenable(i_llvm_fpga_mem_unnamed_k2_zts6c_calc28_k2_zts6c_calc8_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_byteenable),
        .out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_enable(i_llvm_fpga_mem_unnamed_k2_zts6c_calc28_k2_zts6c_calc8_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_enable),
        .out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_read(i_llvm_fpga_mem_unnamed_k2_zts6c_calc28_k2_zts6c_calc8_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_read),
        .out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_write(i_llvm_fpga_mem_unnamed_k2_zts6c_calc28_k2_zts6c_calc8_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_write),
        .out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writedata(i_llvm_fpga_mem_unnamed_k2_zts6c_calc28_k2_zts6c_calc8_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writedata),
        .clock(clock),
        .resetn(resetn)
    );

    // dupName_0_ext_sig_sync_out_x(GPOUT,36)
    assign out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_address = i_llvm_fpga_mem_unnamed_k2_zts6c_calc28_k2_zts6c_calc8_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_address;
    assign out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_enable = i_llvm_fpga_mem_unnamed_k2_zts6c_calc28_k2_zts6c_calc8_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_enable;
    assign out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_read = i_llvm_fpga_mem_unnamed_k2_zts6c_calc28_k2_zts6c_calc8_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_read;
    assign out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_write = i_llvm_fpga_mem_unnamed_k2_zts6c_calc28_k2_zts6c_calc8_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_write;
    assign out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writedata = i_llvm_fpga_mem_unnamed_k2_zts6c_calc28_k2_zts6c_calc8_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_writedata;
    assign out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_byteenable = i_llvm_fpga_mem_unnamed_k2_zts6c_calc28_k2_zts6c_calc8_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_byteenable;
    assign out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_burstcount = i_llvm_fpga_mem_unnamed_k2_zts6c_calc28_k2_zts6c_calc8_out_unnamed_k2_ZTS6c_calc28_k2_ZTS6c_calc_avm_burstcount;

    // redist5_sync_together21_aunroll_x_in_i_valid_8(DELAY,78)
    dspba_delay_ver #( .width(1), .depth(8), .reset_kind("ASYNC"), .phase(0), .modulus(1), .reset_high(1'b0) )
    redist5_sync_together21_aunroll_x_in_i_valid_8 ( .xin(in_i_valid), .xout(redist5_sync_together21_aunroll_x_in_i_valid_8_q), .clk(clock), .aclr(resetn), .ena(1'b1) );

    // valid_fanout_reg0(REG,64)@9 + 1
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            valid_fanout_reg0_q <= $unsigned(1'b0);
        end
        else
        begin
            valid_fanout_reg0_q <= $unsigned(redist5_sync_together21_aunroll_x_in_i_valid_8_q);
        end
    end

    // c_i32_1616(CONSTANT,10)
    assign c_i32_1616_q = $unsigned(32'b00000000000000000000000000010000);

    // i_unnamed_k2_zts6c_calc11(COMPARE,17)@10
    assign i_unnamed_k2_zts6c_calc11_a = {2'b00, bgTrunc_i_unnamed_k2_zts6c_calc10_sel_x_b};
    assign i_unnamed_k2_zts6c_calc11_b = {2'b00, c_i32_1616_q};
    assign i_unnamed_k2_zts6c_calc11_o = $unsigned(i_unnamed_k2_zts6c_calc11_a) - $unsigned(i_unnamed_k2_zts6c_calc11_b);
    assign i_unnamed_k2_zts6c_calc11_c[0] = i_unnamed_k2_zts6c_calc11_o[33];

    // c_i32_115(CONSTANT,9)
    assign c_i32_115_q = $unsigned(32'b00000000000000000000000000000001);

    // redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_notEnable(LOGICAL,86)
    assign redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_notEnable_q = $unsigned(~ (VCC_q));

    // redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_nor(LOGICAL,87)
    assign redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_nor_q = ~ (redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_notEnable_q | redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_sticky_ena_q);

    // redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_mem_last(CONSTANT,83)
    assign redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_mem_last_q = $unsigned(4'b0101);

    // redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_cmp(LOGICAL,84)
    assign redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_cmp_b = {1'b0, redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_rdcnt_q};
    assign redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_cmp_q = $unsigned(redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_mem_last_q == redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_cmp_b ? 1'b1 : 1'b0);

    // redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_cmpReg(REG,85)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_cmpReg_q <= $unsigned(1'b0);
        end
        else
        begin
            redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_cmpReg_q <= $unsigned(redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_cmp_q);
        end
    end

    // redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_sticky_ena(REG,88)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_sticky_ena_q <= $unsigned(1'b0);
        end
        else if (redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_nor_q == 1'b1)
        begin
            redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_sticky_ena_q <= $unsigned(redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_cmpReg_q);
        end
    end

    // redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_enaAnd(LOGICAL,89)
    assign redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_enaAnd_q = redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_sticky_ena_q & VCC_q;

    // redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_rdcnt(COUNTER,81)
    // low=0, high=6, step=1, init=0
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_rdcnt_i <= 3'd0;
            redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_rdcnt_eq <= 1'b0;
        end
        else
        begin
            if (redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_rdcnt_i == 3'd5)
            begin
                redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_rdcnt_eq <= 1'b1;
            end
            else
            begin
                redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_rdcnt_eq <= 1'b0;
            end
            if (redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_rdcnt_eq == 1'b1)
            begin
                redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_rdcnt_i <= $unsigned(redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_rdcnt_i) + $unsigned(3'd2);
            end
            else
            begin
                redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_rdcnt_i <= $unsigned(redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_rdcnt_i) + $unsigned(3'd1);
            end
        end
    end
    assign redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_rdcnt_q = redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_rdcnt_i[2:0];

    // redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_wraddr(REG,82)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_wraddr_q <= $unsigned(3'b110);
        end
        else
        begin
            redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_wraddr_q <= $unsigned(redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_rdcnt_q);
        end
    end

    // redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_mem(DUALMEM,80)
    assign redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_mem_ia = $unsigned(in_c0_eni5_1_tpl);
    assign redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_mem_aa = redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_wraddr_q;
    assign redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_mem_ab = redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_rdcnt_q;
    assign redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_mem_reset0 = ~ (resetn);
    altera_syncram #(
        .ram_block_type("MLAB"),
        .operation_mode("DUAL_PORT"),
        .width_a(32),
        .widthad_a(3),
        .numwords_a(7),
        .width_b(32),
        .widthad_b(3),
        .numwords_b(7),
        .lpm_type("altera_syncram"),
        .width_byteena_a(1),
        .address_reg_b("CLOCK0"),
        .indata_reg_b("CLOCK0"),
        .rdcontrol_reg_b("CLOCK0"),
        .byteena_reg_b("CLOCK0"),
        .outdata_reg_b("CLOCK1"),
        .outdata_aclr_b("CLEAR1"),
        .clock_enable_input_a("NORMAL"),
        .clock_enable_input_b("NORMAL"),
        .clock_enable_output_b("NORMAL"),
        .read_during_write_mode_mixed_ports("DONT_CARE"),
        .power_up_uninitialized("TRUE"),
        .intended_device_family("Arria 10")
    ) redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_mem_dmem (
        .clocken1(redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_enaAnd_q[0]),
        .clocken0(1'b1),
        .clock0(clock),
        .aclr1(redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_mem_reset0),
        .clock1(clock),
        .address_a(redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_mem_aa),
        .data_a(redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_mem_ia),
        .wren_a(VCC_q[0]),
        .address_b(redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_mem_ab),
        .q_b(redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_mem_iq),
        .wren_b(),
        .rden_a(),
        .rden_b(),
        .data_b(),
        .clocken2(),
        .clocken3(),
        .aclr0(),
        .addressstall_a(),
        .addressstall_b(),
        .byteena_a(),
        .byteena_b(),
        .eccencbypass(),
        .eccencparity(),
        .sclr(),
        .address2_a(),
        .address2_b(),
        .q_a(),
        .eccstatus()
    );
    assign redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_mem_q = redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_mem_iq[31:0];

    // redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_outputreg0(DELAY,79)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_outputreg0_q <= '0;
        end
        else
        begin
            redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_outputreg0_q <= $unsigned(redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_mem_q);
        end
    end

    // i_unnamed_k2_zts6c_calc10(ADD,16)@10
    assign i_unnamed_k2_zts6c_calc10_a = {1'b0, redist2_sync_together21_aunroll_x_in_c0_eni5_1_tpl_9_outputreg0_q};
    assign i_unnamed_k2_zts6c_calc10_b = {1'b0, c_i32_115_q};
    assign i_unnamed_k2_zts6c_calc10_o = $unsigned(i_unnamed_k2_zts6c_calc10_a) + $unsigned(i_unnamed_k2_zts6c_calc10_b);
    assign i_unnamed_k2_zts6c_calc10_q = i_unnamed_k2_zts6c_calc10_o[32:0];

    // bgTrunc_i_unnamed_k2_zts6c_calc10_sel_x(BITSELECT,32)@10
    assign bgTrunc_i_unnamed_k2_zts6c_calc10_sel_x_b = i_unnamed_k2_zts6c_calc10_q[31:0];

    // redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_notEnable(LOGICAL,97)
    assign redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_notEnable_q = $unsigned(~ (VCC_q));

    // redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_nor(LOGICAL,98)
    assign redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_nor_q = ~ (redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_notEnable_q | redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_sticky_ena_q);

    // redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_mem_last(CONSTANT,94)
    assign redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_mem_last_q = $unsigned(2'b01);

    // redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_cmp(LOGICAL,95)
    assign redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_cmp_q = $unsigned(redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_mem_last_q == redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_rdcnt_q ? 1'b1 : 1'b0);

    // redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_cmpReg(REG,96)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_cmpReg_q <= $unsigned(1'b0);
        end
        else
        begin
            redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_cmpReg_q <= $unsigned(redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_cmp_q);
        end
    end

    // redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_sticky_ena(REG,99)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_sticky_ena_q <= $unsigned(1'b0);
        end
        else if (redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_nor_q == 1'b1)
        begin
            redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_sticky_ena_q <= $unsigned(redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_cmpReg_q);
        end
    end

    // redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_enaAnd(LOGICAL,100)
    assign redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_enaAnd_q = redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_sticky_ena_q & VCC_q;

    // redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_rdcnt(COUNTER,92)
    // low=0, high=2, step=1, init=0
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_rdcnt_i <= 2'd0;
            redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_rdcnt_eq <= 1'b0;
        end
        else
        begin
            if (redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_rdcnt_i == 2'd1)
            begin
                redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_rdcnt_eq <= 1'b1;
            end
            else
            begin
                redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_rdcnt_eq <= 1'b0;
            end
            if (redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_rdcnt_eq == 1'b1)
            begin
                redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_rdcnt_i <= $unsigned(redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_rdcnt_i) + $unsigned(2'd2);
            end
            else
            begin
                redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_rdcnt_i <= $unsigned(redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_rdcnt_i) + $unsigned(2'd1);
            end
        end
    end
    assign redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_rdcnt_q = redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_rdcnt_i[1:0];

    // redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_wraddr(REG,93)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_wraddr_q <= $unsigned(2'b10);
        end
        else
        begin
            redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_wraddr_q <= $unsigned(redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_rdcnt_q);
        end
    end

    // redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_mem(DUALMEM,91)
    assign redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_mem_ia = $unsigned(in_c0_eni5_5_tpl);
    assign redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_mem_aa = redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_wraddr_q;
    assign redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_mem_ab = redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_rdcnt_q;
    assign redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_mem_reset0 = ~ (resetn);
    altera_syncram #(
        .ram_block_type("MLAB"),
        .operation_mode("DUAL_PORT"),
        .width_a(32),
        .widthad_a(2),
        .numwords_a(3),
        .width_b(32),
        .widthad_b(2),
        .numwords_b(3),
        .lpm_type("altera_syncram"),
        .width_byteena_a(1),
        .address_reg_b("CLOCK0"),
        .indata_reg_b("CLOCK0"),
        .rdcontrol_reg_b("CLOCK0"),
        .byteena_reg_b("CLOCK0"),
        .outdata_reg_b("CLOCK1"),
        .outdata_aclr_b("CLEAR1"),
        .clock_enable_input_a("NORMAL"),
        .clock_enable_input_b("NORMAL"),
        .clock_enable_output_b("NORMAL"),
        .read_during_write_mode_mixed_ports("DONT_CARE"),
        .power_up_uninitialized("TRUE"),
        .intended_device_family("Arria 10")
    ) redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_mem_dmem (
        .clocken1(redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_enaAnd_q[0]),
        .clocken0(1'b1),
        .clock0(clock),
        .aclr1(redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_mem_reset0),
        .clock1(clock),
        .address_a(redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_mem_aa),
        .data_a(redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_mem_ia),
        .wren_a(VCC_q[0]),
        .address_b(redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_mem_ab),
        .q_b(redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_mem_iq),
        .wren_b(),
        .rden_a(),
        .rden_b(),
        .data_b(),
        .clocken2(),
        .clocken3(),
        .aclr0(),
        .addressstall_a(),
        .addressstall_b(),
        .byteena_a(),
        .byteena_b(),
        .eccencbypass(),
        .eccencparity(),
        .sclr(),
        .address2_a(),
        .address2_b(),
        .q_a(),
        .eccstatus()
    );
    assign redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_mem_q = redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_mem_iq[31:0];

    // redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_outputreg0(DELAY,90)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_outputreg0_q <= '0;
        end
        else
        begin
            redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_outputreg0_q <= $unsigned(redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_mem_q);
        end
    end

    // i_llvm_fpga_fp_multadd_mult_add_k2_zts6c_calc9(BLACKBOX,13)@6
    // out out_primWireOut@10
    k2_ZTS6c_calc_flt_i_sfc_logic_s_c0_in_cr0000bgvqocp06o303f0wzj0u thei_llvm_fpga_fp_multadd_mult_add_k2_zts6c_calc9 (
        .in_0(i_llvm_fpga_mem_unnamed_k2_zts6c_calc25_k2_zts6c_calc5_out_o_readdata),
        .in_1(i_llvm_fpga_mem_unnamed_k2_zts6c_calc28_k2_zts6c_calc8_out_o_readdata),
        .in_2(redist4_sync_together21_aunroll_x_in_c0_eni5_5_tpl_5_outputreg0_q),
        .out_primWireOut(i_llvm_fpga_fp_multadd_mult_add_k2_zts6c_calc9_out_primWireOut),
        .clock(clock),
        .resetn(resetn)
    );

    // sync_out_aunroll_x(GPOUT,38)@10
    assign out_c0_exi352_0_tpl = GND_q;
    assign out_c0_exi352_1_tpl = i_llvm_fpga_fp_multadd_mult_add_k2_zts6c_calc9_out_primWireOut;
    assign out_c0_exi352_2_tpl = bgTrunc_i_unnamed_k2_zts6c_calc10_sel_x_b;
    assign out_c0_exi352_3_tpl = i_unnamed_k2_zts6c_calc11_c;
    assign out_o_valid = valid_fanout_reg0_q;
    assign out_unnamed_k2_ZTS6c_calc4 = GND_q;

endmodule
