// ------------------------------------------------------------------------- 
// High Level Design Compiler for Intel(R) FPGAs Version 20.3 (Release Build #121)
// 
// Legal Notice: Copyright 2020 Intel Corporation.  All rights reserved.
// Your use of  Intel Corporation's design tools,  logic functions and other
// software and  tools, and its AMPP partner logic functions, and any output
// files any  of the foregoing (including  device programming  or simulation
// files), and  any associated  documentation  or information  are expressly
// subject  to the terms and  conditions of the  Intel FPGA Software License
// Agreement, Intel MegaCore Function License Agreement, or other applicable
// license agreement,  including,  without limitation,  that your use is for
// the  sole  purpose of  programming  logic devices  manufactured by  Intel
// and  sold by Intel  or its authorized  distributors. Please refer  to the
// applicable agreement for further details.
// ---------------------------------------------------------------------------

// SystemVerilog created from k2_ZTS6c_calc_i_sfc_logic_s_c0_in_zn2cl40000enter_k2_zts6c_calc0
// SystemVerilog created on Thu Nov  5 06:32:57 2020


(* altera_attribute = "-name AUTO_SHIFT_REGISTER_RECOGNITION OFF; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 10037; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 15400; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 12020; -name MESSAGE_DISABLE 12030; -name MESSAGE_DISABLE 12010; -name MESSAGE_DISABLE 12110; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 13410; -name MESSAGE_DISABLE 113007; -name MESSAGE_DISABLE 10958" *)
module k2_ZTS6c_calc_i_sfc_logic_s_c0_in_zn2cl40000enter_k2_zts6c_calc0 (
    input wire [63:0] in_arg1_0_tpl,
    input wire [63:0] in_arg1_1_tpl,
    input wire [63:0] in_arg9_0_tpl,
    input wire [63:0] in_arg9_1_tpl,
    output wire [0:0] out_c0_exi8_0_tpl,
    output wire [31:0] out_c0_exi8_1_tpl,
    output wire [31:0] out_c0_exi8_2_tpl,
    output wire [0:0] out_c0_exi8_3_tpl,
    output wire [31:0] out_c0_exi8_4_tpl,
    output wire [63:0] out_c0_exi8_5_tpl,
    output wire [63:0] out_c0_exi8_6_tpl,
    output wire [63:0] out_c0_exi8_7_tpl,
    output wire [63:0] out_c0_exi8_8_tpl,
    output wire [0:0] out_o_valid,
    output wire [0:0] out_unnamed_k2_ZTS6c_calc4,
    input wire [0:0] in_c0_eni3_0_tpl,
    input wire [31:0] in_c0_eni3_1_tpl,
    input wire [31:0] in_c0_eni3_2_tpl,
    input wire [31:0] in_c0_eni3_3_tpl,
    input wire [0:0] in_i_valid,
    input wire clock,
    input wire resetn
    );

    wire [0:0] GND_q;
    wire [0:0] VCC_q;
    wire [63:0] c_arg0_q;
    wire [63:0] c_arg8_q;
    wire [6:0] i_unnamed_k2_zts6c_calc10_vt_const_6_q;
    wire [31:0] i_unnamed_k2_zts6c_calc10_vt_join_q;
    wire [24:0] i_unnamed_k2_zts6c_calc10_vt_select_31_b;
    wire [32:0] i_unnamed_k2_zts6c_calc11_a;
    wire [32:0] i_unnamed_k2_zts6c_calc11_b;
    logic [32:0] i_unnamed_k2_zts6c_calc11_o;
    wire [32:0] i_unnamed_k2_zts6c_calc11_q;
    wire [31:0] i_unnamed_k2_zts6c_calc12_vt_const_63_q;
    wire [63:0] i_unnamed_k2_zts6c_calc12_vt_join_q;
    wire [31:0] i_unnamed_k2_zts6c_calc12_vt_select_31_b;
    wire [63:0] i_unnamed_k2_zts6c_calc13_vt_join_q;
    wire [31:0] i_unnamed_k2_zts6c_calc13_vt_select_31_b;
    wire [64:0] i_unnamed_k2_zts6c_calc15_a;
    wire [64:0] i_unnamed_k2_zts6c_calc15_b;
    logic [64:0] i_unnamed_k2_zts6c_calc15_o;
    wire [64:0] i_unnamed_k2_zts6c_calc15_q;
    wire [1:0] i_unnamed_k2_zts6c_calc16_vt_const_1_q;
    wire [63:0] i_unnamed_k2_zts6c_calc16_vt_join_q;
    wire [61:0] i_unnamed_k2_zts6c_calc16_vt_select_63_b;
    wire [64:0] i_unnamed_k2_zts6c_calc18_a;
    wire [64:0] i_unnamed_k2_zts6c_calc18_b;
    logic [64:0] i_unnamed_k2_zts6c_calc18_o;
    wire [64:0] i_unnamed_k2_zts6c_calc18_q;
    wire [63:0] i_unnamed_k2_zts6c_calc19_vt_join_q;
    wire [61:0] i_unnamed_k2_zts6c_calc19_vt_select_63_b;
    wire [10:0] i_unnamed_k2_zts6c_calc2_vt_const_10_q;
    wire [31:0] i_unnamed_k2_zts6c_calc2_vt_join_q;
    wire [20:0] i_unnamed_k2_zts6c_calc2_vt_select_31_b;
    wire [10:0] i_unnamed_k2_zts6c_calc3_vt_const_10_q;
    wire [31:0] i_unnamed_k2_zts6c_calc3_vt_join_q;
    wire [20:0] i_unnamed_k2_zts6c_calc3_vt_select_31_b;
    wire [33:0] i_unnamed_k2_zts6c_calc4_a;
    wire [33:0] i_unnamed_k2_zts6c_calc4_b;
    logic [33:0] i_unnamed_k2_zts6c_calc4_o;
    wire [0:0] i_unnamed_k2_zts6c_calc4_c;
    wire [31:0] bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b;
    wire [63:0] bgTrunc_i_unnamed_k2_zts6c_calc14_sel_x_b;
    wire [63:0] bgTrunc_i_unnamed_k2_zts6c_calc15_sel_x_b;
    wire [63:0] bgTrunc_i_unnamed_k2_zts6c_calc17_sel_x_b;
    wire [63:0] bgTrunc_i_unnamed_k2_zts6c_calc18_sel_x_b;
    wire [63:0] i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili2eee_cl_sycl_ranges_arg1_sync_buffer_k2_zts6c_calc8_aunroll_x_out_buffer_out_1_tpl;
    wire [63:0] i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili2eee_cl_sycl_ranges_arg9_sync_buffer_k2_zts6c_calc6_aunroll_x_out_buffer_out_1_tpl;
    wire [63:0] i_unnamed_k2_zts6c_calc12_sel_x_b;
    wire [31:0] i_unnamed_k2_zts6c_calc12_vt_join_narrowed_x_b;
    wire [63:0] i_unnamed_k2_zts6c_calc13_sel_x_b;
    wire [31:0] i_unnamed_k2_zts6c_calc13_vt_join_narrowed_x_b;
    wire [127:0] i_unnamed_k2_zts6c_calc14_extender_x_q;
    wire [127:0] i_unnamed_k2_zts6c_calc17_extender_x_q;
    wire [14:0] dupName_1_i_unnamed_k2_zts6c_calc0_add_x_a;
    wire [14:0] dupName_1_i_unnamed_k2_zts6c_calc0_add_x_b;
    logic [14:0] dupName_1_i_unnamed_k2_zts6c_calc0_add_x_o;
    wire [14:0] dupName_1_i_unnamed_k2_zts6c_calc0_add_x_q;
    wire [63:0] dupName_1_i_unnamed_k2_zts6c_calc0_append_upper_bits_x_q;
    wire [11:0] dupName_1_i_unnamed_k2_zts6c_calc0_narrow_x_b;
    wire [13:0] dupName_1_i_unnamed_k2_zts6c_calc0_shift_join_x_q;
    wire [13:0] dupName_1_i_unnamed_k2_zts6c_calc0_dupName_0_trunc_sel_x_b;
    wire [13:0] dupName_1_i_unnamed_k2_zts6c_calc0_dupName_2_trunc_sel_x_b;
    wire [14:0] dupName_2_i_unnamed_k2_zts6c_calc0_add_x_a;
    wire [14:0] dupName_2_i_unnamed_k2_zts6c_calc0_add_x_b;
    logic [14:0] dupName_2_i_unnamed_k2_zts6c_calc0_add_x_o;
    wire [14:0] dupName_2_i_unnamed_k2_zts6c_calc0_add_x_q;
    wire [63:0] dupName_2_i_unnamed_k2_zts6c_calc0_append_upper_bits_x_q;
    wire [11:0] dupName_2_i_unnamed_k2_zts6c_calc0_narrow_x_b;
    wire [13:0] dupName_2_i_unnamed_k2_zts6c_calc0_shift_join_x_q;
    wire [13:0] dupName_2_i_unnamed_k2_zts6c_calc0_dupName_0_trunc_sel_x_b;
    wire [13:0] dupName_2_i_unnamed_k2_zts6c_calc0_dupName_2_trunc_sel_x_b;
    (* dont_merge *) reg [0:0] valid_fanout_reg0_q;
    (* dont_merge *) reg [0:0] valid_fanout_reg1_q;
    (* dont_merge *) reg [0:0] valid_fanout_reg2_q;
    wire [72:0] i_unnamed_k2_zts6c_calc14_sums_join_0_q;
    wire [54:0] i_unnamed_k2_zts6c_calc14_sums_align_1_q;
    wire [54:0] i_unnamed_k2_zts6c_calc14_sums_align_1_qint;
    wire [40:0] i_unnamed_k2_zts6c_calc14_sums_align_2_q;
    wire [40:0] i_unnamed_k2_zts6c_calc14_sums_align_2_qint;
    wire [95:0] i_unnamed_k2_zts6c_calc14_sums_join_3_q;
    wire [86:0] i_unnamed_k2_zts6c_calc14_sums_align_4_q;
    wire [86:0] i_unnamed_k2_zts6c_calc14_sums_align_4_qint;
    wire [96:0] i_unnamed_k2_zts6c_calc14_sums_result_add_0_0_a;
    wire [96:0] i_unnamed_k2_zts6c_calc14_sums_result_add_0_0_b;
    logic [96:0] i_unnamed_k2_zts6c_calc14_sums_result_add_0_0_o;
    wire [96:0] i_unnamed_k2_zts6c_calc14_sums_result_add_0_0_q;
    wire [97:0] i_unnamed_k2_zts6c_calc14_sums_result_add_1_0_a;
    wire [97:0] i_unnamed_k2_zts6c_calc14_sums_result_add_1_0_b;
    logic [97:0] i_unnamed_k2_zts6c_calc14_sums_result_add_1_0_o;
    wire [97:0] i_unnamed_k2_zts6c_calc14_sums_result_add_1_0_q;
    wire [72:0] i_unnamed_k2_zts6c_calc17_sums_join_0_q;
    wire [54:0] i_unnamed_k2_zts6c_calc17_sums_align_1_q;
    wire [54:0] i_unnamed_k2_zts6c_calc17_sums_align_1_qint;
    wire [40:0] i_unnamed_k2_zts6c_calc17_sums_align_2_q;
    wire [40:0] i_unnamed_k2_zts6c_calc17_sums_align_2_qint;
    wire [95:0] i_unnamed_k2_zts6c_calc17_sums_join_3_q;
    wire [86:0] i_unnamed_k2_zts6c_calc17_sums_align_4_q;
    wire [86:0] i_unnamed_k2_zts6c_calc17_sums_align_4_qint;
    wire [96:0] i_unnamed_k2_zts6c_calc17_sums_result_add_0_0_a;
    wire [96:0] i_unnamed_k2_zts6c_calc17_sums_result_add_0_0_b;
    logic [96:0] i_unnamed_k2_zts6c_calc17_sums_result_add_0_0_o;
    wire [96:0] i_unnamed_k2_zts6c_calc17_sums_result_add_0_0_q;
    wire [97:0] i_unnamed_k2_zts6c_calc17_sums_result_add_1_0_a;
    wire [97:0] i_unnamed_k2_zts6c_calc17_sums_result_add_1_0_b;
    logic [97:0] i_unnamed_k2_zts6c_calc17_sums_result_add_1_0_o;
    wire [97:0] i_unnamed_k2_zts6c_calc17_sums_result_add_1_0_q;
    wire [20:0] i_unnamed_k2_zts6c_calc3_BitSelect_for_a_b;
    wire [31:0] i_unnamed_k2_zts6c_calc3_join_q;
    wire [30:0] leftShiftStage0Idx1Rng1_uid174_i_unnamed_k2_zts6c_calc0_shift_x_in;
    wire [30:0] leftShiftStage0Idx1Rng1_uid174_i_unnamed_k2_zts6c_calc0_shift_x_b;
    wire [31:0] leftShiftStage0Idx1_uid175_i_unnamed_k2_zts6c_calc0_shift_x_q;
    wire [0:0] leftShiftStage0_uid177_i_unnamed_k2_zts6c_calc0_shift_x_s;
    reg [31:0] leftShiftStage0_uid177_i_unnamed_k2_zts6c_calc0_shift_x_q;
    wire [29:0] leftShiftStage1Idx1Rng2_uid179_i_unnamed_k2_zts6c_calc0_shift_x_in;
    wire [29:0] leftShiftStage1Idx1Rng2_uid179_i_unnamed_k2_zts6c_calc0_shift_x_b;
    wire [31:0] leftShiftStage1Idx1_uid180_i_unnamed_k2_zts6c_calc0_shift_x_q;
    wire [0:0] leftShiftStage1_uid182_i_unnamed_k2_zts6c_calc0_shift_x_s;
    reg [31:0] leftShiftStage1_uid182_i_unnamed_k2_zts6c_calc0_shift_x_q;
    wire [7:0] leftShiftStage2Idx1Pad8_uid183_i_unnamed_k2_zts6c_calc0_shift_x_q;
    wire [23:0] leftShiftStage2Idx1Rng8_uid184_i_unnamed_k2_zts6c_calc0_shift_x_in;
    wire [23:0] leftShiftStage2Idx1Rng8_uid184_i_unnamed_k2_zts6c_calc0_shift_x_b;
    wire [31:0] leftShiftStage2Idx1_uid185_i_unnamed_k2_zts6c_calc0_shift_x_q;
    wire [0:0] leftShiftStage2_uid187_i_unnamed_k2_zts6c_calc0_shift_x_s;
    reg [31:0] leftShiftStage2_uid187_i_unnamed_k2_zts6c_calc0_shift_x_q;
    wire [30:0] leftShiftStage0Idx1Rng1_uid192_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_in;
    wire [30:0] leftShiftStage0Idx1Rng1_uid192_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_b;
    wire [31:0] leftShiftStage0Idx1_uid193_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_q;
    wire [0:0] leftShiftStage0_uid195_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_s;
    reg [31:0] leftShiftStage0_uid195_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_q;
    wire [29:0] leftShiftStage1Idx1Rng2_uid197_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_in;
    wire [29:0] leftShiftStage1Idx1Rng2_uid197_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_b;
    wire [31:0] leftShiftStage1Idx1_uid198_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_q;
    wire [0:0] leftShiftStage1_uid200_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_s;
    reg [31:0] leftShiftStage1_uid200_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_q;
    wire [3:0] leftShiftStage2Idx1Pad4_uid201_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_q;
    wire [27:0] leftShiftStage2Idx1Rng4_uid202_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_in;
    wire [27:0] leftShiftStage2Idx1Rng4_uid202_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_b;
    wire [31:0] leftShiftStage2Idx1_uid203_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_q;
    wire [0:0] leftShiftStage2_uid205_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_s;
    reg [31:0] leftShiftStage2_uid205_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_q;
    wire i_unnamed_k2_zts6c_calc14_im0_cma_reset;
    wire [13:0] i_unnamed_k2_zts6c_calc14_im0_cma_a0;
    wire [9:0] i_unnamed_k2_zts6c_calc14_im0_cma_c0;
    wire [23:0] i_unnamed_k2_zts6c_calc14_im0_cma_s0;
    wire [23:0] i_unnamed_k2_zts6c_calc14_im0_cma_qq;
    wire [23:0] i_unnamed_k2_zts6c_calc14_im0_cma_q;
    wire i_unnamed_k2_zts6c_calc14_im0_cma_ena0;
    wire i_unnamed_k2_zts6c_calc14_im0_cma_ena1;
    wire i_unnamed_k2_zts6c_calc14_im0_cma_ena2;
    wire i_unnamed_k2_zts6c_calc14_im18_cma_reset;
    wire [17:0] i_unnamed_k2_zts6c_calc14_im18_cma_a0;
    wire [17:0] i_unnamed_k2_zts6c_calc14_im18_cma_c0;
    wire [35:0] i_unnamed_k2_zts6c_calc14_im18_cma_s0;
    wire [35:0] i_unnamed_k2_zts6c_calc14_im18_cma_qq;
    wire [35:0] i_unnamed_k2_zts6c_calc14_im18_cma_q;
    wire i_unnamed_k2_zts6c_calc14_im18_cma_ena0;
    wire i_unnamed_k2_zts6c_calc14_im18_cma_ena1;
    wire i_unnamed_k2_zts6c_calc14_im18_cma_ena2;
    wire i_unnamed_k2_zts6c_calc17_im0_cma_reset;
    wire [13:0] i_unnamed_k2_zts6c_calc17_im0_cma_a0;
    wire [9:0] i_unnamed_k2_zts6c_calc17_im0_cma_c0;
    wire [23:0] i_unnamed_k2_zts6c_calc17_im0_cma_s0;
    wire [23:0] i_unnamed_k2_zts6c_calc17_im0_cma_qq;
    wire [23:0] i_unnamed_k2_zts6c_calc17_im0_cma_q;
    wire i_unnamed_k2_zts6c_calc17_im0_cma_ena0;
    wire i_unnamed_k2_zts6c_calc17_im0_cma_ena1;
    wire i_unnamed_k2_zts6c_calc17_im0_cma_ena2;
    wire i_unnamed_k2_zts6c_calc17_im18_cma_reset;
    wire [17:0] i_unnamed_k2_zts6c_calc17_im18_cma_a0;
    wire [17:0] i_unnamed_k2_zts6c_calc17_im18_cma_c0;
    wire [35:0] i_unnamed_k2_zts6c_calc17_im18_cma_s0;
    wire [35:0] i_unnamed_k2_zts6c_calc17_im18_cma_qq;
    wire [35:0] i_unnamed_k2_zts6c_calc17_im18_cma_q;
    wire i_unnamed_k2_zts6c_calc17_im18_cma_ena0;
    wire i_unnamed_k2_zts6c_calc17_im18_cma_ena1;
    wire i_unnamed_k2_zts6c_calc17_im18_cma_ena2;
    wire i_unnamed_k2_zts6c_calc14_ma3_cma_reset;
    wire [13:0] i_unnamed_k2_zts6c_calc14_ma3_cma_a0;
    wire [17:0] i_unnamed_k2_zts6c_calc14_ma3_cma_c0;
    wire [13:0] i_unnamed_k2_zts6c_calc14_ma3_cma_a1;
    wire [17:0] i_unnamed_k2_zts6c_calc14_ma3_cma_c1;
    wire [32:0] i_unnamed_k2_zts6c_calc14_ma3_cma_s0;
    wire [32:0] i_unnamed_k2_zts6c_calc14_ma3_cma_qq;
    wire [32:0] i_unnamed_k2_zts6c_calc14_ma3_cma_q;
    wire i_unnamed_k2_zts6c_calc14_ma3_cma_ena0;
    wire i_unnamed_k2_zts6c_calc14_ma3_cma_ena1;
    wire i_unnamed_k2_zts6c_calc14_ma3_cma_ena2;
    wire i_unnamed_k2_zts6c_calc14_ma8_cma_reset;
    wire [17:0] i_unnamed_k2_zts6c_calc14_ma8_cma_a0;
    wire [17:0] i_unnamed_k2_zts6c_calc14_ma8_cma_c0;
    wire [17:0] i_unnamed_k2_zts6c_calc14_ma8_cma_a1;
    wire [17:0] i_unnamed_k2_zts6c_calc14_ma8_cma_c1;
    wire [36:0] i_unnamed_k2_zts6c_calc14_ma8_cma_s0;
    wire [36:0] i_unnamed_k2_zts6c_calc14_ma8_cma_qq;
    wire [36:0] i_unnamed_k2_zts6c_calc14_ma8_cma_q;
    wire i_unnamed_k2_zts6c_calc14_ma8_cma_ena0;
    wire i_unnamed_k2_zts6c_calc14_ma8_cma_ena1;
    wire i_unnamed_k2_zts6c_calc14_ma8_cma_ena2;
    wire i_unnamed_k2_zts6c_calc14_ma13_cma_reset;
    wire [17:0] i_unnamed_k2_zts6c_calc14_ma13_cma_a0;
    wire [17:0] i_unnamed_k2_zts6c_calc14_ma13_cma_c0;
    wire [17:0] i_unnamed_k2_zts6c_calc14_ma13_cma_a1;
    wire [17:0] i_unnamed_k2_zts6c_calc14_ma13_cma_c1;
    wire [36:0] i_unnamed_k2_zts6c_calc14_ma13_cma_s0;
    wire [36:0] i_unnamed_k2_zts6c_calc14_ma13_cma_qq;
    wire [36:0] i_unnamed_k2_zts6c_calc14_ma13_cma_q;
    wire i_unnamed_k2_zts6c_calc14_ma13_cma_ena0;
    wire i_unnamed_k2_zts6c_calc14_ma13_cma_ena1;
    wire i_unnamed_k2_zts6c_calc14_ma13_cma_ena2;
    wire i_unnamed_k2_zts6c_calc17_ma3_cma_reset;
    wire [13:0] i_unnamed_k2_zts6c_calc17_ma3_cma_a0;
    wire [17:0] i_unnamed_k2_zts6c_calc17_ma3_cma_c0;
    wire [13:0] i_unnamed_k2_zts6c_calc17_ma3_cma_a1;
    wire [17:0] i_unnamed_k2_zts6c_calc17_ma3_cma_c1;
    wire [32:0] i_unnamed_k2_zts6c_calc17_ma3_cma_s0;
    wire [32:0] i_unnamed_k2_zts6c_calc17_ma3_cma_qq;
    wire [32:0] i_unnamed_k2_zts6c_calc17_ma3_cma_q;
    wire i_unnamed_k2_zts6c_calc17_ma3_cma_ena0;
    wire i_unnamed_k2_zts6c_calc17_ma3_cma_ena1;
    wire i_unnamed_k2_zts6c_calc17_ma3_cma_ena2;
    wire i_unnamed_k2_zts6c_calc17_ma8_cma_reset;
    wire [17:0] i_unnamed_k2_zts6c_calc17_ma8_cma_a0;
    wire [17:0] i_unnamed_k2_zts6c_calc17_ma8_cma_c0;
    wire [17:0] i_unnamed_k2_zts6c_calc17_ma8_cma_a1;
    wire [17:0] i_unnamed_k2_zts6c_calc17_ma8_cma_c1;
    wire [36:0] i_unnamed_k2_zts6c_calc17_ma8_cma_s0;
    wire [36:0] i_unnamed_k2_zts6c_calc17_ma8_cma_qq;
    wire [36:0] i_unnamed_k2_zts6c_calc17_ma8_cma_q;
    wire i_unnamed_k2_zts6c_calc17_ma8_cma_ena0;
    wire i_unnamed_k2_zts6c_calc17_ma8_cma_ena1;
    wire i_unnamed_k2_zts6c_calc17_ma8_cma_ena2;
    wire i_unnamed_k2_zts6c_calc17_ma13_cma_reset;
    wire [17:0] i_unnamed_k2_zts6c_calc17_ma13_cma_a0;
    wire [17:0] i_unnamed_k2_zts6c_calc17_ma13_cma_c0;
    wire [17:0] i_unnamed_k2_zts6c_calc17_ma13_cma_a1;
    wire [17:0] i_unnamed_k2_zts6c_calc17_ma13_cma_c1;
    wire [36:0] i_unnamed_k2_zts6c_calc17_ma13_cma_s0;
    wire [36:0] i_unnamed_k2_zts6c_calc17_ma13_cma_qq;
    wire [36:0] i_unnamed_k2_zts6c_calc17_ma13_cma_q;
    wire i_unnamed_k2_zts6c_calc17_ma13_cma_ena0;
    wire i_unnamed_k2_zts6c_calc17_ma13_cma_ena1;
    wire i_unnamed_k2_zts6c_calc17_ma13_cma_ena2;
    wire [49:0] dupName_1_i_unnamed_k2_zts6c_calc0_upper_bits_x_merged_bit_select_b;
    wire [13:0] dupName_1_i_unnamed_k2_zts6c_calc0_upper_bits_x_merged_bit_select_c;
    wire [49:0] dupName_2_i_unnamed_k2_zts6c_calc0_upper_bits_x_merged_bit_select_b;
    wire [13:0] dupName_2_i_unnamed_k2_zts6c_calc0_upper_bits_x_merged_bit_select_c;
    wire [9:0] i_unnamed_k2_zts6c_calc14_bs1_merged_bit_select_b;
    wire [17:0] i_unnamed_k2_zts6c_calc14_bs1_merged_bit_select_c;
    wire [17:0] i_unnamed_k2_zts6c_calc14_bs1_merged_bit_select_d;
    wire [17:0] i_unnamed_k2_zts6c_calc14_bs1_merged_bit_select_e;
    wire [9:0] i_unnamed_k2_zts6c_calc17_bs1_merged_bit_select_b;
    wire [17:0] i_unnamed_k2_zts6c_calc17_bs1_merged_bit_select_c;
    wire [17:0] i_unnamed_k2_zts6c_calc17_bs1_merged_bit_select_d;
    wire [17:0] i_unnamed_k2_zts6c_calc17_bs1_merged_bit_select_e;
    wire [13:0] i_unnamed_k2_zts6c_calc14_bs2_merged_bit_select_b;
    wire [17:0] i_unnamed_k2_zts6c_calc14_bs2_merged_bit_select_c;
    wire [13:0] i_unnamed_k2_zts6c_calc17_bs2_merged_bit_select_b;
    wire [17:0] i_unnamed_k2_zts6c_calc17_bs2_merged_bit_select_c;
    reg [32:0] redist0_i_unnamed_k2_zts6c_calc17_ma3_cma_q_1_q;
    reg [32:0] redist1_i_unnamed_k2_zts6c_calc14_ma3_cma_q_1_q;
    reg [31:0] redist2_sync_together31_aunroll_x_in_c0_eni3_2_tpl_1_q;
    reg [31:0] redist3_sync_together31_aunroll_x_in_c0_eni3_3_tpl_1_q;
    reg [0:0] redist4_sync_together31_aunroll_x_in_i_valid_5_q;
    reg [0:0] redist4_sync_together31_aunroll_x_in_i_valid_5_delay_0;
    reg [0:0] redist4_sync_together31_aunroll_x_in_i_valid_5_delay_1;
    reg [0:0] redist4_sync_together31_aunroll_x_in_i_valid_5_delay_2;
    reg [0:0] redist4_sync_together31_aunroll_x_in_i_valid_5_delay_3;
    reg [63:0] redist5_bgTrunc_i_unnamed_k2_zts6c_calc17_sel_x_b_1_q;
    reg [63:0] redist6_bgTrunc_i_unnamed_k2_zts6c_calc14_sel_x_b_1_q;
    wire redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_mem_reset0;
    wire [31:0] redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_mem_ia;
    wire [1:0] redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_mem_aa;
    wire [1:0] redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_mem_ab;
    wire [31:0] redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_mem_iq;
    wire [31:0] redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_mem_q;
    wire [1:0] redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_rdcnt_q;
    (* preserve *) reg [1:0] redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_rdcnt_i;
    reg [1:0] redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_wraddr_q;
    wire [2:0] redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_mem_last_q;
    wire [2:0] redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_cmp_b;
    wire [0:0] redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_cmp_q;
    (* dont_merge *) reg [0:0] redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_cmpReg_q;
    wire [0:0] redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_notEnable_q;
    wire [0:0] redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_nor_q;
    (* dont_merge *) reg [0:0] redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_sticky_ena_q;
    wire [0:0] redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_enaAnd_q;
    reg [20:0] redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_outputreg0_q;
    wire redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_mem_reset0;
    wire [20:0] redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_mem_ia;
    wire [1:0] redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_mem_aa;
    wire [1:0] redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_mem_ab;
    wire [20:0] redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_mem_iq;
    wire [20:0] redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_mem_q;
    wire [1:0] redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_rdcnt_q;
    (* preserve *) reg [1:0] redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_rdcnt_i;
    reg [1:0] redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_wraddr_q;
    wire [2:0] redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_mem_last_q;
    wire [2:0] redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_cmp_b;
    wire [0:0] redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_cmp_q;
    (* dont_merge *) reg [0:0] redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_cmpReg_q;
    wire [0:0] redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_notEnable_q;
    wire [0:0] redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_nor_q;
    (* dont_merge *) reg [0:0] redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_sticky_ena_q;
    wire [0:0] redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_enaAnd_q;
    reg [63:0] redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_outputreg0_q;
    wire redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_mem_reset0;
    wire [63:0] redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_mem_ia;
    wire [1:0] redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_mem_aa;
    wire [1:0] redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_mem_ab;
    wire [63:0] redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_mem_iq;
    wire [63:0] redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_mem_q;
    wire [1:0] redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_rdcnt_q;
    (* preserve *) reg [1:0] redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_rdcnt_i;
    (* preserve *) reg redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_rdcnt_eq;
    reg [1:0] redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_wraddr_q;
    wire [1:0] redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_mem_last_q;
    wire [0:0] redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_cmp_q;
    (* dont_merge *) reg [0:0] redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_cmpReg_q;
    wire [0:0] redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_notEnable_q;
    wire [0:0] redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_nor_q;
    (* dont_merge *) reg [0:0] redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_sticky_ena_q;
    wire [0:0] redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_enaAnd_q;
    reg [63:0] redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_outputreg0_q;
    wire redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_mem_reset0;
    wire [63:0] redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_mem_ia;
    wire [1:0] redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_mem_aa;
    wire [1:0] redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_mem_ab;
    wire [63:0] redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_mem_iq;
    wire [63:0] redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_mem_q;
    wire [1:0] redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_rdcnt_q;
    (* preserve *) reg [1:0] redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_rdcnt_i;
    (* preserve *) reg redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_rdcnt_eq;
    reg [1:0] redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_wraddr_q;
    wire [1:0] redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_mem_last_q;
    wire [0:0] redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_cmp_q;
    (* dont_merge *) reg [0:0] redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_cmpReg_q;
    wire [0:0] redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_notEnable_q;
    wire [0:0] redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_nor_q;
    (* dont_merge *) reg [0:0] redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_sticky_ena_q;
    wire [0:0] redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_enaAnd_q;


    // VCC(CONSTANT,1)
    assign VCC_q = $unsigned(1'b1);

    // redist4_sync_together31_aunroll_x_in_i_valid_5(DELAY,226)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist4_sync_together31_aunroll_x_in_i_valid_5_delay_0 <= '0;
            redist4_sync_together31_aunroll_x_in_i_valid_5_delay_1 <= '0;
            redist4_sync_together31_aunroll_x_in_i_valid_5_delay_2 <= '0;
            redist4_sync_together31_aunroll_x_in_i_valid_5_delay_3 <= '0;
            redist4_sync_together31_aunroll_x_in_i_valid_5_q <= '0;
        end
        else
        begin
            redist4_sync_together31_aunroll_x_in_i_valid_5_delay_0 <= $unsigned(in_i_valid);
            redist4_sync_together31_aunroll_x_in_i_valid_5_delay_1 <= redist4_sync_together31_aunroll_x_in_i_valid_5_delay_0;
            redist4_sync_together31_aunroll_x_in_i_valid_5_delay_2 <= redist4_sync_together31_aunroll_x_in_i_valid_5_delay_1;
            redist4_sync_together31_aunroll_x_in_i_valid_5_delay_3 <= redist4_sync_together31_aunroll_x_in_i_valid_5_delay_2;
            redist4_sync_together31_aunroll_x_in_i_valid_5_q <= redist4_sync_together31_aunroll_x_in_i_valid_5_delay_3;
        end
    end

    // valid_fanout_reg0(REG,98)@6 + 1
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            valid_fanout_reg0_q <= $unsigned(1'b0);
        end
        else
        begin
            valid_fanout_reg0_q <= $unsigned(redist4_sync_together31_aunroll_x_in_i_valid_5_q);
        end
    end

    // c_arg8(CONSTANT,8)
    assign c_arg8_q = $unsigned(64'b0100000001000001000000000000000000000000000000000000000000000000);

    // dupName_2_i_unnamed_k2_zts6c_calc0_upper_bits_x_merged_bit_select(BITSELECT,217)@7
    assign dupName_2_i_unnamed_k2_zts6c_calc0_upper_bits_x_merged_bit_select_b = c_arg8_q[63:14];
    assign dupName_2_i_unnamed_k2_zts6c_calc0_upper_bits_x_merged_bit_select_c = c_arg8_q[13:0];

    // redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_notEnable(LOGICAL,272)
    assign redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_notEnable_q = $unsigned(~ (VCC_q));

    // redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_nor(LOGICAL,273)
    assign redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_nor_q = ~ (redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_notEnable_q | redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_sticky_ena_q);

    // redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_mem_last(CONSTANT,269)
    assign redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_mem_last_q = $unsigned(2'b01);

    // redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_cmp(LOGICAL,270)
    assign redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_cmp_q = $unsigned(redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_mem_last_q == redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_rdcnt_q ? 1'b1 : 1'b0);

    // redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_cmpReg(REG,271)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_cmpReg_q <= $unsigned(1'b0);
        end
        else
        begin
            redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_cmpReg_q <= $unsigned(redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_cmp_q);
        end
    end

    // redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_sticky_ena(REG,274)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_sticky_ena_q <= $unsigned(1'b0);
        end
        else if (redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_nor_q == 1'b1)
        begin
            redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_sticky_ena_q <= $unsigned(redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_cmpReg_q);
        end
    end

    // redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_enaAnd(LOGICAL,275)
    assign redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_enaAnd_q = redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_sticky_ena_q & VCC_q;

    // redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_rdcnt(COUNTER,267)
    // low=0, high=2, step=1, init=0
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_rdcnt_i <= 2'd0;
            redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_rdcnt_eq <= 1'b0;
        end
        else
        begin
            if (redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_rdcnt_i == 2'd1)
            begin
                redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_rdcnt_eq <= 1'b1;
            end
            else
            begin
                redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_rdcnt_eq <= 1'b0;
            end
            if (redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_rdcnt_eq == 1'b1)
            begin
                redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_rdcnt_i <= $unsigned(redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_rdcnt_i) + $unsigned(2'd2);
            end
            else
            begin
                redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_rdcnt_i <= $unsigned(redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_rdcnt_i) + $unsigned(2'd1);
            end
        end
    end
    assign redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_rdcnt_q = redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_rdcnt_i[1:0];

    // i_unnamed_k2_zts6c_calc12_vt_const_63(CONSTANT,19)
    assign i_unnamed_k2_zts6c_calc12_vt_const_63_q = $unsigned(32'b00000000000000000000000000000000);

    // redist2_sync_together31_aunroll_x_in_c0_eni3_2_tpl_1(DELAY,224)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist2_sync_together31_aunroll_x_in_c0_eni3_2_tpl_1_q <= '0;
        end
        else
        begin
            redist2_sync_together31_aunroll_x_in_c0_eni3_2_tpl_1_q <= $unsigned(in_c0_eni3_2_tpl);
        end
    end

    // i_unnamed_k2_zts6c_calc12_sel_x(BITSELECT,58)@2
    assign i_unnamed_k2_zts6c_calc12_sel_x_b = {32'b00000000000000000000000000000000, redist2_sync_together31_aunroll_x_in_c0_eni3_2_tpl_1_q[31:0]};

    // i_unnamed_k2_zts6c_calc12_vt_select_31(BITSELECT,21)@2
    assign i_unnamed_k2_zts6c_calc12_vt_select_31_b = i_unnamed_k2_zts6c_calc12_sel_x_b[31:0];

    // i_unnamed_k2_zts6c_calc12_vt_join(BITJOIN,20)@2
    assign i_unnamed_k2_zts6c_calc12_vt_join_q = {i_unnamed_k2_zts6c_calc12_vt_const_63_q, i_unnamed_k2_zts6c_calc12_vt_select_31_b};

    // redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_wraddr(REG,268)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_wraddr_q <= $unsigned(2'b10);
        end
        else
        begin
            redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_wraddr_q <= $unsigned(redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_rdcnt_q);
        end
    end

    // redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_mem(DUALMEM,266)
    assign redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_mem_ia = $unsigned(i_unnamed_k2_zts6c_calc12_vt_join_q);
    assign redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_mem_aa = redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_wraddr_q;
    assign redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_mem_ab = redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_rdcnt_q;
    assign redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_mem_reset0 = ~ (resetn);
    altera_syncram #(
        .ram_block_type("MLAB"),
        .operation_mode("DUAL_PORT"),
        .width_a(64),
        .widthad_a(2),
        .numwords_a(3),
        .width_b(64),
        .widthad_b(2),
        .numwords_b(3),
        .lpm_type("altera_syncram"),
        .width_byteena_a(1),
        .address_reg_b("CLOCK0"),
        .indata_reg_b("CLOCK0"),
        .rdcontrol_reg_b("CLOCK0"),
        .byteena_reg_b("CLOCK0"),
        .outdata_reg_b("CLOCK1"),
        .outdata_aclr_b("CLEAR1"),
        .clock_enable_input_a("NORMAL"),
        .clock_enable_input_b("NORMAL"),
        .clock_enable_output_b("NORMAL"),
        .read_during_write_mode_mixed_ports("DONT_CARE"),
        .power_up_uninitialized("TRUE"),
        .intended_device_family("Arria 10")
    ) redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_mem_dmem (
        .clocken1(redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_enaAnd_q[0]),
        .clocken0(1'b1),
        .clock0(clock),
        .aclr1(redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_mem_reset0),
        .clock1(clock),
        .address_a(redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_mem_aa),
        .data_a(redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_mem_ia),
        .wren_a(VCC_q[0]),
        .address_b(redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_mem_ab),
        .q_b(redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_mem_iq),
        .wren_b(),
        .rden_a(),
        .rden_b(),
        .data_b(),
        .clocken2(),
        .clocken3(),
        .aclr0(),
        .addressstall_a(),
        .addressstall_b(),
        .byteena_a(),
        .byteena_b(),
        .eccencbypass(),
        .eccencparity(),
        .sclr(),
        .address2_a(),
        .address2_b(),
        .q_a(),
        .eccstatus()
    );
    assign redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_mem_q = redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_mem_iq[63:0];

    // redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_outputreg0(DELAY,265)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_outputreg0_q <= '0;
        end
        else
        begin
            redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_outputreg0_q <= $unsigned(redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_mem_q);
        end
    end

    // i_unnamed_k2_zts6c_calc18(ADD,32)@7
    assign i_unnamed_k2_zts6c_calc18_a = {1'b0, redist5_bgTrunc_i_unnamed_k2_zts6c_calc17_sel_x_b_1_q};
    assign i_unnamed_k2_zts6c_calc18_b = {1'b0, redist10_i_unnamed_k2_zts6c_calc12_vt_join_q_5_outputreg0_q};
    assign i_unnamed_k2_zts6c_calc18_o = $unsigned(i_unnamed_k2_zts6c_calc18_a) + $unsigned(i_unnamed_k2_zts6c_calc18_b);
    assign i_unnamed_k2_zts6c_calc18_q = i_unnamed_k2_zts6c_calc18_o[64:0];

    // bgTrunc_i_unnamed_k2_zts6c_calc18_sel_x(BITSELECT,51)@7
    assign bgTrunc_i_unnamed_k2_zts6c_calc18_sel_x_b = i_unnamed_k2_zts6c_calc18_q[63:0];

    // dupName_2_i_unnamed_k2_zts6c_calc0_dupName_0_trunc_sel_x(BITSELECT,96)@7
    assign dupName_2_i_unnamed_k2_zts6c_calc0_dupName_0_trunc_sel_x_b = bgTrunc_i_unnamed_k2_zts6c_calc18_sel_x_b[13:0];

    // dupName_2_i_unnamed_k2_zts6c_calc0_narrow_x(BITSELECT,89)@7
    assign dupName_2_i_unnamed_k2_zts6c_calc0_narrow_x_b = dupName_2_i_unnamed_k2_zts6c_calc0_dupName_0_trunc_sel_x_b[11:0];

    // dupName_2_i_unnamed_k2_zts6c_calc0_shift_join_x(BITJOIN,90)@7
    assign dupName_2_i_unnamed_k2_zts6c_calc0_shift_join_x_q = {dupName_2_i_unnamed_k2_zts6c_calc0_narrow_x_b, i_unnamed_k2_zts6c_calc16_vt_const_1_q};

    // dupName_2_i_unnamed_k2_zts6c_calc0_add_x(ADD,86)@7
    assign dupName_2_i_unnamed_k2_zts6c_calc0_add_x_a = {1'b0, dupName_2_i_unnamed_k2_zts6c_calc0_upper_bits_x_merged_bit_select_c};
    assign dupName_2_i_unnamed_k2_zts6c_calc0_add_x_b = {1'b0, dupName_2_i_unnamed_k2_zts6c_calc0_shift_join_x_q};
    assign dupName_2_i_unnamed_k2_zts6c_calc0_add_x_o = $unsigned(dupName_2_i_unnamed_k2_zts6c_calc0_add_x_a) + $unsigned(dupName_2_i_unnamed_k2_zts6c_calc0_add_x_b);
    assign dupName_2_i_unnamed_k2_zts6c_calc0_add_x_q = dupName_2_i_unnamed_k2_zts6c_calc0_add_x_o[14:0];

    // dupName_2_i_unnamed_k2_zts6c_calc0_dupName_2_trunc_sel_x(BITSELECT,97)@7
    assign dupName_2_i_unnamed_k2_zts6c_calc0_dupName_2_trunc_sel_x_b = dupName_2_i_unnamed_k2_zts6c_calc0_add_x_q[13:0];

    // dupName_2_i_unnamed_k2_zts6c_calc0_append_upper_bits_x(BITJOIN,87)@7
    assign dupName_2_i_unnamed_k2_zts6c_calc0_append_upper_bits_x_q = {dupName_2_i_unnamed_k2_zts6c_calc0_upper_bits_x_merged_bit_select_b, dupName_2_i_unnamed_k2_zts6c_calc0_dupName_2_trunc_sel_x_b};

    // i_unnamed_k2_zts6c_calc19_vt_select_63(BITSELECT,35)@7
    assign i_unnamed_k2_zts6c_calc19_vt_select_63_b = dupName_2_i_unnamed_k2_zts6c_calc0_append_upper_bits_x_q[63:2];

    // i_unnamed_k2_zts6c_calc16_vt_const_1(CONSTANT,28)
    assign i_unnamed_k2_zts6c_calc16_vt_const_1_q = $unsigned(2'b00);

    // i_unnamed_k2_zts6c_calc19_vt_join(BITJOIN,34)@7
    assign i_unnamed_k2_zts6c_calc19_vt_join_q = {i_unnamed_k2_zts6c_calc19_vt_select_63_b, i_unnamed_k2_zts6c_calc16_vt_const_1_q};

    // redist3_sync_together31_aunroll_x_in_c0_eni3_3_tpl_1(DELAY,225)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist3_sync_together31_aunroll_x_in_c0_eni3_3_tpl_1_q <= '0;
        end
        else
        begin
            redist3_sync_together31_aunroll_x_in_c0_eni3_3_tpl_1_q <= $unsigned(in_c0_eni3_3_tpl);
        end
    end

    // i_unnamed_k2_zts6c_calc13_sel_x(BITSELECT,60)@2
    assign i_unnamed_k2_zts6c_calc13_sel_x_b = {32'b00000000000000000000000000000000, redist3_sync_together31_aunroll_x_in_c0_eni3_3_tpl_1_q[31:0]};

    // i_unnamed_k2_zts6c_calc13_vt_select_31(BITSELECT,25)@2
    assign i_unnamed_k2_zts6c_calc13_vt_select_31_b = i_unnamed_k2_zts6c_calc13_sel_x_b[31:0];

    // i_unnamed_k2_zts6c_calc13_vt_join(BITJOIN,24)@2
    assign i_unnamed_k2_zts6c_calc13_vt_join_q = {i_unnamed_k2_zts6c_calc12_vt_const_63_q, i_unnamed_k2_zts6c_calc13_vt_select_31_b};

    // i_unnamed_k2_zts6c_calc13_vt_join_narrowed_x(BITSELECT,61)@2
    assign i_unnamed_k2_zts6c_calc13_vt_join_narrowed_x_b = i_unnamed_k2_zts6c_calc13_vt_join_q[31:0];

    // i_unnamed_k2_zts6c_calc17_bs2_merged_bit_select(BITSELECT,221)@2
    assign i_unnamed_k2_zts6c_calc17_bs2_merged_bit_select_b = i_unnamed_k2_zts6c_calc13_vt_join_narrowed_x_b[31:18];
    assign i_unnamed_k2_zts6c_calc17_bs2_merged_bit_select_c = i_unnamed_k2_zts6c_calc13_vt_join_narrowed_x_b[17:0];

    // valid_fanout_reg1(REG,99)@1 + 1
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            valid_fanout_reg1_q <= $unsigned(1'b0);
        end
        else
        begin
            valid_fanout_reg1_q <= $unsigned(in_i_valid);
        end
    end

    // i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili2eee_cl_sycl_ranges_arg9_sync_buffer_k2_zts6c_calc6_aunroll_x(BLACKBOX,53)@0
    // in in_i_dependence@2
    // in in_valid_in@2
    // out out_valid_out@2
    // out out_buffer_out_0_tpl@2
    // out out_buffer_out_1_tpl@2
    k2_ZTS6c_calc_i_llvm_fpga_sync_buffer_s_0001uffer_k2_zts6c_calc0 thei_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili2eee_cl_sycl_ranges_arg9_sync_buffer_k2_zts6c_calc6_aunroll_x (
        .in_i_dependence(GND_q),
        .in_stall_in(GND_q),
        .in_valid_in(valid_fanout_reg1_q),
        .in_buffer_in_0_tpl(in_arg9_0_tpl),
        .in_buffer_in_1_tpl(in_arg9_1_tpl),
        .out_stall_out(),
        .out_valid_out(),
        .out_buffer_out_0_tpl(),
        .out_buffer_out_1_tpl(i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili2eee_cl_sycl_ranges_arg9_sync_buffer_k2_zts6c_calc6_aunroll_x_out_buffer_out_1_tpl),
        .clock(clock),
        .resetn(resetn)
    );

    // i_unnamed_k2_zts6c_calc17_bs1_merged_bit_select(BITSELECT,219)@2
    assign i_unnamed_k2_zts6c_calc17_bs1_merged_bit_select_b = i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili2eee_cl_sycl_ranges_arg9_sync_buffer_k2_zts6c_calc6_aunroll_x_out_buffer_out_1_tpl[63:54];
    assign i_unnamed_k2_zts6c_calc17_bs1_merged_bit_select_c = i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili2eee_cl_sycl_ranges_arg9_sync_buffer_k2_zts6c_calc6_aunroll_x_out_buffer_out_1_tpl[53:36];
    assign i_unnamed_k2_zts6c_calc17_bs1_merged_bit_select_d = i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili2eee_cl_sycl_ranges_arg9_sync_buffer_k2_zts6c_calc6_aunroll_x_out_buffer_out_1_tpl[35:18];
    assign i_unnamed_k2_zts6c_calc17_bs1_merged_bit_select_e = i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili2eee_cl_sycl_ranges_arg9_sync_buffer_k2_zts6c_calc6_aunroll_x_out_buffer_out_1_tpl[17:0];

    // i_unnamed_k2_zts6c_calc17_ma3_cma(CHAINMULTADD,213)@2 + 3
    assign i_unnamed_k2_zts6c_calc17_ma3_cma_reset = ~ (resetn);
    assign i_unnamed_k2_zts6c_calc17_ma3_cma_ena0 = 1'b1;
    assign i_unnamed_k2_zts6c_calc17_ma3_cma_ena1 = i_unnamed_k2_zts6c_calc17_ma3_cma_ena0;
    assign i_unnamed_k2_zts6c_calc17_ma3_cma_ena2 = i_unnamed_k2_zts6c_calc17_ma3_cma_ena0;

    assign i_unnamed_k2_zts6c_calc17_ma3_cma_a0 = {4'b0000, i_unnamed_k2_zts6c_calc17_bs1_merged_bit_select_b[9:0]};
    assign i_unnamed_k2_zts6c_calc17_ma3_cma_c0 = i_unnamed_k2_zts6c_calc17_bs2_merged_bit_select_c;
    assign i_unnamed_k2_zts6c_calc17_ma3_cma_a1 = i_unnamed_k2_zts6c_calc17_bs2_merged_bit_select_b;
    assign i_unnamed_k2_zts6c_calc17_ma3_cma_c1 = i_unnamed_k2_zts6c_calc17_bs1_merged_bit_select_c;
    twentynm_mac #(
        .operation_mode("m18x18_sumof2"),
        .use_chainadder("false"),
        .ay_scan_in_clock("0"),
        .ay_scan_in_width(14),
        .by_clock("0"),
        .by_width(14),
        .ax_clock("0"),
        .bx_clock("0"),
        .ax_width(18),
        .bx_width(18),
        .signed_may("false"),
        .signed_mby("false"),
        .signed_max("false"),
        .signed_mbx("false"),
        .input_pipeline_clock("2"),
        .output_clock("1"),
        .result_a_width(33)
    ) i_unnamed_k2_zts6c_calc17_ma3_cma_DSP0 (
        .clk({clock,clock,clock}),
        .ena({ i_unnamed_k2_zts6c_calc17_ma3_cma_ena2, i_unnamed_k2_zts6c_calc17_ma3_cma_ena1, i_unnamed_k2_zts6c_calc17_ma3_cma_ena0 }),
        .aclr({ i_unnamed_k2_zts6c_calc17_ma3_cma_reset, i_unnamed_k2_zts6c_calc17_ma3_cma_reset }),
        .ay(i_unnamed_k2_zts6c_calc17_ma3_cma_a1),
        .by(i_unnamed_k2_zts6c_calc17_ma3_cma_a0),
        .ax(i_unnamed_k2_zts6c_calc17_ma3_cma_c1),
        .bx(i_unnamed_k2_zts6c_calc17_ma3_cma_c0),
        .resulta(i_unnamed_k2_zts6c_calc17_ma3_cma_s0),
        .accumulate(),
        .loadconst(),
        .negate(),
        .sub(),
        .az(),
        .coefsela(),
        .bz(),
        .coefselb(),
        .scanin(),
        .scanout(),
        .chainin(),
        .chainout(),
        .resultb(),
        .dftout()
    );
    dspba_delay_ver #( .width(33), .depth(0), .reset_kind("ASYNC"), .phase(0), .modulus(1), .reset_high(1'b0) )
    i_unnamed_k2_zts6c_calc17_ma3_cma_delay ( .xin(i_unnamed_k2_zts6c_calc17_ma3_cma_s0), .xout(i_unnamed_k2_zts6c_calc17_ma3_cma_qq), .clk(clock), .aclr(resetn), .ena(1'b1) );
    assign i_unnamed_k2_zts6c_calc17_ma3_cma_q = $unsigned(i_unnamed_k2_zts6c_calc17_ma3_cma_qq[32:0]);

    // redist0_i_unnamed_k2_zts6c_calc17_ma3_cma_q_1(DELAY,222)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist0_i_unnamed_k2_zts6c_calc17_ma3_cma_q_1_q <= '0;
        end
        else
        begin
            redist0_i_unnamed_k2_zts6c_calc17_ma3_cma_q_1_q <= $unsigned(i_unnamed_k2_zts6c_calc17_ma3_cma_q);
        end
    end

    // i_unnamed_k2_zts6c_calc17_sums_align_4(BITSHIFT,164)@6
    assign i_unnamed_k2_zts6c_calc17_sums_align_4_qint = { redist0_i_unnamed_k2_zts6c_calc17_ma3_cma_q_1_q, 54'b000000000000000000000000000000000000000000000000000000 };
    assign i_unnamed_k2_zts6c_calc17_sums_align_4_q = i_unnamed_k2_zts6c_calc17_sums_align_4_qint[86:0];

    // i_unnamed_k2_zts6c_calc17_im0_cma(CHAINMULTADD,208)@2 + 3
    assign i_unnamed_k2_zts6c_calc17_im0_cma_reset = ~ (resetn);
    assign i_unnamed_k2_zts6c_calc17_im0_cma_ena0 = 1'b1;
    assign i_unnamed_k2_zts6c_calc17_im0_cma_ena1 = i_unnamed_k2_zts6c_calc17_im0_cma_ena0;
    assign i_unnamed_k2_zts6c_calc17_im0_cma_ena2 = i_unnamed_k2_zts6c_calc17_im0_cma_ena0;

    assign i_unnamed_k2_zts6c_calc17_im0_cma_a0 = i_unnamed_k2_zts6c_calc17_bs2_merged_bit_select_b;
    assign i_unnamed_k2_zts6c_calc17_im0_cma_c0 = i_unnamed_k2_zts6c_calc17_bs1_merged_bit_select_b;
    twentynm_mac #(
        .operation_mode("m18x18_full"),
        .ay_scan_in_clock("0"),
        .ay_scan_in_width(14),
        .ax_clock("0"),
        .ax_width(10),
        .signed_may("false"),
        .signed_max("false"),
        .input_pipeline_clock("2"),
        .output_clock("1"),
        .result_a_width(24)
    ) i_unnamed_k2_zts6c_calc17_im0_cma_DSP0 (
        .clk({clock,clock,clock}),
        .ena({ i_unnamed_k2_zts6c_calc17_im0_cma_ena2, i_unnamed_k2_zts6c_calc17_im0_cma_ena1, i_unnamed_k2_zts6c_calc17_im0_cma_ena0 }),
        .aclr({ i_unnamed_k2_zts6c_calc17_im0_cma_reset, i_unnamed_k2_zts6c_calc17_im0_cma_reset }),
        .ay(i_unnamed_k2_zts6c_calc17_im0_cma_a0),
        .ax(i_unnamed_k2_zts6c_calc17_im0_cma_c0),
        .resulta(i_unnamed_k2_zts6c_calc17_im0_cma_s0),
        .accumulate(),
        .loadconst(),
        .negate(),
        .sub(),
        .az(),
        .coefsela(),
        .bx(),
        .by(),
        .bz(),
        .coefselb(),
        .scanin(),
        .scanout(),
        .chainin(),
        .chainout(),
        .resultb(),
        .dftout()
    );
    dspba_delay_ver #( .width(24), .depth(0), .reset_kind("ASYNC"), .phase(0), .modulus(1), .reset_high(1'b0) )
    i_unnamed_k2_zts6c_calc17_im0_cma_delay ( .xin(i_unnamed_k2_zts6c_calc17_im0_cma_s0), .xout(i_unnamed_k2_zts6c_calc17_im0_cma_qq), .clk(clock), .aclr(resetn), .ena(1'b1) );
    assign i_unnamed_k2_zts6c_calc17_im0_cma_q = $unsigned(i_unnamed_k2_zts6c_calc17_im0_cma_qq[23:0]);

    // i_unnamed_k2_zts6c_calc17_sums_align_2(BITSHIFT,162)@5
    assign i_unnamed_k2_zts6c_calc17_sums_align_2_qint = { i_unnamed_k2_zts6c_calc17_im0_cma_q, 17'b00000000000000000 };
    assign i_unnamed_k2_zts6c_calc17_sums_align_2_q = i_unnamed_k2_zts6c_calc17_sums_align_2_qint[40:0];

    // i_unnamed_k2_zts6c_calc17_ma13_cma(CHAINMULTADD,215)@2 + 3
    assign i_unnamed_k2_zts6c_calc17_ma13_cma_reset = ~ (resetn);
    assign i_unnamed_k2_zts6c_calc17_ma13_cma_ena0 = 1'b1;
    assign i_unnamed_k2_zts6c_calc17_ma13_cma_ena1 = i_unnamed_k2_zts6c_calc17_ma13_cma_ena0;
    assign i_unnamed_k2_zts6c_calc17_ma13_cma_ena2 = i_unnamed_k2_zts6c_calc17_ma13_cma_ena0;

    assign i_unnamed_k2_zts6c_calc17_ma13_cma_a0 = {4'b0000, i_unnamed_k2_zts6c_calc17_bs2_merged_bit_select_b[13:0]};
    assign i_unnamed_k2_zts6c_calc17_ma13_cma_c0 = i_unnamed_k2_zts6c_calc17_bs1_merged_bit_select_e;
    assign i_unnamed_k2_zts6c_calc17_ma13_cma_a1 = i_unnamed_k2_zts6c_calc17_bs2_merged_bit_select_c;
    assign i_unnamed_k2_zts6c_calc17_ma13_cma_c1 = i_unnamed_k2_zts6c_calc17_bs1_merged_bit_select_d;
    twentynm_mac #(
        .operation_mode("m18x18_sumof2"),
        .use_chainadder("false"),
        .ay_scan_in_clock("0"),
        .ay_scan_in_width(18),
        .by_clock("0"),
        .by_width(18),
        .ax_clock("0"),
        .bx_clock("0"),
        .ax_width(18),
        .bx_width(18),
        .signed_may("false"),
        .signed_mby("false"),
        .signed_max("false"),
        .signed_mbx("false"),
        .input_pipeline_clock("2"),
        .output_clock("1"),
        .result_a_width(37)
    ) i_unnamed_k2_zts6c_calc17_ma13_cma_DSP0 (
        .clk({clock,clock,clock}),
        .ena({ i_unnamed_k2_zts6c_calc17_ma13_cma_ena2, i_unnamed_k2_zts6c_calc17_ma13_cma_ena1, i_unnamed_k2_zts6c_calc17_ma13_cma_ena0 }),
        .aclr({ i_unnamed_k2_zts6c_calc17_ma13_cma_reset, i_unnamed_k2_zts6c_calc17_ma13_cma_reset }),
        .ay(i_unnamed_k2_zts6c_calc17_ma13_cma_a1),
        .by(i_unnamed_k2_zts6c_calc17_ma13_cma_a0),
        .ax(i_unnamed_k2_zts6c_calc17_ma13_cma_c1),
        .bx(i_unnamed_k2_zts6c_calc17_ma13_cma_c0),
        .resulta(i_unnamed_k2_zts6c_calc17_ma13_cma_s0),
        .accumulate(),
        .loadconst(),
        .negate(),
        .sub(),
        .az(),
        .coefsela(),
        .bz(),
        .coefselb(),
        .scanin(),
        .scanout(),
        .chainin(),
        .chainout(),
        .resultb(),
        .dftout()
    );
    dspba_delay_ver #( .width(37), .depth(0), .reset_kind("ASYNC"), .phase(0), .modulus(1), .reset_high(1'b0) )
    i_unnamed_k2_zts6c_calc17_ma13_cma_delay ( .xin(i_unnamed_k2_zts6c_calc17_ma13_cma_s0), .xout(i_unnamed_k2_zts6c_calc17_ma13_cma_qq), .clk(clock), .aclr(resetn), .ena(1'b1) );
    assign i_unnamed_k2_zts6c_calc17_ma13_cma_q = $unsigned(i_unnamed_k2_zts6c_calc17_ma13_cma_qq[36:0]);

    // i_unnamed_k2_zts6c_calc17_sums_align_1(BITSHIFT,161)@5
    assign i_unnamed_k2_zts6c_calc17_sums_align_1_qint = { i_unnamed_k2_zts6c_calc17_ma13_cma_q, 18'b000000000000000000 };
    assign i_unnamed_k2_zts6c_calc17_sums_align_1_q = i_unnamed_k2_zts6c_calc17_sums_align_1_qint[54:0];

    // i_unnamed_k2_zts6c_calc17_sums_join_3(BITJOIN,163)@5
    assign i_unnamed_k2_zts6c_calc17_sums_join_3_q = {i_unnamed_k2_zts6c_calc17_sums_align_2_q, i_unnamed_k2_zts6c_calc17_sums_align_1_q};

    // i_unnamed_k2_zts6c_calc17_ma8_cma(CHAINMULTADD,214)@2 + 3
    assign i_unnamed_k2_zts6c_calc17_ma8_cma_reset = ~ (resetn);
    assign i_unnamed_k2_zts6c_calc17_ma8_cma_ena0 = 1'b1;
    assign i_unnamed_k2_zts6c_calc17_ma8_cma_ena1 = i_unnamed_k2_zts6c_calc17_ma8_cma_ena0;
    assign i_unnamed_k2_zts6c_calc17_ma8_cma_ena2 = i_unnamed_k2_zts6c_calc17_ma8_cma_ena0;

    assign i_unnamed_k2_zts6c_calc17_ma8_cma_a0 = {4'b0000, i_unnamed_k2_zts6c_calc17_bs2_merged_bit_select_b[13:0]};
    assign i_unnamed_k2_zts6c_calc17_ma8_cma_c0 = i_unnamed_k2_zts6c_calc17_bs1_merged_bit_select_d;
    assign i_unnamed_k2_zts6c_calc17_ma8_cma_a1 = i_unnamed_k2_zts6c_calc17_bs2_merged_bit_select_c;
    assign i_unnamed_k2_zts6c_calc17_ma8_cma_c1 = i_unnamed_k2_zts6c_calc17_bs1_merged_bit_select_c;
    twentynm_mac #(
        .operation_mode("m18x18_sumof2"),
        .use_chainadder("false"),
        .ay_scan_in_clock("0"),
        .ay_scan_in_width(18),
        .by_clock("0"),
        .by_width(18),
        .ax_clock("0"),
        .bx_clock("0"),
        .ax_width(18),
        .bx_width(18),
        .signed_may("false"),
        .signed_mby("false"),
        .signed_max("false"),
        .signed_mbx("false"),
        .input_pipeline_clock("2"),
        .output_clock("1"),
        .result_a_width(37)
    ) i_unnamed_k2_zts6c_calc17_ma8_cma_DSP0 (
        .clk({clock,clock,clock}),
        .ena({ i_unnamed_k2_zts6c_calc17_ma8_cma_ena2, i_unnamed_k2_zts6c_calc17_ma8_cma_ena1, i_unnamed_k2_zts6c_calc17_ma8_cma_ena0 }),
        .aclr({ i_unnamed_k2_zts6c_calc17_ma8_cma_reset, i_unnamed_k2_zts6c_calc17_ma8_cma_reset }),
        .ay(i_unnamed_k2_zts6c_calc17_ma8_cma_a1),
        .by(i_unnamed_k2_zts6c_calc17_ma8_cma_a0),
        .ax(i_unnamed_k2_zts6c_calc17_ma8_cma_c1),
        .bx(i_unnamed_k2_zts6c_calc17_ma8_cma_c0),
        .resulta(i_unnamed_k2_zts6c_calc17_ma8_cma_s0),
        .accumulate(),
        .loadconst(),
        .negate(),
        .sub(),
        .az(),
        .coefsela(),
        .bz(),
        .coefselb(),
        .scanin(),
        .scanout(),
        .chainin(),
        .chainout(),
        .resultb(),
        .dftout()
    );
    dspba_delay_ver #( .width(37), .depth(0), .reset_kind("ASYNC"), .phase(0), .modulus(1), .reset_high(1'b0) )
    i_unnamed_k2_zts6c_calc17_ma8_cma_delay ( .xin(i_unnamed_k2_zts6c_calc17_ma8_cma_s0), .xout(i_unnamed_k2_zts6c_calc17_ma8_cma_qq), .clk(clock), .aclr(resetn), .ena(1'b1) );
    assign i_unnamed_k2_zts6c_calc17_ma8_cma_q = $unsigned(i_unnamed_k2_zts6c_calc17_ma8_cma_qq[36:0]);

    // i_unnamed_k2_zts6c_calc17_im18_cma(CHAINMULTADD,209)@2 + 3
    assign i_unnamed_k2_zts6c_calc17_im18_cma_reset = ~ (resetn);
    assign i_unnamed_k2_zts6c_calc17_im18_cma_ena0 = 1'b1;
    assign i_unnamed_k2_zts6c_calc17_im18_cma_ena1 = i_unnamed_k2_zts6c_calc17_im18_cma_ena0;
    assign i_unnamed_k2_zts6c_calc17_im18_cma_ena2 = i_unnamed_k2_zts6c_calc17_im18_cma_ena0;

    assign i_unnamed_k2_zts6c_calc17_im18_cma_a0 = i_unnamed_k2_zts6c_calc17_bs1_merged_bit_select_e;
    assign i_unnamed_k2_zts6c_calc17_im18_cma_c0 = i_unnamed_k2_zts6c_calc17_bs2_merged_bit_select_c;
    twentynm_mac #(
        .operation_mode("m18x18_full"),
        .ay_scan_in_clock("0"),
        .ay_scan_in_width(18),
        .ax_clock("0"),
        .ax_width(18),
        .signed_may("false"),
        .signed_max("false"),
        .input_pipeline_clock("2"),
        .output_clock("1"),
        .result_a_width(36)
    ) i_unnamed_k2_zts6c_calc17_im18_cma_DSP0 (
        .clk({clock,clock,clock}),
        .ena({ i_unnamed_k2_zts6c_calc17_im18_cma_ena2, i_unnamed_k2_zts6c_calc17_im18_cma_ena1, i_unnamed_k2_zts6c_calc17_im18_cma_ena0 }),
        .aclr({ i_unnamed_k2_zts6c_calc17_im18_cma_reset, i_unnamed_k2_zts6c_calc17_im18_cma_reset }),
        .ay(i_unnamed_k2_zts6c_calc17_im18_cma_a0),
        .ax(i_unnamed_k2_zts6c_calc17_im18_cma_c0),
        .resulta(i_unnamed_k2_zts6c_calc17_im18_cma_s0),
        .accumulate(),
        .loadconst(),
        .negate(),
        .sub(),
        .az(),
        .coefsela(),
        .bx(),
        .by(),
        .bz(),
        .coefselb(),
        .scanin(),
        .scanout(),
        .chainin(),
        .chainout(),
        .resultb(),
        .dftout()
    );
    dspba_delay_ver #( .width(36), .depth(0), .reset_kind("ASYNC"), .phase(0), .modulus(1), .reset_high(1'b0) )
    i_unnamed_k2_zts6c_calc17_im18_cma_delay ( .xin(i_unnamed_k2_zts6c_calc17_im18_cma_s0), .xout(i_unnamed_k2_zts6c_calc17_im18_cma_qq), .clk(clock), .aclr(resetn), .ena(1'b1) );
    assign i_unnamed_k2_zts6c_calc17_im18_cma_q = $unsigned(i_unnamed_k2_zts6c_calc17_im18_cma_qq[35:0]);

    // i_unnamed_k2_zts6c_calc17_sums_join_0(BITJOIN,160)@5
    assign i_unnamed_k2_zts6c_calc17_sums_join_0_q = {i_unnamed_k2_zts6c_calc17_ma8_cma_q, i_unnamed_k2_zts6c_calc17_im18_cma_q};

    // i_unnamed_k2_zts6c_calc17_sums_result_add_0_0(ADD,166)@5 + 1
    assign i_unnamed_k2_zts6c_calc17_sums_result_add_0_0_a = {24'b000000000000000000000000, i_unnamed_k2_zts6c_calc17_sums_join_0_q};
    assign i_unnamed_k2_zts6c_calc17_sums_result_add_0_0_b = {1'b0, i_unnamed_k2_zts6c_calc17_sums_join_3_q};
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            i_unnamed_k2_zts6c_calc17_sums_result_add_0_0_o <= 97'b0;
        end
        else
        begin
            i_unnamed_k2_zts6c_calc17_sums_result_add_0_0_o <= $unsigned(i_unnamed_k2_zts6c_calc17_sums_result_add_0_0_a) + $unsigned(i_unnamed_k2_zts6c_calc17_sums_result_add_0_0_b);
        end
    end
    assign i_unnamed_k2_zts6c_calc17_sums_result_add_0_0_q = i_unnamed_k2_zts6c_calc17_sums_result_add_0_0_o[96:0];

    // i_unnamed_k2_zts6c_calc17_sums_result_add_1_0(ADD,167)@6
    assign i_unnamed_k2_zts6c_calc17_sums_result_add_1_0_a = {1'b0, i_unnamed_k2_zts6c_calc17_sums_result_add_0_0_q};
    assign i_unnamed_k2_zts6c_calc17_sums_result_add_1_0_b = {11'b00000000000, i_unnamed_k2_zts6c_calc17_sums_align_4_q};
    assign i_unnamed_k2_zts6c_calc17_sums_result_add_1_0_o = $unsigned(i_unnamed_k2_zts6c_calc17_sums_result_add_1_0_a) + $unsigned(i_unnamed_k2_zts6c_calc17_sums_result_add_1_0_b);
    assign i_unnamed_k2_zts6c_calc17_sums_result_add_1_0_q = i_unnamed_k2_zts6c_calc17_sums_result_add_1_0_o[97:0];

    // i_unnamed_k2_zts6c_calc17_extender_x(BITJOIN,64)@6
    assign i_unnamed_k2_zts6c_calc17_extender_x_q = {i_unnamed_k2_zts6c_calc12_vt_const_63_q, i_unnamed_k2_zts6c_calc17_sums_result_add_1_0_q[95:0]};

    // bgTrunc_i_unnamed_k2_zts6c_calc17_sel_x(BITSELECT,50)@6
    assign bgTrunc_i_unnamed_k2_zts6c_calc17_sel_x_b = i_unnamed_k2_zts6c_calc17_extender_x_q[63:0];

    // redist5_bgTrunc_i_unnamed_k2_zts6c_calc17_sel_x_b_1(DELAY,227)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist5_bgTrunc_i_unnamed_k2_zts6c_calc17_sel_x_b_1_q <= '0;
        end
        else
        begin
            redist5_bgTrunc_i_unnamed_k2_zts6c_calc17_sel_x_b_1_q <= $unsigned(bgTrunc_i_unnamed_k2_zts6c_calc17_sel_x_b);
        end
    end

    // c_arg0(CONSTANT,7)
    assign c_arg0_q = $unsigned(64'b0100000001000000000000000000000000000000000000000000000000000000);

    // dupName_1_i_unnamed_k2_zts6c_calc0_upper_bits_x_merged_bit_select(BITSELECT,216)@7
    assign dupName_1_i_unnamed_k2_zts6c_calc0_upper_bits_x_merged_bit_select_b = c_arg0_q[63:14];
    assign dupName_1_i_unnamed_k2_zts6c_calc0_upper_bits_x_merged_bit_select_c = c_arg0_q[13:0];

    // redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_notEnable(LOGICAL,261)
    assign redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_notEnable_q = $unsigned(~ (VCC_q));

    // redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_nor(LOGICAL,262)
    assign redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_nor_q = ~ (redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_notEnable_q | redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_sticky_ena_q);

    // redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_mem_last(CONSTANT,258)
    assign redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_mem_last_q = $unsigned(2'b01);

    // redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_cmp(LOGICAL,259)
    assign redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_cmp_q = $unsigned(redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_mem_last_q == redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_rdcnt_q ? 1'b1 : 1'b0);

    // redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_cmpReg(REG,260)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_cmpReg_q <= $unsigned(1'b0);
        end
        else
        begin
            redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_cmpReg_q <= $unsigned(redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_cmp_q);
        end
    end

    // redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_sticky_ena(REG,263)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_sticky_ena_q <= $unsigned(1'b0);
        end
        else if (redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_nor_q == 1'b1)
        begin
            redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_sticky_ena_q <= $unsigned(redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_cmpReg_q);
        end
    end

    // redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_enaAnd(LOGICAL,264)
    assign redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_enaAnd_q = redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_sticky_ena_q & VCC_q;

    // redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_rdcnt(COUNTER,256)
    // low=0, high=2, step=1, init=0
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_rdcnt_i <= 2'd0;
            redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_rdcnt_eq <= 1'b0;
        end
        else
        begin
            if (redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_rdcnt_i == 2'd1)
            begin
                redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_rdcnt_eq <= 1'b1;
            end
            else
            begin
                redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_rdcnt_eq <= 1'b0;
            end
            if (redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_rdcnt_eq == 1'b1)
            begin
                redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_rdcnt_i <= $unsigned(redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_rdcnt_i) + $unsigned(2'd2);
            end
            else
            begin
                redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_rdcnt_i <= $unsigned(redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_rdcnt_i) + $unsigned(2'd1);
            end
        end
    end
    assign redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_rdcnt_q = redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_rdcnt_i[1:0];

    // redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_wraddr(REG,257)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_wraddr_q <= $unsigned(2'b10);
        end
        else
        begin
            redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_wraddr_q <= $unsigned(redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_rdcnt_q);
        end
    end

    // redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_mem(DUALMEM,255)
    assign redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_mem_ia = $unsigned(i_unnamed_k2_zts6c_calc13_vt_join_q);
    assign redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_mem_aa = redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_wraddr_q;
    assign redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_mem_ab = redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_rdcnt_q;
    assign redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_mem_reset0 = ~ (resetn);
    altera_syncram #(
        .ram_block_type("MLAB"),
        .operation_mode("DUAL_PORT"),
        .width_a(64),
        .widthad_a(2),
        .numwords_a(3),
        .width_b(64),
        .widthad_b(2),
        .numwords_b(3),
        .lpm_type("altera_syncram"),
        .width_byteena_a(1),
        .address_reg_b("CLOCK0"),
        .indata_reg_b("CLOCK0"),
        .rdcontrol_reg_b("CLOCK0"),
        .byteena_reg_b("CLOCK0"),
        .outdata_reg_b("CLOCK1"),
        .outdata_aclr_b("CLEAR1"),
        .clock_enable_input_a("NORMAL"),
        .clock_enable_input_b("NORMAL"),
        .clock_enable_output_b("NORMAL"),
        .read_during_write_mode_mixed_ports("DONT_CARE"),
        .power_up_uninitialized("TRUE"),
        .intended_device_family("Arria 10")
    ) redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_mem_dmem (
        .clocken1(redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_enaAnd_q[0]),
        .clocken0(1'b1),
        .clock0(clock),
        .aclr1(redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_mem_reset0),
        .clock1(clock),
        .address_a(redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_mem_aa),
        .data_a(redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_mem_ia),
        .wren_a(VCC_q[0]),
        .address_b(redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_mem_ab),
        .q_b(redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_mem_iq),
        .wren_b(),
        .rden_a(),
        .rden_b(),
        .data_b(),
        .clocken2(),
        .clocken3(),
        .aclr0(),
        .addressstall_a(),
        .addressstall_b(),
        .byteena_a(),
        .byteena_b(),
        .eccencbypass(),
        .eccencparity(),
        .sclr(),
        .address2_a(),
        .address2_b(),
        .q_a(),
        .eccstatus()
    );
    assign redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_mem_q = redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_mem_iq[63:0];

    // redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_outputreg0(DELAY,254)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_outputreg0_q <= '0;
        end
        else
        begin
            redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_outputreg0_q <= $unsigned(redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_mem_q);
        end
    end

    // i_unnamed_k2_zts6c_calc15(ADD,27)@7
    assign i_unnamed_k2_zts6c_calc15_a = {1'b0, redist6_bgTrunc_i_unnamed_k2_zts6c_calc14_sel_x_b_1_q};
    assign i_unnamed_k2_zts6c_calc15_b = {1'b0, redist9_i_unnamed_k2_zts6c_calc13_vt_join_q_5_outputreg0_q};
    assign i_unnamed_k2_zts6c_calc15_o = $unsigned(i_unnamed_k2_zts6c_calc15_a) + $unsigned(i_unnamed_k2_zts6c_calc15_b);
    assign i_unnamed_k2_zts6c_calc15_q = i_unnamed_k2_zts6c_calc15_o[64:0];

    // bgTrunc_i_unnamed_k2_zts6c_calc15_sel_x(BITSELECT,49)@7
    assign bgTrunc_i_unnamed_k2_zts6c_calc15_sel_x_b = i_unnamed_k2_zts6c_calc15_q[63:0];

    // dupName_1_i_unnamed_k2_zts6c_calc0_dupName_0_trunc_sel_x(BITSELECT,84)@7
    assign dupName_1_i_unnamed_k2_zts6c_calc0_dupName_0_trunc_sel_x_b = bgTrunc_i_unnamed_k2_zts6c_calc15_sel_x_b[13:0];

    // dupName_1_i_unnamed_k2_zts6c_calc0_narrow_x(BITSELECT,77)@7
    assign dupName_1_i_unnamed_k2_zts6c_calc0_narrow_x_b = dupName_1_i_unnamed_k2_zts6c_calc0_dupName_0_trunc_sel_x_b[11:0];

    // dupName_1_i_unnamed_k2_zts6c_calc0_shift_join_x(BITJOIN,78)@7
    assign dupName_1_i_unnamed_k2_zts6c_calc0_shift_join_x_q = {dupName_1_i_unnamed_k2_zts6c_calc0_narrow_x_b, i_unnamed_k2_zts6c_calc16_vt_const_1_q};

    // dupName_1_i_unnamed_k2_zts6c_calc0_add_x(ADD,74)@7
    assign dupName_1_i_unnamed_k2_zts6c_calc0_add_x_a = {1'b0, dupName_1_i_unnamed_k2_zts6c_calc0_upper_bits_x_merged_bit_select_c};
    assign dupName_1_i_unnamed_k2_zts6c_calc0_add_x_b = {1'b0, dupName_1_i_unnamed_k2_zts6c_calc0_shift_join_x_q};
    assign dupName_1_i_unnamed_k2_zts6c_calc0_add_x_o = $unsigned(dupName_1_i_unnamed_k2_zts6c_calc0_add_x_a) + $unsigned(dupName_1_i_unnamed_k2_zts6c_calc0_add_x_b);
    assign dupName_1_i_unnamed_k2_zts6c_calc0_add_x_q = dupName_1_i_unnamed_k2_zts6c_calc0_add_x_o[14:0];

    // dupName_1_i_unnamed_k2_zts6c_calc0_dupName_2_trunc_sel_x(BITSELECT,85)@7
    assign dupName_1_i_unnamed_k2_zts6c_calc0_dupName_2_trunc_sel_x_b = dupName_1_i_unnamed_k2_zts6c_calc0_add_x_q[13:0];

    // dupName_1_i_unnamed_k2_zts6c_calc0_append_upper_bits_x(BITJOIN,75)@7
    assign dupName_1_i_unnamed_k2_zts6c_calc0_append_upper_bits_x_q = {dupName_1_i_unnamed_k2_zts6c_calc0_upper_bits_x_merged_bit_select_b, dupName_1_i_unnamed_k2_zts6c_calc0_dupName_2_trunc_sel_x_b};

    // i_unnamed_k2_zts6c_calc16_vt_select_63(BITSELECT,30)@7
    assign i_unnamed_k2_zts6c_calc16_vt_select_63_b = dupName_1_i_unnamed_k2_zts6c_calc0_append_upper_bits_x_q[63:2];

    // i_unnamed_k2_zts6c_calc16_vt_join(BITJOIN,29)@7
    assign i_unnamed_k2_zts6c_calc16_vt_join_q = {i_unnamed_k2_zts6c_calc16_vt_select_63_b, i_unnamed_k2_zts6c_calc16_vt_const_1_q};

    // i_unnamed_k2_zts6c_calc12_vt_join_narrowed_x(BITSELECT,59)@2
    assign i_unnamed_k2_zts6c_calc12_vt_join_narrowed_x_b = i_unnamed_k2_zts6c_calc12_vt_join_q[31:0];

    // i_unnamed_k2_zts6c_calc14_bs2_merged_bit_select(BITSELECT,220)@2
    assign i_unnamed_k2_zts6c_calc14_bs2_merged_bit_select_b = i_unnamed_k2_zts6c_calc12_vt_join_narrowed_x_b[31:18];
    assign i_unnamed_k2_zts6c_calc14_bs2_merged_bit_select_c = i_unnamed_k2_zts6c_calc12_vt_join_narrowed_x_b[17:0];

    // valid_fanout_reg2(REG,100)@1 + 1
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            valid_fanout_reg2_q <= $unsigned(1'b0);
        end
        else
        begin
            valid_fanout_reg2_q <= $unsigned(in_i_valid);
        end
    end

    // i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili2eee_cl_sycl_ranges_arg1_sync_buffer_k2_zts6c_calc8_aunroll_x(BLACKBOX,52)@0
    // in in_i_dependence@2
    // in in_valid_in@2
    // out out_valid_out@2
    // out out_buffer_out_0_tpl@2
    // out out_buffer_out_1_tpl@2
    k2_ZTS6c_calc_i_llvm_fpga_sync_buffer_s_0000uffer_k2_zts6c_calc0 thei_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili2eee_cl_sycl_ranges_arg1_sync_buffer_k2_zts6c_calc8_aunroll_x (
        .in_i_dependence(GND_q),
        .in_stall_in(GND_q),
        .in_valid_in(valid_fanout_reg2_q),
        .in_buffer_in_0_tpl(in_arg1_0_tpl),
        .in_buffer_in_1_tpl(in_arg1_1_tpl),
        .out_stall_out(),
        .out_valid_out(),
        .out_buffer_out_0_tpl(),
        .out_buffer_out_1_tpl(i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili2eee_cl_sycl_ranges_arg1_sync_buffer_k2_zts6c_calc8_aunroll_x_out_buffer_out_1_tpl),
        .clock(clock),
        .resetn(resetn)
    );

    // i_unnamed_k2_zts6c_calc14_bs1_merged_bit_select(BITSELECT,218)@2
    assign i_unnamed_k2_zts6c_calc14_bs1_merged_bit_select_b = i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili2eee_cl_sycl_ranges_arg1_sync_buffer_k2_zts6c_calc8_aunroll_x_out_buffer_out_1_tpl[63:54];
    assign i_unnamed_k2_zts6c_calc14_bs1_merged_bit_select_c = i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili2eee_cl_sycl_ranges_arg1_sync_buffer_k2_zts6c_calc8_aunroll_x_out_buffer_out_1_tpl[53:36];
    assign i_unnamed_k2_zts6c_calc14_bs1_merged_bit_select_d = i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili2eee_cl_sycl_ranges_arg1_sync_buffer_k2_zts6c_calc8_aunroll_x_out_buffer_out_1_tpl[35:18];
    assign i_unnamed_k2_zts6c_calc14_bs1_merged_bit_select_e = i_llvm_fpga_sync_buffer_s_class_ztsn2cl4sycl5rangeili2eee_cl_sycl_ranges_arg1_sync_buffer_k2_zts6c_calc8_aunroll_x_out_buffer_out_1_tpl[17:0];

    // i_unnamed_k2_zts6c_calc14_ma3_cma(CHAINMULTADD,210)@2 + 3
    assign i_unnamed_k2_zts6c_calc14_ma3_cma_reset = ~ (resetn);
    assign i_unnamed_k2_zts6c_calc14_ma3_cma_ena0 = 1'b1;
    assign i_unnamed_k2_zts6c_calc14_ma3_cma_ena1 = i_unnamed_k2_zts6c_calc14_ma3_cma_ena0;
    assign i_unnamed_k2_zts6c_calc14_ma3_cma_ena2 = i_unnamed_k2_zts6c_calc14_ma3_cma_ena0;

    assign i_unnamed_k2_zts6c_calc14_ma3_cma_a0 = {4'b0000, i_unnamed_k2_zts6c_calc14_bs1_merged_bit_select_b[9:0]};
    assign i_unnamed_k2_zts6c_calc14_ma3_cma_c0 = i_unnamed_k2_zts6c_calc14_bs2_merged_bit_select_c;
    assign i_unnamed_k2_zts6c_calc14_ma3_cma_a1 = i_unnamed_k2_zts6c_calc14_bs2_merged_bit_select_b;
    assign i_unnamed_k2_zts6c_calc14_ma3_cma_c1 = i_unnamed_k2_zts6c_calc14_bs1_merged_bit_select_c;
    twentynm_mac #(
        .operation_mode("m18x18_sumof2"),
        .use_chainadder("false"),
        .ay_scan_in_clock("0"),
        .ay_scan_in_width(14),
        .by_clock("0"),
        .by_width(14),
        .ax_clock("0"),
        .bx_clock("0"),
        .ax_width(18),
        .bx_width(18),
        .signed_may("false"),
        .signed_mby("false"),
        .signed_max("false"),
        .signed_mbx("false"),
        .input_pipeline_clock("2"),
        .output_clock("1"),
        .result_a_width(33)
    ) i_unnamed_k2_zts6c_calc14_ma3_cma_DSP0 (
        .clk({clock,clock,clock}),
        .ena({ i_unnamed_k2_zts6c_calc14_ma3_cma_ena2, i_unnamed_k2_zts6c_calc14_ma3_cma_ena1, i_unnamed_k2_zts6c_calc14_ma3_cma_ena0 }),
        .aclr({ i_unnamed_k2_zts6c_calc14_ma3_cma_reset, i_unnamed_k2_zts6c_calc14_ma3_cma_reset }),
        .ay(i_unnamed_k2_zts6c_calc14_ma3_cma_a1),
        .by(i_unnamed_k2_zts6c_calc14_ma3_cma_a0),
        .ax(i_unnamed_k2_zts6c_calc14_ma3_cma_c1),
        .bx(i_unnamed_k2_zts6c_calc14_ma3_cma_c0),
        .resulta(i_unnamed_k2_zts6c_calc14_ma3_cma_s0),
        .accumulate(),
        .loadconst(),
        .negate(),
        .sub(),
        .az(),
        .coefsela(),
        .bz(),
        .coefselb(),
        .scanin(),
        .scanout(),
        .chainin(),
        .chainout(),
        .resultb(),
        .dftout()
    );
    dspba_delay_ver #( .width(33), .depth(0), .reset_kind("ASYNC"), .phase(0), .modulus(1), .reset_high(1'b0) )
    i_unnamed_k2_zts6c_calc14_ma3_cma_delay ( .xin(i_unnamed_k2_zts6c_calc14_ma3_cma_s0), .xout(i_unnamed_k2_zts6c_calc14_ma3_cma_qq), .clk(clock), .aclr(resetn), .ena(1'b1) );
    assign i_unnamed_k2_zts6c_calc14_ma3_cma_q = $unsigned(i_unnamed_k2_zts6c_calc14_ma3_cma_qq[32:0]);

    // redist1_i_unnamed_k2_zts6c_calc14_ma3_cma_q_1(DELAY,223)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist1_i_unnamed_k2_zts6c_calc14_ma3_cma_q_1_q <= '0;
        end
        else
        begin
            redist1_i_unnamed_k2_zts6c_calc14_ma3_cma_q_1_q <= $unsigned(i_unnamed_k2_zts6c_calc14_ma3_cma_q);
        end
    end

    // i_unnamed_k2_zts6c_calc14_sums_align_4(BITSHIFT,135)@6
    assign i_unnamed_k2_zts6c_calc14_sums_align_4_qint = { redist1_i_unnamed_k2_zts6c_calc14_ma3_cma_q_1_q, 54'b000000000000000000000000000000000000000000000000000000 };
    assign i_unnamed_k2_zts6c_calc14_sums_align_4_q = i_unnamed_k2_zts6c_calc14_sums_align_4_qint[86:0];

    // i_unnamed_k2_zts6c_calc14_im0_cma(CHAINMULTADD,206)@2 + 3
    assign i_unnamed_k2_zts6c_calc14_im0_cma_reset = ~ (resetn);
    assign i_unnamed_k2_zts6c_calc14_im0_cma_ena0 = 1'b1;
    assign i_unnamed_k2_zts6c_calc14_im0_cma_ena1 = i_unnamed_k2_zts6c_calc14_im0_cma_ena0;
    assign i_unnamed_k2_zts6c_calc14_im0_cma_ena2 = i_unnamed_k2_zts6c_calc14_im0_cma_ena0;

    assign i_unnamed_k2_zts6c_calc14_im0_cma_a0 = i_unnamed_k2_zts6c_calc14_bs2_merged_bit_select_b;
    assign i_unnamed_k2_zts6c_calc14_im0_cma_c0 = i_unnamed_k2_zts6c_calc14_bs1_merged_bit_select_b;
    twentynm_mac #(
        .operation_mode("m18x18_full"),
        .ay_scan_in_clock("0"),
        .ay_scan_in_width(14),
        .ax_clock("0"),
        .ax_width(10),
        .signed_may("false"),
        .signed_max("false"),
        .input_pipeline_clock("2"),
        .output_clock("1"),
        .result_a_width(24)
    ) i_unnamed_k2_zts6c_calc14_im0_cma_DSP0 (
        .clk({clock,clock,clock}),
        .ena({ i_unnamed_k2_zts6c_calc14_im0_cma_ena2, i_unnamed_k2_zts6c_calc14_im0_cma_ena1, i_unnamed_k2_zts6c_calc14_im0_cma_ena0 }),
        .aclr({ i_unnamed_k2_zts6c_calc14_im0_cma_reset, i_unnamed_k2_zts6c_calc14_im0_cma_reset }),
        .ay(i_unnamed_k2_zts6c_calc14_im0_cma_a0),
        .ax(i_unnamed_k2_zts6c_calc14_im0_cma_c0),
        .resulta(i_unnamed_k2_zts6c_calc14_im0_cma_s0),
        .accumulate(),
        .loadconst(),
        .negate(),
        .sub(),
        .az(),
        .coefsela(),
        .bx(),
        .by(),
        .bz(),
        .coefselb(),
        .scanin(),
        .scanout(),
        .chainin(),
        .chainout(),
        .resultb(),
        .dftout()
    );
    dspba_delay_ver #( .width(24), .depth(0), .reset_kind("ASYNC"), .phase(0), .modulus(1), .reset_high(1'b0) )
    i_unnamed_k2_zts6c_calc14_im0_cma_delay ( .xin(i_unnamed_k2_zts6c_calc14_im0_cma_s0), .xout(i_unnamed_k2_zts6c_calc14_im0_cma_qq), .clk(clock), .aclr(resetn), .ena(1'b1) );
    assign i_unnamed_k2_zts6c_calc14_im0_cma_q = $unsigned(i_unnamed_k2_zts6c_calc14_im0_cma_qq[23:0]);

    // i_unnamed_k2_zts6c_calc14_sums_align_2(BITSHIFT,133)@5
    assign i_unnamed_k2_zts6c_calc14_sums_align_2_qint = { i_unnamed_k2_zts6c_calc14_im0_cma_q, 17'b00000000000000000 };
    assign i_unnamed_k2_zts6c_calc14_sums_align_2_q = i_unnamed_k2_zts6c_calc14_sums_align_2_qint[40:0];

    // i_unnamed_k2_zts6c_calc14_ma13_cma(CHAINMULTADD,212)@2 + 3
    assign i_unnamed_k2_zts6c_calc14_ma13_cma_reset = ~ (resetn);
    assign i_unnamed_k2_zts6c_calc14_ma13_cma_ena0 = 1'b1;
    assign i_unnamed_k2_zts6c_calc14_ma13_cma_ena1 = i_unnamed_k2_zts6c_calc14_ma13_cma_ena0;
    assign i_unnamed_k2_zts6c_calc14_ma13_cma_ena2 = i_unnamed_k2_zts6c_calc14_ma13_cma_ena0;

    assign i_unnamed_k2_zts6c_calc14_ma13_cma_a0 = {4'b0000, i_unnamed_k2_zts6c_calc14_bs2_merged_bit_select_b[13:0]};
    assign i_unnamed_k2_zts6c_calc14_ma13_cma_c0 = i_unnamed_k2_zts6c_calc14_bs1_merged_bit_select_e;
    assign i_unnamed_k2_zts6c_calc14_ma13_cma_a1 = i_unnamed_k2_zts6c_calc14_bs2_merged_bit_select_c;
    assign i_unnamed_k2_zts6c_calc14_ma13_cma_c1 = i_unnamed_k2_zts6c_calc14_bs1_merged_bit_select_d;
    twentynm_mac #(
        .operation_mode("m18x18_sumof2"),
        .use_chainadder("false"),
        .ay_scan_in_clock("0"),
        .ay_scan_in_width(18),
        .by_clock("0"),
        .by_width(18),
        .ax_clock("0"),
        .bx_clock("0"),
        .ax_width(18),
        .bx_width(18),
        .signed_may("false"),
        .signed_mby("false"),
        .signed_max("false"),
        .signed_mbx("false"),
        .input_pipeline_clock("2"),
        .output_clock("1"),
        .result_a_width(37)
    ) i_unnamed_k2_zts6c_calc14_ma13_cma_DSP0 (
        .clk({clock,clock,clock}),
        .ena({ i_unnamed_k2_zts6c_calc14_ma13_cma_ena2, i_unnamed_k2_zts6c_calc14_ma13_cma_ena1, i_unnamed_k2_zts6c_calc14_ma13_cma_ena0 }),
        .aclr({ i_unnamed_k2_zts6c_calc14_ma13_cma_reset, i_unnamed_k2_zts6c_calc14_ma13_cma_reset }),
        .ay(i_unnamed_k2_zts6c_calc14_ma13_cma_a1),
        .by(i_unnamed_k2_zts6c_calc14_ma13_cma_a0),
        .ax(i_unnamed_k2_zts6c_calc14_ma13_cma_c1),
        .bx(i_unnamed_k2_zts6c_calc14_ma13_cma_c0),
        .resulta(i_unnamed_k2_zts6c_calc14_ma13_cma_s0),
        .accumulate(),
        .loadconst(),
        .negate(),
        .sub(),
        .az(),
        .coefsela(),
        .bz(),
        .coefselb(),
        .scanin(),
        .scanout(),
        .chainin(),
        .chainout(),
        .resultb(),
        .dftout()
    );
    dspba_delay_ver #( .width(37), .depth(0), .reset_kind("ASYNC"), .phase(0), .modulus(1), .reset_high(1'b0) )
    i_unnamed_k2_zts6c_calc14_ma13_cma_delay ( .xin(i_unnamed_k2_zts6c_calc14_ma13_cma_s0), .xout(i_unnamed_k2_zts6c_calc14_ma13_cma_qq), .clk(clock), .aclr(resetn), .ena(1'b1) );
    assign i_unnamed_k2_zts6c_calc14_ma13_cma_q = $unsigned(i_unnamed_k2_zts6c_calc14_ma13_cma_qq[36:0]);

    // i_unnamed_k2_zts6c_calc14_sums_align_1(BITSHIFT,132)@5
    assign i_unnamed_k2_zts6c_calc14_sums_align_1_qint = { i_unnamed_k2_zts6c_calc14_ma13_cma_q, 18'b000000000000000000 };
    assign i_unnamed_k2_zts6c_calc14_sums_align_1_q = i_unnamed_k2_zts6c_calc14_sums_align_1_qint[54:0];

    // i_unnamed_k2_zts6c_calc14_sums_join_3(BITJOIN,134)@5
    assign i_unnamed_k2_zts6c_calc14_sums_join_3_q = {i_unnamed_k2_zts6c_calc14_sums_align_2_q, i_unnamed_k2_zts6c_calc14_sums_align_1_q};

    // i_unnamed_k2_zts6c_calc14_ma8_cma(CHAINMULTADD,211)@2 + 3
    assign i_unnamed_k2_zts6c_calc14_ma8_cma_reset = ~ (resetn);
    assign i_unnamed_k2_zts6c_calc14_ma8_cma_ena0 = 1'b1;
    assign i_unnamed_k2_zts6c_calc14_ma8_cma_ena1 = i_unnamed_k2_zts6c_calc14_ma8_cma_ena0;
    assign i_unnamed_k2_zts6c_calc14_ma8_cma_ena2 = i_unnamed_k2_zts6c_calc14_ma8_cma_ena0;

    assign i_unnamed_k2_zts6c_calc14_ma8_cma_a0 = {4'b0000, i_unnamed_k2_zts6c_calc14_bs2_merged_bit_select_b[13:0]};
    assign i_unnamed_k2_zts6c_calc14_ma8_cma_c0 = i_unnamed_k2_zts6c_calc14_bs1_merged_bit_select_d;
    assign i_unnamed_k2_zts6c_calc14_ma8_cma_a1 = i_unnamed_k2_zts6c_calc14_bs2_merged_bit_select_c;
    assign i_unnamed_k2_zts6c_calc14_ma8_cma_c1 = i_unnamed_k2_zts6c_calc14_bs1_merged_bit_select_c;
    twentynm_mac #(
        .operation_mode("m18x18_sumof2"),
        .use_chainadder("false"),
        .ay_scan_in_clock("0"),
        .ay_scan_in_width(18),
        .by_clock("0"),
        .by_width(18),
        .ax_clock("0"),
        .bx_clock("0"),
        .ax_width(18),
        .bx_width(18),
        .signed_may("false"),
        .signed_mby("false"),
        .signed_max("false"),
        .signed_mbx("false"),
        .input_pipeline_clock("2"),
        .output_clock("1"),
        .result_a_width(37)
    ) i_unnamed_k2_zts6c_calc14_ma8_cma_DSP0 (
        .clk({clock,clock,clock}),
        .ena({ i_unnamed_k2_zts6c_calc14_ma8_cma_ena2, i_unnamed_k2_zts6c_calc14_ma8_cma_ena1, i_unnamed_k2_zts6c_calc14_ma8_cma_ena0 }),
        .aclr({ i_unnamed_k2_zts6c_calc14_ma8_cma_reset, i_unnamed_k2_zts6c_calc14_ma8_cma_reset }),
        .ay(i_unnamed_k2_zts6c_calc14_ma8_cma_a1),
        .by(i_unnamed_k2_zts6c_calc14_ma8_cma_a0),
        .ax(i_unnamed_k2_zts6c_calc14_ma8_cma_c1),
        .bx(i_unnamed_k2_zts6c_calc14_ma8_cma_c0),
        .resulta(i_unnamed_k2_zts6c_calc14_ma8_cma_s0),
        .accumulate(),
        .loadconst(),
        .negate(),
        .sub(),
        .az(),
        .coefsela(),
        .bz(),
        .coefselb(),
        .scanin(),
        .scanout(),
        .chainin(),
        .chainout(),
        .resultb(),
        .dftout()
    );
    dspba_delay_ver #( .width(37), .depth(0), .reset_kind("ASYNC"), .phase(0), .modulus(1), .reset_high(1'b0) )
    i_unnamed_k2_zts6c_calc14_ma8_cma_delay ( .xin(i_unnamed_k2_zts6c_calc14_ma8_cma_s0), .xout(i_unnamed_k2_zts6c_calc14_ma8_cma_qq), .clk(clock), .aclr(resetn), .ena(1'b1) );
    assign i_unnamed_k2_zts6c_calc14_ma8_cma_q = $unsigned(i_unnamed_k2_zts6c_calc14_ma8_cma_qq[36:0]);

    // i_unnamed_k2_zts6c_calc14_im18_cma(CHAINMULTADD,207)@2 + 3
    assign i_unnamed_k2_zts6c_calc14_im18_cma_reset = ~ (resetn);
    assign i_unnamed_k2_zts6c_calc14_im18_cma_ena0 = 1'b1;
    assign i_unnamed_k2_zts6c_calc14_im18_cma_ena1 = i_unnamed_k2_zts6c_calc14_im18_cma_ena0;
    assign i_unnamed_k2_zts6c_calc14_im18_cma_ena2 = i_unnamed_k2_zts6c_calc14_im18_cma_ena0;

    assign i_unnamed_k2_zts6c_calc14_im18_cma_a0 = i_unnamed_k2_zts6c_calc14_bs1_merged_bit_select_e;
    assign i_unnamed_k2_zts6c_calc14_im18_cma_c0 = i_unnamed_k2_zts6c_calc14_bs2_merged_bit_select_c;
    twentynm_mac #(
        .operation_mode("m18x18_full"),
        .ay_scan_in_clock("0"),
        .ay_scan_in_width(18),
        .ax_clock("0"),
        .ax_width(18),
        .signed_may("false"),
        .signed_max("false"),
        .input_pipeline_clock("2"),
        .output_clock("1"),
        .result_a_width(36)
    ) i_unnamed_k2_zts6c_calc14_im18_cma_DSP0 (
        .clk({clock,clock,clock}),
        .ena({ i_unnamed_k2_zts6c_calc14_im18_cma_ena2, i_unnamed_k2_zts6c_calc14_im18_cma_ena1, i_unnamed_k2_zts6c_calc14_im18_cma_ena0 }),
        .aclr({ i_unnamed_k2_zts6c_calc14_im18_cma_reset, i_unnamed_k2_zts6c_calc14_im18_cma_reset }),
        .ay(i_unnamed_k2_zts6c_calc14_im18_cma_a0),
        .ax(i_unnamed_k2_zts6c_calc14_im18_cma_c0),
        .resulta(i_unnamed_k2_zts6c_calc14_im18_cma_s0),
        .accumulate(),
        .loadconst(),
        .negate(),
        .sub(),
        .az(),
        .coefsela(),
        .bx(),
        .by(),
        .bz(),
        .coefselb(),
        .scanin(),
        .scanout(),
        .chainin(),
        .chainout(),
        .resultb(),
        .dftout()
    );
    dspba_delay_ver #( .width(36), .depth(0), .reset_kind("ASYNC"), .phase(0), .modulus(1), .reset_high(1'b0) )
    i_unnamed_k2_zts6c_calc14_im18_cma_delay ( .xin(i_unnamed_k2_zts6c_calc14_im18_cma_s0), .xout(i_unnamed_k2_zts6c_calc14_im18_cma_qq), .clk(clock), .aclr(resetn), .ena(1'b1) );
    assign i_unnamed_k2_zts6c_calc14_im18_cma_q = $unsigned(i_unnamed_k2_zts6c_calc14_im18_cma_qq[35:0]);

    // i_unnamed_k2_zts6c_calc14_sums_join_0(BITJOIN,131)@5
    assign i_unnamed_k2_zts6c_calc14_sums_join_0_q = {i_unnamed_k2_zts6c_calc14_ma8_cma_q, i_unnamed_k2_zts6c_calc14_im18_cma_q};

    // i_unnamed_k2_zts6c_calc14_sums_result_add_0_0(ADD,137)@5 + 1
    assign i_unnamed_k2_zts6c_calc14_sums_result_add_0_0_a = {24'b000000000000000000000000, i_unnamed_k2_zts6c_calc14_sums_join_0_q};
    assign i_unnamed_k2_zts6c_calc14_sums_result_add_0_0_b = {1'b0, i_unnamed_k2_zts6c_calc14_sums_join_3_q};
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            i_unnamed_k2_zts6c_calc14_sums_result_add_0_0_o <= 97'b0;
        end
        else
        begin
            i_unnamed_k2_zts6c_calc14_sums_result_add_0_0_o <= $unsigned(i_unnamed_k2_zts6c_calc14_sums_result_add_0_0_a) + $unsigned(i_unnamed_k2_zts6c_calc14_sums_result_add_0_0_b);
        end
    end
    assign i_unnamed_k2_zts6c_calc14_sums_result_add_0_0_q = i_unnamed_k2_zts6c_calc14_sums_result_add_0_0_o[96:0];

    // i_unnamed_k2_zts6c_calc14_sums_result_add_1_0(ADD,138)@6
    assign i_unnamed_k2_zts6c_calc14_sums_result_add_1_0_a = {1'b0, i_unnamed_k2_zts6c_calc14_sums_result_add_0_0_q};
    assign i_unnamed_k2_zts6c_calc14_sums_result_add_1_0_b = {11'b00000000000, i_unnamed_k2_zts6c_calc14_sums_align_4_q};
    assign i_unnamed_k2_zts6c_calc14_sums_result_add_1_0_o = $unsigned(i_unnamed_k2_zts6c_calc14_sums_result_add_1_0_a) + $unsigned(i_unnamed_k2_zts6c_calc14_sums_result_add_1_0_b);
    assign i_unnamed_k2_zts6c_calc14_sums_result_add_1_0_q = i_unnamed_k2_zts6c_calc14_sums_result_add_1_0_o[97:0];

    // i_unnamed_k2_zts6c_calc14_extender_x(BITJOIN,62)@6
    assign i_unnamed_k2_zts6c_calc14_extender_x_q = {i_unnamed_k2_zts6c_calc12_vt_const_63_q, i_unnamed_k2_zts6c_calc14_sums_result_add_1_0_q[95:0]};

    // bgTrunc_i_unnamed_k2_zts6c_calc14_sel_x(BITSELECT,48)@6
    assign bgTrunc_i_unnamed_k2_zts6c_calc14_sel_x_b = i_unnamed_k2_zts6c_calc14_extender_x_q[63:0];

    // redist6_bgTrunc_i_unnamed_k2_zts6c_calc14_sel_x_b_1(DELAY,228)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist6_bgTrunc_i_unnamed_k2_zts6c_calc14_sel_x_b_1_q <= '0;
        end
        else
        begin
            redist6_bgTrunc_i_unnamed_k2_zts6c_calc14_sel_x_b_1_q <= $unsigned(bgTrunc_i_unnamed_k2_zts6c_calc14_sel_x_b);
        end
    end

    // redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_notEnable(LOGICAL,239)
    assign redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_notEnable_q = $unsigned(~ (VCC_q));

    // redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_nor(LOGICAL,240)
    assign redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_nor_q = ~ (redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_notEnable_q | redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_sticky_ena_q);

    // redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_mem_last(CONSTANT,236)
    assign redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_mem_last_q = $unsigned(3'b010);

    // redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_cmp(LOGICAL,237)
    assign redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_cmp_b = {1'b0, redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_rdcnt_q};
    assign redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_cmp_q = $unsigned(redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_mem_last_q == redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_cmp_b ? 1'b1 : 1'b0);

    // redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_cmpReg(REG,238)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_cmpReg_q <= $unsigned(1'b0);
        end
        else
        begin
            redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_cmpReg_q <= $unsigned(redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_cmp_q);
        end
    end

    // redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_sticky_ena(REG,241)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_sticky_ena_q <= $unsigned(1'b0);
        end
        else if (redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_nor_q == 1'b1)
        begin
            redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_sticky_ena_q <= $unsigned(redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_cmpReg_q);
        end
    end

    // redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_enaAnd(LOGICAL,242)
    assign redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_enaAnd_q = redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_sticky_ena_q & VCC_q;

    // redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_rdcnt(COUNTER,234)
    // low=0, high=3, step=1, init=0
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_rdcnt_i <= 2'd0;
        end
        else
        begin
            redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_rdcnt_i <= $unsigned(redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_rdcnt_i) + $unsigned(2'd1);
        end
    end
    assign redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_rdcnt_q = redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_rdcnt_i[1:0];

    // leftShiftStage2Idx1Rng4_uid202_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x(BITSELECT,201)@2
    assign leftShiftStage2Idx1Rng4_uid202_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_in = leftShiftStage1_uid200_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_q[27:0];
    assign leftShiftStage2Idx1Rng4_uid202_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_b = leftShiftStage2Idx1Rng4_uid202_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_in[27:0];

    // leftShiftStage2Idx1Pad4_uid201_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x(CONSTANT,200)
    assign leftShiftStage2Idx1Pad4_uid201_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_q = $unsigned(4'b0000);

    // leftShiftStage2Idx1_uid203_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x(BITJOIN,202)@2
    assign leftShiftStage2Idx1_uid203_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_q = {leftShiftStage2Idx1Rng4_uid202_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_b, leftShiftStage2Idx1Pad4_uid201_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_q};

    // leftShiftStage1Idx1Rng2_uid197_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x(BITSELECT,196)@2
    assign leftShiftStage1Idx1Rng2_uid197_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_in = leftShiftStage0_uid195_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_q[29:0];
    assign leftShiftStage1Idx1Rng2_uid197_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_b = leftShiftStage1Idx1Rng2_uid197_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_in[29:0];

    // leftShiftStage1Idx1_uid198_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x(BITJOIN,197)@2
    assign leftShiftStage1Idx1_uid198_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_q = {leftShiftStage1Idx1Rng2_uid197_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_b, i_unnamed_k2_zts6c_calc16_vt_const_1_q};

    // leftShiftStage0Idx1Rng1_uid192_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x(BITSELECT,191)@2
    assign leftShiftStage0Idx1Rng1_uid192_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_in = redist2_sync_together31_aunroll_x_in_c0_eni3_2_tpl_1_q[30:0];
    assign leftShiftStage0Idx1Rng1_uid192_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_b = leftShiftStage0Idx1Rng1_uid192_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_in[30:0];

    // leftShiftStage0Idx1_uid193_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x(BITJOIN,192)@2
    assign leftShiftStage0Idx1_uid193_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_q = {leftShiftStage0Idx1Rng1_uid192_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_b, GND_q};

    // leftShiftStage0_uid195_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x(MUX,194)@2
    assign leftShiftStage0_uid195_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_s = VCC_q;
    always @(leftShiftStage0_uid195_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_s or redist2_sync_together31_aunroll_x_in_c0_eni3_2_tpl_1_q or leftShiftStage0Idx1_uid193_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_q)
    begin
        unique case (leftShiftStage0_uid195_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_s)
            1'b0 : leftShiftStage0_uid195_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_q = redist2_sync_together31_aunroll_x_in_c0_eni3_2_tpl_1_q;
            1'b1 : leftShiftStage0_uid195_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_q = leftShiftStage0Idx1_uid193_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_q;
            default : leftShiftStage0_uid195_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_q = 32'b0;
        endcase
    end

    // leftShiftStage1_uid200_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x(MUX,199)@2
    assign leftShiftStage1_uid200_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_s = VCC_q;
    always @(leftShiftStage1_uid200_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_s or leftShiftStage0_uid195_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_q or leftShiftStage1Idx1_uid198_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_q)
    begin
        unique case (leftShiftStage1_uid200_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_s)
            1'b0 : leftShiftStage1_uid200_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_q = leftShiftStage0_uid195_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_q;
            1'b1 : leftShiftStage1_uid200_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_q = leftShiftStage1Idx1_uid198_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_q;
            default : leftShiftStage1_uid200_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_q = 32'b0;
        endcase
    end

    // leftShiftStage2_uid205_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x(MUX,204)@2
    assign leftShiftStage2_uid205_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_s = VCC_q;
    always @(leftShiftStage2_uid205_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_s or leftShiftStage1_uid200_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_q or leftShiftStage2Idx1_uid203_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_q)
    begin
        unique case (leftShiftStage2_uid205_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_s)
            1'b0 : leftShiftStage2_uid205_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_q = leftShiftStage1_uid200_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_q;
            1'b1 : leftShiftStage2_uid205_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_q = leftShiftStage2Idx1_uid203_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_q;
            default : leftShiftStage2_uid205_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_q = 32'b0;
        endcase
    end

    // i_unnamed_k2_zts6c_calc10_vt_select_31(BITSELECT,16)@2
    assign i_unnamed_k2_zts6c_calc10_vt_select_31_b = leftShiftStage2_uid205_dupName_0_i_unnamed_k2_zts6c_calc0_shift_x_q[31:7];

    // i_unnamed_k2_zts6c_calc10_vt_const_6(CONSTANT,14)
    assign i_unnamed_k2_zts6c_calc10_vt_const_6_q = $unsigned(7'b0000000);

    // i_unnamed_k2_zts6c_calc10_vt_join(BITJOIN,15)@2
    assign i_unnamed_k2_zts6c_calc10_vt_join_q = {i_unnamed_k2_zts6c_calc10_vt_select_31_b, i_unnamed_k2_zts6c_calc10_vt_const_6_q};

    // i_unnamed_k2_zts6c_calc11(ADD,17)@2
    assign i_unnamed_k2_zts6c_calc11_a = {1'b0, i_unnamed_k2_zts6c_calc10_vt_join_q};
    assign i_unnamed_k2_zts6c_calc11_b = {1'b0, redist3_sync_together31_aunroll_x_in_c0_eni3_3_tpl_1_q};
    assign i_unnamed_k2_zts6c_calc11_o = $unsigned(i_unnamed_k2_zts6c_calc11_a) + $unsigned(i_unnamed_k2_zts6c_calc11_b);
    assign i_unnamed_k2_zts6c_calc11_q = i_unnamed_k2_zts6c_calc11_o[32:0];

    // bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x(BITSELECT,47)@2
    assign bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b = i_unnamed_k2_zts6c_calc11_q[31:0];

    // redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_wraddr(REG,235)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_wraddr_q <= $unsigned(2'b11);
        end
        else
        begin
            redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_wraddr_q <= $unsigned(redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_rdcnt_q);
        end
    end

    // redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_mem(DUALMEM,233)
    assign redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_mem_ia = $unsigned(bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b);
    assign redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_mem_aa = redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_wraddr_q;
    assign redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_mem_ab = redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_rdcnt_q;
    assign redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_mem_reset0 = ~ (resetn);
    altera_syncram #(
        .ram_block_type("MLAB"),
        .operation_mode("DUAL_PORT"),
        .width_a(32),
        .widthad_a(2),
        .numwords_a(4),
        .width_b(32),
        .widthad_b(2),
        .numwords_b(4),
        .lpm_type("altera_syncram"),
        .width_byteena_a(1),
        .address_reg_b("CLOCK0"),
        .indata_reg_b("CLOCK0"),
        .rdcontrol_reg_b("CLOCK0"),
        .byteena_reg_b("CLOCK0"),
        .outdata_reg_b("CLOCK1"),
        .outdata_aclr_b("CLEAR1"),
        .clock_enable_input_a("NORMAL"),
        .clock_enable_input_b("NORMAL"),
        .clock_enable_output_b("NORMAL"),
        .read_during_write_mode_mixed_ports("DONT_CARE"),
        .power_up_uninitialized("TRUE"),
        .intended_device_family("Arria 10")
    ) redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_mem_dmem (
        .clocken1(redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_enaAnd_q[0]),
        .clocken0(1'b1),
        .clock0(clock),
        .aclr1(redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_mem_reset0),
        .clock1(clock),
        .address_a(redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_mem_aa),
        .data_a(redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_mem_ia),
        .wren_a(VCC_q[0]),
        .address_b(redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_mem_ab),
        .q_b(redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_mem_iq),
        .wren_b(),
        .rden_a(),
        .rden_b(),
        .data_b(),
        .clocken2(),
        .clocken3(),
        .aclr0(),
        .addressstall_a(),
        .addressstall_b(),
        .byteena_a(),
        .byteena_b(),
        .eccencbypass(),
        .eccencparity(),
        .sclr(),
        .address2_a(),
        .address2_b(),
        .q_a(),
        .eccstatus()
    );
    assign redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_mem_q = redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_mem_iq[31:0];

    // i_unnamed_k2_zts6c_calc4(COMPARE,43)@7
    assign i_unnamed_k2_zts6c_calc4_a = $unsigned({{2{i_unnamed_k2_zts6c_calc2_vt_join_q[31]}}, i_unnamed_k2_zts6c_calc2_vt_join_q});
    assign i_unnamed_k2_zts6c_calc4_b = $unsigned({{2{i_unnamed_k2_zts6c_calc3_vt_join_q[31]}}, i_unnamed_k2_zts6c_calc3_vt_join_q});
    assign i_unnamed_k2_zts6c_calc4_o = $unsigned($signed(i_unnamed_k2_zts6c_calc4_a) - $signed(i_unnamed_k2_zts6c_calc4_b));
    assign i_unnamed_k2_zts6c_calc4_c[0] = i_unnamed_k2_zts6c_calc4_o[33];

    // i_unnamed_k2_zts6c_calc3_BitSelect_for_a(BITSELECT,168)@7
    assign i_unnamed_k2_zts6c_calc3_BitSelect_for_a_b = i_unnamed_k2_zts6c_calc2_vt_join_q[31:11];

    // i_unnamed_k2_zts6c_calc3_join(BITJOIN,169)@7
    assign i_unnamed_k2_zts6c_calc3_join_q = {i_unnamed_k2_zts6c_calc3_BitSelect_for_a_b, GND_q, GND_q, GND_q, VCC_q, GND_q, GND_q, GND_q, GND_q, GND_q, GND_q, GND_q};

    // i_unnamed_k2_zts6c_calc3_vt_select_31(BITSELECT,42)@7
    assign i_unnamed_k2_zts6c_calc3_vt_select_31_b = i_unnamed_k2_zts6c_calc3_join_q[31:11];

    // i_unnamed_k2_zts6c_calc3_vt_const_10(CONSTANT,40)
    assign i_unnamed_k2_zts6c_calc3_vt_const_10_q = $unsigned(11'b00010000000);

    // i_unnamed_k2_zts6c_calc3_vt_join(BITJOIN,41)@7
    assign i_unnamed_k2_zts6c_calc3_vt_join_q = {i_unnamed_k2_zts6c_calc3_vt_select_31_b, i_unnamed_k2_zts6c_calc3_vt_const_10_q};

    // redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_notEnable(LOGICAL,250)
    assign redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_notEnable_q = $unsigned(~ (VCC_q));

    // redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_nor(LOGICAL,251)
    assign redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_nor_q = ~ (redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_notEnable_q | redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_sticky_ena_q);

    // redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_mem_last(CONSTANT,247)
    assign redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_mem_last_q = $unsigned(3'b010);

    // redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_cmp(LOGICAL,248)
    assign redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_cmp_b = {1'b0, redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_rdcnt_q};
    assign redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_cmp_q = $unsigned(redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_mem_last_q == redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_cmp_b ? 1'b1 : 1'b0);

    // redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_cmpReg(REG,249)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_cmpReg_q <= $unsigned(1'b0);
        end
        else
        begin
            redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_cmpReg_q <= $unsigned(redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_cmp_q);
        end
    end

    // redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_sticky_ena(REG,252)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_sticky_ena_q <= $unsigned(1'b0);
        end
        else if (redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_nor_q == 1'b1)
        begin
            redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_sticky_ena_q <= $unsigned(redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_cmpReg_q);
        end
    end

    // redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_enaAnd(LOGICAL,253)
    assign redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_enaAnd_q = redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_sticky_ena_q & VCC_q;

    // redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_rdcnt(COUNTER,245)
    // low=0, high=3, step=1, init=0
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_rdcnt_i <= 2'd0;
        end
        else
        begin
            redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_rdcnt_i <= $unsigned(redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_rdcnt_i) + $unsigned(2'd1);
        end
    end
    assign redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_rdcnt_q = redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_rdcnt_i[1:0];

    // leftShiftStage2Idx1Rng8_uid184_i_unnamed_k2_zts6c_calc0_shift_x(BITSELECT,183)@1
    assign leftShiftStage2Idx1Rng8_uid184_i_unnamed_k2_zts6c_calc0_shift_x_in = leftShiftStage1_uid182_i_unnamed_k2_zts6c_calc0_shift_x_q[23:0];
    assign leftShiftStage2Idx1Rng8_uid184_i_unnamed_k2_zts6c_calc0_shift_x_b = leftShiftStage2Idx1Rng8_uid184_i_unnamed_k2_zts6c_calc0_shift_x_in[23:0];

    // leftShiftStage2Idx1Pad8_uid183_i_unnamed_k2_zts6c_calc0_shift_x(CONSTANT,182)
    assign leftShiftStage2Idx1Pad8_uid183_i_unnamed_k2_zts6c_calc0_shift_x_q = $unsigned(8'b00000000);

    // leftShiftStage2Idx1_uid185_i_unnamed_k2_zts6c_calc0_shift_x(BITJOIN,184)@1
    assign leftShiftStage2Idx1_uid185_i_unnamed_k2_zts6c_calc0_shift_x_q = {leftShiftStage2Idx1Rng8_uid184_i_unnamed_k2_zts6c_calc0_shift_x_b, leftShiftStage2Idx1Pad8_uid183_i_unnamed_k2_zts6c_calc0_shift_x_q};

    // leftShiftStage1Idx1Rng2_uid179_i_unnamed_k2_zts6c_calc0_shift_x(BITSELECT,178)@1
    assign leftShiftStage1Idx1Rng2_uid179_i_unnamed_k2_zts6c_calc0_shift_x_in = leftShiftStage0_uid177_i_unnamed_k2_zts6c_calc0_shift_x_q[29:0];
    assign leftShiftStage1Idx1Rng2_uid179_i_unnamed_k2_zts6c_calc0_shift_x_b = leftShiftStage1Idx1Rng2_uid179_i_unnamed_k2_zts6c_calc0_shift_x_in[29:0];

    // leftShiftStage1Idx1_uid180_i_unnamed_k2_zts6c_calc0_shift_x(BITJOIN,179)@1
    assign leftShiftStage1Idx1_uid180_i_unnamed_k2_zts6c_calc0_shift_x_q = {leftShiftStage1Idx1Rng2_uid179_i_unnamed_k2_zts6c_calc0_shift_x_b, i_unnamed_k2_zts6c_calc16_vt_const_1_q};

    // leftShiftStage0Idx1Rng1_uid174_i_unnamed_k2_zts6c_calc0_shift_x(BITSELECT,173)@1
    assign leftShiftStage0Idx1Rng1_uid174_i_unnamed_k2_zts6c_calc0_shift_x_in = in_c0_eni3_1_tpl[30:0];
    assign leftShiftStage0Idx1Rng1_uid174_i_unnamed_k2_zts6c_calc0_shift_x_b = leftShiftStage0Idx1Rng1_uid174_i_unnamed_k2_zts6c_calc0_shift_x_in[30:0];

    // leftShiftStage0Idx1_uid175_i_unnamed_k2_zts6c_calc0_shift_x(BITJOIN,174)@1
    assign leftShiftStage0Idx1_uid175_i_unnamed_k2_zts6c_calc0_shift_x_q = {leftShiftStage0Idx1Rng1_uid174_i_unnamed_k2_zts6c_calc0_shift_x_b, GND_q};

    // leftShiftStage0_uid177_i_unnamed_k2_zts6c_calc0_shift_x(MUX,176)@1
    assign leftShiftStage0_uid177_i_unnamed_k2_zts6c_calc0_shift_x_s = VCC_q;
    always @(leftShiftStage0_uid177_i_unnamed_k2_zts6c_calc0_shift_x_s or in_c0_eni3_1_tpl or leftShiftStage0Idx1_uid175_i_unnamed_k2_zts6c_calc0_shift_x_q)
    begin
        unique case (leftShiftStage0_uid177_i_unnamed_k2_zts6c_calc0_shift_x_s)
            1'b0 : leftShiftStage0_uid177_i_unnamed_k2_zts6c_calc0_shift_x_q = in_c0_eni3_1_tpl;
            1'b1 : leftShiftStage0_uid177_i_unnamed_k2_zts6c_calc0_shift_x_q = leftShiftStage0Idx1_uid175_i_unnamed_k2_zts6c_calc0_shift_x_q;
            default : leftShiftStage0_uid177_i_unnamed_k2_zts6c_calc0_shift_x_q = 32'b0;
        endcase
    end

    // leftShiftStage1_uid182_i_unnamed_k2_zts6c_calc0_shift_x(MUX,181)@1
    assign leftShiftStage1_uid182_i_unnamed_k2_zts6c_calc0_shift_x_s = VCC_q;
    always @(leftShiftStage1_uid182_i_unnamed_k2_zts6c_calc0_shift_x_s or leftShiftStage0_uid177_i_unnamed_k2_zts6c_calc0_shift_x_q or leftShiftStage1Idx1_uid180_i_unnamed_k2_zts6c_calc0_shift_x_q)
    begin
        unique case (leftShiftStage1_uid182_i_unnamed_k2_zts6c_calc0_shift_x_s)
            1'b0 : leftShiftStage1_uid182_i_unnamed_k2_zts6c_calc0_shift_x_q = leftShiftStage0_uid177_i_unnamed_k2_zts6c_calc0_shift_x_q;
            1'b1 : leftShiftStage1_uid182_i_unnamed_k2_zts6c_calc0_shift_x_q = leftShiftStage1Idx1_uid180_i_unnamed_k2_zts6c_calc0_shift_x_q;
            default : leftShiftStage1_uid182_i_unnamed_k2_zts6c_calc0_shift_x_q = 32'b0;
        endcase
    end

    // leftShiftStage2_uid187_i_unnamed_k2_zts6c_calc0_shift_x(MUX,186)@1
    assign leftShiftStage2_uid187_i_unnamed_k2_zts6c_calc0_shift_x_s = VCC_q;
    always @(leftShiftStage2_uid187_i_unnamed_k2_zts6c_calc0_shift_x_s or leftShiftStage1_uid182_i_unnamed_k2_zts6c_calc0_shift_x_q or leftShiftStage2Idx1_uid185_i_unnamed_k2_zts6c_calc0_shift_x_q)
    begin
        unique case (leftShiftStage2_uid187_i_unnamed_k2_zts6c_calc0_shift_x_s)
            1'b0 : leftShiftStage2_uid187_i_unnamed_k2_zts6c_calc0_shift_x_q = leftShiftStage1_uid182_i_unnamed_k2_zts6c_calc0_shift_x_q;
            1'b1 : leftShiftStage2_uid187_i_unnamed_k2_zts6c_calc0_shift_x_q = leftShiftStage2Idx1_uid185_i_unnamed_k2_zts6c_calc0_shift_x_q;
            default : leftShiftStage2_uid187_i_unnamed_k2_zts6c_calc0_shift_x_q = 32'b0;
        endcase
    end

    // i_unnamed_k2_zts6c_calc2_vt_select_31(BITSELECT,38)@1
    assign i_unnamed_k2_zts6c_calc2_vt_select_31_b = leftShiftStage2_uid187_i_unnamed_k2_zts6c_calc0_shift_x_q[31:11];

    // redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_wraddr(REG,246)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_wraddr_q <= $unsigned(2'b11);
        end
        else
        begin
            redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_wraddr_q <= $unsigned(redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_rdcnt_q);
        end
    end

    // redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_mem(DUALMEM,244)
    assign redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_mem_ia = $unsigned(i_unnamed_k2_zts6c_calc2_vt_select_31_b);
    assign redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_mem_aa = redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_wraddr_q;
    assign redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_mem_ab = redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_rdcnt_q;
    assign redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_mem_reset0 = ~ (resetn);
    altera_syncram #(
        .ram_block_type("MLAB"),
        .operation_mode("DUAL_PORT"),
        .width_a(21),
        .widthad_a(2),
        .numwords_a(4),
        .width_b(21),
        .widthad_b(2),
        .numwords_b(4),
        .lpm_type("altera_syncram"),
        .width_byteena_a(1),
        .address_reg_b("CLOCK0"),
        .indata_reg_b("CLOCK0"),
        .rdcontrol_reg_b("CLOCK0"),
        .byteena_reg_b("CLOCK0"),
        .outdata_reg_b("CLOCK1"),
        .outdata_aclr_b("CLEAR1"),
        .clock_enable_input_a("NORMAL"),
        .clock_enable_input_b("NORMAL"),
        .clock_enable_output_b("NORMAL"),
        .read_during_write_mode_mixed_ports("DONT_CARE"),
        .power_up_uninitialized("TRUE"),
        .intended_device_family("Arria 10")
    ) redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_mem_dmem (
        .clocken1(redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_enaAnd_q[0]),
        .clocken0(1'b1),
        .clock0(clock),
        .aclr1(redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_mem_reset0),
        .clock1(clock),
        .address_a(redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_mem_aa),
        .data_a(redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_mem_ia),
        .wren_a(VCC_q[0]),
        .address_b(redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_mem_ab),
        .q_b(redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_mem_iq),
        .wren_b(),
        .rden_a(),
        .rden_b(),
        .data_b(),
        .clocken2(),
        .clocken3(),
        .aclr0(),
        .addressstall_a(),
        .addressstall_b(),
        .byteena_a(),
        .byteena_b(),
        .eccencbypass(),
        .eccencparity(),
        .sclr(),
        .address2_a(),
        .address2_b(),
        .q_a(),
        .eccstatus()
    );
    assign redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_mem_q = redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_mem_iq[20:0];

    // redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_outputreg0(DELAY,243)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_outputreg0_q <= '0;
        end
        else
        begin
            redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_outputreg0_q <= $unsigned(redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_mem_q);
        end
    end

    // i_unnamed_k2_zts6c_calc2_vt_const_10(CONSTANT,36)
    assign i_unnamed_k2_zts6c_calc2_vt_const_10_q = $unsigned(11'b00000000000);

    // i_unnamed_k2_zts6c_calc2_vt_join(BITJOIN,37)@7
    assign i_unnamed_k2_zts6c_calc2_vt_join_q = {redist8_i_unnamed_k2_zts6c_calc2_vt_select_31_b_6_outputreg0_q, i_unnamed_k2_zts6c_calc2_vt_const_10_q};

    // GND(CONSTANT,0)
    assign GND_q = $unsigned(1'b0);

    // sync_out_aunroll_x(GPOUT,68)@7
    assign out_c0_exi8_0_tpl = GND_q;
    assign out_c0_exi8_1_tpl = i_unnamed_k2_zts6c_calc2_vt_join_q;
    assign out_c0_exi8_2_tpl = i_unnamed_k2_zts6c_calc3_vt_join_q;
    assign out_c0_exi8_3_tpl = i_unnamed_k2_zts6c_calc4_c;
    assign out_c0_exi8_4_tpl = redist7_bgTrunc_i_unnamed_k2_zts6c_calc11_sel_x_b_5_mem_q;
    assign out_c0_exi8_5_tpl = redist6_bgTrunc_i_unnamed_k2_zts6c_calc14_sel_x_b_1_q;
    assign out_c0_exi8_6_tpl = i_unnamed_k2_zts6c_calc16_vt_join_q;
    assign out_c0_exi8_7_tpl = redist5_bgTrunc_i_unnamed_k2_zts6c_calc17_sel_x_b_1_q;
    assign out_c0_exi8_8_tpl = i_unnamed_k2_zts6c_calc19_vt_join_q;
    assign out_o_valid = valid_fanout_reg0_q;
    assign out_unnamed_k2_ZTS6c_calc4 = GND_q;

endmodule
